//projects_recHandler Head @55-A4948325
package ManyToManyListbox.ManyToManyListbox;
import java.util.*;
import com.codecharge.*;
import com.codecharge.db.*;
import com.codecharge.components.*;
import com.codecharge.events.*;
import com.codecharge.util.*;
public class projects_recRecordHandler implements RecordListener {
//End projects_recHandler Head

//BeforeShow Head @55-46046458
    public void beforeShow(Event e) {
//End BeforeShow Head

//Event BeforeShow Action Custom Code @63-44795B7A
		if (e.getRecord().isEditMode()) {
			//get connection
			JDBCConnection conn = JDBCConnectionFactory.getJDBCConnection("IntranetDB");
			e.getRecord().getList("employee_list").setValues(
					conn.getRows("SELECT employees.emp_id FROM employees, projects_employees " + 
					"WHERE projects_employees.emp_id = employees.emp_id AND " +
					"projects_employees.project_id=" + 
					conn.toSql(e.getPage().getHttpGetParameter("project_id"), 
					JDBCConnection.INTEGER)), "emp_id");
			conn.closeConnection();
		}
//End Event BeforeShow Action Custom Code

//BeforeShow Tail @55-FCB6E20C
    }
//End BeforeShow Tail

//OnValidate Head @55-5F430F8E
    public void onValidate(Event e) {
//End OnValidate Head

//OnValidate Tail @55-FCB6E20C
    }
//End OnValidate Tail

//BeforeSelect Head @55-E5EC9AD3
    public void beforeSelect(Event e) {
//End BeforeSelect Head

//BeforeSelect Tail @55-FCB6E20C
    }
//End BeforeSelect Tail

//BeforeInsert Head @55-75B62B83
    public void beforeInsert(Event e) {
//End BeforeInsert Head

//BeforeInsert Tail @55-FCB6E20C
    }
//End BeforeInsert Tail
class ProjectEmployeesModifyListbox {
	final public void process(Page page, String mode) {
		String[] employeeList = page.getHttpPostParameters().getParameterValues("employee_list");
		long prjId = 0;
		try {
			prjId = Long.parseLong(DBTools.toSql(page.getHttpGetParameter("project_id"), 
					JDBCConnection.INTEGER, "IntranetDB"));
		} catch (Exception e_ignore) {}
		if ( "Insert".equals(mode) ) {
	     	//Retrieve the last inserted key
     		//Use MS SQL method (disabled below)
     		//String lastInsKey = DBTools.convertToString(
			//		DBTools.dLookUp("@@IDENTITY", "projects", "", "IntranetDB"));
     		//Use method compatible with all databases (unsafe when multiple users 
			//insert records at the same time)
     		String lastPrjId = Utils.convertToString(
					DBTools.dLookUp("max(project_id)", "projects", "", "IntranetDB"));
     		//Insert New links
			if (employeeList != null) {
				JDBCConnection conn = JDBCConnectionFactory.getJDBCConnection("IntranetDB");
				for (int i = 0; i < employeeList.length; i++ ) {
					String empId = conn.toSql(employeeList[i], JDBCConnection.INTEGER);
		    	    conn.executeUpdate("INSERT INTO projects_employees (project_id, emp_id) VALUES (" + 
							lastPrjId + "," + empId + ")");
				}
				conn.closeConnection();
			}
		} else if (prjId > 0) {
			JDBCConnection conn = JDBCConnectionFactory.getJDBCConnection("IntranetDB");
			if ("Delete".equals(mode) || "Update".equals(mode)) {
		        //Delete project employees links
       			conn.executeUpdate("DELETE FROM projects_employees WHERE project_id=" + prjId);
			}
			if ("Update".equals(mode)) {
       			//Insert assigned employees
				if (employeeList != null) {
					for (int i = 0; i < employeeList.length; i++ ) {
						String empId = conn.toSql(employeeList[i], JDBCConnection.INTEGER);
				        conn.executeUpdate("INSERT INTO projects_employees (project_id, emp_id) VALUES (" + 
								prjId + "," + empId + ")");
					}
				}
			}
			conn.closeConnection();
		}
	}
}

//AfterInsert Head @55-767A9165
    public void afterInsert(Event e) {
//End AfterInsert Head

//Event AfterInsert Action Custom Code @64-44795B7A
new ProjectEmployeesModifyListbox().process(e.getPage(), "Insert");
//End Event AfterInsert Action Custom Code

//AfterInsert Tail @55-FCB6E20C
    }
//End AfterInsert Tail

//BeforeUpdate Head @55-33A3CFAC
    public void beforeUpdate(Event e) {
//End BeforeUpdate Head

//BeforeUpdate Tail @55-FCB6E20C
    }
//End BeforeUpdate Tail

//AfterUpdate Head @55-306F754A
    public void afterUpdate(Event e) {
//End AfterUpdate Head

//Event AfterUpdate Action Custom Code @65-44795B7A
new ProjectEmployeesModifyListbox().process(e.getPage(), "Update");
//End Event AfterUpdate Action Custom Code

//AfterUpdate Tail @55-FCB6E20C
    }
//End AfterUpdate Tail

//BeforeDelete Head @55-752E3118
    public void beforeDelete(Event e) {
//End BeforeDelete Head

//Event BeforeDelete Action Custom Code @70-44795B7A
new ProjectEmployeesModifyListbox().process(e.getPage(), "Delete");
//End Event BeforeDelete Action Custom Code

//BeforeDelete Tail @55-FCB6E20C
    }
//End BeforeDelete Tail

//AfterDelete Head @55-76E28BFE
    public void afterDelete(Event e) {
//End AfterDelete Head

//AfterDelete Tail @55-FCB6E20C
    }
//End AfterDelete Tail

//projects_recHandler Tail @55-FCB6E20C
}
//End projects_recHandler Tail

