//employees_recordHandler Head @14-ADE610C3
package ManyToManyListboxes.ManyToManyListboxes;
import java.util.*;
import com.codecharge.*;
import com.codecharge.db.*;
import com.codecharge.components.*;
import com.codecharge.events.*;
import com.codecharge.util.*;
public class employees_recordRecordHandler implements RecordListener {
//End employees_recordHandler Head

//BeforeShow Head @14-46046458
    public void beforeShow(Event e) {
//End BeforeShow Head

//BeforeShow Tail @14-FCB6E20C
    }
//End BeforeShow Tail

//OnValidate Head @14-5F430F8E
    public void onValidate(Event e) {
//End OnValidate Head

//OnValidate Tail @14-FCB6E20C
    }
//End OnValidate Tail

//BeforeSelect Head @14-E5EC9AD3
    public void beforeSelect(Event e) {
//End BeforeSelect Head

//BeforeSelect Tail @14-FCB6E20C
    }
//End BeforeSelect Tail

//BeforeInsert Head @14-75B62B83
    public void beforeInsert(Event e) {
//End BeforeInsert Head

//BeforeInsert Tail @14-FCB6E20C
    }
//End BeforeInsert Tail

class ProjectEmployeesModifyTwoListboxes {
	final public void process(Page page, String mode) {
		Enumeration projectList = StringUtils.split(page.getHttpPostParameter("LinkedID"), ',');
		long empId = 0;
		try {
			empId = Long.parseLong(DBTools.toSql(page.getHttpGetParameter("emp_id"), 
					JDBCConnection.INTEGER, "IntranetDB"));
		} catch (Exception e_ignore) {}
		if ( "Insert".equals(mode) ) {
	     	//Retrieve the last inserted key
     		//Use MS SQL method (disabled below)
     		//String lastInsKey = DBTools.convertToString(
			//		DBTools.dLookUp("@@IDENTITY", "employees", "", "IntranetDB"));
     		//Use method compatible with all databases (unsafe when multiple users 
			//insert records at the same time)
     		String lastInsKey = Utils.convertToString(
					DBTools.dLookUp("max(emp_id)", "employees", "", "IntranetDB"));
     		//Insert New links
			JDBCConnection conn = JDBCConnectionFactory.getJDBCConnection("IntranetDB");
			while (projectList.hasMoreElements()) {
				String projectId = conn.toSql((String) projectList.nextElement(), JDBCConnection.INTEGER);
	    	    conn.executeUpdate("INSERT INTO projects_employees (project_id, emp_id) VALUES (" + 
						projectId + "," + lastInsKey + ")");
			}
			conn.closeConnection();
		} else if (empId > 0) {
			JDBCConnection conn = JDBCConnectionFactory.getJDBCConnection("IntranetDB");
			if ("Delete".equals(mode) || "Update".equals(mode)) {
		        //Delete project employees links
       			conn.executeUpdate("DELETE FROM projects_employees WHERE emp_id=" + empId);
			}
			if ("Update".equals(mode)) {
       			//Insert assigned employees
				while (projectList.hasMoreElements()) {
					String projectId = conn.toSql((String) projectList.nextElement(), JDBCConnection.INTEGER);
			        conn.executeUpdate("INSERT INTO projects_employees (project_id, emp_id) VALUES (" + 
							projectId + "," + empId + ")");
				}
			}
			conn.closeConnection();
		}
	}
}

//AfterInsert Head @14-767A9165
    public void afterInsert(Event e) {
//End AfterInsert Head

//Event AfterInsert Action Custom Code @35-44795B7A
new ProjectEmployeesModifyTwoListboxes().process(e.getPage(), "Insert");
//End Event AfterInsert Action Custom Code

//AfterInsert Tail @14-FCB6E20C
    }
//End AfterInsert Tail

//BeforeUpdate Head @14-33A3CFAC
    public void beforeUpdate(Event e) {
//End BeforeUpdate Head

//BeforeUpdate Tail @14-FCB6E20C
    }
//End BeforeUpdate Tail

//AfterUpdate Head @14-306F754A
    public void afterUpdate(Event e) {
//End AfterUpdate Head

//Event AfterUpdate Action Custom Code @36-44795B7A
new ProjectEmployeesModifyTwoListboxes().process(e.getPage(), "Update");
//End Event AfterUpdate Action Custom Code

//AfterUpdate Tail @14-FCB6E20C
    }
//End AfterUpdate Tail

//BeforeDelete Head @14-752E3118
    public void beforeDelete(Event e) {
//End BeforeDelete Head

//Event BeforeDelete Action Custom Code @49-44795B7A
new ProjectEmployeesModifyTwoListboxes().process(e.getPage(), "Delete");
//End Event BeforeDelete Action Custom Code

//BeforeDelete Tail @14-FCB6E20C
    }
//End BeforeDelete Tail

//AfterDelete Head @14-76E28BFE
    public void afterDelete(Event e) {
//End AfterDelete Head

//AfterDelete Tail @14-FCB6E20C
    }
//End AfterDelete Tail

//employees_recordHandler Tail @14-FCB6E20C
}
//End employees_recordHandler Tail

