//projects_employeesproject_idHandler Head @32-BAA3594E
package MasterDetail.MasterDetail;
import java.util.*;
import com.codecharge.events.*;
import com.codecharge.components.*;
import com.codecharge.validation.*;
import com.codecharge.db.*;
import com.codecharge.util.*;
public class projects_employeesproject_idHandler implements ValidationListener, ListDataObjectListener {
//End projects_employeesproject_idHandler Head

//OnValidate Head @32-5F430F8E
    public void onValidate(Event e) {
//End OnValidate Head

//Event OnValidate Action Custom Code @44-44795B7A
		String projects_string = (String) e.getPage().getRequest().getAttribute("MasterDetail_project_id");
		if (StringUtils.isEmpty(projects_string)) {
			projects_string = ",";
		}
		//Assure that the selected projects are unique
  		if (projects_string.indexOf("," + e.getList().getFormattedValue() + ",") > -1 )  { 
    		e.getList().addError("A project cannot be selected twice");
  		} else { 
			e.getPage().getRequest().setAttribute("MasterDetail_project_id", 
					projects_string + e.getList().getFormattedValue() + ",");
  		}
//End Event OnValidate Action Custom Code

//OnValidate Tail @32-FCB6E20C
    }
//End OnValidate Tail

//BeforeShow Head @32-46046458
    public void beforeShow(Event e) {
//End BeforeShow Head

//BeforeShow Tail @32-FCB6E20C
    }
//End BeforeShow Tail

//BeforeBuildSelect Head @32-3041BA14
    public void beforeBuildSelect( DataObjectEvent e ) {
//End BeforeBuildSelect Head

//BeforeBuildSelect Tail @32-FCB6E20C
    }
//End BeforeBuildSelect Tail

//BeforeExecuteSelect Head @32-8391D9D6
    public void beforeExecuteSelect( DataObjectEvent e ) {
//End BeforeExecuteSelect Head

//BeforeExecuteSelect Tail @32-FCB6E20C
    }
//End BeforeExecuteSelect Tail

//AfterExecuteSelect Head @32-0972E7FA
    public void afterExecuteSelect( DataObjectEvent e ) {
//End AfterExecuteSelect Head

//AfterExecuteSelect Tail @32-FCB6E20C
    }
//End AfterExecuteSelect Tail

//projects_employeesproject_idHandler Tail @32-FCB6E20C
}
//End projects_employeesproject_idHandler Tail

