//employeesGridHandler @2-C5048792
package NavGrid.NavGrid;
import java.util.*;
import com.codecharge.*;
import com.codecharge.db.*;
import com.codecharge.components.*;
import com.codecharge.events.*;
import com.codecharge.util.*;
import javax.servlet.*;
import javax.servlet.http.*;

public class employeesGridHandler implements GridListener {
//End employeesGridHandler

// //beforeShow @2-F81417CB

//BeforeShow Head @2-46046458
    public void beforeShow(Event e) {
//End BeforeShow Head

//BeforeShow Tail @2-FCB6E20C
    }
//End BeforeShow Tail

// //beforeShowRow @2-F81417CB

//beforeShowRow Head @2-BDFD38FC
    public void beforeShowRow(Event e) {
//End beforeShowRow Head

//Event BeforeShowRow Action Custom Code @22-44795B7A
//Calculate the number of records up to the current page
long previousRecords = e.getGrid().getPageSize() * (e.getGrid().getPage()-1);

//Calculate and store the current page number in the empBackPage parameter of the Emp_Name link.
LinkParameter empBackPage = new LinkParameter("empBackPage", "", ParameterSource.EXPRESSION);
empBackPage.setValue(e.getGrid().getPage());
e.getGrid().getLink("emp_name").addParameter(empBackPage);

//Calculate and store each employee's record number in the employeesPage parameter of 
//their corresponding Emp_Name links.
//This parameter is used automatically by the Navigator of the Grid on the detail page NavGrid_Detail.
LinkParameter employeesPage = new LinkParameter("employeesPage", "", ParameterSource.EXPRESSION);
employeesPage.setValue(previousRecords+e.getGrid().getCurrentRowNumber());
e.getGrid().getLink("emp_name").addParameter(employeesPage);
//End Event BeforeShowRow Action Custom Code

//beforeShowRow Tail @2-FCB6E20C
    }
//End beforeShowRow Tail

// //beforeSelect @2-F81417CB

//BeforeSelect Head @2-E5EC9AD3
    public void beforeSelect(Event e) {
//End BeforeSelect Head

//BeforeSelect Tail @2-FCB6E20C
    }
//End BeforeSelect Tail

//employeesHandler Tail @2-FCB6E20C
}
//End employeesHandler Tail

