//departmentsHandler Head @11-06D1020C
package PopUpList.PopUpList;
import java.util.*;
import com.codecharge.*;
import com.codecharge.db.*;
import com.codecharge.components.*;
import com.codecharge.events.*;
import com.codecharge.util.*;
public class departmentsRecordHandler implements RecordListener {
//End departmentsHandler Head

//BeforeShow Head @11-46046458
    public void beforeShow(Event e) {
//End BeforeShow Head

//Event BeforeShow Action Custom Code @17-44795B7A
	try {
     	e.getRecord().getControl("department_manager_id").setValue(
       			DBTools.dLookUp("emp_name", "employees", "emp_id=" + 
	   			Utils.convertToLong(e.getRecord().getControl("department_manager_id").getValue()), 
				"IntranetDB"));
	} catch (NumberFormatException nfe_ignore) {}
//End Event BeforeShow Action Custom Code

//BeforeShow Tail @11-FCB6E20C
    }
//End BeforeShow Tail

//OnValidate Head @11-5F430F8E
    public void onValidate(Event e) {
//End OnValidate Head

//Event OnValidate Action Custom Code @19-44795B7A
		String s_name = (String) e.getRecord().getControl("department_manager_id").getValue();
		if (s_name!=null) s_name = s_name.trim();
		if (! StringUtils.isEmpty(s_name) ) {
    		s_name = s_name.replace(' ','%');
			String search_name = s_name.indexOf("%") == -1 ? "%" + s_name + "%" : s_name + "%";
		    long empCount = ((Number) DBTools.dLookUp("COUNT(*)", "employees", "emp_name LIKE " + 
			DBTools.toSql(search_name, JDBCConnection.TEXT, "IntranetDB"), "IntranetDB")).longValue();
    		if (empCount > 1) {
       			e.getRecord().addError("Too many matching employees were found.");
    		} else if (empCount == 0) { 
       			e.getRecord().addError("No matching employees were found.");
			} else {
       			e.getRecord().getControl("department_manager_id").setValue(
						DBTools.dLookUp("emp_id", "employees", "emp_name LIKE " + 
						DBTools.toSql(search_name, JDBCConnection.TEXT, "IntranetDB"), "IntranetDB"));
			} 
		}
//End Event OnValidate Action Custom Code

//OnValidate Tail @11-FCB6E20C
    }
//End OnValidate Tail

//BeforeSelect Head @11-E5EC9AD3
    public void beforeSelect(Event e) {
//End BeforeSelect Head

//BeforeSelect Tail @11-FCB6E20C
    }
//End BeforeSelect Tail

//BeforeInsert Head @11-75B62B83
    public void beforeInsert(Event e) {
//End BeforeInsert Head

//BeforeInsert Tail @11-FCB6E20C
    }
//End BeforeInsert Tail

//AfterInsert Head @11-767A9165
    public void afterInsert(Event e) {
//End AfterInsert Head

//AfterInsert Tail @11-FCB6E20C
    }
//End AfterInsert Tail

//BeforeUpdate Head @11-33A3CFAC
    public void beforeUpdate(Event e) {
//End BeforeUpdate Head

//BeforeUpdate Tail @11-FCB6E20C
    }
//End BeforeUpdate Tail

//AfterUpdate Head @11-306F754A
    public void afterUpdate(Event e) {
//End AfterUpdate Head

//AfterUpdate Tail @11-FCB6E20C
    }
//End AfterUpdate Tail

//BeforeDelete Head @11-752E3118
    public void beforeDelete(Event e) {
//End BeforeDelete Head

//BeforeDelete Tail @11-FCB6E20C
    }
//End BeforeDelete Tail

//AfterDelete Head @11-76E28BFE
    public void afterDelete(Event e) {
//End AfterDelete Head

//AfterDelete Tail @11-FCB6E20C
    }
//End AfterDelete Tail

//departmentsHandler Tail @11-FCB6E20C
}
//End departmentsHandler Tail

