//employeesDataObjectHandler head @2-0170DC89
package PopUpList.PopUpList_Window;
import com.codecharge.*;
import com.codecharge.db.*;
import com.codecharge.components.*;
import com.codecharge.events.*;
import com.codecharge.util.*;
import javax.servlet.*;
import javax.servlet.http.*;

public class employeesDataObjectHandler implements DataObjectListener {
//End employeesDataObjectHandler head

// //BeforeBuildSelect @2-F81417CB

//beforeBuildSelect head @2-3041BA14
    public void beforeBuildSelect( DataObjectEvent e) {
//End beforeBuildSelect head

//Event BeforeBuildSelect Action Custom Code @20-44795B7A
//Dynamically modify the WHERE statement (of the datasource) to match the following SQL condition:
//"emp_name LIKE F% L%", where F = First Name, L = Last Name.
String s_name = e.getPage().getHttpGetParameter("s_emp_name", "").trim().replace(' ','%');
String search_name = s_name.indexOf("%") == -1 ? "%" + s_name + "%" : s_name + "%";
String where = e.getCommand().getWhere();
StringBuffer sb = where == null ? new StringBuffer() : new StringBuffer(where);
if (sb.length() > 0) {
	sb.append(" AND ");
}
sb.append("emp_name LIKE " + DBTools.toSql(search_name, JDBCConnection.TEXT, "IntranetDB"));
e.getCommand().setWhere(sb.toString());
//End Event BeforeBuildSelect Action Custom Code

//BeforeBuildSelect Tail @2-FCB6E20C
    }
//End BeforeBuildSelect Tail

// //beforeExecuteSelect @2-F81417CB

//beforeExecuteSelect head @2-8391D9D6
    public void beforeExecuteSelect( DataObjectEvent e) {
//End beforeExecuteSelect head

//beforeExecuteSelect Tail @2-FCB6E20C
    }
//End beforeExecuteSelect Tail

// //afterExecuteSelect @2-F81417CB

//afterExecuteSelect Head @2-0972E7FA
    public void afterExecuteSelect( DataObjectEvent e) {
//End afterExecuteSelect Head

//afterExecuteSelect Tail @2-FCB6E20C
    }
//End afterExecuteSelect Tail

//employeesDataObjectHandler Tail @2-FCB6E20C
}
//End employeesDataObjectHandler Tail

