//Using Statements @1-67EB7960
using System;
using System.Collections;
using System.Collections.Specialized;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Text.RegularExpressions;
using System.Globalization;
using CCSExample_CSharp;
using CCSExample_CSharp.Data;
using CCSExample_CSharp.Configuration;
using CCSExample_CSharp.Controls;

namespace CCSExample_CSharp.DirectoryMaintenance.DirectoryMaintenance
{

//End Using Statements

//Forms Definition @1-18443764
public class DirectoryMaintenancePage : System.Web.UI.Page
{
//End Forms Definition

//Forms Objects @1-20973742
    protected CCPath Path_link_categories;
    protected Path_link_categoriesDataProvider Path_link_categoriesData;
    protected CCDirectory yp_category;
    protected yp_categoryDataProvider yp_categoryData;
    protected form_categoriesDataProvider form_categoriesData;
    protected HtmlInputButton form_categoriesInsert1;
    protected HtmlInputButton form_categoriesUpdate1;
    protected HtmlInputButton form_categoriesDelete1;
    protected HtmlInputButton form_categoriesCancel;
    protected System.Web.UI.WebControls.PlaceHolder form_categoriesError;
    protected System.Web.UI.HtmlControls.HtmlTable form_categoriesHolder;
    protected System.Web.UI.WebControls.Label form_categoriesErrorLabel;
    protected bool form_categoriesInsertAllowed=true;
    protected bool form_categoriesUpdateAllowed=true;
    protected bool form_categoriesDeleteAllowed=true;
    protected NameValueCollection form_categoriesErrors=new NameValueCollection();
    protected System.Web.UI.WebControls.TextBox form_categoriescategory_name;
    protected System.Web.UI.HtmlControls.HtmlInputHidden form_categoriescategory_id_parent;
    protected System.Web.UI.HtmlControls.HtmlAnchor Link1;
//End Forms Objects

//Page_Load Event @1-55207E05
private void Page_Load(object sender, System.EventArgs e)
{
//End Page_Load Event

//Page_Load Event BeforeIsPostBack @1-506E5EF9
    if (!IsPostBack)
    {
            PageDataProvider PageData=new PageDataProvider();
            PageItem item=PageItem.CreateFromHttpRequest();
            item.Link1Href = "DirectoryMaintenance_desc.aspx?";
            PageData.FillItem(item);
            Link1.InnerText += item.Link1.GetFormattedValue().Replace("\r","").Replace("\n","<br>");
            Link1.HRef += item.Link1Href+item.Link1HrefParameters.ToString("GET","", ViewState);
            Path_link_categoriesBind();
            yp_categoryBind();
            form_categoriesShow();
    }
//End Page_Load Event BeforeIsPostBack

//Page_Load Event tail @1-FCB6E20C
}
//End Page_Load Event tail

//Page_Unload Event @1-72102C7C
private void Page_Unload(object sender, System.EventArgs e)
{
//End Page_Unload Event

//Page_Unload Event tail @1-FCB6E20C
}
//End Page_Unload Event tail

//Path Path_link_categories Bind @2-F7383CAC
    protected void Path_link_categoriesBind()
    {
        int FooterIndex;
//End Path Path_link_categories Bind

//Path Form Path_link_categories BeforeShow tail @2-44BD838B
        Path_link_categoriesParameters();
        Path_link_categories.DataSource = Path_link_categoriesData.GetResultSet();
        Path_link_categories.DataBind();
        FooterIndex = Path_link_categories.Controls.Count - 1;
        Path_link_categoriesItem item=new Path_link_categoriesItem();
        System.Web.UI.HtmlControls.HtmlAnchor Path_link_categoriesPathBeginLink = (System.Web.UI.HtmlControls.HtmlAnchor)Path_link_categories.Controls[0].FindControl("Path_link_categoriesPathBeginLink");

        item.PathBeginLinkHref = "DirectoryMaintenance.aspx?";

        Path_link_categoriesPathBeginLink.InnerText += item.PathBeginLink.GetFormattedValue().Replace("\r","").Replace("\n","<br>");
        Path_link_categoriesPathBeginLink.HRef += item.PathBeginLinkHref+item.PathBeginLinkHrefParameters.ToString("GET","category_id;edit_id;parent_id", ViewState);
//End Path Form Path_link_categories BeforeShow tail

//Path Path_link_categories Bind tail @2-FCB6E20C
    }
//End Path Path_link_categories Bind tail

//Path Path_link_categories Table Parameters @2-E7A5932D
    protected void Path_link_categoriesParameters()
    {
        try{
            Path_link_categoriesData.Urlcategory_id= IntegerParameter.GetParam(Request.QueryString["category_id"]);
        }catch{
            ControlCollection ParentControls=Path_link_categories.Parent.Controls;
            int RepeaterIndex=ParentControls.IndexOf(Path_link_categories);
            ParentControls.RemoveAt(RepeaterIndex);
            Literal ErrorMessage=new Literal();
            ErrorMessage.Text="Error in Path Path_link_categories: Invalid parameter";
            ParentControls.AddAt(RepeaterIndex,ErrorMessage);
        }
	}
	
//End Path Path_link_categories Table Parameters

//Path Path_link_categories ItemDataBound event @2-B5BF9A18
    protected void Path_link_categoriesItemDataBound(Object Sender, CCPathItemEventArgs e)
    {
        Path_link_categoriesItem DataItem=(Path_link_categoriesItem)e.Item.DataItem;
        if (e.Item.ItemType == CCPathItemType.PathComponent) {
            System.Web.UI.HtmlControls.HtmlAnchor Path_link_categoriesPathCategory = (System.Web.UI.HtmlControls.HtmlAnchor)(e.Item.FindControl("Path_link_categoriesPathCategory"));
            DataItem.PathCategoryHref = "DirectoryMaintenance.aspx?";
            Path_link_categoriesPathCategory.HRef += DataItem.PathCategoryHref + DataItem.PathCategoryHrefParameters.ToString("GET","edit_id;parent_id", ViewState);
        }
        if (e.Item.ItemType == CCPathItemType.CurrentCategory) {
        }
//End Path Path_link_categories ItemDataBound event

//Path Path_link_categories ItemDataBound event tail @2-FCB6E20C
    }
//End Path Path_link_categories ItemDataBound event tail

//Directory yp_category Bind @42-E7BD776E
    protected void yp_categoryBind()
    {
        int FooterIndex;
//End Directory yp_category Bind

//Directory Form yp_category BeforeShow tail @42-A2FCF75D
        yp_categoryParameters();
        yp_category.DataSource = yp_categoryData.GetResultSet();
        yp_category.DataBind();
        FooterIndex = yp_category.Controls.Count - 1;


//End Directory Form yp_category BeforeShow tail

//Directory yp_category Bind tail @42-FCB6E20C
    }
//End Directory yp_category Bind tail

//Directory yp_category Table Parameters @42-EFF3A0C6
    protected void yp_categoryParameters()
    {
        try{
            yp_categoryData.Urlcategory_id= IntegerParameter.GetParam(Request.QueryString["category_id"]);
        }catch{
            ControlCollection ParentControls=yp_category.Parent.Controls;
            int RepeaterIndex=ParentControls.IndexOf(yp_category);
            ParentControls.RemoveAt(RepeaterIndex);
            Literal ErrorMessage=new Literal();
            ErrorMessage.Text="Error in Directory yp_category: Invalid parameter";
            ParentControls.AddAt(RepeaterIndex,ErrorMessage);
        }
	}
	
//End Directory yp_category Table Parameters

//Directory yp_category ItemDataBound event @42-B59F654E
    protected void yp_categoryItemDataBound(Object Sender, CCDirectoryItemEventArgs e)
    {
        yp_categoryItem DataItem=(yp_categoryItem)e.Item.DataItem;
        if (e.Item.ItemType == CCDirectoryItemType.CategoryHeader) {
            System.Web.UI.HtmlControls.HtmlAnchor yp_categoryLink1 = (System.Web.UI.HtmlControls.HtmlAnchor)(e.Item.FindControl("yp_categoryLink1"));
            DataItem.Link1Href = "DirectoryMaintenance.aspx?";
            yp_categoryLink1.HRef += DataItem.Link1Href + DataItem.Link1HrefParameters.ToString("GET","", ViewState);
            System.Web.UI.HtmlControls.HtmlAnchor yp_categoryCategoryLink = (System.Web.UI.HtmlControls.HtmlAnchor)(e.Item.FindControl("yp_categoryCategoryLink"));
            DataItem.CategoryLinkHref = "DirectoryMaintenance.aspx?";
            yp_categoryCategoryLink.HRef += DataItem.CategoryLinkHref + DataItem.CategoryLinkHrefParameters.ToString("GET","edit_id;parent_id", ViewState);
        }
        if (e.Item.ItemType == CCDirectoryItemType.Subcategory) {
            System.Web.UI.HtmlControls.HtmlAnchor yp_categoryLink2 = (System.Web.UI.HtmlControls.HtmlAnchor)(e.Item.FindControl("yp_categoryLink2"));
            DataItem.Link2Href = "DirectoryMaintenance.aspx?";
            yp_categoryLink2.HRef += DataItem.Link2Href + DataItem.Link2HrefParameters.ToString("GET","", ViewState);
            System.Web.UI.HtmlControls.HtmlAnchor yp_categorySubcategoryLink = (System.Web.UI.HtmlControls.HtmlAnchor)(e.Item.FindControl("yp_categorySubcategoryLink"));
            DataItem.SubcategoryLinkHref = "DirectoryMaintenance.aspx?";
            yp_categorySubcategoryLink.HRef += DataItem.SubcategoryLinkHref + DataItem.SubcategoryLinkHrefParameters.ToString("GET","edit_id;parent_id", ViewState);
        }
        if (e.Item.ItemType == CCDirectoryItemType.SubcategoriesTail) {
            System.Web.UI.HtmlControls.HtmlAnchor yp_categorySubcategoriesTailLink = (System.Web.UI.HtmlControls.HtmlAnchor)(e.Item.FindControl("yp_categorySubcategoriesTailLink"));
            DataItem.SubcategoriesTailLinkHref = "DirectoryMaintenance.aspx?";
            yp_categorySubcategoriesTailLink.HRef += DataItem.SubcategoriesTailLinkHref + DataItem.SubcategoriesTailLinkHrefParameters.ToString("GET","edit_id;parent_id", ViewState);
        }
//End Directory yp_category ItemDataBound event

//Directory yp_category ItemDataBound event tail @42-FCB6E20C
    }
//End Directory yp_category ItemDataBound event tail

//Record Form form_categories Parameters @23-4EEF2675
    protected void form_categoriesParameters()
    {
        try{
            form_categoriesData.Urledit_id= IntegerParameter.GetParam(Request.QueryString["edit_id"]);
        }catch(Exception e){
            form_categoriesErrors.Add("Parameters","Form parameters: " + e.Message);
        }
    }
//End Record Form form_categories Parameters

//Record Form form_categories Show method @23-32A612E0
    protected void form_categoriesShow()
    {
        bool AllowRead = true,AllowInsert = true,AllowUpdate = true,AllowDelete = true;
        form_categoriesItem item=form_categoriesItem.CreateFromHttpRequest();
        bool IsInsertMode=!AllowRead;
        form_categoriesErrors.Add(item.errors);
//End Record Form form_categories Show method

//Grid Form form_categories BeforeShow tail @23-9FA82B78
        form_categoriesParameters();
        form_categoriesData.FillItem(item,ref IsInsertMode);
        form_categoriesInsert1.Visible=IsInsertMode&&AllowInsert;
        form_categoriesUpdate1.Visible=!IsInsertMode&&AllowUpdate;
        form_categoriesDelete1.Visible=!IsInsertMode&&AllowDelete;
        form_categoriescategory_name.Text=item.category_name.GetFormattedValue();
        form_categoriescategory_id_parent.Value=item.category_id_parent.GetFormattedValue();
//End Grid Form form_categories BeforeShow tail

//Record form_categories Event BeforeShow. Action Custom Code @35-2A29BDB7

//Set the value of the hidden category_id_parent field to the value based on "Edit" link's parameters.
  if (Request.QueryString["parent_id"] == null || Request.QueryString["parent_id"].Length == 0) {
     form_categoriescategory_id_parent.Value = Request.QueryString["category_id"];
  } else {
     form_categoriescategory_id_parent.Value = Request.QueryString["parent_id"];
  }


//End Record form_categories Event BeforeShow. Action Custom Code

//Record Form form_categories Show method tail @23-9EFF7C0A
        if(form_categoriesErrors.Count>0)
            form_categoriesShowErrors();
    }
//End Record Form form_categories Show method tail

//Record Form form_categories LoadItemFromRequest method @23-66981C12
    protected void form_categoriesLoadItemFromRequest(form_categoriesItem item, bool EnableValidation)
    {
        item.category_name.SetValue(form_categoriescategory_name.Text);
        try{
        item.category_id_parent.SetValue(form_categoriescategory_id_parent.Value);
        }catch(ArgumentException){
            form_categoriesErrors.Add("category_id_parent","The value in field Category Id Parent is not valid.");}
        if(EnableValidation)
            item.Validate(form_categoriesData);
        form_categoriesErrors.Add(item.errors);
    }
//End Record Form form_categories LoadItemFromRequest method

//Record Form form_categories GetRedirectUrl method @23-20B0836D
    protected string Getform_categoriesRedirectUrl(string redirectString ,string removeList)
    {
        string Params="";
        string[] List=("edit_id;parent_id;" + removeList).ToLower().Split(new Char[] {';'});

        if(redirectString == "") redirectString = "DirectoryMaintenance.aspx";
        for(int i = 0; i < Request.QueryString.Count;i ++)
            if(Array.IndexOf(List,Request.QueryString.AllKeys[i].ToLower()) < 0)
                Params += Request.QueryString.AllKeys[i] + "=" + Server.UrlEncode(Request.QueryString[i]) + "&";
        Params = Params.TrimEnd(new Char[]{'&'});
        return redirectString + "?" + Params;
    }

//End Record Form form_categories GetRedirectUrl method

//Record Form form_categories ShowErrors method @23-24B99C5E
    protected void form_categoriesShowErrors()
    {
        string DefaultMessage="";
        for(int i=0;i<form_categoriesErrors.Count;i++)
        switch(form_categoriesErrors.AllKeys[i])
        {
            default:
                DefaultMessage+=form_categoriesErrors[i]+"<br>";
                break;
        }
        form_categoriesError.Visible = true;
        form_categoriesErrorLabel.Text = DefaultMessage;
    }
//End Record Form form_categories ShowErrors method

//Record Form form_categories Insert Operation @23-08FD8CA7
    protected void form_categories_Insert(object sender, System.EventArgs e)
    {
        bool ExecuteFlag = true;
        bool ErrorFlag = false;
        form_categoriesItem item=new form_categoriesItem();
        string RedirectUrl = Getform_categoriesRedirectUrl("", "");
//End Record Form form_categories Insert Operation

//Record Form form_categories BeforeInsert tail @23-F76349F9
    form_categoriesParameters();
    form_categoriesLoadItemFromRequest(item, true);
    if(form_categoriesInsertAllowed){
    ErrorFlag=(form_categoriesErrors.Count>0);
        if(ExecuteFlag&&!ErrorFlag)
            try
            {
                form_categoriesData.InsertItem(item);
            }
            catch (Exception ex)
            {
                form_categoriesErrors.Add("DataProvider",ex.Message);
                ErrorFlag=true;
            }
//End Record Form form_categories BeforeInsert tail

//Record Form form_categories AfterInsert tail  @23-7F6D54BF
        }
        if(ErrorFlag)
            form_categoriesShowErrors();
        else
            Response.Redirect(RedirectUrl);
    }
//End Record Form form_categories AfterInsert tail 

//Record Form form_categories Update Operation @23-4824CBF3
    protected void form_categories_Update(object sender, System.EventArgs e)
    {
        form_categoriesItem item=new form_categoriesItem();
        item.IsNew = false;
        bool ExecuteFlag = true;
        bool ErrorFlag = false;
        string RedirectUrl = Getform_categoriesRedirectUrl("", "");
//End Record Form form_categories Update Operation

//Record Form form_categories Before Update tail @23-073CE61A
        form_categoriesParameters();
        form_categoriesLoadItemFromRequest(item, true);
        if(form_categoriesUpdateAllowed){
        ErrorFlag=(form_categoriesErrors.Count>0);
        if(ExecuteFlag&&!ErrorFlag)
            try
            {
                form_categoriesData.UpdateItem(item);
            }
            catch (Exception ex)
            {
                form_categoriesErrors.Add("DataProvider",ex.Message);
                ErrorFlag=true;
            }
//End Record Form form_categories Before Update tail

//Record Form form_categories Update Operation tail @23-7F6D54BF
        }
        if(ErrorFlag)
            form_categoriesShowErrors();
        else
            Response.Redirect(RedirectUrl);
    }
//End Record Form form_categories Update Operation tail

//Record Form form_categories Delete Operation @23-0B7B5C42
    protected void form_categories_Delete(object sender,System.EventArgs e)
    {
        bool ExecuteFlag = true;
        bool ErrorFlag = false;
        string RedirectUrl = Getform_categoriesRedirectUrl("", "");
        form_categoriesItem item=new form_categoriesItem();
        item.IsNew = false;
        item.IsDeleted = true;
//End Record Form form_categories Delete Operation

//Record Form BeforeDelete tail @23-ADDB5C57
        form_categoriesParameters();
        form_categoriesLoadItemFromRequest(item, false);
        if(form_categoriesDeleteAllowed){
        ErrorFlag = (form_categoriesErrors.Count > 0);
        if(ExecuteFlag && !ErrorFlag)
            try
            {
                form_categoriesData.DeleteItem();
            }
            catch (Exception ex)
            {
                form_categoriesErrors.Add("DataProvider", ex.Message);
                ErrorFlag = true;
            }
//End Record Form BeforeDelete tail

//Record Form AfterDelete tail @23-7F6D54BF
        }
        if(ErrorFlag)
            form_categoriesShowErrors();
        else
            Response.Redirect(RedirectUrl);
    }
//End Record Form AfterDelete tail

//Record Form form_categories Cancel Operation @23-D327CF20
    protected void form_categories_Cancel(object sender,System.EventArgs e)
    {
        form_categoriesItem item=new form_categoriesItem();
        string RedirectUrl = Getform_categoriesRedirectUrl("", "");
        form_categoriesLoadItemFromRequest(item, false);
//End Record Form form_categories Cancel Operation

//Record Form form_categories Cancel Operation tail @23-AE897FBA
        Response.Redirect(RedirectUrl);
    }
//End Record Form form_categories Cancel Operation tail

//OnInit Event @1-A8561F11
    #region Web Form Designer generated code
    override protected void OnInit(EventArgs e)
    {
        //
        //CODEGEN: This call is required by the ASP.NET Web Form Designer.
        //
        InitializeComponent();
        this.Load += new System.EventHandler(this.Page_Load);
        this.Unload += new System.EventHandler(this.Page_Unload);
        Path_link_categoriesData = new Path_link_categoriesDataProvider();
        yp_categoryData = new yp_categoryDataProvider();
        form_categoriesData = new form_categoriesDataProvider();
        base.OnInit(e);
//End OnInit Event

//OnInit Event tail @1-FCB6E20C
    }
//End OnInit Event tail

//InitializeComponent Event @1-722FC1EE
    /// <summary>
    /// Required method for Designer support - do not modify
    /// the contents of this method with the code editor.
    /// </summary>
    private void InitializeComponent()
    {
    }
    #endregion
//End InitializeComponent Event

//Page class tail @1-F5FC18C5
}
}
//End Page class tail

