'Using Statements @1-2F7D3924
Imports System
Imports System.Collections
Imports System.Collections.Specialized
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Web
Imports System.Web.SessionState
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports System.Web.UI.HtmlControls
Imports System.Text.RegularExpressions
Imports System.Globalization
Imports CCSExamplePack
Imports CCSExamplePack.Data
Imports CCSExamplePack.Configuration
Imports CCSExamplePack.Controls
Namespace DirectoryMaintenance.DirectoryMaintenance
'End Using Statements

'Forms Definition @1-0F811691
Public Class [DirectoryMaintenancePage]
Inherits System.Web.UI.Page
'End Forms Definition

'Forms Objects @1-045A9D83
    Protected Path_link_categories As CCPath
    Protected Path_link_categoriesData As Path_link_categoriesDataProvider
    Protected yp_category As  CCDirectory
    Protected yp_categoryData As yp_categoryDataProvider
    Protected form_categoriesData As form_categoriesDataProvider
    Protected form_categoriesInsert1 As HtmlInputButton 
    Protected form_categoriesUpdate1 As HtmlInputButton 
    Protected form_categoriesDelete1 As HtmlInputButton 
    Protected form_categoriesCancel As HtmlInputButton 
    Protected form_categoriesError As System.Web.UI.WebControls.PlaceHolder
    Protected form_categoriesHolder As System.Web.UI.HtmlControls.HtmlTable
    Protected form_categoriesErrorLabel As System.Web.UI.WebControls.Label
    Protected form_categoriesInsertAllowed As Boolean = True
    Protected form_categoriesUpdateAllowed As Boolean = True
    Protected form_categoriesDeleteAllowed As Boolean = True
    Protected form_categoriesErrors As NameValueCollection = New NameValueCollection()
    Protected form_categoriescategory_name As System.Web.UI.WebControls.TextBox
    Protected form_categoriescategory_id_parent As System.Web.UI.HtmlControls.HtmlInputHidden
    Protected Link1 As System.Web.UI.HtmlControls.HtmlAnchor
'End Forms Objects

'Page_Load Event @1-A2D2CF1E

Protected Overrides Sub OnLoad(ByVal e As System.EventArgs)
'End Page_Load Event

'Page_Load Event BeforeIsPostBack @1-847B4B03
    If Not IsPostBack Then
            Dim PageData As PageDataProvider = New PageDataProvider()
            Dim item As PageItem = PageItem.CreateFromHttpRequest()
            item.Link1Href = "DirectoryMaintenance_desc.aspx?"
            PageData.FillItem(item)
            Link1.InnerText += item.Link1.GetFormattedValue().Replace(vbCrLf,"")
            Link1.HRef += item.Link1Href & item.Link1HrefParameters.ToString("GET","", ViewState)
            Path_link_categoriesBind()
            yp_categoryBind
            form_categoriesShow()
    End If
'End Page_Load Event BeforeIsPostBack

'Page_Load Event tail @1-E31F8E2A
End Sub
'End Page_Load Event tail

'Page_Unload Event @1-D998A98F

Protected Overrides Sub OnUnload(ByVal e As System.EventArgs)
'End Page_Unload Event

'Page_Unload Event tail @1-E31F8E2A
End Sub
'End Page_Unload Event tail

'Path Path_link_categories Bind @2-785BAFD5
    Protected Sub Path_link_categoriesBind()
        Dim FooterIndex As Integer
'End Path Path_link_categories Bind

'Path Form Path_link_categories BeforeShow tail @2-575131DF
        Path_link_categoriesParameters()
        Path_link_categories.DataSource = Path_link_categoriesData.GetResultSet()
        Path_link_categories.DataBind()
        FooterIndex = Path_link_categories.Controls.Count - 1
        Dim item As Path_link_categoriesItem = New Path_link_categoriesItem()
        Dim Path_link_categoriesPathBeginLink As System.Web.UI.HtmlControls.HtmlAnchor = DirectCast(Path_link_categories.Controls(0).FindControl("Path_link_categoriesPathBeginLink"),System.Web.UI.HtmlControls.HtmlAnchor)

        item.PathBeginLinkHref = "DirectoryMaintenance.aspx?"

        Path_link_categoriesPathBeginLink.InnerText += item.PathBeginLink.GetFormattedValue().Replace(vbCrLf,"")
        Path_link_categoriesPathBeginLink.HRef += item.PathBeginLinkHref & item.PathBeginLinkHrefParameters.ToString("GET","category_id;edit_id;parent_id", ViewState)
'End Path Form Path_link_categories BeforeShow tail

'Path Path_link_categories Bind tail @2-E31F8E2A
    End Sub
'End Path Path_link_categories Bind tail

'Path Path_link_categories Table Parameters @2-CA05DF78
    Protected Sub Path_link_categoriesParameters()
        Try
            Path_link_categoriesData.Urlcategory_id= IntegerParameter.GetParam(Request.QueryString("category_id"))
        Catch
            Dim ParentControls As ControlCollection=Path_link_categories.Parent.Controls
            Dim RepeaterIndex As Integer=ParentControls.IndexOf(Path_link_categories)
            ParentControls.RemoveAt(RepeaterIndex)
            Dim ErrorMessage as Literal=New Literal()
            ErrorMessage.Text="Error in Grid Path_link_categories: Invalid parameter"
            ParentControls.AddAt(RepeaterIndex,ErrorMessage)
        End Try
    End Sub
'End Path Path_link_categories Table Parameters

'Path Path_link_categories ItemDataBound event @2-6C76B851
    Protected Sub Path_link_categoriesItemDataBound(Sender as Object, e as CCPathItemEventArgs)
        Dim DataItem as Path_link_categoriesItem=CType(e.Item.DataItem,Path_link_categoriesItem)
        If e.Item.ItemType = CCPathItemType.PathComponent Then
            Dim Path_link_categoriesPathCategory As System.Web.UI.HtmlControls.HtmlAnchor = DirectCast(e.Item.FindControl("Path_link_categoriesPathCategory"),System.Web.UI.HtmlControls.HtmlAnchor)
            DataItem.PathCategoryHref = "DirectoryMaintenance.aspx?"
            Path_link_categoriesPathCategory.HRef += DataItem.PathCategoryHref & DataItem.PathCategoryHrefParameters.ToString("GET","edit_id;parent_id", ViewState)
        End If
        If e.Item.ItemType = CCPathItemType.CurrentCategory Then
        End If
'End Path Path_link_categories ItemDataBound event

'Path Path_link_categories ItemDataBound event tail @2-E31F8E2A
    End Sub
'End Path Path_link_categories ItemDataBound event tail

'Directory yp_category Bind @42-12F03152
    Protected Sub yp_categoryBind()
        Dim FooterIndex As Integer
'End Directory yp_category Bind

'Directory Form yp_category BeforeShow tail @42-9993A49D
        yp_categoryParameters()
        yp_category.DataSource = yp_categoryData.GetResultSet()
        yp_category.DataBind()
        FooterIndex = yp_category.Controls.Count - 1


'End Directory Form yp_category BeforeShow tail

'Directory yp_category Bind tail @42-E31F8E2A
    End Sub
'End Directory yp_category Bind tail

'Directory yp_category Table Parameters @42-F308E9C6
    Protected Sub yp_categoryParameters()
        Try
            yp_categoryData.Urlcategory_id= IntegerParameter.GetParam(Request.QueryString("category_id"))
        Catch
            Dim ParentControls As ControlCollection=yp_category.Parent.Controls
            Dim RepeaterIndex As Integer=ParentControls.IndexOf(yp_category)
            ParentControls.RemoveAt(RepeaterIndex)
            Dim ErrorMessage as Literal=New Literal()
            ErrorMessage.Text="Error in Grid yp_category: Invalid parameter"
            ParentControls.AddAt(RepeaterIndex,ErrorMessage)
        End Try
    End Sub
'End Directory yp_category Table Parameters

'Directory yp_category ItemDataBound event @42-233BAA90
    Protected Sub yp_categoryItemDataBound(Sender as Object, e as CCDirectoryItemEventArgs)
        Dim DataItem as yp_categoryItem=CType(e.Item.DataItem,yp_categoryItem)
        If e.Item.ItemType = CCDirectoryItemType.CategoryHeader Then
            Dim yp_categoryLink1 As System.Web.UI.HtmlControls.HtmlAnchor = DirectCast(e.Item.FindControl("yp_categoryLink1"),System.Web.UI.HtmlControls.HtmlAnchor)
            DataItem.Link1Href = "DirectoryMaintenance.aspx?"
            yp_categoryLink1.HRef += DataItem.Link1Href & DataItem.Link1HrefParameters.ToString("GET","", ViewState)
            Dim yp_categoryCategoryLink As System.Web.UI.HtmlControls.HtmlAnchor = DirectCast(e.Item.FindControl("yp_categoryCategoryLink"),System.Web.UI.HtmlControls.HtmlAnchor)
            DataItem.CategoryLinkHref = "DirectoryMaintenance.aspx?"
            yp_categoryCategoryLink.HRef += DataItem.CategoryLinkHref & DataItem.CategoryLinkHrefParameters.ToString("GET","edit_id;parent_id", ViewState)
        End If
        If e.Item.ItemType = CCDirectoryItemType.Subcategory Then
            Dim yp_categoryLink2 As System.Web.UI.HtmlControls.HtmlAnchor = DirectCast(e.Item.FindControl("yp_categoryLink2"),System.Web.UI.HtmlControls.HtmlAnchor)
            DataItem.Link2Href = "DirectoryMaintenance.aspx?"
            yp_categoryLink2.HRef += DataItem.Link2Href & DataItem.Link2HrefParameters.ToString("GET","", ViewState)
            Dim yp_categorySubcategoryLink As System.Web.UI.HtmlControls.HtmlAnchor = DirectCast(e.Item.FindControl("yp_categorySubcategoryLink"),System.Web.UI.HtmlControls.HtmlAnchor)
            DataItem.SubcategoryLinkHref = "DirectoryMaintenance.aspx?"
            yp_categorySubcategoryLink.HRef += DataItem.SubcategoryLinkHref & DataItem.SubcategoryLinkHrefParameters.ToString("GET","edit_id;parent_id", ViewState)
        End If
        If e.Item.ItemType = CCDirectoryItemType.SubcategoriesTail Then
            Dim yp_categorySubcategoriesTailLink As System.Web.UI.HtmlControls.HtmlAnchor = DirectCast(e.Item.FindControl("yp_categorySubcategoriesTailLink"),System.Web.UI.HtmlControls.HtmlAnchor)
            DataItem.SubcategoriesTailLinkHref = "DirectoryMaintenance.aspx?"
            yp_categorySubcategoriesTailLink.HRef += DataItem.SubcategoriesTailLinkHref & DataItem.SubcategoriesTailLinkHrefParameters.ToString("GET","edit_id;parent_id", ViewState)
        End If
'End Directory yp_category ItemDataBound event

'Directory yp_category ItemDataBound event tail @42-E31F8E2A
    End Sub
'End Directory yp_category ItemDataBound event tail

'Record Form form_categories Parameters @23-10CF2292

    Protected Sub form_categoriesParameters()
        Try
            form_categoriesData.Urledit_id = IntegerParameter.GetParam(Request.QueryString("edit_id"))
        Catch e As Exception
            form_categoriesErrors.Add("Parameters","Form Parameters: " + e.Message)
        End Try
    End Sub
'End Record Form form_categories Parameters

'Record Form form_categories Show method @23-1D190D82
    Protected Sub form_categoriesShow()
        Dim AllowRead As Boolean = True
        Dim AllowInsert As Boolean = True
        Dim AllowUpdate As Boolean = True
        Dim AllowDelete As Boolean = True
        Dim item As form_categoriesItem = form_categoriesItem.CreateFromHttpRequest()
        Dim IsInsertMode As Boolean = Not AllowRead
        form_categoriesErrors.Add(item.errors)
        If form_categoriesErrors.Count > 0 Then
            form_categoriesShowErrors()
            Return
        End If
'End Record Form form_categories Show method

'Record Form form_categories BeforeShow tail @23-4A776645
        form_categoriesParameters()
        form_categoriesData.FillItem(item, IsInsertMode)
        form_categoriesInsert1.Visible = IsInsertMode And AllowInsert
        form_categoriesUpdate1.Visible = (Not IsInsertMode) And AllowUpdate
        form_categoriesDelete1.Visible = (Not IsInsertMode) And AllowDelete
        form_categoriescategory_name.Text=item.category_name.GetFormattedValue()
        form_categoriescategory_id_parent.Value = item.category_id_parent.GetFormattedValue()
'End Record Form form_categories BeforeShow tail

'Record form_categories Event BeforeShow. Action Custom Code @35-73254650

'Set the value of the hidden category_id_parent field to the value based on "Edit" link's parameters.
  If IsNothing(Request.QueryString("parent_id")) Or Request.QueryString("parent_id") = "" Then  
     form_categoriescategory_id_parent.Value = Request.QueryString("category_id")
  Else
     form_categoriescategory_id_parent.Value = Request.QueryString("parent_id")
  End if

'End Record form_categories Event BeforeShow. Action Custom Code

'Record Form form_categories Show method tail @23-E31F8E2A
    End Sub
'End Record Form form_categories Show method tail

'Record Form form_categories LoadItemFromRequest method @23-1A130F79

    Protected Function form_categoriesLoadItemFromRequest(ByVal EnableValidation As Boolean) As form_categoriesItem
        Dim item As form_categoriesItem = New form_categoriesItem()
        item.category_name.SetValue(form_categoriescategory_name.Text)
        Try
        item.category_id_parent.SetValue(form_categoriescategory_id_parent.Value)
        Catch ae As ArgumentException
            form_categoriesErrors.Add("category_id_parent","The value in field Category Id Parent is not valid.")
        End Try
        If EnableValidation Then
            item.Validate(form_categoriesData)
        End If
        form_categoriesErrors.Add(item.errors)
        Return item
    End Function
'End Record Form form_categories LoadItemFromRequest method

'Record Form form_categories GetRedirectUrl method @23-DA8C0D6F

    Protected Function Getform_categoriesRedirectUrl(ByVal redirect As String, ByVal removeList As String) As String
        Dim Params As String = ""
        Dim List() As String = {""}

        List = ("edit_id;parent_id;" + RemoveList).ToLower().Split(New Char() {";"})
        If Redirect= "" Then
            Redirect = "DirectoryMaintenance.aspx"
        End If
        Dim j As Integer
        For j=0 To Request.QueryString.Count - 1
            If Array.IndexOf(List,Request.QueryString.AllKeys(j).ToLower()) < 0 Then
                Params = Params & Request.QueryString.AllKeys(j) & "=" & Server.UrlEncode(Request.QueryString(j)) & "&"
            End If
        Next j
        Params = Params.TrimEnd(New Char(){"&"})
        Return Redirect & "?" & Params
    End Function
'End Record Form form_categories GetRedirectUrl method

'Record Form form_categories ShowErrors method @23-A1B4A145

    Protected Sub form_categoriesShowErrors()
        Dim DefaultMessage As String = ""
        Dim i As Integer
        For i = 0 To form_categoriesErrors.Count - 1
        Select Case form_categoriesErrors.AllKeys(i)
            Case Else
                DefaultMessage = DefaultMessage & form_categoriesErrors(i) & "<br>"
        End Select
        Next i
        form_categoriesError.Visible = True
        form_categoriesErrorLabel.Text = DefaultMessage
    End Sub
'End Record Form form_categories ShowErrors method

'Record Form form_categories Insert Operation @23-5C6E7D4D

    Protected Sub form_categories_Insert(ByVal sender As Object, ByVal e As System.EventArgs)
        Dim item As form_categoriesItem = Nothing
        Dim ExecuteFlag As Boolean = True
        Dim ErrorFlag As Boolean = False
        Dim RedirectUrl As String = Getform_categoriesRedirectUrl("", "")
'End Record Form form_categories Insert Operation

'Record Form form_categories BeforeInsert tail @23-D6E45BBC
    form_categoriesParameters()
    item = form_categoriesLoadItemFromRequest(True)
    If form_categoriesInsertAllowed Then
        ErrorFlag=(form_categoriesErrors.Count > 0)
        If ExecuteFlag And (Not ErrorFlag) Then
            Try
                form_categoriesData.InsertItem(item)
            Catch ex As Exception
                form_categoriesErrors.Add("DataProvider",ex.Message)
                ErrorFlag = True
            End Try
        End If
'End Record Form form_categories BeforeInsert tail

'Record Form form_categories AfterInsert tail  @23-1F1C0A8F
        End If
        If ErrorFlag Then
            form_categoriesShowErrors()
        Else
            Response.Redirect(RedirectUrl)
        End If
    End Sub
'End Record Form form_categories AfterInsert tail 

'Record Form form_categories Update Operation @23-8446292D

    Protected Sub form_categories_Update(ByVal sender As Object, ByVal e As System.EventArgs)
        Dim item As form_categoriesItem = Nothing
        Dim ExecuteFlag As Boolean = True
        Dim ErrorFlag As Boolean = False
        Dim RedirectUrl As String = Getform_categoriesRedirectUrl("", "")
'End Record Form form_categories Update Operation

'Record Form form_categories Before Update tail @23-25523946
        form_categoriesParameters()
        item = form_categoriesLoadItemFromRequest(True)
        If form_categoriesUpdateAllowed Then
        ErrorFlag = (form_categoriesErrors.Count > 0)
        If ExecuteFlag And (Not ErrorFlag) Then
            Try
                form_categoriesData.UpdateItem(item)
            Catch ex As Exception
                form_categoriesErrors.Add("DataProvider",ex.Message)
                ErrorFlag = True
            End Try
        End If
'End Record Form form_categories Before Update tail

'Record Form form_categories Update Operation tail @23-1F1C0A8F
        End If
        If ErrorFlag Then
            form_categoriesShowErrors()
        Else
            Response.Redirect(RedirectUrl)
        End If
    End Sub
'End Record Form form_categories Update Operation tail

'Record Form form_categories Delete Operation @23-B621EAA8

    Protected Sub form_categories_Delete(ByVal sender As Object, ByVal e As System.EventArgs)
        Dim ExecuteFlag As Boolean = True
        Dim ErrorFlag As Boolean = False
        Dim RedirectUrl As String = Getform_categoriesRedirectUrl("", "")
        Dim item As form_categoriesItem = Nothing
        item = form_categoriesLoadItemFromRequest(False)
'End Record Form form_categories Delete Operation

'Record Form BeforeDelete tail @23-C8F7D833
        form_categoriesParameters()
        item = form_categoriesLoadItemFromRequest(False)
        If form_categoriesDeleteAllowed Then
        ErrorFlag = (form_categoriesErrors.Count > 0)
        If ExecuteFlag And (Not ErrorFlag) Then
            Try
                form_categoriesData.DeleteItem()
            Catch ex As Exception
                form_categoriesErrors.Add("DataProvider",ex.Message)
                ErrorFlag = True
            End Try
        End If
'End Record Form BeforeDelete tail

'Record Form AfterDelete tail @23-1F1C0A8F
        End If
        If ErrorFlag Then
            form_categoriesShowErrors()
        Else
            Response.Redirect(RedirectUrl)
        End If
    End Sub
'End Record Form AfterDelete tail

'Record Form form_categories Cancel Operation @23-D03D674E

    Protected Sub form_categories_Cancel(ByVal sender As Object, ByVal e As System.EventArgs)
        Dim item As form_categoriesItem = Nothing
        Dim RedirectUrl As String = Getform_categoriesRedirectUrl("", "")
        item = form_categoriesLoadItemFromRequest(False)
'End Record Form form_categories Cancel Operation

'Record Form form_categories Cancel Operation tail @23-EA2B0FFB
        Response.Redirect(RedirectUrl)
    End Sub
'End Record Form form_categories Cancel Operation tail

'OnInit Event @1-BD1C49BF
    #Region " Web Form Designer Generated Code "
    Protected Overrides Sub OnInit(ByVal e As EventArgs)
        '
        ' CODEGEN: This call is required by the ASP.NET Web Form Designer.
        '
        InitializeComponent()
        'Me.Load += new System.EventHandler(this.Page_Load);
        'Me.Unload += new System.EventHandler(this.Page_Unload);
        Path_link_categoriesData = New Path_link_categoriesDataProvider()
        yp_categoryData = New yp_categoryDataProvider()
        form_categoriesData = New form_categoriesDataProvider()
        MyBase.OnInit(e)
'End OnInit Event

'OnInit Event tail @1-E31F8E2A
    End Sub
'End OnInit Event tail

'InitializeComponent Event @1-EA5E2628
    ' <summary>
    ' Required method for Designer support - do not modify
    ' the contents of this method with the code editor.
    ' </summary>
    Private Sub InitializeComponent()
    End Sub
    #End Region
'End InitializeComponent Event

'Page class tail @1-DD082417
End Class
End Namespace
'End Page class tail

