//Using Statements @1-A9948A1F
using System;
using System.Collections;
using System.Collections.Specialized;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Text.RegularExpressions;
using System.Globalization;
using CCSExample_CSharp;
using CCSExample_CSharp.Data;
using CCSExample_CSharp.Configuration;
using CCSExample_CSharp.Controls;

namespace CCSExample_CSharp.EditableGridAddButton.EditableGridAddButton
{

//End Using Statements

//Forms Definition @1-3F1E7D72
public class EditableGridAddButtonPage : System.Web.UI.Page
{
//End Forms Definition

//Forms Objects @1-246581D3
    protected System.Web.UI.WebControls.Repeater departmentsRepeater;
    protected departmentsDataProvider departmentsData;
    protected NameValueCollection departmentsErrors=new NameValueCollection();
    protected System.Web.UI.HtmlControls.HtmlAnchor Link1;
//End Forms Objects
	private string DepartsEmtyRowId;
//Page_Load Event @1-55207E05
private void Page_Load(object sender, System.EventArgs e)
{
//End Page_Load Event

//Page_Load Event BeforeIsPostBack @1-018219C5
    if (!IsPostBack)
    {
            PageDataProvider PageData=new PageDataProvider();
            PageItem item=PageItem.CreateFromHttpRequest();
            item.Link1Href = "EditableGridAddButton_desc.aspx";
            PageData.FillItem(item);
            Link1.InnerText += item.Link1.GetFormattedValue().Replace("\r","").Replace("\n","<br>");
            Link1.HRef += item.Link1Href+item.Link1HrefParameters.ToString("None","", ViewState);
            departmentsBind();
    }
//End Page_Load Event BeforeIsPostBack

//Page_Load Event tail @1-FCB6E20C
}
//End Page_Load Event tail

//Page_Unload Event @1-72102C7C
private void Page_Unload(object sender, System.EventArgs e)
{
//End Page_Unload Event

//Page_Unload Event tail @1-FCB6E20C
}
//End Page_Unload Event tail

//EditableGrid departments Bind @3-5A83747B
    protected void departmentsBind()
    {
        int PagesCount;
        int FooterIndex;
        if (!IsPostBack)
        {
            string Param;
            int PageSize;
            ViewState["departmentsSortField"] = departmentsDataProvider.SortFields.Default;
            PageSize = 0;
            ViewState["departmentsPageNumber"] = 1;
            Param = Request.QueryString["departmentsOrder"];
            if (Param != null && Param.Length > 0)
                try{
                    departmentsDataProvider.SortFields SortField = 0;
                    ViewState["departmentsSortField"] = Enum.Parse(SortField.GetType(), Param);
                }catch {}
            Param = Request.QueryString["departmentsDir"];
            if (Param == null || Param.Length == 0 || Param.ToLower() == "desc")
                ViewState["departmentsSortDir"] = SortDirections.Desc;
            else
                ViewState["departmentsSortDir"] = SortDirections.Asc;
            Param = Request.QueryString["departmentsPage"];
            int PageNumber;
            if (Param != null && Param.Length > 0)
                try
                {
                    PageNumber = Int32.Parse(Param);
                    if (PageNumber <= 0) ViewState["departmentsPageNumber"] = 1;
                }
                catch {}
            Param = Request.QueryString["departmentsPageSize"];
            if (Param != null && Param.Length > 0)
                try
                {
                    PageSize = Int32.Parse(Param);
                    if (PageSize <= 0) PageSize = 0;
                }
                catch {}
            if (PageSize > 100)
                PageSize = 100;
            ViewState["departmentsPageSize"] = PageSize;
        }
//End EditableGrid departments Bind

//Grid Form departments BeforeShow tail @3-592B2E92
        departmentsParameters();
        departmentsData.SortField = (departmentsDataProvider.SortFields)ViewState["departmentsSortField"];
        departmentsData.SortDir = (SortDirections)ViewState["departmentsSortDir"];
        departmentsData.PageNumber = (int)ViewState["departmentsPageNumber"];
        departmentsData.RecordsPerPage = (int)ViewState["departmentsPageSize"];
        object dataSource = departmentsData.GetResultSet(out PagesCount);
        departmentsRepeater.DataSource = departmentsData.GetResultSet(out PagesCount);
        ViewState["departmentsPagesCount"] = PagesCount;
        ViewState["departmentsFormState"] = new Hashtable();
        departmentsRepeater.DataBind();
        FooterIndex = departmentsRepeater.Controls.Count - 1;
        Literal Script = (Literal)departmentsRepeater.Controls[0].FindControl("FormScript");
        Literal Elements = (Literal)departmentsRepeater.Controls[0].FindControl("ElementsID");
        Elements.Text += "var departmentsStaticElementsID;\n";
        string StaticElementsID = "departmentsStaticElementsID = new Array (";
        Elements.Text += "var departmentsAddRowBtnID=0;\n";
        StaticElementsID += "document.forms[\"_ctl0\"]." + departmentsRepeater.Controls[FooterIndex].FindControl("departmentsAddRowBtn").ClientID + ",";
        Elements.Text += "var departmentsButton_SubmitID=1;\n";
        StaticElementsID += "document.forms[\"_ctl0\"]." + departmentsRepeater.Controls[FooterIndex].FindControl("departmentsButton_Submit").ClientID + "";
        Script.Text += StaticElementsID + ");\n";
        departmentsItem item=new departmentsItem();


        if (PagesCount == 0)
        {
            departmentsRepeater.Controls[FooterIndex].FindControl("NoRecords").Visible = true;
        }
        if (departmentsErrors.Count > 0)
        {
            System.Web.UI.WebControls.Label Error = (System.Web.UI.WebControls.Label)(departmentsRepeater.Controls[0].FindControl("ErrorLabel"));
            PlaceHolder RowError = (System.Web.UI.WebControls.PlaceHolder)(departmentsRepeater.Controls[0].FindControl("departmentsError"));
            RowError.Visible = true;
            foreach(string msg in departmentsErrors)
                Error.Text += departmentsErrors[msg] + "<br/>";
        }
//End Grid Form departments BeforeShow tail

//Control departments Event BeforeShow. Action Custom Code @22-2A29BDB7
	ViewState["DepsRowIDs"] = DepartsEmtyRowId.TrimEnd(new Char[]{','});
    RegisterArrayDeclaration("DepsRowIDs",DepartsEmtyRowId.TrimEnd(new Char[]{','}));
//End Control departments Event BeforeShow. Action Custom Code

//EditableGrid departments Bind tail @3-437BB1A2
        departmentsShowErrors(new ArrayList((ICollection)departmentsRepeater.DataSource), departmentsRepeater.Items);
    }
//End EditableGrid departments Bind tail

//EditableGrid departments Table Parameters @3-072611D6
    protected void departmentsParameters()
    {
        try{
        }catch{
            ControlCollection ParentControls=departmentsRepeater.Parent.Controls;
            int RepeaterIndex=ParentControls.IndexOf(departmentsRepeater);
            ParentControls.RemoveAt(RepeaterIndex);
            Literal ErrorMessage=new Literal();
            ErrorMessage.Text="Error in Grid departments: Invalid parameter";
            ParentControls.AddAt(RepeaterIndex,ErrorMessage);
        }
	}
	
//End EditableGrid departments Table Parameters

//EditableGrid departments ItemDataBound event @3-1949CE1A
    protected void departmentsItemDataBound(Object Sender, RepeaterItemEventArgs e)
    {
        departmentsItem DataItem=(departmentsItem)e.Item.DataItem;
        if (e.Item.ItemType == ListItemType.Item || e.Item.ItemType == ListItemType.AlternatingItem) {
            DataItem.RowId = e.Item.ItemIndex;
            Hashtable formState = (Hashtable)ViewState["departmentsFormState"];
            formState.Add("department_idField:" + e.Item.ItemIndex.ToString(),DataItem.department_idField.Value);
            System.Web.UI.HtmlControls.HtmlSelect departmentsmanager_id = (System.Web.UI.HtmlControls.HtmlSelect)(e.Item.FindControl("departmentsmanager_id"));
            DataItem.manager_idItems.SetSelection(DataItem.manager_id.Value);
            departmentsmanager_id.SelectedIndex = -1;
            DataItem.manager_idItems.CopyTo(departmentsmanager_id.Items);
            System.Web.UI.WebControls.CheckBox departmentsCheckBox_Delete = (System.Web.UI.WebControls.CheckBox)(e.Item.FindControl("departmentsCheckBox_Delete"));
            if(DataItem.CheckBox_DeleteCheckedValue.Value.Equals(DataItem.CheckBox_Delete.Value))
                departmentsCheckBox_Delete.Checked = true;
        }
//End EditableGrid departments ItemDataBound event

//EditableGrid departments Event BeforeShowRow. Action Custom Code @17-2A29BDB7
	if (e.Item.ItemType == ListItemType.Item || e.Item.ItemType == ListItemType.AlternatingItem){
		if(DataItem.IsEmptyItem){
			DepartsEmtyRowId += e.Item.FindControl("MyRow").ClientID + ",";
			((HtmlControl)e.Item.FindControl("MyRow")).Attributes.Add("style","display:none");
		}
	}
//End EditableGrid departments Event BeforeShowRow. Action Custom Code

//EditableGrid departments ItemDataBound event tail @3-FCB6E20C
    }
//End EditableGrid departments ItemDataBound event tail

//EditableGrid departments GetRedirectUrl method @3-559EA792
    protected string GetdepartmentsRedirectUrl(string redirectString ,string removeList)
    {
        string Params="";
        string[] List;

        if(removeList=="")
            List=new string[1];
        else
            List=removeList.Split(new Char[] {';'});

        if(redirectString == "") redirectString = Request.Url.AbsolutePath;
        for(int i = 0; i < Request.QueryString.Count;i ++)
            if(Array.IndexOf(List,Request.QueryString.AllKeys[i]) < 0)
                Params += Request.QueryString.AllKeys[i] + "=" + Server.UrlEncode(Request.QueryString[i]) + "&";
        Params = Params.TrimEnd(new Char[]{'&'});
        return redirectString + "?" + Params;
    }
    protected string GetdepartmentsRedirectUrl(string redirectString)
    {
        return GetdepartmentsRedirectUrl(redirectString ,"");
    }
//End EditableGrid departments GetRedirectUrl method

//EditableGrid departments ShowErrors method @3-3ED9A528
    protected bool departmentsShowErrors(ArrayList items, RepeaterItemCollection col)
    {
        bool result = true;
        foreach(departmentsItem item in items)
        {
            if(item.IsUpdated) col[item.RowId].Visible = false;
            if(item.errors.Count > 0){
                result = false;
                string DefaultMessage="";
                for(int j = 0; j < item.errors.Count; j ++)
                switch (item.errors.AllKeys[j])
                {
                    default:
                        DefaultMessage += item.errors[j] + "<br>";
                        break;
                }
                System.Web.UI.WebControls.Label Error = (System.Web.UI.WebControls.Label)(col[item.RowId].FindControl("ErrorLabel"));
                col[item.RowId].FindControl("RowError").Visible = true;
                Error.Text = DefaultMessage;
            }
        }
        return result;
    }
//End EditableGrid departments ShowErrors method

//EditableGrid departments ItemCommand event @3-7066AFC9
    protected void departmentsItemCommand(Object Sender, RepeaterCommandEventArgs e)
    {
        int FooterIndex = departmentsRepeater.Controls.Count - 1;
        bool BindAllowed = false;
//End EditableGrid departments ItemCommand event

//EditableGrid Form departments ItemCommand event tail @3-C8FCB13B
        if(e.CommandName=="Sort"){
            if(((SorterState)e.CommandArgument)==SorterState.None)
                if((SortDirections)ViewState["departmentsSortDir"]==SortDirections.Asc&&ViewState["departmentsSortField"].ToString()==((CCSExample_CSharp.Controls.Sorter)e.CommandSource).Field)
                    ViewState["departmentsSortDir"]=SortDirections.Desc;
                else
                    ViewState["departmentsSortDir"]=SortDirections.Asc;
            else
                ViewState["departmentsSortDir"]=(int)(((CCSExample_CSharp.Controls.Sorter)e.CommandSource).State);
            ViewState["departmentsSortField"]=Enum.Parse(typeof(departmentsDataProvider.SortFields),((CCSExample_CSharp.Controls.Sorter)e.CommandSource).Field);
            ViewState["departmentsPageNumber"] = 1;
            BindAllowed = true;
        }

        if(e.CommandName=="Navigate"){
            ViewState["departmentsPageNumber"] = Int32.Parse(e.CommandArgument.ToString());
            BindAllowed = true;
        }

        if(e.CommandName=="Submit"){
            BindAllowed = true;
            RepeaterItemCollection col=departmentsRepeater.Items;
            ArrayList items=new ArrayList();
            Hashtable formState = (Hashtable)ViewState["departmentsFormState"];
            string RedirectUrl = GetdepartmentsRedirectUrl("");
            departmentsParameters();
            for(int i=0;i<col.Count;i++)
                if(col[i].ItemType == ListItemType.Item || col[i].ItemType == ListItemType.AlternatingItem){
                    System.Web.UI.WebControls.Literal departmentsRowIDAttribute = (System.Web.UI.WebControls.Literal)(col[i].FindControl("departmentsRowIDAttribute"));
                    System.Web.UI.WebControls.Literal departmentsRowNameAttribute = (System.Web.UI.WebControls.Literal)(col[i].FindControl("departmentsRowNameAttribute"));
                    System.Web.UI.WebControls.Literal departmentsRowStyleAttribute = (System.Web.UI.WebControls.Literal)(col[i].FindControl("departmentsRowStyleAttribute"));
                    System.Web.UI.WebControls.TextBox departmentsdepartment_name = (System.Web.UI.WebControls.TextBox)(col[i].FindControl("departmentsdepartment_name"));
                    System.Web.UI.HtmlControls.HtmlSelect departmentsmanager_id = (System.Web.UI.HtmlControls.HtmlSelect)(col[i].FindControl("departmentsmanager_id"));
                    System.Web.UI.WebControls.CheckBox departmentsCheckBox_Delete = (System.Web.UI.WebControls.CheckBox)(col[i].FindControl("departmentsCheckBox_Delete"));
                    col[i].FindControl("RowError").Visible = false;
                    departmentsItem item = new departmentsItem();
                    item.RowId = col[i].ItemIndex;
                    item.IsUpdated = !col[i].Visible;
                    item.department_idField.Value = formState["department_idField:" + col[i].ItemIndex.ToString()];
                    item.IsDeleted = departmentsCheckBox_Delete.Checked;
                    item.RowIDAttribute.SetValue(departmentsRowIDAttribute.Text);
                    item.RowNameAttribute.SetValue(departmentsRowNameAttribute.Text);
                    item.RowStyleAttribute.SetValue(departmentsRowStyleAttribute.Text);
                    item.department_name.SetValue(departmentsdepartment_name.Text);
                    try{
                    item.manager_id.SetValue(departmentsmanager_id.Value);
                    }catch(ArgumentException){
                        item.errors.Add("manager_id","The value in field Manager is not valid.");}
                    items.Add(item);

                    if(!item.IsEmptyItem && !item.IsDeleted) BindAllowed = item.Validate(departmentsData) && BindAllowed;
            }

//End EditableGrid Form departments ItemCommand event tail

//EditableGrid departments Event BeforeSubmit. Action Custom Code @23-2A29BDB7

   		foreach(departmentsItem item in items)
          {
              if(!item.IsEmptyItem){
  				((HtmlControl)(col[item.RowId].FindControl("MyRow"))).Attributes.Remove("style");
              }
  			RegisterArrayDeclaration("DepsRowIDs",ViewState["DepsRowIDs"] as string);
          }

//End EditableGrid departments Event BeforeSubmit. Action Custom Code

//EditableGrid departments Update @3-286A5590
        if (BindAllowed)
            try
            {
                departmentsData.Update(items);
                if (departmentsShowErrors(items, col))
                    Response.Redirect(RedirectUrl);
                else
                    BindAllowed = false;
            }
            catch (Exception ex)
            {
                System.Web.UI.WebControls.Label Error = (System.Web.UI.WebControls.Label)(col[0].FindControl("ErrorLabel"));
                PlaceHolder RowError = (System.Web.UI.WebControls.PlaceHolder)(col[0].FindControl("departmentsError"));
                RowError.Visible = true;
                Error.Text = "DataProvider:" + ex.Message;
                BindAllowed=false;
            }
//End EditableGrid departments Update

//EditableGrid departments AfterSubmit @3-9EE5F552
        else
            departmentsShowErrors(items, col);
        }
        if (BindAllowed)
            departmentsBind();
    }
//End EditableGrid departments AfterSubmit

//OnInit Event @1-5B5259B2
    #region Web Form Designer generated code
    override protected void OnInit(EventArgs e)
    {
        //
        //CODEGEN: This call is required by the ASP.NET Web Form Designer.
        //
        InitializeComponent();
        this.Load += new System.EventHandler(this.Page_Load);
        this.Unload += new System.EventHandler(this.Page_Unload);
        departmentsData = new departmentsDataProvider();
        base.OnInit(e);
//End OnInit Event

//OnInit Event tail @1-FCB6E20C
    }
//End OnInit Event tail

//InitializeComponent Event @1-722FC1EE
    /// <summary>
    /// Required method for Designer support - do not modify
    /// the contents of this method with the code editor.
    /// </summary>
    private void InitializeComponent()
    {
    }
    #endregion
//End InitializeComponent Event

//Page class tail @1-F5FC18C5
}
}
//End Page class tail

