'Using Statements @1-63FE2778
Imports System
Imports System.Text
Imports System.Text.RegularExpressions
Imports System.Collections
Imports System.Collections.Specialized
Imports System.Data
Imports ExamplePack_VB
Imports ExamplePack_VB.Data
Imports ExamplePack_VB.Controls
Imports ExamplePack_VB.Configuration

Namespace EditableGridAddButton.EditableGridAddButton
'End Using Statements

'Page Data Class @1-0E92F43E
Public Class PageItem
    Public errors As NameValueCollection = New NameValueCollection()

    Public Sub New()
    End Sub
    Public Shared Function CreateFromHttpRequest() As PageItem
        Dim item As PageItem = New PageItem()
        item.Link1.SetValue(DBUtility.GetInitialValue("Link1"))
        Return item
    End Function

    Default Public Property Field(fieldName As String) As FieldBase
        Get
            Select fieldName
                Case "Link1"
                    Return Link1
                Case Else
                    Throw (New ArgumentOutOfRangeException())
            End Select
        End Get
        Set (ByVal Value As FieldBase)
            Select fieldName
                Case "Link1"
                    Link1 = CType(value, TextField)
                Case Else
                    Throw (New ArgumentOutOfRangeException())
            End Select
        End Set
    End Property

    Public Link1 As TextField = New TextField("",Nothing)
    Public Link1Href As Object
    Public Link1HrefParameters As LinkParameterCollection = New LinkParameterCollection()
End Class
'End Page Data Class

'Page Data Provider Class @1-E3544B64
Public Class PageDataProvider
Dim j As Integer
'End Page Data Provider Class

'Page Data Provider Class Constructor @1-12B526DF

    Public Sub New()
    End Sub
'End Page Data Provider Class Constructor

'Page Data Provider Class GetResultSet Method @1-F73C4626

    Public Sub FillItem(ByVal item As PageItem)
'End Page Data Provider Class GetResultSet Method

'Page Data Provider Class GetResultSet Method tail @1-E31F8E2A
    End Sub
'End Page Data Provider Class GetResultSet Method tail

'Page Data Provider Tail @1-A61BA892
End Class
'End Page Data Provider Tail

'EditableGrid departments Item Class @3-906EC720
Public Class departmentsItem
    Public errors As NameValueCollection = New NameValueCollection()
    Public RowId As Integer
    Public Sub New()
    End Sub

    Public Default Property Field(ByVal fieldName As String) as FieldBase
        Get
            Select fieldName
                Case "department_idField"
                    Return Me.department_idField
                Case "RowIDAttribute"
                    Return Me.RowIDAttribute
                Case "RowNameAttribute"
                    Return Me.RowNameAttribute
                Case "RowStyleAttribute"
                    Return Me.RowStyleAttribute
                Case "department_name"
                    Return Me.department_name
                Case "manager_id"
                    Return Me.manager_id
                Case "CheckBox_Delete"
                    Return Me.CheckBox_Delete
                Case Else
                    Throw New ArgumentOutOfRangeException()
            End Select
        End Get
        Set (ByVal Value As FieldBase)
            Select fieldName
                Case "department_idField"
                    Me.department_idField = CType(Value,IntegerField)
                Case "RowIDAttribute"
                    Me.RowIDAttribute = CType(Value,TextField)
                Case "RowNameAttribute"
                    Me.RowNameAttribute = CType(Value,TextField)
                Case "RowStyleAttribute"
                    Me.RowStyleAttribute = CType(Value,TextField)
                Case "department_name"
                    Me.department_name = CType(Value,TextField)
                Case "manager_id"
                    Me.manager_id = CType(Value,IntegerField)
                Case "CheckBox_Delete"
                    Me.CheckBox_Delete = CType(Value,BooleanField)
                Case Else
                    Throw New ArgumentOutOfRangeException()
            End Select
        End Set
    End Property

    Public ReadOnly Property IsNew As Boolean
        Get
            Dim result As Boolean = True
            Dim result1 As Boolean = True
            result = IsNothing(department_idField.Value) And result
            result1 = IsNothing(department_name.Value) And result1
            result1 = IsNothing(manager_id.Value) And result1
            result1 = IsNothing(CheckBox_Delete.Value) And result1
            Return result And (Not result1)
        End Get
    End Property

    Public ReadOnly Property IsEmptyItem As Boolean
        Get
            Dim result As Boolean = True
            result = IsNothing(department_name.Value) And result
            result = IsNothing(manager_id.Value) And result
            result = IsNothing(CheckBox_Delete.Value) And result
            result = IsNothing(department_idField.Value) And result
            Return result
        End Get
    End Property

    Public IsDeleted As Boolean = False
    Public IsUpdated As Boolean = False
    Public RowIDAttribute As TextField = New TextField("", Nothing)
    Public RowNameAttribute As TextField = New TextField("", Nothing)
    Public RowStyleAttribute As TextField = New TextField("", Nothing)
    Public department_name As TextField = New TextField("", Nothing)
    Public manager_id As IntegerField = New IntegerField("", Nothing)
    Public manager_idItems As ItemCollection = New ItemCollection()
    Public CheckBox_Delete As BooleanField = New BooleanField(Settings.BoolFormat, Nothing)
    Public CheckBox_DeleteCheckedValue As BooleanField = New BooleanField(Settings.BoolFormat, true)
    Public CheckBox_DeleteUncheckedValue As BooleanField = New BooleanField(Settings.BoolFormat, false)

    Public department_idField As IntegerField = New IntegerField()
    Public Function Validate(ByVal provider As departmentsDataProvider) As Boolean
'End EditableGrid departments Item Class

'department_name validate @7-84879D2D
        If IsNothing(department_name.Value) Then
            errors.Add("department_name","The value in field  Name is required.")
        ElseIf department_name.Value.ToString() ="" Then
            errors.Add("department_name","The value in field  Name is required.")
        End If
'End department_name validate

'EditableGrid departments Item Class tail @3-9124938E
        Return errors.Count = 0
    End Function
End Class
'End EditableGrid departments Item Class tail

'EditableGrid departments Data Provider Class Header @3-B0495CF4
Public Class departmentsDataProvider
Inherits EditableGridDataProviderBase
'End EditableGrid departments Data Provider Class Header

'Grid departments Data Provider Class Variables @3-81C28EEB

    Public Enum SortFields
        _Default
    End Enum

    Private SortFieldsNames As String() = New String() {"department_id"}
    Private SortFieldsNamesDesc As String() = New string() {"department_id"}
    Public SortField As SortFields = SortFields._Default
    Public SortDir As SortDirections = SortDirections._Asc
    Public RecordsPerPage As Integer = 0
    Public PageNumber As Integer = 1
    Public EmptyRows As Integer = 30
    Protected manager_idDataCommand As DataCommand = New TableCommand("SELECT *  " & _
          "FROM employees",New String(){},Settings.IntranetDBDataAccessObject)
'End Grid departments Data Provider Class Variables

'EditableGrid departments Data Provider Class Constructor @3-91AE8AB7

    Public Sub New()
        Select_ = New TableCommand("SELECT *  " & _
          "FROM departments",New String(){},Settings.IntranetDBDataAccessObject)
        Count = New TableCommand("SELECT COUNT(*)  " & _
          "FROM departments",New String(){},Settings.IntranetDBDataAccessObject)
    End Sub
'End EditableGrid departments Data Provider Class Constructor

'Record departments Data Provider Class CheckUnique Method @3-6D4AA45B

    Public Function CheckUnique(ByVal ControlName As String, ByVal item As departmentsItem) As Boolean
        Return True
    End Function
'End Record departments Data Provider Class CheckUnique Method

'Grid departments Data Provider Class Insert Method @3-36951FCB
    Protected Function InsertItem(ByVal item As departmentsItem) As Integer
        Dim Insert As DataCommand = New TableCommand("INSERT INTO departments(department_name, department_manager_id ) VALUES ( {department_name}, {manager_id})" _
          ,New String(){},Settings.IntranetDBDataAccessObject)
'End Grid departments Data Provider Class Insert Method

'EditableGrid departments Build insert @3-538845CD
        Insert.SqlQuery.Replace("{department_name}",Insert.Dao.ToSql(item.department_name.GetFormattedValue(""),FieldType._Text))
        Insert.SqlQuery.Replace("{manager_id}",Insert.Dao.ToSql(item.manager_id.GetFormattedValue(""),FieldType._Integer))
'End EditableGrid departments Build insert

'EditableGrid departments Data Provider Class ExecuteInsert @3-9E5B2417
        Dim result As Object = Nothing
        Dim E As Exception = Nothing
        Try
            result = Insert.ExecuteNonQuery()
        Catch e_ As Exception
            item.errors.Add("DataProvider",e_.Source + ":" + e_.Message)
            result = 0
        Finally
'End EditableGrid departments Data Provider Class ExecuteInsert

'EditableGrid departments AfterExecuteInsert @3-5C54EEF8
        End Try
        Return CType(result, Integer)
    End Function
'End EditableGrid departments AfterExecuteInsert

'EditableGrid departments Data Provider Class Update Method @3-0AF927F1
    Protected Function UpdateItem(ByVal item As departmentsItem) As Integer
        Dim Update As DataCommand = New TableCommand("UPDATE departments SET department_name={department_name}, department_manager_id={manager_id}" _
          ,New String(){"department_id4"},Settings.IntranetDBDataAccessObject)
'End EditableGrid departments Data Provider Class Update Method

'EditableGrid departments BeforeBuildUpdate @3-CEAFF52B
        Update.SqlQuery.Replace("{department_name}",Update.Dao.ToSql(item.department_name.GetFormattedValue(""),FieldType._Text))
        Update.SqlQuery.Replace("{manager_id}",Update.Dao.ToSql(item.manager_id.GetFormattedValue(""),FieldType._Integer))
        Update.Parameters.Add("department_id4","department_id = " & Update.Dao.ToSql(item.department_idField.GetFormattedValue(""),FieldType._Integer))
'End EditableGrid departments BeforeBuildUpdate

'EditableGrid departments Execute Update  @3-A372D3E2
        Dim result As Object = Nothing
        Dim E As Exception = Nothing
        Try
            result = Update.ExecuteNonQuery()
        Catch e_ As Exception
            item.errors.Add("DataProvider",e_.Source + ":" + e_.Message)
            result = 0
        Finally
'End EditableGrid departments Execute Update 

'EditableGrid departments AfterExecuteUpdate @3-5C54EEF8
        End Try
        Return CType(result, Integer)
    End Function
'End EditableGrid departments AfterExecuteUpdate

'Record departments Data Provider Class Delete Method @3-861EC5B1
    Public Function DeleteItem(ByVal item As departmentsItem) As Integer
        Dim Delete As DataCommand = New TableCommand("DELETE FROM departments",New String(){"department_id4"},Settings.IntranetDBDataAccessObject)
'End Record departments Data Provider Class Delete Method

'Record departments BeforeBuildDelete @3-AD2AE028
        Delete.Parameters.Add("department_id4","department_id = " & Delete.Dao.ToSql(item.department_idField.GetFormattedValue(""),FieldType._Integer))
'End Record departments BeforeBuildDelete

'Record departments Event BeforeExecuteDelete. Action Custom Code @20-73254650
 'Get the where parameters
	Dim DepartmentID As String = "department_id = " + Delete.Dao.ToSql(item.department_idField.GetFormattedValue(""), FieldType._Integer)
	Dim NewDao As DataAccessObject = Settings.IntranetDBDataAccessObject
	'Delete project employees links
	NewDao.ExecuteNonQuery(("UPDATE employees SET department_id = NULL WHERE " + DepartmentID))
'End Record departments Event BeforeExecuteDelete. Action Custom Code

'EditableGrid departments Data Provider Class Execute Delete @3-2A5D935C
        Dim result As Object = Nothing
        Dim E As Exception = Nothing
        Try
            result = Delete.ExecuteNonQuery()
        Catch e_ As Exception
            item.errors.Add("DataProvider",e_.Source + ":" + e_.Message)
            result = 0
        Finally
'End EditableGrid departments Data Provider Class Execute Delete

'EditableGrid departments AfterExecuteDelete @3-5C54EEF8
        End Try
        Return CType(result, Integer)
    End Function
'End EditableGrid departments AfterExecuteDelete

'Grid departments Data Provider Class GetResultSet Method @3-4A83201D
    Public Sub Update(ByVal Items As ArrayList)
        Update(Items, 0)
    End Sub

    Public Sub Update(ByVal Items As ArrayList, ByVal userGroup As Integer)
        Dim AllowInsert As Boolean = True
        Dim AllowUpdate As Boolean = True
        Dim AllowDelete As Boolean = True
        Dim i As Integer
        For i = 0 To Items.Count - 1
            Dim op As EditableGridOperation = EditableGridOperation.Insert
            Dim isProcessed As Boolean = False
            Dim item As departmentsItem = CType(Items(i), departmentsItem)
'End Grid departments Data Provider Class GetResultSet Method

'EditableGrid departments Data Provider Class Update @3-222725D8
            If Not item.IsUpdated Then
                If item.IsDeleted And AllowDelete Then
                    DeleteItem(item)
                    op = EditableGridOperation.Delete
                    isProcessed = True
                End If
                If item.IsNew And AllowInsert And Not(isProcessed) Then
                    InsertItem(item)
                    op = EditableGridOperation.Insert
                    isProcessed = True
                End If
                If Not(item.IsEmptyItem) And AllowUpdate And Not(isProcessed) Then
                    UpdateItem(item)
                    op = EditableGridOperation.Update
                End If
'End EditableGrid departments Data Provider Class Update

'EditableGrid departments Data Provider Class AfterUpdate @3-6CCB76B9
                If item.errors.Count = 0 Then item.IsUpdated = True
                OnItemUpdated(New ItemUpdatedEventArgs(op, item))
            End If
        Next i
    End Sub
'End EditableGrid departments Data Provider Class AfterUpdate

'EditableGrid departments Data Provider Class GetResultSet Method @3-27A91F00

    Public Function GetResultSet(ByRef PagesCount As Integer) As departmentsItem()
'End EditableGrid departments Data Provider Class GetResultSet Method

'Before build Select @3-5D7B3AE2
        Dim E as Exception = Nothing
        Parameters.Clear
        If SortDir = SortDirections._Asc Then
            Select_.OrderBy = SortFieldsNames(CInt(SortField)).Trim
        Else
            Select_.OrderBy = SortFieldsNamesDesc(CInt(SortField)).Trim
        End If
'End Before build Select

'Execute Select @3-A2C8CA79
        Dim ds As DataSet = Nothing
        PagesCount=0
        Try
            If RecordsPerPage>0
                ds=ExecuteSelect((PageNumber-1)*RecordsPerPage,RecordsPerPage)
                PagesCount = ExecuteCount()
                m_recordCount = PagesCount
                If PagesCount Mod RecordsPerPage>0 Then
                    PagesCount = (PagesCount\RecordsPerPage)+1
                Else
                    PagesCount = PagesCount\RecordsPerPage
                End If
            Else
            ds=ExecuteSelect()
            If ds.Tables(0).Rows.Count<>0 Then 
                PagesCount=1
            End If
            End If
        Catch ee as Exception
            E=ee
        Finally
'End Execute Select

'After execute Select @3-2D40517A
        If Not IsNothing(E) Then Throw E
        End Try
        Dim dr as DataRowCollection = ds.Tables(0).Rows
        Dim result(dr.Count + EmptyRows - 1) as departmentsItem
        Dim ListBoxSource As DataRowCollection = Nothing
        Dim j As Integer
'End After execute Select

'ListBox manager_id BeforeExecuteSelect @8-5177A1F9
    Try
        ListBoxSource=manager_idDataCommand.Execute().Tables(0).Rows
    Catch ee as Exception 
        E=ee
    Finally
'End ListBox manager_id BeforeExecuteSelect

'ListBox manager_id AfterExecuteSelect @8-426360D1
        If Not IsNothing(E) Then Throw E
    End Try
    Dim manager_idItems As ItemCollection = New ItemCollection()
    For j=0 To ListBoxSource.Count-1 
        Dim Key As String = (New IntegerField("", ListBoxSource(j)("emp_id"))).GetFormattedValue("")
        Dim Val As Object = ListBoxSource(j)("emp_name")
        manager_idItems.Add(Key, Val)
    Next
'End ListBox manager_id AfterExecuteSelect

'After execute Select tail @3-59A2155F
        Dim i as Integer
        For i = 0 To dr.Count - 1
            Dim item as departmentsItem = New departmentsItem()
            item.department_name.SetValue(dr(i)("department_name"),"")
            item.manager_id.SetValue(dr(i)("department_manager_id"),"")
            item.manager_idItems = CType(manager_idItems.Clone(), ItemCollection)
            item.department_idField.SetValue(dr(i)("department_id"),"")
            result(i)=item
        Next i
        For i = dr.Count To dr.Count + EmptyRows - 1
            Dim item as departmentsItem = New departmentsItem()
            item.manager_idItems = CType(manager_idItems.Clone(), ItemCollection)
            result(i) = item
        Next i
        Return result 
    End Function
'End After execute Select tail

'Grid Data Provider tail @3-A61BA892
End Class
'End Grid Data Provider tail

'Page Data Provider Tail @1-5EA2E2E0
End Namespace
'End Page Data Provider Tail

