//Using Statements @1-C19C5F87
using System;
using System.Collections;
using System.Collections.Specialized;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Text.RegularExpressions;
using System.Globalization;
using CCSExample_CSharp;
using CCSExample_CSharp.Data;
using CCSExample_CSharp.Configuration;
using CCSExample_CSharp.Controls;

namespace CCSExample_CSharp.ManyToManyCheckbox.ManyToManyCheckbox
{

//End Using Statements

//Forms Definition @1-60A4C9BE
public class ManyToManyCheckboxPage : System.Web.UI.Page
{
//End Forms Definition

//Forms Objects @1-19759BA7
    protected System.Web.UI.WebControls.Repeater employeesRepeater;
    protected employeesDataProvider employeesData;
    protected employees_recordDataProvider employees_recordData;
    protected HtmlInputButton employees_recordInsert1;
    protected HtmlInputButton employees_recordUpdate1;
    protected HtmlInputButton employees_recordDelete1;
    protected HtmlInputButton employees_recordCancel;
    protected System.Web.UI.WebControls.PlaceHolder employees_recordError;
    protected System.Web.UI.HtmlControls.HtmlTable employees_recordHolder;
    protected System.Web.UI.WebControls.Label employees_recordErrorLabel;
    protected bool employees_recordInsertAllowed=true;
    protected bool employees_recordUpdateAllowed=true;
    protected bool employees_recordDeleteAllowed=true;
    protected NameValueCollection employees_recordErrors=new NameValueCollection();
    protected System.Web.UI.WebControls.TextBox employees_recordemp_name;
    protected System.Web.UI.WebControls.CheckBoxList employees_recordProjectList;
    protected System.Web.UI.HtmlControls.HtmlAnchor Link1;
//End Forms Objects

//Page_Load Event @1-55207E05
private void Page_Load(object sender, System.EventArgs e)
{
//End Page_Load Event

//Page_Load Event BeforeIsPostBack @1-312112EA
    if (!IsPostBack)
    {
            PageDataProvider PageData=new PageDataProvider();
            PageItem item=PageItem.CreateFromHttpRequest();
            item.Link1Href = "ManyToManyCheckbox_desc.aspx?";
            PageData.FillItem(item);
            Link1.InnerText += item.Link1.GetFormattedValue().Replace("\r","").Replace("\n","<br>");
            Link1.HRef += item.Link1Href+item.Link1HrefParameters.ToString("GET","", ViewState);
            employeesBind();
            employees_recordShow();
    }
//End Page_Load Event BeforeIsPostBack

//Page_Load Event tail @1-FCB6E20C
}
//End Page_Load Event tail

//Page_Unload Event @1-72102C7C
private void Page_Unload(object sender, System.EventArgs e)
{
//End Page_Unload Event

//Page_Unload Event tail @1-FCB6E20C
}
//End Page_Unload Event tail

//Grid employees Bind @3-886C465C
    protected void employeesBind()
    {
        int PagesCount;
        int FooterIndex;
        if (!IsPostBack)
        {
            string Param;
            int PageSize;
            ViewState["employeesSortField"] = employeesDataProvider.SortFields.Default;
            PageSize = 15;
            ViewState["employeesPageNumber"] = 1;
            Param = Request.QueryString["employeesOrder"];
            if (Param != null && Param.Length > 0)
                try{
                    employeesDataProvider.SortFields SortField = 0;
                    ViewState["employeesSortField"] = Enum.Parse(SortField.GetType(), Param);
                }catch {}
            Param = Request.QueryString["employeesDir"];
            if (Param == null || Param.Length == 0 || Param.ToLower() == "desc")
                ViewState["employeesSortDir"] = SortDirections.Desc;
            else
                ViewState["employeesSortDir"] = SortDirections.Asc;
            Param = Request.QueryString["employeesPage"];
            int PageNumber;
            if (Param != null && Param.Length > 0)
                try
                {
                    PageNumber = Int32.Parse(Param);
                    if (PageNumber > 0) ViewState["employeesPageNumber"] = PageNumber;
                }
                catch {}
            Param = Request.QueryString["employeesPageSize"];
            if (Param != null && Param.Length > 0)
                try
                {
                    PageSize = Int32.Parse(Param);
                    if (PageSize <= 0) PageSize = 15;
                }
                catch {}
            if (PageSize > 100)
                PageSize = 100;
            ViewState["employeesPageSize"] = PageSize;
        }
//End Grid employees Bind

//Grid Form employees BeforeShow tail @3-332E867B
        employeesParameters();
        employeesData.SortField = (employeesDataProvider.SortFields)ViewState["employeesSortField"];
        employeesData.SortDir = (SortDirections)ViewState["employeesSortDir"];
        employeesData.PageNumber = (int)ViewState["employeesPageNumber"];
        employeesData.RecordsPerPage = (int)ViewState["employeesPageSize"];
        employeesRepeater.DataSource = employeesData.GetResultSet(out PagesCount);
        ViewState["employeesPagesCount"] = PagesCount;
        employeesRepeater.DataBind();
        FooterIndex = employeesRepeater.Controls.Count - 1;
        if (PagesCount == 0)
        {
            employeesRepeater.Controls[FooterIndex].FindControl("NoRecords").Visible = true;
        }
        employeesItem item=new employeesItem();
        System.Web.UI.HtmlControls.HtmlAnchor employeesLink1 = (System.Web.UI.HtmlControls.HtmlAnchor)employeesRepeater.Controls[FooterIndex].FindControl("employeesLink1");

        item.Link1Href = "ManyToManyCheckbox.aspx?";

        employeesLink1.InnerText += item.Link1.GetFormattedValue().Replace("\r","").Replace("\n","<br>");
        employeesLink1.HRef += item.Link1Href+item.Link1HrefParameters.ToString("GET","emp_id", ViewState);
        if(employeesData.SortField.ToString()=="Sorter_department_name") 
            ((CCSExample_CSharp.Controls.Sorter)employeesRepeater.Controls[0].FindControl("Sorter_department_nameSorter")).State=employeesData.SortDir==SortDirections.Asc?SorterState.Ascending:SorterState.Descending;
        if(employeesData.SortField.ToString()=="Sorter_emp_name") 
            ((CCSExample_CSharp.Controls.Sorter)employeesRepeater.Controls[0].FindControl("Sorter_emp_nameSorter")).State=employeesData.SortDir==SortDirections.Asc?SorterState.Ascending:SorterState.Descending;
        CCSExample_CSharp.Controls.Navigator NavigatorNavigator = (CCSExample_CSharp.Controls.Navigator)employeesRepeater.Controls[FooterIndex].FindControl("NavigatorNavigator");
        NavigatorNavigator.MaxPage=PagesCount;
        NavigatorNavigator.PageNumber=employeesData.PageNumber;
        NavigatorNavigator.DataBind();
//End Grid Form employees BeforeShow tail

//Grid employees Bind tail @3-FCB6E20C
    }
//End Grid employees Bind tail

//Grid employees Table Parameters @3-4A735A11
    protected void employeesParameters()
    {
        try{
        }catch{
            ControlCollection ParentControls=employeesRepeater.Parent.Controls;
            int RepeaterIndex=ParentControls.IndexOf(employeesRepeater);
            ParentControls.RemoveAt(RepeaterIndex);
            Literal ErrorMessage=new Literal();
            ErrorMessage.Text="Error in Grid employees: Invalid parameter";
            ParentControls.AddAt(RepeaterIndex,ErrorMessage);
        }
	}
	
//End Grid employees Table Parameters

//Grid employees ItemDataBound event @3-24C820CA
    protected void employeesItemDataBound(Object Sender, RepeaterItemEventArgs e)
    {
        employeesItem DataItem=(employeesItem)e.Item.DataItem;
        if (e.Item.ItemType == ListItemType.Item || e.Item.ItemType == ListItemType.AlternatingItem) {
            System.Web.UI.HtmlControls.HtmlAnchor employeesemp_name = (System.Web.UI.HtmlControls.HtmlAnchor)(e.Item.FindControl("employeesemp_name"));
            DataItem.emp_nameHref = "ManyToManyCheckbox.aspx?";
            employeesemp_name.HRef += DataItem.emp_nameHref + DataItem.emp_nameHrefParameters.ToString("GET","", ViewState);
        }
//End Grid employees ItemDataBound event

//Grid employees ItemDataBound event tail @3-FCB6E20C
    }
//End Grid employees ItemDataBound event tail

//Grid employees ItemCommand event @3-593EB4BC
    protected void employeesItemCommand(Object Sender, RepeaterCommandEventArgs e)
    {
        int FooterIndex = employeesRepeater.Controls.Count - 1;
        bool BindAllowed = false;
        if(e.CommandName=="Sort"){
            if(((SorterState)e.CommandArgument)==SorterState.None)
                if((SortDirections)ViewState["employeesSortDir"]==SortDirections.Asc&&ViewState["employeesSortField"].ToString()==((CCSExample_CSharp.Controls.Sorter)e.CommandSource).Field)
                    ViewState["employeesSortDir"]=SortDirections.Desc;
                else
                    ViewState["employeesSortDir"]=SortDirections.Asc;
            else
                ViewState["employeesSortDir"]=(int)(((CCSExample_CSharp.Controls.Sorter)e.CommandSource).State);
            ViewState["employeesSortField"]=Enum.Parse(typeof(employeesDataProvider.SortFields),((CCSExample_CSharp.Controls.Sorter)e.CommandSource).Field);
            ViewState["employeesPageNumber"] = 1;
            BindAllowed = true;
        }
        if(e.CommandName=="Navigate"){
            ViewState["employeesPageNumber"] = Int32.Parse(e.CommandArgument.ToString());
            BindAllowed = true;
        }
        if (BindAllowed)
            employeesBind();
    }
//End Grid employees ItemCommand event

//Record Form employees_record Parameters @14-073CF455
    protected void employees_recordParameters()
    {
        try{
            employees_recordData.Urlemp_id= IntegerParameter.GetParam(Request.QueryString["emp_id"]);
        }catch(Exception e){
            employees_recordErrors.Add("Parameters","Form parameters: " + e.Message);
        }
    }
//End Record Form employees_record Parameters

 protected void ProjectEmployeesModify(string Actions) 
 {

	//Retrieve current employee
	string Param;
	string Sql;
 	int EmpID;

 	try{

		EmpID = Int32.Parse(Request.QueryString["emp_id"]);
		if(EmpID < 0) EmpID = 0;
 	}
 	catch{
		EmpID = 0;
 	}

	DataAccessObject NewDao = Settings.IntranetDBDataAccessObject;

	//Update project-employees
	if(Actions == "Insert"){
    
		//Retrieve the last inserted key
     	//Use MS SQL method (disabled below)
     	// GetLastInsKey = CCDLookup("@@IDENTITY","projects","",DBIntranetDB)
     	//Use method compatible with all databases (unsafe when multiple users insert records at the same time)

     	long GetLastInsKey = Int64.Parse((new IntegerField("",Settings.IntranetDBDataAccessObject.ExecuteScalar("SELECT max(emp_id) FROM employees"))).GetFormattedValue(""));
     	//Insert New links
				
		for(int i=0; i < employees_recordProjectList.Items.Count; i++){

			if(employees_recordProjectList.Items[i].Selected){

					Sql = "INSERT INTO projects_employees (project_id, emp_id) VALUES (" + 
	               			NewDao.ToSql(employees_recordProjectList.Items[i].Value,FieldType.Integer) + "," + NewDao.ToSql(GetLastInsKey.ToString(),FieldType.Integer) + ")";
       				NewDao.RunSql(Sql);
			}
			
		}
     } 
	if(EmpID > 0){

	    if (Actions == "Delete" || Actions == "Update") {
    		//Delete project employees links
       		Sql = "DELETE FROM projects_employees WHERE emp_id= " + NewDao.ToSql(EmpID.ToString(),FieldType.Integer);
       		NewDao.RunSql(Sql);
    	} 

    	if (Actions == "Update") {
       		//Insert assigned employees
			

			for(int i=0; i < employees_recordProjectList.Items.Count; i++){

				if(employees_recordProjectList.Items[i].Selected){

					Sql = "INSERT INTO projects_employees (project_id, emp_id) VALUES (" + 
	               			NewDao.ToSql(employees_recordProjectList.Items[i].Value,FieldType.Integer) + "," + NewDao.ToSql(EmpID.ToString().ToString(),FieldType.Integer) + ")";
       				NewDao.RunSql(Sql);
				}
			
			}
			
    	} 
  	}

 }

//Record Form employees_record Show method @14-D0C3AD48
    protected void employees_recordShow()
    {
        bool AllowRead = true,AllowInsert = true,AllowUpdate = true,AllowDelete = true;
        employees_recordItem item=employees_recordItem.CreateFromHttpRequest();
        bool IsInsertMode=!AllowRead;
        employees_recordErrors.Add(item.errors);
//End Record Form employees_record Show method

//Grid Form employees_record BeforeShow tail @14-6F82B28A
        employees_recordParameters();
        employees_recordData.FillItem(item,ref IsInsertMode);
        employees_recordInsert1.Visible=IsInsertMode&&AllowInsert;
        employees_recordUpdate1.Visible=!IsInsertMode&&AllowUpdate;
        employees_recordDelete1.Visible=!IsInsertMode&&AllowDelete;
        employees_recordemp_name.Text=item.emp_name.GetFormattedValue();
        item.ProjectListItems.SetSelection(item.ProjectList.Value);
        employees_recordProjectList.SelectedIndex = -1;
        item.ProjectListItems.CopyTo(employees_recordProjectList.Items);
//End Grid Form employees_record BeforeShow tail

//Record employees_record Event BeforeShow. Action Custom Code @34-2A29BDB7
 
  if (Request.QueryString["emp_id"] != null && Request.QueryString["emp_id"] != ""){
     SqlCommand Select;
     Select = new SqlCommand("SELECT project_id FROM projects_employees WHERE emp_id ="+  Request.QueryString["emp_id"].ToString(),
              Settings.IntranetDBDataAccessObject);
     DataRowCollection projectID = Select.Execute().Tables[0].Rows;
     if(!IsInsertMode){
       for(int i = 0; i < projectID.Count; i++){
         item.ProjectListItems.SetSelection(projectID[i]["project_id"].ToString());
       }
       employees_recordProjectList.Items.Clear();
       item.ProjectListItems.CopyTo(employees_recordProjectList.Items);
     } 
  }

//End Record employees_record Event BeforeShow. Action Custom Code

//Record Form employees_record Show method tail @14-5C2EAD42
        if(employees_recordErrors.Count>0)
            employees_recordShowErrors();
    }
//End Record Form employees_record Show method tail

//Record Form employees_record LoadItemFromRequest method @14-2A9717B5
    protected void employees_recordLoadItemFromRequest(employees_recordItem item, bool EnableValidation)
    {
        item.emp_name.SetValue(employees_recordemp_name.Text);
        try{
        if(employees_recordProjectList.SelectedItem!=null)
            item.ProjectList.SetValue(employees_recordProjectList.SelectedItem.Value);
        else
            item.ProjectList.Value=null;
        }catch(ArgumentException){
            employees_recordErrors.Add("ProjectList","The value in field ProjectList is not valid.");}
        if(EnableValidation)
            item.Validate(employees_recordData);
        employees_recordErrors.Add(item.errors);
    }
//End Record Form employees_record LoadItemFromRequest method

//Record Form employees_record GetRedirectUrl method @14-4308FCCE
    protected string Getemployees_recordRedirectUrl(string redirectString ,string removeList)
    {
        string Params="";
        string[] List=("emp_id;" + removeList).ToLower().Split(new Char[] {';'});

        if(redirectString == "") redirectString = "ManyToManyCheckbox.aspx";
        for(int i = 0; i < Request.QueryString.Count;i ++)
            if(Array.IndexOf(List,Request.QueryString.AllKeys[i].ToLower()) < 0)
                Params += Request.QueryString.AllKeys[i] + "=" + Server.UrlEncode(Request.QueryString[i]) + "&";
        Params = Params.TrimEnd(new Char[]{'&'});
        return redirectString + "?" + Params;
    }

//End Record Form employees_record GetRedirectUrl method

//Record Form employees_record ShowErrors method @14-DEEF6001
    protected void employees_recordShowErrors()
    {
        string DefaultMessage="";
        for(int i=0;i<employees_recordErrors.Count;i++)
        switch(employees_recordErrors.AllKeys[i])
        {
            default:
                DefaultMessage+=employees_recordErrors[i]+"<br>";
                break;
        }
        employees_recordError.Visible = true;
        employees_recordErrorLabel.Text = DefaultMessage;
    }
//End Record Form employees_record ShowErrors method

//Record Form employees_record Insert Operation @14-490C11E8
    protected void employees_record_Insert(object sender, System.EventArgs e)
    {
        bool ExecuteFlag = true;
        bool ErrorFlag = false;
        employees_recordItem item=new employees_recordItem();
        string RedirectUrl = Getemployees_recordRedirectUrl("", "");
//End Record Form employees_record Insert Operation

//Record Form employees_record BeforeInsert tail @14-524AC8F8
    employees_recordParameters();
    employees_recordLoadItemFromRequest(item, true);
    if(employees_recordInsertAllowed){
    ErrorFlag=(employees_recordErrors.Count>0);
        if(ExecuteFlag&&!ErrorFlag)
            try
            {
                employees_recordData.InsertItem(item);
            }
            catch (Exception ex)
            {
                employees_recordErrors.Add("DataProvider",ex.Message);
                ErrorFlag=true;
            }
//End Record Form employees_record BeforeInsert tail

//Record employees_record Event AfterInsert. Action Custom Code @35-2A29BDB7

  if (!ErrorFlag) 
     ProjectEmployeesModify("Insert");

//End Record employees_record Event AfterInsert. Action Custom Code

//Record Form employees_record AfterInsert tail  @14-4E875F1A
        }
        if(ErrorFlag)
            employees_recordShowErrors();
        else
            Response.Redirect(RedirectUrl);
    }
//End Record Form employees_record AfterInsert tail 

//Record Form employees_record Update Operation @14-04C665F2
    protected void employees_record_Update(object sender, System.EventArgs e)
    {
        employees_recordItem item=new employees_recordItem();
        item.IsNew = false;
        bool ExecuteFlag = true;
        bool ErrorFlag = false;
        string RedirectUrl = Getemployees_recordRedirectUrl("", "");
//End Record Form employees_record Update Operation

//Record Form employees_record Before Update tail @14-E5FAE478
        employees_recordParameters();
        employees_recordLoadItemFromRequest(item, true);
        if(employees_recordUpdateAllowed){
        ErrorFlag=(employees_recordErrors.Count>0);
        if(ExecuteFlag&&!ErrorFlag)
            try
            {
                employees_recordData.UpdateItem(item);
            }
            catch (Exception ex)
            {
                employees_recordErrors.Add("DataProvider",ex.Message);
                ErrorFlag=true;
            }
//End Record Form employees_record Before Update tail

//Record employees_record Event AfterUpdate. Action Custom Code @36-2A29BDB7

  if (!ErrorFlag) 
	ProjectEmployeesModify("Update");

//End Record employees_record Event AfterUpdate. Action Custom Code

//Record Form employees_record Update Operation tail @14-4E875F1A
        }
        if(ErrorFlag)
            employees_recordShowErrors();
        else
            Response.Redirect(RedirectUrl);
    }
//End Record Form employees_record Update Operation tail

//Record Form employees_record Delete Operation @14-009E3FF8
    protected void employees_record_Delete(object sender,System.EventArgs e)
    {
        bool ExecuteFlag = true;
        bool ErrorFlag = false;
        string RedirectUrl = Getemployees_recordRedirectUrl("", "");
        employees_recordItem item=new employees_recordItem();
        item.IsNew = false;
        item.IsDeleted = true;
//End Record Form employees_record Delete Operation

//Record employees_record Event BeforeDelete. Action Custom Code @39-2A29BDB7
     ProjectEmployeesModify("Delete");
//End Record employees_record Event BeforeDelete. Action Custom Code

//Record Form BeforeDelete tail @14-4A74C200
        employees_recordParameters();
        employees_recordLoadItemFromRequest(item, false);
        if(employees_recordDeleteAllowed){
        ErrorFlag = (employees_recordErrors.Count > 0);
        if(ExecuteFlag && !ErrorFlag)
            try
            {
                employees_recordData.DeleteItem();
            }
            catch (Exception ex)
            {
                employees_recordErrors.Add("DataProvider", ex.Message);
                ErrorFlag = true;
            }
//End Record Form BeforeDelete tail

//Record Form AfterDelete tail @14-4E875F1A
        }
        if(ErrorFlag)
            employees_recordShowErrors();
        else
            Response.Redirect(RedirectUrl);
    }
//End Record Form AfterDelete tail

//Record Form employees_record Cancel Operation @14-1AD690A1
    protected void employees_record_Cancel(object sender,System.EventArgs e)
    {
        employees_recordItem item=new employees_recordItem();
        string RedirectUrl = Getemployees_recordRedirectUrl("", "");
        employees_recordLoadItemFromRequest(item, false);
//End Record Form employees_record Cancel Operation

//Record Form employees_record Cancel Operation tail @14-AE897FBA
        Response.Redirect(RedirectUrl);
    }
//End Record Form employees_record Cancel Operation tail

//OnInit Event @1-F3E84B0C
    #region Web Form Designer generated code
    override protected void OnInit(EventArgs e)
    {
        //
        //CODEGEN: This call is required by the ASP.NET Web Form Designer.
        //
        InitializeComponent();
        this.Load += new System.EventHandler(this.Page_Load);
        this.Unload += new System.EventHandler(this.Page_Unload);
        employeesData = new employeesDataProvider();
        employees_recordData = new employees_recordDataProvider();
        base.OnInit(e);
//End OnInit Event

//OnInit Event tail @1-FCB6E20C
    }
//End OnInit Event tail

//InitializeComponent Event @1-722FC1EE
    /// <summary>
    /// Required method for Designer support - do not modify
    /// the contents of this method with the code editor.
    /// </summary>
    private void InitializeComponent()
    {
    }
    #endregion
//End InitializeComponent Event

//Page class tail @1-F5FC18C5
}
}
//End Page class tail

