'Using Statements @1-772D449A
Imports System
Imports System.Collections
Imports System.Collections.Specialized
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Web
Imports System.Web.SessionState
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports System.Web.UI.HtmlControls
Imports System.Text.RegularExpressions
Imports System.Globalization
Imports ExamplePack_VB
Imports ExamplePack_VB.Data
Imports ExamplePack_VB.Configuration
Imports ExamplePack_VB.Controls
Namespace ManyToManyCheckbox.ManyToManyCheckbox
'End Using Statements

'Forms Definition @1-731E6395
Public Class [ManyToManyCheckboxPage]
Inherits System.Web.UI.Page
'End Forms Definition

'Forms Objects @1-E86ADF8E
    Protected employeesRepeater As  System.Web.UI.WebControls.Repeater
    Protected employeesData As employeesDataProvider
    Protected employees_recordData As employees_recordDataProvider
    Protected employees_recordInsert1 As HtmlInputButton 
    Protected employees_recordUpdate1 As HtmlInputButton 
    Protected employees_recordDelete1 As HtmlInputButton 
    Protected employees_recordCancel As HtmlInputButton 
    Protected employees_recordError As System.Web.UI.WebControls.PlaceHolder
    Protected employees_recordHolder As System.Web.UI.HtmlControls.HtmlTable
    Protected employees_recordErrorLabel As System.Web.UI.WebControls.Label
    Protected employees_recordInsertAllowed As Boolean = True
    Protected employees_recordUpdateAllowed As Boolean = True
    Protected employees_recordDeleteAllowed As Boolean = True
    Protected employees_recordErrors As NameValueCollection = New NameValueCollection()
    Protected employees_recordemp_name As System.Web.UI.WebControls.TextBox
    Protected employees_recordProjectList As System.Web.UI.WebControls.CheckBoxList
    Protected Link1 As System.Web.UI.HtmlControls.HtmlAnchor
'End Forms Objects

'Page_Load Event @1-A2D2CF1E

Protected Overrides Sub OnLoad(ByVal e As System.EventArgs)
'End Page_Load Event

'Page_Load Event BeforeIsPostBack @1-9A3D2873
    If Not IsPostBack Then
            Dim PageData As PageDataProvider = New PageDataProvider()
            Dim item As PageItem = PageItem.CreateFromHttpRequest()
            item.Link1Href = "ManyToManyCheckbox_desc.aspx?"
            PageData.FillItem(item)
            Link1.InnerText += item.Link1.GetFormattedValue().Replace(vbCrLf,"")
            Link1.HRef += item.Link1Href & item.Link1HrefParameters.ToString("GET","", ViewState)
            employeesBind
            employees_recordShow()
    End If
'End Page_Load Event BeforeIsPostBack

'Page_Load Event tail @1-E31F8E2A
End Sub
'End Page_Load Event tail

'Page_Unload Event @1-D998A98F

Protected Overrides Sub OnUnload(ByVal e As System.EventArgs)
'End Page_Unload Event

'Page_Unload Event tail @1-E31F8E2A
End Sub
'End Page_Unload Event tail

'Grid employees Bind @3-045E5A03

    Protected Sub employeesBind()
        Dim PagesCount As Integer
        Dim FooterIndex As Integer
        If Not(IsPostBack) Then
            Dim Param As String
            Param = Request.QueryString("employeesOrder")
            Try
                Dim sf As employeesDataProvider.SortFields = 0
                ViewState("employeesSortField") = [Enum].Parse(sf.GetType(), Param)
            Catch
                ViewState("employeesSortField") = employeesDataProvider.SortFields._Default
            End Try

            Param = Request.QueryString("employeesDir")
            If IsNothing(Param) Then
                ViewState("employeesSortDir") = SortDirections._Desc
            Else
                If Param.Length = 0 Or Param.ToLower() = "desc" Then
                    ViewState("employeesSortDir") = SortDirections._Desc
                Else
                    ViewState("employeesSortDir") = SortDirections._Asc
                End If
            End If
            Param = Request.QueryString("employeesPage")
            Dim PageNumber as Integer
            Try
                PageNumber = Int32.Parse(Param)
                If PageNumber <= 0 Then PageNumber = 1
            Catch
                PageNumber = 1
            End Try
            ViewState("employeesPageNumber") = PageNumber
            Param = Request.QueryString("employeesPageSize")
            Try
                PageNumber = Int32.Parse(Param)
                If PageNumber <= 0 Then PageNumber = 15
            Catch
                PageNumber = 15
            End Try
            If PageNumber > 100 Then
                PageNumber = 100
            End If
            ViewState("employeesPageSize") = PageNumber
        End If
'End Grid employees Bind

'Grid Form employees BeforeShow tail @3-3BC90B92
        employeesParameters
        employeesData.SortField = CType(ViewState("employeesSortField"),employeesDataProvider.SortFields)
        employeesData.SortDir = CType(ViewState("employeesSortDir"),SortDirections)
        employeesData.PageNumber = CInt(ViewState("employeesPageNumber"))
        employeesData.RecordsPerPage = CInt(ViewState("employeesPageSize"))
        employeesRepeater.DataSource = employeesData.GetResultSet(PagesCount)
        ViewState("employeesPagesCount") = PagesCount
        employeesRepeater.DataBind
        FooterIndex = employeesRepeater.Controls.Count - 1
        If PagesCount = 0 Then
            employeesRepeater.Controls(FooterIndex).FindControl("NoRecords").Visible = True
        End If
        Dim item As employeesItem = New employeesItem()
        Dim employeesLink1 As System.Web.UI.HtmlControls.HtmlAnchor = DirectCast(employeesRepeater.Controls(FooterIndex).FindControl("employeesLink1"),System.Web.UI.HtmlControls.HtmlAnchor)

        item.Link1Href = "ManyToManyCheckbox.aspx?"

        employeesLink1.InnerText += item.Link1.GetFormattedValue().Replace(vbCrLf,"")
        employeesLink1.HRef += item.Link1Href & item.Link1HrefParameters.ToString("GET","emp_id", ViewState)
        If employeesData.SortField.ToString()="Sorter_department_name" Then
            If employeesData.SortDir=SortDirections._Asc Then
                CType(employeesRepeater.Controls(0).FindControl("Sorter_department_nameSorter"),Controls.Sorter).State = SorterState.Ascending
            Else
                CType(employeesRepeater.Controls(0).FindControl("Sorter_department_nameSorter"),Controls.Sorter).State = SorterState.Descending
            End If
        End If
        If employeesData.SortField.ToString()="Sorter_emp_name" Then
            If employeesData.SortDir=SortDirections._Asc Then
                CType(employeesRepeater.Controls(0).FindControl("Sorter_emp_nameSorter"),Controls.Sorter).State = SorterState.Ascending
            Else
                CType(employeesRepeater.Controls(0).FindControl("Sorter_emp_nameSorter"),Controls.Sorter).State = SorterState.Descending
            End If
        End If
        Dim NavigatorNavigator As Controls.Navigator = CType(employeesRepeater.Controls(FooterIndex).FindControl("NavigatorNavigator"),Controls.Navigator)
        NavigatorNavigator.MaxPage=PagesCount
        NavigatorNavigator.PageNumber=employeesData.PageNumber
        NavigatorNavigator.DataBind
'End Grid Form employees BeforeShow tail

'Grid employees Bind tail @3-E31F8E2A
    End Sub
'End Grid employees Bind tail

'Grid employees Table Parameters @3-FCECFD33

    Protected Sub employeesParameters()
        Try

        Catch
            Dim ParentControls As ControlCollection=employeesRepeater.Parent.Controls
            Dim RepeaterIndex As Integer=ParentControls.IndexOf(employeesRepeater)
            ParentControls.RemoveAt(RepeaterIndex)
            Dim ErrorMessage as Literal=New Literal()
            ErrorMessage.Text="Error in Grid employees: Invalid parameter"
            ParentControls.AddAt(RepeaterIndex,ErrorMessage)
        End Try
    End Sub
'End Grid employees Table Parameters

'Grid employees ItemDataBound event @3-224E290D

    Protected Sub employeesItemDataBound(Sender as Object, e as RepeaterItemEventArgs)
        Dim DataItem as employeesItem=CType(e.Item.DataItem,employeesItem)
        If e.Item.ItemType = ListItemType.Item Or e.Item.ItemType = ListItemType.AlternatingItem Then
            Dim employeesemp_name As System.Web.UI.HtmlControls.HtmlAnchor = DirectCast(e.Item.FindControl("employeesemp_name"),System.Web.UI.HtmlControls.HtmlAnchor)
            DataItem.emp_nameHref = "ManyToManyCheckbox.aspx?"
            employeesemp_name.HRef += DataItem.emp_nameHref & DataItem.emp_nameHrefParameters.ToString("GET","", ViewState)
        End If
'End Grid employees ItemDataBound event

'Grid employees ItemDataBound event tail @3-E31F8E2A
    End Sub
'End Grid employees ItemDataBound event tail

'Grid employees ItemCommand event @3-3635E357

    Protected Sub employeesItemCommand(Sender as Object, e as RepeaterCommandEventArgs)
        Dim FooterIndex as Integer= employeesRepeater.Controls.Count - 1
        Dim BindAllowed as Boolean= False
        If e.CommandName = "Sort" Then
            If CType(e.CommandArgument,SorterState)=SorterState.None
                If CType(ViewState("employeesSortDir"),SortDirections) = SortDirections._Asc And ViewState("employeesSortField").ToString()=CType(e.CommandSource,Controls.Sorter).Field
                    ViewState("employeesSortDir")=SortDirections._Desc
                Else
                    ViewState("employeesSortDir")=SortDirections._Asc
                End If
            Else
                ViewState("employeesSortDir")=CInt(CType(e.CommandSource,Controls.Sorter).State)
            End If
            Dim sf As employeesDataProvider.SortFields = 0
            ViewState("employeesSortField")=[Enum].Parse(sf.GetType(),CType(e.CommandSource,Controls.Sorter).Field)
            ViewState("employeesPageNumber") = 1
            BindAllowed = True
        End If

        If e.CommandName="Navigate" Then
            ViewState("employeesPageNumber") = Int32.Parse(e.CommandArgument.ToString())
            BindAllowed = True
        End If
        If BindAllowed Then
            employeesBind
        End If
    End Sub
'End Grid employees ItemCommand event

'Record Form employees_record Parameters @14-E93C0424

    Protected Sub employees_recordParameters()
        Try
            employees_recordData.Urlemp_id = IntegerParameter.GetParam(Request.QueryString("emp_id"))
        Catch e As Exception
            employees_recordErrors.Add("Parameters","Form Parameters: " + e.Message)
        End Try
    End Sub
'End Record Form employees_record Parameters

 Protected Sub ProjectEmployeesModify(Actions As String) 
 
	'Retrieve current employee
	
	Dim Sql As String
 	Dim EmpID As Integer
	Dim i As Integer

 	Try

		EmpID = Int32.Parse(Request.QueryString("emp_id"))
		if EmpID < 0 Then EmpID = 0
 	
 	catch e As Exception 
		EmpID = 0
 	End Try

	Dim NewDao As DataAccessObject = Settings.IntranetDBDataAccessObject

	'Update project-employees
	If Actions = "Insert" Then 
    
		'Retrieve the last inserted key
     	'Use MS SQL method (disabled below)
     	'GetLastInsKey = CCDLookup("@@IDENTITY","projects","",DBIntranetDB)
     	'Use method compatible with all databases (unsafe when multiple users insert records at the same time)

     	Dim GetLastInsKey As long  = Int64.Parse((new IntegerField("",Settings.IntranetDBDataAccessObject.ExecuteScalar("SELECT max(emp_id) FROM employees"))).GetFormattedValue(""))
     	
		'Insert New links
		For  i=0 To employees_recordProjectList.Items.Count - 1

			If employees_recordProjectList.Items(i).Selected Then 

					Sql = "INSERT INTO projects_employees (project_id, emp_id) VALUES (" &  _
	               			NewDao.ToSql(employees_recordProjectList.Items(i).Value,FieldType._Integer) & "," & NewDao.ToSql(GetLastInsKey.ToString(),FieldType._Integer) & ")"
       				NewDao.RunSql(Sql)
			End If
			
		Next i
    End If

	If EmpID > 0 Then 

	    If Actions = "Delete" Or Actions = "Update" Then
    		
			'Delete project employees links
       		Sql = "DELETE FROM projects_employees WHERE emp_id= " & NewDao.ToSql(EmpID.ToString(),FieldType._Integer)
       		NewDao.RunSql(Sql)
    	End If

    	If Actions = "Update" Then 
       	
			'Insert assigned employees
			
			For  i = 0 To employees_recordProjectList.Items.Count -1

				If employees_recordProjectList.Items(i).Selected Then 

					Sql = "INSERT INTO projects_employees (project_id, emp_id) VALUES (" & _
	               			NewDao.ToSql(employees_recordProjectList.Items(i).Value,FieldType._Integer) & "," & NewDao.ToSql(EmpID.ToString().ToString(),FieldType._Integer) & ")"
       				NewDao.RunSql(Sql)
				End If
			
			Next i
			
    	End If 
  	End If

End Sub


'Record Form employees_record Show method @14-F0040318
    Protected Sub employees_recordShow()
        Dim AllowRead As Boolean = True
        Dim AllowInsert As Boolean = True
        Dim AllowUpdate As Boolean = True
        Dim AllowDelete As Boolean = True
        Dim item As employees_recordItem = employees_recordItem.CreateFromHttpRequest()
        Dim IsInsertMode As Boolean = Not AllowRead
        employees_recordErrors.Add(item.errors)
        If employees_recordErrors.Count > 0 Then
            employees_recordShowErrors()
            Return
        End If
'End Record Form employees_record Show method

'Record Form employees_record BeforeShow tail @14-F57224E9
        employees_recordParameters()
        employees_recordData.FillItem(item, IsInsertMode)
        employees_recordInsert1.Visible = IsInsertMode And AllowInsert
        employees_recordUpdate1.Visible = (Not IsInsertMode) And AllowUpdate
        employees_recordDelete1.Visible = (Not IsInsertMode) And AllowDelete
        employees_recordemp_name.Text=item.emp_name.GetFormattedValue()
        item.ProjectListItems.SetSelection(item.ProjectList.Value)
        employees_recordProjectList.SelectedIndex = -1
        item.ProjectListItems.CopyTo(employees_recordProjectList.Items)
'End Record Form employees_record BeforeShow tail

'Record employees_record Event BeforeShow. Action Custom Code @34-73254650

	If Not IsNothing(Request.QueryString("emp_id")) And (Request.QueryString("emp_id") <> "") Then 

	    Dim Sel As SqlCommand = new SqlCommand("SELECT project_id FROM projects_employees WHERE emp_id =" &  Request.QueryString("emp_id").ToString(), _
              Settings.IntranetDBDataAccessObject)
     	Dim projectID As DataRowCollection  = Sel.Execute().Tables(0).Rows
		If Not IsInsertMode Then 
			
			Dim i As Integer
			For i = 0 To projectID.Count - 1 
				item.ProjectListItems.SetSelection(projectID(i)("project_id").ToString())
			Next i
			employees_recordProjectList.Items.Clear()
			item.ProjectListItems.CopyTo(employees_recordProjectList.Items)
		End If
	End If
'End Record employees_record Event BeforeShow. Action Custom Code

'Record Form employees_record Show method tail @14-1FF89B49
        If employees_recordErrors.Count > 0 Then
            employees_recordShowErrors()
        End If
    End Sub
'End Record Form employees_record Show method tail

'Record Form employees_record LoadItemFromRequest method @14-98C63449

    Protected Sub employees_recordLoadItemFromRequest(item As employees_recordItem, ByVal EnableValidation As Boolean)
        item.emp_name.SetValue(employees_recordemp_name.Text)
        Try
        If Not IsNothing(employees_recordProjectList.SelectedItem) Then
            item.ProjectList.SetValue(employees_recordProjectList.SelectedItem.Value)
        Else
            item.ProjectList.Value = Nothing
        End If
        Catch ae As ArgumentException
            employees_recordErrors.Add("ProjectList","The value in field ProjectList is not valid.")
        End Try
        If EnableValidation Then
            item.Validate(employees_recordData)
        End If
        employees_recordErrors.Add(item.errors)
    End Sub
'End Record Form employees_record LoadItemFromRequest method

'Record Form employees_record GetRedirectUrl method @14-84CA9502

    Protected Function Getemployees_recordRedirectUrl(ByVal redirect As String, ByVal removeList As String) As String
        Dim Params As String = ""
        Dim List() As String = {""}

        List = ("emp_id;" + RemoveList).ToLower().Split(New Char() {";"})
        If Redirect= "" Then
            Redirect = "ManyToManyCheckbox.aspx"
        End If
        Dim j As Integer
        For j=0 To Request.QueryString.Count - 1
            If Array.IndexOf(List,Request.QueryString.AllKeys(j).ToLower()) < 0 Then
                Params = Params & Request.QueryString.AllKeys(j) & "=" & Server.UrlEncode(Request.QueryString(j)) & "&"
            End If
        Next j
        Params = Params.TrimEnd(New Char(){"&"})
        Return Redirect & "?" & Params
    End Function
'End Record Form employees_record GetRedirectUrl method

'Record Form employees_record ShowErrors method @14-41657038

    Protected Sub employees_recordShowErrors()
        Dim DefaultMessage As String = ""
        Dim i As Integer
        For i = 0 To employees_recordErrors.Count - 1
        Select Case employees_recordErrors.AllKeys(i)
            Case Else
                DefaultMessage = DefaultMessage & employees_recordErrors(i) & "<br>"
        End Select
        Next i
        employees_recordError.Visible = True
        employees_recordErrorLabel.Text = DefaultMessage
    End Sub
'End Record Form employees_record ShowErrors method

'Record Form employees_record Insert Operation @14-0C0155C2

    Protected Sub employees_record_Insert(ByVal sender As Object, ByVal e As System.EventArgs)
        Dim item As employees_recordItem = New employees_recordItem()
        Dim ExecuteFlag As Boolean = True
        Dim ErrorFlag As Boolean = False
        Dim RedirectUrl As String = Getemployees_recordRedirectUrl("", "")
'End Record Form employees_record Insert Operation

'Record Form employees_record BeforeInsert tail @14-E9BF02DB
    employees_recordParameters()
    employees_recordLoadItemFromRequest(item, True)
    If employees_recordInsertAllowed Then
        ErrorFlag=(employees_recordErrors.Count > 0)
        If ExecuteFlag And (Not ErrorFlag) Then
            Try
                employees_recordData.InsertItem(item)
            Catch ex As Exception
                employees_recordErrors.Add("DataProvider",ex.Message)
                ErrorFlag = True
            End Try
        End If
'End Record Form employees_record BeforeInsert tail

'Record employees_record Event AfterInsert. Action Custom Code @35-73254650

  If Not ErrorFlag Then _
	ProjectEmployeesModify("Insert")

'End Record employees_record Event AfterInsert. Action Custom Code

'Record Form employees_record AfterInsert tail  @14-6DB15A98
        End If
        If ErrorFlag Then
            employees_recordShowErrors()
        Else
            Response.Redirect(RedirectUrl)
        End If
    End Sub
'End Record Form employees_record AfterInsert tail 

'Record Form employees_record Update Operation @14-8223DC84

    Protected Sub employees_record_Update(ByVal sender As Object, ByVal e As System.EventArgs)
        Dim item As employees_recordItem = New employees_recordItem()
        item.IsNew = False
        Dim ExecuteFlag As Boolean = True
        Dim ErrorFlag As Boolean = False
        Dim RedirectUrl As String = Getemployees_recordRedirectUrl("", "")
'End Record Form employees_record Update Operation

'Record Form employees_record Before Update tail @14-18ADE6B3
        employees_recordParameters()
        employees_recordLoadItemFromRequest(item, True)
        If employees_recordUpdateAllowed Then
        ErrorFlag = (employees_recordErrors.Count > 0)
        If ExecuteFlag And (Not ErrorFlag) Then
            Try
                employees_recordData.UpdateItem(item)
            Catch ex As Exception
                employees_recordErrors.Add("DataProvider",ex.Message)
                ErrorFlag = True
            End Try
        End If
'End Record Form employees_record Before Update tail

'Record employees_record Event AfterUpdate. Action Custom Code @36-73254650

  If Not ErrorFlag Then _
    ProjectEmployeesModify("Update")

'End Record employees_record Event AfterUpdate. Action Custom Code

'Record Form employees_record Update Operation tail @14-6DB15A98
        End If
        If ErrorFlag Then
            employees_recordShowErrors()
        Else
            Response.Redirect(RedirectUrl)
        End If
    End Sub
'End Record Form employees_record Update Operation tail

'Record Form employees_record Delete Operation @14-FF56DE2A

    Protected Sub employees_record_Delete(ByVal sender As Object, ByVal e As System.EventArgs)
        Dim ExecuteFlag As Boolean = True
        Dim ErrorFlag As Boolean = False
        Dim RedirectUrl As String = Getemployees_recordRedirectUrl("", "")
        Dim item As employees_recordItem = New employees_recordItem()
        item.IsNew  = False
        item.IsDeleted  = True
'End Record Form employees_record Delete Operation

'Record employees_record Event BeforeDelete. Action Custom Code @39-73254650
    
	ProjectEmployeesModify("Delete")

'End Record employees_record Event BeforeDelete. Action Custom Code

'Record Form BeforeDelete tail @14-74B65CDA
        employees_recordParameters()
        employees_recordLoadItemFromRequest(item, False)
        If employees_recordDeleteAllowed Then
        ErrorFlag = (employees_recordErrors.Count > 0)
        If ExecuteFlag And (Not ErrorFlag) Then
            Try
                employees_recordData.DeleteItem()
            Catch ex As Exception
                employees_recordErrors.Add("DataProvider",ex.Message)
                ErrorFlag = True
            End Try
        End If
'End Record Form BeforeDelete tail

'Record Form AfterDelete tail @14-6DB15A98
        End If
        If ErrorFlag Then
            employees_recordShowErrors()
        Else
            Response.Redirect(RedirectUrl)
        End If
    End Sub
'End Record Form AfterDelete tail

'Record Form employees_record Cancel Operation @14-049BD150

    Protected Sub employees_record_Cancel(ByVal sender As Object, ByVal e As System.EventArgs)
        Dim item As employees_recordItem = New employees_recordItem()
        Dim RedirectUrl As String = Getemployees_recordRedirectUrl("", "")
        employees_recordLoadItemFromRequest(item, False)
'End Record Form employees_record Cancel Operation

'Record Form employees_record Cancel Operation tail @14-EA2B0FFB
        Response.Redirect(RedirectUrl)
    End Sub
'End Record Form employees_record Cancel Operation tail

'OnInit Event @1-A6E930FA
    #Region " Web Form Designer Generated Code "
    Protected Overrides Sub OnInit(ByVal e As EventArgs)
        '
        ' CODEGEN: This call is required by the ASP.NET Web Form Designer.
        '
        InitializeComponent()
        'Me.Load += new System.EventHandler(this.Page_Load);
        'Me.Unload += new System.EventHandler(this.Page_Unload);
        employeesData = New employeesDataProvider()
        employees_recordData = New employees_recordDataProvider()
        MyBase.OnInit(e)
'End OnInit Event

'OnInit Event tail @1-E31F8E2A
    End Sub
'End OnInit Event tail

'InitializeComponent Event @1-EA5E2628
    ' <summary>
    ' Required method for Designer support - do not modify
    ' the contents of this method with the code editor.
    ' </summary>
    Private Sub InitializeComponent()
    End Sub
    #End Region
'End InitializeComponent Event

'Page class tail @1-DD082417
End Class
End Namespace
'End Page class tail

