//Using Statements @1-AA20ED07
using System;
using System.Collections;
using System.Collections.Specialized;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Text.RegularExpressions;
using System.Globalization;
using CCSExample_CSharp;
using CCSExample_CSharp.Data;
using CCSExample_CSharp.Configuration;
using CCSExample_CSharp.Controls;

namespace CCSExample_CSharp.ManyToManyListbox.ManyToManyListbox
{

//End Using Statements

//Forms Definition @1-37CD2C4A
public class ManyToManyListboxPage : System.Web.UI.Page
{
//End Forms Definition

//Forms Objects @1-263D16DD
    protected System.Web.UI.WebControls.Repeater projectsRepeater;
    protected projectsDataProvider projectsData;
    protected projects_recDataProvider projects_recData;
    protected HtmlInputButton projects_recInsert1;
    protected HtmlInputButton projects_recUpdate1;
    protected HtmlInputButton projects_recDelete1;
    protected HtmlInputButton projects_recCancel;
    protected System.Web.UI.WebControls.PlaceHolder projects_recError;
    protected System.Web.UI.HtmlControls.HtmlTable projects_recHolder;
    protected System.Web.UI.WebControls.Label projects_recErrorLabel;
    protected bool projects_recInsertAllowed=true;
    protected bool projects_recUpdateAllowed=true;
    protected bool projects_recDeleteAllowed=true;
    protected NameValueCollection projects_recErrors=new NameValueCollection();
    protected System.Web.UI.WebControls.TextBox projects_recproject_name;
    protected System.Web.UI.HtmlControls.HtmlSelect projects_recemployee_list;
    protected System.Web.UI.HtmlControls.HtmlAnchor Link1;
//End Forms Objects

//Page_Load Event @1-55207E05
private void Page_Load(object sender, System.EventArgs e)
{
//End Page_Load Event

//Page_Load Event BeforeIsPostBack @1-19A9C3B1
    if (!IsPostBack)
    {
            PageDataProvider PageData=new PageDataProvider();
            PageItem item=PageItem.CreateFromHttpRequest();
            item.Link1Href = "ManyToManyListbox_desc.aspx?";
            PageData.FillItem(item);
            Link1.InnerText += item.Link1.GetFormattedValue().Replace("\r","").Replace("\n","<br>");
            Link1.HRef += item.Link1Href+item.Link1HrefParameters.ToString("GET","", ViewState);
            projectsBind();
            projects_recShow();
    }
//End Page_Load Event BeforeIsPostBack

//Page_Load Event tail @1-FCB6E20C
}
//End Page_Load Event tail

//Page_Unload Event @1-72102C7C
private void Page_Unload(object sender, System.EventArgs e)
{
//End Page_Unload Event

//Page_Unload Event tail @1-FCB6E20C
}
//End Page_Unload Event tail

//Grid projects Bind @49-8FD79435
    protected void projectsBind()
    {
        int PagesCount;
        int FooterIndex;
        if (!IsPostBack)
        {
            string Param;
            int PageSize;
            ViewState["projectsSortField"] = projectsDataProvider.SortFields.Default;
            PageSize = 10;
            ViewState["projectsPageNumber"] = 1;
            Param = Request.QueryString["projectsOrder"];
            if (Param != null && Param.Length > 0)
                try{
                    projectsDataProvider.SortFields SortField = 0;
                    ViewState["projectsSortField"] = Enum.Parse(SortField.GetType(), Param);
                }catch {}
            Param = Request.QueryString["projectsDir"];
            if (Param == null || Param.Length == 0 || Param.ToLower() == "desc")
                ViewState["projectsSortDir"] = SortDirections.Desc;
            else
                ViewState["projectsSortDir"] = SortDirections.Asc;
            Param = Request.QueryString["projectsPage"];
            int PageNumber;
            if (Param != null && Param.Length > 0)
                try
                {
                    PageNumber = Int32.Parse(Param);
                    if (PageNumber > 0) ViewState["projectsPageNumber"] = PageNumber;
                }
                catch {}
            Param = Request.QueryString["projectsPageSize"];
            if (Param != null && Param.Length > 0)
                try
                {
                    PageSize = Int32.Parse(Param);
                    if (PageSize <= 0) PageSize = 10;
                }
                catch {}
            if (PageSize > 100)
                PageSize = 100;
            ViewState["projectsPageSize"] = PageSize;
        }
//End Grid projects Bind

//Grid Form projects BeforeShow tail @49-C5B0E9AB
        projectsParameters();
        projectsData.SortField = (projectsDataProvider.SortFields)ViewState["projectsSortField"];
        projectsData.SortDir = (SortDirections)ViewState["projectsSortDir"];
        projectsData.PageNumber = (int)ViewState["projectsPageNumber"];
        projectsData.RecordsPerPage = (int)ViewState["projectsPageSize"];
        projectsRepeater.DataSource = projectsData.GetResultSet(out PagesCount);
        ViewState["projectsPagesCount"] = PagesCount;
        projectsRepeater.DataBind();
        FooterIndex = projectsRepeater.Controls.Count - 1;
        if (PagesCount == 0)
        {
            projectsRepeater.Controls[FooterIndex].FindControl("NoRecords").Visible = true;
        }
        projectsItem item=new projectsItem();
        System.Web.UI.HtmlControls.HtmlAnchor projectsproject_add = (System.Web.UI.HtmlControls.HtmlAnchor)projectsRepeater.Controls[FooterIndex].FindControl("projectsproject_add");

        item.project_addHref = "ManyToManyListbox.aspx?";

        projectsproject_add.InnerText += item.project_add.GetFormattedValue().Replace("\r","").Replace("\n","<br>");
        projectsproject_add.HRef += item.project_addHref+item.project_addHrefParameters.ToString("GET","project_id", ViewState);
        if(projectsData.SortField.ToString()=="Sorter_project_id") 
            ((CCSExample_CSharp.Controls.Sorter)projectsRepeater.Controls[0].FindControl("Sorter_project_idSorter")).State=projectsData.SortDir==SortDirections.Asc?SorterState.Ascending:SorterState.Descending;
        if(projectsData.SortField.ToString()=="Sorter_project_name") 
            ((CCSExample_CSharp.Controls.Sorter)projectsRepeater.Controls[0].FindControl("Sorter_project_nameSorter")).State=projectsData.SortDir==SortDirections.Asc?SorterState.Ascending:SorterState.Descending;
        CCSExample_CSharp.Controls.Navigator NavigatorNavigator = (CCSExample_CSharp.Controls.Navigator)projectsRepeater.Controls[FooterIndex].FindControl("NavigatorNavigator");
        NavigatorNavigator.MaxPage=PagesCount;
        NavigatorNavigator.PageNumber=projectsData.PageNumber;
        NavigatorNavigator.DataBind();
//End Grid Form projects BeforeShow tail

//Grid projects Bind tail @49-FCB6E20C
    }
//End Grid projects Bind tail

//Grid projects Table Parameters @49-0786D398
    protected void projectsParameters()
    {
        try{
        }catch{
            ControlCollection ParentControls=projectsRepeater.Parent.Controls;
            int RepeaterIndex=ParentControls.IndexOf(projectsRepeater);
            ParentControls.RemoveAt(RepeaterIndex);
            Literal ErrorMessage=new Literal();
            ErrorMessage.Text="Error in Grid projects: Invalid parameter";
            ParentControls.AddAt(RepeaterIndex,ErrorMessage);
        }
	}
	
//End Grid projects Table Parameters

//Grid projects ItemDataBound event @49-20693F99
    protected void projectsItemDataBound(Object Sender, RepeaterItemEventArgs e)
    {
        projectsItem DataItem=(projectsItem)e.Item.DataItem;
        if (e.Item.ItemType == ListItemType.Item || e.Item.ItemType == ListItemType.AlternatingItem) {
            System.Web.UI.HtmlControls.HtmlAnchor projectsproject_name = (System.Web.UI.HtmlControls.HtmlAnchor)(e.Item.FindControl("projectsproject_name"));
            DataItem.project_nameHref = "ManyToManyListbox.aspx?";
            projectsproject_name.HRef += DataItem.project_nameHref + DataItem.project_nameHrefParameters.ToString("GET","", ViewState);
        }
//End Grid projects ItemDataBound event

//Grid projects ItemDataBound event tail @49-FCB6E20C
    }
//End Grid projects ItemDataBound event tail

//Grid projects ItemCommand event @49-291581FD
    protected void projectsItemCommand(Object Sender, RepeaterCommandEventArgs e)
    {
        int FooterIndex = projectsRepeater.Controls.Count - 1;
        bool BindAllowed = false;
        if(e.CommandName=="Sort"){
            if(((SorterState)e.CommandArgument)==SorterState.None)
                if((SortDirections)ViewState["projectsSortDir"]==SortDirections.Asc&&ViewState["projectsSortField"].ToString()==((CCSExample_CSharp.Controls.Sorter)e.CommandSource).Field)
                    ViewState["projectsSortDir"]=SortDirections.Desc;
                else
                    ViewState["projectsSortDir"]=SortDirections.Asc;
            else
                ViewState["projectsSortDir"]=(int)(((CCSExample_CSharp.Controls.Sorter)e.CommandSource).State);
            ViewState["projectsSortField"]=Enum.Parse(typeof(projectsDataProvider.SortFields),((CCSExample_CSharp.Controls.Sorter)e.CommandSource).Field);
            ViewState["projectsPageNumber"] = 1;
            BindAllowed = true;
        }
        if(e.CommandName=="Navigate"){
            ViewState["projectsPageNumber"] = Int32.Parse(e.CommandArgument.ToString());
            BindAllowed = true;
        }
        if (BindAllowed)
            projectsBind();
    }
//End Grid projects ItemCommand event

//Record Form projects_rec Parameters @55-E845BF58
    protected void projects_recParameters()
    {
        try{
            projects_recData.Urlproject_id= IntegerParameter.GetParam(Request.QueryString["project_id"]);
        }catch(Exception e){
            projects_recErrors.Add("Parameters","Form parameters: " + e.Message);
        }
    }
//End Record Form projects_rec Parameters

 protected void ProjectEmployeesModify(string Actions) 
 {

	//Retrieve current project
	string Param;
	string Sql;
 	int CurrProjectID;

 	try{

		CurrProjectID = Int32.Parse(Request.QueryString["project_id"]);
		if(CurrProjectID < 0) CurrProjectID = 0;
 	}
 	catch{
		CurrProjectID = 0;
 	}

	//Update assigned employees
	//  EmpList = Split(Request.Form("employee_list"),",");
	//  employee_list = Split(Request.Form("employee_list"),",")
	//  ItemCollection employee_listItems = new ItemCollection();
  
	DataAccessObject NewDao = Settings.IntranetDBDataAccessObject;

	if(Actions == "Insert") {
    
		//Retrieve the last inserted key
     	//Use MS SQL method (disabled below)
     	// GetLastInsKey = CCDLookup("@@IDENTITY","projects","",DBIntranetDB)
     	//Use method compatible with all databases (unsafe when multiple users insert records at the same time)

     	long GetLastInsKey = Int64.Parse((new IntegerField("",Settings.IntranetDBDataAccessObject.ExecuteScalar("SELECT max(project_id) FROM projects"))).GetFormattedValue(""));
     	//Insert New links
		if(Request.Form["projects_recemployee_list"] == null) return;
     	for(int i= 0; i <= Request.Form.GetValues("projects_recemployee_list").GetUpperBound(0); i++) {
			Sql = "INSERT INTO projects_employees (project_id, emp_id) VALUES (" + 
	                NewDao.ToSql(GetLastInsKey.ToString(),FieldType.Integer) + "," + NewDao.ToSql(Request.Form.GetValues("projects_recemployee_list")[i],FieldType.Integer) + ")";
       		NewDao.RunSql(Sql);
     	}
  	} 
	if(CurrProjectID > 0){

	    if (Actions == "Delete" || Actions == "Update") {
    		//Delete project employees links
       		Sql = "DELETE FROM projects_employees WHERE project_id= " + NewDao.ToSql(CurrProjectID.ToString(),FieldType.Integer);
       		NewDao.RunSql(Sql);
    	} 

    	if (Actions == "Update") {
       		//Insert assigned employees
			
			
			if(Request.Form["projects_recemployee_list"] == null) return;
			for(int i= 0; i <= Request.Form.GetValues("projects_recemployee_list").GetUpperBound(0); i ++){
         		Sql = "INSERT INTO projects_employees (project_id, emp_id) VALUES (" + 
	                NewDao.ToSql(CurrProjectID.ToString(),FieldType.Integer) + "," + NewDao.ToSql(Request.Form.GetValues("projects_recemployee_list")[i],FieldType.Integer) + ")";
         		NewDao.RunSql(Sql);
       		}
    	} 
  	}

 }


//Record Form projects_rec Show method @55-DE535113
    protected void projects_recShow()
    {
        bool AllowRead = true,AllowInsert = true,AllowUpdate = true,AllowDelete = true;
        projects_recItem item=projects_recItem.CreateFromHttpRequest();
        bool IsInsertMode=!AllowRead;
        projects_recErrors.Add(item.errors);
//End Record Form projects_rec Show method

//Grid Form projects_rec BeforeShow tail @55-D3A5F2C1
        projects_recParameters();
        projects_recData.FillItem(item,ref IsInsertMode);
        projects_recInsert1.Visible=IsInsertMode&&AllowInsert;
        projects_recUpdate1.Visible=!IsInsertMode&&AllowUpdate;
        projects_recDelete1.Visible=!IsInsertMode&&AllowDelete;
        projects_recproject_name.Text=item.project_name.GetFormattedValue();
        if(Request.QueryString["employee_list"] != null && IsInsertMode)
            for(int i = 0;i <= Request.QueryString.GetValues("employee_list").GetUpperBound(0); i ++)
                item.employee_listItems.SetSelection(Request.QueryString.GetValues("employee_list")[i]);
        item.employee_listItems.SetSelection(item.employee_list.Value);
        item.employee_listItems.CopyTo(projects_recemployee_list.Items);
//End Grid Form projects_rec BeforeShow tail

//Record projects_rec Event BeforeShow. Action Custom Code @63-2A29BDB7

  if(Request.QueryString["project_id"] != null && Request.QueryString["project_id"] != "") {
     SqlCommand Select;
     Select = new SqlCommand("SELECT employees.emp_id FROM employees, projects_employees WHERE projects_employees.emp_id = employees.emp_id AND projects_employees.project_id=" +  Request.QueryString["project_id"].ToString(),
              Settings.IntranetDBDataAccessObject);
     DataRowCollection empID = Select.Execute().Tables[0].Rows;
     if(!IsInsertMode){
       for(int i = 0; i < empID.Count; i++){
         item.employee_listItems.SetSelection(empID[i]["emp_id"].ToString());
       }
       projects_recemployee_list.Items.Clear();
       item.employee_listItems.CopyTo(projects_recemployee_list.Items);
     } 
  }
//End Record projects_rec Event BeforeShow. Action Custom Code

//Record Form projects_rec Show method tail @55-35036800
        if(projects_recErrors.Count>0)
            projects_recShowErrors();
    }
//End Record Form projects_rec Show method tail

//Record Form projects_rec LoadItemFromRequest method @55-22C20221
    protected void projects_recLoadItemFromRequest(projects_recItem item, bool EnableValidation)
    {
        item.project_name.SetValue(projects_recproject_name.Text);
        try{
        item.employee_list.SetValue(projects_recemployee_list.Value);
        }catch(ArgumentException){
            projects_recErrors.Add("employee_list","The value in field employee_list is not valid.");}
        if(EnableValidation)
            item.Validate(projects_recData);
        projects_recErrors.Add(item.errors);
    }
//End Record Form projects_rec LoadItemFromRequest method

//Record Form projects_rec GetRedirectUrl method @55-9DF845D9
    protected string Getprojects_recRedirectUrl(string redirectString ,string removeList)
    {
        string Params="";
        string[] List=("project_id;" + removeList).ToLower().Split(new Char[] {';'});

        if(redirectString == "") redirectString = "ManyToManyListbox.aspx";
        for(int i = 0; i < Request.QueryString.Count;i ++)
            if(Array.IndexOf(List,Request.QueryString.AllKeys[i].ToLower()) < 0)
                Params += Request.QueryString.AllKeys[i] + "=" + Server.UrlEncode(Request.QueryString[i]) + "&";
        Params = Params.TrimEnd(new Char[]{'&'});
        return redirectString + "?" + Params;
    }

//End Record Form projects_rec GetRedirectUrl method

//Record Form projects_rec ShowErrors method @55-F9FB84CA
    protected void projects_recShowErrors()
    {
        string DefaultMessage="";
        for(int i=0;i<projects_recErrors.Count;i++)
        switch(projects_recErrors.AllKeys[i])
        {
            default:
                DefaultMessage+=projects_recErrors[i]+"<br>";
                break;
        }
        projects_recError.Visible = true;
        projects_recErrorLabel.Text = DefaultMessage;
    }
//End Record Form projects_rec ShowErrors method

//Record Form projects_rec Insert Operation @55-A2D7180E
    protected void projects_rec_Insert(object sender, System.EventArgs e)
    {
        bool ExecuteFlag = true;
        bool ErrorFlag = false;
        projects_recItem item=new projects_recItem();
        string RedirectUrl = Getprojects_recRedirectUrl("", "");
//End Record Form projects_rec Insert Operation

//Record Form projects_rec BeforeInsert tail @55-6515B419
    projects_recParameters();
    projects_recLoadItemFromRequest(item, true);
    if(projects_recInsertAllowed){
    ErrorFlag=(projects_recErrors.Count>0);
        if(ExecuteFlag&&!ErrorFlag)
            try
            {
                projects_recData.InsertItem(item);
            }
            catch (Exception ex)
            {
                projects_recErrors.Add("DataProvider",ex.Message);
                ErrorFlag=true;
            }
//End Record Form projects_rec BeforeInsert tail

//Record projects_rec Event AfterInsert. Action Custom Code @64-2A29BDB7

  if (!ErrorFlag) 
    ProjectEmployeesModify("Insert");

//End Record projects_rec Event AfterInsert. Action Custom Code

//Record Form projects_rec AfterInsert tail  @55-E11C5A18
        }
        if(ErrorFlag)
            projects_recShowErrors();
        else
            Response.Redirect(RedirectUrl);
    }
//End Record Form projects_rec AfterInsert tail 

//Record Form projects_rec Update Operation @55-33366C0D
    protected void projects_rec_Update(object sender, System.EventArgs e)
    {
        projects_recItem item=new projects_recItem();
        item.IsNew = false;
        bool ExecuteFlag = true;
        bool ErrorFlag = false;
        string RedirectUrl = Getprojects_recRedirectUrl("", "");
//End Record Form projects_rec Update Operation

//Record Form projects_rec Before Update tail @55-9C8F6889
        projects_recParameters();
        projects_recLoadItemFromRequest(item, true);
        if(projects_recUpdateAllowed){
        ErrorFlag=(projects_recErrors.Count>0);
        if(ExecuteFlag&&!ErrorFlag)
            try
            {
                projects_recData.UpdateItem(item);
            }
            catch (Exception ex)
            {
                projects_recErrors.Add("DataProvider",ex.Message);
                ErrorFlag=true;
            }
//End Record Form projects_rec Before Update tail

//Record projects_rec Event AfterUpdate. Action Custom Code @65-2A29BDB7

  if (!ErrorFlag) 
    ProjectEmployeesModify("Update");

//End Record projects_rec Event AfterUpdate. Action Custom Code

//Record Form projects_rec Update Operation tail @55-E11C5A18
        }
        if(ErrorFlag)
            projects_recShowErrors();
        else
            Response.Redirect(RedirectUrl);
    }
//End Record Form projects_rec Update Operation tail

//Record Form projects_rec Delete Operation @55-DEAE8916
    protected void projects_rec_Delete(object sender,System.EventArgs e)
    {
        bool ExecuteFlag = true;
        bool ErrorFlag = false;
        string RedirectUrl = Getprojects_recRedirectUrl("", "");
        projects_recItem item=new projects_recItem();
        item.IsNew = false;
        item.IsDeleted = true;
//End Record Form projects_rec Delete Operation

//Record projects_rec Event BeforeDelete. Action Custom Code @70-2A29BDB7

  ProjectEmployeesModify("Delete");

//End Record projects_rec Event BeforeDelete. Action Custom Code

//Record Form BeforeDelete tail @55-0F0E2880
        projects_recParameters();
        projects_recLoadItemFromRequest(item, false);
        if(projects_recDeleteAllowed){
        ErrorFlag = (projects_recErrors.Count > 0);
        if(ExecuteFlag && !ErrorFlag)
            try
            {
                projects_recData.DeleteItem();
            }
            catch (Exception ex)
            {
                projects_recErrors.Add("DataProvider", ex.Message);
                ErrorFlag = true;
            }
//End Record Form BeforeDelete tail

//Record Form AfterDelete tail @55-E11C5A18
        }
        if(ErrorFlag)
            projects_recShowErrors();
        else
            Response.Redirect(RedirectUrl);
    }
//End Record Form AfterDelete tail

//Record Form projects_rec Cancel Operation @55-765855E1
    protected void projects_rec_Cancel(object sender,System.EventArgs e)
    {
        projects_recItem item=new projects_recItem();
        string RedirectUrl = Getprojects_recRedirectUrl("", "");
        projects_recLoadItemFromRequest(item, false);
//End Record Form projects_rec Cancel Operation

//Record Form projects_rec Cancel Operation tail @55-AE897FBA
        Response.Redirect(RedirectUrl);
    }
//End Record Form projects_rec Cancel Operation tail

//OnInit Event @1-8300A8AA
    #region Web Form Designer generated code
    override protected void OnInit(EventArgs e)
    {
        //
        //CODEGEN: This call is required by the ASP.NET Web Form Designer.
        //
        InitializeComponent();
        this.Load += new System.EventHandler(this.Page_Load);
        this.Unload += new System.EventHandler(this.Page_Unload);
        projectsData = new projectsDataProvider();
        projects_recData = new projects_recDataProvider();
        base.OnInit(e);
//End OnInit Event

//OnInit Event tail @1-FCB6E20C
    }
//End OnInit Event tail

//InitializeComponent Event @1-722FC1EE
    /// <summary>
    /// Required method for Designer support - do not modify
    /// the contents of this method with the code editor.
    /// </summary>
    private void InitializeComponent()
    {
    }
    #endregion
//End InitializeComponent Event

//Page class tail @1-F5FC18C5
}
}
//End Page class tail

