'Using Statements @1-BD64AFAC
Imports System
Imports System.Collections
Imports System.Collections.Specialized
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Web
Imports System.Web.SessionState
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports System.Web.UI.HtmlControls
Imports System.Text.RegularExpressions
Imports System.Globalization
Imports ExamplePack_VB
Imports ExamplePack_VB.Data
Imports ExamplePack_VB.Configuration
Imports ExamplePack_VB.Controls
Namespace ManyToManyListbox.ManyToManyListbox
'End Using Statements

'Forms Definition @1-940C5401
Public Class [ManyToManyListboxPage]
Inherits System.Web.UI.Page
'End Forms Definition

'Forms Objects @1-27CC9D52
    Protected projectsRepeater As  System.Web.UI.WebControls.Repeater
    Protected projectsData As projectsDataProvider
    Protected projects_recData As projects_recDataProvider
    Protected projects_recInsert1 As HtmlInputButton 
    Protected projects_recUpdate1 As HtmlInputButton 
    Protected projects_recDelete1 As HtmlInputButton 
    Protected projects_recCancel As HtmlInputButton 
    Protected projects_recError As System.Web.UI.WebControls.PlaceHolder
    Protected projects_recHolder As System.Web.UI.HtmlControls.HtmlTable
    Protected projects_recErrorLabel As System.Web.UI.WebControls.Label
    Protected projects_recInsertAllowed As Boolean = True
    Protected projects_recUpdateAllowed As Boolean = True
    Protected projects_recDeleteAllowed As Boolean = True
    Protected projects_recErrors As NameValueCollection = New NameValueCollection()
    Protected projects_recproject_name As System.Web.UI.WebControls.TextBox
    Protected projects_recemployee_list As System.Web.UI.HtmlControls.HtmlSelect
    Protected Link1 As System.Web.UI.HtmlControls.HtmlAnchor
'End Forms Objects

'Page_Load Event @1-A2D2CF1E

Protected Overrides Sub OnLoad(ByVal e As System.EventArgs)
'End Page_Load Event

'Page_Load Event BeforeIsPostBack @1-8721250F
    If Not IsPostBack Then
            Dim PageData As PageDataProvider = New PageDataProvider()
            Dim item As PageItem = PageItem.CreateFromHttpRequest()
            item.Link1Href = "ManyToManyListbox_desc.aspx?"
            PageData.FillItem(item)
            Link1.InnerText += item.Link1.GetFormattedValue().Replace(vbCrLf,"")
            Link1.HRef += item.Link1Href & item.Link1HrefParameters.ToString("GET","", ViewState)
            projectsBind
            projects_recShow()
    End If
'End Page_Load Event BeforeIsPostBack

'Page_Load Event tail @1-E31F8E2A
End Sub
'End Page_Load Event tail

'Page_Unload Event @1-D998A98F

Protected Overrides Sub OnUnload(ByVal e As System.EventArgs)
'End Page_Unload Event

'Page_Unload Event tail @1-E31F8E2A
End Sub
'End Page_Unload Event tail

'Grid projects Bind @49-11D6214D

    Protected Sub projectsBind()
        Dim PagesCount As Integer
        Dim FooterIndex As Integer
        If Not(IsPostBack) Then
            Dim Param As String
            Param = Request.QueryString("projectsOrder")
            Try
                Dim sf As projectsDataProvider.SortFields = 0
                ViewState("projectsSortField") = [Enum].Parse(sf.GetType(), Param)
            Catch
                ViewState("projectsSortField") = projectsDataProvider.SortFields._Default
            End Try

            Param = Request.QueryString("projectsDir")
            If IsNothing(Param) Then
                ViewState("projectsSortDir") = SortDirections._Desc
            Else
                If Param.Length = 0 Or Param.ToLower() = "desc" Then
                    ViewState("projectsSortDir") = SortDirections._Desc
                Else
                    ViewState("projectsSortDir") = SortDirections._Asc
                End If
            End If
            Param = Request.QueryString("projectsPage")
            Dim PageNumber as Integer
            Try
                PageNumber = Int32.Parse(Param)
                If PageNumber <= 0 Then PageNumber = 1
            Catch
                PageNumber = 1
            End Try
            ViewState("projectsPageNumber") = PageNumber
            Param = Request.QueryString("projectsPageSize")
            Try
                PageNumber = Int32.Parse(Param)
                If PageNumber <= 0 Then PageNumber = 10
            Catch
                PageNumber = 10
            End Try
            If PageNumber > 100 Then
                PageNumber = 100
            End If
            ViewState("projectsPageSize") = PageNumber
        End If
'End Grid projects Bind

'Grid Form projects BeforeShow tail @49-2F020EA3
        projectsParameters
        projectsData.SortField = CType(ViewState("projectsSortField"),projectsDataProvider.SortFields)
        projectsData.SortDir = CType(ViewState("projectsSortDir"),SortDirections)
        projectsData.PageNumber = CInt(ViewState("projectsPageNumber"))
        projectsData.RecordsPerPage = CInt(ViewState("projectsPageSize"))
        projectsRepeater.DataSource = projectsData.GetResultSet(PagesCount)
        ViewState("projectsPagesCount") = PagesCount
        projectsRepeater.DataBind
        FooterIndex = projectsRepeater.Controls.Count - 1
        If PagesCount = 0 Then
            projectsRepeater.Controls(FooterIndex).FindControl("NoRecords").Visible = True
        End If
        Dim item As projectsItem = New projectsItem()
        Dim projectsproject_add As System.Web.UI.HtmlControls.HtmlAnchor = DirectCast(projectsRepeater.Controls(FooterIndex).FindControl("projectsproject_add"),System.Web.UI.HtmlControls.HtmlAnchor)

        item.project_addHref = "ManyToManyListbox.aspx?"

        projectsproject_add.InnerText += item.project_add.GetFormattedValue().Replace(vbCrLf,"")
        projectsproject_add.HRef += item.project_addHref & item.project_addHrefParameters.ToString("GET","project_id", ViewState)
        If projectsData.SortField.ToString()="Sorter_project_id" Then
            If projectsData.SortDir=SortDirections._Asc Then
                CType(projectsRepeater.Controls(0).FindControl("Sorter_project_idSorter"),Controls.Sorter).State = SorterState.Ascending
            Else
                CType(projectsRepeater.Controls(0).FindControl("Sorter_project_idSorter"),Controls.Sorter).State = SorterState.Descending
            End If
        End If
        If projectsData.SortField.ToString()="Sorter_project_name" Then
            If projectsData.SortDir=SortDirections._Asc Then
                CType(projectsRepeater.Controls(0).FindControl("Sorter_project_nameSorter"),Controls.Sorter).State = SorterState.Ascending
            Else
                CType(projectsRepeater.Controls(0).FindControl("Sorter_project_nameSorter"),Controls.Sorter).State = SorterState.Descending
            End If
        End If
        Dim NavigatorNavigator As Controls.Navigator = CType(projectsRepeater.Controls(FooterIndex).FindControl("NavigatorNavigator"),Controls.Navigator)
        NavigatorNavigator.MaxPage=PagesCount
        NavigatorNavigator.PageNumber=projectsData.PageNumber
        NavigatorNavigator.DataBind
'End Grid Form projects BeforeShow tail

'Grid projects Bind tail @49-E31F8E2A
    End Sub
'End Grid projects Bind tail

'Grid projects Table Parameters @49-08874D0B

    Protected Sub projectsParameters()
        Try

        Catch
            Dim ParentControls As ControlCollection=projectsRepeater.Parent.Controls
            Dim RepeaterIndex As Integer=ParentControls.IndexOf(projectsRepeater)
            ParentControls.RemoveAt(RepeaterIndex)
            Dim ErrorMessage as Literal=New Literal()
            ErrorMessage.Text="Error in Grid projects: Invalid parameter"
            ParentControls.AddAt(RepeaterIndex,ErrorMessage)
        End Try
    End Sub
'End Grid projects Table Parameters

'Grid projects ItemDataBound event @49-F8EB78FC

    Protected Sub projectsItemDataBound(Sender as Object, e as RepeaterItemEventArgs)
        Dim DataItem as projectsItem=CType(e.Item.DataItem,projectsItem)
        If e.Item.ItemType = ListItemType.Item Or e.Item.ItemType = ListItemType.AlternatingItem Then
            Dim projectsproject_name As System.Web.UI.HtmlControls.HtmlAnchor = DirectCast(e.Item.FindControl("projectsproject_name"),System.Web.UI.HtmlControls.HtmlAnchor)
            DataItem.project_nameHref = "ManyToManyListbox.aspx?"
            projectsproject_name.HRef += DataItem.project_nameHref & DataItem.project_nameHrefParameters.ToString("GET","", ViewState)
        End If
'End Grid projects ItemDataBound event

'Grid projects ItemDataBound event tail @49-E31F8E2A
    End Sub
'End Grid projects ItemDataBound event tail

'Grid projects ItemCommand event @49-FA1A55EB

    Protected Sub projectsItemCommand(Sender as Object, e as RepeaterCommandEventArgs)
        Dim FooterIndex as Integer= projectsRepeater.Controls.Count - 1
        Dim BindAllowed as Boolean= False
        If e.CommandName = "Sort" Then
            If CType(e.CommandArgument,SorterState)=SorterState.None
                If CType(ViewState("projectsSortDir"),SortDirections) = SortDirections._Asc And ViewState("projectsSortField").ToString()=CType(e.CommandSource,Controls.Sorter).Field
                    ViewState("projectsSortDir")=SortDirections._Desc
                Else
                    ViewState("projectsSortDir")=SortDirections._Asc
                End If
            Else
                ViewState("projectsSortDir")=CInt(CType(e.CommandSource,Controls.Sorter).State)
            End If
            Dim sf As projectsDataProvider.SortFields = 0
            ViewState("projectsSortField")=[Enum].Parse(sf.GetType(),CType(e.CommandSource,Controls.Sorter).Field)
            ViewState("projectsPageNumber") = 1
            BindAllowed = True
        End If

        If e.CommandName="Navigate" Then
            ViewState("projectsPageNumber") = Int32.Parse(e.CommandArgument.ToString())
            BindAllowed = True
        End If
        If BindAllowed Then
            projectsBind
        End If
    End Sub
'End Grid projects ItemCommand event

'Record Form projects_rec Parameters @55-1758F919

    Protected Sub projects_recParameters()
        Try
            projects_recData.Urlproject_id = IntegerParameter.GetParam(Request.QueryString("project_id"))
        Catch e As Exception
            projects_recErrors.Add("Parameters","Form Parameters: " + e.Message)
        End Try
    End Sub
'End Record Form projects_rec Parameters

Protected Sub ProjectEmployeesModify(Actions As String) 


	'Retrieve current project
	Dim Sql As String
 	Dim CurrProjectID As Integer
	Dim i As Integer

 	Try

		CurrProjectID = Int32.Parse(Request.QueryString("project_id"))
		if CurrProjectID < 0 Then CurrProjectID = 0
 	
 	catch e As Exception 
		CurrProjectID = 0
 	End Try

	'Update assigned employees
	'EmpList = Split(Request.Form("employee_list"),",")
	 'ItemCollection employee_listItems = new ItemCollection()
  
	Dim NewDao As DataAccessObject = Settings.IntranetDBDataAccessObject

	if Actions = "Insert" Then
    
		'Retrieve the last inserted key
     	'Use MS SQL method (disabled below)
     	'GetLastInsKey = CCDLookup("@@IDENTITY","projects","",DBIntranetDB)
     	'Use method compatible with all databases (unsafe when multiple users insert records at the same time)

     	Dim GetLastInsKey As Long = Int64.Parse((new IntegerField("",Settings.IntranetDBDataAccessObject.ExecuteScalar("SELECT max(project_id) FROM projects"))).GetFormattedValue(""))
     	
		'Insert New links
		if IsNothing(Request.Form("projects_recemployee_list")) Then Exit Sub
		
		For i = 0 To Request.Form.GetValues("projects_recemployee_list").GetUpperBound(0)
			Sql = "INSERT INTO projects_employees (project_id, emp_id) VALUES (" & _
	                NewDao.ToSql(GetLastInsKey.ToString(),FieldType._Integer) & "," & NewDao.ToSql(Request.Form.GetValues("projects_recemployee_list")(i),FieldType._Integer) & ")"
       		NewDao.RunSql(Sql)
     	Next i
  	End If 
	If CurrProjectID > 0 Then 

	    If Actions = "Delete" Or Actions = "Update" Then
    		
			'Delete project employees links
       		Sql = "DELETE FROM projects_employees WHERE project_id= " & NewDao.ToSql(CurrProjectID.ToString(),FieldType._Integer)
       		NewDao.RunSql(Sql)
    	
		End If 

    	If Actions = "Update" Then
       		
			'Insert assigned employees
						
			If IsNothing(Request.Form("projects_recemployee_list")) Then Exit Sub
			For i = 0  To Request.Form.GetValues("projects_recemployee_list").GetUpperBound(0)
         		Sql = "INSERT INTO projects_employees (project_id, emp_id) VALUES (" & _ 
	                NewDao.ToSql(CurrProjectID.ToString(),FieldType._Integer) & "," & NewDao.ToSql(Request.Form.GetValues("projects_recemployee_list")(i),FieldType._Integer) & ")"
         		NewDao.RunSql(Sql)
       		Next i
    	End IF 
  	End If

End Sub

'Record Form projects_rec Show method @55-A49CAB12
    Protected Sub projects_recShow()
        Dim AllowRead As Boolean = True
        Dim AllowInsert As Boolean = True
        Dim AllowUpdate As Boolean = True
        Dim AllowDelete As Boolean = True
        Dim item As projects_recItem = projects_recItem.CreateFromHttpRequest()
        Dim IsInsertMode As Boolean = Not AllowRead
        projects_recErrors.Add(item.errors)
        If projects_recErrors.Count > 0 Then
            projects_recShowErrors()
            Return
        End If
'End Record Form projects_rec Show method

'Record Form projects_rec BeforeShow tail @55-3C8BFF16
        projects_recParameters()
        projects_recData.FillItem(item, IsInsertMode)
        projects_recInsert1.Visible = IsInsertMode And AllowInsert
        projects_recUpdate1.Visible = (Not IsInsertMode) And AllowUpdate
        projects_recDelete1.Visible = (Not IsInsertMode) And AllowDelete
        projects_recproject_name.Text=item.project_name.GetFormattedValue()
        If (Not IsNothing(Request.QueryString("employee_list"))) And IsInsertMode Then
            Dim i As Integer
            For i = 0 To Request.QueryString.GetValues("employee_list").GetUpperBound(0)
                item.employee_listItems.SetSelection(Request.QueryString.GetValues("employee_list")(i))
            Next i
        End If
        item.employee_listItems.SetSelection(item.employee_list.Value)
        item.employee_listItems.CopyTo(projects_recemployee_list.Items)
'End Record Form projects_rec BeforeShow tail

'Record projects_rec Event BeforeShow. Action Custom Code @63-73254650

  If Not IsNothing(Request.QueryString("project_id")) And (Request.QueryString("project_id") <> "") Then 
     
     Dim Sel As SqlCommand = new SqlCommand("SELECT employees.emp_id FROM employees, projects_employees WHERE projects_employees.emp_id = employees.emp_id AND projects_employees.project_id=" &  Request.QueryString("project_id").ToString()  _
              ,Settings.IntranetDBDataAccessObject)
     Dim empID As DataRowCollection = Sel.Execute().Tables(0).Rows
     if Not IsInsertMode Then 
		
		Dim i As Integer
		For  i = 0 To empID.Count -1 
			item.employee_listItems.SetSelection(empID(i)("emp_id").ToString())
		Next i
		
		projects_recemployee_list.Items.Clear()
		item.employee_listItems.CopyTo(projects_recemployee_list.Items)
     End If
  
   End If 
'End Record projects_rec Event BeforeShow. Action Custom Code

'Record Form projects_rec Show method tail @55-A8540737
        If projects_recErrors.Count > 0 Then
            projects_recShowErrors()
        End If
    End Sub
'End Record Form projects_rec Show method tail

'Record Form projects_rec LoadItemFromRequest method @55-D084D35D

    Protected Sub projects_recLoadItemFromRequest(item As projects_recItem, ByVal EnableValidation As Boolean)
        item.project_name.SetValue(projects_recproject_name.Text)
        Try
        item.employee_list.SetValue(projects_recemployee_list.Value)
        Catch ae As ArgumentException
            projects_recErrors.Add("employee_list","The value in field employee_list is not valid.")
        End Try
        If EnableValidation Then
            item.Validate(projects_recData)
        End If
        projects_recErrors.Add(item.errors)
    End Sub
'End Record Form projects_rec LoadItemFromRequest method

'Record Form projects_rec GetRedirectUrl method @55-36CD5835

    Protected Function Getprojects_recRedirectUrl(ByVal redirect As String, ByVal removeList As String) As String
        Dim Params As String = ""
        Dim List() As String = {""}

        List = ("project_id;" + RemoveList).ToLower().Split(New Char() {";"})
        If Redirect= "" Then
            Redirect = "ManyToManyListbox.aspx"
        End If
        Dim j As Integer
        For j=0 To Request.QueryString.Count - 1
            If Array.IndexOf(List,Request.QueryString.AllKeys(j).ToLower()) < 0 Then
                Params = Params & Request.QueryString.AllKeys(j) & "=" & Server.UrlEncode(Request.QueryString(j)) & "&"
            End If
        Next j
        Params = Params.TrimEnd(New Char(){"&"})
        Return Redirect & "?" & Params
    End Function
'End Record Form projects_rec GetRedirectUrl method

'Record Form projects_rec ShowErrors method @55-10AFAF1A

    Protected Sub projects_recShowErrors()
        Dim DefaultMessage As String = ""
        Dim i As Integer
        For i = 0 To projects_recErrors.Count - 1
        Select Case projects_recErrors.AllKeys(i)
            Case Else
                DefaultMessage = DefaultMessage & projects_recErrors(i) & "<br>"
        End Select
        Next i
        projects_recError.Visible = True
        projects_recErrorLabel.Text = DefaultMessage
    End Sub
'End Record Form projects_rec ShowErrors method

'Record Form projects_rec Insert Operation @55-9DF515EE

    Protected Sub projects_rec_Insert(ByVal sender As Object, ByVal e As System.EventArgs)
        Dim item As projects_recItem = New projects_recItem()
        Dim ExecuteFlag As Boolean = True
        Dim ErrorFlag As Boolean = False
        Dim RedirectUrl As String = Getprojects_recRedirectUrl("", "")
'End Record Form projects_rec Insert Operation

'Record Form projects_rec BeforeInsert tail @55-6F2FFA75
    projects_recParameters()
    projects_recLoadItemFromRequest(item, True)
    If projects_recInsertAllowed Then
        ErrorFlag=(projects_recErrors.Count > 0)
        If ExecuteFlag And (Not ErrorFlag) Then
            Try
                projects_recData.InsertItem(item)
            Catch ex As Exception
                projects_recErrors.Add("DataProvider",ex.Message)
                ErrorFlag = True
            End Try
        End If
'End Record Form projects_rec BeforeInsert tail

'Record projects_rec Event AfterInsert. Action Custom Code @64-73254650

  If Not ErrorFlag Then _
	ProjectEmployeesModify("Insert")

'End Record projects_rec Event AfterInsert. Action Custom Code

'Record Form projects_rec AfterInsert tail  @55-2A257CBB
        End If
        If ErrorFlag Then
            projects_recShowErrors()
        Else
            Response.Redirect(RedirectUrl)
        End If
    End Sub
'End Record Form projects_rec AfterInsert tail 

'Record Form projects_rec Update Operation @55-892A7411

    Protected Sub projects_rec_Update(ByVal sender As Object, ByVal e As System.EventArgs)
        Dim item As projects_recItem = New projects_recItem()
        item.IsNew = False
        Dim ExecuteFlag As Boolean = True
        Dim ErrorFlag As Boolean = False
        Dim RedirectUrl As String = Getprojects_recRedirectUrl("", "")
'End Record Form projects_rec Update Operation

'Record Form projects_rec Before Update tail @55-7D0EB8A5
        projects_recParameters()
        projects_recLoadItemFromRequest(item, True)
        If projects_recUpdateAllowed Then
        ErrorFlag = (projects_recErrors.Count > 0)
        If ExecuteFlag And (Not ErrorFlag) Then
            Try
                projects_recData.UpdateItem(item)
            Catch ex As Exception
                projects_recErrors.Add("DataProvider",ex.Message)
                ErrorFlag = True
            End Try
        End If
'End Record Form projects_rec Before Update tail

'Record projects_rec Event AfterUpdate. Action Custom Code @65-73254650

  If Not ErrorFlag Then _
    ProjectEmployeesModify("Update")

'End Record projects_rec Event AfterUpdate. Action Custom Code

'Record Form projects_rec Update Operation tail @55-2A257CBB
        End If
        If ErrorFlag Then
            projects_recShowErrors()
        Else
            Response.Redirect(RedirectUrl)
        End If
    End Sub
'End Record Form projects_rec Update Operation tail

'Record Form projects_rec Delete Operation @55-CEC9B989

    Protected Sub projects_rec_Delete(ByVal sender As Object, ByVal e As System.EventArgs)
        Dim ExecuteFlag As Boolean = True
        Dim ErrorFlag As Boolean = False
        Dim RedirectUrl As String = Getprojects_recRedirectUrl("", "")
        Dim item As projects_recItem = New projects_recItem()
        item.IsNew  = False
        item.IsDeleted  = True
'End Record Form projects_rec Delete Operation

'Record projects_rec Event BeforeDelete. Action Custom Code @70-73254650
    ProjectEmployeesModify("Delete")
'End Record projects_rec Event BeforeDelete. Action Custom Code

'Record Form BeforeDelete tail @55-B014C2A7
        projects_recParameters()
        projects_recLoadItemFromRequest(item, False)
        If projects_recDeleteAllowed Then
        ErrorFlag = (projects_recErrors.Count > 0)
        If ExecuteFlag And (Not ErrorFlag) Then
            Try
                projects_recData.DeleteItem()
            Catch ex As Exception
                projects_recErrors.Add("DataProvider",ex.Message)
                ErrorFlag = True
            End Try
        End If
'End Record Form BeforeDelete tail

'Record Form AfterDelete tail @55-2A257CBB
        End If
        If ErrorFlag Then
            projects_recShowErrors()
        Else
            Response.Redirect(RedirectUrl)
        End If
    End Sub
'End Record Form AfterDelete tail

'Record Form projects_rec Cancel Operation @55-2F3DD234

    Protected Sub projects_rec_Cancel(ByVal sender As Object, ByVal e As System.EventArgs)
        Dim item As projects_recItem = New projects_recItem()
        Dim RedirectUrl As String = Getprojects_recRedirectUrl("", "")
        projects_recLoadItemFromRequest(item, False)
'End Record Form projects_rec Cancel Operation

'Record Form projects_rec Cancel Operation tail @55-EA2B0FFB
        Response.Redirect(RedirectUrl)
    End Sub
'End Record Form projects_rec Cancel Operation tail

'OnInit Event @1-0B67D2A4
    #Region " Web Form Designer Generated Code "
    Protected Overrides Sub OnInit(ByVal e As EventArgs)
        '
        ' CODEGEN: This call is required by the ASP.NET Web Form Designer.
        '
        InitializeComponent()
        'Me.Load += new System.EventHandler(this.Page_Load);
        'Me.Unload += new System.EventHandler(this.Page_Unload);
        projectsData = New projectsDataProvider()
        projects_recData = New projects_recDataProvider()
        MyBase.OnInit(e)
'End OnInit Event

'OnInit Event tail @1-E31F8E2A
    End Sub
'End OnInit Event tail

'InitializeComponent Event @1-EA5E2628
    ' <summary>
    ' Required method for Designer support - do not modify
    ' the contents of this method with the code editor.
    ' </summary>
    Private Sub InitializeComponent()
    End Sub
    #End Region
'End InitializeComponent Event

'Page class tail @1-DD082417
End Class
End Namespace
'End Page class tail

