<%--== Handlers ==--%> <%--ManyToManyListbox Opening Initialization directive @1-A0E75F14--%><%!

// //Workaround for JRun 3.1 @1-F81417CB

//projects_rec Record Handler Head @55-7EDE35FB
    public class ManyToManyListboxprojects_recRecordHandler implements RecordListener, RecordDataObjectListener {
//End projects_rec Record Handler Head

//projects_rec OnSetDataSource Method Head @55-9B7FBFCF
        public void onSetDataSource(DataObjectEvent e) {
//End projects_rec OnSetDataSource Method Head

//projects_rec OnSetDataSource Method Tail @55-FCB6E20C
        }
//End projects_rec OnSetDataSource Method Tail

//projects_rec BeforeShow Method Head @55-46046458
        public void beforeShow(Event e) {
//End projects_rec BeforeShow Method Head

//Event BeforeShow Action Custom Code @63-44795B7A
        if (e.getRecord().isEditMode()) {
            //Acquire a connection object
            JDBCConnection conn = JDBCConnectionFactory.getJDBCConnection("IntranetDB");
            e.getRecord().getList("employee_list").setValues(
                    conn.getRows("SELECT employees.emp_id FROM employees, projects_employees " + 
                    "WHERE projects_employees.emp_id = employees.emp_id AND " +
                    "projects_employees.project_id=" + 
                    conn.toSql(e.getPage().getHttpGetParameter("project_id"), 
                    JDBCConnection.INTEGER)), "emp_id");
            conn.closeConnection();
        }
//End Event BeforeShow Action Custom Code

//projects_rec BeforeShow Method Tail @55-FCB6E20C
        }
//End projects_rec BeforeShow Method Tail

//projects_rec OnValidate Method Head @55-5F430F8E
        public void onValidate(Event e) {
//End projects_rec OnValidate Method Head

//projects_rec OnValidate Method Tail @55-FCB6E20C
        }
//End projects_rec OnValidate Method Tail

//projects_rec BeforeSelect Method Head @55-E5EC9AD3
        public void beforeSelect(Event e) {
//End projects_rec BeforeSelect Method Head

//projects_rec BeforeSelect Method Tail @55-FCB6E20C
        }
//End projects_rec BeforeSelect Method Tail

//projects_rec BeforeBuildSelect Method Head @55-3041BA14
        public void beforeBuildSelect(DataObjectEvent e) {
//End projects_rec BeforeBuildSelect Method Head

//projects_rec BeforeBuildSelect Method Tail @55-FCB6E20C
        }
//End projects_rec BeforeBuildSelect Method Tail

//projects_rec BeforeExecuteSelect Method Head @55-8391D9D6
        public void beforeExecuteSelect(DataObjectEvent e) {
//End projects_rec BeforeExecuteSelect Method Head

//projects_rec BeforeExecuteSelect Method Tail @55-FCB6E20C
        }
//End projects_rec BeforeExecuteSelect Method Tail

//projects_rec AfterExecuteSelect Method Head @55-0972E7FA
        public void afterExecuteSelect(DataObjectEvent e) {
//End projects_rec AfterExecuteSelect Method Head

//projects_rec AfterExecuteSelect Method Tail @55-FCB6E20C
        }
//End projects_rec AfterExecuteSelect Method Tail

//projects_rec BeforeInsert Method Head @55-75B62B83
        public void beforeInsert(Event e) {
//End projects_rec BeforeInsert Method Head

//projects_rec BeforeInsert Method Tail @55-FCB6E20C
        }
//End projects_rec BeforeInsert Method Tail

//projects_rec BeforeBuildInsert Method Head @55-FD6471B0
        public void beforeBuildInsert(DataObjectEvent e) {
//End projects_rec BeforeBuildInsert Method Head

//projects_rec BeforeBuildInsert Method Tail @55-FCB6E20C
        }
//End projects_rec BeforeBuildInsert Method Tail

//projects_rec BeforeExecuteInsert Method Head @55-4EB41272
        public void beforeExecuteInsert(DataObjectEvent e) {
//End projects_rec BeforeExecuteInsert Method Head

//projects_rec BeforeExecuteInsert Method Tail @55-FCB6E20C
        }
//End projects_rec BeforeExecuteInsert Method Tail

//projects_rec AfterExecuteInsert Method Head @55-C4572C5E
        public void afterExecuteInsert(DataObjectEvent e) {
//End projects_rec AfterExecuteInsert Method Head

//projects_rec AfterExecuteInsert Method Tail @55-FCB6E20C
        }
//End projects_rec AfterExecuteInsert Method Tail
class ProjectEmployeesModifyListbox {
    final public void process(Page page, String mode) {
        String[] employeeList = page.getHttpPostParameters().getParameterValues("employee_list");
        long prjId = 0;
        try {
            prjId = Long.parseLong(DBTools.toSql(page.getHttpGetParameter("project_id"), 
                    JDBCConnection.INTEGER, "IntranetDB"));
        } catch (Exception e_ignore) {}
        if ( "Insert".equals(mode) ) {
            //Retrieve the last inserted key
            //Use MS SQL method (disabled below)
            //String lastInsKey = DBTools.convertToString(
            //      DBTools.dLookUp("@@IDENTITY", "projects", "", "IntranetDB"));
            //Use method compatible with all databases (unsafe when multiple users 
            //insert records at the same time)
            String lastPrjId = Utils.convertToString(
                    DBTools.dLookUp("max(project_id)", "projects", "", "IntranetDB"));
            //Insert New links
            if (employeeList != null) {
                JDBCConnection conn = JDBCConnectionFactory.getJDBCConnection("IntranetDB");
                for (int i = 0; i < employeeList.length; i++ ) {
                    String empId = conn.toSql(employeeList[i], JDBCConnection.INTEGER);
                    conn.executeUpdate("INSERT INTO projects_employees (project_id, emp_id) VALUES (" + 
                            lastPrjId + "," + empId + ")");
                }
                conn.closeConnection();
            }
        } else if (prjId > 0) {
            JDBCConnection conn = JDBCConnectionFactory.getJDBCConnection("IntranetDB");
            if ("Delete".equals(mode) || "Update".equals(mode)) {
                //Delete project employees links
                conn.executeUpdate("DELETE FROM projects_employees WHERE project_id=" + prjId);
            }
            if ("Update".equals(mode)) {
                //Insert assigned employees
                if (employeeList != null) {
                    for (int i = 0; i < employeeList.length; i++ ) {
                        String empId = conn.toSql(employeeList[i], JDBCConnection.INTEGER);
                        conn.executeUpdate("INSERT INTO projects_employees (project_id, emp_id) VALUES (" + 
                                prjId + "," + empId + ")");
                    }
                }
            }
            conn.closeConnection();
        }
    }
}


//projects_rec AfterInsert Method Head @55-767A9165
        public void afterInsert(Event e) {
//End projects_rec AfterInsert Method Head

//Event AfterInsert Action Custom Code @64-44795B7A
new ProjectEmployeesModifyListbox().process(e.getPage(), "Insert");
//End Event AfterInsert Action Custom Code

//projects_rec AfterInsert Method Tail @55-FCB6E20C
        }
//End projects_rec AfterInsert Method Tail

//projects_rec BeforeUpdate Method Head @55-33A3CFAC
        public void beforeUpdate(Event e) {
//End projects_rec BeforeUpdate Method Head

//projects_rec BeforeUpdate Method Tail @55-FCB6E20C
        }
//End projects_rec BeforeUpdate Method Tail

//projects_rec BeforeBuildUpdate Method Head @55-37688606
        public void beforeBuildUpdate(DataObjectEvent e) {
//End projects_rec BeforeBuildUpdate Method Head

//projects_rec BeforeBuildUpdate Method Tail @55-FCB6E20C
        }
//End projects_rec BeforeBuildUpdate Method Tail

//projects_rec BeforeExecuteUpdate Method Head @55-84B8E5C4
        public void beforeExecuteUpdate(DataObjectEvent e) {
//End projects_rec BeforeExecuteUpdate Method Head

//projects_rec BeforeExecuteUpdate Method Tail @55-FCB6E20C
        }
//End projects_rec BeforeExecuteUpdate Method Tail

//projects_rec AfterExecuteUpdate Method Head @55-0E5BDBE8
        public void afterExecuteUpdate(DataObjectEvent e) {
//End projects_rec AfterExecuteUpdate Method Head

//projects_rec AfterExecuteUpdate Method Tail @55-FCB6E20C
        }
//End projects_rec AfterExecuteUpdate Method Tail

//projects_rec AfterUpdate Method Head @55-306F754A
        public void afterUpdate(Event e) {
//End projects_rec AfterUpdate Method Head

//Event AfterUpdate Action Custom Code @65-44795B7A
new ProjectEmployeesModifyListbox().process(e.getPage(), "Update");
//End Event AfterUpdate Action Custom Code

//projects_rec AfterUpdate Method Tail @55-FCB6E20C
        }
//End projects_rec AfterUpdate Method Tail

//projects_rec BeforeDelete Method Head @55-752E3118
        public void beforeDelete(Event e) {
//End projects_rec BeforeDelete Method Head

//Event BeforeDelete Action Custom Code @70-44795B7A
new ProjectEmployeesModifyListbox().process(e.getPage(), "Delete");
//End Event BeforeDelete Action Custom Code

//projects_rec BeforeDelete Method Tail @55-FCB6E20C
        }
//End projects_rec BeforeDelete Method Tail

//projects_rec BeforeBuildDelete Method Head @55-01A46505
        public void beforeBuildDelete(DataObjectEvent e) {
//End projects_rec BeforeBuildDelete Method Head

//projects_rec BeforeBuildDelete Method Tail @55-FCB6E20C
        }
//End projects_rec BeforeBuildDelete Method Tail

//projects_rec BeforeExecuteDelete Method Head @55-B27406C7
        public void beforeExecuteDelete(DataObjectEvent e) {
//End projects_rec BeforeExecuteDelete Method Head

//projects_rec BeforeExecuteDelete Method Tail @55-FCB6E20C
        }
//End projects_rec BeforeExecuteDelete Method Tail

//projects_rec AfterExecuteDelete Method Head @55-389738EB
        public void afterExecuteDelete(DataObjectEvent e) {
//End projects_rec AfterExecuteDelete Method Head

//projects_rec AfterExecuteDelete Method Tail @55-FCB6E20C
        }
//End projects_rec AfterExecuteDelete Method Tail

//projects_rec AfterDelete Method Head @55-76E28BFE
        public void afterDelete(Event e) {
//End projects_rec AfterDelete Method Head

//projects_rec AfterDelete Method Tail @55-FCB6E20C
        }
//End projects_rec AfterDelete Method Tail

//projects_rec Record Handler Tail @55-FCB6E20C
    }
//End projects_rec Record Handler Tail

//employee_list ListBox Handler Head @62-98F8D249
    public class projects_recemployee_listListBoxHandler implements ValidationListener, ListDataObjectListener {
//End employee_list ListBox Handler Head

//employee_list BeforeShow Method Head @62-46046458
        public void beforeShow(Event e) {
//End employee_list BeforeShow Method Head

//employee_list BeforeShow Method Tail @62-FCB6E20C
        }
//End employee_list BeforeShow Method Tail

//employee_list OnValidate Method Head @62-5F430F8E
        public void onValidate(Event e) {
//End employee_list OnValidate Method Head

//employee_list OnValidate Method Tail @62-FCB6E20C
        }
//End employee_list OnValidate Method Tail

//employee_list BeforeBuildSelect Method Head @62-3041BA14
        public void beforeBuildSelect(DataObjectEvent e) {
//End employee_list BeforeBuildSelect Method Head

//employee_list BeforeBuildSelect Method Tail @62-FCB6E20C
        }
//End employee_list BeforeBuildSelect Method Tail

//employee_list BeforeExecuteSelect Method Head @62-8391D9D6
        public void beforeExecuteSelect(DataObjectEvent e) {
//End employee_list BeforeExecuteSelect Method Head

//employee_list BeforeExecuteSelect Method Tail @62-FCB6E20C
        }
//End employee_list BeforeExecuteSelect Method Tail

//employee_list AfterExecuteSelect Method Head @62-0972E7FA
        public void afterExecuteSelect(DataObjectEvent e) {
//End employee_list AfterExecuteSelect Method Head

//employee_list AfterExecuteSelect Method Tail @62-FCB6E20C
        }
//End employee_list AfterExecuteSelect Method Tail

//employee_list ListBox Handler Tail @62-FCB6E20C
    }
//End employee_list ListBox Handler Tail

%>
