<%
'BindEvents Method @1-914A7553
Sub BindEvents()
    Set projects_rec.CCSEvents("BeforeShow") = GetRef("projects_rec_BeforeShow")
    Set projects_rec.CCSEvents("AfterInsert") = GetRef("projects_rec_AfterInsert")
    Set projects_rec.CCSEvents("AfterUpdate") = GetRef("projects_rec_AfterUpdate")
    Set projects_rec.CCSEvents("BeforeDelete") = GetRef("projects_rec_BeforeDelete")
End Sub
'End BindEvents Method

Function projects_rec_BeforeShow() 'projects_rec_BeforeShow @55-97673DBF
'Custom Code @63-73254650
' -------------------------
'Declare variables
Dim NewConnection
Dim EmpRecordSet
Dim ArraySize
Dim Vals()

'Populate the multi-select project ListBox
 If projects_rec.EditMode Then
   ArraySize = 1: 
   ReDim Vals(0)

  'Create a new database connection object
   Set NewConnection = New clsDBIntranetDB
   NewConnection.Open

   Set EmpRecordSet = NewConnection.Execute("SELECT employees.emp_id FROM employees, projects_employees WHERE projects_employees.emp_id = employees.emp_id AND projects_employees.project_id=" & NewConnection.ToSQL(CCGetFromGet("project_id", "0"),ccsInteger))
   While NOT EmpRecordSet.EOF
     ReDim Preserve Vals(ArraySize)
     Vals(ArraySize) = EmpRecordSet("emp_id")
     EmpRecordSet.MoveNext
     ArraySize = ArraySize + 1
   Wend
   projects_rec.employee_list.IsMultiple = True
   projects_rec.employee_list.MultipleValues = Vals

   'Close and destroy the recordset
   EmpRecordSet.Close
   Set EmpRecordSet = Nothing

  'Close and destroy the database connection object
   NewConnection.Close
   Set NewConnection = Nothing
 End If

'End Custom Code
End Function 'Close projects_rec_BeforeShow @55-54C34B28

Function ProjectEmployeesModify(Actions) 
Dim EmpProjectConn
Dim CurrProjectID
Dim EmpList
Dim EmpID

  'Create a new database connection object
  Set EmpProjectConn = New clsDBIntranetDB
  EmpProjectConn.Open

  'Retrieve the current project
  CurrProjectID = Request.QueryString("project_id")

  'Update assigned employees
  EmpList = Split(Request.Form("employee_list"),",")

  If Actions = "Insert" Then
     'Retrieve the last inserted key
     'Use MS SQL method
     ' GetLastInsKey = CCDLookup("@@IDENTITY","projects","",DBIntranetDB)
     'Use a method compatible with all databases (unsafe when multiple users insert records at the same time)
      CurrProjectID = CCDLookup("max(project_id)", "projects", "", DBIntranetDB)
     'Insert New links
     For Each EmpID In EmpList
         EmpProjectConn.Execute("INSERT INTO projects_employees (project_id, emp_id) VALUES (" & EmpProjectConn.ToSQL(CurrProjectID,ccsInteger) & "," & EmpProjectConn.ToSQL(EmpID,ccsInteger) & ")")
     Next
  End If 

  if CurrProjectID > 0 Then  
    If Actions = "Delete" Or Actions = "Update" Then
       'Delete project employees links
       EmpProjectConn.Execute("DELETE FROM projects_employees WHERE project_id=" & EmpProjectConn.ToSQL(CurrProjectID,ccsInteger))
    End If 
    If Actions = "Update" Then
       'Insert assigned employees
       For Each EmpID In EmpList
           EmpProjectConn.Execute("INSERT INTO projects_employees (project_id, emp_id) VALUES (" & EmpProjectConn.ToSQL(CurrProjectID,ccsInteger) & "," & EmpProjectConn.ToSQL(EmpID,ccsInteger) & ")")
       Next
    End If 
  End If 

  'Close and destroy the database connection object
  EmpProjectConn.Close
  Set EmpProjectConn = Nothing

End Function


Function projects_rec_AfterInsert() 'projects_rec_AfterInsert @55-EFBAA2E9
'Custom Code @64-73254650

  ProjectEmployeesModify("Insert")

'End Custom Code
End Function 'Close projects_rec_AfterInsert @55-54C34B28

Function projects_rec_AfterUpdate() 'projects_rec_AfterUpdate @55-20936366
'Custom Code @65-73254650

  ProjectEmployeesModify("Update")

'End Custom Code
End Function 'Close projects_rec_AfterUpdate @55-54C34B28

Function projects_rec_BeforeDelete() 'projects_rec_BeforeDelete @55-16456638

'Custom Code @70-73254650

  ProjectEmployeesModify("Delete")

'End Custom Code

End Function 'Close projects_rec_BeforeDelete @55-54C34B28


%>
