#BindEvents Method @1-A4205A13
sub BindEvents {
    $employees_record->{AvailableListBox}->{ds}->{CCSEvents}->{"BeforeBuildSelect"} = "employees_record_AvailableListBox_ds_BeforeBuildSelect";
    $employees_record->{CCSEvents}->{"AfterInsert"} = "employees_record_AfterInsert";
    $employees_record->{CCSEvents}->{"AfterUpdate"} = "employees_record_AfterUpdate";
    $employees_record->{CCSEvents}->{"BeforeDelete"} = "employees_record_BeforeDelete";
}
#End BindEvents Method

#employees_record_AvailableListBox_ds_BeforeBuildSelect @46-E2A70C7C
sub employees_record_AvailableListBox_ds_BeforeBuildSelect()
{
    $employees_record_AvailableListBox_ds_BeforeBuildSelect = 1;
#End employees_record_AvailableListBox_ds_BeforeBuildSelect

#Custom Code @52-84ABEA10

	my $LinkedProject = "";

	#Select all projects of the current user
	if(CCGetFromGet("emp_id",0) > 0){

    	#Create a new database connection object
		my $ProjectConnection = clsDBIntranetDB->new();
   		$ProjectConnection->query("SELECT project_id FROM projects_employees WHERE emp_id =".$ProjectConnection->ToSQL(CCGetParam("emp_id",0),$ccsInteger));
    	while($ProjectConnection->next_record()) {
       
			if($LinkedProject != ""){ $LinkedProject .= ","; }
          	$LinkedProject.= $ProjectConnection->f("project_id");
		}

		#Modify the Where clause of the AvailableListBox List Box.
		if($LinkedProject!=""){

			$employees_record->{AvailableListBox}->{ds}->{Where} = "project_id NOT IN (".$LinkedProject.")";
		}
    	#Destroy the database connection object
    	$ProjectConnection->{sth} = undef;

	}

#End Custom Code

#Close employees_record_AvailableListBox_ds_BeforeBuildSelect @46-5E05976E
    return $employees_record_AvailableListBox_ds_BeforeBuildSelect;
}
#End Close employees_record_AvailableListBox_ds_BeforeBuildSelect

#employees_record_AfterInsert @14-9829EF5A
sub employees_record_AfterInsert()
{
    $employees_record_AfterInsert = 1;
#End employees_record_AfterInsert

#Custom Code @35-84ABEA10
	ProjectEmployeesModify("Insert");
#End Custom Code

#Close employees_record_AfterInsert @14-706BBD18
    return $employees_record_AfterInsert;
}
#End Close employees_record_AfterInsert

#employees_record_AfterUpdate @14-C502FF63
sub employees_record_AfterUpdate()
{
    $employees_record_AfterUpdate = 1;
#End employees_record_AfterUpdate

#Custom Code @36-84ABEA10
	ProjectEmployeesModify("Update");
#End Custom Code

#Close employees_record_AfterUpdate @14-BF427C97
    return $employees_record_AfterUpdate;
}
#End Close employees_record_AfterUpdate

#employees_record_BeforeDelete @14-5F527835
sub employees_record_BeforeDelete()
{
    $employees_record_BeforeDelete = 1;
#End employees_record_BeforeDelete

#Custom Code @49-84ABEA10
	ProjectEmployeesModify("Delete");
#End Custom Code

#Close employees_record_BeforeDelete @14-113E24AB
    return $employees_record_BeforeDelete;
}
#End Close employees_record_BeforeDelete


sub ProjectEmployeesModify(){ 
  
  my $ProjectID = 0;
  my $ProjectList = ();
  my $GetLastInsKey = 0;
  my ($Actions) = @_;

  #Create a new database connection object
  $EmpProjectConn = clsDBIntranetDB->new();
  
  #Retrieve the current employee
  $EmpID = CCGetFromGet("emp_id",0);
  
  my $tmp = CCGetFromPost("LinkedID","");
  $tmp =~s/^\s+|\s+$//g; 	# trim parameter
  @ProjectList = split(",",$tmp);

  if($Actions eq "Insert"){

	#Retrieve the last inserted key
   	#Use a method compatible with all databases (unsafe when multiple users insert records at the same time);
	$GetLastInsKey = CCDlookUp("max(emp_id)", "employees", "", $employees_record->{ds});

   	#Insert New links
	foreach $ProjectID (@ProjectList){
	  if($ProjectID>0){
	     $EmpProjectConn->query("INSERT INTO projects_employees(project_id, emp_id) VALUES (".$EmpProjectConn->ToSQL($ProjectID,$ccsInteger).",".$EmpProjectConn->ToSQL($GetLastInsKey,$ccsInteger).")");
      }
    }
  }  	 
  if($EmpID >0){
    if( ($Actions eq "Delete") || ($Actions eq "Update")) {
	   #Delete project employees links
	   $EmpProjectConn->query("DELETE FROM projects_employees WHERE emp_id=".$EmpProjectConn->ToSQL($EmpID,$ccsInteger));
    } 
    if($Actions eq "Update"){
       
	   #Insert assigned employees
       foreach $ProjectID (@ProjectList){
         if($ProjectID>0){
            $EmpProjectConn->query("INSERT INTO projects_employees (project_id, emp_id) VALUES (".$EmpProjectConn->ToSQL($ProjectID,$ccsInteger).",".$EmpProjectConn->ToSQL($EmpID,$ccsInteger).")");
         }
       }
    }
  }

  #Close and destroy the database EmpProjectConnection object
  $EmpProjectConn->{sth} = undef;
  
}


1;
