//Using Statements @1-DE739340
using System;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Specialized;
using System.Data;
using CCSExample_CSharp;
using CCSExample_CSharp.Data;
using CCSExample_CSharp.Controls;
using CCSExample_CSharp.Configuration;

namespace CCSExample_CSharp.ManyToManyListboxes.ManyToManyListboxes
{
//End Using Statements

//Page Data Class @1-F1F2C6B1
public class PageItem
{
    public NameValueCollection errors=new NameValueCollection();
    public PageItem()
    {
    }
    public static PageItem CreateFromHttpRequest()
    {
        PageItem item = new PageItem();
        item.Link1.SetValue(DBUtility.GetInitialValue("Link1"));
        return item;
    }

    public FieldBase this[string fieldName]{
        get{
            switch(fieldName){
                case "Link1":
                    return this.Link1;
                default:
                    throw (new ArgumentOutOfRangeException());
            }
        }
        set{
            switch(fieldName){
                case "Link1":
                    this.Link1 = (TextField)value;
                    break;
                default:
                    throw (new ArgumentOutOfRangeException());
            }
        }
    }

    public TextField Link1 = new TextField("",null);
    public object Link1Href;
    public LinkParameterCollection Link1HrefParameters = new LinkParameterCollection();
}
//End Page Data Class

//Page Data Provider Class @1-50FE4D41
public class PageDataProvider
{
//End Page Data Provider Class

//Page Data Provider Class Constructor @1-9A44B219
    public PageDataProvider()
    {
    }
//End Page Data Provider Class Constructor

//Page Data Provider Class GetResultSet Method @1-052161C6
    public void FillItem(PageItem item)
    {
//End Page Data Provider Class GetResultSet Method

//Page Data Provider Class GetResultSet Method tail @1-FCB6E20C
    }
//End Page Data Provider Class GetResultSet Method tail

//Page Data Provider Tail @1-FCB6E20C
}
//End Page Data Provider Tail

//Grid employees Item Class @3-D942FFF2
public class employeesItem
{
    public NameValueCollection errors=new NameValueCollection();
    public employeesItem()
    {
    }

    public FieldBase this[string fieldName]{
        get{
            switch(fieldName){
                case "emp_id":
                    return this.emp_id;
                case "emp_name":
                    return this.emp_name;
                case "Link1":
                    return this.Link1;
                default:
                    throw (new ArgumentOutOfRangeException());
            }
        }
        set{
            switch(fieldName){
                case "emp_id":
                    this.emp_id = (TextField)value;
                    break;
                case "emp_name":
                    this.emp_name = (TextField)value;
                    break;
                case "Link1":
                    this.Link1 = (TextField)value;
                    break;
                default:
                    throw (new ArgumentOutOfRangeException());
            }
        }
    }

    public TextField emp_id=new TextField("", null);
    public TextField emp_name = new TextField("",null);
    public object emp_nameHref;
    public LinkParameterCollection emp_nameHrefParameters = new LinkParameterCollection();
    public TextField Link1 = new TextField("",null);
    public object Link1Href;
    public LinkParameterCollection Link1HrefParameters = new LinkParameterCollection();
}
//End Grid employees Item Class

//Grid employees Data Provider Class Header @3-144E2004
public class employeesDataProvider:GridDataProviderBase
{
//End Grid employees Data Provider Class Header

//Grid employees Data Provider Class Variables @3-7C9B5194
    public enum SortFields {Default,Sorter_department_name,Sorter_emp_name}
    private string[] SortFieldsNames=new string[]{"emp_name","emp_id","emp_name"};
    private string[] SortFieldsNamesDesc=new string[]{"emp_name","emp_id DESC","emp_name DESC"};
    public SortFields SortField=SortFields.Default;
    public SortDirections SortDir=SortDirections.Asc;
    public int RecordsPerPage=15;
    public int PageNumber=1;
//End Grid employees Data Provider Class Variables

//Grid employees Data Provider Class Constructor @3-1099AF0C
    public employeesDataProvider()
    {
        Select=new TableCommand("SELECT *  " + 
          "FROM employees",new string[]{},Settings.IntranetDBDataAccessObject);
        Count=new TableCommand("SELECT COUNT(*)  " + 
          "FROM employees",new string[]{},Settings.IntranetDBDataAccessObject);
    }
//End Grid employees Data Provider Class Constructor

//Grid employees Data Provider Class GetResultSet Method @3-33DD9B3D
    public employeesItem[] GetResultSet(out int PagesCount)
    {
//End Grid employees Data Provider Class GetResultSet Method

//Before build Select @3-EB281404
        Parameters.Clear();
        Select.OrderBy=(SortDir==SortDirections.Asc?SortFieldsNames[(int)SortField]:SortFieldsNamesDesc[(int)SortField]).Trim();
//End Before build Select

//Execute Select @3-E684A2A4
        DataSet ds=null;Exception E=null;
        PagesCount=0;
        try{
            if(RecordsPerPage>0)
            {
                ds=ExecuteSelect((PageNumber-1)*RecordsPerPage,RecordsPerPage);
                PagesCount = ExecuteCount();
                mRecordCount = PagesCount;
                PagesCount = PagesCount%RecordsPerPage>0?(int)(PagesCount/RecordsPerPage)+1:(int)(PagesCount/RecordsPerPage);
            }
            else
            {
            ds=ExecuteSelect();
            if(ds.Tables[0].Rows.Count!=0)PagesCount=1;
            }
        }catch(Exception e){
            E=e;}
        finally{
//End Execute Select

//After execute Select @3-26794871
        if(E!=null) throw(E);
        }
        DataRowCollection dr=ds.Tables[0].Rows;
        employeesItem[] result=new employeesItem[dr.Count];
//End After execute Select

//After execute Select tail @3-FCDDA9E8
        for(int i=0;i<dr.Count;i++)
        {
            employeesItem item=new employeesItem();
            item.emp_id.SetValue(dr[i]["emp_id"],"");
            item.emp_name.SetValue(dr[i]["emp_name"],"");
            item.emp_nameHrefParameters.Add("emp_id",System.Web.HttpUtility.UrlEncode(dr[i]["emp_id"].ToString()));
            result[i]=item;
        }
        return result; 
    }
//End After execute Select tail

//Grid Data Provider tail @3-FCB6E20C
}
//End Grid Data Provider tail

//Record employees_record Item Class @14-5FC49E4F
public class employees_recordItem
{
    private bool _isNew = true;
    private bool _isDeleted = false;
    public NameValueCollection errors=new NameValueCollection();
    public employees_recordItem()
    {
    }
    public TextField emp_name=new TextField("", null);
    public IntegerField AvailableListBox = new IntegerField("", null);
    public ItemCollection AvailableListBoxItems = new ItemCollection();
    public IntegerField LinkedListBox = new IntegerField("", null);
    public ItemCollection LinkedListBoxItems = new ItemCollection();
    public TextField LinkedID=new TextField("", null);

    public static employees_recordItem CreateFromHttpRequest()
    {
        employees_recordItem item = new employees_recordItem();
        if(DBUtility.GetInitialValue("emp_name") != null){
        item.emp_name.SetValue(DBUtility.GetInitialValue("emp_name"));
        }
        if(DBUtility.GetInitialValue("AvailableListBox") != null){
        item.AvailableListBox.SetValue(DBUtility.GetInitialValue("AvailableListBox"));
        }
        if(DBUtility.GetInitialValue("RightButton") != null){
        }
        if(DBUtility.GetInitialValue("LeftButton") != null){
        }
        if(DBUtility.GetInitialValue("LinkedListBox") != null){
        item.LinkedListBox.SetValue(DBUtility.GetInitialValue("LinkedListBox"));
        }
        if(DBUtility.GetInitialValue("LinkedID") != null){
        item.LinkedID.SetValue(DBUtility.GetInitialValue("LinkedID"));
        }
        if(DBUtility.GetInitialValue("Insert1") != null){
        }
        if(DBUtility.GetInitialValue("Update1") != null){
        }
        if(DBUtility.GetInitialValue("Delete1") != null){
        }
        if(DBUtility.GetInitialValue("Cancel") != null){
        }
        return item;
    }

    public FieldBase this[string fieldName]{
        get{
            switch(fieldName){
                case "emp_name":
                    return this.emp_name;
                case "AvailableListBox":
                    return this.AvailableListBox;
                case "LinkedListBox":
                    return this.LinkedListBox;
                case "LinkedID":
                    return this.LinkedID;
                default:
                    throw (new ArgumentOutOfRangeException());
            }
        }
        set{
            switch(fieldName){
                case "emp_name":
                    this.emp_name = (TextField)value;
                    break;
                case "AvailableListBox":
                    this.AvailableListBox = (IntegerField)value;
                    break;
                case "LinkedListBox":
                    this.LinkedListBox = (IntegerField)value;
                    break;
                case "LinkedID":
                    this.LinkedID = (TextField)value;
                    break;
                default:
                    throw (new ArgumentOutOfRangeException());
            }
        }
    }

    public bool IsNew{
        get{
            return _isNew;
        }
        set{
            _isNew = value;
        }
    }

    public bool IsDeleted{
        get{
            return _isDeleted;
        }
        set{
            _isDeleted = value;
        }
    }

    public void Validate(employees_recordDataProvider provider)
    {
//End Record employees_record Item Class

//emp_name validate @20-3E258E98
        if(emp_name.Value==null||emp_name.Value.ToString()=="")
            errors.Add("emp_name","The value in field Name is required.");
//End emp_name validate

//Record employees_record Item Class tail @14-F5FC18C5
    }
}
//End Record employees_record Item Class tail

//Record employees_record Data Provider Class @14-68D02F91
public class employees_recordDataProvider:RecordDataProviderBase
{
//End Record employees_record Data Provider Class

//Record employees_record Data Provider Class Variables @14-45BB65F7
    protected DataCommand AvailableListBoxDataCommand=new TableCommand("SELECT *  " + 
          "FROM projects",new string[]{},Settings.IntranetDBDataAccessObject);
    protected DataCommand LinkedListBoxDataCommand=new TableCommand("SELECT projects.project_id AS projects_project_id, project_name, projects_employees.*  " + 
          "FROM projects_employees INNER JOIN projects ON projects_employees.project_id = projects.project_id",new string[]{"emp_id61"},Settings.IntranetDBDataAccessObject);
    public IntegerParameter Urlemp_id;
//End Record employees_record Data Provider Class Variables

//Record employees_record Data Provider Class Constructor @14-074514EC
    public employees_recordDataProvider()
    {
        Select=new TableCommand("SELECT *  " + 
          "FROM employees",new string[]{"emp_id19"},Settings.IntranetDBDataAccessObject);
        Insert=new TableCommand("INSERT INTO employees(emp_name ) VALUES ( {emp_name})"
        ,new string[0],Settings.IntranetDBDataAccessObject);
        Update=new TableCommand("UPDATE employees SET emp_name={emp_name}"
        ,new string[]{"emp_id19"},Settings.IntranetDBDataAccessObject);
        Delete=new TableCommand("DELETE FROM employees",new string[]{"emp_id19"},Settings.IntranetDBDataAccessObject);
    }
//End Record employees_record Data Provider Class Constructor

//Record employees_record Data Provider Class LoadParams Method @14-05474DF4
    protected bool LoadParams()
    {
        CommonParameters.Clear();
        CommonParameters.Add("emp_id19",Urlemp_id==null?"":("emp_id = " + Select.Dao.ToSql(Urlemp_id.GetFormattedValue(""),FieldType.Integer)));
        return !(Urlemp_id!=null);
    }
//End Record employees_record Data Provider Class LoadParams Method

//Record employees_record Data Provider Class CheckUnique Method @14-238A0D86
    public bool CheckUnique(string ControlName,employees_recordItem item)
    {
        return true;
    }
//End Record employees_record Data Provider Class CheckUnique Method

//Record employees_record Data Provider Class PrepareInsert Method @14-E2788B74
    override protected void PrepareInsert()
    {
//End Record employees_record Data Provider Class PrepareInsert Method

//Record employees_record Data Provider Class PrepareInsert Method tail @14-FCB6E20C
    }
//End Record employees_record Data Provider Class PrepareInsert Method tail

//Record employees_record Data Provider Class Insert Method @14-958E7687
    public int InsertItem(employees_recordItem item)
    {
//End Record employees_record Data Provider Class Insert Method

//Record employees_record Build insert @14-0DDEDF83
        Insert.SqlQuery.Replace("{emp_name}",Insert.Dao.ToSql(item.emp_name.GetFormattedValue(""),FieldType.Text));
        object result=null;Exception E=null;
        try{
            result=ExecuteInsert();
        }catch(Exception e){
            E=e;}
        finally{
//End Record employees_record Build insert

//Record employees_record AfterExecuteInsert @14-33B45808
            if(E!=null) throw(E);
        }
        return (int)result;
    }
//End Record employees_record AfterExecuteInsert

//Record employees_record Data Provider Class PrepareUpdate Method @14-7A788766
    override protected void PrepareUpdate()
    {
        LoadParams();
        Update.Parameters=CommonParameters;
//End Record employees_record Data Provider Class PrepareUpdate Method

//Record employees_record Data Provider Class PrepareUpdate Method tail @14-FCB6E20C
    }
//End Record employees_record Data Provider Class PrepareUpdate Method tail

//Record employees_record Data Provider Class Update Method @14-99709134
    public int UpdateItem(employees_recordItem item)
    {
//End Record employees_record Data Provider Class Update Method

//Record employees_record BeforeBuildUpdate @14-8491230C
        Update.SqlQuery.Replace("{emp_name}",Update.Dao.ToSql(item.emp_name.GetFormattedValue(""),FieldType.Text));
        object result=null;Exception E=null;
        try{
            result=ExecuteUpdate();
        }catch(Exception e){
            E=e;}
        finally{
//End Record employees_record BeforeBuildUpdate

//Record employees_record AfterExecuteUpdate @14-33B45808
            if(E!=null) throw(E);
        }
        return (int)result;
    }
//End Record employees_record AfterExecuteUpdate

//Record employees_record Data Provider Class PrepareDelete Method @14-9923EE9D
    override protected void PrepareDelete()
    {
        LoadParams();
        Delete.Parameters=CommonParameters;
//End Record employees_record Data Provider Class PrepareDelete Method

//Record employees_record Data Provider Class PrepareDelete Method tail @14-FCB6E20C
    }
//End Record employees_record Data Provider Class PrepareDelete Method tail

//Record employees_record Data Provider Class Delete Method @14-F69D1A58
    public int DeleteItem()
    {
//End Record employees_record Data Provider Class Delete Method

//Record employees_record BeforeBuildDelete @14-C970B5CF
        object result=null;Exception E=null;
        try{
            result=ExecuteDelete();
        }catch(Exception e){
            E=e;}
        finally{
//End Record employees_record BeforeBuildDelete

//Record employees_record BeforeBuildDelete @14-33B45808
            if(E!=null) throw(E);
        }
        return (int)result;
    }
//End Record employees_record BeforeBuildDelete

//PrepareSelect Method @14-32F2D8AA
    override protected void PrepareSelect()
    {
        LoadParams();
        Select.Parameters=CommonParameters;
    }
//End PrepareSelect Method

//Record employees_record Data Provider Class GetResultSet Method @14-7F772655
    public void FillItem(employees_recordItem item, ref bool IsInsertMode)
    {
        bool ReadNotAllowed=IsInsertMode;
        Exception E=null;
//End Record employees_record Data Provider Class GetResultSet Method

//Record employees_record BeforeBuildSelect @14-0CD0BD3D
        IsInsertMode=LoadParams();
        DataRowCollection dr=null;
        if(!IsInsertMode){
//End Record employees_record BeforeBuildSelect

//Record employees_record BeforeExecuteSelect @14-94ACF54A
            try{
                dr=ExecuteSelect().Tables[0].Rows;
            }catch(Exception e){
                E=e;}
            finally{
//End Record employees_record BeforeExecuteSelect

//Record employees_record AfterExecuteSelect @14-948E3573
                if(E!=null) throw(E);
            }
        }
        if(!IsInsertMode && !ReadNotAllowed && dr.Count!=0)
        {
            int i=0;
            item.emp_name.SetValue(dr[i]["emp_name"],"");
        }
        else
            IsInsertMode=true;
        DataRowCollection ListBoxSource=null;
//End Record employees_record AfterExecuteSelect

//ListBox AvailableListBox Event BeforeBuildSelect. Action Custom Code @52-2A29BDB7

	string LinkedProject = "";
	System.Web.HttpRequest Req = System.Web.HttpContext.Current.Request;


	//Populate multi-selectable project ListBox list
	if(Req.QueryString["emp_id"]!=null && Req.QueryString["emp_id"] != ""){

 		SqlCommand Select;
		
     	Select = new SqlCommand("SELECT project_id FROM projects_employees WHERE emp_id =" + Req.QueryString["emp_id"].ToString(),
              Settings.IntranetDBDataAccessObject);
		
    	DataRowCollection ProjID = Select.Execute().Tables[0].Rows;
     	if(!IsInsertMode){

		    for(int i=0; i < ProjID.Count; i++){
				
				if(LinkedProject!="") LinkedProject+= ",";
     			LinkedProject = LinkedProject + ProjID[i]["project_id"].ToString();
				
				
			}
						   
			//Modify AvailableListBox DataSource
			if(LinkedProject!=""){

				((TableCommand)AvailableListBoxDataCommand).Where = "project_id NOT IN (" + LinkedProject + ")";
				((TableCommand)AvailableListBoxDataCommand).Operation = "AND";
			}

		}
       
     } 	
 
//End ListBox AvailableListBox Event BeforeBuildSelect. Action Custom Code

//ListBox AvailableListBox BeforeExecuteSelect @46-F519062B
        try{
            ListBoxSource=AvailableListBoxDataCommand.Execute().Tables[0].Rows;
        }catch(Exception e){
            E=e;}
        finally{
//End ListBox AvailableListBox BeforeExecuteSelect

//ListBox AvailableListBox AfterExecuteSelect @46-D4EA0619
            if(E!=null) throw(E);
        }
        for(int i=0;i<ListBoxSource.Count;i++){
            object val = ListBoxSource[i]["project_name"];
            string key = (new IntegerField("", ListBoxSource[i]["project_id"])).GetFormattedValue("");
            item.AvailableListBoxItems.Add(key,val);
        }
//End ListBox AvailableListBox AfterExecuteSelect

//ListBox LinkedListBox Initialize Data Source @44-D51262E3
        LinkedListBoxDataCommand.Parameters.Add("emp_id61",Urlemp_id==null?"":("emp_id = " + LinkedListBoxDataCommand.Dao.ToSql(Urlemp_id.GetFormattedValue(""),FieldType.Integer)));
//End ListBox LinkedListBox Initialize Data Source

//ListBox LinkedListBox BeforeExecuteSelect @44-AB29437D
        try{
            ListBoxSource=LinkedListBoxDataCommand.Execute().Tables[0].Rows;
        }catch(Exception e){
            E=e;}
        finally{
//End ListBox LinkedListBox BeforeExecuteSelect

//ListBox LinkedListBox AfterExecuteSelect @44-959CB3B0
            if(E!=null) throw(E);
        }
        for(int i=0;i<ListBoxSource.Count;i++){
            object val = ListBoxSource[i]["project_name"];
            string key = (new IntegerField("", ListBoxSource[i]["project_id"])).GetFormattedValue("");
            item.LinkedListBoxItems.Add(key,val);
        }
//End ListBox LinkedListBox AfterExecuteSelect

//Record employees_record AfterExecuteSelect tail @14-FCB6E20C
    }
//End Record employees_record AfterExecuteSelect tail

//Record employees_record Data Provider Class @14-FCB6E20C
}

//End Record employees_record Data Provider Class

//Page Data Provider Tail @1-FCB6E20C
}
//End Page Data Provider Tail

