//Using Statements @1-65A06A91
using System;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Specialized;
using System.Data;
using CCSExample_CSharp;
using CCSExample_CSharp.Data;
using CCSExample_CSharp.Controls;
using CCSExample_CSharp.Configuration;

namespace CCSExample_CSharp.MasterDetail.MasterDetail
{
//End Using Statements

//Page Data Class @1-F1F2C6B1
public class PageItem
{
    public NameValueCollection errors=new NameValueCollection();
    public PageItem()
    {
    }
    public static PageItem CreateFromHttpRequest()
    {
        PageItem item = new PageItem();
        item.Link1.SetValue(DBUtility.GetInitialValue("Link1"));
        return item;
    }

    public FieldBase this[string fieldName]{
        get{
            switch(fieldName){
                case "Link1":
                    return this.Link1;
                default:
                    throw (new ArgumentOutOfRangeException());
            }
        }
        set{
            switch(fieldName){
                case "Link1":
                    this.Link1 = (TextField)value;
                    break;
                default:
                    throw (new ArgumentOutOfRangeException());
            }
        }
    }

    public TextField Link1 = new TextField("",null);
    public object Link1Href;
    public LinkParameterCollection Link1HrefParameters = new LinkParameterCollection();
}
//End Page Data Class

//Page Data Provider Class @1-50FE4D41
public class PageDataProvider
{
//End Page Data Provider Class

//Page Data Provider Class Constructor @1-9A44B219
    public PageDataProvider()
    {
    }
//End Page Data Provider Class Constructor

//Page Data Provider Class GetResultSet Method @1-052161C6
    public void FillItem(PageItem item)
    {
//End Page Data Provider Class GetResultSet Method

//Page Data Provider Class GetResultSet Method tail @1-FCB6E20C
    }
//End Page Data Provider Class GetResultSet Method tail

//Page Data Provider Tail @1-FCB6E20C
}
//End Page Data Provider Tail

//Grid employees_grid Item Class @23-8D58706A
public class employees_gridItem
{
    public NameValueCollection errors=new NameValueCollection();
    public employees_gridItem()
    {
    }

    public FieldBase this[string fieldName]{
        get{
            switch(fieldName){
                case "emp_id":
                    return this.emp_id;
                case "emp_name":
                    return this.emp_name;
                case "Link1":
                    return this.Link1;
                default:
                    throw (new ArgumentOutOfRangeException());
            }
        }
        set{
            switch(fieldName){
                case "emp_id":
                    this.emp_id = (TextField)value;
                    break;
                case "emp_name":
                    this.emp_name = (TextField)value;
                    break;
                case "Link1":
                    this.Link1 = (TextField)value;
                    break;
                default:
                    throw (new ArgumentOutOfRangeException());
            }
        }
    }

    public TextField emp_id=new TextField("", null);
    public TextField emp_name = new TextField("",null);
    public object emp_nameHref;
    public LinkParameterCollection emp_nameHrefParameters = new LinkParameterCollection();
    public TextField Link1 = new TextField("",null);
    public object Link1Href;
    public LinkParameterCollection Link1HrefParameters = new LinkParameterCollection();
}
//End Grid employees_grid Item Class

//Grid employees_grid Data Provider Class Header @23-745EA65C
public class employees_gridDataProvider:GridDataProviderBase
{
//End Grid employees_grid Data Provider Class Header

//Grid employees_grid Data Provider Class Variables @23-136D59A3
    public enum SortFields {Default}
    private string[] SortFieldsNames=new string[]{"emp_name"};
    private string[] SortFieldsNamesDesc=new string[]{"emp_name"};
    public SortFields SortField=SortFields.Default;
    public SortDirections SortDir=SortDirections.Asc;
    public int RecordsPerPage=10;
    public int PageNumber=1;
//End Grid employees_grid Data Provider Class Variables

//Grid employees_grid Data Provider Class Constructor @23-3E16AB9A
    public employees_gridDataProvider()
    {
        Select=new TableCommand("SELECT *  " + 
          "FROM employees",new string[]{},Settings.IntranetDBDataAccessObject);
        Count=new TableCommand("SELECT COUNT(*)  " + 
          "FROM employees",new string[]{},Settings.IntranetDBDataAccessObject);
    }
//End Grid employees_grid Data Provider Class Constructor

//Grid employees_grid Data Provider Class GetResultSet Method @23-E716EA01
    public employees_gridItem[] GetResultSet(out int PagesCount)
    {
//End Grid employees_grid Data Provider Class GetResultSet Method

//Before build Select @23-EB281404
        Parameters.Clear();
        Select.OrderBy=(SortDir==SortDirections.Asc?SortFieldsNames[(int)SortField]:SortFieldsNamesDesc[(int)SortField]).Trim();
//End Before build Select

//Execute Select @23-E684A2A4
        DataSet ds=null;Exception E=null;
        PagesCount=0;
        try{
            if(RecordsPerPage>0)
            {
                ds=ExecuteSelect((PageNumber-1)*RecordsPerPage,RecordsPerPage);
                PagesCount = ExecuteCount();
                mRecordCount = PagesCount;
                PagesCount = PagesCount%RecordsPerPage>0?(int)(PagesCount/RecordsPerPage)+1:(int)(PagesCount/RecordsPerPage);
            }
            else
            {
            ds=ExecuteSelect();
            if(ds.Tables[0].Rows.Count!=0)PagesCount=1;
            }
        }catch(Exception e){
            E=e;}
        finally{
//End Execute Select

//After execute Select @23-14D84E77
        if(E!=null) throw(E);
        }
        DataRowCollection dr=ds.Tables[0].Rows;
        employees_gridItem[] result=new employees_gridItem[dr.Count];
//End After execute Select

//After execute Select tail @23-6E2AC749
        for(int i=0;i<dr.Count;i++)
        {
            employees_gridItem item=new employees_gridItem();
            item.emp_id.SetValue(dr[i]["emp_id"],"");
            item.emp_name.SetValue(dr[i]["emp_name"],"");
            item.emp_nameHrefParameters.Add("emp_id",System.Web.HttpUtility.UrlEncode(dr[i]["emp_id"].ToString()));
            result[i]=item;
        }
        return result; 
    }
//End After execute Select tail

//Grid Data Provider tail @23-FCB6E20C
}
//End Grid Data Provider tail

//Record employees_record Item Class @2-2C792378
public class employees_recordItem
{
    private bool _isNew = true;
    private bool _isDeleted = false;
    public NameValueCollection errors=new NameValueCollection();
    public employees_recordItem()
    {
    }
    public TextField emp_name=new TextField("", null);
    public TextField title=new TextField("", null);
    public IntegerField department_id = new IntegerField("", null);
    public ItemCollection department_idItems = new ItemCollection();

    public static employees_recordItem CreateFromHttpRequest()
    {
        employees_recordItem item = new employees_recordItem();
        if(DBUtility.GetInitialValue("emp_name") != null){
        item.emp_name.SetValue(DBUtility.GetInitialValue("emp_name"));
        }
        if(DBUtility.GetInitialValue("title") != null){
        item.title.SetValue(DBUtility.GetInitialValue("title"));
        }
        if(DBUtility.GetInitialValue("department_id") != null){
        item.department_id.SetValue(DBUtility.GetInitialValue("department_id"));
        }
        if(DBUtility.GetInitialValue("Button_Insert") != null){
        }
        if(DBUtility.GetInitialValue("Button_Update") != null){
        }
        if(DBUtility.GetInitialValue("Button_Delete") != null){
        }
        if(DBUtility.GetInitialValue("Button_Cancel") != null){
        }
        return item;
    }

    public FieldBase this[string fieldName]{
        get{
            switch(fieldName){
                case "emp_name":
                    return this.emp_name;
                case "title":
                    return this.title;
                case "department_id":
                    return this.department_id;
                default:
                    throw (new ArgumentOutOfRangeException());
            }
        }
        set{
            switch(fieldName){
                case "emp_name":
                    this.emp_name = (TextField)value;
                    break;
                case "title":
                    this.title = (TextField)value;
                    break;
                case "department_id":
                    this.department_id = (IntegerField)value;
                    break;
                default:
                    throw (new ArgumentOutOfRangeException());
            }
        }
    }

    public bool IsNew{
        get{
            return _isNew;
        }
        set{
            _isNew = value;
        }
    }

    public bool IsDeleted{
        get{
            return _isDeleted;
        }
        set{
            _isDeleted = value;
        }
    }

    public void Validate(employees_recordDataProvider provider)
    {
//End Record employees_record Item Class

//emp_name validate @8-03604583
        if(emp_name.Value==null||emp_name.Value.ToString()=="")
            errors.Add("emp_name","The value in field Emp Name is required.");
//End emp_name validate

//Record employees_record Item Class tail @2-F5FC18C5
    }
}
//End Record employees_record Item Class tail

//Record employees_record Data Provider Class @2-68D02F91
public class employees_recordDataProvider:RecordDataProviderBase
{
//End Record employees_record Data Provider Class

//Record employees_record Data Provider Class Variables @2-A844EFCB
    protected DataCommand department_idDataCommand=new TableCommand("SELECT *  " + 
          "FROM departments",new string[]{},Settings.IntranetDBDataAccessObject);
    public IntegerParameter Urlemp_id;
//End Record employees_record Data Provider Class Variables

//Record employees_record Data Provider Class Constructor @2-0DD17DA7
    public employees_recordDataProvider()
    {
        Select=new TableCommand("SELECT *  " + 
          "FROM employees",new string[]{"emp_id7"},Settings.IntranetDBDataAccessObject);
        Insert=new TableCommand("INSERT INTO employees(emp_name, title, department_id ) VALUES ( {emp_name}, {title}, {department_id})"
        ,new string[0],Settings.IntranetDBDataAccessObject);
        Update=new TableCommand("UPDATE employees SET emp_name={emp_name}, title={title}, department_id={department_id}"
        ,new string[]{"emp_id7"},Settings.IntranetDBDataAccessObject);
        Delete=new TableCommand("DELETE FROM employees",new string[]{"emp_id7"},Settings.IntranetDBDataAccessObject);
    }
//End Record employees_record Data Provider Class Constructor

//Record employees_record Data Provider Class LoadParams Method @2-E83F9265
    protected bool LoadParams()
    {
        CommonParameters.Clear();
        CommonParameters.Add("emp_id7",Urlemp_id==null?"":("emp_id = " + Select.Dao.ToSql(Urlemp_id.GetFormattedValue(""),FieldType.Integer)));
        return !(Urlemp_id!=null);
    }
//End Record employees_record Data Provider Class LoadParams Method

//Record employees_record Data Provider Class CheckUnique Method @2-238A0D86
    public bool CheckUnique(string ControlName,employees_recordItem item)
    {
        return true;
    }
//End Record employees_record Data Provider Class CheckUnique Method

//Record employees_record Data Provider Class PrepareInsert Method @2-E2788B74
    override protected void PrepareInsert()
    {
//End Record employees_record Data Provider Class PrepareInsert Method

//Record employees_record Data Provider Class PrepareInsert Method tail @2-FCB6E20C
    }
//End Record employees_record Data Provider Class PrepareInsert Method tail

//Record employees_record Data Provider Class Insert Method @2-958E7687
    public int InsertItem(employees_recordItem item)
    {
//End Record employees_record Data Provider Class Insert Method

//Record employees_record Build insert @2-A950963F
        Insert.SqlQuery.Replace("{emp_name}",Insert.Dao.ToSql(item.emp_name.GetFormattedValue(""),FieldType.Text));
        Insert.SqlQuery.Replace("{title}",Insert.Dao.ToSql(item.title.GetFormattedValue(""),FieldType.Text));
        Insert.SqlQuery.Replace("{department_id}",Insert.Dao.ToSql(item.department_id.GetFormattedValue(""),FieldType.Integer));
        object result=null;Exception E=null;
        try{
            result=ExecuteInsert();
        }catch(Exception e){
            E=e;}
        finally{
//End Record employees_record Build insert

//Record employees_record AfterExecuteInsert @2-33B45808
            if(E!=null) throw(E);
        }
        return (int)result;
    }
//End Record employees_record AfterExecuteInsert

//Record employees_record Data Provider Class PrepareUpdate Method @2-7A788766
    override protected void PrepareUpdate()
    {
        LoadParams();
        Update.Parameters=CommonParameters;
//End Record employees_record Data Provider Class PrepareUpdate Method

//Record employees_record Data Provider Class PrepareUpdate Method tail @2-FCB6E20C
    }
//End Record employees_record Data Provider Class PrepareUpdate Method tail

//Record employees_record Data Provider Class Update Method @2-99709134
    public int UpdateItem(employees_recordItem item)
    {
//End Record employees_record Data Provider Class Update Method

//Record employees_record BeforeBuildUpdate @2-C6AC05B7
        Update.SqlQuery.Replace("{emp_name}",Update.Dao.ToSql(item.emp_name.GetFormattedValue(""),FieldType.Text));
        Update.SqlQuery.Replace("{title}",Update.Dao.ToSql(item.title.GetFormattedValue(""),FieldType.Text));
        Update.SqlQuery.Replace("{department_id}",Update.Dao.ToSql(item.department_id.GetFormattedValue(""),FieldType.Integer));
        object result=null;Exception E=null;
        try{
            result=ExecuteUpdate();
        }catch(Exception e){
            E=e;}
        finally{
//End Record employees_record BeforeBuildUpdate

//Record employees_record AfterExecuteUpdate @2-33B45808
            if(E!=null) throw(E);
        }
        return (int)result;
    }
//End Record employees_record AfterExecuteUpdate

//Record employees_record Data Provider Class PrepareDelete Method @2-9923EE9D
    override protected void PrepareDelete()
    {
        LoadParams();
        Delete.Parameters=CommonParameters;
//End Record employees_record Data Provider Class PrepareDelete Method

//Record employees_record Data Provider Class PrepareDelete Method tail @2-FCB6E20C
    }
//End Record employees_record Data Provider Class PrepareDelete Method tail

//Record employees_record Data Provider Class Delete Method @2-F69D1A58
    public int DeleteItem()
    {
//End Record employees_record Data Provider Class Delete Method

//Record employees_record BeforeBuildDelete @2-C970B5CF
        object result=null;Exception E=null;
        try{
            result=ExecuteDelete();
        }catch(Exception e){
            E=e;}
        finally{
//End Record employees_record BeforeBuildDelete

//Record employees_record BeforeBuildDelete @2-33B45808
            if(E!=null) throw(E);
        }
        return (int)result;
    }
//End Record employees_record BeforeBuildDelete

//PrepareSelect Method @2-32F2D8AA
    override protected void PrepareSelect()
    {
        LoadParams();
        Select.Parameters=CommonParameters;
    }
//End PrepareSelect Method

//Record employees_record Data Provider Class GetResultSet Method @2-7F772655
    public void FillItem(employees_recordItem item, ref bool IsInsertMode)
    {
        bool ReadNotAllowed=IsInsertMode;
        Exception E=null;
//End Record employees_record Data Provider Class GetResultSet Method

//Record employees_record BeforeBuildSelect @2-0CD0BD3D
        IsInsertMode=LoadParams();
        DataRowCollection dr=null;
        if(!IsInsertMode){
//End Record employees_record BeforeBuildSelect

//Record employees_record BeforeExecuteSelect @2-94ACF54A
            try{
                dr=ExecuteSelect().Tables[0].Rows;
            }catch(Exception e){
                E=e;}
            finally{
//End Record employees_record BeforeExecuteSelect

//Record employees_record AfterExecuteSelect @2-F670BDF8
                if(E!=null) throw(E);
            }
        }
        if(!IsInsertMode && !ReadNotAllowed && dr.Count!=0)
        {
            int i=0;
            item.emp_name.SetValue(dr[i]["emp_name"],"");
            item.title.SetValue(dr[i]["title"],"");
            item.department_id.SetValue(dr[i]["department_id"],"");
        }
        else
            IsInsertMode=true;
        DataRowCollection ListBoxSource=null;
//End Record employees_record AfterExecuteSelect

//ListBox department_id BeforeExecuteSelect @11-37A0FD27
        try{
            ListBoxSource=department_idDataCommand.Execute().Tables[0].Rows;
        }catch(Exception e){
            E=e;}
        finally{
//End ListBox department_id BeforeExecuteSelect

//ListBox department_id AfterExecuteSelect @11-E89E02E4
            if(E!=null) throw(E);
        }
        for(int i=0;i<ListBoxSource.Count;i++){
            object val = ListBoxSource[i]["department_name"];
            string key = (new IntegerField("", ListBoxSource[i]["department_id"])).GetFormattedValue("");
            item.department_idItems.Add(key,val);
        }
//End ListBox department_id AfterExecuteSelect

//Record employees_record AfterExecuteSelect tail @2-FCB6E20C
    }
//End Record employees_record AfterExecuteSelect tail

//Record employees_record Data Provider Class @2-FCB6E20C
}

//End Record employees_record Data Provider Class

//EditableGrid projects_employees Item Class @31-85DDC846
public class projects_employeesItem
{
    public NameValueCollection errors=new NameValueCollection();
    public int RowId;
    public projects_employeesItem()
    {
    }

    public FieldBase this[string fieldName]{
        get{
            switch(fieldName){
                case "project_idField":
                    return this.project_idField;
                case "emp_idField":
                    return this.emp_idField;
                case "emp_id":
                    return this.emp_id;
                case "project_id":
                    return this.project_id;
                case "percent_allocation":
                    return this.percent_allocation;
                case "Delete1":
                    return this.Delete1;
                default:
                    throw (new ArgumentOutOfRangeException());
            }
        }
        set{
            switch(fieldName){
                case "project_idField":
                    this.project_idField = (IntegerField)value;
                    break;
                case "emp_idField":
                    this.emp_idField = (IntegerField)value;
                    break;
                case "emp_id":
                    this.emp_id = (IntegerField)value;
                    break;
                case "project_id":
                    this.project_id = (IntegerField)value;
                    break;
                case "percent_allocation":
                    this.percent_allocation = (IntegerField)value;
                    break;
                case "Delete1":
                    this.Delete1 = (BooleanField)value;
                    break;
                default:
                    throw (new ArgumentOutOfRangeException());
            }
        }
    }

    public bool IsNew{
        get{
            bool result = true;
            bool result1 = true;
            result = project_idField.Value == null && result;
            result = emp_idField.Value == null && result;
            result1 = emp_id.Value == null && result1;
            result1 = project_id.Value == null && result1;
            result1 = percent_allocation.Value == null && result1;
            result1 = Delete1.Value == null && result1;
            return result && !result1;
        }
    }

    public bool IsEmptyItem{
        get{
            bool result = true;
            result = emp_id.Value == null && result;
            result = project_id.Value == null && result;
            result = percent_allocation.Value == null && result;
            result = Delete1.Value == null && result;
            result = project_idField.Value == null && result;
            result = emp_idField.Value == null && result;
            return result;
        }
    }

    public bool IsDeleted = false;
    public bool IsUpdated = false;
    public IntegerField emp_id=new IntegerField("", null);
    public IntegerField project_id = new IntegerField("", null);
    public ItemCollection project_idItems = new ItemCollection();
    public IntegerField percent_allocation=new IntegerField("", null);
    public BooleanField Delete1=new BooleanField(Settings.BoolFormat, null);
    public BooleanField Delete1CheckedValue = new BooleanField(Settings.BoolFormat, true);
    public BooleanField Delete1UncheckedValue=new BooleanField(Settings.BoolFormat, false);

    public IntegerField project_idField=new IntegerField();
    public IntegerField emp_idField=new IntegerField();
	public bool Validate(projects_employeesDataProvider provider)

    {
        errors.Clear();
//End EditableGrid projects_employees Item Class

//project_id validate @32-58D2D4A1
        if(project_id.Value==null||project_id.Value.ToString()=="")
            errors.Add("project_id","The value in field project_id is required.");
//End project_id validate

//Control project_id Event OnValidate. Action Custom Code @44-2A29BDB7

//End Control project_id Event OnValidate. Action Custom Code

//EditableGrid projects_employees Item Class tail @31-2CA8EF5C
        return errors.Count == 0;
    }
}
//End EditableGrid projects_employees Item Class tail

//EditableGrid projects_employees Data Provider Class Header @31-30A171AB
public class projects_employeesDataProvider:EditableGridDataProviderBase
{
//End EditableGrid projects_employees Data Provider Class Header

//Grid projects_employees Data Provider Class Variables @31-FDA2B982
    public enum SortFields {Default}
    private string[] SortFieldsNames=new string[]{""};
    private string[] SortFieldsNamesDesc=new string[]{""};
    public SortFields SortField=SortFields.Default;
    public SortDirections SortDir=SortDirections.Asc;
    public int RecordsPerPage=20;
    public int PageNumber=1;
    public int EmptyRows = 3;
    public IntegerParameter Urlemp_id;
    protected DataCommand project_idDataCommand=new TableCommand("SELECT *  " + 
          "FROM projects",new string[]{},Settings.IntranetDBDataAccessObject);
//End Grid projects_employees Data Provider Class Variables

//Editable Grid projects_employees Data Provider Class Constructor @31-F401E32B
    public projects_employeesDataProvider()
    {
        Select=new TableCommand("SELECT *  " + 
          "FROM projects_employees",new string[]{"emp_id38"},Settings.IntranetDBDataAccessObject);
        Count=new TableCommand("SELECT COUNT(*)  " + 
          "FROM projects_employees",new string[]{"emp_id38"},Settings.IntranetDBDataAccessObject);
    }
//End Editable Grid projects_employees Data Provider Class Constructor

//Editable Grid projects_employees Data Provider Class CheckUnique Method @31-54D03BA9
    public bool CheckUnique(string ControlName,projects_employeesItem item)
    {
        return true;
    }
//End Editable Grid projects_employees Data Provider Class CheckUnique Method

//Editable Grid projects_employees Data Provider Class InsertItem Method @31-0D3FC62A
    protected int InsertItem(projects_employeesItem item)
    {
        DataCommand Insert=new TableCommand("INSERT INTO projects_employees(emp_id, project_id, percent_allocation ) VALUES ( {emp_id}, {project_id}, {percent_allocation})"
        ,new string[0],Settings.IntranetDBDataAccessObject);
//End Editable Grid projects_employees Data Provider Class InsertItem Method

//EditableGrid projects_employees Event BeforeBuildInsert. Action Custom Code @41-2A29BDB7

	//Update the hidden 'emp_id" field with the current employee id
	System.Web.HttpRequest Req = System.Web.HttpContext.Current.Request;
	if(Req.QueryString["emp_id"]!=null & Req.QueryString["emp_id"].Length >0){
		
		item.emp_id.SetValue(Req.QueryString["emp_id"],"");
  	}
    
//End EditableGrid projects_employees Event BeforeBuildInsert. Action Custom Code

//EditableGrid projects_employees Build insert @31-0956C54A
        Insert.SqlQuery.Replace("{emp_id}",Insert.Dao.ToSql(item.emp_id.GetFormattedValue(""),FieldType.Integer));
        Insert.SqlQuery.Replace("{project_id}",Insert.Dao.ToSql(item.project_id.GetFormattedValue(""),FieldType.Integer));
        Insert.SqlQuery.Replace("{percent_allocation}",Insert.Dao.ToSql(item.percent_allocation.GetFormattedValue(""),FieldType.Integer));
//End EditableGrid projects_employees Build insert

//EditableGrid projects_employees Data Provider Class ExecuteInsert @31-69BE52CC
        object result=null;
        try{
            result = Insert.ExecuteNonQuery();
        }catch(Exception e){
            item.errors.Add("DataProvider",e.Source + ":" + e.Message);
            result = 0;}
        finally{
//End EditableGrid projects_employees Data Provider Class ExecuteInsert

//EditableGrid projects_employees AfterExecuteInsert @31-16B7139B
        }
        return (int)result;
    }
//End EditableGrid projects_employees AfterExecuteInsert

//EditableGrid projects_employees Data Provider Class Update Method @31-F80F0C13
    protected int UpdateItem(projects_employeesItem item)
    {
        DataCommand Update=new TableCommand("UPDATE projects_employees SET emp_id={emp_id}, project_id={project_id}, percent_allocation={percent_allocation}"
        ,new string[]{"project_id36","And","emp_id37"},Settings.IntranetDBDataAccessObject);
//End EditableGrid projects_employees Data Provider Class Update Method

//EditableGrid projects_employees BeforeBuildUpdate @31-84F180FA
        Update.SqlQuery.Replace("{emp_id}",Update.Dao.ToSql(item.emp_id.GetFormattedValue(""),FieldType.Integer));
        Update.SqlQuery.Replace("{project_id}",Update.Dao.ToSql(item.project_id.GetFormattedValue(""),FieldType.Integer));
        Update.SqlQuery.Replace("{percent_allocation}",Update.Dao.ToSql(item.percent_allocation.GetFormattedValue(""),FieldType.Integer));
        Update.Parameters.Add("project_id36","project_id = " + Update.Dao.ToSql(item.project_idField.GetFormattedValue(""),FieldType.Integer));
        Update.Parameters.Add("emp_id37","emp_id = " + Update.Dao.ToSql(item.emp_idField.GetFormattedValue(""),FieldType.Integer));
//End EditableGrid projects_employees BeforeBuildUpdate

//EditableGrid projects_employees Execute Update  @31-74A302F6
        object result=null;
        try{
            result=Update.ExecuteNonQuery();
        }catch(Exception e){
            item.errors.Add("DataProvider",e.Source + ":" + e.Message);
            result = 0;}
        finally{
//End EditableGrid projects_employees Execute Update 

//EditableGrid projects_employees AfterExecuteUpdate @31-16B7139B
        }
        return (int)result;
    }
//End EditableGrid projects_employees AfterExecuteUpdate

//EditableGrid projects_employees Data Provider Class Delete Method @31-D18B772D
    public int DeleteItem(projects_employeesItem item)
    {
        DataCommand Delete=new TableCommand("DELETE FROM projects_employees",new string[]{"project_id36","And","emp_id37"},Settings.IntranetDBDataAccessObject);
//End EditableGrid projects_employees Data Provider Class Delete Method

//EditableGrid projects_employees BeforeBuildDelete @31-BF4220B8
        Delete.Parameters.Add("project_id36","project_id = " + Select.Dao.ToSql(item.project_idField.GetFormattedValue(""),FieldType.Integer));
        Delete.Parameters.Add("emp_id37","emp_id = " + Select.Dao.ToSql(item.emp_idField.GetFormattedValue(""),FieldType.Integer));
//End EditableGrid projects_employees BeforeBuildDelete

//EditableGrid projects_employees Data Provider Class Execute Delete @31-7FECB576
        object result=null;
        try{
            result = Delete.ExecuteNonQuery();
        }catch(Exception e){
            item.errors.Add("DataProvider",e.Source + ":" + e.Message);
            result = 0;}
        finally{
//End EditableGrid projects_employees Data Provider Class Execute Delete

//EditableGrid projects_employees AfterExecuteDelete @31-16B7139B
        }
        return (int)result;
    }
//End EditableGrid projects_employees AfterExecuteDelete

//Grid projects_employees Data Provider Class Update Method @31-7D38BFDC
    public void Update(ArrayList Items)
    {
        Update(Items, 0);
    }

    public void Update(ArrayList Items, int userGroup)
    {
        bool AllowInsert=true;
        bool AllowUpdate=true;
        bool AllowDelete=true;
        for(int i = 0; i < Items.Count; i++)
        {
            EditableGridOperation op = EditableGridOperation.Insert;
            bool isProcessed = false;
            projects_employeesItem item = (projects_employeesItem)Items[i];
            if(item.IsUpdated) continue;
            if(item.IsDeleted && AllowDelete){
                DeleteItem(item);
                op = EditableGridOperation.Delete;
                isProcessed = true;}
            if(item.IsNew && AllowInsert && !isProcessed){
                InsertItem(item);
                op = EditableGridOperation.Insert;
                isProcessed = true;}
            if(!item.IsEmptyItem && AllowUpdate && !isProcessed){
                UpdateItem(item);
                op = EditableGridOperation.Update;}
            if(item.errors.Count == 0) item.IsUpdated = true;
            OnItemUpdated(new ItemUpdatedEventArgs(op, item));
        }
    }
//End Grid projects_employees Data Provider Class Update Method

//Grid projects_employees Data Provider Class GetResultSet Method @31-2242E1A3
    public projects_employeesItem[] GetResultSet(out int PagesCount)
    {
//End Grid projects_employees Data Provider Class GetResultSet Method

//Before build Select @31-51218ED9
        Exception E=null;
        Parameters.Clear();
        Parameters.Add("emp_id38",Urlemp_id==null?"":("emp_id = " + Select.Dao.ToSql(Urlemp_id.GetFormattedValue(""),FieldType.Integer)));
        Select.OrderBy=(SortDir==SortDirections.Asc?SortFieldsNames[(int)SortField]:SortFieldsNamesDesc[(int)SortField]).Trim();
//End Before build Select

//Execute Select @31-E25CF8FC
        DataSet ds=null;
        PagesCount=0;
        try{
            if(RecordsPerPage>0)
            {
                ds=ExecuteSelect((PageNumber-1)*RecordsPerPage,RecordsPerPage);
                PagesCount = ExecuteCount();
                mRecordCount = PagesCount;
                PagesCount = PagesCount%RecordsPerPage>0?(int)(PagesCount/RecordsPerPage)+1:(int)(PagesCount/RecordsPerPage);
            }
            else
            {
            ds=ExecuteSelect();
            if(ds.Tables[0].Rows.Count!=0)PagesCount=1;
            }
        }catch(Exception e){
            E=e;}
        finally{
//End Execute Select

//After execute Select @31-4D8FD3BC
        if(E!=null) throw(E);
        }
        DataRowCollection dr=ds.Tables[0].Rows;
        projects_employeesItem[] result=new projects_employeesItem[dr.Count + EmptyRows];
        DataRowCollection ListBoxSource=null;
//End After execute Select

//ListBox project_id BeforeExecuteSelect @32-B85A5BA1
    try{
        ListBoxSource=project_idDataCommand.Execute().Tables[0].Rows;
    }catch(Exception e){
        E=e;}
    finally{
//End ListBox project_id BeforeExecuteSelect

//ListBox project_id AfterExecuteSelect @32-0AAC21C9
        if(E!=null) throw(E);
    }
    ItemCollection project_idItems=new ItemCollection();
    for(int i=0;i<ListBoxSource.Count;i++){
        object val = ListBoxSource[i]["project_name"];
        string key = (new IntegerField("", ListBoxSource[i]["project_id"])).GetFormattedValue("");
        project_idItems.Add(key,val);
    }
//End ListBox project_id AfterExecuteSelect

//After execute Select tail @31-A0CC8AFC
        for(int i=0;i<dr.Count;i++)
        {
            projects_employeesItem item=new projects_employeesItem();
            item.emp_id.SetValue(dr[i]["emp_id"],"");
            item.project_id.SetValue(dr[i]["project_id"],"");
            item.project_idItems = (ItemCollection)project_idItems.Clone();
            item.percent_allocation.SetValue(dr[i]["percent_allocation"],"");
            item.project_idField.SetValue(dr[i]["project_id"],"");
            item.emp_idField.SetValue(dr[i]["emp_id"],"");
            result[i]=item;
        }
        for(int i = dr.Count; i < dr.Count + EmptyRows; i++){
            projects_employeesItem item=new projects_employeesItem();
            item.project_idItems = (ItemCollection)project_idItems.Clone();
            result[i] = item;}
        return result; 
    }
//End After execute Select tail

//Grid Data Provider tail @31-FCB6E20C
}
//End Grid Data Provider tail

//Page Data Provider Tail @1-FCB6E20C
}
//End Page Data Provider Tail

