'Using Statements @1-6AC7402B
Imports System
Imports System.Text
Imports System.Text.RegularExpressions
Imports System.Collections
Imports System.Collections.Specialized
Imports System.Data
Imports CCSExamplePack
Imports CCSExamplePack.Data
Imports CCSExamplePack.Controls
Imports CCSExamplePack.Configuration

Namespace MasterDetail.MasterDetail
'End Using Statements

'Page Data Class @1-0E92F43E
Public Class PageItem
    Public errors As NameValueCollection = New NameValueCollection()

    Public Sub New()
    End Sub
    Public Shared Function CreateFromHttpRequest() As PageItem
        Dim item As PageItem = New PageItem()
        item.Link1.SetValue(DBUtility.GetInitialValue("Link1"))
        Return item
    End Function

    Default Public Property Field(fieldName As String) As FieldBase
        Get
            Select fieldName
                Case "Link1"
                    Return Link1
                Case Else
                    Throw (New ArgumentOutOfRangeException())
            End Select
        End Get
        Set (ByVal Value As FieldBase)
            Select fieldName
                Case "Link1"
                    Link1 = CType(value, TextField)
                Case Else
                    Throw (New ArgumentOutOfRangeException())
            End Select
        End Set
    End Property

    Public Link1 As TextField = New TextField("",Nothing)
    Public Link1Href As Object
    Public Link1HrefParameters As LinkParameterCollection = New LinkParameterCollection()
End Class
'End Page Data Class

'Page Data Provider Class @1-E3544B64
Public Class PageDataProvider
Dim j As Integer
'End Page Data Provider Class

'Page Data Provider Class Constructor @1-12B526DF

    Public Sub New()
    End Sub
'End Page Data Provider Class Constructor

'Page Data Provider Class GetResultSet Method @1-F73C4626

    Public Sub FillItem(ByVal item As PageItem)
'End Page Data Provider Class GetResultSet Method

'Page Data Provider Class GetResultSet Method tail @1-E31F8E2A
    End Sub
'End Page Data Provider Class GetResultSet Method tail

'Page Data Provider Tail @1-A61BA892
End Class
'End Page Data Provider Tail

'Grid employees_grid Item Class @23-C851BE94
Public Class employees_gridItem
    Public errors As NameValueCollection = New NameValueCollection()
    Public Sub New()
    End Sub

    Public Default Property Field(ByVal fieldName As String) as FieldBase
        Get
            Select fieldName
                Case "emp_id"
                    Return Me.emp_id
                Case "emp_name"
                    Return Me.emp_name
                Case "Link1"
                    Return Me.Link1
                Case Else
                    Throw New ArgumentOutOfRangeException()
            End Select
        End Get
        Set (ByVal Value As FieldBase)
            Select fieldName
                Case "emp_id"
                    Me.emp_id = CType(Value,TextField)
                Case "emp_name"
                    Me.emp_name = CType(Value,TextField)
                Case "Link1"
                    Me.Link1 = CType(Value,TextField)
                Case Else
                    Throw New ArgumentOutOfRangeException()
            End Select
        End Set
    End Property

    Public emp_id As TextField = New TextField("", Nothing)
    Public emp_name As TextField = New TextField("",Nothing)
    Public emp_nameHref As Object
    Public emp_nameHrefParameters As LinkParameterCollection = New LinkParameterCollection()
    Public Link1 As TextField = New TextField("",Nothing)
    Public Link1Href As Object
    Public Link1HrefParameters As LinkParameterCollection = New LinkParameterCollection()
End Class
'End Grid employees_grid Item Class

'Grid employees_grid Data Provider Class Header @23-1D413F68
Public Class employees_gridDataProvider
Inherits GridDataProviderBase
'End Grid employees_grid Data Provider Class Header

'Grid employees_grid Data Provider Class Variables @23-F1112ECE

    Public Enum SortFields
        _Default
    End Enum

    Private SortFieldsNames As String() = New String() {"emp_name"}
    Private SortFieldsNamesDesc As String() = New string() {"emp_name"}
    Public SortField As SortFields = SortFields._Default
    Public SortDir As SortDirections = SortDirections._Asc
    Public RecordsPerPage As Integer = 10
    Public PageNumber As Integer = 1
'End Grid employees_grid Data Provider Class Variables

'Grid employees_grid Data Provider Class Constructor @23-F8CB9E78

    Public Sub New()
        Select_ = New TableCommand("SELECT *  " & _
          "FROM employees",New String(){},Settings.IntranetDBDataAccessObject)
        Count = New TableCommand("SELECT COUNT(*)  " & _
          "FROM employees",New String(){},Settings.IntranetDBDataAccessObject)
    End Sub
'End Grid employees_grid Data Provider Class Constructor

'Grid employees_grid Data Provider Class GetResultSet Method @23-D84D0143

    Public Function GetResultSet(ByRef PagesCount As Integer) As employees_gridItem()
'End Grid employees_grid Data Provider Class GetResultSet Method

'Before build Select @23-EB06405A
        Parameters.Clear
        If SortDir = SortDirections._Asc Then
            Select_.OrderBy=SortFieldsNames(CInt(SortField)).Trim()
        Else
            Select_.OrderBy=SortFieldsNamesDesc(CInt(SortField)).Trim()
        End If
'End Before build Select

'Execute Select @23-467AC0A8
        Dim ds As DataSet = Nothing, E as Exception = Nothing
        PagesCount=0
        Try
            If RecordsPerPage>0
                ds=ExecuteSelect((PageNumber-1)*RecordsPerPage,RecordsPerPage)
                PagesCount = ExecuteCount()
                m_recordCount = PagesCount
                If PagesCount Mod RecordsPerPage>0 Then
                    PagesCount = (PagesCount\RecordsPerPage)+1
                Else
                    PagesCount = PagesCount\RecordsPerPage
                End If
            Else
            ds=ExecuteSelect()
            If ds.Tables(0).Rows.Count<>0 Then 
                PagesCount=1
            End If
            End If
        Catch ee as Exception
            E=ee
        Finally
'End Execute Select

'After execute Select @23-42B9043B
        If Not IsNothing(E) Then Throw E
        End Try
        Dim dr as DataRowCollection = ds.Tables(0).Rows
        Dim result(dr.Count - 1) as employees_gridItem
        Dim j As Integer
'End After execute Select

'After execute Select tail @23-6BBAB47C
        Dim i as Integer
        For i = 0 To dr.Count - 1
            Dim item as employees_gridItem = New employees_gridItem()
            item.emp_id.SetValue(dr(i)("emp_id"),"")
            item.emp_name.SetValue(dr(i)("emp_name"),"")
            item.emp_nameHrefParameters.Add("emp_id",System.Web.HttpUtility.UrlEncode(dr(i)("emp_id").ToString()))
            result(i)=item
        Next
        Return result 
    End Function
'End After execute Select tail

'Grid Data Provider tail @23-A61BA892
End Class
'End Grid Data Provider tail

'Record employees_record Item Class @2-3E1C9F5A
Public Class employees_recordItem
    Private _isNew As Boolean = True
    Private _isDeleted As Boolean = False
    Public errors As NameValueCollection = New NameValueCollection()

    public Sub New()
    End Sub
    Public emp_name As TextField = New TextField("", Nothing)
    Public title As TextField = New TextField("", Nothing)
    Public department_id As IntegerField = New IntegerField("", Nothing)
    Public department_idItems As ItemCollection = New ItemCollection()

    Public Shared Function CreateFromHttpRequest() As employees_recordItem
        Dim item As employees_recordItem = New employees_recordItem()
        If Not IsNothing(DBUtility.GetInitialValue("emp_name")) Then
        item.emp_name.SetValue(DBUtility.GetInitialValue("emp_name"))
        End If 
        If Not IsNothing(DBUtility.GetInitialValue("title")) Then
        item.title.SetValue(DBUtility.GetInitialValue("title"))
        End If 
        If Not IsNothing(DBUtility.GetInitialValue("department_id")) Then
        item.department_id.SetValue(DBUtility.GetInitialValue("department_id"))
        End If 
        If Not IsNothing(DBUtility.GetInitialValue("Button_Insert")) Then
        End If 
        If Not IsNothing(DBUtility.GetInitialValue("Button_Update")) Then
        End If 
        If Not IsNothing(DBUtility.GetInitialValue("Button_Delete")) Then
        End If 
        If Not IsNothing(DBUtility.GetInitialValue("Button_Cancel")) Then
        End If 
        Return item
    End Function

    Default Public Property Field(fieldName As String) As FieldBase
        Get
            Select fieldName
                Case "emp_name"
                    Return emp_name
                Case "title"
                    Return title
                Case "department_id"
                    Return department_id
                Case Else
                    Throw (New ArgumentOutOfRangeException())
            End Select
        End Get
        Set (ByVal Value As FieldBase)
            Select fieldName
                Case "emp_name"
                    emp_name = CType(value, TextField)
                Case "title"
                    title = CType(value, TextField)
                Case "department_id"
                    department_id = CType(value, IntegerField)
                Case Else
                    Throw (New ArgumentOutOfRangeException())
            End Select
        End Set
    End Property

    Public Property IsNew() As Boolean
        Get
            Return _isNew
        End Get
        Set
            _isNew = Value
        End Set
    End Property

    Public Property IsDeleted() As Boolean
        Get
            Return _isDeleted
        End Get
        Set
            _isDeleted = Value
        End Set
    End Property

    Public Sub Validate(ByVal provider As employees_recordDataProvider)
'End Record employees_record Item Class

'emp_name validate @8-FF7EFE53
        If IsNothing(emp_name.Value) Then
            errors.Add("emp_name","The value in field Emp Name is required.")
        ElseIf emp_name.Value.ToString() ="" Then
            errors.Add("emp_name","The value in field Emp Name is required.")
        End If
'End emp_name validate

'Record employees_record Item Class tail @2-8B704AE2
    End Sub
End Class
'End Record employees_record Item Class tail

'Record employees_record Data Provider Class @2-8DBAC386
Public Class employees_recordDataProvider
Inherits RecordDataProviderBase
'End Record employees_record Data Provider Class

'Record employees_record Data Provider Class Variables @2-D05DC7EA
    Protected department_idDataCommand As DataCommand = New TableCommand("SELECT *  " & _
          "FROM departments",New String(){},Settings.IntranetDBDataAccessObject)
    Public Urlemp_id As IntegerParameter
'End Record employees_record Data Provider Class Variables

'Record employees_record Data Provider Class Constructor @2-B2E2D4E2

    Public Sub New()
        Select_ = New TableCommand("SELECT *  " & _
          "FROM employees",New String(){"emp_id7"},Settings.IntranetDBDataAccessObject)
        Insert = New TableCommand("INSERT INTO employees(emp_name, title, department_id ) VALUES ( {emp_name}, {title}, {department_id})" _
          ,New String(){},Settings.IntranetDBDataAccessObject)
        Update = New TableCommand("UPDATE employees SET emp_name={emp_name}, title={title}, department_id={department_id}" _
          ,New String(){"emp_id7"},Settings.IntranetDBDataAccessObject)
        Delete = New TableCommand("DELETE FROM employees",New String(){"emp_id7"},Settings.IntranetDBDataAccessObject)
    End Sub
'End Record employees_record Data Provider Class Constructor

'Record employees_record Data Provider Class LoadParams Method @2-1750518E

    Protected Function LoadParams() As Boolean
        CommonParameters.Clear()
    If IsNothing(Urlemp_id) Then
        CommonParameters.Add("emp_id7","")
    Else
        CommonParameters.Add("emp_id7","emp_id = " & Select_.Dao.ToSql(Urlemp_id.GetFormattedValue(""),FieldType._Integer))
    End If
        Return (IsNothing(Urlemp_id))
    End Function
'End Record employees_record Data Provider Class LoadParams Method

'Record employees_record Data Provider Class CheckUnique Method @2-CD0A30FD

    Public Function CheckUnique(ByVal ControlName As String, ByVal item As employees_recordItem) As Boolean
        Return True
    End Function
'End Record employees_record Data Provider Class CheckUnique Method

'Record employees_record Data Provider Class PrepareInsert Method @2-0E277F0A

    Protected Overrides Sub PrepareInsert()
'End Record employees_record Data Provider Class PrepareInsert Method

'Record employees_record Data Provider Class PrepareInsert Method tail @2-E31F8E2A
    End Sub
'End Record employees_record Data Provider Class PrepareInsert Method tail

'Record employees_record Data Provider Class Insert Method @2-39BD1FA3

    Public Function InsertItem(ByVal item As employees_recordItem) As Integer
'End Record employees_record Data Provider Class Insert Method

'Record employees_record Build insert @2-C922044B
        Insert.SqlQuery.Replace("{emp_name}",Insert.Dao.ToSql(item.emp_name.GetFormattedValue(""),FieldType._Text))
        Insert.SqlQuery.Replace("{title}",Insert.Dao.ToSql(item.title.GetFormattedValue(""),FieldType._Text))
        Insert.SqlQuery.Replace("{department_id}",Insert.Dao.ToSql(item.department_id.GetFormattedValue(""),FieldType._Integer))
        Dim result As Object = Nothing
        Dim E As Exception = Nothing
        Try
            result = ExecuteInsert()
        Catch ee As Exception
            E = ee
        Finally
'End Record employees_record Build insert

'Record employees_record AfterExecuteInsert @2-2FB4FB62
            If Not IsNothing(E) Then Throw E
        End Try
        Return CType(result, Integer)
    End Function
'End Record employees_record AfterExecuteInsert

'Record employees_record Data Provider Class PrepareUpdate Method @2-D72B5D1D

    Protected Overrides Sub PrepareUpdate()
        LoadParams()
        Update.Parameters = CommonParameters
'End Record employees_record Data Provider Class PrepareUpdate Method

'Record employees_record Data Provider Class PrepareUpdate Method tail @2-E31F8E2A
    End Sub
'End Record employees_record Data Provider Class PrepareUpdate Method tail

'Record employees_record Data Provider Class Update Method @2-25F1F619

    Public Function UpdateItem(ByVal item As employees_recordItem) As Integer
'End Record employees_record Data Provider Class Update Method

'Record employees_record BeforeBuildUpdate @2-047FFDEA
        Update.SqlQuery.Replace("{emp_name}",Update.Dao.ToSql(item.emp_name.GetFormattedValue(""),FieldType._Text))
        Update.SqlQuery.Replace("{title}",Update.Dao.ToSql(item.title.GetFormattedValue(""),FieldType._Text))
        Update.SqlQuery.Replace("{department_id}",Update.Dao.ToSql(item.department_id.GetFormattedValue(""),FieldType._Integer))
        Dim result As Object = Nothing
        Dim E As Exception = Nothing
        Try
            result = ExecuteUpdate()
        Catch ee As Exception
            E = ee
        Finally
'End Record employees_record BeforeBuildUpdate

'Record employees_record AfterExecuteUpdate @2-2FB4FB62
            If Not IsNothing(E) Then Throw E
        End Try
        Return CType(result, Integer)
    End Function
'End Record employees_record AfterExecuteUpdate

'Record employees_record Data Provider Class PrepareDelete Method @2-998024F7

    Protected Overrides Sub PrepareDelete()
        LoadParams()
        Delete.Parameters = CommonParameters
'End Record employees_record Data Provider Class PrepareDelete Method

'Record employees_record Data Provider Class PrepareDelete Method tail @2-E31F8E2A
    End Sub
'End Record employees_record Data Provider Class PrepareDelete Method tail

'Record employees_record Data Provider Class Delete Method @2-3393434D

    Public Function DeleteItem() As Integer
'End Record employees_record Data Provider Class Delete Method

'Record employees_record BeforeBuildDelete @2-19F34D29
        Dim result As Object = Nothing
        Dim E As Exception = Nothing
        Try
            result = ExecuteDelete()
        Catch ee As Exception
            E = ee
        Finally
'End Record employees_record BeforeBuildDelete

'Record employees_record BeforeBuildDelete @2-2FB4FB62
            If Not IsNothing(E) Then Throw E
        End Try
        Return CType(result, Integer)
    End Function
'End Record employees_record BeforeBuildDelete

'PrepareSelect Method @2-34AB3510

    Protected Overrides Sub PrepareSelect()
        LoadParams()
        Select_.Parameters = CommonParameters
    End Sub
'End PrepareSelect Method

'Record employees_record Data Provider Class GetResultSet Method @2-A061FBC2

    Public Sub FillItem(ByVal item As employees_recordItem, ByRef IsInsertMode As Boolean)
        Dim ReadNotAllowed As Boolean = IsInsertMode
        Dim E As Exception = Nothing
'End Record employees_record Data Provider Class GetResultSet Method

'Record employees_record BeforeBuildSelect @2-0FCCC126
        IsInsertMode = LoadParams()
        Dim dr As DataRowCollection = Nothing
        If Not IsInsertMode Then
'End Record employees_record BeforeBuildSelect

'Record employees_record BeforeExecuteSelect @2-EBD3678C
            Try
                dr = ExecuteSelect().Tables(0).Rows
            Catch ee As Exception
                E = ee
            Finally
'End Record employees_record BeforeExecuteSelect

'Record employees_record AfterExecuteSelect @2-506FD6D4
                If Not IsNothing(E) Then Throw E
        End Try
        End If
        If (Not IsInsertMode) And (Not ReadNotAllowed) Then
            If dr.Count <> 0 Then
                Dim i As Integer = 0
                item.emp_name.SetValue(dr(i)("emp_name"),"")
                item.title.SetValue(dr(i)("title"),"")
                item.department_id.SetValue(dr(i)("department_id"),"")
        Else
            IsInsertMode = True
            End If
        End If
        Dim ListBoxSource As DataRowCollection = Nothing
        Dim j As Integer
'End Record employees_record AfterExecuteSelect

'ListBox department_id BeforeExecuteSelect @11-4D85C197
        Try
            ListBoxSource=department_idDataCommand.Execute().Tables(0).Rows
        Catch ee as Exception 
            E=ee
        Finally
'End ListBox department_id BeforeExecuteSelect

'ListBox department_id AfterExecuteSelect @11-D10C158B
            If Not IsNothing(E) Then Throw E
        End Try
        For j=0 To ListBoxSource.Count-1 
            Dim Key As String = (New IntegerField("", ListBoxSource(j)("department_id"))).GetFormattedValue("")
            Dim Val As Object = ListBoxSource(j)("department_name")
            item.department_idItems.Add(Key, Val)
        Next
'End ListBox department_id AfterExecuteSelect

'Record employees_record AfterExecuteSelect tail @2-E31F8E2A
    End Sub
'End Record employees_record AfterExecuteSelect tail

'Record employees_record Data Provider Class @2-A61BA892
End Class

'End Record employees_record Data Provider Class

'EditableGrid projects_employees Item Class @31-5C3B1F4F
Public Class projects_employeesItem
    Public errors As NameValueCollection = New NameValueCollection()
    Public RowId As Integer
    Public Sub New()
    End Sub

    Public Default Property Field(ByVal fieldName As String) as FieldBase
        Get
            Select fieldName
                Case "project_idField"
                    Return Me.project_idField
                Case "emp_idField"
                    Return Me.emp_idField
                Case "emp_id"
                    Return Me.emp_id
                Case "project_id"
                    Return Me.project_id
                Case "percent_allocation"
                    Return Me.percent_allocation
                Case "Delete1"
                    Return Me.Delete1
                Case Else
                    Throw New ArgumentOutOfRangeException()
            End Select
        End Get
        Set (ByVal Value As FieldBase)
            Select fieldName
                Case "project_idField"
                    Me.project_idField = CType(Value,IntegerField)
                Case "emp_idField"
                    Me.emp_idField = CType(Value,IntegerField)
                Case "emp_id"
                    Me.emp_id = CType(Value,IntegerField)
                Case "project_id"
                    Me.project_id = CType(Value,IntegerField)
                Case "percent_allocation"
                    Me.percent_allocation = CType(Value,IntegerField)
                Case "Delete1"
                    Me.Delete1 = CType(Value,BooleanField)
                Case Else
                    Throw New ArgumentOutOfRangeException()
            End Select
        End Set
    End Property

    Public ReadOnly Property IsNew As Boolean
        Get
            Dim result As Boolean = True
            Dim result1 As Boolean = True
            result = IsNothing(project_idField.Value) And result
            result = IsNothing(emp_idField.Value) And result
            result1 = IsNothing(emp_id.Value) And result1
            result1 = IsNothing(project_id.Value) And result1
            result1 = IsNothing(percent_allocation.Value) And result1
            result1 = IsNothing(Delete1.Value) And result1
            Return result And (Not result1)
        End Get
    End Property

    Public ReadOnly Property IsEmptyItem As Boolean
        Get
            Dim result As Boolean = True
            result = IsNothing(emp_id.Value) And result
            result = IsNothing(project_id.Value) And result
            result = IsNothing(percent_allocation.Value) And result
            result = IsNothing(Delete1.Value) And result
            result = IsNothing(project_idField.Value) And result
            result = IsNothing(emp_idField.Value) And result
            Return result
        End Get
    End Property

    Public IsDeleted As Boolean = False
    Public IsUpdated As Boolean = False
    Public emp_id As IntegerField = New IntegerField("", Nothing)
    Public project_id As IntegerField = New IntegerField("", Nothing)
    Public project_idItems As ItemCollection = New ItemCollection()
    Public percent_allocation As IntegerField = New IntegerField("", Nothing)
    Public Delete1 As BooleanField = New BooleanField(Settings.BoolFormat, Nothing)
    Public Delete1CheckedValue As BooleanField = New BooleanField(Settings.BoolFormat, true)
    Public Delete1UncheckedValue As BooleanField = New BooleanField(Settings.BoolFormat, false)

    Public project_idField As IntegerField = New IntegerField()
    Public emp_idField As IntegerField = New IntegerField()
    Public Function Validate(ByVal provider As projects_employeesDataProvider) As Boolean
'End EditableGrid projects_employees Item Class

'project_id validate @32-0E3D3ADD
        If IsNothing(project_id.Value) Then
            errors.Add("project_id","The value in field project_id is required.")
        ElseIf project_id.Value.ToString() ="" Then
            errors.Add("project_id","The value in field project_id is required.")
        End If
'End project_id validate

'Control project_id Event OnValidate. Action Custom Code @44-73254650
    ' -------------------------
    ' Write your own code here.
    ' -------------------------
'End Control project_id Event OnValidate. Action Custom Code

'EditableGrid projects_employees Item Class tail @31-9124938E
        Return errors.Count = 0
    End Function
End Class
'End EditableGrid projects_employees Item Class tail

'EditableGrid projects_employees Data Provider Class Header @31-F3E2B3F2
Public Class projects_employeesDataProvider
Inherits EditableGridDataProviderBase
'End EditableGrid projects_employees Data Provider Class Header

'Grid projects_employees Data Provider Class Variables @31-2BD8D9AF

    Public Enum SortFields
        _Default
    End Enum

    Private SortFieldsNames As String() = New String() {""}
    Private SortFieldsNamesDesc As String() = New string() {""}
    Public SortField As SortFields = SortFields._Default
    Public SortDir As SortDirections = SortDirections._Asc
    Public RecordsPerPage As Integer = 20
    Public PageNumber As Integer = 1
    Public EmptyRows As Integer = 3
    Public Urlemp_id As IntegerParameter
    Protected project_idDataCommand As DataCommand = New TableCommand("SELECT *  " & _
          "FROM projects",New String(){},Settings.IntranetDBDataAccessObject)
'End Grid projects_employees Data Provider Class Variables

'EditableGrid projects_employees Data Provider Class Constructor @31-7AAD0055

    Public Sub New()
        Select_ = New TableCommand("SELECT *  " & _
          "FROM projects_employees",New String(){"emp_id38"},Settings.IntranetDBDataAccessObject)
        Count = New TableCommand("SELECT COUNT(*)  " & _
          "FROM projects_employees",New String(){"emp_id38"},Settings.IntranetDBDataAccessObject)
    End Sub
'End EditableGrid projects_employees Data Provider Class Constructor

'Record projects_employees Data Provider Class CheckUnique Method @31-BA6AFEED

    Public Function CheckUnique(ByVal ControlName As String, ByVal item As projects_employeesItem) As Boolean
        Return True
    End Function
'End Record projects_employees Data Provider Class CheckUnique Method

'Grid projects_employees Data Provider Class Insert Method @31-CF142C77
    Protected Function InsertItem(ByVal item As projects_employeesItem) As Integer
        Dim Insert As DataCommand = New TableCommand("INSERT INTO projects_employees(emp_id, project_id, percent_allocation ) VALUES ( {emp_id}, {project_id}, {percent_allocation})" _
          ,New String(){},Settings.IntranetDBDataAccessObject)
'End Grid projects_employees Data Provider Class Insert Method

'EditableGrid projects_employees Event BeforeBuildInsert. Action Custom Code @41-73254650
    
	'Update the hidden 'emp_id" field with the current employee id
	Dim Req As System.Web.HttpRequest  = System.Web.HttpContext.Current.Request
	If Not IsNothing(Req.QueryString("emp_id")) And (Req.QueryString("emp_id") <> "") Then
			
		item.emp_id.SetValue(Req.QueryString("emp_id"),"")
  	End If
'End EditableGrid projects_employees Event BeforeBuildInsert. Action Custom Code

'EditableGrid projects_employees Build insert @31-8B6169DD
        Insert.SqlQuery.Replace("{emp_id}",Insert.Dao.ToSql(item.emp_id.GetFormattedValue(""),FieldType._Integer))
        Insert.SqlQuery.Replace("{project_id}",Insert.Dao.ToSql(item.project_id.GetFormattedValue(""),FieldType._Integer))
        Insert.SqlQuery.Replace("{percent_allocation}",Insert.Dao.ToSql(item.percent_allocation.GetFormattedValue(""),FieldType._Integer))
'End EditableGrid projects_employees Build insert

'EditableGrid projects_employees Data Provider Class ExecuteInsert @31-9E5B2417
        Dim result As Object = Nothing
        Dim E As Exception = Nothing
        Try
            result = Insert.ExecuteNonQuery()
        Catch e_ As Exception
            item.errors.Add("DataProvider",e_.Source + ":" + e_.Message)
            result = 0
        Finally
'End EditableGrid projects_employees Data Provider Class ExecuteInsert

'EditableGrid projects_employees AfterExecuteInsert @31-5C54EEF8
        End Try
        Return CType(result, Integer)
    End Function
'End EditableGrid projects_employees AfterExecuteInsert

'EditableGrid projects_employees Data Provider Class Update Method @31-53DE7CA2
    Protected Function UpdateItem(ByVal item As projects_employeesItem) As Integer
        Dim Update As DataCommand = New TableCommand("UPDATE projects_employees SET emp_id={emp_id}, project_id={project_id}, percent_allocation={percent_allocation}" _
          ,New String(){"project_id36","And","emp_id37"},Settings.IntranetDBDataAccessObject)
'End EditableGrid projects_employees Data Provider Class Update Method

'EditableGrid projects_employees BeforeBuildUpdate @31-BBB38F76
        Update.SqlQuery.Replace("{emp_id}",Update.Dao.ToSql(item.emp_id.GetFormattedValue(""),FieldType._Integer))
        Update.SqlQuery.Replace("{project_id}",Update.Dao.ToSql(item.project_id.GetFormattedValue(""),FieldType._Integer))
        Update.SqlQuery.Replace("{percent_allocation}",Update.Dao.ToSql(item.percent_allocation.GetFormattedValue(""),FieldType._Integer))
        Update.Parameters.Add("project_id36","project_id = " & Update.Dao.ToSql(item.project_idField.GetFormattedValue(""),FieldType._Integer))
        Update.Parameters.Add("emp_id37","emp_id = " & Update.Dao.ToSql(item.emp_idField.GetFormattedValue(""),FieldType._Integer))
'End EditableGrid projects_employees BeforeBuildUpdate

'EditableGrid projects_employees Execute Update  @31-A372D3E2
        Dim result As Object = Nothing
        Dim E As Exception = Nothing
        Try
            result = Update.ExecuteNonQuery()
        Catch e_ As Exception
            item.errors.Add("DataProvider",e_.Source + ":" + e_.Message)
            result = 0
        Finally
'End EditableGrid projects_employees Execute Update 

'EditableGrid projects_employees AfterExecuteUpdate @31-5C54EEF8
        End Try
        Return CType(result, Integer)
    End Function
'End EditableGrid projects_employees AfterExecuteUpdate

'Record projects_employees Data Provider Class Delete Method @31-6829269C
    Public Function DeleteItem(ByVal item As projects_employeesItem) As Integer
        Dim Delete As DataCommand = New TableCommand("DELETE FROM projects_employees",New String(){"project_id36","And","emp_id37"},Settings.IntranetDBDataAccessObject)
'End Record projects_employees Data Provider Class Delete Method

'Record projects_employees BeforeBuildDelete @31-1DCA0B7C
        Delete.Parameters.Add("project_id36","project_id = " & Delete.Dao.ToSql(item.project_idField.GetFormattedValue(""),FieldType._Integer))
        Delete.Parameters.Add("emp_id37","emp_id = " & Delete.Dao.ToSql(item.emp_idField.GetFormattedValue(""),FieldType._Integer))
'End Record projects_employees BeforeBuildDelete

'EditableGrid projects_employees Data Provider Class Execute Delete @31-2A5D935C
        Dim result As Object = Nothing
        Dim E As Exception = Nothing
        Try
            result = Delete.ExecuteNonQuery()
        Catch e_ As Exception
            item.errors.Add("DataProvider",e_.Source + ":" + e_.Message)
            result = 0
        Finally
'End EditableGrid projects_employees Data Provider Class Execute Delete

'EditableGrid projects_employees AfterExecuteDelete @31-5C54EEF8
        End Try
        Return CType(result, Integer)
    End Function
'End EditableGrid projects_employees AfterExecuteDelete

'Grid projects_employees Data Provider Class GetResultSet Method @31-C36DBA12
    Public Sub Update(ByVal Items As ArrayList)
        Update(Items, 0)
    End Sub

    Public Sub Update(ByVal Items As ArrayList, ByVal userGroup As Integer)
        Dim AllowInsert As Boolean = True
        Dim AllowUpdate As Boolean = True
        Dim AllowDelete As Boolean = True
        Dim i As Integer
        For i = 0 To Items.Count - 1
            Dim op As EditableGridOperation = EditableGridOperation.Insert
            Dim isProcessed As Boolean = False
            Dim item As projects_employeesItem = CType(Items(i), projects_employeesItem)
'End Grid projects_employees Data Provider Class GetResultSet Method

'EditableGrid projects_employees Data Provider Class Update @31-222725D8
            If Not item.IsUpdated Then
                If item.IsDeleted And AllowDelete Then
                    DeleteItem(item)
                    op = EditableGridOperation.Delete
                    isProcessed = True
                End If
                If item.IsNew And AllowInsert And Not(isProcessed) Then
                    InsertItem(item)
                    op = EditableGridOperation.Insert
                    isProcessed = True
                End If
                If Not(item.IsEmptyItem) And AllowUpdate And Not(isProcessed) Then
                    UpdateItem(item)
                    op = EditableGridOperation.Update
                End If
'End EditableGrid projects_employees Data Provider Class Update

'EditableGrid projects_employees Data Provider Class AfterUpdate @31-6CCB76B9
                If item.errors.Count = 0 Then item.IsUpdated = True
                OnItemUpdated(New ItemUpdatedEventArgs(op, item))
            End If
        Next i
    End Sub
'End EditableGrid projects_employees Data Provider Class AfterUpdate

'EditableGrid projects_employees Data Provider Class GetResultSet Method @31-E98285B2

    Public Function GetResultSet(ByRef PagesCount As Integer) As projects_employeesItem()
'End EditableGrid projects_employees Data Provider Class GetResultSet Method

'Before build Select @31-CE6AD1B2
        Dim E as Exception = Nothing
        Parameters.Clear
        If IsNothing(Urlemp_id) Then
            Parameters.Add("emp_id38","")
        Else
            Parameters.Add("emp_id38","emp_id = " & Select_.Dao.ToSql(Urlemp_id.GetFormattedValue(""),FieldType._Integer))
        End If
        If SortDir = SortDirections._Asc Then
            Select_.OrderBy = SortFieldsNames(CInt(SortField)).Trim
        Else
            Select_.OrderBy = SortFieldsNamesDesc(CInt(SortField)).Trim
        End If
'End Before build Select

'Execute Select @31-A2C8CA79
        Dim ds As DataSet = Nothing
        PagesCount=0
        Try
            If RecordsPerPage>0
                ds=ExecuteSelect((PageNumber-1)*RecordsPerPage,RecordsPerPage)
                PagesCount = ExecuteCount()
                m_recordCount = PagesCount
                If PagesCount Mod RecordsPerPage>0 Then
                    PagesCount = (PagesCount\RecordsPerPage)+1
                Else
                    PagesCount = PagesCount\RecordsPerPage
                End If
            Else
            ds=ExecuteSelect()
            If ds.Tables(0).Rows.Count<>0 Then 
                PagesCount=1
            End If
            End If
        Catch ee as Exception
            E=ee
        Finally
'End Execute Select

'After execute Select @31-FA8E53AD
        If Not IsNothing(E) Then Throw E
        End Try
        Dim dr as DataRowCollection = ds.Tables(0).Rows
        Dim result(dr.Count + EmptyRows - 1) as projects_employeesItem
        Dim ListBoxSource As DataRowCollection = Nothing
        Dim j As Integer
'End After execute Select

'ListBox project_id BeforeExecuteSelect @32-A3461006
    Try
        ListBoxSource=project_idDataCommand.Execute().Tables(0).Rows
    Catch ee as Exception 
        E=ee
    Finally
'End ListBox project_id BeforeExecuteSelect

'ListBox project_id AfterExecuteSelect @32-105F29BF
        If Not IsNothing(E) Then Throw E
    End Try
    Dim project_idItems As ItemCollection = New ItemCollection()
    For j=0 To ListBoxSource.Count-1 
        Dim Key As String = (New IntegerField("", ListBoxSource(j)("project_id"))).GetFormattedValue("")
        Dim Val As Object = ListBoxSource(j)("project_name")
        project_idItems.Add(Key, Val)
    Next
'End ListBox project_id AfterExecuteSelect

'After execute Select tail @31-D34C5E65
        Dim i as Integer
        For i = 0 To dr.Count - 1
            Dim item as projects_employeesItem = New projects_employeesItem()
            item.emp_id.SetValue(dr(i)("emp_id"),"")
            item.project_id.SetValue(dr(i)("project_id"),"")
            item.project_idItems = CType(project_idItems.Clone(), ItemCollection)
            item.percent_allocation.SetValue(dr(i)("percent_allocation"),"")
            item.project_idField.SetValue(dr(i)("project_id"),"")
            item.emp_idField.SetValue(dr(i)("emp_id"),"")
            result(i)=item
        Next i
        For i = dr.Count To dr.Count + EmptyRows - 1
            Dim item as projects_employeesItem = New projects_employeesItem()
            item.project_idItems = CType(project_idItems.Clone(), ItemCollection)
            result(i) = item
        Next i
        Return result 
    End Function
'End After execute Select tail

'Grid Data Provider tail @31-A61BA892
End Class
'End Grid Data Provider tail

'Page Data Provider Tail @1-5EA2E2E0
End Namespace
'End Page Data Provider Tail

