#BindEvents Method @1-78AD6604
sub BindEvents {
    $projects_emp_rec->{percent_allocation}->{CCSEvents}->{"OnValidate"} = "projects_emp_rec_percent_allocation_OnValidate";
    $projects_emp_rec->{CCSEvents}->{"OnValidate"} = "projects_emp_rec_OnValidate";
}
#End BindEvents Method

#projects_emp_rec_percent_allocation_OnValidate @65-9C16765B
sub projects_emp_rec_percent_allocation_OnValidate()
{
    $projects_emp_rec_percent_allocation_OnValidate = 1;
#End projects_emp_rec_percent_allocation_OnValidate

#Validate Maximum Value @74-8DFC6701
    if (length($projects_emp_rec->{percent_allocation}->GetText()) && $projects_emp_rec->{percent_allocation}->GetValue() > 100)
    {
        $projects_emp_rec->{percent_allocation}->{Errors}->addError("The value in field 'Percent Allocation' cannot be greater than 100.");
    }
#End Validate Maximum Value

#Close projects_emp_rec_percent_allocation_OnValidate @65-C5D695D2
    return $projects_emp_rec_percent_allocation_OnValidate;
}
#End Close projects_emp_rec_percent_allocation_OnValidate

#projects_emp_rec_OnValidate @58-10FC3D37
sub projects_emp_rec_OnValidate()
{
    $projects_emp_rec_OnValidate = 1;
#End projects_emp_rec_OnValidate

#Custom Code @72-84ABEA10

  if(!$projects_emp_rec->{EditMode} || (CCGetFromGet("project_id",0) != $projects_emp_rec->{project_id}->{Value} || CCGetFromGet("emp_id",0) != $projects_emp_rec->{emp_id}->{Value}) ) { 

      $DBIntranetDB = clsDBIntranetDB->new();
      $IsUniqueValue = CCDLookUp("project_id", "projects_employees", " project_id=".$DBIntranetDB->ToSQL(CCGetFromPost("project_id",0),$ccsInteger)." AND emp_id=".$DBIntranetDB->ToSQL(CCGetFromPost("emp_id",0),$ccsInteger), $DBIntranetDB);
      if($IsUniqueValue) {
         $projects_emp_rec->{Errors}->addError("The project is already assigned to this employee.");
      }
      $DBIntranetDB->{sth} = undef;
      $DBIntranetDB->{dbh} = undef;
  }

#End Custom Code

#Close projects_emp_rec_OnValidate @58-79E3A273
    return $projects_emp_rec_OnValidate;
}
#End Close projects_emp_rec_OnValidate


1;
