'Using Statements @1-ED7DDDB2
Imports System
Imports System.Text
Imports System.Text.RegularExpressions
Imports System.Collections
Imports System.Collections.Specialized
Imports System.Data
Imports ExamplePack_VB
Imports ExamplePack_VB.Data
Imports ExamplePack_VB.Controls
Imports ExamplePack_VB.Configuration

Namespace MultiColumnPrimaryKey.MultiColumnPrimaryKey
'End Using Statements

'Page Data Class @1-0E92F43E
Public Class PageItem
    Public errors As NameValueCollection = New NameValueCollection()

    Public Sub New()
    End Sub
    Public Shared Function CreateFromHttpRequest() As PageItem
        Dim item As PageItem = New PageItem()
        item.Link1.SetValue(DBUtility.GetInitialValue("Link1"))
        Return item
    End Function

    Default Public Property Field(fieldName As String) As FieldBase
        Get
            Select fieldName
                Case "Link1"
                    Return Link1
                Case Else
                    Throw (New ArgumentOutOfRangeException())
            End Select
        End Get
        Set (ByVal Value As FieldBase)
            Select fieldName
                Case "Link1"
                    Link1 = CType(value, TextField)
                Case Else
                    Throw (New ArgumentOutOfRangeException())
            End Select
        End Set
    End Property

    Public Link1 As TextField = New TextField("",Nothing)
    Public Link1Href As Object
    Public Link1HrefParameters As LinkParameterCollection = New LinkParameterCollection()
End Class
'End Page Data Class

'Page Data Provider Class @1-E3544B64
Public Class PageDataProvider
Dim j As Integer
'End Page Data Provider Class

'Page Data Provider Class Constructor @1-12B526DF

    Public Sub New()
    End Sub
'End Page Data Provider Class Constructor

'Page Data Provider Class GetResultSet Method @1-F73C4626

    Public Sub FillItem(ByVal item As PageItem)
'End Page Data Provider Class GetResultSet Method

'Page Data Provider Class GetResultSet Method tail @1-E31F8E2A
    End Sub
'End Page Data Provider Class GetResultSet Method tail

'Page Data Provider Tail @1-A61BA892
End Class
'End Page Data Provider Tail

'Record projects_emp_Search Item Class @40-0AA69CB6
Public Class projects_emp_SearchItem
    Private _isNew As Boolean = True
    Private _isDeleted As Boolean = False
    Public errors As NameValueCollection = New NameValueCollection()

    public Sub New()
    End Sub
    Public s_project_id As IntegerField = New IntegerField("", Nothing)
    Public s_project_idItems As ItemCollection = New ItemCollection()
    Public s_emp_id As IntegerField = New IntegerField("", Nothing)
    Public s_emp_idItems As ItemCollection = New ItemCollection()

    Public Shared Function CreateFromHttpRequest() As projects_emp_SearchItem
        Dim item As projects_emp_SearchItem = New projects_emp_SearchItem()
        If Not IsNothing(DBUtility.GetInitialValue("s_project_id")) Then
        item.s_project_id.SetValue(DBUtility.GetInitialValue("s_project_id"))
        End If 
        If Not IsNothing(DBUtility.GetInitialValue("s_emp_id")) Then
        item.s_emp_id.SetValue(DBUtility.GetInitialValue("s_emp_id"))
        End If 
        If Not IsNothing(DBUtility.GetInitialValue("Button_DoSearch")) Then
        End If 
        Return item
    End Function

    Default Public Property Field(fieldName As String) As FieldBase
        Get
            Select fieldName
                Case "s_project_id"
                    Return s_project_id
                Case "s_emp_id"
                    Return s_emp_id
                Case Else
                    Throw (New ArgumentOutOfRangeException())
            End Select
        End Get
        Set (ByVal Value As FieldBase)
            Select fieldName
                Case "s_project_id"
                    s_project_id = CType(value, IntegerField)
                Case "s_emp_id"
                    s_emp_id = CType(value, IntegerField)
                Case Else
                    Throw (New ArgumentOutOfRangeException())
            End Select
        End Set
    End Property

    Public Property IsNew() As Boolean
        Get
            Return _isNew
        End Get
        Set
            _isNew = Value
        End Set
    End Property

    Public Property IsDeleted() As Boolean
        Get
            Return _isDeleted
        End Get
        Set
            _isDeleted = Value
        End Set
    End Property

    Public Sub Validate(ByVal provider As projects_emp_SearchDataProvider)
'End Record projects_emp_Search Item Class

'Record projects_emp_Search Item Class tail @40-8B704AE2
    End Sub
End Class
'End Record projects_emp_Search Item Class tail

'Record projects_emp_Search Data Provider Class @40-22D5A24F
Public Class projects_emp_SearchDataProvider
Inherits RecordDataProviderBase
'End Record projects_emp_Search Data Provider Class

'Record projects_emp_Search Data Provider Class Variables @40-92647CDB
    Protected s_project_idDataCommand As DataCommand = New TableCommand("SELECT *  " & _
          "FROM projects",New String(){},Settings.IntranetDBDataAccessObject)
    Protected s_emp_idDataCommand As DataCommand = New TableCommand("SELECT *  " & _
          "FROM employees",New String(){},Settings.IntranetDBDataAccessObject)
'End Record projects_emp_Search Data Provider Class Variables

'Record projects_emp_Search Data Provider Class GetResultSet Method @40-0BDECD55

    Public Sub FillItem(ByVal item As projects_emp_SearchItem, ByRef IsInsertMode As Boolean)
        Dim ReadNotAllowed As Boolean = IsInsertMode
        Dim E As Exception = Nothing
'End Record projects_emp_Search Data Provider Class GetResultSet Method

'Record projects_emp_Search BeforeBuildSelect @40-DD7355FB
        Dim dr As DataRowCollection = Nothing
        If Not IsInsertMode Then
'End Record projects_emp_Search BeforeBuildSelect

'Record projects_emp_Search AfterExecuteSelect @40-83591636
        End If
            IsInsertMode = True
        Dim ListBoxSource As DataRowCollection = Nothing
        Dim j As Integer
'End Record projects_emp_Search AfterExecuteSelect

'ListBox s_project_id BeforeExecuteSelect @42-BD229136
        Try
            ListBoxSource=s_project_idDataCommand.Execute().Tables(0).Rows
        Catch ee as Exception 
            E=ee
        Finally
'End ListBox s_project_id BeforeExecuteSelect

'ListBox s_project_id AfterExecuteSelect @42-3960F48E
            If Not IsNothing(E) Then Throw E
        End Try
        For j=0 To ListBoxSource.Count-1 
            Dim Key As String = (New IntegerField("", ListBoxSource(j)("project_id"))).GetFormattedValue("")
            Dim Val As Object = ListBoxSource(j)("project_name")
            item.s_project_idItems.Add(Key, Val)
        Next
'End ListBox s_project_id AfterExecuteSelect

'ListBox s_emp_id Initialize Data Source @43-F92F37B6
        s_emp_idDataCommand.OrderBy="emp_name"
'End ListBox s_emp_id Initialize Data Source

'ListBox s_emp_id BeforeExecuteSelect @43-AF31D841
        Try
            ListBoxSource=s_emp_idDataCommand.Execute().Tables(0).Rows
        Catch ee as Exception 
            E=ee
        Finally
'End ListBox s_emp_id BeforeExecuteSelect

'ListBox s_emp_id AfterExecuteSelect @43-AFB9F66A
            If Not IsNothing(E) Then Throw E
        End Try
        For j=0 To ListBoxSource.Count-1 
            Dim Key As String = (New IntegerField("", ListBoxSource(j)("emp_id"))).GetFormattedValue("")
            Dim Val As Object = ListBoxSource(j)("emp_name")
            item.s_emp_idItems.Add(Key, Val)
        Next
'End ListBox s_emp_id AfterExecuteSelect

'Record projects_emp_Search AfterExecuteSelect tail @40-E31F8E2A
    End Sub
'End Record projects_emp_Search AfterExecuteSelect tail

'Record projects_emp_Search Data Provider Class @40-A61BA892
End Class

'End Record projects_emp_Search Data Provider Class

'Grid projects_emp_grid Item Class @29-F95E1A7C
Public Class projects_emp_gridItem
    Public errors As NameValueCollection = New NameValueCollection()
    Public Sub New()
    End Sub

    Public Default Property Field(ByVal fieldName As String) as FieldBase
        Get
            Select fieldName
                Case "project_name"
                    Return Me.project_name
                Case "emp_name"
                    Return Me.emp_name
                Case "percent_allocation"
                    Return Me.percent_allocation
                Case "Link1"
                    Return Me.Link1
                Case Else
                    Throw New ArgumentOutOfRangeException()
            End Select
        End Get
        Set (ByVal Value As FieldBase)
            Select fieldName
                Case "project_name"
                    Me.project_name = CType(Value,TextField)
                Case "emp_name"
                    Me.emp_name = CType(Value,TextField)
                Case "percent_allocation"
                    Me.percent_allocation = CType(Value,FloatField)
                Case "Link1"
                    Me.Link1 = CType(Value,TextField)
                Case Else
                    Throw New ArgumentOutOfRangeException()
            End Select
        End Set
    End Property

    Public project_name As TextField = New TextField("",Nothing)
    Public project_nameHref As Object
    Public project_nameHrefParameters As LinkParameterCollection = New LinkParameterCollection()
    Public emp_name As TextField = New TextField("", Nothing)
    Public percent_allocation As FloatField = New FloatField("", Nothing)
    Public Link1 As TextField = New TextField("",Nothing)
    Public Link1Href As Object
    Public Link1HrefParameters As LinkParameterCollection = New LinkParameterCollection()
End Class
'End Grid projects_emp_grid Item Class

'Grid projects_emp_grid Data Provider Class Header @29-0FBA733B
Public Class projects_emp_gridDataProvider
Inherits GridDataProviderBase
'End Grid projects_emp_grid Data Provider Class Header

'Grid projects_emp_grid Data Provider Class Variables @29-795FC177

    Public Enum SortFields
        _Default
    End Enum

    Private SortFieldsNames As String() = New String() {"project_name"}
    Private SortFieldsNamesDesc As String() = New string() {"project_name"}
    Public SortField As SortFields = SortFields._Default
    Public SortDir As SortDirections = SortDirections._Asc
    Public RecordsPerPage As Integer = 10
    Public PageNumber As Integer = 1
    Public Urls_project_id As IntegerParameter
    Public Urls_emp_id As IntegerParameter
'End Grid projects_emp_grid Data Provider Class Variables

'Grid projects_emp_grid Data Provider Class Constructor @29-27801301

    Public Sub New()
        Select_ = New TableCommand("SELECT projects_employees.*, emp_name, project_name  " & _
          "FROM projects INNER JOIN (employees INNER JOIN projects_employees ON employees.emp_id = projects_employees.emp_id) ON projects.project_id = projects_employees.project_id",New String(){"s_project_id44","And","s_emp_id45"},Settings.IntranetDBDataAccessObject)
        Count = New TableCommand("SELECT COUNT(*)  " & _
          "FROM projects INNER JOIN (employees INNER JOIN projects_employees ON employees.emp_id = projects_employees.emp_id) ON projects.project_id = projects_employees.project_id",New String(){"s_project_id44","And","s_emp_id45"},Settings.IntranetDBDataAccessObject)
    End Sub
'End Grid projects_emp_grid Data Provider Class Constructor

'Grid projects_emp_grid Data Provider Class GetResultSet Method @29-DF77A8AE

    Public Function GetResultSet(ByRef PagesCount As Integer) As projects_emp_gridItem()
'End Grid projects_emp_grid Data Provider Class GetResultSet Method

'Before build Select @29-E315A288
        Parameters.Clear
        If IsNothing(Urls_project_id) Then
            Parameters.Add("s_project_id44","")
        Else
            Parameters.Add("s_project_id44","projects_employees.project_id = " & Select_.Dao.ToSql(Urls_project_id.GetFormattedValue(""),FieldType._Integer))
        End If
        If IsNothing(Urls_emp_id) Then
            Parameters.Add("s_emp_id45","")
        Else
            Parameters.Add("s_emp_id45","projects_employees.emp_id = " & Select_.Dao.ToSql(Urls_emp_id.GetFormattedValue(""),FieldType._Integer))
        End If
        If SortDir = SortDirections._Asc Then
            Select_.OrderBy=SortFieldsNames(CInt(SortField)).Trim()
        Else
            Select_.OrderBy=SortFieldsNamesDesc(CInt(SortField)).Trim()
        End If
'End Before build Select

'Execute Select @29-467AC0A8
        Dim ds As DataSet = Nothing, E as Exception = Nothing
        PagesCount=0
        Try
            If RecordsPerPage>0
                ds=ExecuteSelect((PageNumber-1)*RecordsPerPage,RecordsPerPage)
                PagesCount = ExecuteCount()
                m_recordCount = PagesCount
                If PagesCount Mod RecordsPerPage>0 Then
                    PagesCount = (PagesCount\RecordsPerPage)+1
                Else
                    PagesCount = PagesCount\RecordsPerPage
                End If
            Else
            ds=ExecuteSelect()
            If ds.Tables(0).Rows.Count<>0 Then 
                PagesCount=1
            End If
            End If
        Catch ee as Exception
            E=ee
        Finally
'End Execute Select

'After execute Select @29-1D2AAB4A
        If Not IsNothing(E) Then Throw E
        End Try
        Dim dr as DataRowCollection = ds.Tables(0).Rows
        Dim result(dr.Count - 1) as projects_emp_gridItem
        Dim j As Integer
'End After execute Select

'After execute Select tail @29-B0D70174
        Dim i as Integer
        For i = 0 To dr.Count - 1
            Dim item as projects_emp_gridItem = New projects_emp_gridItem()
            item.project_name.SetValue(dr(i)("project_name"),"")
            item.project_nameHrefParameters.Add("project_id",System.Web.HttpUtility.UrlEncode(dr(i)("project_id").ToString()))
            item.project_nameHrefParameters.Add("emp_id",System.Web.HttpUtility.UrlEncode(dr(i)("emp_id").ToString()))
            item.emp_name.SetValue(dr(i)("emp_name"),"")
            item.percent_allocation.SetValue(dr(i)("percent_allocation"),"")
            result(i)=item
        Next
        Return result 
    End Function
'End After execute Select tail

'Grid Data Provider tail @29-A61BA892
End Class
'End Grid Data Provider tail

'Record projects_emp_rec Item Class @58-E8837C55
Public Class projects_emp_recItem
    Private _isNew As Boolean = True
    Private _isDeleted As Boolean = False
    Public errors As NameValueCollection = New NameValueCollection()

    public Sub New()
    End Sub
    Public project_id As IntegerField = New IntegerField("", Nothing)
    Public project_idItems As ItemCollection = New ItemCollection()
    Public emp_id As IntegerField = New IntegerField("", Nothing)
    Public emp_idItems As ItemCollection = New ItemCollection()
    Public percent_allocation As FloatField = New FloatField("", Nothing)

    Public Shared Function CreateFromHttpRequest() As projects_emp_recItem
        Dim item As projects_emp_recItem = New projects_emp_recItem()
        If Not IsNothing(DBUtility.GetInitialValue("project_id")) Then
        item.project_id.SetValue(DBUtility.GetInitialValue("project_id"))
        End If 
        If Not IsNothing(DBUtility.GetInitialValue("emp_id")) Then
        item.emp_id.SetValue(DBUtility.GetInitialValue("emp_id"))
        End If 
        If Not IsNothing(DBUtility.GetInitialValue("percent_allocation")) Then
        item.percent_allocation.SetValue(DBUtility.GetInitialValue("percent_allocation"))
        End If 
        If Not IsNothing(DBUtility.GetInitialValue("Button_Insert")) Then
        End If 
        If Not IsNothing(DBUtility.GetInitialValue("Button_Update")) Then
        End If 
        If Not IsNothing(DBUtility.GetInitialValue("Button_Delete")) Then
        End If 
        If Not IsNothing(DBUtility.GetInitialValue("Button_Cancel")) Then
        End If 
        Return item
    End Function

    Default Public Property Field(fieldName As String) As FieldBase
        Get
            Select fieldName
                Case "project_id"
                    Return project_id
                Case "emp_id"
                    Return emp_id
                Case "percent_allocation"
                    Return percent_allocation
                Case Else
                    Throw (New ArgumentOutOfRangeException())
            End Select
        End Get
        Set (ByVal Value As FieldBase)
            Select fieldName
                Case "project_id"
                    project_id = CType(value, IntegerField)
                Case "emp_id"
                    emp_id = CType(value, IntegerField)
                Case "percent_allocation"
                    percent_allocation = CType(value, FloatField)
                Case Else
                    Throw (New ArgumentOutOfRangeException())
            End Select
        End Set
    End Property

    Public Property IsNew() As Boolean
        Get
            Return _isNew
        End Get
        Set
            _isNew = Value
        End Set
    End Property

    Public Property IsDeleted() As Boolean
        Get
            Return _isDeleted
        End Get
        Set
            _isDeleted = Value
        End Set
    End Property

    Public Sub Validate(ByVal provider As projects_emp_recDataProvider)
'End Record projects_emp_rec Item Class

'project_id validate @66-18CA1BFB
        If IsNothing(project_id.Value) Then
            errors.Add("project_id","The value in field Project is required.")
        ElseIf project_id.Value.ToString() ="" Then
            errors.Add("project_id","The value in field Project is required.")
        End If
'End project_id validate

'emp_id validate @64-8CE27D84
        If IsNothing(emp_id.Value) Then
            errors.Add("emp_id","The value in field Employee is required.")
        ElseIf emp_id.Value.ToString() ="" Then
            errors.Add("emp_id","The value in field Employee is required.")
        End If
'End emp_id validate

'Control percent_allocation Event OnValidate. Action Validate Maximum Value @74-5F9576DB
        If Not (percent_allocation.Value Is Nothing) Then
            If Convert.ToDouble(percent_allocation.Value) > 100 Then
                errors.Add("percent_allocation","The value in field 'Percent Allocation' cannot be greater than 100.")
            End If
        End If
'End Control percent_allocation Event OnValidate. Action Validate Maximum Value

'Record projects_emp_rec Event OnValidate. Action Custom Code @72-73254650
Dim IsUniqueValue
Dim Request As HttpRequest = HttpContext.Current.Request

 If (errors.count = 0) Then
  If (IsNew) Or (Request.QueryString("project_id") <> project_id.Value) Or (Request.QueryString("emp_id") <> emp_id.Value) Then 
    IsUniqueValue = CType(New IntegerField("",Settings.IntranetDBDataAccessObject.ExecuteScalar("SELECT project_id FROM projects_employees WHERE project_id="& project_id.Value &" AND emp_id="&emp_id.Value )).Value, Int64)
    If IsUniqueValue Then
	   errors.Add("project_id","The project is already assigned to this employee.")
	End if
  End if  
 End if  
 
'End Record projects_emp_rec Event OnValidate. Action Custom Code

'Record projects_emp_rec Item Class tail @58-8B704AE2
    End Sub
End Class
'End Record projects_emp_rec Item Class tail

'Record projects_emp_rec Data Provider Class @58-3F28EA1A
Public Class projects_emp_recDataProvider
Inherits RecordDataProviderBase
'End Record projects_emp_rec Data Provider Class

'Record projects_emp_rec Data Provider Class Variables @58-AD4363E6
    Protected project_idDataCommand As DataCommand = New TableCommand("SELECT *  " & _
          "FROM projects",New String(){},Settings.IntranetDBDataAccessObject)
    Protected emp_idDataCommand As DataCommand = New TableCommand("SELECT *  " & _
          "FROM employees",New String(){},Settings.IntranetDBDataAccessObject)
    Public Urlproject_id As IntegerParameter
    Public Urlemp_id As IntegerParameter
'End Record projects_emp_rec Data Provider Class Variables

'Record projects_emp_rec Data Provider Class Constructor @58-41A78181

    Public Sub New()
        Select_ = New TableCommand("SELECT *  " & _
          "FROM projects_employees",New String(){"project_id63","And","emp_id71"},Settings.IntranetDBDataAccessObject)
        Insert = New TableCommand("INSERT INTO projects_employees(project_id, emp_id, percent_allocation ) VALUES ( {project_id}, {emp_id}, {percent_allocation})" _
          ,New String(){},Settings.IntranetDBDataAccessObject)
        Update = New TableCommand("UPDATE projects_employees SET project_id={project_id}, emp_id={emp_id}, percent_allocation={percent_allocation}" _
          ,New String(){"project_id63","And","emp_id71"},Settings.IntranetDBDataAccessObject)
        Delete = New TableCommand("DELETE FROM projects_employees",New String(){"project_id63","And","emp_id71"},Settings.IntranetDBDataAccessObject)
    End Sub
'End Record projects_emp_rec Data Provider Class Constructor

'Record projects_emp_rec Data Provider Class LoadParams Method @58-4C1B3C42

    Protected Function LoadParams() As Boolean
        CommonParameters.Clear()
    If IsNothing(Urlproject_id) Then
        CommonParameters.Add("project_id63","")
    Else
        CommonParameters.Add("project_id63","project_id = " & Select_.Dao.ToSql(Urlproject_id.GetFormattedValue(""),FieldType._Integer))
    End If
    If IsNothing(Urlemp_id) Then
        CommonParameters.Add("emp_id71","")
    Else
        CommonParameters.Add("emp_id71","emp_id = " & Select_.Dao.ToSql(Urlemp_id.GetFormattedValue(""),FieldType._Integer))
    End If
        Return (IsNothing(Urlproject_id) Or IsNothing(Urlemp_id))
    End Function
'End Record projects_emp_rec Data Provider Class LoadParams Method

'Record projects_emp_rec Data Provider Class CheckUnique Method @58-BF56AF10

    Public Function CheckUnique(ByVal ControlName As String, ByVal item As projects_emp_recItem) As Boolean
        Return True
    End Function
'End Record projects_emp_rec Data Provider Class CheckUnique Method

'Record projects_emp_rec Data Provider Class PrepareInsert Method @58-0E277F0A

    Protected Overrides Sub PrepareInsert()
'End Record projects_emp_rec Data Provider Class PrepareInsert Method

'Record projects_emp_rec Data Provider Class PrepareInsert Method tail @58-E31F8E2A
    End Sub
'End Record projects_emp_rec Data Provider Class PrepareInsert Method tail

'Record projects_emp_rec Data Provider Class Insert Method @58-6D559BB0

    Public Function InsertItem(ByVal item As projects_emp_recItem) As Integer
'End Record projects_emp_rec Data Provider Class Insert Method

'Record projects_emp_rec Build insert @58-97FA0392
        Insert.SqlQuery.Replace("{project_id}",Insert.Dao.ToSql(item.project_id.GetFormattedValue(""),FieldType._Integer))
        Insert.SqlQuery.Replace("{emp_id}",Insert.Dao.ToSql(item.emp_id.GetFormattedValue(""),FieldType._Integer))
        Insert.SqlQuery.Replace("{percent_allocation}",Insert.Dao.ToSql(item.percent_allocation.GetFormattedValue(""),FieldType._Float))
        Dim result As Object = Nothing
        Dim E As Exception = Nothing
        Try
            result = ExecuteInsert()
        Catch ee As Exception
            E = ee
        Finally
'End Record projects_emp_rec Build insert

'Record projects_emp_rec AfterExecuteInsert @58-2FB4FB62
            If Not IsNothing(E) Then Throw E
        End Try
        Return CType(result, Integer)
    End Function
'End Record projects_emp_rec AfterExecuteInsert

'Record projects_emp_rec Data Provider Class PrepareUpdate Method @58-D72B5D1D

    Protected Overrides Sub PrepareUpdate()
        LoadParams()
        Update.Parameters = CommonParameters
'End Record projects_emp_rec Data Provider Class PrepareUpdate Method

'Record projects_emp_rec Data Provider Class PrepareUpdate Method tail @58-E31F8E2A
    End Sub
'End Record projects_emp_rec Data Provider Class PrepareUpdate Method tail

'Record projects_emp_rec Data Provider Class Update Method @58-7119720A

    Public Function UpdateItem(ByVal item As projects_emp_recItem) As Integer
'End Record projects_emp_rec Data Provider Class Update Method

'Record projects_emp_rec BeforeBuildUpdate @58-148E52D4
        Update.SqlQuery.Replace("{project_id}",Update.Dao.ToSql(item.project_id.GetFormattedValue(""),FieldType._Integer))
        Update.SqlQuery.Replace("{emp_id}",Update.Dao.ToSql(item.emp_id.GetFormattedValue(""),FieldType._Integer))
        Update.SqlQuery.Replace("{percent_allocation}",Update.Dao.ToSql(item.percent_allocation.GetFormattedValue(""),FieldType._Float))
        Dim result As Object = Nothing
        Dim E As Exception = Nothing
        Try
            result = ExecuteUpdate()
        Catch ee As Exception
            E = ee
        Finally
'End Record projects_emp_rec BeforeBuildUpdate

'Record projects_emp_rec AfterExecuteUpdate @58-2FB4FB62
            If Not IsNothing(E) Then Throw E
        End Try
        Return CType(result, Integer)
    End Function
'End Record projects_emp_rec AfterExecuteUpdate

'Record projects_emp_rec Data Provider Class PrepareDelete Method @58-998024F7

    Protected Overrides Sub PrepareDelete()
        LoadParams()
        Delete.Parameters = CommonParameters
'End Record projects_emp_rec Data Provider Class PrepareDelete Method

'Record projects_emp_rec Data Provider Class PrepareDelete Method tail @58-E31F8E2A
    End Sub
'End Record projects_emp_rec Data Provider Class PrepareDelete Method tail

'Record projects_emp_rec Data Provider Class Delete Method @58-3393434D

    Public Function DeleteItem() As Integer
'End Record projects_emp_rec Data Provider Class Delete Method

'Record projects_emp_rec BeforeBuildDelete @58-19F34D29
        Dim result As Object = Nothing
        Dim E As Exception = Nothing
        Try
            result = ExecuteDelete()
        Catch ee As Exception
            E = ee
        Finally
'End Record projects_emp_rec BeforeBuildDelete

'Record projects_emp_rec BeforeBuildDelete @58-2FB4FB62
            If Not IsNothing(E) Then Throw E
        End Try
        Return CType(result, Integer)
    End Function
'End Record projects_emp_rec BeforeBuildDelete

'PrepareSelect Method @58-34AB3510

    Protected Overrides Sub PrepareSelect()
        LoadParams()
        Select_.Parameters = CommonParameters
    End Sub
'End PrepareSelect Method

'Record projects_emp_rec Data Provider Class GetResultSet Method @58-7E6C6801

    Public Sub FillItem(ByVal item As projects_emp_recItem, ByRef IsInsertMode As Boolean)
        Dim ReadNotAllowed As Boolean = IsInsertMode
        Dim E As Exception = Nothing
'End Record projects_emp_rec Data Provider Class GetResultSet Method

'Record projects_emp_rec BeforeBuildSelect @58-0FCCC126
        IsInsertMode = LoadParams()
        Dim dr As DataRowCollection = Nothing
        If Not IsInsertMode Then
'End Record projects_emp_rec BeforeBuildSelect

'Record projects_emp_rec BeforeExecuteSelect @58-EBD3678C
            Try
                dr = ExecuteSelect().Tables(0).Rows
            Catch ee As Exception
                E = ee
            Finally
'End Record projects_emp_rec BeforeExecuteSelect

'Record projects_emp_rec AfterExecuteSelect @58-AFFEAF76
                If Not IsNothing(E) Then Throw E
        End Try
        End If
        If (Not IsInsertMode) And (Not ReadNotAllowed) Then
            If dr.Count <> 0 Then
                Dim i As Integer = 0
                item.project_id.SetValue(dr(i)("project_id"),"")
                item.emp_id.SetValue(dr(i)("emp_id"),"")
                item.percent_allocation.SetValue(dr(i)("percent_allocation"),"")
        Else
            IsInsertMode = True
            End If
        End If
        Dim ListBoxSource As DataRowCollection = Nothing
        Dim j As Integer
'End Record projects_emp_rec AfterExecuteSelect

'ListBox project_id BeforeExecuteSelect @66-A3461006
        Try
            ListBoxSource=project_idDataCommand.Execute().Tables(0).Rows
        Catch ee as Exception 
            E=ee
        Finally
'End ListBox project_id BeforeExecuteSelect

'ListBox project_id AfterExecuteSelect @66-F081E73C
            If Not IsNothing(E) Then Throw E
        End Try
        For j=0 To ListBoxSource.Count-1 
            Dim Key As String = (New IntegerField("", ListBoxSource(j)("project_id"))).GetFormattedValue("")
            Dim Val As Object = ListBoxSource(j)("project_name")
            item.project_idItems.Add(Key, Val)
        Next
'End ListBox project_id AfterExecuteSelect

'ListBox emp_id Initialize Data Source @64-215E269F
        emp_idDataCommand.OrderBy="emp_name"
'End ListBox emp_id Initialize Data Source

'ListBox emp_id BeforeExecuteSelect @64-7DC5D05E
        Try
            ListBoxSource=emp_idDataCommand.Execute().Tables(0).Rows
        Catch ee as Exception 
            E=ee
        Finally
'End ListBox emp_id BeforeExecuteSelect

'ListBox emp_id AfterExecuteSelect @64-E46BBCEC
            If Not IsNothing(E) Then Throw E
        End Try
        For j=0 To ListBoxSource.Count-1 
            Dim Key As String = (New IntegerField("", ListBoxSource(j)("emp_id"))).GetFormattedValue("")
            Dim Val As Object = ListBoxSource(j)("emp_name")
            item.emp_idItems.Add(Key, Val)
        Next
'End ListBox emp_id AfterExecuteSelect

'Record projects_emp_rec AfterExecuteSelect tail @58-E31F8E2A
    End Sub
'End Record projects_emp_rec AfterExecuteSelect tail

'Record projects_emp_rec Data Provider Class @58-A61BA892
End Class

'End Record projects_emp_rec Data Provider Class

'Page Data Provider Tail @1-5EA2E2E0
End Namespace
'End Page Data Provider Tail

