'Using Statements @1-3BA39352
Imports System
Imports System.Collections
Imports System.Collections.Specialized
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Web
Imports System.Web.SessionState
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports System.Web.UI.HtmlControls
Imports System.Text.RegularExpressions
Imports System.Globalization
Imports CCSExamplePack
Imports CCSExamplePack.Data
Imports CCSExamplePack.Configuration
Imports CCSExamplePack.Controls
Namespace MultiStepRegistration.MultiStepRegistration1
'End Using Statements

'Forms Definition @1-1CC1EF15
Public Class [MultiStepRegistration1Page]
Inherits System.Web.UI.Page
'End Forms Definition

'Forms Objects @1-FB319DF8
    Protected usersData As usersDataProvider
    Protected usersInsert1 As HtmlInputButton 
    Protected usersUpdate1 As HtmlInputButton 
    Protected usersCancel As HtmlInputButton 
    Protected usersError As System.Web.UI.WebControls.PlaceHolder
    Protected usersHolder As System.Web.UI.HtmlControls.HtmlTable
    Protected usersErrorLabel As System.Web.UI.WebControls.Label
    Protected usersInsertAllowed As Boolean = True
    Protected usersUpdateAllowed As Boolean = True
    Protected usersErrors As NameValueCollection = New NameValueCollection()
    Protected usersuser_login As System.Web.UI.WebControls.TextBox
    Protected usersuser_password As System.Web.UI.WebControls.TextBox
    Protected usersfirst_name As System.Web.UI.WebControls.TextBox
    Protected userslast_name As System.Web.UI.WebControls.TextBox
    Protected usersemail As System.Web.UI.WebControls.TextBox
'End Forms Objects

'Page_Load Event @1-A2D2CF1E

Protected Overrides Sub OnLoad(ByVal e As System.EventArgs)
'End Page_Load Event

'Page_Load Event BeforeIsPostBack @1-2AE3709F
    If Not IsPostBack Then
            Dim PageData As PageDataProvider = New PageDataProvider()
            Dim item As PageItem = PageItem.CreateFromHttpRequest()
            PageData.FillItem(item)
            usersShow()
    End If
'End Page_Load Event BeforeIsPostBack

'Page_Load Event tail @1-E31F8E2A
End Sub
'End Page_Load Event tail

'Page_Unload Event @1-D998A98F

Protected Overrides Sub OnUnload(ByVal e As System.EventArgs)
'End Page_Unload Event

'Page_Unload Event tail @1-E31F8E2A
End Sub
'End Page_Unload Event tail

'Record Form users Parameters @3-A1BEF15A

    Protected Sub usersParameters()
        Try
            usersData.Urluser_id = IntegerParameter.GetParam(Request.QueryString("user_id"))
        Catch e As Exception
            usersErrors.Add("Parameters","Form Parameters: " + e.Message)
        End Try
    End Sub
'End Record Form users Parameters

'Record Form users Show method @3-AB39C641
    Protected Sub usersShow()
        Dim AllowRead As Boolean = True
        Dim AllowInsert As Boolean = True
        Dim AllowUpdate As Boolean = True
        Dim item As usersItem = usersItem.CreateFromHttpRequest()
        Dim IsInsertMode As Boolean = Not AllowRead
        usersErrors.Add(item.errors)
        If usersErrors.Count > 0 Then
            usersShowErrors()
            Return
        End If
'End Record Form users Show method

'Record Form users BeforeShow tail @3-5C593C54
        usersParameters()
        usersData.FillItem(item, IsInsertMode)
        usersInsert1.Visible = IsInsertMode And AllowInsert
        usersUpdate1.Visible = (Not IsInsertMode) And AllowUpdate
        usersuser_login.Text=item.user_login.GetFormattedValue()
        usersuser_password.Text=item.user_password.GetFormattedValue()
        usersfirst_name.Text=item.first_name.GetFormattedValue()
        userslast_name.Text=item.last_name.GetFormattedValue()
        usersemail.Text=item.email.GetFormattedValue()
'End Record Form users BeforeShow tail

'Record Form users Show method tail @3-02197FA5
        If usersErrors.Count > 0 Then
            usersShowErrors()
        End If
    End Sub
'End Record Form users Show method tail

'Record Form users LoadItemFromRequest method @3-0556938E

    Protected Sub usersLoadItemFromRequest(item As usersItem, ByVal EnableValidation As Boolean)
        item.user_login.SetValue(usersuser_login.Text)
        item.user_password.SetValue(usersuser_password.Text)
        item.first_name.SetValue(usersfirst_name.Text)
        item.last_name.SetValue(userslast_name.Text)
        item.email.SetValue(usersemail.Text)
        If EnableValidation Then
            item.Validate(usersData)
        End If
        usersErrors.Add(item.errors)
    End Sub
'End Record Form users LoadItemFromRequest method

'Record Form users GetRedirectUrl method @3-B7006AB4

    Protected Function GetusersRedirectUrl(ByVal redirect As String, ByVal removeList As String) As String
        Dim Params As String = ""
        Dim List() As String = {""}

        List = (RemoveList).ToLower().Split(New Char() {";"})
        If Redirect= "" Then
            Redirect = "MultiStepRegistration2.aspx"
        End If
        Dim j As Integer
        For j=0 To Request.QueryString.Count - 1
            If Array.IndexOf(List,Request.QueryString.AllKeys(j).ToLower()) < 0 Then
                Params = Params & Request.QueryString.AllKeys(j) & "=" & Server.UrlEncode(Request.QueryString(j)) & "&"
            End If
        Next j
        Params = Params.TrimEnd(New Char(){"&"})
        Return Redirect & "?" & Params
    End Function
'End Record Form users GetRedirectUrl method

'Record Form users ShowErrors method @3-2BBFE30D

    Protected Sub usersShowErrors()
        Dim DefaultMessage As String = ""
        Dim i As Integer
        For i = 0 To usersErrors.Count - 1
        Select Case usersErrors.AllKeys(i)
            Case Else
                DefaultMessage = DefaultMessage & usersErrors(i) & "<br>"
        End Select
        Next i
        usersError.Visible = True
        usersErrorLabel.Text = DefaultMessage
    End Sub
'End Record Form users ShowErrors method

'Record Form users Insert Operation @3-6011B757

    Protected Sub users_Insert(ByVal sender As Object, ByVal e As System.EventArgs)
        Dim item As usersItem = New usersItem()
        Dim ExecuteFlag As Boolean = True
        Dim ErrorFlag As Boolean = False
        Dim RedirectUrl As String = GetusersRedirectUrl("", "")
'End Record Form users Insert Operation

'Record Form users BeforeInsert tail @3-39E1BB02
    usersParameters()
    usersLoadItemFromRequest(item, True)
    If usersInsertAllowed Then
        ErrorFlag=(usersErrors.Count > 0)
        If ExecuteFlag And (Not ErrorFlag) Then
            Try
                usersData.InsertItem(item)
            Catch ex As Exception
                usersErrors.Add("DataProvider",ex.Message)
                ErrorFlag = True
            End Try
        End If
'End Record Form users BeforeInsert tail

'Record users Event AfterInsert. Action Custom Code @47-73254650
Dim LastID

'Retrieve the last inserted key if the new user is registered
'This method of retrieving the last inserted key is safe because the value of the user_login field has to be unique.
  If IsNothing(Request.QueryString("user_id")) Then 
      LastID = CType((New IntegerField("",Settings.InternetDBDataAccessObject.ExecuteScalar("SELECT max(user_id) FROM users WHERE user_login=" &"'"& usersuser_login.Text &"'"  ))).Value, Int64)
	  RedirectUrl = RedirectUrl & "user_id=" & LastID
  End IF

'End Record users Event AfterInsert. Action Custom Code

'Record Form users AfterInsert tail  @3-4B29F018
        End If
        If ErrorFlag Then
            usersShowErrors()
        Else
            Response.Redirect(RedirectUrl)
        End If
    End Sub
'End Record Form users AfterInsert tail 

'Record Form users Update Operation @3-07CCACC1

    Protected Sub users_Update(ByVal sender As Object, ByVal e As System.EventArgs)
        Dim item As usersItem = New usersItem()
        item.IsNew = False
        Dim ExecuteFlag As Boolean = True
        Dim ErrorFlag As Boolean = False
        Dim RedirectUrl As String = GetusersRedirectUrl("", "")
'End Record Form users Update Operation

'Record Form users Before Update tail @3-3A0EF085
        usersParameters()
        usersLoadItemFromRequest(item, True)
        If usersUpdateAllowed Then
        ErrorFlag = (usersErrors.Count > 0)
        If ExecuteFlag And (Not ErrorFlag) Then
            Try
                usersData.UpdateItem(item)
            Catch ex As Exception
                usersErrors.Add("DataProvider",ex.Message)
                ErrorFlag = True
            End Try
        End If
'End Record Form users Before Update tail

'Record Form users Update Operation tail @3-4B29F018
        End If
        If ErrorFlag Then
            usersShowErrors()
        Else
            Response.Redirect(RedirectUrl)
        End If
    End Sub
'End Record Form users Update Operation tail

'Record Form users Cancel Operation @3-FF400712

    Protected Sub users_Cancel(ByVal sender As Object, ByVal e As System.EventArgs)
        Dim item As usersItem = New usersItem()
        Dim RedirectUrl As String = GetusersRedirectUrl("MultiStepRegistrationGrid.aspx", "")
        usersLoadItemFromRequest(item, False)
'End Record Form users Cancel Operation

'Record Form users Cancel Operation tail @3-EA2B0FFB
        Response.Redirect(RedirectUrl)
    End Sub
'End Record Form users Cancel Operation tail

'OnInit Event @1-71600462
    #Region " Web Form Designer Generated Code "
    Protected Overrides Sub OnInit(ByVal e As EventArgs)
        '
        ' CODEGEN: This call is required by the ASP.NET Web Form Designer.
        '
        InitializeComponent()
        'Me.Load += new System.EventHandler(this.Page_Load);
        'Me.Unload += new System.EventHandler(this.Page_Unload);
        usersData = New usersDataProvider()
        MyBase.OnInit(e)
'End OnInit Event

'OnInit Event tail @1-E31F8E2A
    End Sub
'End OnInit Event tail

'InitializeComponent Event @1-EA5E2628
    ' <summary>
    ' Required method for Designer support - do not modify
    ' the contents of this method with the code editor.
    ' </summary>
    Private Sub InitializeComponent()
    End Sub
    #End Region
'End InitializeComponent Event

'Page class tail @1-DD082417
End Class
End Namespace
'End Page class tail

