//Using Statements @1-949F51D8
using System;
using System.Collections;
using System.Collections.Specialized;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Text.RegularExpressions;
using System.Globalization;
using CCSExamplePack;
using CCSExamplePack.Data;
using CCSExamplePack.Configuration;
using CCSExamplePack.Controls;

namespace CCSExamplePack.NavGrid.NavGrid
{

//End Using Statements

//Forms Definition @1-C0DB6913
public class NavGridPage : System.Web.UI.Page
{
//End Forms Definition

int CurrentRecord;

//Forms Objects @1-F8422B4B
    protected employeesSearchDataProvider employeesSearchData;
    protected HtmlInputButton employeesSearchDoSearch;
    protected System.Web.UI.WebControls.PlaceHolder employeesSearchError;
    protected System.Web.UI.HtmlControls.HtmlTable employeesSearchHolder;
    protected System.Web.UI.WebControls.Label employeesSearchErrorLabel;
    protected NameValueCollection employeesSearchErrors=new NameValueCollection();
    protected System.Web.UI.HtmlControls.HtmlAnchor employeesSearchLink1;
    protected System.Web.UI.WebControls.TextBox employeesSearchs_emp_name;
    protected System.Web.UI.WebControls.Repeater employeesRepeater;
    protected employeesDataProvider employeesData;
//End Forms Objects

//Page_Load Event @1-55207E05
private void Page_Load(object sender, System.EventArgs e)
{
//End Page_Load Event

//Page_Load Event BeforeIsPostBack @1-5936AE3B
    if (!IsPostBack)
    {
            PageDataProvider PageData=new PageDataProvider();
            PageItem item=PageItem.CreateFromHttpRequest();
            PageData.FillItem(item);
            employeesSearchShow();
            employeesBind();
    }
//End Page_Load Event BeforeIsPostBack

//Page_Load Event tail @1-FCB6E20C
}
//End Page_Load Event tail

//Page_Unload Event @1-72102C7C
private void Page_Unload(object sender, System.EventArgs e)
{
//End Page_Unload Event

//Page_Unload Event tail @1-FCB6E20C
}
//End Page_Unload Event tail

//Record Form employeesSearch Parameters @24-E6EA4341
    protected void employeesSearchParameters()
    {
        try{
        }catch(Exception e){
            employeesSearchErrors.Add("Parameters","Form parameters: " + e.Message);
        }
    }
//End Record Form employeesSearch Parameters

//Record Form employeesSearch Show method @24-EAFA3A2A
    protected void employeesSearchShow()
    {
        bool AllowRead = true;
        employeesSearchItem item=employeesSearchItem.CreateFromHttpRequest();
        bool IsInsertMode=!AllowRead;
        item.Link1Href = "NavGrid_desc.aspx";
        employeesSearchErrors.Add(item.errors);
//End Record Form employeesSearch Show method

//Grid Form employeesSearch BeforeShow tail @24-83BB5056
        employeesSearchParameters();
        employeesSearchData.FillItem(item,ref IsInsertMode);
        employeesSearchLink1.InnerText += item.Link1.GetFormattedValue().Replace("\r","").Replace("\n","<br>");
        employeesSearchLink1.HRef += item.Link1Href+item.Link1HrefParameters.ToString("None","", ViewState);
        employeesSearchs_emp_name.Text=item.s_emp_name.GetFormattedValue();
//End Grid Form employeesSearch BeforeShow tail

//Record Form employeesSearch Show method tail @24-7A0DB7A0
        if(employeesSearchErrors.Count>0)
            employeesSearchShowErrors();
    }
//End Record Form employeesSearch Show method tail

//Record Form employeesSearch LoadItemFromRequest method @24-4D347AEC
    protected void employeesSearchLoadItemFromRequest(employeesSearchItem item, bool EnableValidation)
    {
        item.s_emp_name.SetValue(employeesSearchs_emp_name.Text);
        if(EnableValidation)
            item.Validate(employeesSearchData);
        employeesSearchErrors.Add(item.errors);
    }
//End Record Form employeesSearch LoadItemFromRequest method

//Record Form employeesSearch GetRedirectUrl method @24-52A8859C
    protected string GetemployeesSearchRedirectUrl(string redirectString ,string removeList)
    {
        string Params="";
        string[] List;

        if(removeList=="")
            List=new string[1];
        else
            List=(removeList).ToLower().Split(new Char[] {';'});

        if(redirectString == "") redirectString = "NavGrid.aspx";
        for(int i=0;i<Request.Form.Count;i++)
        {
            if(Array.IndexOf(List,Request.Form.AllKeys[i].ToLower()) < 0 && Request.Form.AllKeys[i] != "__EVENTTARGET" && Request.Form.AllKeys[i] != "__EVENTARGUMENT" && Request.Form.AllKeys[i] != "__VIEWSTATE")
                Params += Request.Form.AllKeys[i] + "=" + Server.UrlEncode(Request.Form[i]) + "&";
        }
        Params = Params.TrimEnd(new Char[]{'&'});
        return redirectString + "?" + Params;
    }

//End Record Form employeesSearch GetRedirectUrl method

//Record Form employeesSearch ShowErrors method @24-8CB7F3AB
    protected void employeesSearchShowErrors()
    {
        string DefaultMessage="";
        for(int i=0;i<employeesSearchErrors.Count;i++)
        switch(employeesSearchErrors.AllKeys[i])
        {
            default:
                DefaultMessage+=employeesSearchErrors[i]+"<br>";
                break;
        }
        employeesSearchError.Visible = true;
        employeesSearchErrorLabel.Text = DefaultMessage;
    }
//End Record Form employeesSearch ShowErrors method

//Record Form employeesSearch Search Operation @24-2735BC87
    protected void employeesSearch_Search(object sender, System.EventArgs e)
    {
        bool ErrorFlag=false;
        employeesSearchItem item=new employeesSearchItem();
        employeesSearchLoadItemFromRequest(item, true);
        ErrorFlag=(employeesSearchErrors.Count>0);
//End Record Form employeesSearch Search Operation

//Record Form employeesSearch Search Operation tail @24-3816AFD9
        if(ErrorFlag)
            employeesSearchShowErrors();
        else{
            string Params="";
            Params+=employeesSearchs_emp_name.Text!=""?("s_emp_name="+Server.UrlEncode(employeesSearchs_emp_name.Text)+"&"):"";
            string RedirectUrl = GetemployeesSearchRedirectUrl("", "s_emp_name");
            if( RedirectUrl.EndsWith("?"))
                RedirectUrl += Params;
            else
                RedirectUrl += "&" + Params;
            RedirectUrl = RedirectUrl.TrimEnd(new Char[]{'&'});
            Response.Redirect(RedirectUrl);
        }
    }
//End Record Form employeesSearch Search Operation tail

//Grid employees Bind @2-9031C015
    protected void employeesBind()
    {
        int PagesCount;
        int FooterIndex;
        if (!IsPostBack)
        {
            string Param;
            int PageSize;
            ViewState["employeesSortField"] = employeesDataProvider.SortFields.Default;
            PageSize = 5;
            ViewState["employeesPageNumber"] = 1;
            Param = Request.QueryString["employeesOrder"];
            if (Param != null && Param.Length > 0)
                try{
                    employeesDataProvider.SortFields SortField = 0;
                    ViewState["employeesSortField"] = Enum.Parse(SortField.GetType(), Param);
                }catch {}
            Param = Request.QueryString["employeesDir"];
            if (Param == null || Param.Length == 0 || Param.ToLower() == "desc")
                ViewState["employeesSortDir"] = SortDirections.Desc;
            else
                ViewState["employeesSortDir"] = SortDirections.Asc;
            Param = Request.QueryString["employeesPage"];
            int PageNumber;
            if (Param != null && Param.Length > 0)
                try
                {
                    PageNumber = Int32.Parse(Param);
                    if (PageNumber > 0) ViewState["employeesPageNumber"] = PageNumber;
                }
                catch {}
            Param = Request.QueryString["employeesPageSize"];
            if (Param != null && Param.Length > 0)
                try
                {
                    PageSize = Int32.Parse(Param);
                    if (PageSize <= 0) PageSize = 5;
                }
                catch {}
            if (PageSize > 100)
                PageSize = 100;
            ViewState["employeesPageSize"] = PageSize;
        }
//End Grid employees Bind

//Grid Form employees BeforeShow tail @2-D40B94D3
        employeesParameters();
        employeesData.SortField = (employeesDataProvider.SortFields)ViewState["employeesSortField"];
        employeesData.SortDir = (SortDirections)ViewState["employeesSortDir"];
        employeesData.PageNumber = (int)ViewState["employeesPageNumber"];
        employeesData.RecordsPerPage = (int)ViewState["employeesPageSize"];
        employeesRepeater.DataSource = employeesData.GetResultSet(out PagesCount);
        ViewState["employeesPagesCount"] = PagesCount;
        employeesRepeater.DataBind();
        FooterIndex = employeesRepeater.Controls.Count - 1;
        if (PagesCount == 0)
        {
            employeesRepeater.Controls[FooterIndex].FindControl("NoRecords").Visible = true;
        }


        if(employeesData.SortField.ToString()=="Sorter_emp_name") 
            ((CCSExamplePack.Controls.Sorter)employeesRepeater.Controls[0].FindControl("Sorter_emp_nameSorter")).State=employeesData.SortDir==SortDirections.Asc?SorterState.Ascending:SorterState.Descending;
        if(employeesData.SortField.ToString()=="Sorter_title") 
            ((CCSExamplePack.Controls.Sorter)employeesRepeater.Controls[0].FindControl("Sorter_titleSorter")).State=employeesData.SortDir==SortDirections.Asc?SorterState.Ascending:SorterState.Descending;
        if(employeesData.SortField.ToString()=="Sorter_department_name") 
            ((CCSExamplePack.Controls.Sorter)employeesRepeater.Controls[0].FindControl("Sorter_department_nameSorter")).State=employeesData.SortDir==SortDirections.Asc?SorterState.Ascending:SorterState.Descending;
        CCSExamplePack.Controls.Navigator Navigator1Navigator = (CCSExamplePack.Controls.Navigator)employeesRepeater.Controls[FooterIndex].FindControl("Navigator1Navigator");
        Navigator1Navigator.MaxPage=PagesCount;
        Navigator1Navigator.PageNumber=employeesData.PageNumber;
        Navigator1Navigator.DataBind();
//End Grid Form employees BeforeShow tail

//Grid employees Bind tail @2-FCB6E20C
    }
//End Grid employees Bind tail

//Grid employees Table Parameters @2-B390922E
    protected void employeesParameters()
    {
        try{
            employeesData.Urls_emp_name= TextParameter.GetParam(Request.QueryString["s_emp_name"]);
        }catch{
            ControlCollection ParentControls=employeesRepeater.Parent.Controls;
            int RepeaterIndex=ParentControls.IndexOf(employeesRepeater);
            ParentControls.RemoveAt(RepeaterIndex);
            Literal ErrorMessage=new Literal();
            ErrorMessage.Text="Error in Grid employees: Invalid parameter";
            ParentControls.AddAt(RepeaterIndex,ErrorMessage);
        }
	}
	
//End Grid employees Table Parameters

//Grid employees ItemDataBound event @2-0AD27D72
    protected void employeesItemDataBound(Object Sender, RepeaterItemEventArgs e)
    {
        employeesItem DataItem=(employeesItem)e.Item.DataItem;
        if (e.Item.ItemType == ListItemType.Item || e.Item.ItemType == ListItemType.AlternatingItem) {
            System.Web.UI.HtmlControls.HtmlAnchor employeesemp_name = (System.Web.UI.HtmlControls.HtmlAnchor)(e.Item.FindControl("employeesemp_name"));
            DataItem.emp_nameHref = "NavGrid_Detail.aspx?";
            employeesemp_name.HRef += DataItem.emp_nameHref + DataItem.emp_nameHrefParameters.ToString("GET","employeesPage", ViewState);
        }
//End Grid employees ItemDataBound event

//Grid employees Event BeforeShowRow. Action Custom Code @22-2A29BDB7

  if (e.Item.ItemType == ListItemType.Item || e.Item.ItemType == ListItemType.AlternatingItem) {
      System.Web.UI.HtmlControls.HtmlAnchor employeesemp_name = (System.Web.UI.HtmlControls.HtmlAnchor)(e.Item.FindControl("employeesemp_name"));

    //Calculate the number of records up to the current page
    int PreviousRecords = (int)ViewState["employeesPageSize"] * ((int)ViewState["employeesPageNumber"]-1);

    CurrentRecord = CurrentRecord + 1;
    //Calculate and store the current page number in the empBackPage parameter of the Emp_Name link.
    employeesemp_name.HRef += "&empBackPage="+ ViewState["employeesPageNumber"];
    
	//'Calculate and store each employee's record number in the employeesPage parameter of their corresponding Emp_Name links.
    //This parameter is used automatically by the Navigator of the Grid on the detail page NavGrid_Detail.
    employeesemp_name.HRef += "&employeesPage=" + (PreviousRecords + CurrentRecord);
  }

//End Grid employees Event BeforeShowRow. Action Custom Code

//Grid employees ItemDataBound event tail @2-FCB6E20C
    }
//End Grid employees ItemDataBound event tail

//Grid employees ItemCommand event @2-484F40B1
    protected void employeesItemCommand(Object Sender, RepeaterCommandEventArgs e)
    {
        int FooterIndex = employeesRepeater.Controls.Count - 1;
        bool BindAllowed = false;
        if(e.CommandName=="Sort"){
            if(((SorterState)e.CommandArgument)==SorterState.None)
                if((SortDirections)ViewState["employeesSortDir"]==SortDirections.Asc&&ViewState["employeesSortField"].ToString()==((CCSExamplePack.Controls.Sorter)e.CommandSource).Field)
                    ViewState["employeesSortDir"]=SortDirections.Desc;
                else
                    ViewState["employeesSortDir"]=SortDirections.Asc;
            else
                ViewState["employeesSortDir"]=(int)(((CCSExamplePack.Controls.Sorter)e.CommandSource).State);
            ViewState["employeesSortField"]=Enum.Parse(typeof(employeesDataProvider.SortFields),((CCSExamplePack.Controls.Sorter)e.CommandSource).Field);
            ViewState["employeesPageNumber"] = 1;
            BindAllowed = true;
        }
        if(e.CommandName=="Navigate"){
            ViewState["employeesPageNumber"] = Int32.Parse(e.CommandArgument.ToString());
            BindAllowed = true;
        }
        if (BindAllowed)
            employeesBind();
    }
//End Grid employees ItemCommand event

//OnInit Event @1-A8828ACD
    #region Web Form Designer generated code
    override protected void OnInit(EventArgs e)
    {
        //
        //CODEGEN: This call is required by the ASP.NET Web Form Designer.
        //
        InitializeComponent();
        this.Load += new System.EventHandler(this.Page_Load);
        this.Unload += new System.EventHandler(this.Page_Unload);
        employeesSearchData = new employeesSearchDataProvider();
        employeesData = new employeesDataProvider();
        base.OnInit(e);
//End OnInit Event

//OnInit Event tail @1-FCB6E20C
    }
//End OnInit Event tail

//InitializeComponent Event @1-722FC1EE
    /// <summary>
    /// Required method for Designer support - do not modify
    /// the contents of this method with the code editor.
    /// </summary>
    private void InitializeComponent()
    {
    }
    #endregion
//End InitializeComponent Event

//Page class tail @1-F5FC18C5
}
}
//End Page class tail

