'Using Statements @1-BD846736
Imports System
Imports System.Collections
Imports System.Collections.Specialized
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Web
Imports System.Web.SessionState
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports System.Web.UI.HtmlControls
Imports System.Text.RegularExpressions
Imports System.Globalization
Imports CCSExamplePack
Imports CCSExamplePack.Data
Imports CCSExamplePack.Configuration
Imports CCSExamplePack.Controls
Namespace NavGrid.NavGrid
'End Using Statements

'Forms Definition @1-090FB709
Public Class [NavGridPage]
Inherits System.Web.UI.Page
'End Forms Definition

Dim PreviousRecords As Integer
Dim CurrentRecord As Integer

'Forms Objects @1-8A4D131E
    Protected employeesSearchData As employeesSearchDataProvider
    Protected employeesSearchDoSearch As HtmlInputButton 
    Protected employeesSearchError As System.Web.UI.WebControls.PlaceHolder
    Protected employeesSearchHolder As System.Web.UI.HtmlControls.HtmlTable
    Protected employeesSearchErrorLabel As System.Web.UI.WebControls.Label
    Protected employeesSearchErrors As NameValueCollection = New NameValueCollection()
    Protected employeesSearchLink1 As System.Web.UI.HtmlControls.HtmlAnchor
    Protected employeesSearchs_emp_name As System.Web.UI.WebControls.TextBox
    Protected employeesRepeater As  System.Web.UI.WebControls.Repeater
    Protected employeesData As employeesDataProvider
'End Forms Objects

'Page_Load Event @1-A2D2CF1E

Protected Overrides Sub OnLoad(ByVal e As System.EventArgs)
'End Page_Load Event

'Page_Load Event BeforeIsPostBack @1-FE3B9603
    If Not IsPostBack Then
            Dim PageData As PageDataProvider = New PageDataProvider()
            Dim item As PageItem = PageItem.CreateFromHttpRequest()
            PageData.FillItem(item)
            employeesSearchShow()
            employeesBind
    End If
'End Page_Load Event BeforeIsPostBack

'Page_Load Event tail @1-E31F8E2A
End Sub
'End Page_Load Event tail

'Page_Unload Event @1-D998A98F

Protected Overrides Sub OnUnload(ByVal e As System.EventArgs)
'End Page_Unload Event

'Page_Unload Event tail @1-E31F8E2A
End Sub
'End Page_Unload Event tail

'Record Form employeesSearch Parameters @24-B88DDEB3

    Protected Sub employeesSearchParameters()
    End Sub
'End Record Form employeesSearch Parameters

'Record Form employeesSearch Show method @24-C949059D
    Protected Sub employeesSearchShow()
        Dim AllowRead As Boolean = True
        Dim item As employeesSearchItem = employeesSearchItem.CreateFromHttpRequest()
        Dim IsInsertMode As Boolean = Not AllowRead
        item.Link1Href = "NavGrid_desc.aspx"
        employeesSearchErrors.Add(item.errors)
        If employeesSearchErrors.Count > 0 Then
            employeesSearchShowErrors()
            Return
        End If
'End Record Form employeesSearch Show method

'Record Form employeesSearch BeforeShow tail @24-5201ABC3
        employeesSearchParameters()
        employeesSearchData.FillItem(item, IsInsertMode)
        employeesSearchLink1.InnerText += item.Link1.GetFormattedValue().Replace(vbCrLf,"")
        employeesSearchLink1.HRef += item.Link1Href & item.Link1HrefParameters.ToString("None","", ViewState)
        employeesSearchs_emp_name.Text=item.s_emp_name.GetFormattedValue()
'End Record Form employeesSearch BeforeShow tail

'Record Form employeesSearch Show method tail @24-F49AB662
        If employeesSearchErrors.Count > 0 Then
            employeesSearchShowErrors()
        End If
    End Sub
'End Record Form employeesSearch Show method tail

'Record Form employeesSearch LoadItemFromRequest method @24-2FCC8879

    Protected Sub employeesSearchLoadItemFromRequest(item As employeesSearchItem, ByVal EnableValidation As Boolean)
        item.s_emp_name.SetValue(employeesSearchs_emp_name.Text)
        If EnableValidation Then
            item.Validate(employeesSearchData)
        End If
        employeesSearchErrors.Add(item.errors)
    End Sub
'End Record Form employeesSearch LoadItemFromRequest method

'Record Form employeesSearch GetRedirectUrl method @24-4B44B419

    Protected Function GetemployeesSearchRedirectUrl(ByVal redirect As String, ByVal removeList As String) As String
        Dim Params As String = ""
        Dim List() As String = {""}

        List = (RemoveList).ToLower().Split(New Char() {";"})
        If Redirect= "" Then
            Redirect = "NavGrid.aspx"
        End If
        Dim i As Integer
        For i=0 To Request.Form.Count - 1
            If Array.IndexOf(List,Request.Form.AllKeys(i).ToLower()) < 0 And Request.Form.AllKeys(i) <> "__EVENTTARGET" And Request.Form.AllKeys(i) <> "__EVENTARGUMENT" And Request.Form.AllKeys(i) <> "__VIEWSTATE" Then
                Params = Params & Request.Form.AllKeys(i) & "=" & Server.UrlEncode(Request.Form(i)) & "&"
            End If
        Next i
        Params = Params.TrimEnd(New Char(){"&"})
        Return Redirect & "?" & Params
    End Function
'End Record Form employeesSearch GetRedirectUrl method

'Record Form employeesSearch ShowErrors method @24-DF0E48CC

    Protected Sub employeesSearchShowErrors()
        Dim DefaultMessage As String = ""
        Dim i As Integer
        For i = 0 To employeesSearchErrors.Count - 1
        Select Case employeesSearchErrors.AllKeys(i)
            Case Else
                DefaultMessage = DefaultMessage & employeesSearchErrors(i) & "<br>"
        End Select
        Next i
        employeesSearchError.Visible = True
        employeesSearchErrorLabel.Text = DefaultMessage
    End Sub
'End Record Form employeesSearch ShowErrors method

'Record Form employeesSearch Search Operation @24-28193E67

    Protected Sub employeesSearch_Search(ByVal sender As Object, ByVal e As System.EventArgs)
        Dim ErrorFlag As Boolean = False
        Dim item As employeesSearchItem = New employeesSearchItem()
        employeesSearchLoadItemFromRequest(item, True)
        ErrorFlag = (employeesSearchErrors.Count > 0)
'End Record Form employeesSearch Search Operation

'Record Form employeesSearch Search Operation tail @24-1FDF24F2
        If ErrorFlag Then
            employeesSearchShowErrors()
        Else
            Dim Params As String = ""
            Dim li As ListItem
            Params = Params & IIf(employeesSearchs_emp_name.Text <> "",("s_emp_name=" & Server.UrlEncode(employeesSearchs_emp_name.Text) & "&"), "")
            Dim RedirectUrl As String = GetemployeesSearchRedirectUrl("", "s_emp_name")
            If RedirectUrl.EndsWith("?") Then
                RedirectUrl &= Params
            Else
                RedirectUrl &= "&" & Params
            End If
            RedirectUrl = RedirectUrl.TrimEnd(New Char(){"&"})
            Response.Redirect(RedirectUrl)
        End If
    End Sub
'End Record Form employeesSearch Search Operation tail

'Grid employees Bind @2-A5BC4EF6

    Protected Sub employeesBind()
        Dim PagesCount As Integer
        Dim FooterIndex As Integer
        If Not(IsPostBack) Then
            Dim Param As String
            Param = Request.QueryString("employeesOrder")
            Try
                Dim sf As employeesDataProvider.SortFields = 0
                ViewState("employeesSortField") = [Enum].Parse(sf.GetType(), Param)
            Catch
                ViewState("employeesSortField") = employeesDataProvider.SortFields._Default
            End Try

            Param = Request.QueryString("employeesDir")
            If IsNothing(Param) Then
                ViewState("employeesSortDir") = SortDirections._Desc
            Else
                If Param.Length = 0 Or Param.ToLower() = "desc" Then
                    ViewState("employeesSortDir") = SortDirections._Desc
                Else
                    ViewState("employeesSortDir") = SortDirections._Asc
                End If
            End If
            Param = Request.QueryString("employeesPage")
            Dim PageNumber as Integer
            Try
                PageNumber = Int32.Parse(Param)
                If PageNumber <= 0 Then PageNumber = 1
            Catch
                PageNumber = 1
            End Try
            ViewState("employeesPageNumber") = PageNumber
            Param = Request.QueryString("employeesPageSize")
            Try
                PageNumber = Int32.Parse(Param)
                If PageNumber <= 0 Then PageNumber = 5
            Catch
                PageNumber = 5
            End Try
            If PageNumber > 100 Then
                PageNumber = 100
            End If
            ViewState("employeesPageSize") = PageNumber
        End If
'End Grid employees Bind

'Grid Form employees BeforeShow tail @2-23FE43EF
        employeesParameters
        employeesData.SortField = CType(ViewState("employeesSortField"),employeesDataProvider.SortFields)
        employeesData.SortDir = CType(ViewState("employeesSortDir"),SortDirections)
        employeesData.PageNumber = CInt(ViewState("employeesPageNumber"))
        employeesData.RecordsPerPage = CInt(ViewState("employeesPageSize"))
        employeesRepeater.DataSource = employeesData.GetResultSet(PagesCount)
        ViewState("employeesPagesCount") = PagesCount
        employeesRepeater.DataBind
        FooterIndex = employeesRepeater.Controls.Count - 1
        If PagesCount = 0 Then
            employeesRepeater.Controls(FooterIndex).FindControl("NoRecords").Visible = True
        End If


        If employeesData.SortField.ToString()="Sorter_emp_name" Then
            If employeesData.SortDir=SortDirections._Asc Then
                CType(employeesRepeater.Controls(0).FindControl("Sorter_emp_nameSorter"),Controls.Sorter).State = SorterState.Ascending
            Else
                CType(employeesRepeater.Controls(0).FindControl("Sorter_emp_nameSorter"),Controls.Sorter).State = SorterState.Descending
            End If
        End If
        If employeesData.SortField.ToString()="Sorter_title" Then
            If employeesData.SortDir=SortDirections._Asc Then
                CType(employeesRepeater.Controls(0).FindControl("Sorter_titleSorter"),Controls.Sorter).State = SorterState.Ascending
            Else
                CType(employeesRepeater.Controls(0).FindControl("Sorter_titleSorter"),Controls.Sorter).State = SorterState.Descending
            End If
        End If
        If employeesData.SortField.ToString()="Sorter_department_name" Then
            If employeesData.SortDir=SortDirections._Asc Then
                CType(employeesRepeater.Controls(0).FindControl("Sorter_department_nameSorter"),Controls.Sorter).State = SorterState.Ascending
            Else
                CType(employeesRepeater.Controls(0).FindControl("Sorter_department_nameSorter"),Controls.Sorter).State = SorterState.Descending
            End If
        End If
        Dim Navigator1Navigator As Controls.Navigator = CType(employeesRepeater.Controls(FooterIndex).FindControl("Navigator1Navigator"),Controls.Navigator)
        Navigator1Navigator.MaxPage=PagesCount
        Navigator1Navigator.PageNumber=employeesData.PageNumber
        Navigator1Navigator.DataBind
'End Grid Form employees BeforeShow tail

'Grid employees Bind tail @2-E31F8E2A
    End Sub
'End Grid employees Bind tail

'Grid employees Table Parameters @2-E66943E3

    Protected Sub employeesParameters()
        Try
            employeesData.Urls_emp_name= TextParameter.GetParam(Request.QueryString("s_emp_name"))

        Catch
            Dim ParentControls As ControlCollection=employeesRepeater.Parent.Controls
            Dim RepeaterIndex As Integer=ParentControls.IndexOf(employeesRepeater)
            ParentControls.RemoveAt(RepeaterIndex)
            Dim ErrorMessage as Literal=New Literal()
            ErrorMessage.Text="Error in Grid employees: Invalid parameter"
            ParentControls.AddAt(RepeaterIndex,ErrorMessage)
        End Try
    End Sub
'End Grid employees Table Parameters

'Grid employees ItemDataBound event @2-A37367FF

    Protected Sub employeesItemDataBound(Sender as Object, e as RepeaterItemEventArgs)
        Dim DataItem as employeesItem=CType(e.Item.DataItem,employeesItem)
        If e.Item.ItemType = ListItemType.Item Or e.Item.ItemType = ListItemType.AlternatingItem Then
            Dim employeesemp_name As System.Web.UI.HtmlControls.HtmlAnchor = DirectCast(e.Item.FindControl("employeesemp_name"),System.Web.UI.HtmlControls.HtmlAnchor)
            DataItem.emp_nameHref = "NavGrid_Detail.aspx?"
            employeesemp_name.HRef += DataItem.emp_nameHref & DataItem.emp_nameHrefParameters.ToString("GET","employeesPage", ViewState)
        End If
'End Grid employees ItemDataBound event


'Grid employees Event BeforeShowRow. Action Custom Code @22-73254650
  
    If e.Item.ItemType = ListItemType.Item Or e.Item.ItemType = ListItemType.AlternatingItem Then
       Dim employeesemp_name As System.Web.UI.HtmlControls.HtmlAnchor = DirectCast(e.Item.FindControl("employeesemp_name"),System.Web.UI.HtmlControls.HtmlAnchor)
  
      'Calculate the number of records up to the current page
      PreviousRecords = CInt(ViewState("employeesPageSize")) * (CInt(ViewState("employeesPageNumber"))-1)
  
      CurrentRecord = CurrentRecord + 1
      'Calculate and store the current page number in the empBackPage parameter of the Emp_Name link.
      employeesemp_name.HRef += "&empBackPage="&CInt(ViewState("employeesPageNumber"))
      'Calculate and store each employee's record number in the employeesPage parameter of their corresponding Emp_Name links.
      'This parameter is used automatically by the Navigator of the Grid on the detail page NavGrid_Detail.
      employeesemp_name.HRef += "&employeesPage="& (PreviousRecords + CurrentRecord).ToString()
    End If
  
'End Grid employees Event BeforeShowRow. Action Custom Code

'Grid employees ItemDataBound event tail @2-E31F8E2A
    End Sub
'End Grid employees ItemDataBound event tail

'Grid employees ItemCommand event @2-3635E357

    Protected Sub employeesItemCommand(Sender as Object, e as RepeaterCommandEventArgs)
        Dim FooterIndex as Integer= employeesRepeater.Controls.Count - 1
        Dim BindAllowed as Boolean= False
        If e.CommandName = "Sort" Then
            If CType(e.CommandArgument,SorterState)=SorterState.None
                If CType(ViewState("employeesSortDir"),SortDirections) = SortDirections._Asc And ViewState("employeesSortField").ToString()=CType(e.CommandSource,Controls.Sorter).Field
                    ViewState("employeesSortDir")=SortDirections._Desc
                Else
                    ViewState("employeesSortDir")=SortDirections._Asc
                End If
            Else
                ViewState("employeesSortDir")=CInt(CType(e.CommandSource,Controls.Sorter).State)
            End If
            Dim sf As employeesDataProvider.SortFields = 0
            ViewState("employeesSortField")=[Enum].Parse(sf.GetType(),CType(e.CommandSource,Controls.Sorter).Field)
            ViewState("employeesPageNumber") = 1
            BindAllowed = True
        End If

        If e.CommandName="Navigate" Then
            ViewState("employeesPageNumber") = Int32.Parse(e.CommandArgument.ToString())
            BindAllowed = True
        End If
        If BindAllowed Then
            employeesBind
        End If
    End Sub
'End Grid employees ItemCommand event

'OnInit Event @1-A5C87FC8
    #Region " Web Form Designer Generated Code "
    Protected Overrides Sub OnInit(ByVal e As EventArgs)
        '
        ' CODEGEN: This call is required by the ASP.NET Web Form Designer.
        '
        InitializeComponent()
        'Me.Load += new System.EventHandler(this.Page_Load);
        'Me.Unload += new System.EventHandler(this.Page_Unload);
        employeesSearchData = New employeesSearchDataProvider()
        employeesData = New employeesDataProvider()
        MyBase.OnInit(e)
'End OnInit Event

'OnInit Event tail @1-E31F8E2A
    End Sub
'End OnInit Event tail

'InitializeComponent Event @1-EA5E2628
    ' <summary>
    ' Required method for Designer support - do not modify
    ' the contents of this method with the code editor.
    ' </summary>
    Private Sub InitializeComponent()
    End Sub
    #End Region
'End InitializeComponent Event

'Page class tail @1-DD082417
End Class
End Namespace
'End Page class tail

