'Using Statements @1-3B96A978
Imports System
Imports System.Collections
Imports System.Collections.Specialized
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Web
Imports System.Web.SessionState
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports System.Web.UI.HtmlControls
Imports System.Text.RegularExpressions
Imports System.Globalization
Imports CCSExamplePack
Imports CCSExamplePack.Data
Imports CCSExamplePack.Configuration
Imports CCSExamplePack.Controls
Namespace OrderEntry.OrderEntry
'End Using Statements

'Forms Definition @1-EB66B6E8
Public Class [OrderEntryPage]
Inherits System.Web.UI.Page
'End Forms Definition

'Forms Objects @1-41E54242
    Protected store_orders_gridRepeater As  System.Web.UI.WebControls.Repeater
    Protected store_orders_gridData As store_orders_gridDataProvider
    Protected store_orders_recordData As store_orders_recordDataProvider
    Protected store_orders_recordButton_Insert As HtmlInputButton 
    Protected store_orders_recordButton_Update As HtmlInputButton 
    Protected store_orders_recordButton_Delete As HtmlInputButton 
    Protected store_orders_recordError As System.Web.UI.WebControls.PlaceHolder
    Protected store_orders_recordHolder As System.Web.UI.HtmlControls.HtmlTable
    Protected store_orders_recordErrorLabel As System.Web.UI.WebControls.Label
    Protected store_orders_recordInsertAllowed As Boolean = True
    Protected store_orders_recordUpdateAllowed As Boolean = True
    Protected store_orders_recordDeleteAllowed As Boolean = True
    Protected store_orders_recordErrors As NameValueCollection = New NameValueCollection()
    Protected store_orders_recorduser_id As System.Web.UI.HtmlControls.HtmlSelect
    Protected store_orders_recordorder_date As System.Web.UI.WebControls.TextBox
    Protected store_orders_recordDatePicker1 As System.Web.UI.WebControls.PlaceHolder 
    Protected store_orders_recordDatePicker1Name As String
    Protected store_orders_recordDatePicker1DateControl As String
    Protected store_orders_itemsRepeater As System.Web.UI.WebControls.Repeater
    Protected store_orders_itemsData As store_orders_itemsDataProvider
    Protected store_orders_itemsErrors As New NameValueCollection()
    Protected Link1 As System.Web.UI.HtmlControls.HtmlAnchor
'End Forms Objects
	Private OrdersEmtyRowId As String 
'Page_Load Event @1-A2D2CF1E

Protected Overrides Sub OnLoad(ByVal e As System.EventArgs)
'End Page_Load Event

'Page_Load Event BeforeIsPostBack @1-C231C286
    If Not IsPostBack Then
            Dim PageData As PageDataProvider = New PageDataProvider()
            Dim item As PageItem = PageItem.CreateFromHttpRequest()
            item.Link1Href = "OrderEntry_desc.aspx"
            PageData.FillItem(item)
            Link1.InnerText += item.Link1.GetFormattedValue().Replace(vbCrLf,"")
            Link1.HRef += item.Link1Href & item.Link1HrefParameters.ToString("None","", ViewState)
            store_orders_gridBind
            store_orders_recordShow()
            store_orders_itemsBind()
    End If
'End Page_Load Event BeforeIsPostBack

'Page_Load Event tail @1-E31F8E2A
End Sub
'End Page_Load Event tail

'Page_Unload Event @1-D998A98F

Protected Overrides Sub OnUnload(ByVal e As System.EventArgs)
'End Page_Unload Event

'Page_Unload Event tail @1-E31F8E2A
End Sub
'End Page_Unload Event tail

'Grid store_orders_grid Bind @3-0CCCE439

    Protected Sub store_orders_gridBind()
        Dim PagesCount As Integer
        Dim FooterIndex As Integer
        If Not(IsPostBack) Then
            Dim Param As String
            Param = Request.QueryString("store_orders_gridOrder")
            Try
                Dim sf As store_orders_gridDataProvider.SortFields = 0
                ViewState("store_orders_gridSortField") = [Enum].Parse(sf.GetType(), Param)
            Catch
                ViewState("store_orders_gridSortField") = store_orders_gridDataProvider.SortFields._Default
            End Try

            Param = Request.QueryString("store_orders_gridDir")
            If IsNothing(Param) Then
                ViewState("store_orders_gridSortDir") = SortDirections._Desc
            Else
                If Param.Length = 0 Or Param.ToLower() = "desc" Then
                    ViewState("store_orders_gridSortDir") = SortDirections._Desc
                Else
                    ViewState("store_orders_gridSortDir") = SortDirections._Asc
                End If
            End If
            Param = Request.QueryString("store_orders_gridPage")
            Dim PageNumber as Integer
            Try
                PageNumber = Int32.Parse(Param)
                If PageNumber <= 0 Then PageNumber = 1
            Catch
                PageNumber = 1
            End Try
            ViewState("store_orders_gridPageNumber") = PageNumber
            Param = Request.QueryString("store_orders_gridPageSize")
            Try
                PageNumber = Int32.Parse(Param)
                If PageNumber <= 0 Then PageNumber = 10
            Catch
                PageNumber = 10
            End Try
            If PageNumber > 100 Then
                PageNumber = 100
            End If
            ViewState("store_orders_gridPageSize") = PageNumber
        End If
'End Grid store_orders_grid Bind

'Grid Form store_orders_grid BeforeShow tail @3-BD4C7B9B
        store_orders_gridParameters
        store_orders_gridData.SortField = CType(ViewState("store_orders_gridSortField"),store_orders_gridDataProvider.SortFields)
        store_orders_gridData.SortDir = CType(ViewState("store_orders_gridSortDir"),SortDirections)
        store_orders_gridData.PageNumber = CInt(ViewState("store_orders_gridPageNumber"))
        store_orders_gridData.RecordsPerPage = CInt(ViewState("store_orders_gridPageSize"))
        store_orders_gridRepeater.DataSource = store_orders_gridData.GetResultSet(PagesCount)
        ViewState("store_orders_gridPagesCount") = PagesCount
        store_orders_gridRepeater.DataBind
        FooterIndex = store_orders_gridRepeater.Controls.Count - 1
        If PagesCount = 0 Then
            store_orders_gridRepeater.Controls(FooterIndex).FindControl("NoRecords").Visible = True
        End If
        Dim item As store_orders_gridItem = New store_orders_gridItem()
        Dim store_orders_gridLink1 As System.Web.UI.HtmlControls.HtmlAnchor = DirectCast(store_orders_gridRepeater.Controls(FooterIndex).FindControl("store_orders_gridLink1"),System.Web.UI.HtmlControls.HtmlAnchor)

        item.Link1Href = "OrderEntry.aspx?"

        store_orders_gridLink1.InnerText += item.Link1.GetFormattedValue().Replace(vbCrLf,"")
        store_orders_gridLink1.HRef += item.Link1Href & item.Link1HrefParameters.ToString("GET","order_id", ViewState)
        If store_orders_gridData.SortField.ToString()="Sorter_order_id" Then
            If store_orders_gridData.SortDir=SortDirections._Asc Then
                CType(store_orders_gridRepeater.Controls(0).FindControl("Sorter_order_idSorter"),Controls.Sorter).State = SorterState.Ascending
            Else
                CType(store_orders_gridRepeater.Controls(0).FindControl("Sorter_order_idSorter"),Controls.Sorter).State = SorterState.Descending
            End If
        End If
        If store_orders_gridData.SortField.ToString()="Sorter_user_id" Then
            If store_orders_gridData.SortDir=SortDirections._Asc Then
                CType(store_orders_gridRepeater.Controls(0).FindControl("Sorter_user_idSorter"),Controls.Sorter).State = SorterState.Ascending
            Else
                CType(store_orders_gridRepeater.Controls(0).FindControl("Sorter_user_idSorter"),Controls.Sorter).State = SorterState.Descending
            End If
        End If
        If store_orders_gridData.SortField.ToString()="Sorter_order_date" Then
            If store_orders_gridData.SortDir=SortDirections._Asc Then
                CType(store_orders_gridRepeater.Controls(0).FindControl("Sorter_order_dateSorter"),Controls.Sorter).State = SorterState.Ascending
            Else
                CType(store_orders_gridRepeater.Controls(0).FindControl("Sorter_order_dateSorter"),Controls.Sorter).State = SorterState.Descending
            End If
        End If
        Dim NavigatorNavigator As Controls.Navigator = CType(store_orders_gridRepeater.Controls(FooterIndex).FindControl("NavigatorNavigator"),Controls.Navigator)
        NavigatorNavigator.MaxPage=PagesCount
        NavigatorNavigator.PageNumber=store_orders_gridData.PageNumber
        NavigatorNavigator.DataBind
'End Grid Form store_orders_grid BeforeShow tail

'Grid store_orders_grid Bind tail @3-E31F8E2A
    End Sub
'End Grid store_orders_grid Bind tail

'Grid store_orders_grid Table Parameters @3-78B0AD9C

    Protected Sub store_orders_gridParameters()
        Try

        Catch
            Dim ParentControls As ControlCollection=store_orders_gridRepeater.Parent.Controls
            Dim RepeaterIndex As Integer=ParentControls.IndexOf(store_orders_gridRepeater)
            ParentControls.RemoveAt(RepeaterIndex)
            Dim ErrorMessage as Literal=New Literal()
            ErrorMessage.Text="Error in Grid store_orders_grid: Invalid parameter"
            ParentControls.AddAt(RepeaterIndex,ErrorMessage)
        End Try
    End Sub
'End Grid store_orders_grid Table Parameters

'Grid store_orders_grid ItemDataBound event @3-643694D7

    Protected Sub store_orders_gridItemDataBound(Sender as Object, e as RepeaterItemEventArgs)
        Dim DataItem as store_orders_gridItem=CType(e.Item.DataItem,store_orders_gridItem)
        If e.Item.ItemType = ListItemType.Item Or e.Item.ItemType = ListItemType.AlternatingItem Then
            Dim store_orders_gridorder_id As System.Web.UI.HtmlControls.HtmlAnchor = DirectCast(e.Item.FindControl("store_orders_gridorder_id"),System.Web.UI.HtmlControls.HtmlAnchor)
            DataItem.order_idHref = "OrderEntry.aspx?"
            store_orders_gridorder_id.HRef += DataItem.order_idHref & DataItem.order_idHrefParameters.ToString("GET","", ViewState)
        End If
'End Grid store_orders_grid ItemDataBound event

'Grid store_orders_grid ItemDataBound event tail @3-E31F8E2A
    End Sub
'End Grid store_orders_grid ItemDataBound event tail

'Grid store_orders_grid ItemCommand event @3-E728BFAA

    Protected Sub store_orders_gridItemCommand(Sender as Object, e as RepeaterCommandEventArgs)
        Dim FooterIndex as Integer= store_orders_gridRepeater.Controls.Count - 1
        Dim BindAllowed as Boolean= False
        If e.CommandName = "Sort" Then
            If CType(e.CommandArgument,SorterState)=SorterState.None
                If CType(ViewState("store_orders_gridSortDir"),SortDirections) = SortDirections._Asc And ViewState("store_orders_gridSortField").ToString()=CType(e.CommandSource,Controls.Sorter).Field
                    ViewState("store_orders_gridSortDir")=SortDirections._Desc
                Else
                    ViewState("store_orders_gridSortDir")=SortDirections._Asc
                End If
            Else
                ViewState("store_orders_gridSortDir")=CInt(CType(e.CommandSource,Controls.Sorter).State)
            End If
            Dim sf As store_orders_gridDataProvider.SortFields = 0
            ViewState("store_orders_gridSortField")=[Enum].Parse(sf.GetType(),CType(e.CommandSource,Controls.Sorter).Field)
            ViewState("store_orders_gridPageNumber") = 1
            BindAllowed = True
        End If

        If e.CommandName="Navigate" Then
            ViewState("store_orders_gridPageNumber") = Int32.Parse(e.CommandArgument.ToString())
            BindAllowed = True
        End If
        If BindAllowed Then
            store_orders_gridBind
        End If
    End Sub
'End Grid store_orders_grid ItemCommand event

'Record Form store_orders_record Parameters @64-EE069981

    Protected Sub store_orders_recordParameters()
        Try
            store_orders_recordData.Urlorder_id = IntegerParameter.GetParam(Request.QueryString("order_id"), CObj(-1))
        Catch e As Exception
            store_orders_recordErrors.Add("Parameters","Form Parameters: " + e.Message)
        End Try
    End Sub
'End Record Form store_orders_record Parameters

'Record Form store_orders_record Show method @64-1ABFD036
    Protected Sub store_orders_recordShow()
        Dim AllowRead As Boolean = True
        Dim AllowInsert As Boolean = True
        Dim AllowUpdate As Boolean = True
        Dim AllowDelete As Boolean = True
        Dim item As store_orders_recordItem = store_orders_recordItem.CreateFromHttpRequest()
        Dim IsInsertMode As Boolean = Not AllowRead
        store_orders_recordErrors.Add(item.errors)
        If store_orders_recordErrors.Count > 0 Then
            store_orders_recordShowErrors()
            Return
        End If
'End Record Form store_orders_record Show method

'Record Form store_orders_record BeforeShow tail @64-77FEBDE6
        store_orders_recordParameters()
        store_orders_recordData.FillItem(item, IsInsertMode)
        store_orders_recordButton_Insert.Visible = IsInsertMode And AllowInsert
        store_orders_recordButton_Update.Visible = (Not IsInsertMode) And AllowUpdate
        store_orders_recordButton_Delete.Visible = (Not IsInsertMode) And AllowDelete
        item.user_idItems.SetSelection(item.user_id.Value)
        store_orders_recorduser_id.SelectedIndex = -1
        item.user_idItems.CopyTo(store_orders_recorduser_id.Items)
        store_orders_recordorder_date.Text=item.order_date.GetFormattedValue()
        store_orders_recordDatePicker1Name = "store_orders_record_DatePicker1"
        store_orders_recordDatePicker1DateControl = store_orders_recordorder_date.ClientID
        store_orders_recordDatePicker1.DataBind()
'End Record Form store_orders_record BeforeShow tail

'Record store_orders_record Event BeforeShow. Action Custom Code @74-73254650
    	If IsInsertMode Then store_orders_itemsRepeater.Visible = False
'End Record store_orders_record Event BeforeShow. Action Custom Code

'Record Form store_orders_record Show method tail @64-13B650C9
        If store_orders_recordErrors.Count > 0 Then
            store_orders_recordShowErrors()
        End If
    End Sub
'End Record Form store_orders_record Show method tail

'Record Form store_orders_record LoadItemFromRequest method @64-29BD6570

    Protected Sub store_orders_recordLoadItemFromRequest(item As store_orders_recordItem, ByVal EnableValidation As Boolean)
        Try
        item.user_id.SetValue(store_orders_recorduser_id.Value)
        Catch ae As ArgumentException
            store_orders_recordErrors.Add("user_id","The value in field Customer is not valid.")
        End Try
        Try
        item.order_date.SetValue(store_orders_recordorder_date.Text)
        Catch ae As ArgumentException
            Dim FormatString as String = "mm/dd/yyyy"
            store_orders_recordErrors.Add("order_date","The value in field Order Date is not valid. Use the following format: "+FormatString+".")
        End Try
        If EnableValidation Then
            item.Validate(store_orders_recordData)
        End If
        store_orders_recordErrors.Add(item.errors)
    End Sub
'End Record Form store_orders_record LoadItemFromRequest method

'Record Form store_orders_record GetRedirectUrl method @64-A3A6150D

    Protected Function Getstore_orders_recordRedirectUrl(ByVal redirect As String, ByVal removeList As String) As String
        Dim Params As String = ""
        Dim List() As String = {""}

        List = ("order_id;" + RemoveList).ToLower().Split(New Char() {";"})
        If Redirect= "" Then
            Redirect = "OrderEntry.aspx"
        End If
        Dim j As Integer
        For j=0 To Request.QueryString.Count - 1
            If Array.IndexOf(List,Request.QueryString.AllKeys(j).ToLower()) < 0 Then
                Params = Params & Request.QueryString.AllKeys(j) & "=" & Server.UrlEncode(Request.QueryString(j)) & "&"
            End If
        Next j
        Params = Params.TrimEnd(New Char(){"&"})
        Return Redirect & "?" & Params
    End Function
'End Record Form store_orders_record GetRedirectUrl method

'Record Form store_orders_record ShowErrors method @64-5E0007CD

    Protected Sub store_orders_recordShowErrors()
        Dim DefaultMessage As String = ""
        Dim i As Integer
        For i = 0 To store_orders_recordErrors.Count - 1
        Select Case store_orders_recordErrors.AllKeys(i)
            Case Else
                DefaultMessage = DefaultMessage & store_orders_recordErrors(i) & "<br>"
        End Select
        Next i
        store_orders_recordError.Visible = True
        store_orders_recordErrorLabel.Text = DefaultMessage
    End Sub
'End Record Form store_orders_record ShowErrors method

'Record Form store_orders_record Insert Operation @64-61DB9050

    Protected Sub store_orders_record_Insert(ByVal sender As Object, ByVal e As System.EventArgs)
        Dim item As store_orders_recordItem = New store_orders_recordItem()
        Dim ExecuteFlag As Boolean = True
        Dim ErrorFlag As Boolean = False
        Dim RedirectUrl As String = Getstore_orders_recordRedirectUrl("", "")
'End Record Form store_orders_record Insert Operation

'Record Form store_orders_record BeforeInsert tail @64-32DBE11B
    store_orders_recordParameters()
    store_orders_recordLoadItemFromRequest(item, True)
    If store_orders_recordInsertAllowed Then
        ErrorFlag=(store_orders_recordErrors.Count > 0)
        If ExecuteFlag And (Not ErrorFlag) Then
            Try
                store_orders_recordData.InsertItem(item)
            Catch ex As Exception
                store_orders_recordErrors.Add("DataProvider",ex.Message)
                ErrorFlag = True
            End Try
        End If
'End Record Form store_orders_record BeforeInsert tail

'Record store_orders_record Event AfterInsert. Action Custom Code @73-73254650
	Dim NewDao As DataAccessObject = Settings.IntranetDBDataAccessObject
    RedirectUrl += "&order_id=" + NewDao.ExecuteScalar("select max(order_id) from orders").ToString()
'End Record store_orders_record Event AfterInsert. Action Custom Code

'Record Form store_orders_record AfterInsert tail  @64-272C50D0
        End If
        If ErrorFlag Then
            store_orders_recordShowErrors()
        Else
            Response.Redirect(RedirectUrl)
        End If
    End Sub
'End Record Form store_orders_record AfterInsert tail 

'Record Form store_orders_record Update Operation @64-AA577D19

    Protected Sub store_orders_record_Update(ByVal sender As Object, ByVal e As System.EventArgs)
        Dim item As store_orders_recordItem = New store_orders_recordItem()
        item.IsNew = False
        Dim ExecuteFlag As Boolean = True
        Dim ErrorFlag As Boolean = False
        Dim RedirectUrl As String = Getstore_orders_recordRedirectUrl("", "")
'End Record Form store_orders_record Update Operation

'Record Form store_orders_record Before Update tail @64-D927D7B9
        store_orders_recordParameters()
        store_orders_recordLoadItemFromRequest(item, True)
        If store_orders_recordUpdateAllowed Then
        ErrorFlag = (store_orders_recordErrors.Count > 0)
        If ExecuteFlag And (Not ErrorFlag) Then
            Try
                store_orders_recordData.UpdateItem(item)
            Catch ex As Exception
                store_orders_recordErrors.Add("DataProvider",ex.Message)
                ErrorFlag = True
            End Try
        End If
'End Record Form store_orders_record Before Update tail

'Record Form store_orders_record Update Operation tail @64-272C50D0
        End If
        If ErrorFlag Then
            store_orders_recordShowErrors()
        Else
            Response.Redirect(RedirectUrl)
        End If
    End Sub
'End Record Form store_orders_record Update Operation tail

'Record Form store_orders_record Delete Operation @64-1BADFBA3

    Protected Sub store_orders_record_Delete(ByVal sender As Object, ByVal e As System.EventArgs)
        Dim ExecuteFlag As Boolean = True
        Dim ErrorFlag As Boolean = False
        Dim RedirectUrl As String = Getstore_orders_recordRedirectUrl("", "")
        Dim item As store_orders_recordItem = New store_orders_recordItem()
        item.IsNew  = False
        item.IsDeleted  = True
'End Record Form store_orders_record Delete Operation

'Record store_orders_record Event BeforeDelete. Action Custom Code @75-73254650
		  If Not IsNothing(Request.QueryString("order_id")) Then
			  Dim NewDao As DataAccessObject = Settings.IntranetDBDataAccessObject
			  NewDao.ExecuteNonQuery("DELETE FROM order_items WHERE order_id=" + NewDao.ToSql(Request.QueryString("order_id"),FieldType._Integer))
		  End If    
'End Record store_orders_record Event BeforeDelete. Action Custom Code

'Record Form BeforeDelete tail @64-74ADAC41
        store_orders_recordParameters()
        store_orders_recordLoadItemFromRequest(item, False)
        If store_orders_recordDeleteAllowed Then
        ErrorFlag = (store_orders_recordErrors.Count > 0)
        If ExecuteFlag And (Not ErrorFlag) Then
            Try
                store_orders_recordData.DeleteItem()
            Catch ex As Exception
                store_orders_recordErrors.Add("DataProvider",ex.Message)
                ErrorFlag = True
            End Try
        End If
'End Record Form BeforeDelete tail

'Record Form AfterDelete tail @64-272C50D0
        End If
        If ErrorFlag Then
            store_orders_recordShowErrors()
        Else
            Response.Redirect(RedirectUrl)
        End If
    End Sub
'End Record Form AfterDelete tail

'Record Form store_orders_record Cancel Operation @64-95E1CE3E

    Protected Sub store_orders_record_Cancel(ByVal sender As Object, ByVal e As System.EventArgs)
        Dim item As store_orders_recordItem = New store_orders_recordItem()
        Dim RedirectUrl As String = Getstore_orders_recordRedirectUrl("", "")
        store_orders_recordLoadItemFromRequest(item, True)
'End Record Form store_orders_record Cancel Operation

'Record Form store_orders_record Cancel Operation tail @64-EA2B0FFB
        Response.Redirect(RedirectUrl)
    End Sub
'End Record Form store_orders_record Cancel Operation tail

'EditableGrid store_orders_items Bind @77-103B9862
    Protected Sub store_orders_itemsBind()
        Dim PagesCount As Integer
        Dim FooterIndex As Integer
        If Not(IsPostBack) Then
            Dim Param As String
            Param = Request.QueryString("store_orders_itemsOrder")
            Try
                Dim sf As store_orders_itemsDataProvider.SortFields = 0
                ViewState("store_orders_itemsSortField") = [Enum].Parse(sf.GetType(), Param)
            Catch
                ViewState("store_orders_itemsSortField") = store_orders_itemsDataProvider.SortFields._Default
            End Try

            Param = Request.QueryString("store_orders_itemsDir")
            If IsNothing(Param) Then
                ViewState("store_orders_itemsSortDir") = SortDirections._Desc
            Else
                If Param.Length = 0 Or Param.ToLower() = "desc" Then
                    ViewState("store_orders_itemsSortDir") = SortDirections._Desc
                Else
                    ViewState("store_orders_itemsSortDir") = SortDirections._Asc
                End If
            End If
            Param = Request.QueryString("store_orders_itemsPage")
            Dim PageNumber as Integer
            Try
                PageNumber = Int32.Parse(Param)
                If PageNumber <= 0 Then PageNumber = 1
            Catch
                PageNumber = 1
            End Try
            ViewState("store_orders_itemsPageNumber") = PageNumber
            Param = Request.QueryString("store_orders_itemsPageSize")
            Try
                PageNumber = Int32.Parse(Param)
                If PageNumber <= 0 Then PageNumber = 0
            Catch
                PageNumber = 0
            End Try
            If PageNumber > 100 Then
                PageNumber = 100
            End If
            ViewState("store_orders_itemsPageSize") = PageNumber
        End If
'End EditableGrid store_orders_items Bind

'Grid Form store_orders_items BeforeShow tail @77-13233E56
        store_orders_itemsParameters()
        store_orders_itemsData.SortField = CType(ViewState("store_orders_itemsSortField"), store_orders_itemsDataProvider.SortFields)
        store_orders_itemsData.SortDir = CType(ViewState("store_orders_itemsSortDir"), SortDirections)
        store_orders_itemsData.PageNumber = CType(ViewState("store_orders_itemsPageNumber"), Integer)
        store_orders_itemsData.RecordsPerPage = CType(ViewState("store_orders_itemsPageSize"), Integer)
        store_orders_itemsRepeater.DataSource = store_orders_itemsData.GetResultSet(PagesCount)
        ViewState("store_orders_itemsPagesCount") = PagesCount
        ViewState("store_orders_itemsFormState") = New Hashtable()
        store_orders_itemsRepeater.DataBind()
        FooterIndex = store_orders_itemsRepeater.Controls.Count - 1
        Dim Script As Literal = CType(store_orders_itemsRepeater.Controls(0).FindControl("FormScript"), Literal)
        Dim Elements As Literal = CType(store_orders_itemsRepeater.Controls(0).FindControl("ElementsID"), Literal)
        Elements.Text += "var store_orders_itemsStaticElementsID;" + vbCrLf
        Dim StaticElementsID As String= "store_orders_itemsStaticElementsID = new Array ("
        Elements.Text += "var store_orders_itemsPriceArrayID=0;" + vbCrLf
        StaticElementsID += "document.forms[""_ctl0""]." + store_orders_itemsRepeater.Controls(0).FindControl("store_orders_itemsPriceArray").ClientID + ","
        Elements.Text += "var store_orders_itemsAddItemBtnID=1;" + vbCrLf
        StaticElementsID += "document.forms[""_ctl0""]." + store_orders_itemsRepeater.Controls(FooterIndex).FindControl("store_orders_itemsAddItemBtn").ClientID + ","
        Elements.Text += "var store_orders_itemsButton_SubmitID=2;" + vbCrLf
        StaticElementsID += "document.forms[""_ctl0""]." + store_orders_itemsRepeater.Controls(FooterIndex).FindControl("store_orders_itemsButton_Submit").ClientID + ""
        Script.Text += StaticElementsID + ");"+ vbCrLf
        Elements.Text &= "var store_orders_itemsEmptyRows = 30;"+ vbCrLf
        Script.Text += "store_orders_itemsElements = new Array ("
        Elements.Text += "var store_orders_itemsorder_idID=0;"+ vbCrLf
        Elements.Text += "var store_orders_itemsproduct_idID=1;"+ vbCrLf
        Elements.Text += "var store_orders_itemspriceID=2;"+ vbCrLf
        Elements.Text += "var store_orders_itemsquantityID=3;"+ vbCrLf
        Elements.Text += "var store_orders_itemsSumPriceID=4;"+ vbCrLf
        Elements.Text += "var store_orders_itemsDelete1ID=5;"+ vbCrLf
        Elements.Text += "var store_orders_itemsDeleteControl = 5;"+ vbCrLf
        Dim col As Control
        For Each col In store_orders_itemsRepeater.Controls
            If CType(col, RepeaterItem).ItemType = ListItemType.Item Or CType(col, RepeaterItem).ItemType = ListItemType.AlternatingItem Then
                Dim arr as String = ""
                arr += "document.forms[""_ctl0""]." & col.FindControl("store_orders_itemsorder_id").ClientID & ","
                arr += "document.forms[""_ctl0""]." & col.FindControl("store_orders_itemsproduct_id").ClientID & ","
                arr += "document.forms[""_ctl0""]." & col.FindControl("store_orders_itemsprice").ClientID & ","
                arr += "document.forms[""_ctl0""]." & col.FindControl("store_orders_itemsquantity").ClientID & ","
                arr += "document.forms[""_ctl0""]." & col.FindControl("store_orders_itemsSumPrice").ClientID & ","
                arr += "document.forms[""_ctl0""]." & col.FindControl("store_orders_itemsDelete1").ClientID & ","
                Script.Text += vbCrLf + "new Array(" + arr.TrimEnd(New Char() {","}) + "),"
            End If
        Next col
        Script.Text = Script.Text.TrimEnd(New Char() {","}) + ");"
        Dim item As store_orders_itemsItem = New store_orders_itemsItem()
        Dim store_orders_itemsPriceArray As System.Web.UI.WebControls.Literal = DirectCast(store_orders_itemsRepeater.Controls(0).FindControl("store_orders_itemsPriceArray"),System.Web.UI.WebControls.Literal)


        store_orders_itemsPriceArray.Text = item.PriceArray.GetFormattedValue()
        If PagesCount = 0 Then
            store_orders_itemsRepeater.Controls(FooterIndex).FindControl("NoRecords").Visible = True
        End If
        If store_orders_itemsErrors.Count > 0 Then
            Dim ErrorLabel As System.Web.UI.WebControls.Label = DirectCast(store_orders_itemsRepeater.Controls(0).FindControl("ErrorLabel"),System.Web.UI.WebControls.Label)
            Dim RowError As PlaceHolder = DirectCast(store_orders_itemsRepeater.Controls(0).FindControl("store_orders_itemsError"), System.Web.UI.WebControls.PlaceHolder)
            RowError.Visible = True
            Dim msg As String
            For Each msg In store_orders_itemsErrors
                ErrorLabel.Text += store_orders_itemsErrors(msg) + "<br/>"
            Next
        End If
'End Grid Form store_orders_items BeforeShow tail

'EditableGrid PriceArray Event BeforeShow. Action Custom Code @79-73254650
		Dim dr As DataRowCollection = Settings.IntranetDBDataAccessObject.RunSql("SELECT product_id,price FROM products").Tables(0).Rows
		Dim prices As String = "<script language=""JavaScript""> product_price = new Array ();"
		Dim i As Integer
		For i = 0 To dr.Count - 1
		   prices += "product_price[" + dr(i)("product_id").ToString() + "]=""" + dr(i)("price").ToString() + """; "
		Next i
		store_orders_itemsPriceArray.Text = prices + " </script>"
'End EditableGrid PriceArray Event BeforeShow. Action Custom Code

'Control store_orders_items Event BeforeShow. Action Custom Code @117-73254650
		ViewState("OrdersRowIDs") = OrdersEmtyRowId.TrimEnd(New Char(){","C})
		If store_orders_itemsRepeater.Visible Then
	    	RegisterArrayDeclaration("OrdersRowIDs",OrdersEmtyRowId.TrimEnd(New Char(){","C}))
		End If
'End Control store_orders_items Event BeforeShow. Action Custom Code

'EditableGrid store_orders_items Bind tail @77-EF9CA164
        store_orders_itemsShowErrors(New ArrayList(CType(store_orders_itemsRepeater.DataSource, ICollection)), store_orders_itemsRepeater.Items)
    End Sub
'End EditableGrid store_orders_items Bind tail

'EditableGrid store_orders_items Table Parameters @77-A0E8F9D5
    Protected Sub store_orders_itemsParameters()
        Try
            store_orders_itemsData.Urlorder_id= IntegerParameter.GetParam(Request.QueryString("order_id"), CObj(-1))
        Catch
            Dim ParentControls As ControlCollection = store_orders_itemsRepeater.Parent.Controls
            Dim RepeaterIndex As Integer = ParentControls.IndexOf(store_orders_itemsRepeater)
            ParentControls.RemoveAt(RepeaterIndex)
            Dim ErrorMessage As Literal = New Literal()
            ErrorMessage.Text = "Error in Grid store_orders_items: Invalid parameter"
            ParentControls.AddAt(RepeaterIndex,ErrorMessage)
        End Try
	End Sub
	
'End EditableGrid store_orders_items Table Parameters

'EditableGrid store_orders_items ItemDataBound event @77-78B4703E
    Protected Sub store_orders_itemsItemDataBound(ByVal Sender As Object, ByVal e As RepeaterItemEventArgs)
        Dim DataItem As store_orders_itemsItem = DirectCast(e.Item.DataItem, store_orders_itemsItem)
        If e.Item.ItemType = ListItemType.Item Or e.Item.ItemType = ListItemType.AlternatingItem Then
            DataItem.RowId = e.Item.ItemIndex
            Dim formState As Hashtable = DirectCast(ViewState("store_orders_itemsFormState"), Hashtable)
            formState.Add("order_item_idField:" & e.Item.ItemIndex, DataItem.order_item_idField.Value)
            Dim store_orders_itemsproduct_id As System.Web.UI.HtmlControls.HtmlSelect = DirectCast(e.Item.FindControl("store_orders_itemsproduct_id"),System.Web.UI.HtmlControls.HtmlSelect)
            DataItem.product_idItems.SetSelection(DataItem.product_id.Value)
            store_orders_itemsproduct_id.SelectedIndex = -1
            DataItem.product_idItems.CopyTo(store_orders_itemsproduct_id.Items)
            Dim store_orders_itemsDelete1 As System.Web.UI.WebControls.CheckBox = DirectCast(e.Item.FindControl("store_orders_itemsDelete1"),System.Web.UI.WebControls.CheckBox)
            If DataItem.Delete1CheckedValue.Value.Equals(DataItem.Delete1.Value) Then
                store_orders_itemsDelete1.Checked = True
            End If
        End If
'End EditableGrid store_orders_items ItemDataBound event

'store_orders_items control Before Show @77-EBC08450
        If e.Item.ItemType = ListItemType.Item Or e.Item.ItemType = ListItemType.AlternatingItem Then
'End store_orders_items control Before Show

'Get PriceArray control @78-D91970FB
            Dim store_orders_itemsPriceArray As System.Web.UI.WebControls.Literal = DirectCast(store_orders_itemsRepeater.Controls(0).FindControl("store_orders_itemsPriceArray"),System.Web.UI.WebControls.Literal)
'End Get PriceArray control

'Control PriceArray Event BeforeShow. Action Custom Code @79-73254650
    ' -------------------------
    ' Write your own code here.
    ' -------------------------
'End Control PriceArray Event BeforeShow. Action Custom Code

'store_orders_items control Before Show tail @77-477CF3C9
        End If
'End store_orders_items control Before Show tail

'EditableGrid store_orders_items Event BeforeShowRow. Action Custom Code @105-73254650
		If e.Item.ItemType = ListItemType.Item Or e.Item.ItemType = ListItemType.AlternatingItem Then
		   If DataItem.IsEmptyItem Then
		      OrdersEmtyRowId += e.Item.FindControl("MyRow").ClientID + ","
		      CType(e.Item.FindControl("MyRow"), HtmlControl).Attributes.Add("style", "display:none")
		   End If
		End If
'End EditableGrid store_orders_items Event BeforeShowRow. Action Custom Code

'EditableGrid store_orders_items ItemDataBound event tail @77-E31F8E2A
    End Sub
'End EditableGrid store_orders_items ItemDataBound event tail

'EditableGrid store_orders_items GetRedirectUrl method @77-07D62AFB
    Protected Function Getstore_orders_itemsRedirectUrl(ByVal redirectString As String, ByVal removeList As String) As String
        Dim Params As String = ""
        Dim List As String()

        If removeList = "" Then
            List = New String() {""}
        Else
            List = removeList.Split(New Char() {";"})
        End If

        If redirectString = "" Then redirectString = Request.Url.AbsolutePath
        Dim i As Integer
        For i = 0 To Request.QueryString.Count - 1
            If Array.IndexOf(List,Request.QueryString.AllKeys(i)) < 0 Then
                Params &= Request.QueryString.AllKeys(i) & "=" & Server.UrlEncode(Request.QueryString(i)) & "&"
            End If
        Next i
        Params = Params.TrimEnd(New Char(){"&"})
        Return redirectString & "?" & Params
    End Function
    Protected Function Getstore_orders_itemsRedirectUrl(ByVal redirectString As String) As String
        Return Getstore_orders_itemsRedirectUrl(redirectString ,"")
    End Function
'End EditableGrid store_orders_items GetRedirectUrl method

'EditableGrid store_orders_items ShowErrors method @77-AFE87861
    Protected Function store_orders_itemsShowErrors(ByVal items As ArrayList, ByVal col As RepeaterItemCollection) As Boolean
        Dim result As Boolean = True
        Dim i As Integer
        For i=0 To items.Count - 1
            If CType(items(i), store_orders_itemsItem).IsUpdated Then col(CType(items(i), store_orders_itemsItem).RowId).Visible = False
            If (CType(items(i), store_orders_itemsItem).errors.Count > 0) Then
                result = False
                Dim DefaultMessage As String = ""
                Dim j As Integer
                For j = 0 To CType(items(i), store_orders_itemsItem).errors.Count - 1
                Select CType(items(i), store_orders_itemsItem).errors.AllKeys(j)
                    Case Else
                        DefaultMessage &= CType(items(i), store_orders_itemsItem).errors(j) & "<br>"
                End Select
                Next j
                Dim Err As System.Web.UI.WebControls.Label = CType(col(CType(items(i), store_orders_itemsItem).RowId).FindControl("ErrorLabel"), System.Web.UI.WebControls.Label)
                col(CType(items(i), store_orders_itemsItem).RowId).FindControl("RowError").Visible = True
                Err.Text = DefaultMessage
            End If
        Next i
        Return result
    End Function
'End EditableGrid store_orders_items ShowErrors method

'EditableGrid store_orders_items ItemCommand event @77-6FD59C5B
    Protected Sub store_orders_itemsItemCommand(ByVal Sender As Object, ByVal e As RepeaterCommandEventArgs)
        Dim FooterIndex  As Integer = store_orders_itemsRepeater.Controls.Count - 1
        Dim BindAllowed As Boolean = False
        If e.CommandName= "Sort" Then
            If(CType(e.CommandArgument, SorterState) = SorterState.None) Then
                If(CType(ViewState("store_orders_itemsSortDir"), SortDirections) = SortDirections._Asc And ViewState("store_orders_itemsSortField").ToString() = CType(e.CommandSource, Controls.Sorter).Field) Then
                    ViewState("store_orders_itemsSortDir") = SortDirections._Desc
                Else
                    ViewState("store_orders_itemsSortDir") = SortDirections._Asc
                End If
            Else
                ViewState("store_orders_itemsSortDir") = CType((CType(e.CommandSource, Controls.Sorter).State), Integer)
            End If
            Dim sf As store_orders_itemsDataProvider.SortFields = 0
            ViewState("store_orders_itemsSortField") = [Enum].Parse(SF.GetType(),CType(e.CommandSource, Controls.Sorter).Field)
            ViewState("store_orders_itemsPageNumber") = 1
            BindAllowed = True
        End If

        If e.CommandName = "Navigate" Then
            ViewState("store_orders_itemsPageNumber") = Int32.Parse(e.CommandArgument.ToString())
            BindAllowed = True
        End If

        If (e.CommandName = "Submit") Then
            BindAllowed = True
            Dim col As RepeaterItemCollection = store_orders_itemsRepeater.Items
            Dim items As ArrayList = New ArrayList()
            Dim RedirectUrl As String = Getstore_orders_itemsRedirectUrl("")
            Dim formState As Hashtable = DirectCast(ViewState("store_orders_itemsFormState"), Hashtable)
            Dim i As Integer
            For i = 0 To col.Count - 1
                If(col(i).ItemType = ListItemType.Item Or col(i).ItemType = ListItemType.AlternatingItem) Then
                    Dim store_orders_itemsPriceArray As System.Web.UI.WebControls.Literal = DirectCast(store_orders_itemsRepeater.Controls(0).FindControl("store_orders_itemsPriceArray"),System.Web.UI.WebControls.Literal)
                    Dim store_orders_itemsRowIDAttribute As System.Web.UI.WebControls.Literal = DirectCast(col(i).FindControl("store_orders_itemsRowIDAttribute"),System.Web.UI.WebControls.Literal)
                    Dim store_orders_itemsRowNameAttribute As System.Web.UI.WebControls.Literal = DirectCast(col(i).FindControl("store_orders_itemsRowNameAttribute"),System.Web.UI.WebControls.Literal)
                    Dim store_orders_itemsRowStyleAttribute As System.Web.UI.WebControls.Literal = DirectCast(col(i).FindControl("store_orders_itemsRowStyleAttribute"),System.Web.UI.WebControls.Literal)
                    Dim store_orders_itemsorder_id As System.Web.UI.HtmlControls.HtmlInputHidden = DirectCast(col(i).FindControl("store_orders_itemsorder_id"),System.Web.UI.HtmlControls.HtmlInputHidden)
                    Dim store_orders_itemsproduct_id As System.Web.UI.HtmlControls.HtmlSelect = DirectCast(col(i).FindControl("store_orders_itemsproduct_id"),System.Web.UI.HtmlControls.HtmlSelect)
                    Dim store_orders_itemsprice As System.Web.UI.WebControls.TextBox = DirectCast(col(i).FindControl("store_orders_itemsprice"),System.Web.UI.WebControls.TextBox)
                    Dim store_orders_itemsquantity As System.Web.UI.WebControls.TextBox = DirectCast(col(i).FindControl("store_orders_itemsquantity"),System.Web.UI.WebControls.TextBox)
                    Dim store_orders_itemsSumPrice As System.Web.UI.WebControls.TextBox = DirectCast(col(i).FindControl("store_orders_itemsSumPrice"),System.Web.UI.WebControls.TextBox)
                    Dim store_orders_itemsDelete1 As System.Web.UI.WebControls.CheckBox = DirectCast(col(i).FindControl("store_orders_itemsDelete1"),System.Web.UI.WebControls.CheckBox)
                    col(i).FindControl("RowError").Visible = False
                    Dim item As store_orders_itemsItem = New store_orders_itemsItem()
                    item.RowId = col(i).ItemIndex
                    item.IsUpdated = Not(col(i).Visible)
                    item.order_item_idField.Value = formState("order_item_idField:" & col(i).ItemIndex)
                    item.IsDeleted = (CType(col(i).FindControl("store_orders_itemsDelete1"), System.Web.UI.WebControls.CheckBox)).Checked
                    item.PriceArray.SetValue(store_orders_itemsPriceArray.Text)
                    item.RowIDAttribute.SetValue(store_orders_itemsRowIDAttribute.Text)
                    item.RowNameAttribute.SetValue(store_orders_itemsRowNameAttribute.Text)
                    item.RowStyleAttribute.SetValue(store_orders_itemsRowStyleAttribute.Text)
                    Try
                    item.order_id.SetValue(store_orders_itemsorder_id.Value)
                    Catch ex As ArgumentException
                        item.errors.Add("order_id","The value in field Order Id is not valid.")
                    End Try
                    Try
                    item.product_id.SetValue(store_orders_itemsproduct_id.Value)
                    Catch ex As ArgumentException
                        item.errors.Add("product_id","The value in field Product Id is not valid.")
                    End Try
                    Try
                    item.price.SetValue(store_orders_itemsprice.Text)
                    Catch ex As ArgumentException
                        Dim FormatString As String = "0.00"
                        item.errors.Add("price","The value in field Price is not valid. Use the following format: "+FormatString+".")
                    End Try
                    Try
                    item.quantity.SetValue(store_orders_itemsquantity.Text)
                    Catch ex As ArgumentException
                        item.errors.Add("quantity","The value in field Quantity is not valid.")
                    End Try
                    item.SumPrice.SetValue(store_orders_itemsSumPrice.Text)
                    items.Add(item)

                    If Not item.IsEmptyItem And Not item.IsDeleted Then BindAllowed = item.Validate(store_orders_itemsData) And BindAllowed
                End If
            Next i
'End EditableGrid store_orders_items ItemCommand event

'EditableGrid store_orders_items Event BeforeSubmit. Action Custom Code @118-73254650
Dim itm As store_orders_itemsItem
For Each itm In  items
   If Not itm.IsEmptyItem Then
      CType(col(itm.RowId).FindControl("MyRow"), HtmlControl).Attributes.Remove("style")
   End If
   RegisterArrayDeclaration("OrdersRowIDs", ViewState("OrdersRowIDs")) 
Next itm
'End EditableGrid store_orders_items Event BeforeSubmit. Action Custom Code

'EditableGrid store_orders_items Update @77-6211FB3B
            If BindAllowed Then
                Try
                    store_orders_itemsData.Update(items)
                    If store_orders_itemsShowErrors(items, col) Then
                        Response.Redirect(RedirectUrl)
                    Else
                        BindAllowed = False
                    End If
                Catch ex As Exception
                    Dim Error_ As System.Web.UI.WebControls.Label = CType(col(0).FindControl("ErrorLabel"), System.Web.UI.WebControls.Label)
                    Dim RowError As PlaceHolder = Ctype(col(0).FindControl("store_orders_itemsError"), System.Web.UI.WebControls.PlaceHolder)
                    RowError.Visible = True
                    Error_.Text = "DataProvider:" & ex.Message
                    BindAllowed = False
'End EditableGrid store_orders_items Update

'EditableGrid store_orders_items After Update @77-C53B52F0
                End Try
            Else
                store_orders_itemsShowErrors(items, col)
            End If
            End If
            If BindAllowed Then
                store_orders_itemsBind()
            End If
        End Sub
'End EditableGrid store_orders_items After Update

'OnInit Event @1-1EA0F8DC
    #Region " Web Form Designer Generated Code "
    Protected Overrides Sub OnInit(ByVal e As EventArgs)
        '
        ' CODEGEN: This call is required by the ASP.NET Web Form Designer.
        '
        InitializeComponent()
        'Me.Load += new System.EventHandler(this.Page_Load);
        'Me.Unload += new System.EventHandler(this.Page_Unload);
        store_orders_gridData = New store_orders_gridDataProvider()
        store_orders_recordData = New store_orders_recordDataProvider()
        store_orders_itemsData = New store_orders_itemsDataProvider()
        MyBase.OnInit(e)
'End OnInit Event

'OnInit Event tail @1-E31F8E2A
    End Sub
'End OnInit Event tail

'InitializeComponent Event @1-EA5E2628
    ' <summary>
    ' Required method for Designer support - do not modify
    ' the contents of this method with the code editor.
    ' </summary>
    Private Sub InitializeComponent()
    End Sub
    #End Region
'End InitializeComponent Event

'Page class tail @1-DD082417
End Class
End Namespace
'End Page class tail

