//Using Statements @1-07B18602
using System;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Specialized;
using System.Data;
using CCSExamplePack;
using CCSExamplePack.Data;
using CCSExamplePack.Controls;
using CCSExamplePack.Configuration;

namespace CCSExamplePack.OrderEntry.OrderEntry
{
//End Using Statements

//Page Data Class @1-F1F2C6B1
public class PageItem
{
    public NameValueCollection errors=new NameValueCollection();
    public PageItem()
    {
    }
    public static PageItem CreateFromHttpRequest()
    {
        PageItem item = new PageItem();
        item.Link1.SetValue(DBUtility.GetInitialValue("Link1"));
        return item;
    }

    public FieldBase this[string fieldName]{
        get{
            switch(fieldName){
                case "Link1":
                    return this.Link1;
                default:
                    throw (new ArgumentOutOfRangeException());
            }
        }
        set{
            switch(fieldName){
                case "Link1":
                    this.Link1 = (TextField)value;
                    break;
                default:
                    throw (new ArgumentOutOfRangeException());
            }
        }
    }

    public TextField Link1 = new TextField("",null);
    public object Link1Href;
    public LinkParameterCollection Link1HrefParameters = new LinkParameterCollection();
}
//End Page Data Class

//Page Data Provider Class @1-50FE4D41
public class PageDataProvider
{
//End Page Data Provider Class

//Page Data Provider Class Constructor @1-9A44B219
    public PageDataProvider()
    {
    }
//End Page Data Provider Class Constructor

//Page Data Provider Class GetResultSet Method @1-052161C6
    public void FillItem(PageItem item)
    {
//End Page Data Provider Class GetResultSet Method

//Page Data Provider Class GetResultSet Method tail @1-FCB6E20C
    }
//End Page Data Provider Class GetResultSet Method tail

//Page Data Provider Tail @1-FCB6E20C
}
//End Page Data Provider Tail

//Grid store_orders_grid Item Class @3-573F5D30
public class store_orders_gridItem
{
    public NameValueCollection errors=new NameValueCollection();
    public store_orders_gridItem()
    {
    }

    public FieldBase this[string fieldName]{
        get{
            switch(fieldName){
                case "order_id":
                    return this.order_id;
                case "customer_name":
                    return this.customer_name;
                case "order_date":
                    return this.order_date;
                case "Link1":
                    return this.Link1;
                default:
                    throw (new ArgumentOutOfRangeException());
            }
        }
        set{
            switch(fieldName){
                case "order_id":
                    this.order_id = (IntegerField)value;
                    break;
                case "customer_name":
                    this.customer_name = (TextField)value;
                    break;
                case "order_date":
                    this.order_date = (DateField)value;
                    break;
                case "Link1":
                    this.Link1 = (TextField)value;
                    break;
                default:
                    throw (new ArgumentOutOfRangeException());
            }
        }
    }

    public IntegerField order_id = new IntegerField("",null);
    public object order_idHref;
    public LinkParameterCollection order_idHrefParameters = new LinkParameterCollection();
    public TextField customer_name=new TextField("", null);
    public DateField order_date=new DateField(Settings.DateFormat, null);
    public TextField Link1 = new TextField("",null);
    public object Link1Href;
    public LinkParameterCollection Link1HrefParameters = new LinkParameterCollection();
}
//End Grid store_orders_grid Item Class

//Grid store_orders_grid Data Provider Class Header @3-5BC05CD5
public class store_orders_gridDataProvider:GridDataProviderBase
{
//End Grid store_orders_grid Data Provider Class Header

//Grid store_orders_grid Data Provider Class Variables @3-EBFD58B7
    public enum SortFields {Default,Sorter_order_id,Sorter_user_id,Sorter_order_date}
    private string[] SortFieldsNames=new string[]{"","order_id","customer_id","order_date"};
    private string[] SortFieldsNamesDesc=new string[]{"","order_id DESC","customer_id DESC","order_date DESC"};
    public SortFields SortField=SortFields.Default;
    public SortDirections SortDir=SortDirections.Asc;
    public int RecordsPerPage=10;
    public int PageNumber=1;
//End Grid store_orders_grid Data Provider Class Variables

//Grid store_orders_grid Data Provider Class Constructor @3-5C1F11D6
    public store_orders_gridDataProvider()
    {
        Select=new TableCommand("SELECT orders.*, customer_name  " + 
          "FROM customers INNER JOIN orders ON customers.customer_id = orders.order_customer_id",new string[]{},Settings.IntranetDBDataAccessObject);
        Count=new TableCommand("SELECT COUNT(*)  " + 
          "FROM customers INNER JOIN orders ON customers.customer_id = orders.order_customer_id",new string[]{},Settings.IntranetDBDataAccessObject);
    }
//End Grid store_orders_grid Data Provider Class Constructor

//Grid store_orders_grid Data Provider Class GetResultSet Method @3-0C83A99C
    public store_orders_gridItem[] GetResultSet(out int PagesCount)
    {
//End Grid store_orders_grid Data Provider Class GetResultSet Method

//Before build Select @3-EB281404
        Parameters.Clear();
        Select.OrderBy=(SortDir==SortDirections.Asc?SortFieldsNames[(int)SortField]:SortFieldsNamesDesc[(int)SortField]).Trim();
//End Before build Select

//Execute Select @3-E684A2A4
        DataSet ds=null;Exception E=null;
        PagesCount=0;
        try{
            if(RecordsPerPage>0)
            {
                ds=ExecuteSelect((PageNumber-1)*RecordsPerPage,RecordsPerPage);
                PagesCount = ExecuteCount();
                mRecordCount = PagesCount;
                PagesCount = PagesCount%RecordsPerPage>0?(int)(PagesCount/RecordsPerPage)+1:(int)(PagesCount/RecordsPerPage);
            }
            else
            {
            ds=ExecuteSelect();
            if(ds.Tables[0].Rows.Count!=0)PagesCount=1;
            }
        }catch(Exception e){
            E=e;}
        finally{
//End Execute Select

//After execute Select @3-40782846
        if(E!=null) throw(E);
        }
        DataRowCollection dr=ds.Tables[0].Rows;
        store_orders_gridItem[] result=new store_orders_gridItem[dr.Count];
//End After execute Select

//After execute Select tail @3-AAF20128
        for(int i=0;i<dr.Count;i++)
        {
            store_orders_gridItem item=new store_orders_gridItem();
            item.order_id.SetValue(dr[i]["order_id"],"");
            item.order_idHrefParameters.Add("order_id",System.Web.HttpUtility.UrlEncode(dr[i]["order_id"].ToString()));
            item.customer_name.SetValue(dr[i]["customer_name"],"");
            item.order_date.SetValue(dr[i]["order_date"],Select.DateFormat);
            result[i]=item;
        }
        return result; 
    }
//End After execute Select tail

//Grid Data Provider tail @3-FCB6E20C
}
//End Grid Data Provider tail

//Record store_orders_record Item Class @64-87F2BF08
public class store_orders_recordItem
{
    private bool _isNew = true;
    private bool _isDeleted = false;
    public NameValueCollection errors=new NameValueCollection();
    public store_orders_recordItem()
    {
    }
    public IntegerField user_id = new IntegerField("", null);
    public ItemCollection user_idItems = new ItemCollection();
    public DateField order_date=new DateField(Settings.DateFormat, null);

    public static store_orders_recordItem CreateFromHttpRequest()
    {
        store_orders_recordItem item = new store_orders_recordItem();
        if(DBUtility.GetInitialValue("user_id") != null){
        item.user_id.SetValue(DBUtility.GetInitialValue("user_id"));
        }
        if(DBUtility.GetInitialValue("order_date") != null){
        item.order_date.SetValue(DBUtility.GetInitialValue("order_date"));
        }
        if(DBUtility.GetInitialValue("DatePicker1") != null){
        }
        if(DBUtility.GetInitialValue("Button_Insert") != null){
        }
        if(DBUtility.GetInitialValue("Button_Update") != null){
        }
        if(DBUtility.GetInitialValue("Button_Delete") != null){
        }
        return item;
    }

    public FieldBase this[string fieldName]{
        get{
            switch(fieldName){
                case "user_id":
                    return this.user_id;
                case "order_date":
                    return this.order_date;
                default:
                    throw (new ArgumentOutOfRangeException());
            }
        }
        set{
            switch(fieldName){
                case "user_id":
                    this.user_id = (IntegerField)value;
                    break;
                case "order_date":
                    this.order_date = (DateField)value;
                    break;
                default:
                    throw (new ArgumentOutOfRangeException());
            }
        }
    }

    public bool IsNew{
        get{
            return _isNew;
        }
        set{
            _isNew = value;
        }
    }

    public bool IsDeleted{
        get{
            return _isDeleted;
        }
        set{
            _isDeleted = value;
        }
    }

    public void Validate(store_orders_recordDataProvider provider)
    {
//End Record store_orders_record Item Class

//user_id validate @65-7585BBA8
        if(user_id.Value==null||user_id.Value.ToString()=="")
            errors.Add("user_id","The value in field Customer is required.");
//End user_id validate

//Record store_orders_record Item Class tail @64-F5FC18C5
    }
}
//End Record store_orders_record Item Class tail

//Record store_orders_record Data Provider Class @64-04C1BAEB
public class store_orders_recordDataProvider:RecordDataProviderBase
{
//End Record store_orders_record Data Provider Class

//Record store_orders_record Data Provider Class Variables @64-C3042BE6
    protected DataCommand user_idDataCommand=new TableCommand("SELECT *  " + 
          "FROM customers",new string[]{},Settings.IntranetDBDataAccessObject);
    public IntegerParameter Urlorder_id;
//End Record store_orders_record Data Provider Class Variables

//Record store_orders_record Data Provider Class Constructor @64-74DE98F2
    public store_orders_recordDataProvider()
    {
        Select=new TableCommand("SELECT *  " + 
          "FROM orders",new string[]{"order_id76"},Settings.IntranetDBDataAccessObject);
        Insert=new TableCommand("INSERT INTO orders(order_customer_id, order_date ) VALUES ( {user_id}, {order_date})"
        ,new string[0],Settings.IntranetDBDataAccessObject);
        Update=new TableCommand("UPDATE orders SET order_customer_id={user_id}, order_date={order_date}"
        ,new string[]{"order_id76"},Settings.IntranetDBDataAccessObject);
        Delete=new TableCommand("DELETE FROM orders",new string[]{"order_id76"},Settings.IntranetDBDataAccessObject);
    }
//End Record store_orders_record Data Provider Class Constructor

//Record store_orders_record Data Provider Class LoadParams Method @64-4C33D50B
    protected bool LoadParams()
    {
        CommonParameters.Clear();
        CommonParameters.Add("order_id76",Urlorder_id==null?"":("order_id = " + Select.Dao.ToSql(Urlorder_id.GetFormattedValue(""),FieldType.Integer)));
        return !(Urlorder_id!=null);
    }
//End Record store_orders_record Data Provider Class LoadParams Method

//Record store_orders_record Data Provider Class CheckUnique Method @64-40FADD2B
    public bool CheckUnique(string ControlName,store_orders_recordItem item)
    {
        return true;
    }
//End Record store_orders_record Data Provider Class CheckUnique Method

//Record store_orders_record Data Provider Class PrepareInsert Method @64-E2788B74
    override protected void PrepareInsert()
    {
//End Record store_orders_record Data Provider Class PrepareInsert Method

//Record store_orders_record Data Provider Class PrepareInsert Method tail @64-FCB6E20C
    }
//End Record store_orders_record Data Provider Class PrepareInsert Method tail

//Record store_orders_record Data Provider Class Insert Method @64-EECC6B49
    public int InsertItem(store_orders_recordItem item)
    {
//End Record store_orders_record Data Provider Class Insert Method

//Record store_orders_record Build insert @64-F33D8F8B
        Insert.SqlQuery.Replace("{user_id}",Insert.Dao.ToSql(item.user_id.GetFormattedValue(""),FieldType.Integer));
        Insert.SqlQuery.Replace("{order_date}",Insert.Dao.ToSql(item.order_date.GetFormattedValue(Insert.DateFormat),FieldType.Date));
        object result=null;Exception E=null;
        try{
            result=ExecuteInsert();
        }catch(Exception e){
            E=e;}
        finally{
//End Record store_orders_record Build insert

//Record store_orders_record AfterExecuteInsert @64-33B45808
            if(E!=null) throw(E);
        }
        return (int)result;
    }
//End Record store_orders_record AfterExecuteInsert

//Record store_orders_record Data Provider Class PrepareUpdate Method @64-7A788766
    override protected void PrepareUpdate()
    {
        LoadParams();
        Update.Parameters=CommonParameters;
//End Record store_orders_record Data Provider Class PrepareUpdate Method

//Record store_orders_record Data Provider Class PrepareUpdate Method tail @64-FCB6E20C
    }
//End Record store_orders_record Data Provider Class PrepareUpdate Method tail

//Record store_orders_record Data Provider Class Update Method @64-62EE913C
    public int UpdateItem(store_orders_recordItem item)
    {
//End Record store_orders_record Data Provider Class Update Method

//Record store_orders_record BeforeBuildUpdate @64-D37049C9
        Update.SqlQuery.Replace("{user_id}",Update.Dao.ToSql(item.user_id.GetFormattedValue(""),FieldType.Integer));
        Update.SqlQuery.Replace("{order_date}",Update.Dao.ToSql(item.order_date.GetFormattedValue(Update.DateFormat),FieldType.Date));
        object result=null;Exception E=null;
        try{
            result=ExecuteUpdate();
        }catch(Exception e){
            E=e;}
        finally{
//End Record store_orders_record BeforeBuildUpdate

//Record store_orders_record AfterExecuteUpdate @64-33B45808
            if(E!=null) throw(E);
        }
        return (int)result;
    }
//End Record store_orders_record AfterExecuteUpdate

//Record store_orders_record Data Provider Class PrepareDelete Method @64-9923EE9D
    override protected void PrepareDelete()
    {
        LoadParams();
        Delete.Parameters=CommonParameters;
//End Record store_orders_record Data Provider Class PrepareDelete Method

//Record store_orders_record Data Provider Class PrepareDelete Method tail @64-FCB6E20C
    }
//End Record store_orders_record Data Provider Class PrepareDelete Method tail

//Record store_orders_record Data Provider Class Delete Method @64-F69D1A58
    public int DeleteItem()
    {
//End Record store_orders_record Data Provider Class Delete Method

//Record store_orders_record BeforeBuildDelete @64-C970B5CF
        object result=null;Exception E=null;
        try{
            result=ExecuteDelete();
        }catch(Exception e){
            E=e;}
        finally{
//End Record store_orders_record BeforeBuildDelete

//Record store_orders_record BeforeBuildDelete @64-33B45808
            if(E!=null) throw(E);
        }
        return (int)result;
    }
//End Record store_orders_record BeforeBuildDelete

//PrepareSelect Method @64-32F2D8AA
    override protected void PrepareSelect()
    {
        LoadParams();
        Select.Parameters=CommonParameters;
    }
//End PrepareSelect Method

//Record store_orders_record Data Provider Class GetResultSet Method @64-A45A84E8
    public void FillItem(store_orders_recordItem item, ref bool IsInsertMode)
    {
        bool ReadNotAllowed=IsInsertMode;
        Exception E=null;
//End Record store_orders_record Data Provider Class GetResultSet Method

//Record store_orders_record BeforeBuildSelect @64-0CD0BD3D
        IsInsertMode=LoadParams();
        DataRowCollection dr=null;
        if(!IsInsertMode){
//End Record store_orders_record BeforeBuildSelect

//Record store_orders_record BeforeExecuteSelect @64-94ACF54A
            try{
                dr=ExecuteSelect().Tables[0].Rows;
            }catch(Exception e){
                E=e;}
            finally{
//End Record store_orders_record BeforeExecuteSelect

//Record store_orders_record AfterExecuteSelect @64-9358CCF9
                if(E!=null) throw(E);
            }
        }
        if(!IsInsertMode && !ReadNotAllowed && dr.Count!=0)
        {
            int i=0;
            item.user_id.SetValue(dr[i]["order_customer_id"],"");
            item.order_date.SetValue(dr[i]["order_date"],Select.DateFormat);
        }
        else
            IsInsertMode=true;
        DataRowCollection ListBoxSource=null;
//End Record store_orders_record AfterExecuteSelect

//ListBox user_id BeforeExecuteSelect @65-F863528D
        try{
            ListBoxSource=user_idDataCommand.Execute().Tables[0].Rows;
        }catch(Exception e){
            E=e;}
        finally{
//End ListBox user_id BeforeExecuteSelect

//ListBox user_id AfterExecuteSelect @65-1689A586
            if(E!=null) throw(E);
        }
        for(int i=0;i<ListBoxSource.Count;i++){
            object val = ListBoxSource[i]["customer_name"];
            string key = (new IntegerField("", ListBoxSource[i]["customer_id"])).GetFormattedValue("");
            item.user_idItems.Add(key,val);
        }
//End ListBox user_id AfterExecuteSelect

//Record store_orders_record AfterExecuteSelect tail @64-FCB6E20C
    }
//End Record store_orders_record AfterExecuteSelect tail

//Record store_orders_record Data Provider Class @64-FCB6E20C
}

//End Record store_orders_record Data Provider Class

//EditableGrid store_orders_items Item Class @77-1CEB042D
public class store_orders_itemsItem
{
    public NameValueCollection errors=new NameValueCollection();
    public int RowId;
    public store_orders_itemsItem()
    {
    }

    public FieldBase this[string fieldName]{
        get{
            switch(fieldName){
                case "order_item_idField":
                    return this.order_item_idField;
                case "PriceArray":
                    return this.PriceArray;
                case "RowIDAttribute":
                    return this.RowIDAttribute;
                case "RowNameAttribute":
                    return this.RowNameAttribute;
                case "RowStyleAttribute":
                    return this.RowStyleAttribute;
                case "order_id":
                    return this.order_id;
                case "product_id":
                    return this.product_id;
                case "price":
                    return this.price;
                case "quantity":
                    return this.quantity;
                case "SumPrice":
                    return this.SumPrice;
                case "Delete1":
                    return this.Delete1;
                default:
                    throw (new ArgumentOutOfRangeException());
            }
        }
        set{
            switch(fieldName){
                case "order_item_idField":
                    this.order_item_idField = (IntegerField)value;
                    break;
                case "PriceArray":
                    this.PriceArray = (TextField)value;
                    break;
                case "RowIDAttribute":
                    this.RowIDAttribute = (TextField)value;
                    break;
                case "RowNameAttribute":
                    this.RowNameAttribute = (TextField)value;
                    break;
                case "RowStyleAttribute":
                    this.RowStyleAttribute = (TextField)value;
                    break;
                case "order_id":
                    this.order_id = (IntegerField)value;
                    break;
                case "product_id":
                    this.product_id = (IntegerField)value;
                    break;
                case "price":
                    this.price = (FloatField)value;
                    break;
                case "quantity":
                    this.quantity = (IntegerField)value;
                    break;
                case "SumPrice":
                    this.SumPrice = (TextField)value;
                    break;
                case "Delete1":
                    this.Delete1 = (BooleanField)value;
                    break;
                default:
                    throw (new ArgumentOutOfRangeException());
            }
        }
    }

    public bool IsNew{
        get{
            bool result = true;
            bool result1 = true;
            result = order_item_idField.Value == null && result;
            result1 = order_id.Value == null && result1;
            result1 = product_id.Value == null && result1;
            result1 = price.Value == null && result1;
            result1 = quantity.Value == null && result1;
            result1 = SumPrice.Value == null && result1;
            result1 = Delete1.Value == null && result1;
            return result && !result1;
        }
    }

    public bool IsEmptyItem{
        get{
            bool result = true;
            result = order_id.Value == null && result;
            result = product_id.Value == null && result;
            result = price.Value == null && result;
            result = quantity.Value == null && result;
            result = SumPrice.Value == null && result;
            result = Delete1.Value == null && result;
            result = order_item_idField.Value == null && result;
            return result;
        }
    }

    public bool IsDeleted = false;
    public bool IsUpdated = false;
    public TextField PriceArray=new TextField("", null);
    public TextField RowIDAttribute=new TextField("", null);
    public TextField RowNameAttribute=new TextField("", null);
    public TextField RowStyleAttribute=new TextField("", null);
    public IntegerField order_id=new IntegerField("", null);
    public IntegerField product_id = new IntegerField("", null);
    public ItemCollection product_idItems = new ItemCollection();
    public FloatField price=new FloatField("0.00", null);
    public IntegerField quantity=new IntegerField("", null);
    public TextField SumPrice=new TextField("", null);
    public BooleanField Delete1=new BooleanField(Settings.BoolFormat, null);
    public BooleanField Delete1CheckedValue = new BooleanField(Settings.BoolFormat, true);
    public BooleanField Delete1UncheckedValue=new BooleanField(Settings.BoolFormat, false);

    public IntegerField order_item_idField=new IntegerField();
    public bool Validate(store_orders_itemsDataProvider provider)
    {
        errors.Clear();
//End EditableGrid store_orders_items Item Class

//product_id validate @81-0843BB5F
        if(product_id.Value==null||product_id.Value.ToString()=="")
            errors.Add("product_id","The value in field Product Id is required.");
//End product_id validate

//quantity validate @84-C24E7580
        if(quantity.Value==null||quantity.Value.ToString()=="")
            errors.Add("quantity","The value in field Quantity is required.");
//End quantity validate

//EditableGrid store_orders_items Item Class tail @77-2CA8EF5C
        return errors.Count == 0;
    }
}
//End EditableGrid store_orders_items Item Class tail

//EditableGrid store_orders_items Data Provider Class Header @77-3FADB4EA
public class store_orders_itemsDataProvider:EditableGridDataProviderBase
{
//End EditableGrid store_orders_items Data Provider Class Header

//Grid store_orders_items Data Provider Class Variables @77-5D35A3F9
    public enum SortFields {Default}
    private string[] SortFieldsNames=new string[]{""};
    private string[] SortFieldsNamesDesc=new string[]{""};
    public SortFields SortField=SortFields.Default;
    public SortDirections SortDir=SortDirections.Asc;
    public int RecordsPerPage=0;
    public int PageNumber=1;
    public int EmptyRows = 30;
    public IntegerParameter Urlorder_id;
    protected DataCommand product_idDataCommand=new TableCommand("SELECT *  " + 
          "FROM products",new string[]{},Settings.IntranetDBDataAccessObject);
//End Grid store_orders_items Data Provider Class Variables

//Editable Grid store_orders_items Data Provider Class Constructor @77-3ED1A300
    public store_orders_itemsDataProvider()
    {
        Select=new TableCommand("SELECT *  " + 
          "FROM order_items",new string[]{"order_id92"},Settings.IntranetDBDataAccessObject);
        Count=new TableCommand("SELECT COUNT(*)  " + 
          "FROM order_items",new string[]{"order_id92"},Settings.IntranetDBDataAccessObject);
    }
//End Editable Grid store_orders_items Data Provider Class Constructor

//Editable Grid store_orders_items Data Provider Class CheckUnique Method @77-235BE888
    public bool CheckUnique(string ControlName,store_orders_itemsItem item)
    {
        return true;
    }
//End Editable Grid store_orders_items Data Provider Class CheckUnique Method

//Editable Grid store_orders_items Data Provider Class InsertItem Method @77-A8B84F80
    protected int InsertItem(store_orders_itemsItem item)
    {
        DataCommand Insert=new TableCommand("INSERT INTO order_items(order_id, product_id, price, quantity ) VALUES ( {order_id}, {product_id}, {price}, {quantity})"
        ,new string[0],Settings.IntranetDBDataAccessObject);
//End Editable Grid store_orders_items Data Provider Class InsertItem Method

//EditableGrid store_orders_items Event BeforeBuildInsert. Action Custom Code @90-2A29BDB7
 	    if(System.Web.HttpContext.Current.Request.QueryString["order_id"]!=null)
		   item.order_id.SetValue(System.Web.HttpContext.Current.Request.QueryString["order_id"]);
		
//End EditableGrid store_orders_items Event BeforeBuildInsert. Action Custom Code

//EditableGrid store_orders_items Build insert @77-D74B3E00
        Insert.SqlQuery.Replace("{order_id}",Insert.Dao.ToSql(item.order_id.GetFormattedValue(""),FieldType.Integer));
        Insert.SqlQuery.Replace("{product_id}",Insert.Dao.ToSql(item.product_id.GetFormattedValue(""),FieldType.Integer));
        Insert.SqlQuery.Replace("{price}",Insert.Dao.ToSql(item.price.GetFormattedValue(""),FieldType.Float));
        Insert.SqlQuery.Replace("{quantity}",Insert.Dao.ToSql(item.quantity.GetFormattedValue(""),FieldType.Integer));
//End EditableGrid store_orders_items Build insert

//EditableGrid store_orders_items Data Provider Class ExecuteInsert @77-69BE52CC
        object result=null;
        try{
            result = Insert.ExecuteNonQuery();
        }catch(Exception e){
            item.errors.Add("DataProvider",e.Source + ":" + e.Message);
            result = 0;}
        finally{
//End EditableGrid store_orders_items Data Provider Class ExecuteInsert

//EditableGrid store_orders_items AfterExecuteInsert @77-16B7139B
        }
        return (int)result;
    }
//End EditableGrid store_orders_items AfterExecuteInsert

//EditableGrid store_orders_items Data Provider Class Update Method @77-1C5DC4C9
    protected int UpdateItem(store_orders_itemsItem item)
    {
        DataCommand Update=new TableCommand("UPDATE order_items SET order_id={order_id}, product_id={product_id}, price={price}, quantity={quantity}"
        ,new string[]{"order_item_id95"},Settings.IntranetDBDataAccessObject);
//End EditableGrid store_orders_items Data Provider Class Update Method

//EditableGrid store_orders_items BeforeBuildUpdate @77-4205C518
        Update.SqlQuery.Replace("{order_id}",Update.Dao.ToSql(item.order_id.GetFormattedValue(""),FieldType.Integer));
        Update.SqlQuery.Replace("{product_id}",Update.Dao.ToSql(item.product_id.GetFormattedValue(""),FieldType.Integer));
        Update.SqlQuery.Replace("{price}",Update.Dao.ToSql(item.price.GetFormattedValue(""),FieldType.Float));
        Update.SqlQuery.Replace("{quantity}",Update.Dao.ToSql(item.quantity.GetFormattedValue(""),FieldType.Integer));
        Update.Parameters.Add("order_item_id95","order_item_id = " + Update.Dao.ToSql(item.order_item_idField.GetFormattedValue(""),FieldType.Integer));
//End EditableGrid store_orders_items BeforeBuildUpdate

//EditableGrid store_orders_items Execute Update  @77-74A302F6
        object result=null;
        try{
            result=Update.ExecuteNonQuery();
        }catch(Exception e){
            item.errors.Add("DataProvider",e.Source + ":" + e.Message);
            result = 0;}
        finally{
//End EditableGrid store_orders_items Execute Update 

//EditableGrid store_orders_items AfterExecuteUpdate @77-16B7139B
        }
        return (int)result;
    }
//End EditableGrid store_orders_items AfterExecuteUpdate

//EditableGrid store_orders_items Data Provider Class Delete Method @77-31CEE85F
    public int DeleteItem(store_orders_itemsItem item)
    {
        DataCommand Delete=new TableCommand("DELETE FROM order_items",new string[]{"order_item_id95"},Settings.IntranetDBDataAccessObject);
//End EditableGrid store_orders_items Data Provider Class Delete Method

//EditableGrid store_orders_items BeforeBuildDelete @77-BDEEFEF6
        Delete.Parameters.Add("order_item_id95","order_item_id = " + Select.Dao.ToSql(item.order_item_idField.GetFormattedValue(""),FieldType.Integer));
//End EditableGrid store_orders_items BeforeBuildDelete

//EditableGrid store_orders_items Data Provider Class Execute Delete @77-7FECB576
        object result=null;
        try{
            result = Delete.ExecuteNonQuery();
        }catch(Exception e){
            item.errors.Add("DataProvider",e.Source + ":" + e.Message);
            result = 0;}
        finally{
//End EditableGrid store_orders_items Data Provider Class Execute Delete

//EditableGrid store_orders_items AfterExecuteDelete @77-16B7139B
        }
        return (int)result;
    }
//End EditableGrid store_orders_items AfterExecuteDelete

//Grid store_orders_items Data Provider Class Update Method @77-5B3113D4
    public void Update(ArrayList Items)
    {
        Update(Items, 0);
    }

    public void Update(ArrayList Items, int userGroup)
    {
        bool AllowInsert=true;
        bool AllowUpdate=true;
        bool AllowDelete=true;
        for(int i = 0; i < Items.Count; i++)
        {
            EditableGridOperation op = EditableGridOperation.Insert;
            bool isProcessed = false;
            store_orders_itemsItem item = (store_orders_itemsItem)Items[i];
            if(item.IsUpdated) continue;
            if(item.IsDeleted && AllowDelete){
                DeleteItem(item);
                op = EditableGridOperation.Delete;
                isProcessed = true;}
            if(item.IsNew && AllowInsert && !isProcessed){
                InsertItem(item);
                op = EditableGridOperation.Insert;
                isProcessed = true;}
            if(!item.IsEmptyItem && AllowUpdate && !isProcessed){
                UpdateItem(item);
                op = EditableGridOperation.Update;}
            if(item.errors.Count == 0) item.IsUpdated = true;
            OnItemUpdated(new ItemUpdatedEventArgs(op, item));
        }
    }
//End Grid store_orders_items Data Provider Class Update Method

//Grid store_orders_items Data Provider Class GetResultSet Method @77-DC14F7BE
    public store_orders_itemsItem[] GetResultSet(out int PagesCount)
    {
//End Grid store_orders_items Data Provider Class GetResultSet Method

//Before build Select @77-FE6BF9DC
        Exception E=null;
        Parameters.Clear();
        Parameters.Add("order_id92",Urlorder_id==null?"":("order_id = " + Select.Dao.ToSql(Urlorder_id.GetFormattedValue(""),FieldType.Integer)));
        Select.OrderBy=(SortDir==SortDirections.Asc?SortFieldsNames[(int)SortField]:SortFieldsNamesDesc[(int)SortField]).Trim();
//End Before build Select

//Execute Select @77-E25CF8FC
        DataSet ds=null;
        PagesCount=0;
        try{
            if(RecordsPerPage>0)
            {
                ds=ExecuteSelect((PageNumber-1)*RecordsPerPage,RecordsPerPage);
                PagesCount = ExecuteCount();
                mRecordCount = PagesCount;
                PagesCount = PagesCount%RecordsPerPage>0?(int)(PagesCount/RecordsPerPage)+1:(int)(PagesCount/RecordsPerPage);
            }
            else
            {
            ds=ExecuteSelect();
            if(ds.Tables[0].Rows.Count!=0)PagesCount=1;
            }
        }catch(Exception e){
            E=e;}
        finally{
//End Execute Select

//After execute Select @77-B3BEDDFE
        if(E!=null) throw(E);
        }
        DataRowCollection dr=ds.Tables[0].Rows;
        store_orders_itemsItem[] result=new store_orders_itemsItem[dr.Count + EmptyRows];
        DataRowCollection ListBoxSource=null;
//End After execute Select

//ListBox product_id BeforeExecuteSelect @81-47112048
    try{
        ListBoxSource=product_idDataCommand.Execute().Tables[0].Rows;
    }catch(Exception e){
        E=e;}
    finally{
//End ListBox product_id BeforeExecuteSelect

//ListBox product_id AfterExecuteSelect @81-95724F6A
        if(E!=null) throw(E);
    }
    ItemCollection product_idItems=new ItemCollection();
    for(int i=0;i<ListBoxSource.Count;i++){
        object val = ListBoxSource[i]["product_name"];
        string key = (new IntegerField("", ListBoxSource[i]["product_id"])).GetFormattedValue("");
        product_idItems.Add(key,val);
    }
//End ListBox product_id AfterExecuteSelect

//After execute Select tail @77-C34740BD
        for(int i=0;i<dr.Count;i++)
        {
            store_orders_itemsItem item=new store_orders_itemsItem();
            item.order_id.SetValue(dr[i]["order_id"],"");
            item.product_id.SetValue(dr[i]["product_id"],"");
            item.product_idItems = (ItemCollection)product_idItems.Clone();
            item.price.SetValue(dr[i]["price"],"");
            item.quantity.SetValue(dr[i]["quantity"],"");
            item.order_item_idField.SetValue(dr[i]["order_item_id"],"");
            result[i]=item;
        }
        for(int i = dr.Count; i < dr.Count + EmptyRows; i++){
            store_orders_itemsItem item=new store_orders_itemsItem();
            item.product_idItems = (ItemCollection)product_idItems.Clone();
            result[i] = item;}
        return result; 
    }
//End After execute Select tail

//Grid Data Provider tail @77-FCB6E20C
}
//End Grid Data Provider tail

//Page Data Provider Tail @1-FCB6E20C
}
//End Page Data Provider Tail

