'Using Statements @1-AC7815D1
Imports System
Imports System.Collections
Imports System.Collections.Specialized
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Web
Imports System.Web.SessionState
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports System.Web.UI.HtmlControls
Imports System.Text.RegularExpressions
Imports System.Globalization
Imports CCSExamplePack
Imports CCSExamplePack.Data
Imports CCSExamplePack.Configuration
Imports CCSExamplePack.Controls
Namespace PopUpList.PopUpList_Window
'End Using Statements

'Forms Definition @1-855EE6C9
Public Class [PopUpList_WindowPage]
Inherits System.Web.UI.Page
'End Forms Definition

'Forms Objects @1-C46821BF
    Protected employees_deparSearchData As employees_deparSearchDataProvider
    Protected employees_deparSearchDoSearch As HtmlInputButton 
    Protected employees_deparSearchError As System.Web.UI.WebControls.PlaceHolder
    Protected employees_deparSearchHolder As System.Web.UI.HtmlControls.HtmlTable
    Protected employees_deparSearchErrorLabel As System.Web.UI.WebControls.Label
    Protected employees_deparSearchErrors As NameValueCollection = New NameValueCollection()
    Protected employees_deparSearchs_emp_name As System.Web.UI.WebControls.TextBox
    Protected employees_deparSearchs_department_name As System.Web.UI.HtmlControls.HtmlSelect
    Protected employeesRepeater As  System.Web.UI.WebControls.Repeater
    Protected employeesData As employeesDataProvider
    Protected Link1 As System.Web.UI.HtmlControls.HtmlAnchor
'End Forms Objects

'Page_Load Event @1-A2D2CF1E

Protected Overrides Sub OnLoad(ByVal e As System.EventArgs)
'End Page_Load Event

'Page_Load Event BeforeIsPostBack @1-F82D9508
    If Not IsPostBack Then
            Dim PageData As PageDataProvider = New PageDataProvider()
            Dim item As PageItem = PageItem.CreateFromHttpRequest()
            PageData.FillItem(item)
            Link1.InnerText += item.Link1.GetFormattedValue().Replace(vbCrLf,"")
            employees_deparSearchShow()
            employeesBind
    End If
'End Page_Load Event BeforeIsPostBack

'Page_Load Event tail @1-E31F8E2A
End Sub
'End Page_Load Event tail

'Page_Unload Event @1-D998A98F

Protected Overrides Sub OnUnload(ByVal e As System.EventArgs)
'End Page_Unload Event

'Page_Unload Event tail @1-E31F8E2A
End Sub
'End Page_Unload Event tail

'Record Form employees_deparSearch Parameters @8-F5A91317

    Protected Sub employees_deparSearchParameters()
        Try
        Catch e As Exception
            employees_deparSearchErrors.Add("Parameters","Form Parameters: " + e.Message)
        End Try
    End Sub
'End Record Form employees_deparSearch Parameters

'Record Form employees_deparSearch Show method @8-4DAF7062
    Protected Sub employees_deparSearchShow()
        Dim AllowRead As Boolean = True
        Dim item As employees_deparSearchItem = employees_deparSearchItem.CreateFromHttpRequest()
        Dim IsInsertMode As Boolean = Not AllowRead
        employees_deparSearchErrors.Add(item.errors)
        If employees_deparSearchErrors.Count > 0 Then
            employees_deparSearchShowErrors()
            Return
        End If
'End Record Form employees_deparSearch Show method

'Record Form employees_deparSearch BeforeShow tail @8-A6C6B9B8
        employees_deparSearchParameters()
        employees_deparSearchData.FillItem(item, IsInsertMode)
        employees_deparSearchs_emp_name.Text=item.s_emp_name.GetFormattedValue()
        item.s_department_nameItems.SetSelection(item.s_department_name.Value)
        employees_deparSearchs_department_name.SelectedIndex = -1
        item.s_department_nameItems.CopyTo(employees_deparSearchs_department_name.Items)
'End Record Form employees_deparSearch BeforeShow tail

'Record Form employees_deparSearch Show method tail @8-01F2A74B
        If employees_deparSearchErrors.Count > 0 Then
            employees_deparSearchShowErrors()
        End If
    End Sub
'End Record Form employees_deparSearch Show method tail

'Record Form employees_deparSearch LoadItemFromRequest method @8-8AB9019D

    Protected Sub employees_deparSearchLoadItemFromRequest(item As employees_deparSearchItem, ByVal EnableValidation As Boolean)
        item.s_emp_name.SetValue(employees_deparSearchs_emp_name.Text)
        Try
        item.s_department_name.SetValue(employees_deparSearchs_department_name.Value)
        Catch ae As ArgumentException
            employees_deparSearchErrors.Add("s_department_name","The value in field s_department_name is not valid.")
        End Try
        If EnableValidation Then
            item.Validate(employees_deparSearchData)
        End If
        employees_deparSearchErrors.Add(item.errors)
    End Sub
'End Record Form employees_deparSearch LoadItemFromRequest method

'Record Form employees_deparSearch GetRedirectUrl method @8-8FDD2D01

    Protected Function Getemployees_deparSearchRedirectUrl(ByVal redirect As String, ByVal removeList As String) As String
        Dim Params As String = ""
        Dim List() As String = {""}

        List = (RemoveList).ToLower().Split(New Char() {";"})
        If Redirect= "" Then
            Redirect = "PopUpList_Window.aspx"
        End If
        Dim i As Integer
        For i=0 To Request.Form.Count - 1
            If Array.IndexOf(List,Request.Form.AllKeys(i).ToLower()) < 0 And Request.Form.AllKeys(i) <> "__EVENTTARGET" And Request.Form.AllKeys(i) <> "__EVENTARGUMENT" And Request.Form.AllKeys(i) <> "__VIEWSTATE" Then
                Params = Params & Request.Form.AllKeys(i) & "=" & Server.UrlEncode(Request.Form(i)) & "&"
            End If
        Next i
        Params = Params.TrimEnd(New Char(){"&"})
        Return Redirect & "?" & Params
    End Function
'End Record Form employees_deparSearch GetRedirectUrl method

'Record Form employees_deparSearch ShowErrors method @8-FFCF218A

    Protected Sub employees_deparSearchShowErrors()
        Dim DefaultMessage As String = ""
        Dim i As Integer
        For i = 0 To employees_deparSearchErrors.Count - 1
        Select Case employees_deparSearchErrors.AllKeys(i)
            Case Else
                DefaultMessage = DefaultMessage & employees_deparSearchErrors(i) & "<br>"
        End Select
        Next i
    End Sub
'End Record Form employees_deparSearch ShowErrors method

'Record Form employees_deparSearch Search Operation @8-8D1E42CC

    Protected Sub employees_deparSearch_Search(ByVal sender As Object, ByVal e As System.EventArgs)
        Dim ErrorFlag As Boolean = False
        Dim item As employees_deparSearchItem = New employees_deparSearchItem()
        employees_deparSearchLoadItemFromRequest(item, True)
        ErrorFlag = (employees_deparSearchErrors.Count > 0)
'End Record Form employees_deparSearch Search Operation

'Record Form employees_deparSearch Search Operation tail @8-19ACD1DC
        If ErrorFlag Then
            employees_deparSearchShowErrors()
        Else
            Dim Params As String = ""
            Dim li As ListItem
            Params = Params & IIf(employees_deparSearchs_emp_name.Text <> "",("s_emp_name=" & Server.UrlEncode(employees_deparSearchs_emp_name.Text) & "&"), "")
            For Each li In employees_deparSearchs_department_name.Items
                If li.Selected And Not "".Equals(li.Value) Then
                    Params &= "s_department_name=" & Server.UrlEncode(li.Value) & "&"
                End If
            Next li
            Dim RedirectUrl As String = Getemployees_deparSearchRedirectUrl("", "s_emp_name;s_department_name")
            If RedirectUrl.EndsWith("?") Then
                RedirectUrl &= Params
            Else
                RedirectUrl &= "&" & Params
            End If
            RedirectUrl = RedirectUrl.TrimEnd(New Char(){"&"})
            Response.Redirect(RedirectUrl)
        End If
    End Sub
'End Record Form employees_deparSearch Search Operation tail

'Grid employees Bind @2-53275E57

    Protected Sub employeesBind()
        Dim PagesCount As Integer
        Dim FooterIndex As Integer
        If Not(IsPostBack) Then
            Dim Param As String
            Param = Request.QueryString("employeesOrder")
            Try
                Dim sf As employeesDataProvider.SortFields = 0
                ViewState("employeesSortField") = [Enum].Parse(sf.GetType(), Param)
            Catch
                ViewState("employeesSortField") = employeesDataProvider.SortFields._Default
            End Try

            Param = Request.QueryString("employeesDir")
            If IsNothing(Param) Then
                ViewState("employeesSortDir") = SortDirections._Desc
            Else
                If Param.Length = 0 Or Param.ToLower() = "desc" Then
                    ViewState("employeesSortDir") = SortDirections._Desc
                Else
                    ViewState("employeesSortDir") = SortDirections._Asc
                End If
            End If
            Param = Request.QueryString("employeesPage")
            Dim PageNumber as Integer
            Try
                PageNumber = Int32.Parse(Param)
                If PageNumber <= 0 Then PageNumber = 1
            Catch
                PageNumber = 1
            End Try
            ViewState("employeesPageNumber") = PageNumber
            Param = Request.QueryString("employeesPageSize")
            Try
                PageNumber = Int32.Parse(Param)
                If PageNumber <= 0 Then PageNumber = 10
            Catch
                PageNumber = 10
            End Try
            If PageNumber > 100 Then
                PageNumber = 100
            End If
            ViewState("employeesPageSize") = PageNumber
        End If
'End Grid employees Bind

'Grid Form employees BeforeShow tail @2-EFE151FE
        employeesParameters
        employeesData.SortField = CType(ViewState("employeesSortField"),employeesDataProvider.SortFields)
        employeesData.SortDir = CType(ViewState("employeesSortDir"),SortDirections)
        employeesData.PageNumber = CInt(ViewState("employeesPageNumber"))
        employeesData.RecordsPerPage = CInt(ViewState("employeesPageSize"))
        employeesRepeater.DataSource = employeesData.GetResultSet(PagesCount)
        ViewState("employeesPagesCount") = PagesCount
        employeesRepeater.DataBind
        FooterIndex = employeesRepeater.Controls.Count - 1
        If PagesCount = 0 Then
            employeesRepeater.Controls(FooterIndex).FindControl("NoRecords").Visible = True
        End If


        Dim Navigator1Navigator As Controls.Navigator = CType(employeesRepeater.Controls(FooterIndex).FindControl("Navigator1Navigator"),Controls.Navigator)
        Navigator1Navigator.MaxPage=PagesCount
        Navigator1Navigator.PageNumber=employeesData.PageNumber
        Navigator1Navigator.DataBind
'End Grid Form employees BeforeShow tail

'Control employees Event BeforeShow. Action Custom Code @23-73254650
	
	If PagesCount < 2 Then Navigator1Navigator.Visible = false
 
'End Control employees Event BeforeShow. Action Custom Code

'Grid employees Bind tail @2-E31F8E2A
    End Sub
'End Grid employees Bind tail

'Grid employees Table Parameters @2-9AE9FA11

    Protected Sub employeesParameters()
        Try
            employeesData.Urls_department_name= IntegerParameter.GetParam(Request.QueryString("s_department_name"))

        Catch
            Dim ParentControls As ControlCollection=employeesRepeater.Parent.Controls
            Dim RepeaterIndex As Integer=ParentControls.IndexOf(employeesRepeater)
            ParentControls.RemoveAt(RepeaterIndex)
            Dim ErrorMessage as Literal=New Literal()
            ErrorMessage.Text="Error in Grid employees: Invalid parameter"
            ParentControls.AddAt(RepeaterIndex,ErrorMessage)
        End Try
    End Sub
'End Grid employees Table Parameters

'Grid employees ItemDataBound event @2-191F60AA

    Protected Sub employeesItemDataBound(Sender as Object, e as RepeaterItemEventArgs)
        Dim DataItem as employeesItem=CType(e.Item.DataItem,employeesItem)
        If e.Item.ItemType = ListItemType.Item Or e.Item.ItemType = ListItemType.AlternatingItem Then
            Dim employeesemp_name As System.Web.UI.HtmlControls.HtmlAnchor = DirectCast(e.Item.FindControl("employeesemp_name"),System.Web.UI.HtmlControls.HtmlAnchor)
            employeesemp_name.HRef += DataItem.emp_nameHref & DataItem.emp_nameHrefParameters.ToString("GET","", ViewState)
        End If
'End Grid employees ItemDataBound event

'Grid employees ItemDataBound event tail @2-E31F8E2A
    End Sub
'End Grid employees ItemDataBound event tail

'Grid employees ItemCommand event @2-3635E357

    Protected Sub employeesItemCommand(Sender as Object, e as RepeaterCommandEventArgs)
        Dim FooterIndex as Integer= employeesRepeater.Controls.Count - 1
        Dim BindAllowed as Boolean= False
        If e.CommandName = "Sort" Then
            If CType(e.CommandArgument,SorterState)=SorterState.None
                If CType(ViewState("employeesSortDir"),SortDirections) = SortDirections._Asc And ViewState("employeesSortField").ToString()=CType(e.CommandSource,Controls.Sorter).Field
                    ViewState("employeesSortDir")=SortDirections._Desc
                Else
                    ViewState("employeesSortDir")=SortDirections._Asc
                End If
            Else
                ViewState("employeesSortDir")=CInt(CType(e.CommandSource,Controls.Sorter).State)
            End If
            Dim sf As employeesDataProvider.SortFields = 0
            ViewState("employeesSortField")=[Enum].Parse(sf.GetType(),CType(e.CommandSource,Controls.Sorter).Field)
            ViewState("employeesPageNumber") = 1
            BindAllowed = True
        End If

        If e.CommandName="Navigate" Then
            ViewState("employeesPageNumber") = Int32.Parse(e.CommandArgument.ToString())
            BindAllowed = True
        End If
        If BindAllowed Then
            employeesBind
        End If
    End Sub
'End Grid employees ItemCommand event

'OnInit Event @1-0A22BD0B
    #Region " Web Form Designer Generated Code "
    Protected Overrides Sub OnInit(ByVal e As EventArgs)
        '
        ' CODEGEN: This call is required by the ASP.NET Web Form Designer.
        '
        InitializeComponent()
        'Me.Load += new System.EventHandler(this.Page_Load);
        'Me.Unload += new System.EventHandler(this.Page_Unload);
        employees_deparSearchData = New employees_deparSearchDataProvider()
        employeesData = New employeesDataProvider()
        MyBase.OnInit(e)
'End OnInit Event

'OnInit Event tail @1-E31F8E2A
    End Sub
'End OnInit Event tail

'InitializeComponent Event @1-EA5E2628
    ' <summary>
    ' Required method for Designer support - do not modify
    ' the contents of this method with the code editor.
    ' </summary>
    Private Sub InitializeComponent()
    End Sub
    #End Region
'End InitializeComponent Event

'Page class tail @1-DD082417
End Class
End Namespace
'End Page class tail

