#BindEvents Method @1-77E64CC1
sub BindEvents {
    $employees->{ds}->{CCSEvents}->{"BeforeBuildSelect"} = "employees_ds_BeforeBuildSelect";
    $employees->{CCSEvents}->{"BeforeShow"} = "employees_BeforeShow";
}
#End BindEvents Method

#employees_ds_BeforeBuildSelect @2-476B6564
sub employees_ds_BeforeBuildSelect()
{
    $employees_ds_BeforeBuildSelect = 1;
#End employees_ds_BeforeBuildSelect

#Custom Code @20-84ABEA10

	#Dynamically modify the WHERE statement (of the datasource) to match the following SQL condition:
	#emp_name LIKE F L", where F = First Name, L = Last Name.

	$search_name = CCGetFromGet("s_emp_name","");
	$search_name =~s/^\s+|\s+$//g;
	$search_name =~s/\s+/%/g;
			
    if(index($search_name,"%") == -1){ 
    	$search_name = "%".$search_name."%";
    }else{ 
    	$search_name = $search_name."%";
	}

  
	if($employees->{ds}->{Where} ne ""){
		$employees->{ds}->{Where}.=" AND ";
	}
	$employees->{ds}->{Where}.= "emp_name LIKE ".$employees->{ds}->ToSQL($search_name,$ccsText);

#End Custom Code

#Close employees_ds_BeforeBuildSelect @2-F731E0AD
    return $employees_ds_BeforeBuildSelect;
}
#End Close employees_ds_BeforeBuildSelect

#employees_BeforeShow @2-49C34BE0
sub employees_BeforeShow()
{
    $employees_BeforeShow = 1;
#End employees_BeforeShow

#Custom Code @23-84ABEA10

	if($employees->{ds}->{PageCount} < 2){ 
      $employees->{Navigator1}->{Visible} = 0;
	}

#End Custom Code

#Close employees_BeforeShow @2-4F58CE32
    return $employees_BeforeShow;
}
#End Close employees_BeforeShow


1;
