<%
'BindEvents Method @1-E67B94DB
Sub BindEvents()
    Set departments.CCSEvents("BeforeShow") = GetRef("departments_BeforeShow")
    Set departments.CCSEvents("OnValidate") = GetRef("departments_OnValidate")
End Sub
'End BindEvents Method

Function departments_BeforeShow() 'departments_BeforeShow @11-4EFCBE16
'Custom Code @17-73254650
  if departments.department_manager_id.Value <> Empty AND _
     isnumeric(departments.department_manager_id.Value) Then 
     departments.department_manager_id.Value = _
       CCDLookUp("emp_name", "employees", "emp_id="& CInt(departments.department_manager_id.Value), DBIntranetDB)
  End if
'End Custom Code
End Function 'Close departments_BeforeShow @11-54C34B28


Function departments_OnValidate() 'departments_OnValidate @11-7107DA9F
'Custom Code @19-73254650
Dim EmpCount
Dim search_name

  search_name = trim(departments.department_manager_id.Value)
  If search_name <> "" Then
    search_name = replace(search_name," ","% ")
    if instr(search_name,"%") = 0 Then
       search_name = "%"&search_name&"%"
    Else
       search_name = search_name&"%"
    End If 

    If instr(search_name,"'") >0 Then _
    search_name = replace(search_name,"'","''")

    EmpCount = CCDLookUp("COUNT(*)", "employees", "emp_name LIKE "&DBIntranetDB.ToSQL(search_name,ccsText), DBIntranetDB)
    if EmpCount > 1 Then
       departments.Errors.addError("Too many matching employees were found.")
    End if 
    If EmpCount = 0 Then 
       departments.Errors.addError("No matching employees were found.")
    End if 
    If EmpCount = 1 Then 
       departments.department_manager_id.Value = _
          CCDLookUp("emp_id", "employees", "emp_name LIKE "&DBIntranetDB.ToSQL(search_name,ccsText), DBIntranetDB)
    End if
  End if
'End Custom Code
End Function 'Close departments_OnValidate @11-54C34B28

%>
