'Using Statements @1-8955DE7A
Imports System
Imports System.Text
Imports System.Text.RegularExpressions
Imports System.Collections
Imports System.Collections.Specialized
Imports System.Data
Imports ExPack_VB
Imports ExPack_VB.Data
Imports ExPack_VB.Controls
Imports ExPack_VB.Security
Imports ExPack_VB.Configuration
Namespace PopUpList.PopUpList
'End Using Statements

'Page Data Class @1-0EE890C0
Public Class PageItem
    Public errors As NameValueCollection = New NameValueCollection()

    Public Sub New()
    End Sub
    Public Shared Function CreateFromHttpRequest() As PageItem
        Dim item As PageItem = New PageItem()
        item.Link2.SetValue(DBUtility.GetInitialValue("Link2"))
        Return item
    End Function

    Default Public Property Field(fieldName As String) As FieldBase
        Get
            Select fieldName
                Case "Link2"
                    Return Link2
                Case Else
                    Throw (New ArgumentOutOfRangeException())
            End Select
        End Get
        Set (ByVal Value As FieldBase)
            Select fieldName
                Case "Link2"
                    Link2 = CType(value, TextField)
                Case Else
                    Throw (New ArgumentOutOfRangeException())
            End Select
        End Set
    End Property

    Public Link2 As TextField = New TextField("",Nothing)
    Public Link2Href As Object
    Public Link2HrefParameters As LinkParameterCollection = New LinkParameterCollection()
End Class
'End Page Data Class

'Page Data Provider Class @1-E3544B64
Public Class PageDataProvider
Dim j As Integer
'End Page Data Provider Class

'Page Data Provider Class Constructor @1-12B526DF

    Public Sub New()
    End Sub
'End Page Data Provider Class Constructor

'Page Data Provider Class GetResultSet Method @1-F73C4626

    Public Sub FillItem(ByVal item As PageItem)
'End Page Data Provider Class GetResultSet Method

'Page Data Provider Class GetResultSet Method tail @1-E31F8E2A
    End Sub
'End Page Data Provider Class GetResultSet Method tail

'Page Data Provider class Tail @1-A61BA892
End Class
'End Page Data Provider class Tail

'Grid departments_emp Item Class @3-322DF94A
Public Class departments_empItem
    Public errors As NameValueCollection = New NameValueCollection()
    Public Sub New()
    End Sub

    Public Default Property Field(ByVal fieldName As String) as FieldBase
        Get
            Select fieldName
                Case "department_name"
                    Return Me.department_name
                Case "emp_name"
                    Return Me.emp_name
                Case "Add"
                    Return Me.Add
                Case Else
                    Throw New ArgumentOutOfRangeException()
            End Select
        End Get
        Set (ByVal Value As FieldBase)
            Select fieldName
                Case "department_name"
                    Me.department_name = CType(Value,TextField)
                Case "emp_name"
                    Me.emp_name = CType(Value,TextField)
                Case "Add"
                    Me.Add = CType(Value,TextField)
                Case Else
                    Throw New ArgumentOutOfRangeException()
            End Select
        End Set
    End Property

    Public department_name As TextField = New TextField("",Nothing)
    Public department_nameHref As Object
    Public department_nameHrefParameters As LinkParameterCollection = New LinkParameterCollection()
    Public emp_name As TextField = New TextField("", Nothing)
    Public Add As TextField = New TextField("",Nothing)
    Public AddHref As Object
    Public AddHrefParameters As LinkParameterCollection = New LinkParameterCollection()
End Class
'End Grid departments_emp Item Class

'Grid departments_emp Data Provider Class Header @3-9B844469
Public Class departments_empDataProvider
Inherits GridDataProviderBase
'End Grid departments_emp Data Provider Class Header

'Grid departments_emp Data Provider Class Variables @3-FFEDF2F1

    Public Enum SortFields
        _Default
    End Enum

    Private SortFieldsNames As String() = New String() {"departments.department_id"}
    Private SortFieldsNamesDesc As String() = New string() {"departments.department_id"}
    Public SortField As SortFields = SortFields._Default
    Public SortDir As SortDirections = SortDirections._Asc
    Public RecordsPerPage As Integer = 10
    Public PageNumber As Integer = 1
'End Grid departments_emp Data Provider Class Variables

'Grid departments_emp Data Provider Class Constructor @3-012F47E3

    Public Sub New()
        Select_ = New TableCommand("SELECT departments.department_id AS departments_department_id, department_name,  " & _
          "emp_name  " & _
          "FROM departments LEFT JOIN employees ON " & _
          "departments.department_manager_id = employees.emp_id", New String(){},Settings.IntranetDBDataAccessObject)
        Count = New TableCommand("SELECT COUNT(*)  " & _
          "FROM departments LEFT JOIN employees ON " & _
          "departments.department_manager_id = employees.emp_id", New String(){},Settings.IntranetDBDataAccessObject)
    End Sub
'End Grid departments_emp Data Provider Class Constructor

'Grid departments_emp Data Provider Class GetResultSet Method @3-F82576BD

    Public Function GetResultSet(ByRef PagesCount As Integer) As departments_empItem()
'End Grid departments_emp Data Provider Class GetResultSet Method

'Before build Select @3-EB06405A
        Parameters.Clear
        If SortDir = SortDirections._Asc Then
            Select_.OrderBy=SortFieldsNames(CInt(SortField)).Trim()
        Else
            Select_.OrderBy=SortFieldsNamesDesc(CInt(SortField)).Trim()
        End If
'End Before build Select

'Execute Select @3-467AC0A8
        Dim ds As DataSet = Nothing, E as Exception = Nothing
        PagesCount=0
        Try
            If RecordsPerPage>0
                ds=ExecuteSelect((PageNumber-1)*RecordsPerPage,RecordsPerPage)
                PagesCount = ExecuteCount()
                m_recordCount = PagesCount
                If PagesCount Mod RecordsPerPage>0 Then
                    PagesCount = (PagesCount\RecordsPerPage)+1
                Else
                    PagesCount = PagesCount\RecordsPerPage
                End If
            Else
            ds=ExecuteSelect()
            If ds.Tables(0).Rows.Count<>0 Then 
                PagesCount=1
            End If
            End If
        Catch ee as Exception
            E=ee
        Finally
'End Execute Select

'After execute Select @3-DEBD7F70
        If Not IsNothing(E) Then Throw E
        End Try
        Dim dr as DataRowCollection = ds.Tables(0).Rows
        Dim result(dr.Count - 1) as departments_empItem
        Dim j As Integer
'End After execute Select

'After execute Select tail @3-26AF1B4F
        Dim i as Integer
        For i = 0 To dr.Count - 1
            Dim item as departments_empItem = New departments_empItem()
            item.department_name.SetValue(dr(i)("department_name"),"")
            item.department_nameHrefParameters.Add("department_id",System.Web.HttpUtility.UrlEncode(dr(i)("departments_department_id").ToString()))
            item.emp_name.SetValue(dr(i)("emp_name"),"")
            result(i)=item
        Next
        Return result 
    End Function
'End After execute Select tail

'Grid Data Provider tail @3-A61BA892
End Class
'End Grid Data Provider tail

'Record departments Item Class @11-67E3AC94
Public Class departmentsItem
    Private _isNew As Boolean = True
    Private _isDeleted As Boolean = False
    Public errors As NameValueCollection = New NameValueCollection()

    public Sub New()
    End Sub
    Public department_name As TextField = New TextField("", Nothing)
    Public department_manager_id As TextField = New TextField("", Nothing)
    Public Link1 As TextField = New TextField("",Nothing)
    Public Link1Href As Object
    Public Link1HrefParameters As LinkParameterCollection = New LinkParameterCollection()
    Public is_change As TextField = New TextField("", Nothing)

    Public Shared Function CreateFromHttpRequest() As departmentsItem
        Dim item As departmentsItem = New departmentsItem()
        If Not IsNothing(DBUtility.GetInitialValue("department_name")) Then
        item.department_name.SetValue(DBUtility.GetInitialValue("department_name"))
        End If 
        If Not IsNothing(DBUtility.GetInitialValue("department_manager_id")) Then
        item.department_manager_id.SetValue(DBUtility.GetInitialValue("department_manager_id"))
        End If 
        If Not IsNothing(DBUtility.GetInitialValue("Link1")) Then
        item.Link1.SetValue(DBUtility.GetInitialValue("Link1"))
        End If 
        If Not IsNothing(DBUtility.GetInitialValue("is_change")) Then
        item.is_change.SetValue(DBUtility.GetInitialValue("is_change"))
        End If 
        If Not IsNothing(DBUtility.GetInitialValue("Insert_Button")) Then
        End If 
        If Not IsNothing(DBUtility.GetInitialValue("Update_Button")) Then
        End If 
        If Not IsNothing(DBUtility.GetInitialValue("Delete_Button")) Then
        End If 
        Return item
    End Function

    Default Public Property Field(fieldName As String) As FieldBase
        Get
            Select fieldName
                Case "department_name"
                    Return department_name
                Case "department_manager_id"
                    Return department_manager_id
                Case "Link1"
                    Return Link1
                Case "is_change"
                    Return is_change
                Case Else
                    Throw (New ArgumentOutOfRangeException())
            End Select
        End Get
        Set (ByVal Value As FieldBase)
            Select fieldName
                Case "department_name"
                    department_name = CType(value, TextField)
                Case "department_manager_id"
                    department_manager_id = CType(value, TextField)
                Case "Link1"
                    Link1 = CType(value, TextField)
                Case "is_change"
                    is_change = CType(value, TextField)
                Case Else
                    Throw (New ArgumentOutOfRangeException())
            End Select
        End Set
    End Property

    Public Property IsNew() As Boolean
        Get
            Return _isNew
        End Get
        Set
            _isNew = Value
        End Set
    End Property

    Public Property IsDeleted() As Boolean
        Get
            Return _isDeleted
        End Get
        Set
            _isDeleted = Value
        End Set
    End Property

    Public Sub Validate(ByVal provider As departmentsDataProvider)
'End Record departments Item Class

'department_name validate @14-09ED9EB5
        If IsNothing(department_name.Value) Then
            errors.Add("department_name","The value in field Department is required.")
        ElseIf department_name.Value.ToString() ="" Then
            errors.Add("department_name","The value in field Department is required.")
        End If
'End department_name validate

'Record departments Event OnValidate. Action Custom Code @19-73254650
    
  Dim EmpCount As Integer = 0
  Dim search_name As String
  
  If IsNothing(department_manager_id.Value)	Then
  	search_name = ""
  Else search_name = department_manager_id.Value.ToString().Trim()
  End If

  If search_name <> "" Then 
    
	search_name = search_name.Replace(" ","%")
    If search_name.IndexOf("%") =-1 Then 
       search_name = "%" & search_name & "%"
    Else
       search_name = search_name & "%"
    End If 
    search_name = search_name.Replace("'","''")

    EmpCount = Int32.Parse(new IntegerField("",Settings.IntranetDBDataAccessObject.ExecuteScalar("SELECT COUNT(*) FROM employees WHERE emp_name LIKE " & "'" & search_name & "'" )).GetFormattedValue(""))
    If EmpCount > 1 Then 
       errors.Add("department_manager_id","Too many matching employees were found.")
     
    ElseIf EmpCount = 0 Then 
	       errors.Add("department_manager_id","No matching employees were found.")
    
    elseIf EmpCount = 1 Then  
       department_manager_id.Value = Int32.Parse(new IntegerField("",Settings.IntranetDBDataAccessObject.ExecuteScalar("SELECT emp_id FROM employees WHERE emp_name LIKE " + "'" + search_name + "'" )).GetFormattedValue(""))
    End If
  
  End If

'End Record departments Event OnValidate. Action Custom Code

'Record departments Item Class tail @11-8B704AE2
    End Sub
End Class
'End Record departments Item Class tail

'Record departments Data Provider Class @11-28719FB4
Public Class departmentsDataProvider
Inherits RecordDataProviderBase
'End Record departments Data Provider Class

'Record departments Data Provider Class Variables @11-C917AE91
    Public Urldepartment_id As IntegerParameter
'End Record departments Data Provider Class Variables

'Record departments Data Provider Class Constructor @11-533981A8

    Public Sub New()
        Select_ = New TableCommand("SELECT *  " & _
          "FROM departments", New String(){"department_id13"},Settings.IntranetDBDataAccessObject)
        Insert = New TableCommand("INSERT INTO departments(department_name,  " & _
          "department_manager_id ) VALUES ( {department_name}, {department_manager_id})", New String(){},Settings.IntranetDBDataAccessObject)
        Update = New TableCommand("UPDATE departments SET department_name={department_name},  " & _
          "department_manager_id={department_manager_id}", New String(){"department_id13"},Settings.IntranetDBDataAccessObject)
        Delete = New TableCommand("DELETE FROM departments", New String(){"department_id13"},Settings.IntranetDBDataAccessObject)
    End Sub
'End Record departments Data Provider Class Constructor

'Record departments Data Provider Class LoadParams Method @11-5313721B

    Protected Function LoadParams() As Boolean
        CommonParameters.Clear()
    If IsNothing(Urldepartment_id) Then
        CommonParameters.Add("department_id13","")
    Else
        CommonParameters.Add("department_id13","department_id = " & Select_.Dao.ToSql(Urldepartment_id.GetFormattedValue(""),FieldType._Integer))
    End If
        Return (IsNothing(Urldepartment_id))
    End Function
'End Record departments Data Provider Class LoadParams Method

'Record departments Data Provider Class CheckUnique Method @11-6D4AA45B

    Public Function CheckUnique(ByVal ControlName As String, ByVal item As departmentsItem) As Boolean
        Return True
    End Function
'End Record departments Data Provider Class CheckUnique Method

'Record departments Data Provider Class PrepareInsert Method @11-0E277F0A

    Protected Overrides Sub PrepareInsert()
'End Record departments Data Provider Class PrepareInsert Method

'Record departments Data Provider Class PrepareInsert Method tail @11-E31F8E2A
    End Sub
'End Record departments Data Provider Class PrepareInsert Method tail

'Record departments Data Provider Class Insert Method @11-8F48E345

    Public Function InsertItem(ByVal item As departmentsItem) As Integer
'End Record departments Data Provider Class Insert Method

'Record departments Build insert @11-75A437CA
        Insert.SqlQuery.Replace("{department_name}",Insert.Dao.ToSql(item.department_name.GetFormattedValue(""),FieldType._Text))
        Insert.SqlQuery.Replace("{department_manager_id}",Insert.Dao.ToSql(item.department_manager_id.GetFormattedValue(""),FieldType._Text))
        Insert.SqlQuery.Replace("{is_change}",Insert.Dao.ToSql(item.is_change.GetFormattedValue(""),FieldType._Text))
        Dim result As Object = Nothing
        Dim E As Exception = Nothing
        Try
            result = ExecuteInsert()
        Catch ee As Exception
            E = ee
        Finally
'End Record departments Build insert

'Record departments AfterExecuteInsert @11-2FB4FB62
            If Not IsNothing(E) Then Throw E
        End Try
        Return CType(result, Integer)
    End Function
'End Record departments AfterExecuteInsert

'Record departments Data Provider Class PrepareUpdate Method @11-D72B5D1D

    Protected Overrides Sub PrepareUpdate()
        LoadParams()
        Update.Parameters = CommonParameters
'End Record departments Data Provider Class PrepareUpdate Method

'Record departments Data Provider Class PrepareUpdate Method tail @11-E31F8E2A
    End Sub
'End Record departments Data Provider Class PrepareUpdate Method tail

'Record departments Data Provider Class Update Method @11-999F5351

    Public Function UpdateItem(ByVal item As departmentsItem) As Integer
'End Record departments Data Provider Class Update Method

'Record departments BeforeBuildUpdate @11-0636D160
        Update.SqlQuery.Replace("{department_name}",Update.Dao.ToSql(item.department_name.GetFormattedValue(""),FieldType._Text))
        Update.SqlQuery.Replace("{department_manager_id}",Update.Dao.ToSql(item.department_manager_id.GetFormattedValue(""),FieldType._Text))
        Update.SqlQuery.Replace("{is_change}",Update.Dao.ToSql(item.is_change.GetFormattedValue(""),FieldType._Text))
        Dim result As Object = Nothing
        Dim E As Exception = Nothing
        Try
            result = ExecuteUpdate()
        Catch ee As Exception
            E = ee
        Finally
'End Record departments BeforeBuildUpdate

'Record departments AfterExecuteUpdate @11-2FB4FB62
            If Not IsNothing(E) Then Throw E
        End Try
        Return CType(result, Integer)
    End Function
'End Record departments AfterExecuteUpdate

'Record departments Data Provider Class PrepareDelete Method @11-998024F7

    Protected Overrides Sub PrepareDelete()
        LoadParams()
        Delete.Parameters = CommonParameters
'End Record departments Data Provider Class PrepareDelete Method

'Record departments Data Provider Class PrepareDelete Method tail @11-E31F8E2A
    End Sub
'End Record departments Data Provider Class PrepareDelete Method tail

'Record departments Data Provider Class Delete Method @11-AF4612A4

    Public Function DeleteItem(ByVal item As departmentsItem) As Integer
'End Record departments Data Provider Class Delete Method

'Record departments BeforeBuildDelete @11-19F34D29
        Dim result As Object = Nothing
        Dim E As Exception = Nothing
        Try
            result = ExecuteDelete()
        Catch ee As Exception
            E = ee
        Finally
'End Record departments BeforeBuildDelete

'Record departments BeforeBuildDelete @11-2FB4FB62
            If Not IsNothing(E) Then Throw E
        End Try
        Return CType(result, Integer)
    End Function
'End Record departments BeforeBuildDelete

'PrepareSelect Method @11-34AB3510

    Protected Overrides Sub PrepareSelect()
        LoadParams()
        Select_.Parameters = CommonParameters
    End Sub
'End PrepareSelect Method

'Record departments Data Provider Class GetResultSet Method @11-406306A7

    Public Sub FillItem(ByVal item As departmentsItem, ByRef IsInsertMode As Boolean)
        Dim ReadNotAllowed As Boolean = IsInsertMode
        Dim E As Exception = Nothing
'End Record departments Data Provider Class GetResultSet Method

'Record departments BeforeBuildSelect @11-0FCCC126
        IsInsertMode = LoadParams()
        Dim dr As DataRowCollection = Nothing
        If Not IsInsertMode Then
'End Record departments BeforeBuildSelect

'Record departments BeforeExecuteSelect @11-EBD3678C
            Try
                dr = ExecuteSelect().Tables(0).Rows
            Catch ee As Exception
                E = ee
            Finally
'End Record departments BeforeExecuteSelect

'Record departments AfterExecuteSelect @11-1015CECA
                If Not IsNothing(E) Then Throw E
        End Try
        End If
        If (Not IsInsertMode) And (Not ReadNotAllowed) Then
            If dr.Count <> 0 Then
                Dim i As Integer = 0
                item.department_name.SetValue(dr(i)("department_name"),"")
                item.department_manager_id.SetValue(dr(i)("department_manager_id"),"")
        Else
            IsInsertMode = True
            End If
        End If
'End Record departments AfterExecuteSelect

'Record departments AfterExecuteSelect tail @11-E31F8E2A
    End Sub
'End Record departments AfterExecuteSelect tail

'Record departments Data Provider Class @11-A61BA892
End Class

'End Record departments Data Provider Class

'Page Data Provider Tail @1-5EA2E2E0
End Namespace
'End Page Data Provider Tail



