//Using Statements @1-4D26104F
using System;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Specialized;
using System.Data;
using CCSExample_CSharp;
using CCSExample_CSharp.Data;
using CCSExample_CSharp.Controls;
using CCSExample_CSharp.Configuration;

namespace CCSExample_CSharp.PopUpList.PopUpList_Window
{
//End Using Statements

//Page Data Class @1-F1F2C6B1
public class PageItem
{
    public NameValueCollection errors=new NameValueCollection();
    public PageItem()
    {
    }
    public static PageItem CreateFromHttpRequest()
    {
        PageItem item = new PageItem();
        item.Link1.SetValue(DBUtility.GetInitialValue("Link1"));
        return item;
    }

    public FieldBase this[string fieldName]{
        get{
            switch(fieldName){
                case "Link1":
                    return this.Link1;
                default:
                    throw (new ArgumentOutOfRangeException());
            }
        }
        set{
            switch(fieldName){
                case "Link1":
                    this.Link1 = (TextField)value;
                    break;
                default:
                    throw (new ArgumentOutOfRangeException());
            }
        }
    }

    public TextField Link1 = new TextField("",null);
    public object Link1Href;
    public LinkParameterCollection Link1HrefParameters = new LinkParameterCollection();
}
//End Page Data Class

//Page Data Provider Class @1-50FE4D41
public class PageDataProvider
{
//End Page Data Provider Class

//Page Data Provider Class Constructor @1-9A44B219
    public PageDataProvider()
    {
    }
//End Page Data Provider Class Constructor

//Page Data Provider Class GetResultSet Method @1-052161C6
    public void FillItem(PageItem item)
    {
//End Page Data Provider Class GetResultSet Method

//Page Data Provider Class GetResultSet Method tail @1-FCB6E20C
    }
//End Page Data Provider Class GetResultSet Method tail

//Page Data Provider Tail @1-FCB6E20C
}
//End Page Data Provider Tail

//Record employees_deparSearch Item Class @8-9CA73FD9
public class employees_deparSearchItem
{
    private bool _isNew = true;
    private bool _isDeleted = false;
    public NameValueCollection errors=new NameValueCollection();
    public employees_deparSearchItem()
    {
    }
    public TextField s_emp_name=new TextField("", null);
    public IntegerField s_department_name = new IntegerField("", null);
    public ItemCollection s_department_nameItems = new ItemCollection();

    public static employees_deparSearchItem CreateFromHttpRequest()
    {
        employees_deparSearchItem item = new employees_deparSearchItem();
        if(DBUtility.GetInitialValue("s_emp_name") != null){
        item.s_emp_name.SetValue(DBUtility.GetInitialValue("s_emp_name"));
        }
        if(DBUtility.GetInitialValue("s_department_name") != null){
        item.s_department_name.SetValue(DBUtility.GetInitialValue("s_department_name"));
        }
        if(DBUtility.GetInitialValue("DoSearch") != null){
        }
        return item;
    }

    public FieldBase this[string fieldName]{
        get{
            switch(fieldName){
                case "s_emp_name":
                    return this.s_emp_name;
                case "s_department_name":
                    return this.s_department_name;
                default:
                    throw (new ArgumentOutOfRangeException());
            }
        }
        set{
            switch(fieldName){
                case "s_emp_name":
                    this.s_emp_name = (TextField)value;
                    break;
                case "s_department_name":
                    this.s_department_name = (IntegerField)value;
                    break;
                default:
                    throw (new ArgumentOutOfRangeException());
            }
        }
    }

    public bool IsNew{
        get{
            return _isNew;
        }
        set{
            _isNew = value;
        }
    }

    public bool IsDeleted{
        get{
            return _isDeleted;
        }
        set{
            _isDeleted = value;
        }
    }

    public void Validate(employees_deparSearchDataProvider provider)
    {
//End Record employees_deparSearch Item Class

//Record employees_deparSearch Item Class tail @8-F5FC18C5
    }
}
//End Record employees_deparSearch Item Class tail

//Record employees_deparSearch Data Provider Class @8-867A9758
public class employees_deparSearchDataProvider:RecordDataProviderBase
{
//End Record employees_deparSearch Data Provider Class

//Record employees_deparSearch Data Provider Class Variables @8-6F0C0D15
    protected DataCommand s_department_nameDataCommand=new TableCommand("SELECT *  " + 
          "FROM departments",new string[]{},Settings.IntranetDBDataAccessObject);
//End Record employees_deparSearch Data Provider Class Variables

//Record employees_deparSearch Data Provider Class GetResultSet Method @8-E2C78777
    public void FillItem(employees_deparSearchItem item, ref bool IsInsertMode)
    {
        bool ReadNotAllowed=IsInsertMode;
        Exception E=null;
//End Record employees_deparSearch Data Provider Class GetResultSet Method

//Record employees_deparSearch BeforeBuildSelect @8-921CE95D
        if(!IsInsertMode){
//End Record employees_deparSearch BeforeBuildSelect

//Record employees_deparSearch AfterExecuteSelect @8-C5999683
        }
            IsInsertMode=true;
        DataRowCollection ListBoxSource=null;
//End Record employees_deparSearch AfterExecuteSelect

//ListBox s_department_name BeforeExecuteSelect @11-59E60BAB
        try{
            ListBoxSource=s_department_nameDataCommand.Execute().Tables[0].Rows;
        }catch(Exception e){
            E=e;}
        finally{
//End ListBox s_department_name BeforeExecuteSelect

//ListBox s_department_name AfterExecuteSelect @11-BF85E3EC
            if(E!=null) throw(E);
        }
        for(int i=0;i<ListBoxSource.Count;i++){
            object val = ListBoxSource[i]["department_name"];
            string key = (new IntegerField("", ListBoxSource[i]["department_id"])).GetFormattedValue("");
            item.s_department_nameItems.Add(key,val);
        }
//End ListBox s_department_name AfterExecuteSelect

//Record employees_deparSearch AfterExecuteSelect tail @8-FCB6E20C
    }
//End Record employees_deparSearch AfterExecuteSelect tail

//Record employees_deparSearch Data Provider Class @8-FCB6E20C
}

//End Record employees_deparSearch Data Provider Class

//Grid employees Item Class @2-60F72981
public class employeesItem
{
    public NameValueCollection errors=new NameValueCollection();
    public employeesItem()
    {
    }

    public FieldBase this[string fieldName]{
        get{
            switch(fieldName){
                case "emp_name":
                    return this.emp_name;
                case "department_name":
                    return this.department_name;
                case "title":
                    return this.title;
                default:
                    throw (new ArgumentOutOfRangeException());
            }
        }
        set{
            switch(fieldName){
                case "emp_name":
                    this.emp_name = (TextField)value;
                    break;
                case "department_name":
                    this.department_name = (TextField)value;
                    break;
                case "title":
                    this.title = (TextField)value;
                    break;
                default:
                    throw (new ArgumentOutOfRangeException());
            }
        }
    }

    public TextField emp_name = new TextField("",null);
    public object emp_nameHref;
    public LinkParameterCollection emp_nameHrefParameters = new LinkParameterCollection();
    public TextField department_name=new TextField("", null);
    public TextField title=new TextField("", null);
}
//End Grid employees Item Class

//Grid employees Data Provider Class Header @2-144E2004
public class employeesDataProvider:GridDataProviderBase
{
//End Grid employees Data Provider Class Header

//Grid employees Data Provider Class Variables @2-B12DC5DC
    public enum SortFields {Default}
    private string[] SortFieldsNames=new string[]{"department_name"};
    private string[] SortFieldsNamesDesc=new string[]{"department_name"};
    public SortFields SortField=SortFields.Default;
    public SortDirections SortDir=SortDirections.Asc;
    public int RecordsPerPage=10;
    public int PageNumber=1;
    public IntegerParameter Urls_department_name;
//End Grid employees Data Provider Class Variables

//Grid employees Data Provider Class Constructor @2-99ADD9B2
    public employeesDataProvider()
    {
        Select=new TableCommand("SELECT *  " + 
          "FROM departments INNER JOIN employees ON departments.department_id = employees.department_id",new string[]{"s_department_name15"},Settings.IntranetDBDataAccessObject);
        Count=new TableCommand("SELECT COUNT(*)  " + 
          "FROM departments INNER JOIN employees ON departments.department_id = employees.department_id",new string[]{"s_department_name15"},Settings.IntranetDBDataAccessObject);
    }
//End Grid employees Data Provider Class Constructor

//Grid employees Data Provider Class GetResultSet Method @2-33DD9B3D
    public employeesItem[] GetResultSet(out int PagesCount)
    {
//End Grid employees Data Provider Class GetResultSet Method

//Grid employees Event BeforeBuildSelect. Action Custom Code @20-2A29BDB7

	//Dynamically modify the WHERE statement (of the datasource) to match the following SQL condition:
	//emp_name LIKE F% L%", where F = First Name, L = Last Name.

	string search_name;
	System.Web.HttpRequest Req = System.Web.HttpContext.Current.Request;

	if(Req.QueryString["s_emp_name"]==null || Req.QueryString["s_emp_name"].Length ==0){
		search_name = "";
	}else{
		search_name = Req.QueryString["s_emp_name"].Trim().Replace(" ","%");
	}
	
	if(search_name.IndexOf("%")==-1) search_name = "%" + search_name + "%";
	else search_name = search_name + "%";
	search_name = search_name.Replace("'","''");

	((TableCommand)Select).Where = "emp_name like '" + search_name + "'";
	((TableCommand)Select).Operation = "AND";

      
//End Grid employees Event BeforeBuildSelect. Action Custom Code

//Before build Select @2-42F84E05
        Parameters.Clear();
        Parameters.Add("s_department_name15",Urls_department_name==null?"":("departments.department_id = " + Select.Dao.ToSql(Urls_department_name.GetFormattedValue(""),FieldType.Integer)));
        Select.OrderBy=(SortDir==SortDirections.Asc?SortFieldsNames[(int)SortField]:SortFieldsNamesDesc[(int)SortField]).Trim();
//End Before build Select

//Execute Select @2-E684A2A4
        DataSet ds=null;Exception E=null;
        PagesCount=0;
        try{
            if(RecordsPerPage>0)
            {
                ds=ExecuteSelect((PageNumber-1)*RecordsPerPage,RecordsPerPage);
                PagesCount = ExecuteCount();
                mRecordCount = PagesCount;
                PagesCount = PagesCount%RecordsPerPage>0?(int)(PagesCount/RecordsPerPage)+1:(int)(PagesCount/RecordsPerPage);
            }
            else
            {
            ds=ExecuteSelect();
            if(ds.Tables[0].Rows.Count!=0)PagesCount=1;
            }
        }catch(Exception e){
            E=e;}
        finally{
//End Execute Select

//After execute Select @2-26794871
        if(E!=null) throw(E);
        }
        DataRowCollection dr=ds.Tables[0].Rows;
        employeesItem[] result=new employeesItem[dr.Count];
//End After execute Select

//After execute Select tail @2-23BDE7BD
        for(int i=0;i<dr.Count;i++)
        {
            employeesItem item=new employeesItem();
            item.emp_name.SetValue(dr[i]["emp_name"],"");
            item.department_name.SetValue(dr[i]["department_name"],"");
            item.title.SetValue(dr[i]["title"],"");
            result[i]=item;
        }
        return result; 
    }
//End After execute Select tail

//Grid Data Provider tail @2-FCB6E20C
}
//End Grid Data Provider tail

//Page Data Provider Tail @1-FCB6E20C
}
//End Page Data Provider Tail

