//employees_recordHandler Head @2-517E2E03
package MasterDetail.MasterDetail;
import java.util.*;
import com.codecharge.*;
import com.codecharge.db.*;
import com.codecharge.components.*;
import com.codecharge.events.*;
import com.codecharge.util.*;
public class employees_recordRecordHandler implements RecordListener {
//End employees_recordHandler Head

//BeforeShow Head @2-46046458
    public void beforeShow(Event e) {
//End BeforeShow Head

//Event BeforeShow Action Custom Code @42-44795B7A
  		//Hide the Editable grid if record is in the insert mode
  		if (! e.getRecord().isEditMode()) {
     		e.getPage().getEditableGrid("projects_employees").setVisible(false);
  		}
//End Event BeforeShow Action Custom Code

//BeforeShow Tail @2-FCB6E20C
    }
//End BeforeShow Tail

//OnValidate Head @2-5F430F8E
    public void onValidate(Event e) {
//End OnValidate Head

//OnValidate Tail @2-FCB6E20C
    }
//End OnValidate Tail

//BeforeSelect Head @2-E5EC9AD3
    public void beforeSelect(Event e) {
//End BeforeSelect Head

//BeforeSelect Tail @2-FCB6E20C
    }
//End BeforeSelect Tail

//BeforeInsert Head @2-75B62B83
    public void beforeInsert(Event e) {
//End BeforeInsert Head

//BeforeInsert Tail @2-FCB6E20C
    }
//End BeforeInsert Tail

//AfterInsert Head @2-767A9165
    public void afterInsert(Event e) {
//End AfterInsert Head

//Event AfterInsert Action Custom Code @30-44795B7A
  		//Retrieve the last inserted key
  		String lastId = Utils.convertToString(DBTools.dLookUp("max(emp_id)","employees","", "IntranetDB"));
  		//Append the last inserted key to the URL by modifying the 'Redirect' variable
  		e.getPage().setRedirectString( e.getPage().getName() + ".do?" + 
				e.getPage().getHttpGetParameters().toString(new String[]{"ccsForm"}) +
				"&emp_id=" + lastId	);
//End Event AfterInsert Action Custom Code

//AfterInsert Tail @2-FCB6E20C
    }
//End AfterInsert Tail

//BeforeUpdate Head @2-33A3CFAC
    public void beforeUpdate(Event e) {
//End BeforeUpdate Head

//BeforeUpdate Tail @2-FCB6E20C
    }
//End BeforeUpdate Tail

//AfterUpdate Head @2-306F754A
    public void afterUpdate(Event e) {
//End AfterUpdate Head

//AfterUpdate Tail @2-FCB6E20C
    }
//End AfterUpdate Tail

//BeforeDelete Head @2-752E3118
    public void beforeDelete(Event e) {
//End BeforeDelete Head

//Event BeforeDelete Action Custom Code @45-44795B7A
		//Delete related projects when deleting an employee
		String empId = e.getPage().getHttpGetParameter("emp_id");
  		if (! StringUtils.isEmpty(empId)) {
    		DBTools.executeUpdate("DELETE FROM projects_employees WHERE emp_id=" + 
					DBTools.toSql(empId, JDBCConnection.INTEGER, "IntranetDB"), "IntranetDB"
					);
  		}    
//End Event BeforeDelete Action Custom Code

//BeforeDelete Tail @2-FCB6E20C
    }
//End BeforeDelete Tail

//AfterDelete Head @2-76E28BFE
    public void afterDelete(Event e) {
//End AfterDelete Head

//AfterDelete Tail @2-FCB6E20C
    }
//End AfterDelete Tail

//employees_recordHandler Tail @2-FCB6E20C
}
//End employees_recordHandler Tail

