//Using Statements @1-7B123125
using System;
using System.Collections;
using System.Collections.Specialized;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Text.RegularExpressions;
using System.Globalization;
using CCSExamplePack;
using CCSExamplePack.Data;
using CCSExamplePack.Configuration;
using CCSExamplePack.Controls;

namespace CCSExamplePack.Directory.Directory
{

//End Using Statements

//Forms Definition @1-A7CA7198
public class DirectoryPage : System.Web.UI.Page
{
//End Forms Definition

//Forms Objects @1-23125CB8
    protected CCPath NewPath1;
    protected NewPath1DataProvider NewPath1Data;
    protected CCDirectory yp_categories;
    protected yp_categoriesDataProvider yp_categoriesData;
    protected System.Web.UI.WebControls.Repeater yp_gridRepeater;
    protected yp_gridDataProvider yp_gridData;
    protected System.Web.UI.HtmlControls.HtmlAnchor Link1;
//End Forms Objects

//Page_Load Event @1-55207E05
private void Page_Load(object sender, System.EventArgs e)
{
//End Page_Load Event

//Page_Load Event BeforeIsPostBack @1-47C29414
    if (!IsPostBack)
    {
            PageDataProvider PageData=new PageDataProvider();
            PageItem item=PageItem.CreateFromHttpRequest();
            item.Link1Href = "Directory_desc.aspx?";
            PageData.FillItem(item);
            Link1.InnerText += item.Link1.GetFormattedValue().Replace("\r","").Replace("\n","<br>");
            Link1.HRef += item.Link1Href+item.Link1HrefParameters.ToString("GET","", ViewState);
            NewPath1Bind();
            yp_categoriesBind();
            yp_gridBind();
    }
//End Page_Load Event BeforeIsPostBack

//Page_Load Event tail @1-FCB6E20C
}
//End Page_Load Event tail

//Page_Unload Event @1-72102C7C
private void Page_Unload(object sender, System.EventArgs e)
{
//End Page_Unload Event

//Page_Unload Event tail @1-FCB6E20C
}
//End Page_Unload Event tail

//Path NewPath1 Bind @77-22A9908C
    protected void NewPath1Bind()
    {
        int FooterIndex;
//End Path NewPath1 Bind

//Path Form NewPath1 BeforeShow tail @77-26B53FBF
        NewPath1Parameters();
        NewPath1.DataSource = NewPath1Data.GetResultSet();
        NewPath1.DataBind();
        FooterIndex = NewPath1.Controls.Count - 1;
        NewPath1Item item=new NewPath1Item();
        System.Web.UI.HtmlControls.HtmlAnchor NewPath1PathBeginLink = (System.Web.UI.HtmlControls.HtmlAnchor)NewPath1.Controls[0].FindControl("NewPath1PathBeginLink");

        item.PathBeginLinkHref = "Directory.aspx?";

        NewPath1PathBeginLink.InnerText += item.PathBeginLink.GetFormattedValue().Replace("\r","").Replace("\n","<br>");
        NewPath1PathBeginLink.HRef += item.PathBeginLinkHref+item.PathBeginLinkHrefParameters.ToString("GET","category_id", ViewState);
//End Path Form NewPath1 BeforeShow tail

//Path NewPath1 Bind tail @77-FCB6E20C
    }
//End Path NewPath1 Bind tail

//Path NewPath1 Table Parameters @77-FE018EE3
    protected void NewPath1Parameters()
    {
        try{
            NewPath1Data.Urlcategory_id= IntegerParameter.GetParam(Request.QueryString["category_id"]);
        }catch{
            ControlCollection ParentControls=NewPath1.Parent.Controls;
            int RepeaterIndex=ParentControls.IndexOf(NewPath1);
            ParentControls.RemoveAt(RepeaterIndex);
            Literal ErrorMessage=new Literal();
            ErrorMessage.Text="Error in Path NewPath1: Invalid parameter";
            ParentControls.AddAt(RepeaterIndex,ErrorMessage);
        }
	}
	
//End Path NewPath1 Table Parameters

//Path NewPath1 ItemDataBound event @77-3A1BF7EB
    protected void NewPath1ItemDataBound(Object Sender, CCPathItemEventArgs e)
    {
        NewPath1Item DataItem=(NewPath1Item)e.Item.DataItem;
        if (e.Item.ItemType == CCPathItemType.PathComponent) {
            System.Web.UI.HtmlControls.HtmlAnchor NewPath1PathCategory = (System.Web.UI.HtmlControls.HtmlAnchor)(e.Item.FindControl("NewPath1PathCategory"));
            DataItem.PathCategoryHref = "Directory.aspx?";
            NewPath1PathCategory.HRef += DataItem.PathCategoryHref + DataItem.PathCategoryHrefParameters.ToString("GET","", ViewState);
        }
        if (e.Item.ItemType == CCPathItemType.CurrentCategory) {
        }
//End Path NewPath1 ItemDataBound event

//Path NewPath1 ItemDataBound event tail @77-FCB6E20C
    }
//End Path NewPath1 ItemDataBound event tail

//Directory yp_categories Bind @8-2F2BBE5A
    protected void yp_categoriesBind()
    {
        int FooterIndex;
//End Directory yp_categories Bind

//Directory Form yp_categories BeforeShow tail @8-1575B86F
        yp_categories.SubcategoryCount= 4;
        yp_categories.ColumnCount= 2;
        yp_categoriesParameters();
        yp_categories.DataSource = yp_categoriesData.GetResultSet();
        yp_categories.DataBind();
        FooterIndex = yp_categories.Controls.Count - 1;


//End Directory Form yp_categories BeforeShow tail

//Control yp_categories Event BeforeShow. Action Custom Code @84-2A29BDB7

  if (!yp_categories.DataSource.GetEnumerator().MoveNext()) { 
     yp_categories.Visible = false;
  }

//End Control yp_categories Event BeforeShow. Action Custom Code

//Directory yp_categories Bind tail @8-FCB6E20C
    }
//End Directory yp_categories Bind tail

//Directory yp_categories Table Parameters @8-C1121344
    protected void yp_categoriesParameters()
    {
        try{
            yp_categoriesData.Urlcategory_id= IntegerParameter.GetParam(Request.QueryString["category_id"]);
        }catch{
            ControlCollection ParentControls=yp_categories.Parent.Controls;
            int RepeaterIndex=ParentControls.IndexOf(yp_categories);
            ParentControls.RemoveAt(RepeaterIndex);
            Literal ErrorMessage=new Literal();
            ErrorMessage.Text="Error in Directory yp_categories: Invalid parameter";
            ParentControls.AddAt(RepeaterIndex,ErrorMessage);
        }
	}
	
//End Directory yp_categories Table Parameters

//Directory yp_categories ItemDataBound event @8-033DB640
    protected void yp_categoriesItemDataBound(Object Sender, CCDirectoryItemEventArgs e)
    {
        yp_categoriesItem DataItem=(yp_categoriesItem)e.Item.DataItem;
        if (e.Item.ItemType == CCDirectoryItemType.CategoryHeader) {
            System.Web.UI.HtmlControls.HtmlAnchor yp_categoriesCategoryLink = (System.Web.UI.HtmlControls.HtmlAnchor)(e.Item.FindControl("yp_categoriesCategoryLink"));
            DataItem.CategoryLinkHref = "Directory.aspx?";
            yp_categoriesCategoryLink.HRef += DataItem.CategoryLinkHref + DataItem.CategoryLinkHrefParameters.ToString("GET","", ViewState);
        }
        if (e.Item.ItemType == CCDirectoryItemType.Subcategory) {
            System.Web.UI.HtmlControls.HtmlAnchor yp_categoriesSubcategoryLink = (System.Web.UI.HtmlControls.HtmlAnchor)(e.Item.FindControl("yp_categoriesSubcategoryLink"));
            DataItem.SubcategoryLinkHref = "Directory.aspx?";
            yp_categoriesSubcategoryLink.HRef += DataItem.SubcategoryLinkHref + DataItem.SubcategoryLinkHrefParameters.ToString("GET","", ViewState);
        }
        if (e.Item.ItemType == CCDirectoryItemType.SubcategoriesTail) {
            System.Web.UI.HtmlControls.HtmlAnchor yp_categoriesSubcategoriesTailLink = (System.Web.UI.HtmlControls.HtmlAnchor)(e.Item.FindControl("yp_categoriesSubcategoriesTailLink"));
            DataItem.SubcategoriesTailLinkHref = "Directory.aspx?";
            yp_categoriesSubcategoriesTailLink.HRef += DataItem.SubcategoriesTailLinkHref + DataItem.SubcategoriesTailLinkHrefParameters.ToString("GET","", ViewState);
        }
//End Directory yp_categories ItemDataBound event

//Directory yp_categories ItemDataBound event tail @8-FCB6E20C
    }
//End Directory yp_categories ItemDataBound event tail

//Grid yp_grid Bind @24-7D95BB97
    protected void yp_gridBind()
    {
        int PagesCount;
        int FooterIndex;
        if (!IsPostBack)
        {
            string Param;
            int PageSize;
            ViewState["yp_gridSortField"] = yp_gridDataProvider.SortFields.Default;
            PageSize = 20;
            ViewState["yp_gridPageNumber"] = 1;
            Param = Request.QueryString["yp_gridOrder"];
            if (Param != null && Param.Length > 0)
                try{
                    yp_gridDataProvider.SortFields SortField = 0;
                    ViewState["yp_gridSortField"] = Enum.Parse(SortField.GetType(), Param);
                }catch {}
            Param = Request.QueryString["yp_gridDir"];
            if (Param == null || Param.Length == 0 || Param.ToLower() == "desc")
                ViewState["yp_gridSortDir"] = SortDirections.Desc;
            else
                ViewState["yp_gridSortDir"] = SortDirections.Asc;
            Param = Request.QueryString["yp_gridPage"];
            int PageNumber;
            if (Param != null && Param.Length > 0)
                try
                {
                    PageNumber = Int32.Parse(Param);
                    if (PageNumber > 0) ViewState["yp_gridPageNumber"] = PageNumber;
                }
                catch {}
            Param = Request.QueryString["yp_gridPageSize"];
            if (Param != null && Param.Length > 0)
                try
                {
                    PageSize = Int32.Parse(Param);
                    if (PageSize <= 0) PageSize = 20;
                }
                catch {}
            if (PageSize > 100)
                PageSize = 100;
            ViewState["yp_gridPageSize"] = PageSize;
        }
//End Grid yp_grid Bind

//Grid Form yp_grid BeforeShow tail @24-F2D229A6
        yp_gridParameters();
        yp_gridData.SortField = (yp_gridDataProvider.SortFields)ViewState["yp_gridSortField"];
        yp_gridData.SortDir = (SortDirections)ViewState["yp_gridSortDir"];
        yp_gridData.PageNumber = (int)ViewState["yp_gridPageNumber"];
        yp_gridData.RecordsPerPage = (int)ViewState["yp_gridPageSize"];
        yp_gridRepeater.DataSource = yp_gridData.GetResultSet(out PagesCount);
        ViewState["yp_gridPagesCount"] = PagesCount;
        yp_gridRepeater.DataBind();
        FooterIndex = yp_gridRepeater.Controls.Count - 1;
        if (PagesCount == 0)
        {
            yp_gridRepeater.Controls[FooterIndex].FindControl("NoRecords").Visible = true;
        }


        if(yp_gridData.SortField.ToString()=="Sorter_item_name") 
            ((CCSExamplePack.Controls.Sorter)yp_gridRepeater.Controls[0].FindControl("Sorter_item_nameSorter")).State=yp_gridData.SortDir==SortDirections.Asc?SorterState.Ascending:SorterState.Descending;
        if(yp_gridData.SortField.ToString()=="Sorter_address") 
            ((CCSExamplePack.Controls.Sorter)yp_gridRepeater.Controls[0].FindControl("Sorter_addressSorter")).State=yp_gridData.SortDir==SortDirections.Asc?SorterState.Ascending:SorterState.Descending;
        if(yp_gridData.SortField.ToString()=="Sorter_city") 
            ((CCSExamplePack.Controls.Sorter)yp_gridRepeater.Controls[0].FindControl("Sorter_citySorter")).State=yp_gridData.SortDir==SortDirections.Asc?SorterState.Ascending:SorterState.Descending;
        if(yp_gridData.SortField.ToString()=="Sorter_phone") 
            ((CCSExamplePack.Controls.Sorter)yp_gridRepeater.Controls[0].FindControl("Sorter_phoneSorter")).State=yp_gridData.SortDir==SortDirections.Asc?SorterState.Ascending:SorterState.Descending;
        if(yp_gridData.SortField.ToString()=="Sorter_zip") 
            ((CCSExamplePack.Controls.Sorter)yp_gridRepeater.Controls[0].FindControl("Sorter_zipSorter")).State=yp_gridData.SortDir==SortDirections.Asc?SorterState.Ascending:SorterState.Descending;
        if(yp_gridData.SortField.ToString()=="Sorter_email") 
            ((CCSExamplePack.Controls.Sorter)yp_gridRepeater.Controls[0].FindControl("Sorter_emailSorter")).State=yp_gridData.SortDir==SortDirections.Asc?SorterState.Ascending:SorterState.Descending;
        if(yp_gridData.SortField.ToString()=="Sorter_url") 
            ((CCSExamplePack.Controls.Sorter)yp_gridRepeater.Controls[0].FindControl("Sorter_urlSorter")).State=yp_gridData.SortDir==SortDirections.Asc?SorterState.Ascending:SorterState.Descending;
        CCSExamplePack.Controls.Navigator NavigatorNavigator = (CCSExamplePack.Controls.Navigator)yp_gridRepeater.Controls[FooterIndex].FindControl("NavigatorNavigator");
        NavigatorNavigator.MaxPage=PagesCount;
        NavigatorNavigator.PageNumber=yp_gridData.PageNumber;
        NavigatorNavigator.DataBind();
//End Grid Form yp_grid BeforeShow tail

//Control yp_grid Event BeforeShow. Action Custom Code @42-2A29BDB7

  if (PagesCount == 0) {
     yp_gridRepeater.Visible = false; 
  }

//End Control yp_grid Event BeforeShow. Action Custom Code

//Grid yp_grid Bind tail @24-FCB6E20C
    }
//End Grid yp_grid Bind tail

//Grid yp_grid Table Parameters @24-6092952D
    protected void yp_gridParameters()
    {
        try{
            yp_gridData.Urlcategory_id= IntegerParameter.GetParam(Request.QueryString["category_id"]);
        }catch{
            ControlCollection ParentControls=yp_gridRepeater.Parent.Controls;
            int RepeaterIndex=ParentControls.IndexOf(yp_gridRepeater);
            ParentControls.RemoveAt(RepeaterIndex);
            Literal ErrorMessage=new Literal();
            ErrorMessage.Text="Error in Grid yp_grid: Invalid parameter";
            ParentControls.AddAt(RepeaterIndex,ErrorMessage);
        }
	}
	
//End Grid yp_grid Table Parameters

//Grid yp_grid ItemDataBound event @24-896BC9FF
    protected void yp_gridItemDataBound(Object Sender, RepeaterItemEventArgs e)
    {
        yp_gridItem DataItem=(yp_gridItem)e.Item.DataItem;
        if (e.Item.ItemType == ListItemType.Item || e.Item.ItemType == ListItemType.AlternatingItem) {
            System.Web.UI.HtmlControls.HtmlAnchor yp_gridemail = (System.Web.UI.HtmlControls.HtmlAnchor)(e.Item.FindControl("yp_gridemail"));
            yp_gridemail.HRef += DataItem.emailHref + DataItem.emailHrefParameters.ToString("None","", ViewState);
            System.Web.UI.HtmlControls.HtmlAnchor yp_gridurl = (System.Web.UI.HtmlControls.HtmlAnchor)(e.Item.FindControl("yp_gridurl"));
            yp_gridurl.HRef += DataItem.urlHref + DataItem.urlHrefParameters.ToString("None","", ViewState);
        }
//End Grid yp_grid ItemDataBound event

//Grid yp_grid ItemDataBound event tail @24-FCB6E20C
    }
//End Grid yp_grid ItemDataBound event tail

//Grid yp_grid ItemCommand event @24-0CCEF3D7
    protected void yp_gridItemCommand(Object Sender, RepeaterCommandEventArgs e)
    {
        int FooterIndex = yp_gridRepeater.Controls.Count - 1;
        bool BindAllowed = false;
        if(e.CommandName=="Sort"){
            if(((SorterState)e.CommandArgument)==SorterState.None)
                if((SortDirections)ViewState["yp_gridSortDir"]==SortDirections.Asc&&ViewState["yp_gridSortField"].ToString()==((CCSExamplePack.Controls.Sorter)e.CommandSource).Field)
                    ViewState["yp_gridSortDir"]=SortDirections.Desc;
                else
                    ViewState["yp_gridSortDir"]=SortDirections.Asc;
            else
                ViewState["yp_gridSortDir"]=(int)(((CCSExamplePack.Controls.Sorter)e.CommandSource).State);
            ViewState["yp_gridSortField"]=Enum.Parse(typeof(yp_gridDataProvider.SortFields),((CCSExamplePack.Controls.Sorter)e.CommandSource).Field);
            ViewState["yp_gridPageNumber"] = 1;
            BindAllowed = true;
        }
        if(e.CommandName=="Navigate"){
            ViewState["yp_gridPageNumber"] = Int32.Parse(e.CommandArgument.ToString());
            BindAllowed = true;
        }
        if (BindAllowed)
            yp_gridBind();
    }
//End Grid yp_grid ItemCommand event

//OnInit Event @1-084A2ACA
    #region Web Form Designer generated code
    override protected void OnInit(EventArgs e)
    {
        //
        //CODEGEN: This call is required by the ASP.NET Web Form Designer.
        //
        InitializeComponent();
        this.Load += new System.EventHandler(this.Page_Load);
        this.Unload += new System.EventHandler(this.Page_Unload);
        NewPath1Data = new NewPath1DataProvider();
        yp_categoriesData = new yp_categoriesDataProvider();
        yp_gridData = new yp_gridDataProvider();
        base.OnInit(e);
//End OnInit Event

//OnInit Event tail @1-FCB6E20C
    }
//End OnInit Event tail

//InitializeComponent Event @1-722FC1EE
    /// <summary>
    /// Required method for Designer support - do not modify
    /// the contents of this method with the code editor.
    /// </summary>
    private void InitializeComponent()
    {
    }
    #endregion
//End InitializeComponent Event

//Page class tail @1-F5FC18C5
}
}
//End Page class tail

