'Using Statements @1-FC26B47E
Imports System
Imports System.Collections
Imports System.Collections.Specialized
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Web
Imports System.Web.SessionState
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports System.Web.UI.HtmlControls
Imports System.Text.RegularExpressions
Imports System.Globalization
Imports CCSExamplePack
Imports CCSExamplePack.Data
Imports CCSExamplePack.Configuration
Imports CCSExamplePack.Controls
Namespace Directory.Directory
'End Using Statements

'Forms Definition @1-DE4965A3
Public Class [DirectoryPage]
Inherits System.Web.UI.Page
'End Forms Definition

'Forms Objects @1-40C0E12A
    Protected NewPath1 As CCPath
    Protected NewPath1Data As NewPath1DataProvider
    Protected yp_categories As  CCDirectory
    Protected yp_categoriesData As yp_categoriesDataProvider
    Protected yp_gridRepeater As  System.Web.UI.WebControls.Repeater
    Protected yp_gridData As yp_gridDataProvider
    Protected Link1 As System.Web.UI.HtmlControls.HtmlAnchor
'End Forms Objects

'Page_Load Event @1-A2D2CF1E

Protected Overrides Sub OnLoad(ByVal e As System.EventArgs)
'End Page_Load Event

'Page_Load Event BeforeIsPostBack @1-B076DE57
    If Not IsPostBack Then
            Dim PageData As PageDataProvider = New PageDataProvider()
            Dim item As PageItem = PageItem.CreateFromHttpRequest()
            item.Link1Href = "Directory_desc.aspx?"
            PageData.FillItem(item)
            Link1.InnerText += item.Link1.GetFormattedValue().Replace(vbCrLf,"")
            Link1.HRef += item.Link1Href & item.Link1HrefParameters.ToString("GET","", ViewState)
            NewPath1Bind()
            yp_categoriesBind
            yp_gridBind
    End If
'End Page_Load Event BeforeIsPostBack

'Page_Load Event tail @1-E31F8E2A
End Sub
'End Page_Load Event tail

'Page_Unload Event @1-D998A98F

Protected Overrides Sub OnUnload(ByVal e As System.EventArgs)
'End Page_Unload Event

'Page_Unload Event tail @1-E31F8E2A
End Sub
'End Page_Unload Event tail

'Path NewPath1 Bind @77-1E3D4563
    Protected Sub NewPath1Bind()
        Dim FooterIndex As Integer
'End Path NewPath1 Bind

'Path Form NewPath1 BeforeShow tail @77-805A9139
        NewPath1Parameters()
        NewPath1.DataSource = NewPath1Data.GetResultSet()
        NewPath1.DataBind()
        FooterIndex = NewPath1.Controls.Count - 1
        Dim item As NewPath1Item = New NewPath1Item()
        Dim NewPath1PathBeginLink As System.Web.UI.HtmlControls.HtmlAnchor = DirectCast(NewPath1.Controls(0).FindControl("NewPath1PathBeginLink"),System.Web.UI.HtmlControls.HtmlAnchor)

        item.PathBeginLinkHref = "Directory.aspx?"

        NewPath1PathBeginLink.InnerText += item.PathBeginLink.GetFormattedValue().Replace(vbCrLf,"")
        NewPath1PathBeginLink.HRef += item.PathBeginLinkHref & item.PathBeginLinkHrefParameters.ToString("GET","category_id", ViewState)
'End Path Form NewPath1 BeforeShow tail

'Path NewPath1 Bind tail @77-E31F8E2A
    End Sub
'End Path NewPath1 Bind tail

'Path NewPath1 Table Parameters @77-31B46524
    Protected Sub NewPath1Parameters()
        Try
            NewPath1Data.Urlcategory_id= IntegerParameter.GetParam(Request.QueryString("category_id"))
        Catch
            Dim ParentControls As ControlCollection=NewPath1.Parent.Controls
            Dim RepeaterIndex As Integer=ParentControls.IndexOf(NewPath1)
            ParentControls.RemoveAt(RepeaterIndex)
            Dim ErrorMessage as Literal=New Literal()
            ErrorMessage.Text="Error in Grid NewPath1: Invalid parameter"
            ParentControls.AddAt(RepeaterIndex,ErrorMessage)
        End Try
    End Sub
'End Path NewPath1 Table Parameters

'Path NewPath1 ItemDataBound event @77-D51282D1
    Protected Sub NewPath1ItemDataBound(Sender as Object, e as CCPathItemEventArgs)
        Dim DataItem as NewPath1Item=CType(e.Item.DataItem,NewPath1Item)
        If e.Item.ItemType = CCPathItemType.PathComponent Then
            Dim NewPath1PathCategory As System.Web.UI.HtmlControls.HtmlAnchor = DirectCast(e.Item.FindControl("NewPath1PathCategory"),System.Web.UI.HtmlControls.HtmlAnchor)
            DataItem.PathCategoryHref = "Directory.aspx?"
            NewPath1PathCategory.HRef += DataItem.PathCategoryHref & DataItem.PathCategoryHrefParameters.ToString("GET","", ViewState)
        End If
        If e.Item.ItemType = CCPathItemType.CurrentCategory Then
        End If
'End Path NewPath1 ItemDataBound event

'Path NewPath1 ItemDataBound event tail @77-E31F8E2A
    End Sub
'End Path NewPath1 ItemDataBound event tail

'Directory yp_categories Bind @8-4F3C6D8D
    Protected Sub yp_categoriesBind()
        Dim FooterIndex As Integer
'End Directory yp_categories Bind

'Directory Form yp_categories BeforeShow tail @8-FA4077AD
        yp_categories.SubcategoryCount= 4
        yp_categories.ColumnCount= 2
        yp_categoriesParameters()
        yp_categories.DataSource = yp_categoriesData.GetResultSet()
        yp_categories.DataBind()
        FooterIndex = yp_categories.Controls.Count - 1


'End Directory Form yp_categories BeforeShow tail

'Control yp_categories Event BeforeShow. Action Custom Code @84-73254650

  If Not yp_categories.DataSource.GetEnumerator().MoveNext() Then 
     yp_categories.Visible = False
  End if 

'End Control yp_categories Event BeforeShow. Action Custom Code

'Directory yp_categories Bind tail @8-E31F8E2A
    End Sub
'End Directory yp_categories Bind tail

'Directory yp_categories Table Parameters @8-865CBC01
    Protected Sub yp_categoriesParameters()
        Try
            yp_categoriesData.Urlcategory_id= IntegerParameter.GetParam(Request.QueryString("category_id"))
        Catch
            Dim ParentControls As ControlCollection=yp_categories.Parent.Controls
            Dim RepeaterIndex As Integer=ParentControls.IndexOf(yp_categories)
            ParentControls.RemoveAt(RepeaterIndex)
            Dim ErrorMessage as Literal=New Literal()
            ErrorMessage.Text="Error in Grid yp_categories: Invalid parameter"
            ParentControls.AddAt(RepeaterIndex,ErrorMessage)
        End Try
    End Sub
'End Directory yp_categories Table Parameters

'Directory yp_categories ItemDataBound event @8-4FCA8AE4
    Protected Sub yp_categoriesItemDataBound(Sender as Object, e as CCDirectoryItemEventArgs)
        Dim DataItem as yp_categoriesItem=CType(e.Item.DataItem,yp_categoriesItem)
        If e.Item.ItemType = CCDirectoryItemType.CategoryHeader Then
            Dim yp_categoriesCategoryLink As System.Web.UI.HtmlControls.HtmlAnchor = DirectCast(e.Item.FindControl("yp_categoriesCategoryLink"),System.Web.UI.HtmlControls.HtmlAnchor)
            DataItem.CategoryLinkHref = "Directory.aspx?"
            yp_categoriesCategoryLink.HRef += DataItem.CategoryLinkHref & DataItem.CategoryLinkHrefParameters.ToString("GET","", ViewState)
        End If
        If e.Item.ItemType = CCDirectoryItemType.Subcategory Then
            Dim yp_categoriesSubcategoryLink As System.Web.UI.HtmlControls.HtmlAnchor = DirectCast(e.Item.FindControl("yp_categoriesSubcategoryLink"),System.Web.UI.HtmlControls.HtmlAnchor)
            DataItem.SubcategoryLinkHref = "Directory.aspx?"
            yp_categoriesSubcategoryLink.HRef += DataItem.SubcategoryLinkHref & DataItem.SubcategoryLinkHrefParameters.ToString("GET","", ViewState)
        End If
        If e.Item.ItemType = CCDirectoryItemType.SubcategoriesTail Then
            Dim yp_categoriesSubcategoriesTailLink As System.Web.UI.HtmlControls.HtmlAnchor = DirectCast(e.Item.FindControl("yp_categoriesSubcategoriesTailLink"),System.Web.UI.HtmlControls.HtmlAnchor)
            DataItem.SubcategoriesTailLinkHref = "Directory.aspx?"
            yp_categoriesSubcategoriesTailLink.HRef += DataItem.SubcategoriesTailLinkHref & DataItem.SubcategoriesTailLinkHrefParameters.ToString("GET","", ViewState)
        End If
'End Directory yp_categories ItemDataBound event

'Directory yp_categories ItemDataBound event tail @8-E31F8E2A
    End Sub
'End Directory yp_categories ItemDataBound event tail

'Grid yp_grid Bind @24-9738CE6C

    Protected Sub yp_gridBind()
        Dim PagesCount As Integer
        Dim FooterIndex As Integer
        If Not(IsPostBack) Then
            Dim Param As String
            Param = Request.QueryString("yp_gridOrder")
            Try
                Dim sf As yp_gridDataProvider.SortFields = 0
                ViewState("yp_gridSortField") = [Enum].Parse(sf.GetType(), Param)
            Catch
                ViewState("yp_gridSortField") = yp_gridDataProvider.SortFields._Default
            End Try

            Param = Request.QueryString("yp_gridDir")
            If IsNothing(Param) Then
                ViewState("yp_gridSortDir") = SortDirections._Desc
            Else
                If Param.Length = 0 Or Param.ToLower() = "desc" Then
                    ViewState("yp_gridSortDir") = SortDirections._Desc
                Else
                    ViewState("yp_gridSortDir") = SortDirections._Asc
                End If
            End If
            Param = Request.QueryString("yp_gridPage")
            Dim PageNumber as Integer
            Try
                PageNumber = Int32.Parse(Param)
                If PageNumber <= 0 Then PageNumber = 1
            Catch
                PageNumber = 1
            End Try
            ViewState("yp_gridPageNumber") = PageNumber
            Param = Request.QueryString("yp_gridPageSize")
            Try
                PageNumber = Int32.Parse(Param)
                If PageNumber <= 0 Then PageNumber = 20
            Catch
                PageNumber = 20
            End Try
            If PageNumber > 100 Then
                PageNumber = 100
            End If
            ViewState("yp_gridPageSize") = PageNumber
        End If
'End Grid yp_grid Bind

'Grid Form yp_grid BeforeShow tail @24-3CD4D2DF
        yp_gridParameters
        yp_gridData.SortField = CType(ViewState("yp_gridSortField"),yp_gridDataProvider.SortFields)
        yp_gridData.SortDir = CType(ViewState("yp_gridSortDir"),SortDirections)
        yp_gridData.PageNumber = CInt(ViewState("yp_gridPageNumber"))
        yp_gridData.RecordsPerPage = CInt(ViewState("yp_gridPageSize"))
        yp_gridRepeater.DataSource = yp_gridData.GetResultSet(PagesCount)
        ViewState("yp_gridPagesCount") = PagesCount
        yp_gridRepeater.DataBind
        FooterIndex = yp_gridRepeater.Controls.Count - 1
        If PagesCount = 0 Then
            yp_gridRepeater.Controls(FooterIndex).FindControl("NoRecords").Visible = True
        End If


        If yp_gridData.SortField.ToString()="Sorter_item_name" Then
            If yp_gridData.SortDir=SortDirections._Asc Then
                CType(yp_gridRepeater.Controls(0).FindControl("Sorter_item_nameSorter"),Controls.Sorter).State = SorterState.Ascending
            Else
                CType(yp_gridRepeater.Controls(0).FindControl("Sorter_item_nameSorter"),Controls.Sorter).State = SorterState.Descending
            End If
        End If
        If yp_gridData.SortField.ToString()="Sorter_address" Then
            If yp_gridData.SortDir=SortDirections._Asc Then
                CType(yp_gridRepeater.Controls(0).FindControl("Sorter_addressSorter"),Controls.Sorter).State = SorterState.Ascending
            Else
                CType(yp_gridRepeater.Controls(0).FindControl("Sorter_addressSorter"),Controls.Sorter).State = SorterState.Descending
            End If
        End If
        If yp_gridData.SortField.ToString()="Sorter_city" Then
            If yp_gridData.SortDir=SortDirections._Asc Then
                CType(yp_gridRepeater.Controls(0).FindControl("Sorter_citySorter"),Controls.Sorter).State = SorterState.Ascending
            Else
                CType(yp_gridRepeater.Controls(0).FindControl("Sorter_citySorter"),Controls.Sorter).State = SorterState.Descending
            End If
        End If
        If yp_gridData.SortField.ToString()="Sorter_phone" Then
            If yp_gridData.SortDir=SortDirections._Asc Then
                CType(yp_gridRepeater.Controls(0).FindControl("Sorter_phoneSorter"),Controls.Sorter).State = SorterState.Ascending
            Else
                CType(yp_gridRepeater.Controls(0).FindControl("Sorter_phoneSorter"),Controls.Sorter).State = SorterState.Descending
            End If
        End If
        If yp_gridData.SortField.ToString()="Sorter_zip" Then
            If yp_gridData.SortDir=SortDirections._Asc Then
                CType(yp_gridRepeater.Controls(0).FindControl("Sorter_zipSorter"),Controls.Sorter).State = SorterState.Ascending
            Else
                CType(yp_gridRepeater.Controls(0).FindControl("Sorter_zipSorter"),Controls.Sorter).State = SorterState.Descending
            End If
        End If
        If yp_gridData.SortField.ToString()="Sorter_email" Then
            If yp_gridData.SortDir=SortDirections._Asc Then
                CType(yp_gridRepeater.Controls(0).FindControl("Sorter_emailSorter"),Controls.Sorter).State = SorterState.Ascending
            Else
                CType(yp_gridRepeater.Controls(0).FindControl("Sorter_emailSorter"),Controls.Sorter).State = SorterState.Descending
            End If
        End If
        If yp_gridData.SortField.ToString()="Sorter_url" Then
            If yp_gridData.SortDir=SortDirections._Asc Then
                CType(yp_gridRepeater.Controls(0).FindControl("Sorter_urlSorter"),Controls.Sorter).State = SorterState.Ascending
            Else
                CType(yp_gridRepeater.Controls(0).FindControl("Sorter_urlSorter"),Controls.Sorter).State = SorterState.Descending
            End If
        End If
        Dim NavigatorNavigator As Controls.Navigator = CType(yp_gridRepeater.Controls(FooterIndex).FindControl("NavigatorNavigator"),Controls.Navigator)
        NavigatorNavigator.MaxPage=PagesCount
        NavigatorNavigator.PageNumber=yp_gridData.PageNumber
        NavigatorNavigator.DataBind
'End Grid Form yp_grid BeforeShow tail

'Control yp_grid Event BeforeShow. Action Custom Code @42-73254650

  If PagesCount = 0 Then
     yp_gridRepeater.Visible = False 
  End If

'End Control yp_grid Event BeforeShow. Action Custom Code

'Grid yp_grid Bind tail @24-E31F8E2A
    End Sub
'End Grid yp_grid Bind tail

'Grid yp_grid Table Parameters @24-F77635E5

    Protected Sub yp_gridParameters()
        Try
            yp_gridData.Urlcategory_id= IntegerParameter.GetParam(Request.QueryString("category_id"))

        Catch
            Dim ParentControls As ControlCollection=yp_gridRepeater.Parent.Controls
            Dim RepeaterIndex As Integer=ParentControls.IndexOf(yp_gridRepeater)
            ParentControls.RemoveAt(RepeaterIndex)
            Dim ErrorMessage as Literal=New Literal()
            ErrorMessage.Text="Error in Grid yp_grid: Invalid parameter"
            ParentControls.AddAt(RepeaterIndex,ErrorMessage)
        End Try
    End Sub
'End Grid yp_grid Table Parameters

'Grid yp_grid ItemDataBound event @24-DF08553D

    Protected Sub yp_gridItemDataBound(Sender as Object, e as RepeaterItemEventArgs)
        Dim DataItem as yp_gridItem=CType(e.Item.DataItem,yp_gridItem)
        If e.Item.ItemType = ListItemType.Item Or e.Item.ItemType = ListItemType.AlternatingItem Then
            Dim yp_gridemail As System.Web.UI.HtmlControls.HtmlAnchor = DirectCast(e.Item.FindControl("yp_gridemail"),System.Web.UI.HtmlControls.HtmlAnchor)
            yp_gridemail.HRef += DataItem.emailHref & DataItem.emailHrefParameters.ToString("None","", ViewState)
            Dim yp_gridurl As System.Web.UI.HtmlControls.HtmlAnchor = DirectCast(e.Item.FindControl("yp_gridurl"),System.Web.UI.HtmlControls.HtmlAnchor)
            yp_gridurl.HRef += DataItem.urlHref & DataItem.urlHrefParameters.ToString("None","", ViewState)
        End If
'End Grid yp_grid ItemDataBound event

'Grid yp_grid ItemDataBound event tail @24-E31F8E2A
    End Sub
'End Grid yp_grid ItemDataBound event tail

'Grid yp_grid ItemCommand event @24-F530994D

    Protected Sub yp_gridItemCommand(Sender as Object, e as RepeaterCommandEventArgs)
        Dim FooterIndex as Integer= yp_gridRepeater.Controls.Count - 1
        Dim BindAllowed as Boolean= False
        If e.CommandName = "Sort" Then
            If CType(e.CommandArgument,SorterState)=SorterState.None
                If CType(ViewState("yp_gridSortDir"),SortDirections) = SortDirections._Asc And ViewState("yp_gridSortField").ToString()=CType(e.CommandSource,Controls.Sorter).Field
                    ViewState("yp_gridSortDir")=SortDirections._Desc
                Else
                    ViewState("yp_gridSortDir")=SortDirections._Asc
                End If
            Else
                ViewState("yp_gridSortDir")=CInt(CType(e.CommandSource,Controls.Sorter).State)
            End If
            Dim sf As yp_gridDataProvider.SortFields = 0
            ViewState("yp_gridSortField")=[Enum].Parse(sf.GetType(),CType(e.CommandSource,Controls.Sorter).Field)
            ViewState("yp_gridPageNumber") = 1
            BindAllowed = True
        End If

        If e.CommandName="Navigate" Then
            ViewState("yp_gridPageNumber") = Int32.Parse(e.CommandArgument.ToString())
            BindAllowed = True
        End If
        If BindAllowed Then
            yp_gridBind
        End If
    End Sub
'End Grid yp_grid ItemCommand event

'OnInit Event @1-E5E6FAEC
    #Region " Web Form Designer Generated Code "
    Protected Overrides Sub OnInit(ByVal e As EventArgs)
        '
        ' CODEGEN: This call is required by the ASP.NET Web Form Designer.
        '
        InitializeComponent()
        'Me.Load += new System.EventHandler(this.Page_Load);
        'Me.Unload += new System.EventHandler(this.Page_Unload);
        NewPath1Data = New NewPath1DataProvider()
        yp_categoriesData = New yp_categoriesDataProvider()
        yp_gridData = New yp_gridDataProvider()
        MyBase.OnInit(e)
'End OnInit Event

'OnInit Event tail @1-E31F8E2A
    End Sub
'End OnInit Event tail

'InitializeComponent Event @1-EA5E2628
    ' <summary>
    ' Required method for Designer support - do not modify
    ' the contents of this method with the code editor.
    ' </summary>
    Private Sub InitializeComponent()
    End Sub
    #End Region
'End InitializeComponent Event

'Page class tail @1-DD082417
End Class
End Namespace
'End Page class tail

