//Using Statements @1-BE06F36E
using System;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Specialized;
using System.Data;
using CCSExample_CSharp;
using CCSExample_CSharp.Data;
using CCSExample_CSharp.Controls;
using CCSExample_CSharp.Configuration;

namespace CCSExample_CSharp.EditableGridAddButton.EditableGridAddButton
{
//End Using Statements

//Page Data Class @1-F1F2C6B1
public class PageItem
{
    public NameValueCollection errors=new NameValueCollection();
    public PageItem()
    {
    }
    public static PageItem CreateFromHttpRequest()
    {
        PageItem item = new PageItem();
        item.Link1.SetValue(DBUtility.GetInitialValue("Link1"));
        return item;
    }

    public FieldBase this[string fieldName]{
        get{
            switch(fieldName){
                case "Link1":
                    return this.Link1;
                default:
                    throw (new ArgumentOutOfRangeException());
            }
        }
        set{
            switch(fieldName){
                case "Link1":
                    this.Link1 = (TextField)value;
                    break;
                default:
                    throw (new ArgumentOutOfRangeException());
            }
        }
    }

    public TextField Link1 = new TextField("",null);
    public object Link1Href;
    public LinkParameterCollection Link1HrefParameters = new LinkParameterCollection();
}
//End Page Data Class

//Page Data Provider Class @1-50FE4D41
public class PageDataProvider
{
//End Page Data Provider Class

//Page Data Provider Class Constructor @1-9A44B219
    public PageDataProvider()
    {
    }
//End Page Data Provider Class Constructor

//Page Data Provider Class GetResultSet Method @1-052161C6
    public void FillItem(PageItem item)
    {
//End Page Data Provider Class GetResultSet Method

//Page Data Provider Class GetResultSet Method tail @1-FCB6E20C
    }
//End Page Data Provider Class GetResultSet Method tail

//Page Data Provider Tail @1-FCB6E20C
}
//End Page Data Provider Tail

//EditableGrid departments Item Class @3-F3B34089
public class departmentsItem
{
    public NameValueCollection errors=new NameValueCollection();
    public int RowId;
    public departmentsItem()
    {
    }

    public FieldBase this[string fieldName]{
        get{
            switch(fieldName){
                case "department_idField":
                    return this.department_idField;
                case "RowIDAttribute":
                    return this.RowIDAttribute;
                case "RowNameAttribute":
                    return this.RowNameAttribute;
                case "RowStyleAttribute":
                    return this.RowStyleAttribute;
                case "department_name":
                    return this.department_name;
                case "manager_id":
                    return this.manager_id;
                case "CheckBox_Delete":
                    return this.CheckBox_Delete;
                default:
                    throw (new ArgumentOutOfRangeException());
            }
        }
        set{
            switch(fieldName){
                case "department_idField":
                    this.department_idField = (IntegerField)value;
                    break;
                case "RowIDAttribute":
                    this.RowIDAttribute = (TextField)value;
                    break;
                case "RowNameAttribute":
                    this.RowNameAttribute = (TextField)value;
                    break;
                case "RowStyleAttribute":
                    this.RowStyleAttribute = (TextField)value;
                    break;
                case "department_name":
                    this.department_name = (TextField)value;
                    break;
                case "manager_id":
                    this.manager_id = (IntegerField)value;
                    break;
                case "CheckBox_Delete":
                    this.CheckBox_Delete = (BooleanField)value;
                    break;
                default:
                    throw (new ArgumentOutOfRangeException());
            }
        }
    }

    public bool IsNew{
        get{
            bool result = true;
            bool result1 = true;
            result = department_idField.Value == null && result;
            result1 = department_name.Value == null && result1;
            result1 = manager_id.Value == null && result1;
            result1 = CheckBox_Delete.Value == null && result1;
            return result && !result1;
        }
    }

    public bool IsEmptyItem{
        get{
            bool result = true;
            result = department_name.Value == null && result;
            result = manager_id.Value == null && result;
            result = CheckBox_Delete.Value == null && result;
            result = department_idField.Value == null && result;
            return result;
        }
    }

    public bool IsDeleted = false;
    public bool IsUpdated = false;
    public TextField RowIDAttribute=new TextField("", null);
    public TextField RowNameAttribute=new TextField("", null);
    public TextField RowStyleAttribute=new TextField("", null);
    public TextField department_name=new TextField("", null);
    public IntegerField manager_id = new IntegerField("", null);
    public ItemCollection manager_idItems = new ItemCollection();
    public BooleanField CheckBox_Delete=new BooleanField(Settings.BoolFormat, null);
    public BooleanField CheckBox_DeleteCheckedValue = new BooleanField(Settings.BoolFormat, true);
    public BooleanField CheckBox_DeleteUncheckedValue=new BooleanField(Settings.BoolFormat, false);

    public IntegerField department_idField=new IntegerField();
    public bool Validate(departmentsDataProvider provider)
    {
        errors.Clear();
//End EditableGrid departments Item Class

//department_name validate @7-B19DE9FD
        if(department_name.Value==null||department_name.Value.ToString()=="")
            errors.Add("department_name","The value in field  Name is required.");
//End department_name validate

//EditableGrid departments Item Class tail @3-2CA8EF5C
        return errors.Count == 0;
    }
}
//End EditableGrid departments Item Class tail

//EditableGrid departments Data Provider Class Header @3-C101F86A
public class departmentsDataProvider:EditableGridDataProviderBase
{
//End EditableGrid departments Data Provider Class Header

//Grid departments Data Provider Class Variables @3-64CCFD3B
    public enum SortFields {Default}
    private string[] SortFieldsNames=new string[]{"department_id"};
    private string[] SortFieldsNamesDesc=new string[]{"department_id"};
    public SortFields SortField=SortFields.Default;
    public SortDirections SortDir=SortDirections.Asc;
    public int RecordsPerPage=0;
    public int PageNumber=1;
    public int EmptyRows = 30;
    protected DataCommand manager_idDataCommand=new TableCommand("SELECT *  " + 
          "FROM employees",new string[]{},Settings.IntranetDBDataAccessObject);
//End Grid departments Data Provider Class Variables

//Editable Grid departments Data Provider Class Constructor @3-D26026A4
    public departmentsDataProvider()
    {
        Select=new TableCommand("SELECT *  " + 
          "FROM departments",new string[]{},Settings.IntranetDBDataAccessObject);
        Count=new TableCommand("SELECT COUNT(*)  " + 
          "FROM departments",new string[]{},Settings.IntranetDBDataAccessObject);
    }
//End Editable Grid departments Data Provider Class Constructor

//Editable Grid departments Data Provider Class CheckUnique Method @3-A73D3349
    public bool CheckUnique(string ControlName,departmentsItem item)
    {
        return true;
    }
//End Editable Grid departments Data Provider Class CheckUnique Method

//Editable Grid departments Data Provider Class InsertItem Method @3-911B2144
    protected int InsertItem(departmentsItem item)
    {
        DataCommand Insert=new TableCommand("INSERT INTO departments(department_name, department_manager_id ) VALUES ( {department_name}, {manager_id})"
        ,new string[0],Settings.IntranetDBDataAccessObject);
//End Editable Grid departments Data Provider Class InsertItem Method

//EditableGrid departments Build insert @3-76A5C8C9
        Insert.SqlQuery.Replace("{department_name}",Insert.Dao.ToSql(item.department_name.GetFormattedValue(""),FieldType.Text));
        Insert.SqlQuery.Replace("{manager_id}",Insert.Dao.ToSql(item.manager_id.GetFormattedValue(""),FieldType.Integer));
//End EditableGrid departments Build insert

//EditableGrid departments Data Provider Class ExecuteInsert @3-69BE52CC
        object result=null;
        try{
            result = Insert.ExecuteNonQuery();
        }catch(Exception e){
            item.errors.Add("DataProvider",e.Source + ":" + e.Message);
            result = 0;}
        finally{
//End EditableGrid departments Data Provider Class ExecuteInsert

//EditableGrid departments AfterExecuteInsert @3-16B7139B
        }
        return (int)result;
    }
//End EditableGrid departments AfterExecuteInsert

//EditableGrid departments Data Provider Class Update Method @3-00CC4483
    protected int UpdateItem(departmentsItem item)
    {
        DataCommand Update=new TableCommand("UPDATE departments SET department_name={department_name}, department_manager_id={manager_id}"
        ,new string[]{"department_id4"},Settings.IntranetDBDataAccessObject);
//End EditableGrid departments Data Provider Class Update Method

//EditableGrid departments BeforeBuildUpdate @3-4A4BD8A1
        Update.SqlQuery.Replace("{department_name}",Update.Dao.ToSql(item.department_name.GetFormattedValue(""),FieldType.Text));
        Update.SqlQuery.Replace("{manager_id}",Update.Dao.ToSql(item.manager_id.GetFormattedValue(""),FieldType.Integer));
        Update.Parameters.Add("department_id4","department_id = " + Update.Dao.ToSql(item.department_idField.GetFormattedValue(""),FieldType.Integer));
//End EditableGrid departments BeforeBuildUpdate

//EditableGrid departments Execute Update  @3-74A302F6
        object result=null;
        try{
            result=Update.ExecuteNonQuery();
        }catch(Exception e){
            item.errors.Add("DataProvider",e.Source + ":" + e.Message);
            result = 0;}
        finally{
//End EditableGrid departments Execute Update 

//EditableGrid departments AfterExecuteUpdate @3-16B7139B
        }
        return (int)result;
    }
//End EditableGrid departments AfterExecuteUpdate

//EditableGrid departments Data Provider Class Delete Method @3-695BB2EE
    public int DeleteItem(departmentsItem item)
    {
        DataCommand Delete=new TableCommand("DELETE FROM departments",new string[]{"department_id4"},Settings.IntranetDBDataAccessObject);
//End EditableGrid departments Data Provider Class Delete Method

//EditableGrid departments BeforeBuildDelete @3-6F7B436F
        Delete.Parameters.Add("department_id4","department_id = " + Select.Dao.ToSql(item.department_idField.GetFormattedValue(""),FieldType.Integer));
//End EditableGrid departments BeforeBuildDelete

//Record departments Event BeforeExecuteDelete. Action Custom Code @20-2A29BDB7

  //Get the where parameters
  string DepartmentID = "department_id = " + Select.Dao.ToSql(item.department_idField.GetFormattedValue(""),FieldType.Integer);
  DataAccessObject NewDao = Settings.IntranetDBDataAccessObject;
  //Delete project employees links
  NewDao.ExecuteNonQuery("UPDATE employees SET department_id = NULL WHERE " + DepartmentID);
  


//End Record departments Event BeforeExecuteDelete. Action Custom Code

//EditableGrid departments Data Provider Class Execute Delete @3-7FECB576
        object result=null;
        try{
            result = Delete.ExecuteNonQuery();
        }catch(Exception e){
            item.errors.Add("DataProvider",e.Source + ":" + e.Message);
            result = 0;}
        finally{
//End EditableGrid departments Data Provider Class Execute Delete

//EditableGrid departments AfterExecuteDelete @3-16B7139B
        }
        return (int)result;
    }
//End EditableGrid departments AfterExecuteDelete

//Grid departments Data Provider Class Update Method @3-3BCE8754
    public void Update(ArrayList Items)
    {
        Update(Items, 0);
    }

    public void Update(ArrayList Items, int userGroup)
    {
        bool AllowInsert=true;
        bool AllowUpdate=true;
        bool AllowDelete=true;
        for(int i = 0; i < Items.Count; i++)
        {
            EditableGridOperation op = EditableGridOperation.Insert;
            bool isProcessed = false;
            departmentsItem item = (departmentsItem)Items[i];
            if(item.IsUpdated) continue;
            if(item.IsDeleted && AllowDelete){
                DeleteItem(item);
                op = EditableGridOperation.Delete;
                isProcessed = true;}
            if(item.IsNew && AllowInsert && !isProcessed){
                InsertItem(item);
                op = EditableGridOperation.Insert;
                isProcessed = true;}
            if(!item.IsEmptyItem && AllowUpdate && !isProcessed){
                UpdateItem(item);
                op = EditableGridOperation.Update;}
            if(item.errors.Count == 0) item.IsUpdated = true;
            OnItemUpdated(new ItemUpdatedEventArgs(op, item));
        }
    }
//End Grid departments Data Provider Class Update Method

//Grid departments Data Provider Class GetResultSet Method @3-29FD717B
    public departmentsItem[] GetResultSet(out int PagesCount)
    {
//End Grid departments Data Provider Class GetResultSet Method

//Before build Select @3-DF95E8F6
        Exception E=null;
        Parameters.Clear();
        Select.OrderBy=(SortDir==SortDirections.Asc?SortFieldsNames[(int)SortField]:SortFieldsNamesDesc[(int)SortField]).Trim();
//End Before build Select

//Execute Select @3-E25CF8FC
        DataSet ds=null;
        PagesCount=0;
        try{
            if(RecordsPerPage>0)
            {
                ds=ExecuteSelect((PageNumber-1)*RecordsPerPage,RecordsPerPage);
                PagesCount = ExecuteCount();
                mRecordCount = PagesCount;
                PagesCount = PagesCount%RecordsPerPage>0?(int)(PagesCount/RecordsPerPage)+1:(int)(PagesCount/RecordsPerPage);
            }
            else
            {
            ds=ExecuteSelect();
            if(ds.Tables[0].Rows.Count!=0)PagesCount=1;
            }
        }catch(Exception e){
            E=e;}
        finally{
//End Execute Select

//After execute Select @3-905E3430
        if(E!=null) throw(E);
        }
        DataRowCollection dr=ds.Tables[0].Rows;
        departmentsItem[] result=new departmentsItem[dr.Count + EmptyRows];
        DataRowCollection ListBoxSource=null;
//End After execute Select

//ListBox manager_id BeforeExecuteSelect @8-372D5DF5
    try{
        ListBoxSource=manager_idDataCommand.Execute().Tables[0].Rows;
    }catch(Exception e){
        E=e;}
    finally{
//End ListBox manager_id BeforeExecuteSelect

//ListBox manager_id AfterExecuteSelect @8-FB70E6A8
        if(E!=null) throw(E);
    }
    ItemCollection manager_idItems=new ItemCollection();
    for(int i=0;i<ListBoxSource.Count;i++){
        object val = ListBoxSource[i]["emp_name"];
        string key = (new IntegerField("", ListBoxSource[i]["emp_id"])).GetFormattedValue("");
        manager_idItems.Add(key,val);
    }
//End ListBox manager_id AfterExecuteSelect

//After execute Select tail @3-DBF61FD8
        for(int i=0;i<dr.Count;i++)
        {
            departmentsItem item=new departmentsItem();
            item.department_name.SetValue(dr[i]["department_name"],"");
            item.manager_id.SetValue(dr[i]["department_manager_id"],"");
            item.manager_idItems = (ItemCollection)manager_idItems.Clone();
            item.department_idField.SetValue(dr[i]["department_id"],"");
            result[i]=item;
        }
        for(int i = dr.Count; i < dr.Count + EmptyRows; i++){
            departmentsItem item=new departmentsItem();
            item.manager_idItems = (ItemCollection)manager_idItems.Clone();
            result[i] = item;}
        return result; 
    }
//End After execute Select tail

//Grid Data Provider tail @3-FCB6E20C
}
//End Grid Data Provider tail

//Page Data Provider Tail @1-FCB6E20C
}
//End Page Data Provider Tail

