'Using Statements @1-5BD81A45
Imports System
Imports System.Collections
Imports System.Collections.Specialized
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Web
Imports System.Web.SessionState
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports System.Web.UI.HtmlControls
Imports System.Text.RegularExpressions
Imports System.Globalization
Imports ExamplePack_VB
Imports ExamplePack_VB.Data
Imports ExamplePack_VB.Configuration
Imports ExamplePack_VB.Controls
Namespace EditableGridAutoRows.EditableGridAutoRows
'End Using Statements

'Forms Definition @1-389903F5
Public Class [EditableGridAutoRowsPage]
Inherits System.Web.UI.Page
'End Forms Definition

'Forms Objects @1-AD2C10BB
    Protected departmentsRepeater As System.Web.UI.WebControls.Repeater
    Protected departmentsData As departmentsDataProvider
    Protected departmentsErrors As New NameValueCollection()
    Protected Link1 As System.Web.UI.HtmlControls.HtmlAnchor
'End Forms Objects
	Private DepartsEmtyRowId As String
	Private isFirstEmptyRow As Boolean = True
'Page_Load Event @1-A2D2CF1E

Protected Overrides Sub OnLoad(ByVal e As System.EventArgs)
'End Page_Load Event

'Page_Load Event BeforeIsPostBack @1-317ACF6F
    If Not IsPostBack Then
            Dim PageData As PageDataProvider = New PageDataProvider()
            Dim item As PageItem = PageItem.CreateFromHttpRequest()
            item.Link1Href = "EditableGridAutoRows_desc.aspx"
            PageData.FillItem(item)
            Link1.InnerText += item.Link1.GetFormattedValue().Replace(vbCrLf,"")
            Link1.HRef += item.Link1Href & item.Link1HrefParameters.ToString("None","", ViewState)
            departmentsBind()
    End If
'End Page_Load Event BeforeIsPostBack

'Page_Load Event tail @1-E31F8E2A
End Sub
'End Page_Load Event tail

'Page_Unload Event @1-D998A98F

Protected Overrides Sub OnUnload(ByVal e As System.EventArgs)
'End Page_Unload Event

'Page_Unload Event tail @1-E31F8E2A
End Sub
'End Page_Unload Event tail

'EditableGrid departments Bind @3-13F91289
    Protected Sub departmentsBind()
        Dim PagesCount As Integer
        Dim FooterIndex As Integer
        If Not(IsPostBack) Then
            Dim Param As String
            Param = Request.QueryString("departmentsOrder")
            Try
                Dim sf As departmentsDataProvider.SortFields = 0
                ViewState("departmentsSortField") = [Enum].Parse(sf.GetType(), Param)
            Catch
                ViewState("departmentsSortField") = departmentsDataProvider.SortFields._Default
            End Try

            Param = Request.QueryString("departmentsDir")
            If IsNothing(Param) Then
                ViewState("departmentsSortDir") = SortDirections._Desc
            Else
                If Param.Length = 0 Or Param.ToLower() = "desc" Then
                    ViewState("departmentsSortDir") = SortDirections._Desc
                Else
                    ViewState("departmentsSortDir") = SortDirections._Asc
                End If
            End If
            Param = Request.QueryString("departmentsPage")
            Dim PageNumber as Integer
            Try
                PageNumber = Int32.Parse(Param)
                If PageNumber <= 0 Then PageNumber = 1
            Catch
                PageNumber = 1
            End Try
            ViewState("departmentsPageNumber") = PageNumber
            Param = Request.QueryString("departmentsPageSize")
            Try
                PageNumber = Int32.Parse(Param)
                If PageNumber <= 0 Then PageNumber = 0
            Catch
                PageNumber = 0
            End Try
            If PageNumber > 100 Then
                PageNumber = 100
            End If
            ViewState("departmentsPageSize") = PageNumber
        End If
'End EditableGrid departments Bind

'Grid Form departments BeforeShow tail @3-55C71B90
        departmentsParameters()
        departmentsData.SortField = CType(ViewState("departmentsSortField"), departmentsDataProvider.SortFields)
        departmentsData.SortDir = CType(ViewState("departmentsSortDir"), SortDirections)
        departmentsData.PageNumber = CType(ViewState("departmentsPageNumber"), Integer)
        departmentsData.RecordsPerPage = CType(ViewState("departmentsPageSize"), Integer)
        departmentsRepeater.DataSource = departmentsData.GetResultSet(PagesCount)
        ViewState("departmentsPagesCount") = PagesCount
        ViewState("departmentsFormState") = New Hashtable()
        departmentsRepeater.DataBind()
        FooterIndex = departmentsRepeater.Controls.Count - 1
        Dim item As departmentsItem = New departmentsItem()


        If PagesCount = 0 Then
            departmentsRepeater.Controls(FooterIndex).FindControl("NoRecords").Visible = True
        End If
        If departmentsErrors.Count > 0 Then
            Dim ErrorLabel As System.Web.UI.WebControls.Label = DirectCast(departmentsRepeater.Controls(0).FindControl("ErrorLabel"),System.Web.UI.WebControls.Label)
            Dim RowError As PlaceHolder = DirectCast(departmentsRepeater.Controls(0).FindControl("departmentsError"), System.Web.UI.WebControls.PlaceHolder)
            RowError.Visible = True
            Dim msg As String
            For Each msg In departmentsErrors
                ErrorLabel.Text += departmentsErrors(msg) + "<br/>"
            Next
        End If
'End Grid Form departments BeforeShow tail

'Control departments Event BeforeShow. Action Custom Code @24-73254650
	ViewState("DepsRowIDs") = DepartsEmtyRowId.TrimEnd(New [Char]() {","c}) 
	RegisterArrayDeclaration("DepsRowIDs", DepartsEmtyRowId.TrimEnd(New [Char]() {","c}))
'End Control departments Event BeforeShow. Action Custom Code

'EditableGrid departments Bind tail @3-ED08C813
        departmentsShowErrors(New ArrayList(CType(departmentsRepeater.DataSource, ICollection)), departmentsRepeater.Items)
    End Sub
'End EditableGrid departments Bind tail

'EditableGrid departments Table Parameters @3-CF7B549E
    Protected Sub departmentsParameters()
        Try
        Catch
            Dim ParentControls As ControlCollection = departmentsRepeater.Parent.Controls
            Dim RepeaterIndex As Integer = ParentControls.IndexOf(departmentsRepeater)
            ParentControls.RemoveAt(RepeaterIndex)
            Dim ErrorMessage As Literal = New Literal()
            ErrorMessage.Text = "Error in Grid departments: Invalid parameter"
            ParentControls.AddAt(RepeaterIndex,ErrorMessage)
        End Try
	End Sub
	
'End EditableGrid departments Table Parameters

'EditableGrid departments ItemDataBound event @3-270179C1
    Protected Sub departmentsItemDataBound(ByVal Sender As Object, ByVal e As RepeaterItemEventArgs)
        Dim DataItem As departmentsItem = DirectCast(e.Item.DataItem, departmentsItem)
        If e.Item.ItemType = ListItemType.Item Or e.Item.ItemType = ListItemType.AlternatingItem Then
            DataItem.RowId = e.Item.ItemIndex
            Dim formState As Hashtable = DirectCast(ViewState("departmentsFormState"), Hashtable)
            formState.Add("department_idField:" & e.Item.ItemIndex, DataItem.department_idField.Value)
            Dim departmentsmanager_id As System.Web.UI.HtmlControls.HtmlSelect = DirectCast(e.Item.FindControl("departmentsmanager_id"),System.Web.UI.HtmlControls.HtmlSelect)
            DataItem.manager_idItems.SetSelection(DataItem.manager_id.Value)
            departmentsmanager_id.SelectedIndex = -1
            DataItem.manager_idItems.CopyTo(departmentsmanager_id.Items)
            Dim departmentsCheckBox_Delete As System.Web.UI.WebControls.CheckBox = DirectCast(e.Item.FindControl("departmentsCheckBox_Delete"),System.Web.UI.WebControls.CheckBox)
            If DataItem.CheckBox_DeleteCheckedValue.Value.Equals(DataItem.CheckBox_Delete.Value) Then
                departmentsCheckBox_Delete.Checked = True
            End If
        End If
'End EditableGrid departments ItemDataBound event

'EditableGrid departments Event BeforeShowRow. Action Custom Code @17-73254650
	If e.Item.ItemType = ListItemType.Item Or e.Item.ItemType = ListItemType.AlternatingItem Then
	   If DataItem.IsEmptyItem And isFirstEmptyRow Then
	      CType(e.Item.FindControl("departmentsdepartment_name"), WebControl).Attributes.Add("onchange", "ShowNewEmptyRow(this);")
	   End If
	   If DataItem.IsEmptyItem And Not isFirstEmptyRow Then
	      DepartsEmtyRowId += e.Item.FindControl("MyRow").ClientID + ","
	      CType(e.Item.FindControl("MyRow"), HtmlControl).Attributes.Add("style", "display:none")
	      CType(e.Item.FindControl("departmentsdepartment_name"), WebControl).Attributes.Add("onchange", "ShowNewEmptyRow(this);")
	   End If
	   isFirstEmptyRow = Not DataItem.IsEmptyItem And isFirstEmptyRow
	End If
'End EditableGrid departments Event BeforeShowRow. Action Custom Code

'EditableGrid departments ItemDataBound event tail @3-E31F8E2A
    End Sub
'End EditableGrid departments ItemDataBound event tail

'EditableGrid departments GetRedirectUrl method @3-85C4E92A
    Protected Function GetdepartmentsRedirectUrl(ByVal redirectString As String, ByVal removeList As String) As String
        Dim Params As String = ""
        Dim List As String()

        If removeList = "" Then
            List = New String() {""}
        Else
            List = removeList.Split(New Char() {";"})
        End If

        If redirectString = "" Then redirectString = Request.Url.AbsolutePath
        Dim i As Integer
        For i = 0 To Request.QueryString.Count - 1
            If Array.IndexOf(List,Request.QueryString.AllKeys(i)) < 0 Then
                Params &= Request.QueryString.AllKeys(i) & "=" & Server.UrlEncode(Request.QueryString(i)) & "&"
            End If
        Next i
        Params = Params.TrimEnd(New Char(){"&"})
        Return redirectString & "?" & Params
    End Function
    Protected Function GetdepartmentsRedirectUrl(ByVal redirectString As String) As String
        Return GetdepartmentsRedirectUrl(redirectString ,"")
    End Function
'End EditableGrid departments GetRedirectUrl method

'EditableGrid departments ShowErrors method @3-D06FEB21
    Protected Function departmentsShowErrors(ByVal items As ArrayList, ByVal col As RepeaterItemCollection) As Boolean
        Dim result As Boolean = True
        Dim i As Integer
        For i=0 To items.Count - 1
            If CType(items(i), departmentsItem).IsUpdated Then col(CType(items(i), departmentsItem).RowId).Visible = False
            If (CType(items(i), departmentsItem).errors.Count > 0) Then
                result = False
                Dim DefaultMessage As String = ""
                Dim j As Integer
                For j = 0 To CType(items(i), departmentsItem).errors.Count - 1
                Select CType(items(i), departmentsItem).errors.AllKeys(j)
                    Case Else
                        DefaultMessage &= CType(items(i), departmentsItem).errors(j) & "<br>"
                End Select
                Next j
                Dim Err As System.Web.UI.WebControls.Label = CType(col(CType(items(i), departmentsItem).RowId).FindControl("ErrorLabel"), System.Web.UI.WebControls.Label)
                col(CType(items(i), departmentsItem).RowId).FindControl("RowError").Visible = True
                Err.Text = DefaultMessage
            End If
        Next i
        Return result
    End Function
'End EditableGrid departments ShowErrors method

'EditableGrid departments ItemCommand event @3-AE7DD06E
    Protected Sub departmentsItemCommand(ByVal Sender As Object, ByVal e As RepeaterCommandEventArgs)
        Dim FooterIndex  As Integer = departmentsRepeater.Controls.Count - 1
        Dim BindAllowed As Boolean = False
        If e.CommandName= "Sort" Then
            If(CType(e.CommandArgument, SorterState) = SorterState.None) Then
                If(CType(ViewState("departmentsSortDir"), SortDirections) = SortDirections._Asc And ViewState("departmentsSortField").ToString() = CType(e.CommandSource, Controls.Sorter).Field) Then
                    ViewState("departmentsSortDir") = SortDirections._Desc
                Else
                    ViewState("departmentsSortDir") = SortDirections._Asc
                End If
            Else
                ViewState("departmentsSortDir") = CType((CType(e.CommandSource, Controls.Sorter).State), Integer)
            End If
            Dim sf As departmentsDataProvider.SortFields = 0
            ViewState("departmentsSortField") = [Enum].Parse(SF.GetType(),CType(e.CommandSource, Controls.Sorter).Field)
            ViewState("departmentsPageNumber") = 1
            BindAllowed = True
        End If

        If e.CommandName = "Navigate" Then
            ViewState("departmentsPageNumber") = Int32.Parse(e.CommandArgument.ToString())
            BindAllowed = True
        End If

        If (e.CommandName = "Submit") Then
            BindAllowed = True
            Dim col As RepeaterItemCollection = departmentsRepeater.Items
            Dim items As ArrayList = New ArrayList()
            Dim RedirectUrl As String = GetdepartmentsRedirectUrl("")
            Dim formState As Hashtable = DirectCast(ViewState("departmentsFormState"), Hashtable)
            Dim i As Integer
            For i = 0 To col.Count - 1
                If(col(i).ItemType = ListItemType.Item Or col(i).ItemType = ListItemType.AlternatingItem) Then
                    Dim departmentsRowIDAttribute As System.Web.UI.WebControls.Literal = DirectCast(col(i).FindControl("departmentsRowIDAttribute"),System.Web.UI.WebControls.Literal)
                    Dim departmentsRowNameAttribute As System.Web.UI.WebControls.Literal = DirectCast(col(i).FindControl("departmentsRowNameAttribute"),System.Web.UI.WebControls.Literal)
                    Dim departmentsRowStyleAttribute As System.Web.UI.WebControls.Literal = DirectCast(col(i).FindControl("departmentsRowStyleAttribute"),System.Web.UI.WebControls.Literal)
                    Dim departmentsAddedRow As System.Web.UI.WebControls.Literal = DirectCast(col(i).FindControl("departmentsAddedRow"),System.Web.UI.WebControls.Literal)
                    Dim departmentsdepartment_name As System.Web.UI.WebControls.TextBox = DirectCast(col(i).FindControl("departmentsdepartment_name"),System.Web.UI.WebControls.TextBox)
                    Dim departmentsmanager_id As System.Web.UI.HtmlControls.HtmlSelect = DirectCast(col(i).FindControl("departmentsmanager_id"),System.Web.UI.HtmlControls.HtmlSelect)
                    Dim departmentsCheckBox_Delete As System.Web.UI.WebControls.CheckBox = DirectCast(col(i).FindControl("departmentsCheckBox_Delete"),System.Web.UI.WebControls.CheckBox)
                    col(i).FindControl("RowError").Visible = False
                    Dim item As departmentsItem = New departmentsItem()
                    item.RowId = col(i).ItemIndex
                    item.IsUpdated = Not(col(i).Visible)
                    item.department_idField.Value = formState("department_idField:" & col(i).ItemIndex)
                    item.IsDeleted = (CType(col(i).FindControl("departmentsCheckBox_Delete"), System.Web.UI.WebControls.CheckBox)).Checked
                    item.RowIDAttribute.SetValue(departmentsRowIDAttribute.Text)
                    item.RowNameAttribute.SetValue(departmentsRowNameAttribute.Text)
                    item.RowStyleAttribute.SetValue(departmentsRowStyleAttribute.Text)
                    item.AddedRow.SetValue(departmentsAddedRow.Text)
                    item.department_name.SetValue(departmentsdepartment_name.Text)
                    Try
                    item.manager_id.SetValue(departmentsmanager_id.Value)
                    Catch ex As ArgumentException
                        item.errors.Add("manager_id","The value in field Manager is not valid.")
                    End Try
                    items.Add(item)

                    If Not item.IsEmptyItem And Not item.IsDeleted Then BindAllowed = item.Validate(departmentsData) And BindAllowed
                End If
            Next i
'End EditableGrid departments ItemCommand event

'EditableGrid departments Event BeforeSubmit. Action Custom Code @25-73254650
Dim itm As departmentsItem
For Each itm In  items
   If Not itm.IsEmptyItem Or isFirstEmptyRow Then
      CType(col(itm.RowId).FindControl("MyRow"), HtmlControl).Attributes.Remove("style")
   End If
   If Not itm.IsEmptyItem Then
      CType(col(itm.RowId).FindControl("departmentsdepartment_name"), WebControl).Attributes.Remove("onchange")
   End If
   
   isFirstEmptyRow = Not itm.IsEmptyItem And isFirstEmptyRow
   RegisterArrayDeclaration("DepsRowIDs", ViewState("DepsRowIDs")) 
Next itm
'End EditableGrid departments Event BeforeSubmit. Action Custom Code

'EditableGrid departments Update @3-F9794C82
            If BindAllowed Then
                Try
                    departmentsData.Update(items)
                    If departmentsShowErrors(items, col) Then
                        Response.Redirect(RedirectUrl)
                    Else
                        BindAllowed = False
                    End If
                Catch ex As Exception
                    Dim Error_ As System.Web.UI.WebControls.Label = CType(col(0).FindControl("ErrorLabel"), System.Web.UI.WebControls.Label)
                    Dim RowError As PlaceHolder = Ctype(col(0).FindControl("departmentsError"), System.Web.UI.WebControls.PlaceHolder)
                    RowError.Visible = True
                    Error_.Text = "DataProvider:" & ex.Message
                    BindAllowed = False
'End EditableGrid departments Update

'EditableGrid departments After Update @3-80ABDE8A
                End Try
            Else
                departmentsShowErrors(items, col)
            End If
            End If
            If BindAllowed Then
                departmentsBind()
            End If
        End Sub
'End EditableGrid departments After Update

'OnInit Event @1-A1757AF5
    #Region " Web Form Designer Generated Code "
    Protected Overrides Sub OnInit(ByVal e As EventArgs)
        '
        ' CODEGEN: This call is required by the ASP.NET Web Form Designer.
        '
        InitializeComponent()
        'Me.Load += new System.EventHandler(this.Page_Load);
        'Me.Unload += new System.EventHandler(this.Page_Unload);
        departmentsData = New departmentsDataProvider()
        MyBase.OnInit(e)
'End OnInit Event

'OnInit Event tail @1-E31F8E2A
    End Sub
'End OnInit Event tail

'InitializeComponent Event @1-EA5E2628
    ' <summary>
    ' Required method for Designer support - do not modify
    ' the contents of this method with the code editor.
    ' </summary>
    Private Sub InitializeComponent()
    End Sub
    #End Region
'End InitializeComponent Event

'Page class tail @1-DD082417
End Class
End Namespace
'End Page class tail

