<%
'BindEvents Method @1-C69EF4C2
Sub BindEvents()
    Set departments.CCSEvents("BeforeShowRow") = GetRef("departments_BeforeShowRow")
    Set departments.DataSource.CCSEvents("BeforeExecuteDelete") = GetRef("departments_DataSource_BeforeExecuteDelete")
End Sub
'End BindEvents Method

'Declare/define the page-specific variables
Dim RowNumber
Dim FirstEmptyRow

Function departments_BeforeShowRow() 'departments_BeforeShowRow @3-6AEB8C03
'Custom Code @17-73254650
'Increase the row number and set it within the HTML
  RowNumber = RowNumber + 1
  departments.RowIDAttribute.Value = RowNumber

'Configure the row's properties based on it's state (empty or filled)
  departments.AddedRow.Value = "false"
  If Not departments.Recordset.Eof AND (RowNumber-1) < departments.PageSize Then
     departments.RowNameAttribute.Value = "FillRow"
  Else 
     departments.RowNameAttribute.Value = "EmptyRow"
     departments.RowStyleAttribute.Value = "style=""display:none;"""
     departments.AddedRow.Value = "true"
     If NOT FirstEmptyRow Then
        departments.RowStyleAttribute.Value = ""
		FirstEmptyRow = True
	 End If
     If departments.IsFormSubmitted Then
	    If Len(departments.ErrorMessages(RowNumber)) > 0 Then
           departments.RowStyleAttribute.Value = ""
        End if 
	 End If
  End If

'End Custom Code
End Function 'Close departments_BeforeShowRow @3-54C34B28

Function departments_DataSource_BeforeExecuteDelete() 'departments_DataSource_BeforeExecuteDelete @3-1FE690AD

'Custom Code @23-73254650
Dim NewConn
Dim DepartmentID

  'Create a new database connection object
  Set NewConn = New clsDBIntranetDB
  NewConn.Open
  
  'Get the where parameters
  DepartmentID = departments.DataSource.Where
  If Len (DepartmentID) > 0 Then
    'Delete project employees links
     NewConn.Execute("UPDATE employees SET department_id = NULL WHERE " & DepartmentID)
  End If 

  'Close and destroy the database connection object
  NewConn.Close
  Set NewConn = Nothing

'End Custom Code

End Function 'Close departments_DataSource_BeforeExecuteDelete @3-54C34B28


%>