<%
'Include Common Files @1-AED2A97A
%>
<!-- #INCLUDE FILE="..\Common.asp"-->
<!-- #INCLUDE FILE="..\Cache.asp" -->
<!-- #INCLUDE FILE="..\Template.asp" -->
<!-- #INCLUDE FILE="..\Sorter.asp" -->
<!-- #INCLUDE FILE="..\Navigator.asp" -->
<%
'End Include Common Files

'Initialize Page @1-5FACAA23
' Variables
Dim PathToRoot, ScriptPath
Dim FileName
Dim Redirect
Dim Tpl, HTMLTemplate
Dim TemplateFileName
Dim ComponentName
Dim PathToCurrentPage

' Events
Dim CCSEvents
Dim CCSEventResult

' Connections
Dim DBInternetDB

' Page controls
Dim Header
Dim Link1
Dim usersgrid
Dim users

Redirect = ""
TemplateFileName = "InputMask.html"
Set CCSEvents = CreateObject("Scripting.Dictionary")
PathToCurrentPage = "./InputMask/"
FileName = "InputMask.asp"
PathToRoot = "../"
ScriptPath = Left(Request.ServerVariables("PATH_TRANSLATED"), Len(Request.ServerVariables("PATH_TRANSLATED")) - Len(FileName))
'End Initialize Page

'Initialize Objects @1-98C418E4
Set DBInternetDB = New clsDBInternetDB
DBInternetDB.Open

' Controls
Set Header = New clsHeader
Header.BindEvents
Header.TemplatePath = "../"
Header.Initialize
Set Link1 = CCCreateControl(ccsLink, "Link1", "Link1", ccsText, Empty, CCGetRequestParam("Link1", ccsGet))
Set usersgrid = New clsGridusersgrid
Set users = new clsRecordusers

Link1.Link = ""
Link1.Page = "InputMask_desc.asp"
usersgrid.Initialize DBInternetDB
users.Initialize DBInternetDB

' Events
%>
<!-- #INCLUDE FILE="InputMask_events.asp" -->
<%
BindEvents

CCSEventResult = CCRaiseEvent(CCSEvents, "AfterInitialize", Nothing)
'End Initialize Objects

'Execute Components @1-2D8B9D12
Header.Operations
users.Operation
'End Execute Components

'Go to destination page @1-6D35F4FD
If NOT ( Redirect = "" ) Then
    UnloadPage
    Response.Redirect Redirect
End If
'End Go to destination page

'Initialize HTML Template @1-0155E1BE
CCSEventResult = CCRaiseEvent(CCSEvents, "OnInitializeView", Nothing)
Set HTMLTemplate = new clsTemplate
Set HTMLTemplate.Cache = TemplatesRepository
HTMLTemplate.LoadTemplate ScriptPath & TemplateFileName
Set Tpl = HTMLTemplate.Block("main")
CCSEventResult = CCRaiseEvent(CCSEvents, "BeforeShow", Nothing)
'End Initialize HTML Template

'Show Page @1-815F011C
Header.Show Tpl, "Header"
Link1.Show Tpl
usersgrid.Show Tpl
users.Show Tpl
HTMLTemplate.PParse "main", False
'End Show Page

'Unload Page @1-CB210C62
UnloadPage
Set Tpl = Nothing
Set HTMLTemplate = Nothing
'End Unload Page

'UnloadPage Sub @1-3593086E
Sub UnloadPage()
    CCSEventResult = CCRaiseEvent(CCSEvents, "BeforeUnload", Nothing)
    If DBInternetDB.State = adStateOpen Then _
        DBInternetDB.Close
    Set DBInternetDB = Nothing
    Set Header = Nothing
    Set usersgrid = Nothing
    Set users = Nothing
End Sub
'End UnloadPage Sub

'Include Page Implementation @2-16DAF624
%>
<!-- #INCLUDE FILE="../Header.asp" -->
<%
'End Include Page Implementation

Class clsGridusersgrid 'usersgrid Class @31-56A88540

'usersgrid Variables @31-C9D9A293

    ' Public variables
    Public ComponentName, CCSEvents
    Public Visible, Errors
    Public DataSource, PageSize
    Public PageNumber
    Public Command
    Public TemplateBlock
    Public ActiveSorter, SortingDirection
    Public Recordset

    Private CCSEventResult

    ' Grid Controls
    Public StaticControls, RowControls
    Dim Sorter_first_name
    Dim Sorter_last_name
    Dim Sort_Email
    Dim Sorter_phone_home
    Dim Sort_SSN
    Dim first_name
    Dim last_name
    Dim email
    Dim phone_work
    Dim user_SSN
    Dim Link1
    Dim Navigator
'End usersgrid Variables

'usersgrid Class_Initialize Event @31-22807BF2
    Private Sub Class_Initialize()
        ComponentName = "usersgrid"
        Visible = True
        Set CCSEvents = CreateObject("Scripting.Dictionary")
        Set Errors = New clsErrors
        Set DataSource = New clsusersgridDataSource
        Set Command = New clsCommand
        PageSize = CCGetParam(ComponentName & "PageSize", Empty)
        If IsNumeric(PageSize) And Len(PageSize) > 0 Then
            If PageSize=0 Then Errors.AddError("(CCS06) Invalid page size.")
        End If
        If NOT IsNumeric(PageSize) OR IsEmpty(PageSize) Then _
            PageSize = 10 _
        Else _
            PageSize = CInt(PageSize)
        PageNumber = CInt(CCGetParam(ComponentName & "Page", 1))
        ActiveSorter = CCGetParam("usersgridOrder", Empty)
        SortingDirection = CCGetParam("usersgridDir", Empty)
        If NOT(SortingDirection = "ASC" OR SortingDirection = "DESC") Then _
            SortingDirection = Empty

        Set first_name = CCCreateControl(ccsLink, "first_name", "first_name", ccsText, Empty, CCGetRequestParam("first_name", ccsGet))
        Set last_name = CCCreateControl(ccsLabel, "last_name", "last_name", ccsText, Empty, CCGetRequestParam("last_name", ccsGet))
        Set email = CCCreateControl(ccsLabel, "email", "email", ccsText, Empty, CCGetRequestParam("email", ccsGet))
        Set phone_work = CCCreateControl(ccsLabel, "phone_work", "phone_work", ccsText, Empty, CCGetRequestParam("phone_work", ccsGet))
        Set user_SSN = CCCreateControl(ccsLabel, "user_SSN", "user_SSN", ccsText, Empty, CCGetRequestParam("user_SSN", ccsGet))
        Set Sorter_first_name = CCCreateSorter("Sorter_first_name", Me, FileName)
        Set Sorter_last_name = CCCreateSorter("Sorter_last_name", Me, FileName)
        Set Sort_Email = CCCreateSorter("Sort_Email", Me, FileName)
        Set Sorter_phone_home = CCCreateSorter("Sorter_phone_home", Me, FileName)
        Set Sort_SSN = CCCreateSorter("Sort_SSN", Me, FileName)
        Set Link1 = CCCreateControl(ccsLink, "Link1", "Link1", ccsText, Empty, CCGetRequestParam("Link1", ccsGet))
        Set Navigator = CCCreateNavigator(ComponentName, "Navigator", FileName, 10, tpCentered)
    End Sub
'End usersgrid Class_Initialize Event

'usersgrid Initialize Method @31-2AEA3975
    Sub Initialize(objConnection)
        If NOT Visible Then Exit Sub

        Set DataSource.Connection = objConnection
        DataSource.PageSize = PageSize
        DataSource.SetOrder ActiveSorter, SortingDirection
        DataSource.AbsolutePage = PageNumber
    End Sub
'End usersgrid Initialize Method

'usersgrid Class_Terminate Event @31-E1528F98
    Private Sub Class_Terminate()
        Set DataSource = Nothing
        Set Command = Nothing
        Set Errors = Nothing
    End Sub
'End usersgrid Class_Terminate Event

'usersgrid Show Method @31-3B14E86E
    Sub Show(Tpl)
        If NOT Visible Then Exit Sub

        Dim RecordCounter, ShownRecords
        Dim RowBlock

        With DataSource
        End With

        CCSEventResult = CCRaiseEvent(CCSEvents, "BeforeSelect", Me)
        Set Recordset = DataSource.Open(Command)

        Set TemplateBlock = Tpl.Block("Grid " & ComponentName)
        Set RowBlock = TemplateBlock.Block("Row")
        Set StaticControls = CCCreateCollection(TemplateBlock, Null, ccsParseOverwrite, _
            Array(Sorter_first_name, Sorter_last_name, Sort_Email, Sorter_phone_home, Sort_SSN, Link1, Navigator))
        Set RowControls = CCCreateCollection(RowBlock, Null, ccsParseAccumulate, _
            Array(first_name, last_name, email, phone_work, user_SSN))

        CCSEventResult = CCRaiseEvent(CCSEvents, "BeforeShow", Me)
        If NOT Visible Then Exit Sub

        Errors.AddErrors DataSource.Errors
        If Errors.Count > 0 Then
            TemplateBlock.HTML = CCFormatError("Grid usersgrid", Errors)
        Else

            ' Show NoRecords block if no records are found
            If Recordset.EOF Then
                TemplateBlock.Block("NoRecords").Parse ccsParseOverwrite
            End If
            While NOT Recordset.EOF AND ShownRecords < PageSize
                first_name.Value = Recordset.Fields("first_name")
                first_name.Parameters = CCGetQueryString("QueryString", Array("ccsForm"))
                first_name.Parameters = CCAddParam(first_name.Parameters, "user_id", Recordset.Fields("first_name_param1"))
                first_name.Page = "InputMask.asp"
                last_name.Value = Recordset.Fields("last_name")
                email.Value = Recordset.Fields("email")
                phone_work.Value = Recordset.Fields("phone_work")
                user_SSN.Value = Recordset.Fields("user_SSN")
                CCSEventResult = CCRaiseEvent(CCSEvents, "BeforeShowRow", Me)
                RowControls.Show
                Recordset.MoveNext
                ShownRecords = ShownRecords + 1
            Wend
            
            Link1.Parameters = CCGetQueryString("QueryString", Array("ccsForm"))
            Link1.Page = "InputMask.asp"
            Navigator.SetDataSource Recordset
            StaticControls.Show
        End If

    End Sub
'End usersgrid Show Method

End Class 'End usersgrid Class @31-A61BA892

Class clsusersgridDataSource 'usersgridDataSource Class @31-AA6E7C81

'DataSource Variables @31-1F587D48
    Public Errors, Connection, Parameters, CCSEvents

    Public Recordset
    Public SQL, CountSQL, Order, Where, Orders
    Public RecordsCount
    Public PageSize
    Public PageCount
    Public AbsolutePage
    Public Fields
    Dim WhereParameters
    Public AllParamsSet

    Private CurrentOperation
    Private CCSEventResult

    ' Datasource fields
    Public first_name
    Public first_name_param1
    Public last_name
    Public email
    Public phone_work
    Public user_SSN
'End DataSource Variables

'DataSource Class_Initialize Event @31-D990BCB0
    Private Sub Class_Initialize()

        Set CCSEvents = CreateObject("Scripting.Dictionary")
        Set Fields = New clsFields
        Set Recordset = New clsDataSource
        Set Errors = New clsErrors
        AllParamsSet = True
        Set first_name = CCCreateField("first_name", "first_name", ccsText, Empty, Recordset)
        Set first_name_param1 = CCCreateField("first_name_param1", "user_id", ccsText, Empty, Recordset)
        Set last_name = CCCreateField("last_name", "last_name", ccsText, Empty, Recordset)
        Set email = CCCreateField("email", "email", ccsText, Empty, Recordset)
        Set phone_work = CCCreateField("phone_work", "phone_work", ccsText, Empty, Recordset)
        Set user_SSN = CCCreateField("user_SSN", "user_SSN", ccsText, Empty, Recordset)
        Fields.AddFields Array(first_name, first_name_param1, last_name, email, phone_work, user_SSN)
        Orders = Array( _ 
            Array("Sorter_first_name", "first_name", ""), _
            Array("Sorter_last_name", "last_name", ""), _
            Array("Sort_Email", "email", ""), _
            Array("Sorter_phone_home", "phone_home", ""), _
            Array("Sort_SSN", "user_SSN", ""))

        SQL = "SELECT *  " & _
        "FROM users"
        CountSQL = "SELECT COUNT(*)  " & _
        "FROM users"
        Where = ""
        Order = "user_id"
    End Sub
'End DataSource Class_Initialize Event

'SetOrder Method @31-68FC9576
    Sub SetOrder(Column, Direction)
        Order = Recordset.GetOrder(Order, Column, Direction, Orders)
    End Sub
'End SetOrder Method

'BuildTableWhere Method @31-98E5A92F
    Public Sub BuildTableWhere()
    End Sub
'End BuildTableWhere Method

'Open Method @31-D0383B6E
    Function Open(Cmd)
        Errors.Clear
        Set Recordset.DataSource = Me
        Set Cmd.Connection = Connection
        Cmd.CommandOperation = cmdOpen
        Cmd.PageSize = PageSize
        Cmd.ActivePage = AbsolutePage
        Cmd.CommandType = dsTable
        CCSEventResult = CCRaiseEvent(CCSEvents, "BeforeBuildSelect", Me)
        Cmd.SQL = SQL
        Cmd.CountSQL = CountSQL
        Cmd.Where = Where
        Cmd.OrderBy = Order
        CCSEventResult = CCRaiseEvent(CCSEvents, "BeforeExecuteSelect", Me)
        If Errors.Count = 0 And CCSEventResult Then _
            Set Recordset = Cmd.Exec(Errors)
        CCSEventResult = CCRaiseEvent(CCSEvents, "AfterExecuteSelect", Me)
        Set Recordset.FieldsCollection = Fields
        Set Open = Recordset
    End Function
'End Open Method

'DataSource Class_Terminate Event @31-41B4B08D
    Private Sub Class_Terminate()
        If Recordset.State = adStateOpen Then _
            Recordset.Close
        Set Recordset = Nothing
        Set Parameters = Nothing
        Set Errors = Nothing
    End Sub
'End DataSource Class_Terminate Event

End Class 'End usersgridDataSource Class @31-A61BA892

Class clsRecordusers 'users Class @20-AC83D989

'users Variables @20-81F7EC52

    ' Public variables
    Public ComponentName
    Public HTMLFormAction
    Public PressedButton
    Public Errors
    Public FormSubmitted
    Public EditMode
    Public Visible
    Public Recordset
    Public TemplateBlock

    Public CCSEvents
    Private CCSEventResult

    Public InsertAllowed
    Public UpdateAllowed
    Public DeleteAllowed
    Public DataSource
    Public Command
    Public ValidatingControls
    Public Controls

    ' Class variables
    Dim first_name
    Dim last_name
    Dim email
    Dim phone_work
    Dim user_SSN
    Dim Button_Insert
    Dim Button_Update
    Dim Button_Delete
    Dim Button_Cancel
'End users Variables

'users Class_Initialize Event @20-A989ED7C
    Private Sub Class_Initialize()

        Visible = True
        Set Errors = New clsErrors
        Set CCSEvents = CreateObject("Scripting.Dictionary")
        Set DataSource = New clsusersDataSource
        Set Command = New clsCommand
        InsertAllowed = True
        UpdateAllowed = True
        DeleteAllowed = True
        Dim Method
        Dim OperationMode
        
        If Visible Then
            OperationMode = Split(Request.QueryString("ccsForm"), ":")
            If UBound(OperationMode) > -1 Then 
                FormSubmitted = (OperationMode(0) = "users")
            End If
            If UBound(OperationMode) > 0 Then 
                EditMode = (OperationMode(1) = "Edit")
            End If
            ComponentName = "users"
            Method = IIf(FormSubmitted, ccsPost, ccsGet)
            Set first_name = CCCreateControl(ccsTextBox, "first_name", "First Name", ccsText, Empty, CCGetRequestParam("first_name", Method))
            first_name.Required = True
            Set last_name = CCCreateControl(ccsTextBox, "last_name", "Last Name", ccsText, Empty, CCGetRequestParam("last_name", Method))
            last_name.Required = True
            Set email = CCCreateControl(ccsTextBox, "email", "Email", ccsText, Empty, CCGetRequestParam("email", Method))
            Set phone_work = CCCreateControl(ccsTextBox, "phone_work", "Phone Work", ccsText, Empty, CCGetRequestParam("phone_work", Method))
            Set user_SSN = CCCreateControl(ccsTextBox, "user_SSN", "SSN", ccsText, Empty, CCGetRequestParam("user_SSN", Method))
            Set Button_Insert = CCCreateButton("Button_Insert")
            Set Button_Update = CCCreateButton("Button_Update")
            Set Button_Delete = CCCreateButton("Button_Delete")
            Set Button_Cancel = CCCreateButton("Button_Cancel")
            Set ValidatingControls = new clsControls
            ValidatingControls.addControls Array(first_name, last_name, email, phone_work, user_SSN)
        End If
    End Sub
'End users Class_Initialize Event

'users Initialize Method @20-80303BE5
    Sub Initialize(objConnection)

        If NOT Visible Then Exit Sub


        Set DataSource.Connection = objConnection
        With DataSource
            .Parameters("urluser_id") = CCGetRequestParam("user_id", ccsGET)
        End With
    End Sub
'End users Initialize Method

'users Class_Terminate Event @20-32B847C9
    Private Sub Class_Terminate()
        Set Errors = Nothing
    End Sub
'End users Class_Terminate Event

'users Validate Method @20-99412B61
    Function Validate()
        Dim Validation
        If NOT CCRegExpTest(email.Text, "^[\w\.-]{1,}\@([\da-zA-Z-]{1,}\.){1,}[\da-zA-Z-]+$", False, False) Then
            email.Errors.addError("Mask validation failed for field Email.")
        End If
        Validation = ValidatingControls.Validate
        CCSEventResult = CCRaiseEvent(CCSEvents, "OnValidate", Me)
        Validate = Validation And (Errors.Count = 0)
    End Function
'End users Validate Method

'users Operation Method @20-256A1AF2
    Sub Operation()
        If NOT ( Visible AND FormSubmitted ) Then Exit Sub

        If FormSubmitted Then
            PressedButton = IIf(EditMode, "Button_Update", "Button_Insert")
            If Not IsEmpty(CCGetParam("Button_Insert", Empty)) Then
                PressedButton = "Button_Insert"
            ElseIf Not IsEmpty(CCGetParam("Button_Update", Empty)) Then
                PressedButton = "Button_Update"
            ElseIf Not IsEmpty(CCGetParam("Button_Delete", Empty)) Then
                PressedButton = "Button_Delete"
            ElseIf Not IsEmpty(CCGetParam("Button_Cancel", Empty)) Then
                PressedButton = "Button_Cancel"
            End If
        End If
        Redirect = "InputMask.asp?" & CCGetQueryString("QueryString", Array("ccsForm", "Button_Insert", "Button_Update", "Button_Delete", "Button_Cancel", "user_id"))
        If PressedButton = "Button_Delete" Then
            If NOT Button_Delete.OnClick OR NOT DeleteRow() Then
                Redirect = ""
            End If
        ElseIf PressedButton = "Button_Cancel" Then
            If NOT Button_Cancel.OnClick Then
                Redirect = ""
            End If
        ElseIf Validate() Then
            If PressedButton = "Button_Insert" Then
                If NOT Button_Insert.OnClick() OR NOT InsertRow() Then
                    Redirect = ""
                End If
            ElseIf PressedButton = "Button_Update" Then
                If NOT Button_Update.OnClick() OR NOT UpdateRow() Then
                    Redirect = ""
                End If
            End If
        Else
            Redirect = ""
        End If
    End Sub
'End users Operation Method

'users InsertRow Method @20-9EB1D085
    Function InsertRow()
        CCSEventResult = CCRaiseEvent(CCSEvents, "BeforeInsert", Me)
        If NOT InsertAllowed Then InsertRow = False : Exit Function
        DataSource.first_name.Value = first_name.Value
        DataSource.last_name.Value = last_name.Value
        DataSource.email.Value = email.Value
        DataSource.phone_work.Value = phone_work.Value
        DataSource.user_SSN.Value = user_SSN.Value
        DataSource.Insert(Command)


        CCSEventResult = CCRaiseEvent(CCSEvents, "AfterInsert", Me)
        If DataSource.Errors.Count > 0 Then
            PrintDBError "Record " & ComponentName & " / Insert Operation", DataSource.Connection.LastSQL, DataSource.Errors.ToString()
            DataSource.Errors.Clear
            Errors.AddError "Database command error."
        End If
        InsertRow = (Errors.Count = 0)
    End Function
'End users InsertRow Method

'users UpdateRow Method @20-CA2DBDB6
    Function UpdateRow()
        CCSEventResult = CCRaiseEvent(CCSEvents, "BeforeUpdate", Me)
        If NOT UpdateAllowed Then UpdateRow = False : Exit Function
        DataSource.first_name.Value = first_name.Value
        DataSource.last_name.Value = last_name.Value
        DataSource.email.Value = email.Value
        DataSource.phone_work.Value = phone_work.Value
        DataSource.user_SSN.Value = user_SSN.Value
        DataSource.Update(Command)


        CCSEventResult = CCRaiseEvent(CCSEvents, "AfterUpdate", Me)
        If DataSource.Errors.Count > 0 Then
            PrintDBError "Record " & ComponentName & " / Update Operation", DataSource.Connection.LastSQL, DataSource.Errors.ToString()
            DataSource.Errors.Clear
            Errors.AddError "Database command error."
        End If
        UpdateRow = (Errors.Count = 0)
    End Function
'End users UpdateRow Method

'users DeleteRow Method @20-1BC2677D
    Function DeleteRow()
        CCSEventResult = CCRaiseEvent(CCSEvents, "BeforeDelete", Me)
        If NOT DeleteAllowed Then DeleteRow = False : Exit Function
        DataSource.Delete(Command)


        CCSEventResult = CCRaiseEvent(CCSEvents, "AfterDelete", Me)
        If DataSource.Errors.Count > 0 Then
            PrintDBError "Record " & ComponentName & " / Delete Operation", DataSource.Connection.LastSQL, DataSource.Errors.ToString()
            DataSource.Errors.Clear
            Errors.AddError "Database command error."
        End If
        DeleteRow = (Errors.Count = 0)
    End Function
'End users DeleteRow Method

'users Show Method @20-050063B4
    Sub Show(Tpl)

        If NOT Visible Then Exit Sub

        CCSEventResult = CCRaiseEvent(CCSEvents, "BeforeSelect", Me)
        Set Recordset = DataSource.Open(Command)
        If Recordset.State = adStateOpen Then 
            EditMode = NOT Recordset.EOF 
        Else 
            EditMode = False
        End If
        HTMLFormAction = FileName & "?" & CCAddParam(Request.ServerVariables("QUERY_STRING"), "ccsForm", "users" & IIf(EditMode, ":Edit", ""))
        Set TemplateBlock = Tpl.Block("Record " & ComponentName)
        TemplateBlock.Variable("HTMLFormName") = ComponentName
        TemplateBlock.Variable("HTMLFormEnctype") ="application/x-www-form-urlencoded"
        Set Controls = CCCreateCollection(TemplateBlock, Null, ccsParseOverwrite, _
            Array(first_name, last_name, email, phone_work, user_SSN, Button_Insert, Button_Update, Button_Delete, Button_Cancel))
        If EditMode Then
            If Errors.Count = 0 Then
                If Recordset.Errors.Count > 0 Then
                    PrintDBError "Record users", DataSource.Connection.LastSQL, Recordset.Errors.ToString
                ElseIf Not Recordset.EOF Then
                    If Not FormSubmitted Then
                        first_name.Value = Recordset.Fields("first_name")
                        last_name.Value = Recordset.Fields("last_name")
                        email.Value = Recordset.Fields("email")
                        phone_work.Value = Recordset.Fields("phone_work")
                        user_SSN.Value = Recordset.Fields("user_SSN")
                    End If
                Else
                    EditMode = False
                End If
            End If
        End If
        If Not FormSubmitted Then
        End If
        If FormSubmitted Then
            With TemplateBlock.Block("Error")
                .Variable("Error") = ValidatingControls.GetErrors & Errors.ToString _
                    & DataSource.Errors.ToString
                .Parse False
            End With
        End If
        TemplateBlock.Variable("Action") = HTMLFormAction
        Button_Insert.Visible = NOT EditMode
        Button_Update.Visible = EditMode
        Button_Delete.Visible = EditMode

        CCSEventResult = CCRaiseEvent(CCSEvents, "BeforeShow", Me)
        If Visible Then Controls.Show
    End Sub
'End users Show Method

End Class 'End users Class @20-A61BA892

Class clsusersDataSource 'usersDataSource Class @20-D36C769C

'DataSource Variables @20-B3C51B77
    Public Errors, Connection, Parameters, CCSEvents

    Public Recordset
    Public SQL, CountSQL, Order, Where, Orders
    Public RecordsCount
    Public PageSize
    Public PageCount
    Public AbsolutePage
    Public Fields
    Dim WhereParameters
    Public AllParamsSet

    Private CurrentOperation
    Private CCSEventResult

    ' Datasource fields
    Public first_name
    Public last_name
    Public email
    Public phone_work
    Public user_SSN
'End DataSource Variables

'DataSource Class_Initialize Event @20-6FF5BCEA
    Private Sub Class_Initialize()

        Set CCSEvents = CreateObject("Scripting.Dictionary")
        Set Fields = New clsFields
        Set Recordset = New clsDataSource
        Set Errors = New clsErrors
        AllParamsSet = True
        Set first_name = CCCreateField("first_name", "first_name", ccsText, Empty, Recordset)
        Set last_name = CCCreateField("last_name", "last_name", ccsText, Empty, Recordset)
        Set email = CCCreateField("email", "email", ccsText, Empty, Recordset)
        Set phone_work = CCCreateField("phone_work", "phone_work", ccsText, Empty, Recordset)
        Set user_SSN = CCCreateField("user_SSN", "user_SSN", ccsText, Empty, Recordset)
        Fields.AddFields Array(first_name, last_name, email, phone_work, user_SSN)
        Set Parameters = Server.CreateObject("Scripting.Dictionary")
        Set WhereParameters = Nothing

        SQL = "SELECT *  " & _
        "FROM users"
        CountSQL = "SELECT COUNT(*)  " & _
        "FROM users"
        Where = ""
        Order = ""
    End Sub
'End DataSource Class_Initialize Event

'BuildTableWhere Method @20-AE604FDB
    Public Sub BuildTableWhere()
        Dim WhereParams

        If Not WhereParameters Is Nothing Then _
            Exit Sub
        Set WhereParameters = new clsSQLParameters
        With WhereParameters
            Set .Connection = Connection
            Set .ParameterSources = Parameters
            Set .DataSource = Me
            .AddParameter 1, "urluser_id", ccsInteger, Empty, Empty, Empty, False
            AllParamsSet = .AllParamsSet
            .Criterion(1) = .Operation(opEqual, False, "user_id", .getParamByID(1))
            .AssembledWhere = .Criterion(1)
            WhereParams = .AssembledWhere
            If Len(Where) > 0 Then 
                If Len(WhereParams) > 0 Then _
                    Where = Where & " AND " & WhereParams
            Else
                If Len(WhereParams) > 0 Then _
                    Where = WhereParams
            End If
        End With
    End Sub
'End BuildTableWhere Method

'Open Method @20-DF951BED
    Function Open(Cmd)
        Errors.Clear
        Set Recordset.DataSource = Me
        Set Cmd.Connection = Connection
        Cmd.CommandOperation = cmdOpen
        Cmd.PageSize = PageSize
        Cmd.ActivePage = AbsolutePage
        Cmd.CommandType = dsTable
        CCSEventResult = CCRaiseEvent(CCSEvents, "BeforeBuildSelect", Me)
        Cmd.SQL = SQL
        BuildTableWhere
        Cmd.Where = Where
        Cmd.OrderBy = Order
        If Not AllParamsSet Then
            Set Open = New clsEmptyDataSource
            Exit Function
        End If
        CCSEventResult = CCRaiseEvent(CCSEvents, "BeforeExecuteSelect", Me)
        If Errors.Count = 0 And CCSEventResult Then _
            Set Recordset = Cmd.Exec(Errors)
        CCSEventResult = CCRaiseEvent(CCSEvents, "AfterExecuteSelect", Me)
        Set Recordset.FieldsCollection = Fields
        Set Open = Recordset
    End Function
'End Open Method

'DataSource Class_Terminate Event @20-41B4B08D
    Private Sub Class_Terminate()
        If Recordset.State = adStateOpen Then _
            Recordset.Close
        Set Recordset = Nothing
        Set Parameters = Nothing
        Set Errors = Nothing
    End Sub
'End DataSource Class_Terminate Event

'Delete Method @20-6121187C
    Sub Delete(Cmd)
        CCSEventResult = CCRaiseEvent(CCSEvents, "BeforeBuildDelete", Me)
        Set Cmd.Connection = Connection
        Cmd.CommandOperation = cmdExec
        Cmd.CommandType = dsTable
        Cmd.CommandParameters = Empty
        BuildTableWhere
        If NOT AllParamsSet Then
            Errors.AddError "Unable to perform the Delete operation. There are one or more unspecified parameters."
            Exit Sub
        End If
        Cmd.SQL = "DELETE FROM users" & IIf(Len(Where) > 0, " WHERE " & Where, "")
        CCSEventResult = CCRaiseEvent(CCSEvents, "BeforeExecuteDelete", Me)
        Cmd.Exec(Errors)
        CCSEventResult = CCRaiseEvent(CCSEvents, "AfterExecuteDelete", Me)
    End Sub
'End Delete Method

'Update Method @20-20C93931
    Sub Update(Cmd)
        CCSEventResult = CCRaiseEvent(CCSEvents, "BeforeBuildUpdate", Me)
        Set Cmd.Connection = Connection
        Cmd.CommandOperation = cmdExec
        Cmd.CommandType = dsTable
        Cmd.CommandParameters = Empty
        BuildTableWhere
        If NOT AllParamsSet Then
            Errors.AddError "Unable to perform the Update operation.  There are one or more unspecified parameters."
            Exit Sub
        End If
        Cmd.SQL = "UPDATE users SET " & _
            "first_name=" & Connection.ToSQL(first_name.SQLText, first_name.DataType) & ", " & _
            "last_name=" & Connection.ToSQL(last_name.SQLText, last_name.DataType) & ", " & _
            "email=" & Connection.ToSQL(email.SQLText, email.DataType) & ", " & _
            "phone_work=" & Connection.ToSQL(phone_work.SQLText, phone_work.DataType) & ", " & _
            "user_SSN=" & Connection.ToSQL(user_SSN.SQLText, user_SSN.DataType) & _
            IIf(Len(Where) > 0, " WHERE " & Where, "")
        CCSEventResult = CCRaiseEvent(CCSEvents, "BeforeExecuteUpdate", Me)
        Cmd.Exec(Errors)
        CCSEventResult = CCRaiseEvent(CCSEvents, "AfterExecuteUpdate", Me)
    End Sub
'End Update Method

'Insert Method @20-391A2637
    Sub Insert(Cmd)
        CCSEventResult = CCRaiseEvent(CCSEvents, "BeforeBuildInsert", Me)
        Set Cmd.Connection = Connection
        Cmd.CommandOperation = cmdExec
        Cmd.CommandType = dsTable
        Cmd.CommandParameters = Empty
        Cmd.SQL = "INSERT INTO users(" & _
            "first_name, " & _
            "last_name, " & _
            "email, " & _
            "phone_work, " & _
            "user_SSN" & _
        ") VALUES (" & _
            Connection.ToSQL(first_name.SQLText, first_name.DataType) & ", " & _
            Connection.ToSQL(last_name.SQLText, last_name.DataType) & ", " & _
            Connection.ToSQL(email.SQLText, email.DataType) & ", " & _
            Connection.ToSQL(phone_work.SQLText, phone_work.DataType) & ", " & _
            Connection.ToSQL(user_SSN.SQLText, user_SSN.DataType) & _
        ")"
        CCSEventResult = CCRaiseEvent(CCSEvents, "BeforeExecuteInsert", Me)
        Cmd.Exec(Errors)
        CCSEventResult = CCRaiseEvent(CCSEvents, "AfterExecuteInsert", Me)
    End Sub
'End Insert Method

End Class 'End usersDataSource Class @20-A61BA892


%>
