#BindEvents Method @1-30BA0C0A
sub BindEvents {
    $employees_record->{CCSEvents}->{"BeforeShow"} = "employees_record_BeforeShow";
    $employees_record->{CCSEvents}->{"AfterInsert"} = "employees_record_AfterInsert";
    $employees_record->{CCSEvents}->{"AfterUpdate"} = "employees_record_AfterUpdate";
    $employees_record->{CCSEvents}->{"BeforeDelete"} = "employees_record_BeforeDelete";
}
#End BindEvents Method

#employees_record_BeforeShow @14-7D3CACA5
sub employees_record_BeforeShow()
{
    $employees_record_BeforeShow = 1;
#End employees_record_BeforeShow

#Custom Code @34-84ABEA10
	
	@ArrayProject = ();
	
	#Populate the multi-select project CheckBox list
	if($employees_record->{EditMode}) {

		#Create a new database connection object
		my $ProjectConnection = clsDBIntranetDB->new();
   		$ProjectConnection->query("SELECT project_id FROM projects_employees WHERE emp_id =".$ProjectConnection->ToSQL(CCGetParam("emp_id", 0),$ccsInteger));
   		while($ProjectConnection->next_record()) {
        	push(@ArrayProject,$ProjectConnection->f("project_id"));
   		}
   		$employees_record->{ProjectList}->{Multiple} = 1;
		$employees_record->{ProjectList}->SetValue(\@ArrayProject);
		
   		#Close and destroy the recordset
   		$ProjectConnection->{sth} = undef;
	
 }
#End Custom Code

#Close employees_record_BeforeShow @14-70CBFC0C
    return $employees_record_BeforeShow;
}
#End Close employees_record_BeforeShow

#employees_record_AfterInsert @14-9829EF5A
sub employees_record_AfterInsert()
{
    $employees_record_AfterInsert = 1;
#End employees_record_AfterInsert

#Custom Code @35-84ABEA10

	ProjectEmployeesModify("Insert");

#End Custom Code

#Close employees_record_AfterInsert @14-706BBD18
    return $employees_record_AfterInsert;
}
#End Close employees_record_AfterInsert

#employees_record_AfterUpdate @14-C502FF63
sub employees_record_AfterUpdate()
{
    $employees_record_AfterUpdate = 1;
#End employees_record_AfterUpdate

#Custom Code @36-84ABEA10

	ProjectEmployeesModify("Update");

#End Custom Code

#Close employees_record_AfterUpdate @14-BF427C97
    return $employees_record_AfterUpdate;
}
#End Close employees_record_AfterUpdate

#employees_record_BeforeDelete @14-5F527835
sub employees_record_BeforeDelete()
{
    $employees_record_BeforeDelete = 1;
#End employees_record_BeforeDelete

#Custom Code @39-84ABEA10

	ProjectEmployeesModify("Delete");

#End Custom Code

#Close employees_record_BeforeDelete @14-113E24AB
    return $employees_record_BeforeDelete;
}
#End Close employees_record_BeforeDelete

sub ProjectEmployeesModify(){ 

  my $EmpID = 0;
  my $ProjectID = 0;
  my @ProjectList = ();
  my $GetLastInsKey = 0;
  my ($Actions) = @_;

  #Create a new database connection object
  $EmpProjectConn = clsDBIntranetDB->new();
	
  #Retrieve the current project
  $EmpID = CCGetFromGet("emp_id",0);
  
  my $proj = CCGetFromPost("ProjectList",0);

  if(ref($proj) eq "ARRAY") {
 
	@ProjectList = @$proj;
    
  }elsif(length($proj)) {
     
	@ProjectList = ($proj);
  }

  if($Actions eq "Insert"){
	
     #Retrieve the last inserted key
     #Use MS SQL method
     #$GetLastInsKey = CCDlookup("@@IDENTITY","employees","",$DBIntranetDB);
     #Use a method compatible with all databases (unsafe when multiple users insert records at the same time)
     $GetLastInsKey = CCDlookUp("max(emp_id)", "employees", "", $employees_record->{ds});
     
     #Insert New links
	 foreach $ProjectID (@ProjectList){
		$EmpProjectConn->query("INSERT INTO projects_employees(project_id, emp_id) VALUES (".$EmpProjectConn->ToSQL($ProjectID,$ccsInteger).",".$EmpProjectConn->ToSQL($GetLastInsKey,$ccsInteger).")");
	 }
  }  	 
  if($EmpID >0){
  	if( ($Actions eq "Delete") || ($Actions eq "Update")){
       
	    #Delete project employees links
     	$EmpProjectConn->query("DELETE FROM projects_employees WHERE emp_id=".$EmpProjectConn->ToSQL($EmpID,$ccsInteger));
    } 
  	if($Actions eq "Update"){
       
	   #Insert assigned employees
	   foreach $ProjectID (@ProjectList){
          $EmpProjectConn->query("INSERT INTO projects_employees (project_id, emp_id) VALUES (".$EmpProjectConn->ToSQL($ProjectID,$ccsInteger).",".$EmpProjectConn->ToSQL($EmpID,$ccsInteger).")");
       }
    }
  }
  #Close and destroy the database connection object
  $EmpProjectConn->{sth} = undef;
}



1;
