#BindEvents Method @1-FABC0C53
sub BindEvents {
    $projects_rec->{CCSEvents}->{"BeforeShow"} = "projects_rec_BeforeShow";
    $projects_rec->{CCSEvents}->{"AfterInsert"} = "projects_rec_AfterInsert";
    $projects_rec->{CCSEvents}->{"AfterUpdate"} = "projects_rec_AfterUpdate";
    $projects_rec->{CCSEvents}->{"BeforeDelete"} = "projects_rec_BeforeDelete";
}
#End BindEvents Method

#projects_rec_BeforeShow @55-4E3FA3FF
sub projects_rec_BeforeShow()
{
    $projects_rec_BeforeShow = 1;
#End projects_rec_BeforeShow

#Custom Code @63-84ABEA10
  
  @Vals = ();
	
 #Populate the multi-select project listBox
 if($projects_rec->{EditMode}){

   #Create a new database connection object
   $NewConnection = clsDBIntranetDB->new();
   
   $NewConnection->query("SELECT employees.emp_id FROM employees, projects_employees WHERE projects_employees.emp_id = employees.emp_id AND projects_employees.project_id=".$NewConnection->ToSQL(CCGetParam("project_id", 0),$ccsInteger) );
   while($NewConnection->next_record()){
     push(@Vals,$NewConnection->f("emp_id"));
   }
   $projects_rec->{employee_list}->{Multiple} = 1;
   $projects_rec->{employee_list}->SetValue(\@Vals);

   #Close and destroy the recordset
   $NewConnection->{sth} = undef;
 
 }
#End Custom Code

#Close projects_rec_BeforeShow @55-1A49E35E
    return $projects_rec_BeforeShow;
}
#End Close projects_rec_BeforeShow

#projects_rec_AfterInsert @55-36795250
sub projects_rec_AfterInsert()
{
    $projects_rec_AfterInsert = 1;
#End projects_rec_AfterInsert

#Custom Code @64-84ABEA10
	ProjectEmployeesModify("Insert");
#End Custom Code

#Close projects_rec_AfterInsert @55-F5640FDF
    return $projects_rec_AfterInsert;
}
#End Close projects_rec_AfterInsert

#projects_rec_AfterUpdate @55-474F0293
sub projects_rec_AfterUpdate()
{
    $projects_rec_AfterUpdate = 1;
#End projects_rec_AfterUpdate

#Custom Code @65-84ABEA10
	ProjectEmployeesModify("Update");
#End Custom Code

#Close projects_rec_AfterUpdate @55-3A4DCE50
    return $projects_rec_AfterUpdate;
}
#End Close projects_rec_AfterUpdate

#projects_rec_BeforeDelete @55-830ECBBC
sub projects_rec_BeforeDelete()
{
    $projects_rec_BeforeDelete = 1;
#End projects_rec_BeforeDelete

#Custom Code @70-84ABEA10
	ProjectEmployeesModify("Delete");
#End Custom Code

#Close projects_rec_BeforeDelete @55-14BB7C0A
    return $projects_rec_BeforeDelete;
}
#End Close projects_rec_BeforeDelete

sub ProjectEmployeesModify(){ 
  
 my $CurrProjectID = 0;
 my @EmpList = ();
 my $EmpID = 0;
 my ($Actions) = @_;
		
  #Create a new database Connection object
  $EmpProjectConn = clsDBIntranetDB->new();

  $CurrProjectID = CCGetFromGet("project_id",0);
  my $emp = CCGetFromPost("employee_list",());

  if(ref($emp) eq "ARRAY") {
 
	@EmpList = @$emp;
    
  }elsif(length($emp)){
     
	@EmpList = ($emp);
  }
		  	
  if($Actions eq "Insert") {
    
	#Retrieve the last inserted key
    #Use MS SQL method
    #$GetLastInsKey = CCDlookUp("@@IDENTITY","projects","",DBIntranetDB);
    #Use a method compatible with all databases (unsafe when multiple users insert records at the same time)
    $CurrProjectID = CCDlookUp("max(project_id)", "projects", "", $projects_rec->{ds});
    #Insert New links
	
	foreach $EmpID (@EmpList){
		$EmpProjectConn->query("INSERT INTO projects_employees(project_id,emp_id) VALUES (".$EmpProjectConn->ToSQL($CurrProjectID,$ccsInteger).",".$EmpProjectConn->ToSQL($EmpID,$ccsInteger).")");
   	}
  }  	 
  if($CurrProjectID >0) {
	if( ($Actions eq "Delete") || ($Actions eq "Update")){
	   
	   #Delete project employees links
       $EmpProjectConn->query("DELETE FROM projects_employees WHERE project_id=".$EmpProjectConn->ToSQL($CurrProjectID,$ccsInteger));
    } 
    if($Actions eq "Update"){
      
	  #Insert assigned employees
      foreach $EmpID (@EmpList){
         $EmpProjectConn->query("INSERT INTO projects_employees (project_id, emp_id) VALUES (".$EmpProjectConn->ToSQL($CurrProjectID,$ccsInteger).",".$EmpProjectConn->ToSQL($EmpID,$ccsInteger).")");
      }
    }
  }

  #Close and destroy the database Connection object
  $EmpProjectConn->{sth} = undef;

}

1;
