<%
'BindEvents Method @1-3DA55296
Sub BindEvents()
    Set employees_record.AvailableListBox.DataSource.CCSEvents("BeforeBuildSelect") = GetRef("employees_record_AvailableListBox_DataSource_BeforeBuildSelect")
    Set employees_record.CCSEvents("AfterInsert") = GetRef("employees_record_AfterInsert")
    Set employees_record.CCSEvents("AfterUpdate") = GetRef("employees_record_AfterUpdate")
    Set employees_record.CCSEvents("BeforeDelete") = GetRef("employees_record_BeforeDelete")
End Sub
'End BindEvents Method

Function employees_record_AvailableListBox_DataSource_BeforeBuildSelect() 'employees_record_AvailableListBox_DataSource_BeforeBuildSelect @46-F1AA30C6
'Custom Code @52-73254650
Dim ProjectConnection
Dim ProjectRecordSet
Dim LinkedProject

'Populate multi-selectable project CheckBox list
 If CCGetFromGet("emp_id",0) <> 0 Then

   'Create a new database connection object
   Set ProjectConnection = New clsDBIntranetDB
   ProjectConnection.Open
   Set ProjectRecordSet = ProjectConnection.Execute("SELECT project_id FROM projects_employees WHERE emp_id =" & ProjectConnection.ToSQL(CCGetFromGet("emp_id", 0),ccsInteger))
   While NOT ProjectRecordSet.EOF
     If Not IsEmpty(LinkedProject) Then LinkedProject = LinkedProject&","
     LinkedProject = LinkedProject&ProjectRecordSet("project_id")
     ProjectRecordSet.MoveNext
   Wend
   
   'Close and destroy the recordset
   ProjectRecordSet.Close
   Set ProjectRecordSet = Nothing

   'Close and destroy the database connection object
   ProjectConnection.Close
   Set ProjectConnection = Nothing
 End If

   'Modify the Where clause of the AvailableListBox List Box
   If NOT IsEmpty(LinkedProject) Then
	employees_record.AvailableListBox.DataSource.Where = "project_id NOT IN (" &LinkedProject& ")"
   End If  
   
'End Custom Code
End Function 'Close employees_record_AvailableListBox_DataSource_BeforeBuildSelect @46-54C34B28

Function ProjectEmployeesModify(Actions) 
Dim EmpProjectConn
Dim EmpID
Dim ProjectID
Dim ProjectList
Dim GetLastInsKey

  'Create a new database connection object
  Set EmpProjectConn = New clsDBIntranetDB
  EmpProjectConn.Open

  'Retrieve current project
  EmpID = Request.QueryString("emp_id")
  ProjectList = Split(Request.Form("LinkedID"),",")

  If Actions = "Insert" Then
     'Retrieve the last inserted key
     'Use MS SQL method
     ' GetLastInsKey = CCDLookup("@@IDENTITY","employees","",DBIntranetDB)
     'Use a method compatible with all databases (unsafe when multiple users insert records at the same time)
     GetLastInsKey = CCDLookup("max(emp_id)", "employees", "", DBIntranetDB)
     'Insert New links
     For Each ProjectID In ProjectList
       EmpProjectConn.Execute("INSERT INTO projects_employees (project_id, emp_id) VALUES (" & EmpProjectConn.ToSQL(ProjectID,ccsInteger) & "," & EmpProjectConn.ToSQL(GetLastInsKey,ccsInteger) & ")")
     Next
  End If 
  If EmpID > 0 Then
    If Actions = "Delete" Or Actions = "Update" Then
       'Delete project employees links
       EmpProjectConn.Execute("DELETE FROM projects_employees WHERE emp_id=" & EmpProjectConn.ToSQL(EmpID,ccsInteger))
    End If 
    If Actions = "Update" Then
       'Insert assigned employees
       For Each ProjectID In ProjectList
         EmpProjectConn.Execute("INSERT INTO projects_employees (project_id, emp_id) VALUES (" & EmpProjectConn.ToSQL(ProjectID,ccsInteger) & "," & EmpProjectConn.ToSQL(EmpID,ccsInteger) & ")")
       Next
    End If 
  End If 

  'Close and destroy the database connection object
  EmpProjectConn.Close
  Set EmpProjectConn = Nothing

End Function

Function employees_record_AfterInsert() 'employees_record_AfterInsert @14-D36A08FC
'Custom Code @35-73254650

  ProjectEmployeesModify("Insert")

'End Custom Code
End Function 'Close employees_record_AfterInsert @14-54C34B28

Function employees_record_AfterUpdate() 'employees_record_AfterUpdate @14-1C43C973
'Custom Code @36-73254650

  ProjectEmployeesModify("Update")

'End Custom Code
End Function 'Close employees_record_AfterUpdate @14-54C34B28

Function employees_record_BeforeDelete() 'employees_record_BeforeDelete @14-7BA45279
'Custom Code @49-73254650

 ProjectEmployeesModify("Delete")

'End Custom Code
End Function 'Close employees_record_BeforeDelete @14-54C34B28


%>
