'Using Statements @1-D844C4BD
Imports System
Imports System.Text
Imports System.Text.RegularExpressions
Imports System.Collections
Imports System.Collections.Specialized
Imports System.Data
Imports CCSExamplePack
Imports CCSExamplePack.Data
Imports CCSExamplePack.Controls
Imports CCSExamplePack.Configuration

Namespace ManyToManyListboxes.ManyToManyListboxes
'End Using Statements

'Page Data Class @1-0E92F43E
Public Class PageItem
    Public errors As NameValueCollection = New NameValueCollection()

    Public Sub New()
    End Sub
    Public Shared Function CreateFromHttpRequest() As PageItem
        Dim item As PageItem = New PageItem()
        item.Link1.SetValue(DBUtility.GetInitialValue("Link1"))
        Return item
    End Function

    Default Public Property Field(fieldName As String) As FieldBase
        Get
            Select fieldName
                Case "Link1"
                    Return Link1
                Case Else
                    Throw (New ArgumentOutOfRangeException())
            End Select
        End Get
        Set (ByVal Value As FieldBase)
            Select fieldName
                Case "Link1"
                    Link1 = CType(value, TextField)
                Case Else
                    Throw (New ArgumentOutOfRangeException())
            End Select
        End Set
    End Property

    Public Link1 As TextField = New TextField("",Nothing)
    Public Link1Href As Object
    Public Link1HrefParameters As LinkParameterCollection = New LinkParameterCollection()
End Class
'End Page Data Class

'Page Data Provider Class @1-E3544B64
Public Class PageDataProvider
Dim j As Integer
'End Page Data Provider Class

'Page Data Provider Class Constructor @1-12B526DF

    Public Sub New()
    End Sub
'End Page Data Provider Class Constructor

'Page Data Provider Class GetResultSet Method @1-F73C4626

    Public Sub FillItem(ByVal item As PageItem)
'End Page Data Provider Class GetResultSet Method

'Page Data Provider Class GetResultSet Method tail @1-E31F8E2A
    End Sub
'End Page Data Provider Class GetResultSet Method tail

'Page Data Provider Tail @1-A61BA892
End Class
'End Page Data Provider Tail

'Grid employees Item Class @3-CF138EE0
Public Class employeesItem
    Public errors As NameValueCollection = New NameValueCollection()
    Public Sub New()
    End Sub

    Public Default Property Field(ByVal fieldName As String) as FieldBase
        Get
            Select fieldName
                Case "emp_id"
                    Return Me.emp_id
                Case "emp_name"
                    Return Me.emp_name
                Case "Link1"
                    Return Me.Link1
                Case Else
                    Throw New ArgumentOutOfRangeException()
            End Select
        End Get
        Set (ByVal Value As FieldBase)
            Select fieldName
                Case "emp_id"
                    Me.emp_id = CType(Value,TextField)
                Case "emp_name"
                    Me.emp_name = CType(Value,TextField)
                Case "Link1"
                    Me.Link1 = CType(Value,TextField)
                Case Else
                    Throw New ArgumentOutOfRangeException()
            End Select
        End Set
    End Property

    Public emp_id As TextField = New TextField("", Nothing)
    Public emp_name As TextField = New TextField("",Nothing)
    Public emp_nameHref As Object
    Public emp_nameHrefParameters As LinkParameterCollection = New LinkParameterCollection()
    Public Link1 As TextField = New TextField("",Nothing)
    Public Link1Href As Object
    Public Link1HrefParameters As LinkParameterCollection = New LinkParameterCollection()
End Class
'End Grid employees Item Class

'Grid employees Data Provider Class Header @3-5ADC7C39
Public Class employeesDataProvider
Inherits GridDataProviderBase
'End Grid employees Data Provider Class Header

'Grid employees Data Provider Class Variables @3-2DE69CE6

    Public Enum SortFields
        _Default
        Sorter_department_name
        Sorter_emp_name
    End Enum

    Private SortFieldsNames As String() = New String() {"emp_name","emp_id","emp_name"}
    Private SortFieldsNamesDesc As String() = New string() {"emp_name","emp_id DESC","emp_name DESC"}
    Public SortField As SortFields = SortFields._Default
    Public SortDir As SortDirections = SortDirections._Asc
    Public RecordsPerPage As Integer = 15
    Public PageNumber As Integer = 1
'End Grid employees Data Provider Class Variables

'Grid employees Data Provider Class Constructor @3-F8CB9E78

    Public Sub New()
        Select_ = New TableCommand("SELECT *  " & _
          "FROM employees",New String(){},Settings.IntranetDBDataAccessObject)
        Count = New TableCommand("SELECT COUNT(*)  " & _
          "FROM employees",New String(){},Settings.IntranetDBDataAccessObject)
    End Sub
'End Grid employees Data Provider Class Constructor

'Grid employees Data Provider Class GetResultSet Method @3-14850EE9

    Public Function GetResultSet(ByRef PagesCount As Integer) As employeesItem()
'End Grid employees Data Provider Class GetResultSet Method

'Before build Select @3-EB06405A
        Parameters.Clear
        If SortDir = SortDirections._Asc Then
            Select_.OrderBy=SortFieldsNames(CInt(SortField)).Trim()
        Else
            Select_.OrderBy=SortFieldsNamesDesc(CInt(SortField)).Trim()
        End If
'End Before build Select

'Execute Select @3-467AC0A8
        Dim ds As DataSet = Nothing, E as Exception = Nothing
        PagesCount=0
        Try
            If RecordsPerPage>0
                ds=ExecuteSelect((PageNumber-1)*RecordsPerPage,RecordsPerPage)
                PagesCount = ExecuteCount()
                m_recordCount = PagesCount
                If PagesCount Mod RecordsPerPage>0 Then
                    PagesCount = (PagesCount\RecordsPerPage)+1
                Else
                    PagesCount = PagesCount\RecordsPerPage
                End If
            Else
            ds=ExecuteSelect()
            If ds.Tables(0).Rows.Count<>0 Then 
                PagesCount=1
            End If
            End If
        Catch ee as Exception
            E=ee
        Finally
'End Execute Select

'After execute Select @3-DD02C5F8
        If Not IsNothing(E) Then Throw E
        End Try
        Dim dr as DataRowCollection = ds.Tables(0).Rows
        Dim result(dr.Count - 1) as employeesItem
        Dim j As Integer
'End After execute Select

'After execute Select tail @3-70C4A422
        Dim i as Integer
        For i = 0 To dr.Count - 1
            Dim item as employeesItem = New employeesItem()
            item.emp_id.SetValue(dr(i)("emp_id"),"")
            item.emp_name.SetValue(dr(i)("emp_name"),"")
            item.emp_nameHrefParameters.Add("emp_id",System.Web.HttpUtility.UrlEncode(dr(i)("emp_id").ToString()))
            result(i)=item
        Next
        Return result 
    End Function
'End After execute Select tail

'Grid Data Provider tail @3-A61BA892
End Class
'End Grid Data Provider tail

'Record employees_record Item Class @14-8AD2CB90
Public Class employees_recordItem
    Private _isNew As Boolean = True
    Private _isDeleted As Boolean = False
    Public errors As NameValueCollection = New NameValueCollection()

    public Sub New()
    End Sub
    Public emp_name As TextField = New TextField("", Nothing)
    Public AvailableListBox As IntegerField = New IntegerField("", Nothing)
    Public AvailableListBoxItems As ItemCollection = New ItemCollection()
    Public LinkedListBox As IntegerField = New IntegerField("", Nothing)
    Public LinkedListBoxItems As ItemCollection = New ItemCollection()
    Public LinkedID As TextField = New TextField("", Nothing)

    Public Shared Function CreateFromHttpRequest() As employees_recordItem
        Dim item As employees_recordItem = New employees_recordItem()
        If Not IsNothing(DBUtility.GetInitialValue("emp_name")) Then
        item.emp_name.SetValue(DBUtility.GetInitialValue("emp_name"))
        End If 
        If Not IsNothing(DBUtility.GetInitialValue("AvailableListBox")) Then
        item.AvailableListBox.SetValue(DBUtility.GetInitialValue("AvailableListBox"))
        End If 
        If Not IsNothing(DBUtility.GetInitialValue("RightButton")) Then
        End If 
        If Not IsNothing(DBUtility.GetInitialValue("LeftButton")) Then
        End If 
        If Not IsNothing(DBUtility.GetInitialValue("LinkedListBox")) Then
        item.LinkedListBox.SetValue(DBUtility.GetInitialValue("LinkedListBox"))
        End If 
        If Not IsNothing(DBUtility.GetInitialValue("LinkedID")) Then
        item.LinkedID.SetValue(DBUtility.GetInitialValue("LinkedID"))
        End If 
        If Not IsNothing(DBUtility.GetInitialValue("Insert1")) Then
        End If 
        If Not IsNothing(DBUtility.GetInitialValue("Update1")) Then
        End If 
        If Not IsNothing(DBUtility.GetInitialValue("Delete1")) Then
        End If 
        If Not IsNothing(DBUtility.GetInitialValue("Cancel")) Then
        End If 
        Return item
    End Function

    Default Public Property Field(fieldName As String) As FieldBase
        Get
            Select fieldName
                Case "emp_name"
                    Return emp_name
                Case "AvailableListBox"
                    Return AvailableListBox
                Case "LinkedListBox"
                    Return LinkedListBox
                Case "LinkedID"
                    Return LinkedID
                Case Else
                    Throw (New ArgumentOutOfRangeException())
            End Select
        End Get
        Set (ByVal Value As FieldBase)
            Select fieldName
                Case "emp_name"
                    emp_name = CType(value, TextField)
                Case "AvailableListBox"
                    AvailableListBox = CType(value, IntegerField)
                Case "LinkedListBox"
                    LinkedListBox = CType(value, IntegerField)
                Case "LinkedID"
                    LinkedID = CType(value, TextField)
                Case Else
                    Throw (New ArgumentOutOfRangeException())
            End Select
        End Set
    End Property

    Public Property IsNew() As Boolean
        Get
            Return _isNew
        End Get
        Set
            _isNew = Value
        End Set
    End Property

    Public Property IsDeleted() As Boolean
        Get
            Return _isDeleted
        End Get
        Set
            _isDeleted = Value
        End Set
    End Property

    Public Sub Validate(ByVal provider As employees_recordDataProvider)
'End Record employees_record Item Class

'emp_name validate @20-0B9B357F
        If IsNothing(emp_name.Value) Then
            errors.Add("emp_name","The value in field Name is required.")
        ElseIf emp_name.Value.ToString() ="" Then
            errors.Add("emp_name","The value in field Name is required.")
        End If
'End emp_name validate

'Record employees_record Item Class tail @14-8B704AE2
    End Sub
End Class
'End Record employees_record Item Class tail

'Record employees_record Data Provider Class @14-8DBAC386
Public Class employees_recordDataProvider
Inherits RecordDataProviderBase
'End Record employees_record Data Provider Class

'Record employees_record Data Provider Class Variables @14-0AE160D3
    Protected AvailableListBoxDataCommand As DataCommand = New TableCommand("SELECT *  " & _
          "FROM projects",New String(){},Settings.IntranetDBDataAccessObject)
    Protected LinkedListBoxDataCommand As DataCommand = New TableCommand("SELECT projects.*  " & _
          "FROM projects_employees INNER JOIN projects ON projects_employees.project_id = projects.project_id",New String(){"emp_id61"},Settings.IntranetDBDataAccessObject)
    Public Urlemp_id As IntegerParameter
'End Record employees_record Data Provider Class Variables

'Record employees_record Data Provider Class Constructor @14-BF9B979A

    Public Sub New()
        Select_ = New TableCommand("SELECT *  " & _
          "FROM employees",New String(){"emp_id19"},Settings.IntranetDBDataAccessObject)
        Insert = New TableCommand("INSERT INTO employees(emp_name ) VALUES ( {emp_name})" _
          ,New String(){},Settings.IntranetDBDataAccessObject)
        Update = New TableCommand("UPDATE employees SET emp_name={emp_name}" _
          ,New String(){"emp_id19"},Settings.IntranetDBDataAccessObject)
        Delete = New TableCommand("DELETE FROM employees",New String(){"emp_id19"},Settings.IntranetDBDataAccessObject)
    End Sub
'End Record employees_record Data Provider Class Constructor

'Record employees_record Data Provider Class LoadParams Method @14-74DA69E0

    Protected Function LoadParams() As Boolean
        CommonParameters.Clear()
    If IsNothing(Urlemp_id) Then
        CommonParameters.Add("emp_id19","")
    Else
        CommonParameters.Add("emp_id19","emp_id = " & Select_.Dao.ToSql(Urlemp_id.GetFormattedValue(""),FieldType._Integer))
    End If
        Return (IsNothing(Urlemp_id))
    End Function
'End Record employees_record Data Provider Class LoadParams Method

'Record employees_record Data Provider Class CheckUnique Method @14-CD0A30FD

    Public Function CheckUnique(ByVal ControlName As String, ByVal item As employees_recordItem) As Boolean
        Return True
    End Function
'End Record employees_record Data Provider Class CheckUnique Method

'Record employees_record Data Provider Class PrepareInsert Method @14-0E277F0A

    Protected Overrides Sub PrepareInsert()
'End Record employees_record Data Provider Class PrepareInsert Method

'Record employees_record Data Provider Class PrepareInsert Method tail @14-E31F8E2A
    End Sub
'End Record employees_record Data Provider Class PrepareInsert Method tail

'Record employees_record Data Provider Class Insert Method @14-39BD1FA3

    Public Function InsertItem(ByVal item As employees_recordItem) As Integer
'End Record employees_record Data Provider Class Insert Method

'Record employees_record Build insert @14-DE998929
        Insert.SqlQuery.Replace("{emp_name}",Insert.Dao.ToSql(item.emp_name.GetFormattedValue(""),FieldType._Text))
        Insert.SqlQuery.Replace("{LinkedID}",Insert.Dao.ToSql(item.LinkedID.GetFormattedValue(""),FieldType._Text))
        Dim result As Object = Nothing
        Dim E As Exception = Nothing
        Try
            result = ExecuteInsert()
        Catch ee As Exception
            E = ee
        Finally
'End Record employees_record Build insert

'Record employees_record AfterExecuteInsert @14-2FB4FB62
            If Not IsNothing(E) Then Throw E
        End Try
        Return CType(result, Integer)
    End Function
'End Record employees_record AfterExecuteInsert

'Record employees_record Data Provider Class PrepareUpdate Method @14-D72B5D1D

    Protected Overrides Sub PrepareUpdate()
        LoadParams()
        Update.Parameters = CommonParameters
'End Record employees_record Data Provider Class PrepareUpdate Method

'Record employees_record Data Provider Class PrepareUpdate Method tail @14-E31F8E2A
    End Sub
'End Record employees_record Data Provider Class PrepareUpdate Method tail

'Record employees_record Data Provider Class Update Method @14-25F1F619

    Public Function UpdateItem(ByVal item As employees_recordItem) As Integer
'End Record employees_record Data Provider Class Update Method

'Record employees_record BeforeBuildUpdate @14-01AE36EE
        Update.SqlQuery.Replace("{emp_name}",Update.Dao.ToSql(item.emp_name.GetFormattedValue(""),FieldType._Text))
        Update.SqlQuery.Replace("{LinkedID}",Update.Dao.ToSql(item.LinkedID.GetFormattedValue(""),FieldType._Text))
        Dim result As Object = Nothing
        Dim E As Exception = Nothing
        Try
            result = ExecuteUpdate()
        Catch ee As Exception
            E = ee
        Finally
'End Record employees_record BeforeBuildUpdate

'Record employees_record AfterExecuteUpdate @14-2FB4FB62
            If Not IsNothing(E) Then Throw E
        End Try
        Return CType(result, Integer)
    End Function
'End Record employees_record AfterExecuteUpdate

'Record employees_record Data Provider Class PrepareDelete Method @14-998024F7

    Protected Overrides Sub PrepareDelete()
        LoadParams()
        Delete.Parameters = CommonParameters
'End Record employees_record Data Provider Class PrepareDelete Method

'Record employees_record Data Provider Class PrepareDelete Method tail @14-E31F8E2A
    End Sub
'End Record employees_record Data Provider Class PrepareDelete Method tail

'Record employees_record Data Provider Class Delete Method @14-3393434D

    Public Function DeleteItem() As Integer
'End Record employees_record Data Provider Class Delete Method

'Record employees_record BeforeBuildDelete @14-19F34D29
        Dim result As Object = Nothing
        Dim E As Exception = Nothing
        Try
            result = ExecuteDelete()
        Catch ee As Exception
            E = ee
        Finally
'End Record employees_record BeforeBuildDelete

'Record employees_record BeforeBuildDelete @14-2FB4FB62
            If Not IsNothing(E) Then Throw E
        End Try
        Return CType(result, Integer)
    End Function
'End Record employees_record BeforeBuildDelete

'PrepareSelect Method @14-34AB3510

    Protected Overrides Sub PrepareSelect()
        LoadParams()
        Select_.Parameters = CommonParameters
    End Sub
'End PrepareSelect Method

'Record employees_record Data Provider Class GetResultSet Method @14-A061FBC2

    Public Sub FillItem(ByVal item As employees_recordItem, ByRef IsInsertMode As Boolean)
        Dim ReadNotAllowed As Boolean = IsInsertMode
        Dim E As Exception = Nothing
'End Record employees_record Data Provider Class GetResultSet Method

'Record employees_record BeforeBuildSelect @14-0FCCC126
        IsInsertMode = LoadParams()
        Dim dr As DataRowCollection = Nothing
        If Not IsInsertMode Then
'End Record employees_record BeforeBuildSelect

'Record employees_record BeforeExecuteSelect @14-EBD3678C
            Try
                dr = ExecuteSelect().Tables(0).Rows
            Catch ee As Exception
                E = ee
            Finally
'End Record employees_record BeforeExecuteSelect

'Record employees_record AfterExecuteSelect @14-F3AAD4A6
                If Not IsNothing(E) Then Throw E
        End Try
        End If
        If (Not IsInsertMode) And (Not ReadNotAllowed) Then
            If dr.Count <> 0 Then
                Dim i As Integer = 0
                item.emp_name.SetValue(dr(i)("emp_name"),"")
        Else
            IsInsertMode = True
            End If
        End If
        Dim ListBoxSource As DataRowCollection = Nothing
        Dim j As Integer
'End Record employees_record AfterExecuteSelect

'ListBox AvailableListBox Event BeforeBuildSelect. Action Custom Code @52-73254650
    
	Dim LinkedProject As String  = ""
	Dim Req As System.Web.HttpRequest  = System.Web.HttpContext.Current.Request


	'Populate multi-selectable project Listbox list
	if Not IsNothing(Req.QueryString("emp_id")) And Req.QueryString("emp_id") <> "" Then 

 		
	   	Dim Sel As SqlCommand = new SqlCommand("SELECT project_id FROM projects_employees WHERE emp_id =" & Req.QueryString("emp_id").ToString(), _
              Settings.IntranetDBDataAccessObject)
		
    	Dim ProjID As DataRowCollection  = Sel.Execute().Tables(0).Rows
     	if Not IsInsertMode Then

			Dim i As Integer
		    For i = 0  To ProjID.Count - 1
				
				If LinkedProject <> "" Then LinkedProject = LinkedProject & ","
     			LinkedProject = LinkedProject & ProjID(i)("project_id").ToString()
							
			Next i
						   
			'Modify AvailableListBox DataSource
			if LinkedProject <> "" Then
				
				DirectCast(AvailableListBoxDataCommand,TableCommand).Where = "project_id NOT IN (" & LinkedProject & ")"
				DirectCast(AvailableListBoxDataCommand,TableCommand).Operation = "AND"
							
			End If

		End If
       
     End If 	
'End ListBox AvailableListBox Event BeforeBuildSelect. Action Custom Code

'ListBox AvailableListBox BeforeExecuteSelect @46-2F44BF26
        Try
            ListBoxSource=AvailableListBoxDataCommand.Execute().Tables(0).Rows
        Catch ee as Exception 
            E=ee
        Finally
'End ListBox AvailableListBox BeforeExecuteSelect

'ListBox AvailableListBox AfterExecuteSelect @46-2B80E442
            If Not IsNothing(E) Then Throw E
        End Try
        For j=0 To ListBoxSource.Count-1 
            Dim Key As String = (New IntegerField("", ListBoxSource(j)("project_id"))).GetFormattedValue("")
            Dim Val As Object = ListBoxSource(j)("project_name")
            item.AvailableListBoxItems.Add(Key, Val)
        Next
'End ListBox AvailableListBox AfterExecuteSelect

'ListBox LinkedListBox Initialize Data Source @44-14B3480E
        If IsNothing(Urlemp_id) Then
            LinkedListBoxDataCommand.Parameters.Add("emp_id61","")
        Else
            LinkedListBoxDataCommand.Parameters.Add("emp_id61","emp_id = " & LinkedListBoxDataCommand.Dao.ToSql(Urlemp_id.GetFormattedValue(""),FieldType._Integer))
        End If
'End ListBox LinkedListBox Initialize Data Source

'ListBox LinkedListBox BeforeExecuteSelect @44-37881494
        Try
            ListBoxSource=LinkedListBoxDataCommand.Execute().Tables(0).Rows
        Catch ee as Exception 
            E=ee
        Finally
'End ListBox LinkedListBox BeforeExecuteSelect

'ListBox LinkedListBox AfterExecuteSelect @44-E09F0A2C
            If Not IsNothing(E) Then Throw E
        End Try
        For j=0 To ListBoxSource.Count-1 
            Dim Key As String = (New IntegerField("", ListBoxSource(j)("project_id"))).GetFormattedValue("")
            Dim Val As Object = ListBoxSource(j)("project_name")
            item.LinkedListBoxItems.Add(Key, Val)
        Next
'End ListBox LinkedListBox AfterExecuteSelect

'Record employees_record AfterExecuteSelect tail @14-E31F8E2A
    End Sub
'End Record employees_record AfterExecuteSelect tail

'Record employees_record Data Provider Class @14-A61BA892
End Class

'End Record employees_record Data Provider Class

'Page Data Provider Tail @1-5EA2E2E0
End Namespace
'End Page Data Provider Tail

