//Using Statements @1-8833E6D6
using System;
using System.Collections;
using System.Collections.Specialized;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Text.RegularExpressions;
using System.Globalization;
using CCSExample_CSharp;
using CCSExample_CSharp.Data;
using CCSExample_CSharp.Configuration;
using CCSExample_CSharp.Controls;

namespace CCSExample_CSharp.MasterDetail.MasterDetail
{

//End Using Statements

//Forms Definition @1-040ED37C
public class MasterDetailPage : System.Web.UI.Page
{
//End Forms Definition

//Forms Objects @1-1C62BD28
    protected System.Web.UI.WebControls.Repeater employees_gridRepeater;
    protected employees_gridDataProvider employees_gridData;
    protected employees_recordDataProvider employees_recordData;
    protected HtmlInputButton employees_recordButton_Insert;
    protected HtmlInputButton employees_recordButton_Update;
    protected HtmlInputButton employees_recordButton_Delete;
    protected HtmlInputButton employees_recordButton_Cancel;
    protected System.Web.UI.WebControls.PlaceHolder employees_recordError;
    protected System.Web.UI.HtmlControls.HtmlTable employees_recordHolder;
    protected System.Web.UI.WebControls.Label employees_recordErrorLabel;
    protected bool employees_recordInsertAllowed=true;
    protected bool employees_recordUpdateAllowed=true;
    protected bool employees_recordDeleteAllowed=true;
    protected NameValueCollection employees_recordErrors=new NameValueCollection();
    protected System.Web.UI.WebControls.TextBox employees_recordemp_name;
    protected System.Web.UI.WebControls.TextBox employees_recordtitle;
    protected System.Web.UI.HtmlControls.HtmlSelect employees_recorddepartment_id;
    protected System.Web.UI.WebControls.Repeater projects_employeesRepeater;
    protected projects_employeesDataProvider projects_employeesData;
    protected NameValueCollection projects_employeesErrors=new NameValueCollection();
    protected System.Web.UI.HtmlControls.HtmlAnchor Link1;
//End Forms Objects

//Page_Load Event @1-55207E05
private void Page_Load(object sender, System.EventArgs e)
{
//End Page_Load Event

//Page_Load Event BeforeIsPostBack @1-0DB1047F
    if (!IsPostBack)
    {
            PageDataProvider PageData=new PageDataProvider();
            PageItem item=PageItem.CreateFromHttpRequest();
            item.Link1Href = "MasterDetail_desc.aspx";
            PageData.FillItem(item);
            Link1.InnerText += item.Link1.GetFormattedValue().Replace("\r","").Replace("\n","<br>");
            Link1.HRef += item.Link1Href+item.Link1HrefParameters.ToString("None","", ViewState);
            employees_gridBind();
            employees_recordShow();
            projects_employeesBind();
    }
//End Page_Load Event BeforeIsPostBack

//Page_Load Event tail @1-FCB6E20C
}
//End Page_Load Event tail

//Page_Unload Event @1-72102C7C
private void Page_Unload(object sender, System.EventArgs e)
{
//End Page_Unload Event

//Page_Unload Event tail @1-FCB6E20C
}
//End Page_Unload Event tail

//Grid employees_grid Bind @23-29B77A58
    protected void employees_gridBind()
    {
        int PagesCount;
        int FooterIndex;
        if (!IsPostBack)
        {
            string Param;
            int PageSize;
            ViewState["employees_gridSortField"] = employees_gridDataProvider.SortFields.Default;
            PageSize = 10;
            ViewState["employees_gridPageNumber"] = 1;
            Param = Request.QueryString["employees_gridOrder"];
            if (Param != null && Param.Length > 0)
                try{
                    employees_gridDataProvider.SortFields SortField = 0;
                    ViewState["employees_gridSortField"] = Enum.Parse(SortField.GetType(), Param);
                }catch {}
            Param = Request.QueryString["employees_gridDir"];
            if (Param == null || Param.Length == 0 || Param.ToLower() == "desc")
                ViewState["employees_gridSortDir"] = SortDirections.Desc;
            else
                ViewState["employees_gridSortDir"] = SortDirections.Asc;
            Param = Request.QueryString["employees_gridPage"];
            int PageNumber;
            if (Param != null && Param.Length > 0)
                try
                {
                    PageNumber = Int32.Parse(Param);
                    if (PageNumber > 0) ViewState["employees_gridPageNumber"] = PageNumber;
                }
                catch {}
            Param = Request.QueryString["employees_gridPageSize"];
            if (Param != null && Param.Length > 0)
                try
                {
                    PageSize = Int32.Parse(Param);
                    if (PageSize <= 0) PageSize = 10;
                }
                catch {}
            if (PageSize > 100)
                PageSize = 100;
            ViewState["employees_gridPageSize"] = PageSize;
        }
//End Grid employees_grid Bind

//Grid Form employees_grid BeforeShow tail @23-B8ACC75F
        employees_gridParameters();
        employees_gridData.SortField = (employees_gridDataProvider.SortFields)ViewState["employees_gridSortField"];
        employees_gridData.SortDir = (SortDirections)ViewState["employees_gridSortDir"];
        employees_gridData.PageNumber = (int)ViewState["employees_gridPageNumber"];
        employees_gridData.RecordsPerPage = (int)ViewState["employees_gridPageSize"];
        employees_gridRepeater.DataSource = employees_gridData.GetResultSet(out PagesCount);
        ViewState["employees_gridPagesCount"] = PagesCount;
        employees_gridRepeater.DataBind();
        FooterIndex = employees_gridRepeater.Controls.Count - 1;
        if (PagesCount == 0)
        {
            employees_gridRepeater.Controls[FooterIndex].FindControl("NoRecords").Visible = true;
        }
        employees_gridItem item=new employees_gridItem();
        System.Web.UI.HtmlControls.HtmlAnchor employees_gridLink1 = (System.Web.UI.HtmlControls.HtmlAnchor)employees_gridRepeater.Controls[FooterIndex].FindControl("employees_gridLink1");

        item.Link1Href = "MasterDetail.aspx?";

        employees_gridLink1.InnerText += item.Link1.GetFormattedValue().Replace("\r","").Replace("\n","<br>");
        employees_gridLink1.HRef += item.Link1Href+item.Link1HrefParameters.ToString("GET","emp_id", ViewState);
        CCSExample_CSharp.Controls.Navigator NavigatorNavigator = (CCSExample_CSharp.Controls.Navigator)employees_gridRepeater.Controls[FooterIndex].FindControl("NavigatorNavigator");
        NavigatorNavigator.MaxPage=PagesCount;
        NavigatorNavigator.PageNumber=employees_gridData.PageNumber;
        NavigatorNavigator.DataBind();
//End Grid Form employees_grid BeforeShow tail

//Grid employees_grid Bind tail @23-FCB6E20C
    }
//End Grid employees_grid Bind tail

//Grid employees_grid Table Parameters @23-BAAE69FD
    protected void employees_gridParameters()
    {
        try{
        }catch{
            ControlCollection ParentControls=employees_gridRepeater.Parent.Controls;
            int RepeaterIndex=ParentControls.IndexOf(employees_gridRepeater);
            ParentControls.RemoveAt(RepeaterIndex);
            Literal ErrorMessage=new Literal();
            ErrorMessage.Text="Error in Grid employees_grid: Invalid parameter";
            ParentControls.AddAt(RepeaterIndex,ErrorMessage);
        }
	}
	
//End Grid employees_grid Table Parameters

//Grid employees_grid ItemDataBound event @23-F356F1EE
    protected void employees_gridItemDataBound(Object Sender, RepeaterItemEventArgs e)
    {
        employees_gridItem DataItem=(employees_gridItem)e.Item.DataItem;
        if (e.Item.ItemType == ListItemType.Item || e.Item.ItemType == ListItemType.AlternatingItem) {
            System.Web.UI.HtmlControls.HtmlAnchor employees_gridemp_name = (System.Web.UI.HtmlControls.HtmlAnchor)(e.Item.FindControl("employees_gridemp_name"));
            DataItem.emp_nameHref = "MasterDetail.aspx?";
            employees_gridemp_name.HRef += DataItem.emp_nameHref + DataItem.emp_nameHrefParameters.ToString("GET","", ViewState);
        }
//End Grid employees_grid ItemDataBound event

//Grid employees_grid ItemDataBound event tail @23-FCB6E20C
    }
//End Grid employees_grid ItemDataBound event tail

//Grid employees_grid ItemCommand event @23-7EECA0CF
    protected void employees_gridItemCommand(Object Sender, RepeaterCommandEventArgs e)
    {
        int FooterIndex = employees_gridRepeater.Controls.Count - 1;
        bool BindAllowed = false;
        if(e.CommandName=="Sort"){
            if(((SorterState)e.CommandArgument)==SorterState.None)
                if((SortDirections)ViewState["employees_gridSortDir"]==SortDirections.Asc&&ViewState["employees_gridSortField"].ToString()==((CCSExample_CSharp.Controls.Sorter)e.CommandSource).Field)
                    ViewState["employees_gridSortDir"]=SortDirections.Desc;
                else
                    ViewState["employees_gridSortDir"]=SortDirections.Asc;
            else
                ViewState["employees_gridSortDir"]=(int)(((CCSExample_CSharp.Controls.Sorter)e.CommandSource).State);
            ViewState["employees_gridSortField"]=Enum.Parse(typeof(employees_gridDataProvider.SortFields),((CCSExample_CSharp.Controls.Sorter)e.CommandSource).Field);
            ViewState["employees_gridPageNumber"] = 1;
            BindAllowed = true;
        }
        if(e.CommandName=="Navigate"){
            ViewState["employees_gridPageNumber"] = Int32.Parse(e.CommandArgument.ToString());
            BindAllowed = true;
        }
        if (BindAllowed)
            employees_gridBind();
    }
//End Grid employees_grid ItemCommand event

//Record Form employees_record Parameters @2-073CF455
    protected void employees_recordParameters()
    {
        try{
            employees_recordData.Urlemp_id= IntegerParameter.GetParam(Request.QueryString["emp_id"]);
        }catch(Exception e){
            employees_recordErrors.Add("Parameters","Form parameters: " + e.Message);
        }
    }
//End Record Form employees_record Parameters

//Record Form employees_record Show method @2-D0C3AD48
    protected void employees_recordShow()
    {
        bool AllowRead = true,AllowInsert = true,AllowUpdate = true,AllowDelete = true;
        employees_recordItem item=employees_recordItem.CreateFromHttpRequest();
        bool IsInsertMode=!AllowRead;
        employees_recordErrors.Add(item.errors);
//End Record Form employees_record Show method

//Grid Form employees_record BeforeShow tail @2-F12C79ED
        employees_recordParameters();
        employees_recordData.FillItem(item,ref IsInsertMode);
        employees_recordButton_Insert.Visible=IsInsertMode&&AllowInsert;
        employees_recordButton_Update.Visible=!IsInsertMode&&AllowUpdate;
        employees_recordButton_Delete.Visible=!IsInsertMode&&AllowDelete;
        employees_recordemp_name.Text=item.emp_name.GetFormattedValue();
        employees_recordtitle.Text=item.title.GetFormattedValue();
        item.department_idItems.SetSelection(item.department_id.Value);
        employees_recorddepartment_id.SelectedIndex = -1;
        item.department_idItems.CopyTo(employees_recorddepartment_id.Items);
//End Grid Form employees_record BeforeShow tail

//Record employees_record Event BeforeShow. Action Custom Code @42-2A29BDB7

	//Hide the Editable grid if record is in the insert mode
  	if(IsInsertMode){
		projects_employeesRepeater.Visible = false;
  	}
//End Record employees_record Event BeforeShow. Action Custom Code

//Record Form employees_record Show method tail @2-5C2EAD42
        if(employees_recordErrors.Count>0)
            employees_recordShowErrors();
    }
//End Record Form employees_record Show method tail

//Record Form employees_record LoadItemFromRequest method @2-6D960B62
    protected void employees_recordLoadItemFromRequest(employees_recordItem item, bool EnableValidation)
    {
        item.emp_name.SetValue(employees_recordemp_name.Text);
        item.title.SetValue(employees_recordtitle.Text);
        try{
        item.department_id.SetValue(employees_recorddepartment_id.Value);
        }catch(ArgumentException){
            employees_recordErrors.Add("department_id","The value in field Department Id is not valid.");}
        if(EnableValidation)
            item.Validate(employees_recordData);
        employees_recordErrors.Add(item.errors);
    }
//End Record Form employees_record LoadItemFromRequest method

//Record Form employees_record GetRedirectUrl method @2-A0C6D4C3
    protected string Getemployees_recordRedirectUrl(string redirectString ,string removeList)
    {
        string Params="";
        string[] List;

        if(removeList=="")
            List=new string[1];
        else
            List=(removeList).ToLower().Split(new Char[] {';'});

        if(redirectString == "") redirectString = "MasterDetail.aspx";
        for(int i = 0; i < Request.QueryString.Count;i ++)
            if(Array.IndexOf(List,Request.QueryString.AllKeys[i].ToLower()) < 0)
                Params += Request.QueryString.AllKeys[i] + "=" + Server.UrlEncode(Request.QueryString[i]) + "&";
        Params = Params.TrimEnd(new Char[]{'&'});
        return redirectString + "?" + Params;
    }

//End Record Form employees_record GetRedirectUrl method

//Record Form employees_record ShowErrors method @2-DEEF6001
    protected void employees_recordShowErrors()
    {
        string DefaultMessage="";
        for(int i=0;i<employees_recordErrors.Count;i++)
        switch(employees_recordErrors.AllKeys[i])
        {
            default:
                DefaultMessage+=employees_recordErrors[i]+"<br>";
                break;
        }
        employees_recordError.Visible = true;
        employees_recordErrorLabel.Text = DefaultMessage;
    }
//End Record Form employees_record ShowErrors method

//Record Form employees_record Insert Operation @2-490C11E8
    protected void employees_record_Insert(object sender, System.EventArgs e)
    {
        bool ExecuteFlag = true;
        bool ErrorFlag = false;
        employees_recordItem item=new employees_recordItem();
        string RedirectUrl = Getemployees_recordRedirectUrl("", "");
//End Record Form employees_record Insert Operation

//Record Form employees_record BeforeInsert tail @2-524AC8F8
    employees_recordParameters();
    employees_recordLoadItemFromRequest(item, true);
    if(employees_recordInsertAllowed){
    ErrorFlag=(employees_recordErrors.Count>0);
        if(ExecuteFlag&&!ErrorFlag)
            try
            {
                employees_recordData.InsertItem(item);
            }
            catch (Exception ex)
            {
                employees_recordErrors.Add("DataProvider",ex.Message);
                ErrorFlag=true;
            }
//End Record Form employees_record BeforeInsert tail

//Record employees_record Event AfterInsert. Action Custom Code @30-2A29BDB7

	// Select last insert emp_id 
	// Redirect user to this page with this parameter

	string LastID = (new TextField("",Settings.IntranetDBDataAccessObject.ExecuteScalar("SELECT max(emp_id) FROM employees WHERE emp_name=" + "'" + employees_recordemp_name.Text + "'" ))).GetFormattedValue("");
	if(RedirectUrl.IndexOf("?")==-1) RedirectUrl +="?emp_id=" + LastID;
	else RedirectUrl +="&emp_id=" + LastID;
		
	    
//End Record employees_record Event AfterInsert. Action Custom Code

//Record Form employees_record AfterInsert tail  @2-4E875F1A
        }
        if(ErrorFlag)
            employees_recordShowErrors();
        else
            Response.Redirect(RedirectUrl);
    }
//End Record Form employees_record AfterInsert tail 

//Record Form employees_record Update Operation @2-04C665F2
    protected void employees_record_Update(object sender, System.EventArgs e)
    {
        employees_recordItem item=new employees_recordItem();
        item.IsNew = false;
        bool ExecuteFlag = true;
        bool ErrorFlag = false;
        string RedirectUrl = Getemployees_recordRedirectUrl("", "");
//End Record Form employees_record Update Operation

//Record Form employees_record Before Update tail @2-E5FAE478
        employees_recordParameters();
        employees_recordLoadItemFromRequest(item, true);
        if(employees_recordUpdateAllowed){
        ErrorFlag=(employees_recordErrors.Count>0);
        if(ExecuteFlag&&!ErrorFlag)
            try
            {
                employees_recordData.UpdateItem(item);
            }
            catch (Exception ex)
            {
                employees_recordErrors.Add("DataProvider",ex.Message);
                ErrorFlag=true;
            }
//End Record Form employees_record Before Update tail

//Record Form employees_record Update Operation tail @2-4E875F1A
        }
        if(ErrorFlag)
            employees_recordShowErrors();
        else
            Response.Redirect(RedirectUrl);
    }
//End Record Form employees_record Update Operation tail

//Record Form employees_record Delete Operation @2-009E3FF8
    protected void employees_record_Delete(object sender,System.EventArgs e)
    {
        bool ExecuteFlag = true;
        bool ErrorFlag = false;
        string RedirectUrl = Getemployees_recordRedirectUrl("", "");
        employees_recordItem item=new employees_recordItem();
        item.IsNew = false;
        item.IsDeleted = true;
//End Record Form employees_record Delete Operation

//Record employees_record Event BeforeDelete. Action Custom Code @45-2A29BDB7
    
	if(Request.QueryString["emp_id"]!= null && Request.QueryString["emp_id"] != ""){

		DataAccessObject NewDao = Settings.IntranetDBDataAccessObject;
  		string Sql = "Delete from projects_employees where emp_id=" + NewDao.ToSql(Request.QueryString["emp_id"],FieldType.Integer);
		NewDao.RunSql(Sql);
    }
//End Record employees_record Event BeforeDelete. Action Custom Code

//Record Form BeforeDelete tail @2-4A74C200
        employees_recordParameters();
        employees_recordLoadItemFromRequest(item, false);
        if(employees_recordDeleteAllowed){
        ErrorFlag = (employees_recordErrors.Count > 0);
        if(ExecuteFlag && !ErrorFlag)
            try
            {
                employees_recordData.DeleteItem();
            }
            catch (Exception ex)
            {
                employees_recordErrors.Add("DataProvider", ex.Message);
                ErrorFlag = true;
            }
//End Record Form BeforeDelete tail

//Record Form AfterDelete tail @2-4E875F1A
        }
        if(ErrorFlag)
            employees_recordShowErrors();
        else
            Response.Redirect(RedirectUrl);
    }
//End Record Form AfterDelete tail

//Record Form employees_record Cancel Operation @2-1AD690A1
    protected void employees_record_Cancel(object sender,System.EventArgs e)
    {
        employees_recordItem item=new employees_recordItem();
        string RedirectUrl = Getemployees_recordRedirectUrl("", "");
        employees_recordLoadItemFromRequest(item, false);
//End Record Form employees_record Cancel Operation

//Record Form employees_record Cancel Operation tail @2-AE897FBA
        Response.Redirect(RedirectUrl);
    }
//End Record Form employees_record Cancel Operation tail

//EditableGrid projects_employees Bind @31-54259DD5
    protected void projects_employeesBind()
    {
        int PagesCount;
        int FooterIndex;
        if (!IsPostBack)
        {
            string Param;
            int PageSize;
            ViewState["projects_employeesSortField"] = projects_employeesDataProvider.SortFields.Default;
            PageSize = 20;
            ViewState["projects_employeesPageNumber"] = 1;
            Param = Request.QueryString["projects_employeesOrder"];
            if (Param != null && Param.Length > 0)
                try{
                    projects_employeesDataProvider.SortFields SortField = 0;
                    ViewState["projects_employeesSortField"] = Enum.Parse(SortField.GetType(), Param);
                }catch {}
            Param = Request.QueryString["projects_employeesDir"];
            if (Param == null || Param.Length == 0 || Param.ToLower() == "desc")
                ViewState["projects_employeesSortDir"] = SortDirections.Desc;
            else
                ViewState["projects_employeesSortDir"] = SortDirections.Asc;
            Param = Request.QueryString["projects_employeesPage"];
            int PageNumber;
            if (Param != null && Param.Length > 0)
                try
                {
                    PageNumber = Int32.Parse(Param);
                    if (PageNumber <= 0) ViewState["projects_employeesPageNumber"] = 1;
                }
                catch {}
            Param = Request.QueryString["projects_employeesPageSize"];
            if (Param != null && Param.Length > 0)
                try
                {
                    PageSize = Int32.Parse(Param);
                    if (PageSize <= 0) PageSize = 20;
                }
                catch {}
            ViewState["projects_employeesPageSize"] = PageSize;
        }
//End EditableGrid projects_employees Bind

//Grid Form projects_employees BeforeShow tail @31-CBEE1261
        projects_employeesParameters();
        projects_employeesData.SortField = (projects_employeesDataProvider.SortFields)ViewState["projects_employeesSortField"];
        projects_employeesData.SortDir = (SortDirections)ViewState["projects_employeesSortDir"];
        projects_employeesData.PageNumber = (int)ViewState["projects_employeesPageNumber"];
        projects_employeesData.RecordsPerPage = (int)ViewState["projects_employeesPageSize"];
        object dataSource = projects_employeesData.GetResultSet(out PagesCount);
        projects_employeesRepeater.DataSource = projects_employeesData.GetResultSet(out PagesCount);
        ViewState["projects_employeesPagesCount"] = PagesCount;
        ViewState["projects_employeesFormState"] = new Hashtable();
        projects_employeesRepeater.DataBind();
        FooterIndex = projects_employeesRepeater.Controls.Count - 1;
        projects_employeesItem item=new projects_employeesItem();


        if (PagesCount == 0)
        {
            projects_employeesRepeater.Controls[FooterIndex].FindControl("NoRecords").Visible = true;
        }
        if (projects_employeesErrors.Count > 0)
        {
            System.Web.UI.WebControls.Label Error = (System.Web.UI.WebControls.Label)(projects_employeesRepeater.Controls[0].FindControl("ErrorLabel"));
            PlaceHolder RowError = (System.Web.UI.WebControls.PlaceHolder)(projects_employeesRepeater.Controls[0].FindControl("projects_employeesError"));
            RowError.Visible = true;
            foreach(string msg in projects_employeesErrors)
                Error.Text += projects_employeesErrors[msg] + "<br/>";
        }
//End Grid Form projects_employees BeforeShow tail

//EditableGrid projects_employees Bind tail @31-A5BAC156
        projects_employeesShowErrors(new ArrayList((ICollection)projects_employeesRepeater.DataSource), projects_employeesRepeater.Items);
    }
//End EditableGrid projects_employees Bind tail

//EditableGrid projects_employees Table Parameters @31-D03E902E
    protected void projects_employeesParameters()
    {
        try{
            projects_employeesData.Urlemp_id= IntegerParameter.GetParam(Request.QueryString["emp_id"], (object)(-1));
        }catch{
            ControlCollection ParentControls=projects_employeesRepeater.Parent.Controls;
            int RepeaterIndex=ParentControls.IndexOf(projects_employeesRepeater);
            ParentControls.RemoveAt(RepeaterIndex);
            Literal ErrorMessage=new Literal();
            ErrorMessage.Text="Error in Grid projects_employees: Invalid parameter";
            ParentControls.AddAt(RepeaterIndex,ErrorMessage);
        }
	}
	
//End EditableGrid projects_employees Table Parameters

//EditableGrid projects_employees ItemDataBound event @31-55D5A14E
    protected void projects_employeesItemDataBound(Object Sender, RepeaterItemEventArgs e)
    {
        projects_employeesItem DataItem=(projects_employeesItem)e.Item.DataItem;
        if (e.Item.ItemType == ListItemType.Item || e.Item.ItemType == ListItemType.AlternatingItem) {
            DataItem.RowId = e.Item.ItemIndex;
            Hashtable formState = (Hashtable)ViewState["projects_employeesFormState"];
            formState.Add("project_idField:" + e.Item.ItemIndex.ToString(),DataItem.project_idField.Value);
            formState.Add("emp_idField:" + e.Item.ItemIndex.ToString(),DataItem.emp_idField.Value);
            System.Web.UI.HtmlControls.HtmlSelect projects_employeesproject_id = (System.Web.UI.HtmlControls.HtmlSelect)(e.Item.FindControl("projects_employeesproject_id"));
            DataItem.project_idItems.SetSelection(DataItem.project_id.Value);
            projects_employeesproject_id.SelectedIndex = -1;
            DataItem.project_idItems.CopyTo(projects_employeesproject_id.Items);
            System.Web.UI.WebControls.CheckBox projects_employeesDelete1 = (System.Web.UI.WebControls.CheckBox)(e.Item.FindControl("projects_employeesDelete1"));
            if(DataItem.Delete1CheckedValue.Value.Equals(DataItem.Delete1.Value))
                projects_employeesDelete1.Checked = true;
        }
//End EditableGrid projects_employees ItemDataBound event

//EditableGrid projects_employees ItemDataBound event tail @31-FCB6E20C
    }
//End EditableGrid projects_employees ItemDataBound event tail

//EditableGrid projects_employees GetRedirectUrl method @31-2CE4EF7F
    protected string Getprojects_employeesRedirectUrl(string redirectString ,string removeList)
    {
        string Params="";
        string[] List;

        if(removeList=="")
            List=new string[1];
        else
            List=removeList.Split(new Char[] {';'});

        if(redirectString == "") redirectString = Request.Url.AbsolutePath;
        for(int i = 0; i < Request.QueryString.Count;i ++)
            if(Array.IndexOf(List,Request.QueryString.AllKeys[i]) < 0)
                Params += Request.QueryString.AllKeys[i] + "=" + Server.UrlEncode(Request.QueryString[i]) + "&";
        Params = Params.TrimEnd(new Char[]{'&'});
        return redirectString + "?" + Params;
    }
    protected string Getprojects_employeesRedirectUrl(string redirectString)
    {
        return Getprojects_employeesRedirectUrl(redirectString ,"");
    }
//End EditableGrid projects_employees GetRedirectUrl method

//EditableGrid projects_employees ShowErrors method @31-A5A4936F
    protected bool projects_employeesShowErrors(ArrayList items, RepeaterItemCollection col)
    {
        bool result = true;
        foreach(projects_employeesItem item in items)
        {
            if(item.IsUpdated) col[item.RowId].Visible = false;
            if(item.errors.Count > 0){
                result = false;
                string DefaultMessage="";
                for(int j = 0; j < item.errors.Count; j ++)
                switch (item.errors.AllKeys[j])
                {
                    default:
                        DefaultMessage += item.errors[j] + "<br>";
                        break;
                }
                System.Web.UI.WebControls.Label Error = (System.Web.UI.WebControls.Label)(col[item.RowId].FindControl("ErrorLabel"));
                col[item.RowId].FindControl("RowError").Visible = true;
                Error.Text = DefaultMessage;
            }
        }
        return result;
    }
//End EditableGrid projects_employees ShowErrors method

//EditableGrid projects_employees ItemCommand event @31-AFC8844C
    protected void projects_employeesItemCommand(Object Sender, RepeaterCommandEventArgs e)
    {
        int FooterIndex = projects_employeesRepeater.Controls.Count - 1;
        bool BindAllowed = false;
//End EditableGrid projects_employees ItemCommand event

//EditableGrid Form projects_employees ItemCommand event tail @31-A9E48C03
        if(e.CommandName=="Sort"){
            if(((SorterState)e.CommandArgument)==SorterState.None)
                if((SortDirections)ViewState["projects_employeesSortDir"]==SortDirections.Asc&&ViewState["projects_employeesSortField"].ToString()==((CCSExample_CSharp.Controls.Sorter)e.CommandSource).Field)
                    ViewState["projects_employeesSortDir"]=SortDirections.Desc;
                else
                    ViewState["projects_employeesSortDir"]=SortDirections.Asc;
            else
                ViewState["projects_employeesSortDir"]=(int)(((CCSExample_CSharp.Controls.Sorter)e.CommandSource).State);
            ViewState["projects_employeesSortField"]=Enum.Parse(typeof(projects_employeesDataProvider.SortFields),((CCSExample_CSharp.Controls.Sorter)e.CommandSource).Field);
            ViewState["projects_employeesPageNumber"] = 1;
            BindAllowed = true;
        }

        if(e.CommandName=="Navigate"){
            ViewState["projects_employeesPageNumber"] = Int32.Parse(e.CommandArgument.ToString());
            BindAllowed = true;
        }

        if(e.CommandName=="Submit"){
            BindAllowed = true;
            RepeaterItemCollection col=projects_employeesRepeater.Items;
            ArrayList items=new ArrayList();
            Hashtable formState = (Hashtable)ViewState["projects_employeesFormState"];
            string RedirectUrl = Getprojects_employeesRedirectUrl("");
            projects_employeesParameters();
            for(int i=0;i<col.Count;i++)
                if(col[i].ItemType == ListItemType.Item || col[i].ItemType == ListItemType.AlternatingItem){
                    System.Web.UI.HtmlControls.HtmlInputHidden projects_employeesemp_id = (System.Web.UI.HtmlControls.HtmlInputHidden)(col[i].FindControl("projects_employeesemp_id"));
                    System.Web.UI.HtmlControls.HtmlSelect projects_employeesproject_id = (System.Web.UI.HtmlControls.HtmlSelect)(col[i].FindControl("projects_employeesproject_id"));
                    System.Web.UI.WebControls.TextBox projects_employeespercent_allocation = (System.Web.UI.WebControls.TextBox)(col[i].FindControl("projects_employeespercent_allocation"));
                    System.Web.UI.WebControls.CheckBox projects_employeesDelete1 = (System.Web.UI.WebControls.CheckBox)(col[i].FindControl("projects_employeesDelete1"));
                    col[i].FindControl("RowError").Visible = false;
                    projects_employeesItem item = new projects_employeesItem();
                    item.RowId = col[i].ItemIndex;
                    item.IsUpdated = !col[i].Visible;
                    item.project_idField.Value = formState["project_idField:" + col[i].ItemIndex.ToString()];
                    item.emp_idField.Value = formState["emp_idField:" + col[i].ItemIndex.ToString()];
                    item.IsDeleted = projects_employeesDelete1.Checked;
                    try{
                    item.emp_id.SetValue(projects_employeesemp_id.Value);
                    }catch(ArgumentException){
                        item.errors.Add("emp_id","The value in field emp_id is not valid.");}
                    try{
                    item.project_id.SetValue(projects_employeesproject_id.Value);
                    }catch(ArgumentException){
                        item.errors.Add("project_id","The value in field project_id is not valid.");}
                    try{
                    item.percent_allocation.SetValue(projects_employeespercent_allocation.Text);
                    }catch(ArgumentException){
                        item.errors.Add("percent_allocation","The value in field percent allocation is not valid.");}
                    items.Add(item);

                    if(!item.IsEmptyItem && !item.IsDeleted) BindAllowed = item.Validate(projects_employeesData) && BindAllowed;
            }

//End EditableGrid Form projects_employees ItemCommand event tail

//EditableGrid projects_employees Event BeforeSubmit. Action Custom Code @47-2A29BDB7
    	
	NameValueCollection	temp = new NameValueCollection();
	for(int j = 0; j < items.Count; j++){

		projects_employeesItem myitem = (projects_employeesItem)items[j];
		if(myitem.project_id.Value==null){
			temp.Add("e" + j,"");
		}else{
			temp.Add(myitem.project_id.GetFormattedValue(),"");
		}
		if(temp.Count < j + 1){
		 
			myitem.errors.Add("project_id","A project cannot be selected twice");
			temp.Add("separator","separator");
			BindAllowed = false;
		}
	}
//End EditableGrid projects_employees Event BeforeSubmit. Action Custom Code

//EditableGrid projects_employees Update @31-EE9D2041
        if (BindAllowed)
            try
            {
                projects_employeesData.Update(items);
                if (projects_employeesShowErrors(items, col))
                    Response.Redirect(RedirectUrl);
                else
                    BindAllowed = false;
            }
            catch (Exception ex)
            {
                System.Web.UI.WebControls.Label Error = (System.Web.UI.WebControls.Label)(col[0].FindControl("ErrorLabel"));
                PlaceHolder RowError = (System.Web.UI.WebControls.PlaceHolder)(col[0].FindControl("projects_employeesError"));
                RowError.Visible = true;
                Error.Text = "DataProvider:" + ex.Message;
                BindAllowed=false;
            }
//End EditableGrid projects_employees Update

//EditableGrid projects_employees AfterSubmit @31-165258D4
        else
            projects_employeesShowErrors(items, col);
        }
        if (BindAllowed)
            projects_employeesBind();
    }
//End EditableGrid projects_employees AfterSubmit

//OnInit Event @1-B587BDCA
    #region Web Form Designer generated code
    override protected void OnInit(EventArgs e)
    {
        //
        //CODEGEN: This call is required by the ASP.NET Web Form Designer.
        //
        InitializeComponent();
        this.Load += new System.EventHandler(this.Page_Load);
        this.Unload += new System.EventHandler(this.Page_Unload);
        employees_gridData = new employees_gridDataProvider();
        employees_recordData = new employees_recordDataProvider();
        projects_employeesData = new projects_employeesDataProvider();
        base.OnInit(e);
//End OnInit Event

//OnInit Event tail @1-FCB6E20C
    }
//End OnInit Event tail

//InitializeComponent Event @1-722FC1EE
    /// <summary>
    /// Required method for Designer support - do not modify
    /// the contents of this method with the code editor.
    /// </summary>
    private void InitializeComponent()
    {
    }
    #endregion
//End InitializeComponent Event

//Page class tail @1-F5FC18C5
}
}
//End Page class tail

