'Using Statements @1-A4903BEE
Imports System
Imports System.Collections
Imports System.Collections.Specialized
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Web
Imports System.Web.SessionState
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports System.Web.UI.HtmlControls
Imports System.Text.RegularExpressions
Imports System.Globalization
Imports CCSExamplePack
Imports CCSExamplePack.Data
Imports CCSExamplePack.Configuration
Imports CCSExamplePack.Controls
Namespace MasterDetail.MasterDetail
'End Using Statements

'Forms Definition @1-F90A88FA
Public Class [MasterDetailPage]
Inherits System.Web.UI.Page
'End Forms Definition

'Forms Objects @1-A2F2F24B
    Protected employees_gridRepeater As  System.Web.UI.WebControls.Repeater
    Protected employees_gridData As employees_gridDataProvider
    Protected employees_recordData As employees_recordDataProvider
    Protected employees_recordButton_Insert As HtmlInputButton 
    Protected employees_recordButton_Update As HtmlInputButton 
    Protected employees_recordButton_Delete As HtmlInputButton 
    Protected employees_recordButton_Cancel As HtmlInputButton 
    Protected employees_recordError As System.Web.UI.WebControls.PlaceHolder
    Protected employees_recordHolder As System.Web.UI.HtmlControls.HtmlTable
    Protected employees_recordErrorLabel As System.Web.UI.WebControls.Label
    Protected employees_recordInsertAllowed As Boolean = True
    Protected employees_recordUpdateAllowed As Boolean = True
    Protected employees_recordDeleteAllowed As Boolean = True
    Protected employees_recordErrors As NameValueCollection = New NameValueCollection()
    Protected employees_recordemp_name As System.Web.UI.WebControls.TextBox
    Protected employees_recordtitle As System.Web.UI.WebControls.TextBox
    Protected employees_recorddepartment_id As System.Web.UI.HtmlControls.HtmlSelect
    Protected projects_employeesRepeater As System.Web.UI.WebControls.Repeater
    Protected projects_employeesData As projects_employeesDataProvider
    Protected projects_employeesErrors As New NameValueCollection()
    Protected Link1 As System.Web.UI.HtmlControls.HtmlAnchor
'End Forms Objects

'Page_Load Event @1-A2D2CF1E

Protected Overrides Sub OnLoad(ByVal e As System.EventArgs)
'End Page_Load Event

'Page_Load Event BeforeIsPostBack @1-F5AF7E51
    projects_employeesParameters()
    If Not IsPostBack Then
            Dim PageData As PageDataProvider = New PageDataProvider()
            Dim item As PageItem = PageItem.CreateFromHttpRequest()
            item.Link1Href = "MasterDetail_desc.aspx"
            PageData.FillItem(item)
            Link1.InnerText += item.Link1.GetFormattedValue().Replace(vbCrLf,"")
            Link1.HRef += item.Link1Href & item.Link1HrefParameters.ToString("None","", ViewState)
            employees_gridBind
            employees_recordShow()
            projects_employeesBind()
    End If
'End Page_Load Event BeforeIsPostBack

'Page_Load Event tail @1-E31F8E2A
End Sub
'End Page_Load Event tail

'Page_Unload Event @1-D998A98F

Protected Overrides Sub OnUnload(ByVal e As System.EventArgs)
'End Page_Unload Event

'Page_Unload Event tail @1-E31F8E2A
End Sub
'End Page_Unload Event tail

'Grid employees_grid Bind @23-E75658DD

    Protected Sub employees_gridBind()
        Dim PagesCount As Integer
        Dim FooterIndex As Integer
        If Not(IsPostBack) Then
            Dim Param As String
            Param = Request.QueryString("employees_gridOrder")
            Try
                Dim sf As employees_gridDataProvider.SortFields = 0
                ViewState("employees_gridSortField") = [Enum].Parse(sf.GetType(), Param)
            Catch
                ViewState("employees_gridSortField") = employees_gridDataProvider.SortFields._Default
            End Try

            Param = Request.QueryString("employees_gridDir")
            If IsNothing(Param) Then
                ViewState("employees_gridSortDir") = SortDirections._Desc
            Else
                If Param.Length = 0 Or Param.ToLower() = "desc" Then
                    ViewState("employees_gridSortDir") = SortDirections._Desc
                Else
                    ViewState("employees_gridSortDir") = SortDirections._Asc
                End If
            End If
            Param = Request.QueryString("employees_gridPage")
            Dim PageNumber as Integer
            Try
                PageNumber = Int32.Parse(Param)
                If PageNumber <= 0 Then PageNumber = 1
            Catch
                PageNumber = 1
            End Try
            ViewState("employees_gridPageNumber") = PageNumber
            Param = Request.QueryString("employees_gridPageSize")
            Try
                PageNumber = Int32.Parse(Param)
                If PageNumber <= 0 Then PageNumber = 10
            Catch
                PageNumber = 10
            End Try
            If PageNumber > 100 Then
                PageNumber = 100
            End If
            ViewState("employees_gridPageSize") = PageNumber
        End If
'End Grid employees_grid Bind

'Grid Form employees_grid BeforeShow tail @23-6CE31AED
        employees_gridParameters
        employees_gridData.SortField = CType(ViewState("employees_gridSortField"),employees_gridDataProvider.SortFields)
        employees_gridData.SortDir = CType(ViewState("employees_gridSortDir"),SortDirections)
        employees_gridData.PageNumber = CInt(ViewState("employees_gridPageNumber"))
        employees_gridData.RecordsPerPage = CInt(ViewState("employees_gridPageSize"))
        employees_gridRepeater.DataSource = employees_gridData.GetResultSet(PagesCount)
        ViewState("employees_gridPagesCount") = PagesCount
        employees_gridRepeater.DataBind
        FooterIndex = employees_gridRepeater.Controls.Count - 1
        If PagesCount = 0 Then
            employees_gridRepeater.Controls(FooterIndex).FindControl("NoRecords").Visible = True
        End If
        Dim item As employees_gridItem = New employees_gridItem()
        Dim employees_gridLink1 As System.Web.UI.HtmlControls.HtmlAnchor = DirectCast(employees_gridRepeater.Controls(FooterIndex).FindControl("employees_gridLink1"),System.Web.UI.HtmlControls.HtmlAnchor)

        item.Link1Href = "MasterDetail.aspx?"

        employees_gridLink1.InnerText += item.Link1.GetFormattedValue().Replace(vbCrLf,"")
        employees_gridLink1.HRef += item.Link1Href & item.Link1HrefParameters.ToString("GET","emp_id", ViewState)
        Dim NavigatorNavigator As Controls.Navigator = CType(employees_gridRepeater.Controls(FooterIndex).FindControl("NavigatorNavigator"),Controls.Navigator)
        NavigatorNavigator.MaxPage=PagesCount
        NavigatorNavigator.PageNumber=employees_gridData.PageNumber
        NavigatorNavigator.DataBind
'End Grid Form employees_grid BeforeShow tail

'Grid employees_grid Bind tail @23-E31F8E2A
    End Sub
'End Grid employees_grid Bind tail

'Grid employees_grid Table Parameters @23-9B5C5D46

    Protected Sub employees_gridParameters()
        Try

        Catch
            Dim ParentControls As ControlCollection=employees_gridRepeater.Parent.Controls
            Dim RepeaterIndex As Integer=ParentControls.IndexOf(employees_gridRepeater)
            ParentControls.RemoveAt(RepeaterIndex)
            Dim ErrorMessage as Literal=New Literal()
            ErrorMessage.Text="Error in Grid employees_grid: Invalid parameter"
            ParentControls.AddAt(RepeaterIndex,ErrorMessage)
        End Try
    End Sub
'End Grid employees_grid Table Parameters

'Grid employees_grid ItemDataBound event @23-0B1EC7B3

    Protected Sub employees_gridItemDataBound(Sender as Object, e as RepeaterItemEventArgs)
        Dim DataItem as employees_gridItem=CType(e.Item.DataItem,employees_gridItem)
        If e.Item.ItemType = ListItemType.Item Or e.Item.ItemType = ListItemType.AlternatingItem Then
            Dim employees_gridemp_name As System.Web.UI.HtmlControls.HtmlAnchor = DirectCast(e.Item.FindControl("employees_gridemp_name"),System.Web.UI.HtmlControls.HtmlAnchor)
            DataItem.emp_nameHref = "MasterDetail.aspx?"
            employees_gridemp_name.HRef += DataItem.emp_nameHref & DataItem.emp_nameHrefParameters.ToString("GET","", ViewState)
        End If
'End Grid employees_grid ItemDataBound event

'Grid employees_grid ItemDataBound event tail @23-E31F8E2A
    End Sub
'End Grid employees_grid ItemDataBound event tail

'Grid employees_grid ItemCommand event @23-9296DB36

    Protected Sub employees_gridItemCommand(Sender as Object, e as RepeaterCommandEventArgs)
        Dim FooterIndex as Integer= employees_gridRepeater.Controls.Count - 1
        Dim BindAllowed as Boolean= False
        If e.CommandName = "Sort" Then
            If CType(e.CommandArgument,SorterState)=SorterState.None
                If CType(ViewState("employees_gridSortDir"),SortDirections) = SortDirections._Asc And ViewState("employees_gridSortField").ToString()=CType(e.CommandSource,Controls.Sorter).Field
                    ViewState("employees_gridSortDir")=SortDirections._Desc
                Else
                    ViewState("employees_gridSortDir")=SortDirections._Asc
                End If
            Else
                ViewState("employees_gridSortDir")=CInt(CType(e.CommandSource,Controls.Sorter).State)
            End If
            Dim sf As employees_gridDataProvider.SortFields = 0
            ViewState("employees_gridSortField")=[Enum].Parse(sf.GetType(),CType(e.CommandSource,Controls.Sorter).Field)
            ViewState("employees_gridPageNumber") = 1
            BindAllowed = True
        End If

        If e.CommandName="Navigate" Then
            ViewState("employees_gridPageNumber") = Int32.Parse(e.CommandArgument.ToString())
            BindAllowed = True
        End If
        If BindAllowed Then
            employees_gridBind
        End If
    End Sub
'End Grid employees_grid ItemCommand event

'Record Form employees_record Parameters @2-E93C0424

    Protected Sub employees_recordParameters()
        Try
            employees_recordData.Urlemp_id = IntegerParameter.GetParam(Request.QueryString("emp_id"))
        Catch e As Exception
            employees_recordErrors.Add("Parameters","Form Parameters: " + e.Message)
        End Try
    End Sub
'End Record Form employees_record Parameters

'Record Form employees_record Show method @2-F0040318
    Protected Sub employees_recordShow()
        Dim AllowRead As Boolean = True
        Dim AllowInsert As Boolean = True
        Dim AllowUpdate As Boolean = True
        Dim AllowDelete As Boolean = True
        Dim item As employees_recordItem = employees_recordItem.CreateFromHttpRequest()
        Dim IsInsertMode As Boolean = Not AllowRead
        employees_recordErrors.Add(item.errors)
        If employees_recordErrors.Count > 0 Then
            employees_recordShowErrors()
            Return
        End If
'End Record Form employees_record Show method

'Record Form employees_record BeforeShow tail @2-D95780D0
        employees_recordParameters()
        employees_recordData.FillItem(item, IsInsertMode)
        employees_recordButton_Insert.Visible = IsInsertMode And AllowInsert
        employees_recordButton_Update.Visible = (Not IsInsertMode) And AllowUpdate
        employees_recordButton_Delete.Visible = (Not IsInsertMode) And AllowDelete
        employees_recordemp_name.Text=item.emp_name.GetFormattedValue()
        employees_recordtitle.Text=item.title.GetFormattedValue()
        item.department_idItems.SetSelection(item.department_id.Value)
        employees_recorddepartment_id.SelectedIndex = -1
        item.department_idItems.CopyTo(employees_recorddepartment_id.Items)
'End Record Form employees_record BeforeShow tail

'Record employees_record Event BeforeShow. Action Custom Code @42-73254650
    
	'Hide the Editable grid if record is in the insert mode
  	If IsInsertMode Then 
		projects_employeesRepeater.Visible = false
  	End If
'End Record employees_record Event BeforeShow. Action Custom Code

'Record Form employees_record Show method tail @2-1FF89B49
        If employees_recordErrors.Count > 0 Then
            employees_recordShowErrors()
        End If
    End Sub
'End Record Form employees_record Show method tail

'Record Form employees_record LoadItemFromRequest method @2-4C66FFF8

    Protected Sub employees_recordLoadItemFromRequest(item As employees_recordItem, ByVal EnableValidation As Boolean)
        item.emp_name.SetValue(employees_recordemp_name.Text)
        item.title.SetValue(employees_recordtitle.Text)
        Try
        item.department_id.SetValue(employees_recorddepartment_id.Value)
        Catch ae As ArgumentException
            employees_recordErrors.Add("department_id","The value in field Department Id is not valid.")
        End Try
        If EnableValidation Then
            item.Validate(employees_recordData)
        End If
        employees_recordErrors.Add(item.errors)
    End Sub
'End Record Form employees_record LoadItemFromRequest method

'Record Form employees_record GetRedirectUrl method @2-BA8067F8

    Protected Function Getemployees_recordRedirectUrl(ByVal redirect As String, ByVal removeList As String) As String
        Dim Params As String = ""
        Dim List() As String = {""}

        List = (RemoveList).ToLower().Split(New Char() {";"})
        If Redirect= "" Then
            Redirect = "MasterDetail.aspx"
        End If
        Dim j As Integer
        For j=0 To Request.QueryString.Count - 1
            If Array.IndexOf(List,Request.QueryString.AllKeys(j).ToLower()) < 0 Then
                Params = Params & Request.QueryString.AllKeys(j) & "=" & Server.UrlEncode(Request.QueryString(j)) & "&"
            End If
        Next j
        Params = Params.TrimEnd(New Char(){"&"})
        Return Redirect & "?" & Params
    End Function
'End Record Form employees_record GetRedirectUrl method

'Record Form employees_record ShowErrors method @2-41657038

    Protected Sub employees_recordShowErrors()
        Dim DefaultMessage As String = ""
        Dim i As Integer
        For i = 0 To employees_recordErrors.Count - 1
        Select Case employees_recordErrors.AllKeys(i)
            Case Else
                DefaultMessage = DefaultMessage & employees_recordErrors(i) & "<br>"
        End Select
        Next i
        employees_recordError.Visible = True
        employees_recordErrorLabel.Text = DefaultMessage
    End Sub
'End Record Form employees_record ShowErrors method

'Record Form employees_record Insert Operation @2-0C0155C2

    Protected Sub employees_record_Insert(ByVal sender As Object, ByVal e As System.EventArgs)
        Dim item As employees_recordItem = New employees_recordItem()
        Dim ExecuteFlag As Boolean = True
        Dim ErrorFlag As Boolean = False
        Dim RedirectUrl As String = Getemployees_recordRedirectUrl("", "")
'End Record Form employees_record Insert Operation

'Record Form employees_record BeforeInsert tail @2-E9BF02DB
    employees_recordParameters()
    employees_recordLoadItemFromRequest(item, True)
    If employees_recordInsertAllowed Then
        ErrorFlag=(employees_recordErrors.Count > 0)
        If ExecuteFlag And (Not ErrorFlag) Then
            Try
                employees_recordData.InsertItem(item)
            Catch ex As Exception
                employees_recordErrors.Add("DataProvider",ex.Message)
                ErrorFlag = True
            End Try
        End If
'End Record Form employees_record BeforeInsert tail

'Record employees_record Event AfterInsert. Action Custom Code @30-73254650
    	
	'Select last insert emp_id 
	'Redirect user to this page with this parameter

	Dim LastID As string  = (new TextField("",Settings.IntranetDBDataAccessObject.ExecuteScalar("SELECT max(emp_id) FROM employees WHERE emp_name=" & "'" & employees_recordemp_name.Text & "'" ))).GetFormattedValue("")
	If RedirectUrl.IndexOf("?")=-1 Then
		RedirectUrl = RedirectUrl & "?emp_id=" & LastID
		else RedirectUrl = RedirectUrl & "&emp_id=" & LastID
	End If
'End Record employees_record Event AfterInsert. Action Custom Code

'Record Form employees_record AfterInsert tail  @2-6DB15A98
        End If
        If ErrorFlag Then
            employees_recordShowErrors()
        Else
            Response.Redirect(RedirectUrl)
        End If
    End Sub
'End Record Form employees_record AfterInsert tail 

'Record Form employees_record Update Operation @2-8223DC84

    Protected Sub employees_record_Update(ByVal sender As Object, ByVal e As System.EventArgs)
        Dim item As employees_recordItem = New employees_recordItem()
        item.IsNew = False
        Dim ExecuteFlag As Boolean = True
        Dim ErrorFlag As Boolean = False
        Dim RedirectUrl As String = Getemployees_recordRedirectUrl("", "")
'End Record Form employees_record Update Operation

'Record Form employees_record Before Update tail @2-18ADE6B3
        employees_recordParameters()
        employees_recordLoadItemFromRequest(item, True)
        If employees_recordUpdateAllowed Then
        ErrorFlag = (employees_recordErrors.Count > 0)
        If ExecuteFlag And (Not ErrorFlag) Then
            Try
                employees_recordData.UpdateItem(item)
            Catch ex As Exception
                employees_recordErrors.Add("DataProvider",ex.Message)
                ErrorFlag = True
            End Try
        End If
'End Record Form employees_record Before Update tail

'Record Form employees_record Update Operation tail @2-6DB15A98
        End If
        If ErrorFlag Then
            employees_recordShowErrors()
        Else
            Response.Redirect(RedirectUrl)
        End If
    End Sub
'End Record Form employees_record Update Operation tail

'Record Form employees_record Delete Operation @2-FF56DE2A

    Protected Sub employees_record_Delete(ByVal sender As Object, ByVal e As System.EventArgs)
        Dim ExecuteFlag As Boolean = True
        Dim ErrorFlag As Boolean = False
        Dim RedirectUrl As String = Getemployees_recordRedirectUrl("", "")
        Dim item As employees_recordItem = New employees_recordItem()
        item.IsNew  = False
        item.IsDeleted  = True
'End Record Form employees_record Delete Operation

'Record employees_record Event BeforeDelete. Action Custom Code @45-73254650
    
	If Not IsNothing(Request.QueryString("emp_id")) And (Request.QueryString("emp_id") <> "") Then

		Dim NewDao As DataAccessObject = Settings.IntranetDBDataAccessObject
  		Dim Sql As string  = "Delete from projects_employees where emp_id=" & NewDao.ToSql(Request.QueryString("emp_id"),FieldType._Integer)
		NewDao.RunSql(Sql)
    End If
'End Record employees_record Event BeforeDelete. Action Custom Code

'Record Form BeforeDelete tail @2-74B65CDA
        employees_recordParameters()
        employees_recordLoadItemFromRequest(item, False)
        If employees_recordDeleteAllowed Then
        ErrorFlag = (employees_recordErrors.Count > 0)
        If ExecuteFlag And (Not ErrorFlag) Then
            Try
                employees_recordData.DeleteItem()
            Catch ex As Exception
                employees_recordErrors.Add("DataProvider",ex.Message)
                ErrorFlag = True
            End Try
        End If
'End Record Form BeforeDelete tail

'Record Form AfterDelete tail @2-6DB15A98
        End If
        If ErrorFlag Then
            employees_recordShowErrors()
        Else
            Response.Redirect(RedirectUrl)
        End If
    End Sub
'End Record Form AfterDelete tail

'Record Form employees_record Cancel Operation @2-049BD150

    Protected Sub employees_record_Cancel(ByVal sender As Object, ByVal e As System.EventArgs)
        Dim item As employees_recordItem = New employees_recordItem()
        Dim RedirectUrl As String = Getemployees_recordRedirectUrl("", "")
        employees_recordLoadItemFromRequest(item, False)
'End Record Form employees_record Cancel Operation

'Record Form employees_record Cancel Operation tail @2-EA2B0FFB
        Response.Redirect(RedirectUrl)
    End Sub
'End Record Form employees_record Cancel Operation tail

'EditableGrid projects_employees Bind @31-CCF192FE
    Protected Sub projects_employeesBind()
        Dim PagesCount As Integer
        Dim FooterIndex As Integer
        If Not(IsPostBack) Then
            Dim Param As String
            Param = Request.QueryString("projects_employeesOrder")
            Try
                Dim sf As projects_employeesDataProvider.SortFields = 0
                ViewState("projects_employeesSortField") = [Enum].Parse(sf.GetType(), Param)
            Catch
                ViewState("projects_employeesSortField") = projects_employeesDataProvider.SortFields._Default
            End Try

            Param = Request.QueryString("projects_employeesDir")
            If IsNothing(Param) Then
                ViewState("projects_employeesSortDir") = SortDirections._Desc
            Else
                If Param.Length = 0 Or Param.ToLower() = "desc" Then
                    ViewState("projects_employeesSortDir") = SortDirections._Desc
                Else
                    ViewState("projects_employeesSortDir") = SortDirections._Asc
                End If
            End If
            Param = Request.QueryString("projects_employeesPage")
            Dim PageNumber as Integer
            Try
                PageNumber = Int32.Parse(Param)
                If PageNumber <= 0 Then PageNumber = 1
            Catch
                PageNumber = 1
            End Try
            ViewState("projects_employeesPageNumber") = PageNumber
            Param = Request.QueryString("projects_employeesPageSize")
            Try
                PageNumber = Int32.Parse(Param)
                If PageNumber <= 0 Then PageNumber = 20
            Catch
                PageNumber = 20
            End Try
            ViewState("projects_employeesPageSize") = PageNumber
        End If
'End EditableGrid projects_employees Bind

'Grid Form projects_employees BeforeShow tail @31-CB7C226B
        projects_employeesParameters()
        projects_employeesData.SortField = CType(ViewState("projects_employeesSortField"), projects_employeesDataProvider.SortFields)
        projects_employeesData.SortDir = CType(ViewState("projects_employeesSortDir"), SortDirections)
        projects_employeesData.PageNumber = CType(ViewState("projects_employeesPageNumber"), Integer)
        projects_employeesData.RecordsPerPage = CType(ViewState("projects_employeesPageSize"), Integer)
        projects_employeesRepeater.DataSource = projects_employeesData.GetResultSet(PagesCount)
        ViewState("projects_employeesPagesCount") = PagesCount
        ViewState("projects_employeesFormState") = New Hashtable()
        projects_employeesRepeater.DataBind()
        FooterIndex = projects_employeesRepeater.Controls.Count - 1
        Dim item As projects_employeesItem = New projects_employeesItem()


        If PagesCount = 0 Then
            projects_employeesRepeater.Controls(FooterIndex).FindControl("NoRecords").Visible = True
        End If
        If projects_employeesErrors.Count > 0 Then
            Dim ErrorLabel As System.Web.UI.WebControls.Label = DirectCast(projects_employeesRepeater.Controls(0).FindControl("ErrorLabel"),System.Web.UI.WebControls.Label)
            Dim RowError As PlaceHolder = DirectCast(projects_employeesRepeater.Controls(0).FindControl("projects_employeesError"), System.Web.UI.WebControls.PlaceHolder)
            RowError.Visible = True
            Dim msg As String
            For Each msg In projects_employeesErrors
                ErrorLabel.Text += projects_employeesErrors(msg) + "<br/>"
            Next
        End If
'End Grid Form projects_employees BeforeShow tail

'EditableGrid projects_employees Bind tail @31-C80D556C
        projects_employeesShowErrors(New ArrayList(CType(projects_employeesRepeater.DataSource, ICollection)), projects_employeesRepeater.Items)
    End Sub
'End EditableGrid projects_employees Bind tail

'EditableGrid projects_employees Table Parameters @31-977E9861
    Protected Sub projects_employeesParameters()
        Try
            projects_employeesData.Urlemp_id= IntegerParameter.GetParam(Request.QueryString("emp_id"), CObj(-1))
        Catch
            Dim ParentControls As ControlCollection = projects_employeesRepeater.Parent.Controls
            Dim RepeaterIndex As Integer = ParentControls.IndexOf(projects_employeesRepeater)
            ParentControls.RemoveAt(RepeaterIndex)
            Dim ErrorMessage As Literal = New Literal()
            ErrorMessage.Text = "Error in Grid projects_employees: Invalid parameter"
            ParentControls.AddAt(RepeaterIndex,ErrorMessage)
        End Try
	End Sub
	
'End EditableGrid projects_employees Table Parameters

'EditableGrid projects_employees ItemDataBound event @31-AB2A5A92
    Protected Sub projects_employeesItemDataBound(ByVal Sender As Object, ByVal e As RepeaterItemEventArgs)
        Dim DataItem As projects_employeesItem = DirectCast(e.Item.DataItem, projects_employeesItem)
        If e.Item.ItemType = ListItemType.Item Or e.Item.ItemType = ListItemType.AlternatingItem Then
            DataItem.RowId = e.Item.ItemIndex
            Dim formState As Hashtable = DirectCast(ViewState("projects_employeesFormState"), Hashtable)
            formState.Add("project_idField:" & e.Item.ItemIndex, DataItem.project_idField.Value)
            formState.Add("emp_idField:" & e.Item.ItemIndex, DataItem.emp_idField.Value)
            Dim projects_employeesproject_id As System.Web.UI.HtmlControls.HtmlSelect = DirectCast(e.Item.FindControl("projects_employeesproject_id"),System.Web.UI.HtmlControls.HtmlSelect)
            DataItem.project_idItems.SetSelection(DataItem.project_id.Value)
            projects_employeesproject_id.SelectedIndex = -1
            DataItem.project_idItems.CopyTo(projects_employeesproject_id.Items)
            Dim projects_employeesDelete1 As System.Web.UI.WebControls.CheckBox = DirectCast(e.Item.FindControl("projects_employeesDelete1"),System.Web.UI.WebControls.CheckBox)
            If DataItem.Delete1CheckedValue.Value.Equals(DataItem.Delete1.Value) Then
                projects_employeesDelete1.Checked = True
            End If
        End If
'End EditableGrid projects_employees ItemDataBound event

'EditableGrid projects_employees ItemDataBound event tail @31-E31F8E2A
    End Sub
'End EditableGrid projects_employees ItemDataBound event tail

'EditableGrid projects_employees GetRedirectUrl method @31-65E08CD1
    Protected Function Getprojects_employeesRedirectUrl(ByVal redirectString As String, ByVal removeList As String) As String
        Dim Params As String = ""
        Dim List As String()

        If removeList = "" Then
            List = New String() {""}
        Else
            List = removeList.Split(New Char() {";"})
        End If

        If redirectString = "" Then redirectString = Request.Url.AbsolutePath
        Dim i As Integer
        For i = 0 To Request.QueryString.Count - 1
            If Array.IndexOf(List,Request.QueryString.AllKeys(i)) < 0 Then
                Params &= Request.QueryString.AllKeys(i) & "=" & Server.UrlEncode(Request.QueryString(i)) & "&"
            End If
        Next i
        Params = Params.TrimEnd(New Char(){"&"})
        Return redirectString & "?" & Params
    End Function
    Protected Function Getprojects_employeesRedirectUrl(ByVal redirectString As String) As String
        Return Getprojects_employeesRedirectUrl(redirectString ,"")
    End Function
'End EditableGrid projects_employees GetRedirectUrl method

'EditableGrid projects_employees ShowErrors method @31-A39984E0
    Protected Function projects_employeesShowErrors(ByVal items As ArrayList, ByVal col As RepeaterItemCollection) As Boolean
        Dim result As Boolean = True
        Dim i As Integer
        For i=0 To items.Count - 1
            If CType(items(i), projects_employeesItem).IsUpdated Then col(CType(items(i), projects_employeesItem).RowId).Visible = False
            If (CType(items(i), projects_employeesItem).errors.Count > 0) Then
                result = False
                Dim DefaultMessage As String = ""
                Dim j As Integer
                For j = 0 To CType(items(i), projects_employeesItem).errors.Count - 1
                Select CType(items(i), projects_employeesItem).errors.AllKeys(j)
                    Case Else
                        DefaultMessage &= CType(items(i), projects_employeesItem).errors(j) & "<br>"
                End Select
                Next j
                Dim Err As System.Web.UI.WebControls.Label = CType(col(CType(items(i), projects_employeesItem).RowId).FindControl("ErrorLabel"), System.Web.UI.WebControls.Label)
                col(CType(items(i), projects_employeesItem).RowId).FindControl("RowError").Visible = True
                Err.Text = DefaultMessage
            End If
        Next i
        Return result
    End Function
'End EditableGrid projects_employees ShowErrors method

'EditableGrid projects_employees ItemCommand event @31-C2C4343D
    Protected Sub projects_employeesItemCommand(ByVal Sender As Object, ByVal e As RepeaterCommandEventArgs)
        Dim FooterIndex  As Integer = projects_employeesRepeater.Controls.Count - 1
        Dim BindAllowed As Boolean = False
        If e.CommandName= "Sort" Then
            If(CType(e.CommandArgument, SorterState) = SorterState.None) Then
                If(CType(ViewState("projects_employeesSortDir"), SortDirections) = SortDirections._Asc And ViewState("projects_employeesSortField").ToString() = CType(e.CommandSource, Controls.Sorter).Field) Then
                    ViewState("projects_employeesSortDir") = SortDirections._Desc
                Else
                    ViewState("projects_employeesSortDir") = SortDirections._Asc
                End If
            Else
                ViewState("projects_employeesSortDir") = CType((CType(e.CommandSource, Controls.Sorter).State), Integer)
            End If
            Dim sf As projects_employeesDataProvider.SortFields = 0
            ViewState("projects_employeesSortField") = [Enum].Parse(SF.GetType(),CType(e.CommandSource, Controls.Sorter).Field)
            ViewState("projects_employeesPageNumber") = 1
            BindAllowed = True
        End If

        If e.CommandName = "Navigate" Then
            ViewState("projects_employeesPageNumber") = Int32.Parse(e.CommandArgument.ToString())
            BindAllowed = True
        End If

        If (e.CommandName = "Submit") Then
            BindAllowed = True
            Dim col As RepeaterItemCollection = projects_employeesRepeater.Items
            Dim items As ArrayList = New ArrayList()
            Dim RedirectUrl As String = Getprojects_employeesRedirectUrl("")
            Dim formState As Hashtable = DirectCast(ViewState("projects_employeesFormState"), Hashtable)
            Dim i As Integer
            For i = 0 To col.Count - 1
                If(col(i).ItemType = ListItemType.Item Or col(i).ItemType = ListItemType.AlternatingItem) Then
                    Dim projects_employeesemp_id As System.Web.UI.HtmlControls.HtmlInputHidden = DirectCast(col(i).FindControl("projects_employeesemp_id"),System.Web.UI.HtmlControls.HtmlInputHidden)
                    Dim projects_employeesproject_id As System.Web.UI.HtmlControls.HtmlSelect = DirectCast(col(i).FindControl("projects_employeesproject_id"),System.Web.UI.HtmlControls.HtmlSelect)
                    Dim projects_employeespercent_allocation As System.Web.UI.WebControls.TextBox = DirectCast(col(i).FindControl("projects_employeespercent_allocation"),System.Web.UI.WebControls.TextBox)
                    Dim projects_employeesDelete1 As System.Web.UI.WebControls.CheckBox = DirectCast(col(i).FindControl("projects_employeesDelete1"),System.Web.UI.WebControls.CheckBox)
                    col(i).FindControl("RowError").Visible = False
                    Dim item As projects_employeesItem = New projects_employeesItem()
                    item.RowId = col(i).ItemIndex
                    item.IsUpdated = Not(col(i).Visible)
                    item.project_idField.Value = formState("project_idField:" & col(i).ItemIndex)
                    item.emp_idField.Value = formState("emp_idField:" & col(i).ItemIndex)
                    item.IsDeleted = (CType(col(i).FindControl("projects_employeesDelete1"), System.Web.UI.WebControls.CheckBox)).Checked
                    Try
                    item.emp_id.SetValue(projects_employeesemp_id.Value)
                    Catch ex As ArgumentException
                        item.errors.Add("emp_id","The value in field emp_id is not valid.")
                    End Try
                    Try
                    item.project_id.SetValue(projects_employeesproject_id.Value)
                    Catch ex As ArgumentException
                        item.errors.Add("project_id","The value in field project_id is not valid.")
                    End Try
                    Try
                    item.percent_allocation.SetValue(projects_employeespercent_allocation.Text)
                    Catch ex As ArgumentException
                        item.errors.Add("percent_allocation","The value in field percent allocation is not valid.")
                    End Try
                    items.Add(item)

                    If Not item.IsEmptyItem And Not item.IsDeleted Then BindAllowed = item.Validate(projects_employeesData) And BindAllowed
                End If
            Next i
'End EditableGrid projects_employees ItemCommand event

'EditableGrid projects_employees Event BeforeSubmit. Action Custom Code @47-73254650
    
	Dim	temp As NameValueCollection	= new NameValueCollection()
	Dim j As Integer
	for j = 0 To  items.Count -1 

		Dim myitem As projects_employeesItem  = DirectCast(items(j),projects_employeesItem)
		If IsNothing(myitem.project_id.Value) Then 
			temp.Add("e" & j,"")

		else temp.Add(myitem.project_id.GetFormattedValue(),"")
		End If
		If temp.Count < j + 1 Then 
		 
			myitem.errors.Add("project_id","A project cannot be selected twice")
			temp.Add("separator","separator")
			BindAllowed = false
		End If
	Next j
'End EditableGrid projects_employees Event BeforeSubmit. Action Custom Code

'EditableGrid projects_employees Update @31-69DCC3EB
            If BindAllowed Then
                Try
                    projects_employeesData.Update(items)
                    If projects_employeesShowErrors(items, col) Then
                        Response.Redirect(RedirectUrl)
                    Else
                        BindAllowed = False
                    End If
                Catch ex As Exception
                    Dim Error_ As System.Web.UI.WebControls.Label = CType(col(0).FindControl("ErrorLabel"), System.Web.UI.WebControls.Label)
                    Dim RowError As PlaceHolder = Ctype(col(0).FindControl("projects_employeesError"), System.Web.UI.WebControls.PlaceHolder)
                    RowError.Visible = True
                    Error_.Text = "DataProvider:" & ex.Message
                    BindAllowed = False
'End EditableGrid projects_employees Update

'EditableGrid projects_employees After Update @31-B9B89F03
                End Try
            Else
                projects_employeesShowErrors(items, col)
            End If
            End If
            If BindAllowed Then
                projects_employeesBind()
            End If
        End Sub
'End EditableGrid projects_employees After Update

'OnInit Event @1-842F3E03
    #Region " Web Form Designer Generated Code "
    Protected Overrides Sub OnInit(ByVal e As EventArgs)
        '
        ' CODEGEN: This call is required by the ASP.NET Web Form Designer.
        '
        InitializeComponent()
        'Me.Load += new System.EventHandler(this.Page_Load);
        'Me.Unload += new System.EventHandler(this.Page_Unload);
        employees_gridData = New employees_gridDataProvider()
        employees_recordData = New employees_recordDataProvider()
        projects_employeesData = New projects_employeesDataProvider()
        MyBase.OnInit(e)
'End OnInit Event

'OnInit Event tail @1-E31F8E2A
    End Sub
'End OnInit Event tail

'InitializeComponent Event @1-EA5E2628
    ' <summary>
    ' Required method for Designer support - do not modify
    ' the contents of this method with the code editor.
    ' </summary>
    Private Sub InitializeComponent()
    End Sub
    #End Region
'End InitializeComponent Event

'Page class tail @1-DD082417
End Class
End Namespace
'End Page class tail

