<%
'BindEvents Method @1-B13AC97C
Sub BindEvents()
    Set employees_record.CCSEvents("AfterInsert") = GetRef("employees_record_AfterInsert")
    Set employees_record.CCSEvents("BeforeShow") = GetRef("employees_record_BeforeShow")
    Set employees_record.CCSEvents("BeforeDelete") = GetRef("employees_record_BeforeDelete")
    Set projects_employees.project_id.CCSEvents("OnValidate") = GetRef("projects_employees_project_id_OnValidate")
    Set projects_employees.DataSource.CCSEvents("BeforeBuildInsert") = GetRef("projects_employees_DataSource_BeforeBuildInsert")
End Sub
'End BindEvents Method

Function employees_record_AfterInsert() 'employees_record_AfterInsert @2-D36A08FC
'Custom Code @30-73254650
Dim LastID

  'Retrieve the last inserted key
  LastID = CCDLookUp("max(emp_id)","employees","", DBIntranetDB)
  'Append the last inserted key to the URL by modifying the 'Redirect' variable
  redirect = FileName &"?"&CCAddParam(CCRemoveParam(Request.QueryString,"ccsForm"), "emp_id", LastID)
'End Custom Code
End Function 'Close employees_record_AfterInsert @2-54C34B28


Function employees_record_BeforeShow() 'employees_record_BeforeShow @2-4429F99B
'Custom Code @42-73254650
  'Hide the Editable grid if record is in insert mode
  If Not employees_record.EditMode Then
     projects_employees.Visible = False
  End if
'End Custom Code
End Function 'Close employees_record_BeforeShow @2-54C34B28


Function employees_record_BeforeDelete() 'employees_record_BeforeDelete @2-7BA45279
'Custom Code @45-73254650
Dim NewConnection

'Delete related projects when deleting an employee
  If not isEmpty(request.QueryString("emp_id")) Then
    'Create a new database connection object
    Set NewConnection = New clsDBIntranetDB
    NewConnection.Open
  
    NewConnection.Execute("DELETE FROM projects_employees WHERE emp_id=" & NewConnection.ToSQL(request.QueryString("emp_id"),ccsInteger))

    'Close and destroy the database connection object
    NewConnection.Close
    Set NewConnection = Nothing
  End If    
'End Custom Code
End Function 'Close employees_record_BeforeDelete @2-54C34B28


'Global variable 
Dim projects_string : projects_string = ","

Function projects_employees_project_id_OnValidate() 'projects_employees_project_id_OnValidate @32-8B12D01E
'Custom Code @44-73254650
'Ensure that the selected projects are unique
  If InStr(projects_string,","&projects_employees.project_id.Value&",")  Then 
    projects_employees.project_id.Errors.AddError("A project cannot be selected twice")
  Else 
	projects_string = projects_string & projects_employees.project_id.Value& ","
  End If
'End Custom Code
End Function 'Close projects_employees_project_id_OnValidate @32-54C34B28


Function projects_employees_DataSource_BeforeBuildInsert() 'projects_employees_DataSource_BeforeBuildInsert @31-D4EFEE2F
'Custom Code @41-73254650
'Update the hidden 'emp_id" field with the current employee id
  If not isEmpty(request.QueryString("emp_id")) Then
     projects_employees.datasource.emp_id.value = request.QueryString("emp_id")
  End If
'End Custom Code
End Function 'Close projects_employees_DataSource_BeforeBuildInsert @31-54C34B28

%>