#BindEvents Method @1-1EF09436
sub BindEvents {
    $employees_record->{CCSEvents}->{"AfterInsert"} = "employees_record_AfterInsert";
    $employees_record->{CCSEvents}->{"BeforeShow"} = "employees_record_BeforeShow";
    $employees_record->{CCSEvents}->{"BeforeDelete"} = "employees_record_BeforeDelete";
    $projects_employees->{project_id}->{CCSEvents}->{"OnValidate"} = "projects_employees_project_id_OnValidate";
    $projects_employees->{ds}->{CCSEvents}->{"BeforeBuildInsert"} = "projects_employees_ds_BeforeBuildInsert";
}
#End BindEvents Method

$project_arr = ",";

#employees_record_AfterInsert @2-9829EF5A
sub employees_record_AfterInsert()
{
    $employees_record_AfterInsert = 1;
#End employees_record_AfterInsert

#Custom Code @30-84ABEA10
  
  #Retrieve the last inserted key
  my $LastID = CCDlookUp("max(emp_id)","employees","", $employees_record->{ds});
  #Append the last inserted key to the URL by modifying the 'Redirect' variable
  $Redirect = $FileName."?".CCAddParam(CCRemoveParam(CCGetQueryString("QueryString", "ccsForm"),"ccsForm"), "emp_id", $LastID);

#End Custom Code

#Close employees_record_AfterInsert @2-706BBD18
    return $employees_record_AfterInsert;
}
#End Close employees_record_AfterInsert

#employees_record_BeforeShow @2-7D3CACA5
sub employees_record_BeforeShow()
{
    $employees_record_BeforeShow = 1;
#End employees_record_BeforeShow

#Custom Code @42-84ABEA10
  
  #Hide the Editable grid if it is in insert mode
  if(!$employees_record->{EditMode}){
     $projects_employees->{Visible} = 0;
  }
#End Custom Code

#Close employees_record_BeforeShow @2-70CBFC0C
    return $employees_record_BeforeShow;
}
#End Close employees_record_BeforeShow

#employees_record_BeforeDelete @2-5F527835
sub employees_record_BeforeDelete()
{
    $employees_record_BeforeDelete = 1;
#End employees_record_BeforeDelete

#Custom Code @45-84ABEA10

	#Delete related projects when deleting an employee
	my $emp_id = CCGetFromGet("emp_id",-1);	
	if($emp_id >0){
   	
		#Create a new database connection object
   		$NewConnection = clsDBIntranetDB->new();

	   	$NewConnection->query("DELETE FROM projects_employees WHERE emp_id=".$NewConnection->ToSQL($emp_id,$ccsInteger));
	    #Close and destroy the database connection object
    	$NewConnection->{sth} = undef;

  }  
#End Custom Code

#Close employees_record_BeforeDelete @2-113E24AB
    return $employees_record_BeforeDelete;
}
#End Close employees_record_BeforeDelete

#projects_employees_project_id_OnValidate @32-1E995D07
sub projects_employees_project_id_OnValidate()
{
    $projects_employees_project_id_OnValidate = 1;
#End projects_employees_project_id_OnValidate

#Custom Code @44-84ABEA10
  
  #Ensure that the selected projects are unique
  my $newproj_id = $projects_employees->{project_id}->{Value};
  if(index($project_arr,",".$newproj_id.",")!=-1){
   	$projects_employees->{project_id}->{Errors}->addError("A project cannot be selected twice");
  }else{
	$project_arr.= $newproj_id.",";
  }
#End Custom Code

#Close projects_employees_project_id_OnValidate @32-02BF7F70
    return $projects_employees_project_id_OnValidate;
}
#End Close projects_employees_project_id_OnValidate

#projects_employees_ds_BeforeBuildInsert @31-5722C660
sub projects_employees_ds_BeforeBuildInsert()
{
    $projects_employees_ds_BeforeBuildInsert = 1;
#End projects_employees_ds_BeforeBuildInsert

#Custom Code @41-84ABEA10
  
  #Update the 'emp_id' field with the current employee id
  my $emp_id = CCGetFromGet("emp_id",0);
  if($emp_id > 0){
	$projects_employees->{ds}->{emp_id}->SetValue($emp_id);
  }
#End Custom Code

#Close projects_employees_ds_BeforeBuildInsert @31-24F5322D
    return $projects_employees_ds_BeforeBuildInsert;
}
#End Close projects_employees_ds_BeforeBuildInsert


1;
