
//Using Statements @1-C5395B3A
using System;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Specialized;
using System.Data;
using CCSExample_CSharp;
using CCSExample_CSharp.Data;
using CCSExample_CSharp.Controls;
using CCSExample_CSharp.Configuration;

namespace CCSExample_CSharp.MultiColumnPrimaryKey.MultiColumnPrimaryKey
{
//End Using Statements

//Page Data Class @1-F1F2C6B1
public class PageItem
{
    public NameValueCollection errors=new NameValueCollection();
    public PageItem()
    {
    }
    public static PageItem CreateFromHttpRequest()
    {
        PageItem item = new PageItem();
        item.Link1.SetValue(DBUtility.GetInitialValue("Link1"));
        return item;
    }

    public FieldBase this[string fieldName]{
        get{
            switch(fieldName){
                case "Link1":
                    return this.Link1;
                default:
                    throw (new ArgumentOutOfRangeException());
            }
        }
        set{
            switch(fieldName){
                case "Link1":
                    this.Link1 = (TextField)value;
                    break;
                default:
                    throw (new ArgumentOutOfRangeException());
            }
        }
    }

    public TextField Link1 = new TextField("",null);
    public object Link1Href;
    public LinkParameterCollection Link1HrefParameters = new LinkParameterCollection();
}
//End Page Data Class

//Page Data Provider Class @1-50FE4D41
public class PageDataProvider
{
//End Page Data Provider Class

//Page Data Provider Class Constructor @1-9A44B219
    public PageDataProvider()
    {
    }
//End Page Data Provider Class Constructor

//Page Data Provider Class GetResultSet Method @1-052161C6
    public void FillItem(PageItem item)
    {
//End Page Data Provider Class GetResultSet Method

//Page Data Provider Class GetResultSet Method tail @1-FCB6E20C
    }
//End Page Data Provider Class GetResultSet Method tail

//Page Data Provider Tail @1-FCB6E20C
}
//End Page Data Provider Tail

//Record projects_emp_Search Item Class @40-D04DCFCD
public class projects_emp_SearchItem
{
    private bool _isNew = true;
    private bool _isDeleted = false;
    public NameValueCollection errors=new NameValueCollection();
    public projects_emp_SearchItem()
    {
    }
    public IntegerField s_project_id = new IntegerField("", null);
    public ItemCollection s_project_idItems = new ItemCollection();
    public IntegerField s_emp_id = new IntegerField("", null);
    public ItemCollection s_emp_idItems = new ItemCollection();

    public static projects_emp_SearchItem CreateFromHttpRequest()
    {
        projects_emp_SearchItem item = new projects_emp_SearchItem();
        if(DBUtility.GetInitialValue("s_project_id") != null){
        item.s_project_id.SetValue(DBUtility.GetInitialValue("s_project_id"));
        }
        if(DBUtility.GetInitialValue("s_emp_id") != null){
        item.s_emp_id.SetValue(DBUtility.GetInitialValue("s_emp_id"));
        }
        if(DBUtility.GetInitialValue("Button_DoSearch") != null){
        }
        return item;
    }

    public FieldBase this[string fieldName]{
        get{
            switch(fieldName){
                case "s_project_id":
                    return this.s_project_id;
                case "s_emp_id":
                    return this.s_emp_id;
                default:
                    throw (new ArgumentOutOfRangeException());
            }
        }
        set{
            switch(fieldName){
                case "s_project_id":
                    this.s_project_id = (IntegerField)value;
                    break;
                case "s_emp_id":
                    this.s_emp_id = (IntegerField)value;
                    break;
                default:
                    throw (new ArgumentOutOfRangeException());
            }
        }
    }

    public bool IsNew{
        get{
            return _isNew;
        }
        set{
            _isNew = value;
        }
    }

    public bool IsDeleted{
        get{
            return _isDeleted;
        }
        set{
            _isDeleted = value;
        }
    }

    public void Validate(projects_emp_SearchDataProvider provider)
    {
//End Record projects_emp_Search Item Class

//Record projects_emp_Search Item Class tail @40-F5FC18C5
    }
}
//End Record projects_emp_Search Item Class tail

//Record projects_emp_Search Data Provider Class @40-A1556644
public class projects_emp_SearchDataProvider:RecordDataProviderBase
{
//End Record projects_emp_Search Data Provider Class

//Record projects_emp_Search Data Provider Class Variables @40-6CAB7A25
    protected DataCommand s_project_idDataCommand=new TableCommand("SELECT *  " + 
          "FROM projects",new string[]{},Settings.IntranetDBDataAccessObject);
    protected DataCommand s_emp_idDataCommand=new TableCommand("SELECT *  " + 
          "FROM employees",new string[]{},Settings.IntranetDBDataAccessObject);
//End Record projects_emp_Search Data Provider Class Variables

//Record projects_emp_Search Data Provider Class GetResultSet Method @40-C825388F
    public void FillItem(projects_emp_SearchItem item, ref bool IsInsertMode)
    {
        bool ReadNotAllowed=IsInsertMode;
        Exception E=null;
//End Record projects_emp_Search Data Provider Class GetResultSet Method

//Record projects_emp_Search BeforeBuildSelect @40-921CE95D
        if(!IsInsertMode){
//End Record projects_emp_Search BeforeBuildSelect

//Record projects_emp_Search AfterExecuteSelect @40-C5999683
        }
            IsInsertMode=true;
        DataRowCollection ListBoxSource=null;
//End Record projects_emp_Search AfterExecuteSelect

//ListBox s_project_id BeforeExecuteSelect @42-846FB320
        try{
            ListBoxSource=s_project_idDataCommand.Execute().Tables[0].Rows;
        }catch(Exception e){
            E=e;}
        finally{
//End ListBox s_project_id BeforeExecuteSelect

//ListBox s_project_id AfterExecuteSelect @42-AAD041B1
            if(E!=null) throw(E);
        }
        for(int i=0;i<ListBoxSource.Count;i++){
            object val = ListBoxSource[i]["project_name"];
            string key = (new IntegerField("", ListBoxSource[i]["project_id"])).GetFormattedValue("");
            item.s_project_idItems.Add(key,val);
        }
//End ListBox s_project_id AfterExecuteSelect

//ListBox s_emp_id Initialize Data Source @43-41F23F27
        s_emp_idDataCommand.OrderBy="emp_name";
//End ListBox s_emp_id Initialize Data Source

//ListBox s_emp_id BeforeExecuteSelect @43-020E164C
        try{
            ListBoxSource=s_emp_idDataCommand.Execute().Tables[0].Rows;
        }catch(Exception e){
            E=e;}
        finally{
//End ListBox s_emp_id BeforeExecuteSelect

//ListBox s_emp_id AfterExecuteSelect @43-A97E9457
            if(E!=null) throw(E);
        }
        for(int i=0;i<ListBoxSource.Count;i++){
            object val = ListBoxSource[i]["emp_name"];
            string key = (new IntegerField("", ListBoxSource[i]["emp_id"])).GetFormattedValue("");
            item.s_emp_idItems.Add(key,val);
        }
//End ListBox s_emp_id AfterExecuteSelect

//Record projects_emp_Search AfterExecuteSelect tail @40-FCB6E20C
    }
//End Record projects_emp_Search AfterExecuteSelect tail

//Record projects_emp_Search Data Provider Class @40-FCB6E20C
}

//End Record projects_emp_Search Data Provider Class

//Grid projects_emp_grid Item Class @29-6322EF37
public class projects_emp_gridItem
{
    public NameValueCollection errors=new NameValueCollection();
    public projects_emp_gridItem()
    {
    }

    public FieldBase this[string fieldName]{
        get{
            switch(fieldName){
                case "project_name":
                    return this.project_name;
                case "emp_name":
                    return this.emp_name;
                case "percent_allocation":
                    return this.percent_allocation;
                case "Link1":
                    return this.Link1;
                default:
                    throw (new ArgumentOutOfRangeException());
            }
        }
        set{
            switch(fieldName){
                case "project_name":
                    this.project_name = (TextField)value;
                    break;
                case "emp_name":
                    this.emp_name = (TextField)value;
                    break;
                case "percent_allocation":
                    this.percent_allocation = (FloatField)value;
                    break;
                case "Link1":
                    this.Link1 = (TextField)value;
                    break;
                default:
                    throw (new ArgumentOutOfRangeException());
            }
        }
    }

    public TextField project_name = new TextField("",null);
    public object project_nameHref;
    public LinkParameterCollection project_nameHrefParameters = new LinkParameterCollection();
    public TextField emp_name=new TextField("", null);
    public FloatField percent_allocation=new FloatField("", null);
    public TextField Link1 = new TextField("",null);
    public object Link1Href;
    public LinkParameterCollection Link1HrefParameters = new LinkParameterCollection();
}
//End Grid projects_emp_grid Item Class

//Grid projects_emp_grid Data Provider Class Header @29-0EB19E47
public class projects_emp_gridDataProvider:GridDataProviderBase
{
//End Grid projects_emp_grid Data Provider Class Header

//Grid projects_emp_grid Data Provider Class Variables @29-7B8C753E
    public enum SortFields {Default}
    private string[] SortFieldsNames=new string[]{"project_name"};
    private string[] SortFieldsNamesDesc=new string[]{"project_name"};
    public SortFields SortField=SortFields.Default;
    public SortDirections SortDir=SortDirections.Asc;
    public int RecordsPerPage=10;
    public int PageNumber=1;
    public IntegerParameter Urls_project_id;
    public IntegerParameter Urls_emp_id;
//End Grid projects_emp_grid Data Provider Class Variables

//Grid projects_emp_grid Data Provider Class Constructor @29-7D264944
    public projects_emp_gridDataProvider()
    {
        Select=new TableCommand("SELECT projects_employees.*, emp_name, project_name  " + 
          "FROM projects INNER JOIN (employees INNER JOIN projects_employees ON employees.emp_id = projects_employees.emp_id) ON projects.project_id = projects_employees.project_id",new string[]{"s_project_id44","And","s_emp_id45"},Settings.IntranetDBDataAccessObject);
        Count=new TableCommand("SELECT COUNT(*)  " + 
          "FROM projects INNER JOIN (employees INNER JOIN projects_employees ON employees.emp_id = projects_employees.emp_id) ON projects.project_id = projects_employees.project_id",new string[]{"s_project_id44","And","s_emp_id45"},Settings.IntranetDBDataAccessObject);
    }
//End Grid projects_emp_grid Data Provider Class Constructor

//Grid projects_emp_grid Data Provider Class GetResultSet Method @29-2CDA3131
    public projects_emp_gridItem[] GetResultSet(out int PagesCount)
    {
//End Grid projects_emp_grid Data Provider Class GetResultSet Method

//Before build Select @29-2CBB03B5
        Parameters.Clear();
        Parameters.Add("s_project_id44",Urls_project_id==null?"":("projects_employees.project_id = " + Select.Dao.ToSql(Urls_project_id.GetFormattedValue(""),FieldType.Integer)));
        Parameters.Add("s_emp_id45",Urls_emp_id==null?"":("projects_employees.emp_id = " + Select.Dao.ToSql(Urls_emp_id.GetFormattedValue(""),FieldType.Integer)));
        Select.OrderBy=(SortDir==SortDirections.Asc?SortFieldsNames[(int)SortField]:SortFieldsNamesDesc[(int)SortField]).Trim();
//End Before build Select

//Execute Select @29-E684A2A4
        DataSet ds=null;Exception E=null;
        PagesCount=0;
        try{
            if(RecordsPerPage>0)
            {
                ds=ExecuteSelect((PageNumber-1)*RecordsPerPage,RecordsPerPage);
                PagesCount = ExecuteCount();
                mRecordCount = PagesCount;
                PagesCount = PagesCount%RecordsPerPage>0?(int)(PagesCount/RecordsPerPage)+1:(int)(PagesCount/RecordsPerPage);
            }
            else
            {
            ds=ExecuteSelect();
            if(ds.Tables[0].Rows.Count!=0)PagesCount=1;
            }
        }catch(Exception e){
            E=e;}
        finally{
//End Execute Select

//After execute Select @29-A4153FA0
        if(E!=null) throw(E);
        }
        DataRowCollection dr=ds.Tables[0].Rows;
        projects_emp_gridItem[] result=new projects_emp_gridItem[dr.Count];
//End After execute Select

//After execute Select tail @29-334F5AB2
        for(int i=0;i<dr.Count;i++)
        {
            projects_emp_gridItem item=new projects_emp_gridItem();
            item.project_name.SetValue(dr[i]["project_name"],"");
            item.project_nameHrefParameters.Add("project_id",System.Web.HttpUtility.UrlEncode(dr[i]["project_id"].ToString()));
            item.project_nameHrefParameters.Add("emp_id",System.Web.HttpUtility.UrlEncode(dr[i]["emp_id"].ToString()));
            item.emp_name.SetValue(dr[i]["emp_name"],"");
            item.percent_allocation.SetValue(dr[i]["percent_allocation"],"");
            result[i]=item;
        }
        return result; 
    }
//End After execute Select tail

//Grid Data Provider tail @29-FCB6E20C
}
//End Grid Data Provider tail

//Record projects_emp_rec Item Class @58-97B94FDB
public class projects_emp_recItem
{
    private bool _isNew = true;
    private bool _isDeleted = false;
    public NameValueCollection errors=new NameValueCollection();
    public projects_emp_recItem()
    {
    }
    public IntegerField project_id = new IntegerField("", null);
    public ItemCollection project_idItems = new ItemCollection();
    public IntegerField emp_id = new IntegerField("", null);
    public ItemCollection emp_idItems = new ItemCollection();
    public FloatField percent_allocation=new FloatField("", null);

    public static projects_emp_recItem CreateFromHttpRequest()
    {
        projects_emp_recItem item = new projects_emp_recItem();
        if(DBUtility.GetInitialValue("project_id") != null){
        item.project_id.SetValue(DBUtility.GetInitialValue("project_id"));
        }
        if(DBUtility.GetInitialValue("emp_id") != null){
        item.emp_id.SetValue(DBUtility.GetInitialValue("emp_id"));
        }
        if(DBUtility.GetInitialValue("percent_allocation") != null){
        item.percent_allocation.SetValue(DBUtility.GetInitialValue("percent_allocation"));
        }
        if(DBUtility.GetInitialValue("Button_Insert") != null){
        }
        if(DBUtility.GetInitialValue("Button_Update") != null){
        }
        if(DBUtility.GetInitialValue("Button_Delete") != null){
        }
        if(DBUtility.GetInitialValue("Button_Cancel") != null){
        }
        return item;
    }

    public FieldBase this[string fieldName]{
        get{
            switch(fieldName){
                case "project_id":
                    return this.project_id;
                case "emp_id":
                    return this.emp_id;
                case "percent_allocation":
                    return this.percent_allocation;
                default:
                    throw (new ArgumentOutOfRangeException());
            }
        }
        set{
            switch(fieldName){
                case "project_id":
                    this.project_id = (IntegerField)value;
                    break;
                case "emp_id":
                    this.emp_id = (IntegerField)value;
                    break;
                case "percent_allocation":
                    this.percent_allocation = (FloatField)value;
                    break;
                default:
                    throw (new ArgumentOutOfRangeException());
            }
        }
    }

    public bool IsNew{
        get{
            return _isNew;
        }
        set{
            _isNew = value;
        }
    }

    public bool IsDeleted{
        get{
            return _isDeleted;
        }
        set{
            _isDeleted = value;
        }
    }

    public void Validate(projects_emp_recDataProvider provider)
    {
//End Record projects_emp_rec Item Class

//project_id validate @66-EACEF5F6
        if(project_id.Value==null||project_id.Value.ToString()=="")
            errors.Add("project_id","The value in field Project is required.");
//End project_id validate

//emp_id validate @64-94DFD765
        if(emp_id.Value==null||emp_id.Value.ToString()=="")
            errors.Add("emp_id","The value in field Employee is required.");
//End emp_id validate

//Control percent_allocation Event OnValidate. Action Validate Maximum Value @74-5F2C5BE5
        if(percent_allocation.Value!=null &&Convert.ToDouble(percent_allocation.Value) > 100) 
            errors.Add("percent_allocation","The value in field 'Percent Allocation' cannot be greater than 100.");
//End Control percent_allocation Event OnValidate. Action Validate Maximum Value

//Record projects_emp_rec Event OnValidate. Action Custom Code @72-2A29BDB7
System.Web.HttpContext context = System.Web.HttpContext.Current;

long IsUniqueValue = 0;

 if (errors.Count == 0) {
  if ( IsNew || (context.Request.QueryString["project_id"] != project_id.Value.ToString() || context.Request.QueryString["emp_id"] != emp_id.Value.ToString() ) ) { 
    IsUniqueValue = (Int64)(new IntegerField("",Settings.IntranetDBDataAccessObject.ExecuteScalar("SELECT count(project_id) FROM projects_employees WHERE project_id="+ project_id.Value +" AND emp_id=" + emp_id.Value ))).Value;
    if (IsUniqueValue != 0) {
	   errors.Add("project_id","The project is already assigned to this employee.");
	}
  }
 }

//End Record projects_emp_rec Event OnValidate. Action Custom Code

//Record projects_emp_rec Item Class tail @58-F5FC18C5
    }
}
//End Record projects_emp_rec Item Class tail

//Record projects_emp_rec Data Provider Class @58-B619EDCB
public class projects_emp_recDataProvider:RecordDataProviderBase
{
//End Record projects_emp_rec Data Provider Class

//Record projects_emp_rec Data Provider Class Variables @58-E6F9F41A
    protected DataCommand project_idDataCommand=new TableCommand("SELECT *  " + 
          "FROM projects",new string[]{},Settings.IntranetDBDataAccessObject);
    protected DataCommand emp_idDataCommand=new TableCommand("SELECT *  " + 
          "FROM employees",new string[]{},Settings.IntranetDBDataAccessObject);
    public IntegerParameter Urlproject_id;
    public IntegerParameter Urlemp_id;
//End Record projects_emp_rec Data Provider Class Variables

//Record projects_emp_rec Data Provider Class Constructor @58-EE4AFE04
    public projects_emp_recDataProvider()
    {
        Select=new TableCommand("SELECT *  " + 
          "FROM projects_employees",new string[]{"project_id63","And","emp_id71"},Settings.IntranetDBDataAccessObject);
        Insert=new TableCommand("INSERT INTO projects_employees(project_id, emp_id, percent_allocation ) VALUES ( {project_id}, {emp_id}, {percent_allocation})"
        ,new string[0],Settings.IntranetDBDataAccessObject);
        Update=new TableCommand("UPDATE projects_employees SET project_id={project_id}, emp_id={emp_id}, percent_allocation={percent_allocation}"
        ,new string[]{"project_id63","And","emp_id71"},Settings.IntranetDBDataAccessObject);
        Delete=new TableCommand("DELETE FROM projects_employees",new string[]{"project_id63","And","emp_id71"},Settings.IntranetDBDataAccessObject);
    }
//End Record projects_emp_rec Data Provider Class Constructor

//Record projects_emp_rec Data Provider Class LoadParams Method @58-718B1DE9
    protected bool LoadParams()
    {
        CommonParameters.Clear();
        CommonParameters.Add("project_id63",Urlproject_id==null?"":("project_id = " + Select.Dao.ToSql(Urlproject_id.GetFormattedValue(""),FieldType.Integer)));
        CommonParameters.Add("emp_id71",Urlemp_id==null?"":("emp_id = " + Select.Dao.ToSql(Urlemp_id.GetFormattedValue(""),FieldType.Integer)));
        return !(Urlproject_id!=null&&Urlemp_id!=null);
    }
//End Record projects_emp_rec Data Provider Class LoadParams Method

//Record projects_emp_rec Data Provider Class CheckUnique Method @58-9A63054B
    public bool CheckUnique(string ControlName,projects_emp_recItem item)
    {
        return true;
    }
//End Record projects_emp_rec Data Provider Class CheckUnique Method

//Record projects_emp_rec Data Provider Class PrepareInsert Method @58-E2788B74
    override protected void PrepareInsert()
    {
//End Record projects_emp_rec Data Provider Class PrepareInsert Method

//Record projects_emp_rec Data Provider Class PrepareInsert Method tail @58-FCB6E20C
    }
//End Record projects_emp_rec Data Provider Class PrepareInsert Method tail

//Record projects_emp_rec Data Provider Class Insert Method @58-59A9C91D
    public int InsertItem(projects_emp_recItem item)
    {
//End Record projects_emp_rec Data Provider Class Insert Method

//Record projects_emp_rec Build insert @58-5CDCE70B
        Insert.SqlQuery.Replace("{project_id}",Insert.Dao.ToSql(item.project_id.GetFormattedValue(""),FieldType.Integer));
        Insert.SqlQuery.Replace("{emp_id}",Insert.Dao.ToSql(item.emp_id.GetFormattedValue(""),FieldType.Integer));
        Insert.SqlQuery.Replace("{percent_allocation}",Insert.Dao.ToSql(item.percent_allocation.GetFormattedValue(""),FieldType.Float));
        object result=null;Exception E=null;
        try{
            result=ExecuteInsert();
        }catch(Exception e){
            E=e;}
        finally{
//End Record projects_emp_rec Build insert

//Record projects_emp_rec AfterExecuteInsert @58-33B45808
            if(E!=null) throw(E);
        }
        return (int)result;
    }
//End Record projects_emp_rec AfterExecuteInsert

//Record projects_emp_rec Data Provider Class PrepareUpdate Method @58-7A788766
    override protected void PrepareUpdate()
    {
        LoadParams();
        Update.Parameters=CommonParameters;
//End Record projects_emp_rec Data Provider Class PrepareUpdate Method

//Record projects_emp_rec Data Provider Class PrepareUpdate Method tail @58-FCB6E20C
    }
//End Record projects_emp_rec Data Provider Class PrepareUpdate Method tail

//Record projects_emp_rec Data Provider Class Update Method @58-55572EAE
    public int UpdateItem(projects_emp_recItem item)
    {
//End Record projects_emp_rec Data Provider Class Update Method

//Record projects_emp_rec BeforeBuildUpdate @58-5E761C27
        Update.SqlQuery.Replace("{project_id}",Update.Dao.ToSql(item.project_id.GetFormattedValue(""),FieldType.Integer));
        Update.SqlQuery.Replace("{emp_id}",Update.Dao.ToSql(item.emp_id.GetFormattedValue(""),FieldType.Integer));
        Update.SqlQuery.Replace("{percent_allocation}",Update.Dao.ToSql(item.percent_allocation.GetFormattedValue(""),FieldType.Float));
        object result=null;Exception E=null;
        try{
            result=ExecuteUpdate();
        }catch(Exception e){
            E=e;}
        finally{
//End Record projects_emp_rec BeforeBuildUpdate

//Record projects_emp_rec AfterExecuteUpdate @58-33B45808
            if(E!=null) throw(E);
        }
        return (int)result;
    }
//End Record projects_emp_rec AfterExecuteUpdate

//Record projects_emp_rec Data Provider Class PrepareDelete Method @58-9923EE9D
    override protected void PrepareDelete()
    {
        LoadParams();
        Delete.Parameters=CommonParameters;
//End Record projects_emp_rec Data Provider Class PrepareDelete Method

//Record projects_emp_rec Data Provider Class PrepareDelete Method tail @58-FCB6E20C
    }
//End Record projects_emp_rec Data Provider Class PrepareDelete Method tail

//Record projects_emp_rec Data Provider Class Delete Method @58-F69D1A58
    public int DeleteItem()
    {
//End Record projects_emp_rec Data Provider Class Delete Method

//Record projects_emp_rec BeforeBuildDelete @58-C970B5CF
        object result=null;Exception E=null;
        try{
            result=ExecuteDelete();
        }catch(Exception e){
            E=e;}
        finally{
//End Record projects_emp_rec BeforeBuildDelete

//Record projects_emp_rec BeforeBuildDelete @58-33B45808
            if(E!=null) throw(E);
        }
        return (int)result;
    }
//End Record projects_emp_rec BeforeBuildDelete

//PrepareSelect Method @58-32F2D8AA
    override protected void PrepareSelect()
    {
        LoadParams();
        Select.Parameters=CommonParameters;
    }
//End PrepareSelect Method

//Record projects_emp_rec Data Provider Class GetResultSet Method @58-1571C93D
    public void FillItem(projects_emp_recItem item, ref bool IsInsertMode)
    {
        bool ReadNotAllowed=IsInsertMode;
        Exception E=null;
//End Record projects_emp_rec Data Provider Class GetResultSet Method

//Record projects_emp_rec BeforeBuildSelect @58-0CD0BD3D
        IsInsertMode=LoadParams();
        DataRowCollection dr=null;
        if(!IsInsertMode){
//End Record projects_emp_rec BeforeBuildSelect

//Record projects_emp_rec BeforeExecuteSelect @58-94ACF54A
            try{
                dr=ExecuteSelect().Tables[0].Rows;
            }catch(Exception e){
                E=e;}
            finally{
//End Record projects_emp_rec BeforeExecuteSelect

//Record projects_emp_rec AfterExecuteSelect @58-851FC57B
                if(E!=null) throw(E);
            }
        }
        if(!IsInsertMode && !ReadNotAllowed && dr.Count!=0)
        {
            int i=0;
            item.project_id.SetValue(dr[i]["project_id"],"");
            item.emp_id.SetValue(dr[i]["emp_id"],"");
            item.percent_allocation.SetValue(dr[i]["percent_allocation"],"");
        }
        else
            IsInsertMode=true;
        DataRowCollection ListBoxSource=null;
//End Record projects_emp_rec AfterExecuteSelect

//ListBox project_id BeforeExecuteSelect @66-B85A5BA1
        try{
            ListBoxSource=project_idDataCommand.Execute().Tables[0].Rows;
        }catch(Exception e){
            E=e;}
        finally{
//End ListBox project_id BeforeExecuteSelect

//ListBox project_id AfterExecuteSelect @66-1A2F62FE
            if(E!=null) throw(E);
        }
        for(int i=0;i<ListBoxSource.Count;i++){
            object val = ListBoxSource[i]["project_name"];
            string key = (new IntegerField("", ListBoxSource[i]["project_id"])).GetFormattedValue("");
            item.project_idItems.Add(key,val);
        }
//End ListBox project_id AfterExecuteSelect

//ListBox emp_id Initialize Data Source @64-0398D65A
        emp_idDataCommand.OrderBy="emp_name";
//End ListBox emp_id Initialize Data Source

//ListBox emp_id BeforeExecuteSelect @64-F3442258
        try{
            ListBoxSource=emp_idDataCommand.Execute().Tables[0].Rows;
        }catch(Exception e){
            E=e;}
        finally{
//End ListBox emp_id BeforeExecuteSelect

//ListBox emp_id AfterExecuteSelect @64-E09DF7D6
            if(E!=null) throw(E);
        }
        for(int i=0;i<ListBoxSource.Count;i++){
            object val = ListBoxSource[i]["emp_name"];
            string key = (new IntegerField("", ListBoxSource[i]["emp_id"])).GetFormattedValue("");
            item.emp_idItems.Add(key,val);
        }
//End ListBox emp_id AfterExecuteSelect

//Record projects_emp_rec AfterExecuteSelect tail @58-FCB6E20C
    }
//End Record projects_emp_rec AfterExecuteSelect tail

//Record projects_emp_rec Data Provider Class @58-FCB6E20C
}

//End Record projects_emp_rec Data Provider Class

//Page Data Provider Tail @1-FCB6E20C
}
//End Page Data Provider Tail

