//Using Statements @1-8F31FC8E
using System;
using System.Collections;
using System.Collections.Specialized;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Text.RegularExpressions;
using System.Globalization;
using CCSExamplePack;
using CCSExamplePack.Data;
using CCSExamplePack.Configuration;
using CCSExamplePack.Controls;

namespace CCSExamplePack.MultiStepRegistration.MultiStepRegistration1
{

//End Using Statements

//Forms Definition @1-5C3CCB74
public class MultiStepRegistration1Page : System.Web.UI.Page
{
//End Forms Definition

//Forms Objects @1-B10493E7
    protected usersDataProvider usersData;
    protected HtmlInputButton usersInsert1;
    protected HtmlInputButton usersUpdate1;
    protected HtmlInputButton usersCancel;
    protected System.Web.UI.WebControls.PlaceHolder usersError;
    protected System.Web.UI.HtmlControls.HtmlTable usersHolder;
    protected System.Web.UI.WebControls.Label usersErrorLabel;
    protected bool usersInsertAllowed=true;
    protected bool usersUpdateAllowed=true;
    protected NameValueCollection usersErrors=new NameValueCollection();
    protected System.Web.UI.WebControls.TextBox usersuser_login;
    protected System.Web.UI.WebControls.TextBox usersuser_password;
    protected System.Web.UI.WebControls.TextBox usersfirst_name;
    protected System.Web.UI.WebControls.TextBox userslast_name;
    protected System.Web.UI.WebControls.TextBox usersemail;
//End Forms Objects

//Page_Load Event @1-55207E05
private void Page_Load(object sender, System.EventArgs e)
{
//End Page_Load Event

//Page_Load Event BeforeIsPostBack @1-4D09AAA6
    if (!IsPostBack)
    {
            PageDataProvider PageData=new PageDataProvider();
            PageItem item=PageItem.CreateFromHttpRequest();
            PageData.FillItem(item);
            usersShow();
    }
//End Page_Load Event BeforeIsPostBack

//Page_Load Event tail @1-FCB6E20C
}
//End Page_Load Event tail

//Page_Unload Event @1-72102C7C
private void Page_Unload(object sender, System.EventArgs e)
{
//End Page_Unload Event

//Page_Unload Event tail @1-FCB6E20C
}
//End Page_Unload Event tail

//Record Form users Parameters @3-6BF2D5D2
    protected void usersParameters()
    {
        try{
            usersData.Urluser_id= IntegerParameter.GetParam(Request.QueryString["user_id"]);
        }catch(Exception e){
            usersErrors.Add("Parameters","Form parameters: " + e.Message);
        }
    }
//End Record Form users Parameters

//Record Form users Show method @3-2E9965F0
    protected void usersShow()
    {
        bool AllowRead = true,AllowInsert = true,AllowUpdate = true;
        usersItem item=usersItem.CreateFromHttpRequest();
        bool IsInsertMode=!AllowRead;
        usersErrors.Add(item.errors);
//End Record Form users Show method

//Grid Form users BeforeShow tail @3-6A8A3743
        usersParameters();
        usersData.FillItem(item,ref IsInsertMode);
        usersInsert1.Visible=IsInsertMode&&AllowInsert;
        usersUpdate1.Visible=!IsInsertMode&&AllowUpdate;
        usersuser_login.Text=item.user_login.GetFormattedValue();
        usersuser_password.Text=item.user_password.GetFormattedValue();
        usersfirst_name.Text=item.first_name.GetFormattedValue();
        userslast_name.Text=item.last_name.GetFormattedValue();
        usersemail.Text=item.email.GetFormattedValue();
//End Grid Form users BeforeShow tail

//Record Form users Show method tail @3-00ECC24D
        if(usersErrors.Count>0)
            usersShowErrors();
    }
//End Record Form users Show method tail

//Record Form users LoadItemFromRequest method @3-11FF2F1A
    protected void usersLoadItemFromRequest(usersItem item, bool EnableValidation)
    {
        item.user_login.SetValue(usersuser_login.Text);
        item.user_password.SetValue(usersuser_password.Text);
        item.first_name.SetValue(usersfirst_name.Text);
        item.last_name.SetValue(userslast_name.Text);
        item.email.SetValue(usersemail.Text);
        if(EnableValidation)
            item.Validate(usersData);
        usersErrors.Add(item.errors);
    }
//End Record Form users LoadItemFromRequest method

//Record Form users GetRedirectUrl method @3-E50C9327
    protected string GetusersRedirectUrl(string redirectString ,string removeList)
    {
        string Params="";
        string[] List;

        if(removeList=="")
            List=new string[1];
        else
            List=(removeList).ToLower().Split(new Char[] {';'});

        if(redirectString == "") redirectString = "MultiStepRegistration2.aspx";
        for(int i = 0; i < Request.QueryString.Count;i ++)
            if(Array.IndexOf(List,Request.QueryString.AllKeys[i].ToLower()) < 0)
                Params += Request.QueryString.AllKeys[i] + "=" + Server.UrlEncode(Request.QueryString[i]) + "&";
        Params = Params.TrimEnd(new Char[]{'&'});
        return redirectString + "?" + Params;
    }

//End Record Form users GetRedirectUrl method

//Record Form users ShowErrors method @3-93979AC4
    protected void usersShowErrors()
    {
        string DefaultMessage="";
        for(int i=0;i<usersErrors.Count;i++)
        switch(usersErrors.AllKeys[i])
        {
            default:
                DefaultMessage+=usersErrors[i]+"<br>";
                break;
        }
        usersError.Visible = true;
        usersErrorLabel.Text = DefaultMessage;
    }
//End Record Form users ShowErrors method

//Record Form users Insert Operation @3-7945D459
    protected void users_Insert(object sender, System.EventArgs e)
    {
        bool ExecuteFlag = true;
        bool ErrorFlag = false;
        usersItem item=new usersItem();
        string RedirectUrl = GetusersRedirectUrl("", "");
//End Record Form users Insert Operation

//Record Form users BeforeInsert tail @3-4E35296A
    usersParameters();
    usersLoadItemFromRequest(item, true);
    if(usersInsertAllowed){
    ErrorFlag=(usersErrors.Count>0);
        if(ExecuteFlag&&!ErrorFlag)
            try
            {
                usersData.InsertItem(item);
            }
            catch (Exception ex)
            {
                usersErrors.Add("DataProvider",ex.Message);
                ErrorFlag=true;
            }
//End Record Form users BeforeInsert tail

//Record users Event AfterInsert. Action Custom Code @47-2A29BDB7

//Retrieve the last inserted key if the new user is registered
//This method of retrieving the last inserted key is safe because the value of the user_login field has to be unique.
  if (Request.QueryString["user_id"] == null || Request.QueryString["user_id"].Length == 0) {
      string LastID = (new TextField("",Settings.InternetDBDataAccessObject.ExecuteScalar("SELECT max(user_id) FROM users WHERE user_login=" +"'"+ usersuser_login.Text +"'" ))).GetFormattedValue("");
	  RedirectUrl = RedirectUrl + "user_id=" + LastID;
  }

//End Record users Event AfterInsert. Action Custom Code

//Record Form users AfterInsert tail  @3-CCCD5F10
        }
        if(ErrorFlag)
            usersShowErrors();
        else
            Response.Redirect(RedirectUrl);
    }
//End Record Form users AfterInsert tail 

//Record Form users Update Operation @3-9F42E7C3
    protected void users_Update(object sender, System.EventArgs e)
    {
        usersItem item=new usersItem();
        item.IsNew = false;
        bool ExecuteFlag = true;
        bool ErrorFlag = false;
        string RedirectUrl = GetusersRedirectUrl("", "");
//End Record Form users Update Operation

//Record Form users Before Update tail @3-4A4F9758
        usersParameters();
        usersLoadItemFromRequest(item, true);
        if(usersUpdateAllowed){
        ErrorFlag=(usersErrors.Count>0);
        if(ExecuteFlag&&!ErrorFlag)
            try
            {
                usersData.UpdateItem(item);
            }
            catch (Exception ex)
            {
                usersErrors.Add("DataProvider",ex.Message);
                ErrorFlag=true;
            }
//End Record Form users Before Update tail

//Record Form users Update Operation tail @3-CCCD5F10
        }
        if(ErrorFlag)
            usersShowErrors();
        else
            Response.Redirect(RedirectUrl);
    }
//End Record Form users Update Operation tail

//Record Form users Cancel Operation @3-CCA238BD
    protected void users_Cancel(object sender,System.EventArgs e)
    {
        usersItem item=new usersItem();
        string RedirectUrl = GetusersRedirectUrl("MultiStepRegistrationGrid.aspx", "");
        usersLoadItemFromRequest(item, false);
//End Record Form users Cancel Operation

//Record Form users Cancel Operation tail @3-AE897FBA
        Response.Redirect(RedirectUrl);
    }
//End Record Form users Cancel Operation tail

//OnInit Event @1-CD944117
    #region Web Form Designer generated code
    override protected void OnInit(EventArgs e)
    {
        //
        //CODEGEN: This call is required by the ASP.NET Web Form Designer.
        //
        InitializeComponent();
        this.Load += new System.EventHandler(this.Page_Load);
        this.Unload += new System.EventHandler(this.Page_Unload);
        usersData = new usersDataProvider();
        base.OnInit(e);
//End OnInit Event

//OnInit Event tail @1-FCB6E20C
    }
//End OnInit Event tail

//InitializeComponent Event @1-722FC1EE
    /// <summary>
    /// Required method for Designer support - do not modify
    /// the contents of this method with the code editor.
    /// </summary>
    private void InitializeComponent()
    {
    }
    #endregion
//End InitializeComponent Event

//Page class tail @1-F5FC18C5
}
}
//End Page class tail

