//Using Statements @1-BA312FF2
using System;
using System.Collections;
using System.Collections.Specialized;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Text.RegularExpressions;
using System.Globalization;
using CCSExample_CSharp;
using CCSExample_CSharp.Data;
using CCSExample_CSharp.Configuration;
using CCSExample_CSharp.Controls;

namespace CCSExample_CSharp.NavRecordGrid.NavRecordGrid
{

//End Using Statements

//Forms Definition @1-DBDCBDE0
public class NavRecordGridPage : System.Web.UI.Page
{
//End Forms Definition

//Forms Objects @1-56CB9A92
    protected System.Web.UI.WebControls.Repeater employeesRepeater;
    protected employeesDataProvider employeesData;
    protected NameValueCollection employeesErrors=new NameValueCollection();
    protected System.Web.UI.HtmlControls.HtmlAnchor Link1;
//End Forms Objects

//Page_Load Event @1-55207E05
private void Page_Load(object sender, System.EventArgs e)
{
//End Page_Load Event

//Page_Load Event BeforeIsPostBack @1-F381BE22
    if (!IsPostBack)
    {
            PageDataProvider PageData=new PageDataProvider();
            PageItem item=PageItem.CreateFromHttpRequest();
            item.Link1Href = "NavRecordGrid_desc.aspx?";
            PageData.FillItem(item);
            Link1.InnerText += item.Link1.GetFormattedValue().Replace("\r","").Replace("\n","<br>");
            Link1.HRef += item.Link1Href+item.Link1HrefParameters.ToString("GET","", ViewState);
            employeesBind();
    }
//End Page_Load Event BeforeIsPostBack

//Page_Load Event tail @1-FCB6E20C
}
//End Page_Load Event tail

//Page_Unload Event @1-72102C7C
private void Page_Unload(object sender, System.EventArgs e)
{
//End Page_Unload Event

//Page_Unload Event tail @1-FCB6E20C
}
//End Page_Unload Event tail

//EditableGrid employees Bind @67-13B81547
    protected void employeesBind()
    {
        int PagesCount;
        int FooterIndex;
        if (!IsPostBack)
        {
            string Param;
            int PageSize;
            ViewState["employeesSortField"] = employeesDataProvider.SortFields.Default;
            PageSize = 1;
            ViewState["employeesPageNumber"] = 1;
            Param = Request.QueryString["employeesOrder"];
            if (Param != null && Param.Length > 0)
                try{
                    employeesDataProvider.SortFields SortField = 0;
                    ViewState["employeesSortField"] = Enum.Parse(SortField.GetType(), Param);
                }catch {}
            Param = Request.QueryString["employeesDir"];
            if (Param == null || Param.Length == 0 || Param.ToLower() == "desc")
                ViewState["employeesSortDir"] = SortDirections.Desc;
            else
                ViewState["employeesSortDir"] = SortDirections.Asc;
            Param = Request.QueryString["employeesPage"];
            int PageNumber;
            if (Param != null && Param.Length > 0)
                try
                {
                    PageNumber = Int32.Parse(Param);
                    if (PageNumber <= 0) ViewState["employeesPageNumber"] = 1;
                }
                catch {}
            Param = Request.QueryString["employeesPageSize"];
            if (Param != null && Param.Length > 0)
                try
                {
                    PageSize = Int32.Parse(Param);
                    if (PageSize <= 0) PageSize = 1;
                }
                catch {}
            if (PageSize > 100)
                PageSize = 100;
            ViewState["employeesPageSize"] = PageSize;
        }
//End EditableGrid employees Bind

//EditableGrid employees Event BeforeSelect. Action Custom Code @94-2A29BDB7
    
 //If adding a new record
  if (Request.QueryString["emp_id"] == "-1") {
     //Show one empty row
	 employeesData.EmptyRows = 1;
 //If modyfing an existing record
  }else{
     //Hide empty rows (usually used for adding multiple new records)
	 employeesData.EmptyRows = 0;
  }
//End EditableGrid employees Event BeforeSelect. Action Custom Code

//Grid Form employees BeforeShow tail @67-F80E4C58
        employeesParameters();
        employeesData.SortField = (employeesDataProvider.SortFields)ViewState["employeesSortField"];
        employeesData.SortDir = (SortDirections)ViewState["employeesSortDir"];
        employeesData.PageNumber = (int)ViewState["employeesPageNumber"];
        employeesData.RecordsPerPage = (int)ViewState["employeesPageSize"];
        object dataSource = employeesData.GetResultSet(out PagesCount);
        employeesRepeater.DataSource = employeesData.GetResultSet(out PagesCount);
        ViewState["employeesPagesCount"] = PagesCount;
        ViewState["employeesFormState"] = new Hashtable();
        employeesRepeater.DataBind();
        FooterIndex = employeesRepeater.Controls.Count - 1;
        employeesItem item=new employeesItem();
        System.Web.UI.HtmlControls.HtmlAnchor employeesLink1 = (System.Web.UI.HtmlControls.HtmlAnchor)employeesRepeater.Controls[FooterIndex].FindControl("employeesLink1");

        item.Link1Href = "NavRecordGrid.aspx?";
        item.Link1HrefParameters.Add("emp_id",System.Web.HttpUtility.UrlEncode((-1).ToString()));

        employeesLink1.InnerText += item.Link1.GetFormattedValue().Replace("\r","").Replace("\n","<br>");
        employeesLink1.HRef += item.Link1Href+item.Link1HrefParameters.ToString("GET","", ViewState);
        if (PagesCount == 0)
        {
            employeesRepeater.Controls[FooterIndex].FindControl("NoRecords").Visible = true;
        }
        CCSExample_CSharp.Controls.Navigator NavigatorNavigator = (CCSExample_CSharp.Controls.Navigator)employeesRepeater.Controls[FooterIndex].FindControl("NavigatorNavigator");
        NavigatorNavigator.MaxPage=PagesCount;
        NavigatorNavigator.PageNumber=employeesData.PageNumber;
        NavigatorNavigator.DataBind();
        if (employeesErrors.Count > 0)
        {
            System.Web.UI.WebControls.Label Error = (System.Web.UI.WebControls.Label)(employeesRepeater.Controls[0].FindControl("ErrorLabel"));
            PlaceHolder RowError = (System.Web.UI.WebControls.PlaceHolder)(employeesRepeater.Controls[0].FindControl("employeesError"));
            RowError.Visible = true;
            foreach(string msg in employeesErrors)
                Error.Text += employeesErrors[msg] + "<br/>";
        }
//End Grid Form employees BeforeShow tail

//Control employees Event BeforeShow. Action Custom Code @88-2A29BDB7
  
  //If adding a new record
  if (Request.QueryString["emp_id"] == "-1") {
	 //Hide the navigator
     NavigatorNavigator.Visible = false;
  }    
//End Control employees Event BeforeShow. Action Custom Code

//EditableGrid employees Bind tail @67-595FB04C
        employeesShowErrors(new ArrayList((ICollection)employeesRepeater.DataSource), employeesRepeater.Items);
    }
//End EditableGrid employees Bind tail

//EditableGrid employees Table Parameters @67-A04431EF
    protected void employeesParameters()
    {
        try{
            employeesData.Urlemp_id= IntegerParameter.GetParam(Request.QueryString["emp_id"]);
        }catch{
            ControlCollection ParentControls=employeesRepeater.Parent.Controls;
            int RepeaterIndex=ParentControls.IndexOf(employeesRepeater);
            ParentControls.RemoveAt(RepeaterIndex);
            Literal ErrorMessage=new Literal();
            ErrorMessage.Text="Error in Grid employees: Invalid parameter";
            ParentControls.AddAt(RepeaterIndex,ErrorMessage);
        }
	}
	
//End EditableGrid employees Table Parameters

//EditableGrid employees ItemDataBound event @67-446AFB6A
    protected void employeesItemDataBound(Object Sender, RepeaterItemEventArgs e)
    {
        employeesItem DataItem=(employeesItem)e.Item.DataItem;
        if (e.Item.ItemType == ListItemType.Item || e.Item.ItemType == ListItemType.AlternatingItem) {
            DataItem.RowId = e.Item.ItemIndex;
            Hashtable formState = (Hashtable)ViewState["employeesFormState"];
            formState.Add("emp_idField:" + e.Item.ItemIndex.ToString(),DataItem.emp_idField.Value);
            System.Web.UI.HtmlControls.HtmlSelect employeesgroup_id = (System.Web.UI.HtmlControls.HtmlSelect)(e.Item.FindControl("employeesgroup_id"));
            DataItem.group_idItems.SetSelection(DataItem.group_id.Value);
            employeesgroup_id.SelectedIndex = -1;
            DataItem.group_idItems.CopyTo(employeesgroup_id.Items);
            System.Web.UI.HtmlControls.HtmlSelect employeesdepartment_id = (System.Web.UI.HtmlControls.HtmlSelect)(e.Item.FindControl("employeesdepartment_id"));
            DataItem.department_idItems.SetSelection(DataItem.department_id.Value);
            employeesdepartment_id.SelectedIndex = -1;
            DataItem.department_idItems.CopyTo(employeesdepartment_id.Items);
            System.Web.UI.WebControls.CheckBox employeesDelete1 = (System.Web.UI.WebControls.CheckBox)(e.Item.FindControl("employeesDelete1"));
            if(DataItem.Delete1CheckedValue.Value.Equals(DataItem.Delete1.Value))
                employeesDelete1.Checked = true;
        }
//End EditableGrid employees ItemDataBound event

//EditableGrid employees ItemDataBound event tail @67-FCB6E20C
    }
//End EditableGrid employees ItemDataBound event tail

//EditableGrid employees GetRedirectUrl method @67-0F17B38E
    protected string GetemployeesRedirectUrl(string redirectString ,string removeList)
    {
        string Params="";
        string[] List;

        if(removeList=="")
            List=new string[1];
        else
            List=removeList.Split(new Char[] {';'});

        if(redirectString == "") redirectString = Request.Url.AbsolutePath;
        for(int i = 0; i < Request.QueryString.Count;i ++)
            if(Array.IndexOf(List,Request.QueryString.AllKeys[i]) < 0)
                Params += Request.QueryString.AllKeys[i] + "=" + Server.UrlEncode(Request.QueryString[i]) + "&";
        Params = Params.TrimEnd(new Char[]{'&'});
        return redirectString + "?" + Params;
    }
    protected string GetemployeesRedirectUrl(string redirectString)
    {
        return GetemployeesRedirectUrl(redirectString ,"emp_id");
    }
//End EditableGrid employees GetRedirectUrl method

//EditableGrid employees ShowErrors method @67-F9E7EB9D
    protected bool employeesShowErrors(ArrayList items, RepeaterItemCollection col)
    {
        bool result = true;
        foreach(employeesItem item in items)
        {
            if(item.IsUpdated) col[item.RowId].Visible = false;
            if(item.errors.Count > 0){
                result = false;
                string DefaultMessage="";
                for(int j = 0; j < item.errors.Count; j ++)
                switch (item.errors.AllKeys[j])
                {
                    default:
                        DefaultMessage += item.errors[j] + "<br>";
                        break;
                }
                System.Web.UI.WebControls.Label Error = (System.Web.UI.WebControls.Label)(col[item.RowId].FindControl("ErrorLabel"));
                col[item.RowId].FindControl("RowError").Visible = true;
                Error.Text = DefaultMessage;
            }
        }
        return result;
    }
//End EditableGrid employees ShowErrors method

//EditableGrid employees ItemCommand event @67-4EE937C8
    protected void employeesItemCommand(Object Sender, RepeaterCommandEventArgs e)
    {
        int FooterIndex = employeesRepeater.Controls.Count - 1;
        bool BindAllowed = false;
//End EditableGrid employees ItemCommand event

//EditableGrid Form employees ItemCommand event tail @67-B1A4AAB2
        if(e.CommandName=="Sort"){
            if(((SorterState)e.CommandArgument)==SorterState.None)
                if((SortDirections)ViewState["employeesSortDir"]==SortDirections.Asc&&ViewState["employeesSortField"].ToString()==((CCSExample_CSharp.Controls.Sorter)e.CommandSource).Field)
                    ViewState["employeesSortDir"]=SortDirections.Desc;
                else
                    ViewState["employeesSortDir"]=SortDirections.Asc;
            else
                ViewState["employeesSortDir"]=(int)(((CCSExample_CSharp.Controls.Sorter)e.CommandSource).State);
            ViewState["employeesSortField"]=Enum.Parse(typeof(employeesDataProvider.SortFields),((CCSExample_CSharp.Controls.Sorter)e.CommandSource).Field);
            ViewState["employeesPageNumber"] = 1;
            BindAllowed = true;
        }

        if(e.CommandName=="Navigate"){
            ViewState["employeesPageNumber"] = Int32.Parse(e.CommandArgument.ToString());
            BindAllowed = true;
        }

        if(e.CommandName=="Submit"){
            BindAllowed = true;
            RepeaterItemCollection col=employeesRepeater.Items;
            ArrayList items=new ArrayList();
            Hashtable formState = (Hashtable)ViewState["employeesFormState"];
            string RedirectUrl = GetemployeesRedirectUrl("");
            employeesParameters();
            for(int i=0;i<col.Count;i++)
                if(col[i].ItemType == ListItemType.Item || col[i].ItemType == ListItemType.AlternatingItem){
                    System.Web.UI.WebControls.TextBox employeesemp_name = (System.Web.UI.WebControls.TextBox)(col[i].FindControl("employeesemp_name"));
                    System.Web.UI.HtmlControls.HtmlInputHidden employeesHidden1 = (System.Web.UI.HtmlControls.HtmlInputHidden)(col[i].FindControl("employeesHidden1"));
                    System.Web.UI.WebControls.TextBox employeesemp_login = (System.Web.UI.WebControls.TextBox)(col[i].FindControl("employeesemp_login"));
                    System.Web.UI.WebControls.TextBox employeesemp_password = (System.Web.UI.WebControls.TextBox)(col[i].FindControl("employeesemp_password"));
                    System.Web.UI.WebControls.TextBox employeestitle = (System.Web.UI.WebControls.TextBox)(col[i].FindControl("employeestitle"));
                    System.Web.UI.HtmlControls.HtmlSelect employeesgroup_id = (System.Web.UI.HtmlControls.HtmlSelect)(col[i].FindControl("employeesgroup_id"));
                    System.Web.UI.HtmlControls.HtmlSelect employeesdepartment_id = (System.Web.UI.HtmlControls.HtmlSelect)(col[i].FindControl("employeesdepartment_id"));
                    System.Web.UI.WebControls.TextBox employeesphone_work = (System.Web.UI.WebControls.TextBox)(col[i].FindControl("employeesphone_work"));
                    System.Web.UI.WebControls.CheckBox employeesDelete1 = (System.Web.UI.WebControls.CheckBox)(col[i].FindControl("employeesDelete1"));
                    System.Web.UI.HtmlControls.HtmlAnchor employeesLink1 = (System.Web.UI.HtmlControls.HtmlAnchor)employeesRepeater.Controls[FooterIndex].FindControl("employeesLink1");
                    col[i].FindControl("RowError").Visible = false;
                    employeesItem item = new employeesItem();
                    item.RowId = col[i].ItemIndex;
                    item.IsUpdated = !col[i].Visible;
                    item.emp_idField.Value = formState["emp_idField:" + col[i].ItemIndex.ToString()];
                    item.IsDeleted = employeesDelete1.Checked;
                    item.emp_name.SetValue(employeesemp_name.Text);
                    item.Hidden1.SetValue(employeesHidden1.Value);
                    item.emp_login.SetValue(employeesemp_login.Text);
                    item.emp_password.SetValue(employeesemp_password.Text);
                    item.title.SetValue(employeestitle.Text);
                    try{
                    item.group_id.SetValue(employeesgroup_id.Value);
                    }catch(ArgumentException){
                        item.errors.Add("group_id","The value in field Group is not valid.");}
                    try{
                    item.department_id.SetValue(employeesdepartment_id.Value);
                    }catch(ArgumentException){
                        item.errors.Add("department_id","The value in field Department is not valid.");}
                    item.phone_work.SetValue(employeesphone_work.Text);
                    items.Add(item);

                    if(!item.IsEmptyItem && !item.IsDeleted) BindAllowed = item.Validate(employeesData) && BindAllowed;
            }

//End EditableGrid Form employees ItemCommand event tail

//EditableGrid employees Update @67-7307A9C9
        if (BindAllowed)
            try
            {
                employeesData.Update(items);
                if (employeesShowErrors(items, col))
                    Response.Redirect(RedirectUrl);
                else
                    BindAllowed = false;
            }
            catch (Exception ex)
            {
                System.Web.UI.WebControls.Label Error = (System.Web.UI.WebControls.Label)(col[0].FindControl("ErrorLabel"));
                PlaceHolder RowError = (System.Web.UI.WebControls.PlaceHolder)(col[0].FindControl("employeesError"));
                RowError.Visible = true;
                Error.Text = "DataProvider:" + ex.Message;
                BindAllowed=false;
            }
//End EditableGrid employees Update

//EditableGrid employees AfterSubmit @67-1511E6E6
        else
            employeesShowErrors(items, col);
        }
        if (BindAllowed)
            employeesBind();
    }
//End EditableGrid employees AfterSubmit

//OnInit Event @1-6754D0B9
    #region Web Form Designer generated code
    override protected void OnInit(EventArgs e)
    {
        //
        //CODEGEN: This call is required by the ASP.NET Web Form Designer.
        //
        InitializeComponent();
        this.Load += new System.EventHandler(this.Page_Load);
        this.Unload += new System.EventHandler(this.Page_Unload);
        employeesData = new employeesDataProvider();
        base.OnInit(e);
//End OnInit Event

//OnInit Event tail @1-FCB6E20C
    }
//End OnInit Event tail

//InitializeComponent Event @1-722FC1EE
    /// <summary>
    /// Required method for Designer support - do not modify
    /// the contents of this method with the code editor.
    /// </summary>
    private void InitializeComponent()
    {
    }
    #endregion
//End InitializeComponent Event

//Page class tail @1-F5FC18C5
}
}
//End Page class tail

