'Using Statements @1-77F1B74E
Imports System
Imports System.Collections
Imports System.Collections.Specialized
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Web
Imports System.Web.SessionState
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports System.Web.UI.HtmlControls
Imports System.Text.RegularExpressions
Imports System.Globalization
Imports NewProject3
Imports NewProject3.Data
Imports NewProject3.Configuration
Imports NewProject3.Controls
Namespace NavRecordGrid.NavRecordGrid
'End Using Statements

'Forms Definition @1-19FD4FF3
Public Class [NavRecordGridPage]
Inherits System.Web.UI.Page
'End Forms Definition

'Forms Objects @1-EA8EC966
    Protected employeesRepeater As System.Web.UI.WebControls.Repeater
    Protected employeesData As employeesDataProvider
    Protected employeesErrors As New NameValueCollection()
    Protected Link1 As System.Web.UI.HtmlControls.HtmlAnchor
'End Forms Objects

'Page_Load Event @1-A2D2CF1E

Protected Overrides Sub OnLoad(ByVal e As System.EventArgs)
'End Page_Load Event

'Page_Load Event BeforeIsPostBack @1-FDB9C314
    If Not IsPostBack Then
            Dim PageData As PageDataProvider = New PageDataProvider()
            Dim item As PageItem = PageItem.CreateFromHttpRequest()
            item.Link1Href = "NavRecordGrid_desc.aspx?"
            PageData.FillItem(item)
            Link1.InnerText += item.Link1.GetFormattedValue().Replace(vbCrLf,"")
            Link1.HRef += item.Link1Href & item.Link1HrefParameters.ToString("GET","", ViewState)
            employeesBind()
    End If
'End Page_Load Event BeforeIsPostBack

'Page_Load Event tail @1-E31F8E2A
End Sub
'End Page_Load Event tail

'Page_Unload Event @1-D998A98F

Protected Overrides Sub OnUnload(ByVal e As System.EventArgs)
'End Page_Unload Event

'Page_Unload Event tail @1-E31F8E2A
End Sub
'End Page_Unload Event tail

'EditableGrid employees Bind @67-46C70B48
    Protected Sub employeesBind()
        Dim PagesCount As Integer
        Dim FooterIndex As Integer
        If Not(IsPostBack) Then
            Dim Param As String
            Param = Request.QueryString("employeesOrder")
            Try
                Dim sf As employeesDataProvider.SortFields = 0
                ViewState("employeesSortField") = [Enum].Parse(sf.GetType(), Param)
            Catch
                ViewState("employeesSortField") = employeesDataProvider.SortFields._Default
            End Try

            Param = Request.QueryString("employeesDir")
            If IsNothing(Param) Then
                ViewState("employeesSortDir") = SortDirections._Desc
            Else
                If Param.Length = 0 Or Param.ToLower() = "desc" Then
                    ViewState("employeesSortDir") = SortDirections._Desc
                Else
                    ViewState("employeesSortDir") = SortDirections._Asc
                End If
            End If
            Param = Request.QueryString("employeesPage")
            Dim PageNumber as Integer
            Try
                PageNumber = Int32.Parse(Param)
                If PageNumber <= 0 Then PageNumber = 1
            Catch
                PageNumber = 1
            End Try
            ViewState("employeesPageNumber") = PageNumber
            Param = Request.QueryString("employeesPageSize")
            Try
                PageNumber = Int32.Parse(Param)
                If PageNumber <= 0 Then PageNumber = 1
            Catch
                PageNumber = 1
            End Try
            If PageNumber > 100 Then
                PageNumber = 100
            End If
            ViewState("employeesPageSize") = PageNumber
        End If
'End EditableGrid employees Bind

'EditableGrid employees Event BeforeSelect. Action Custom Code @94-73254650

 'If adding a new record
  If CInt(Request.QueryString("emp_id")) = -1 Then
     'Show one empty row
	 employeesData.EmptyRows = 1
 'If modyfing an existing record
  Else
     'Hide empty rows (usually used for adding multiple new records)
	 employeesData.EmptyRows = 0
  End if

'End EditableGrid employees Event BeforeSelect. Action Custom Code

'Grid Form employees BeforeShow tail @67-CB21AB35
        employeesParameters()
        employeesData.SortField = CType(ViewState("employeesSortField"), employeesDataProvider.SortFields)
        employeesData.SortDir = CType(ViewState("employeesSortDir"), SortDirections)
        employeesData.PageNumber = CType(ViewState("employeesPageNumber"), Integer)
        employeesData.RecordsPerPage = CType(ViewState("employeesPageSize"), Integer)
        employeesRepeater.DataSource = employeesData.GetResultSet(PagesCount)
        ViewState("employeesPagesCount") = PagesCount
        ViewState("employeesFormState") = New Hashtable()
        employeesRepeater.DataBind()
        FooterIndex = employeesRepeater.Controls.Count - 1
        Dim item As employeesItem = New employeesItem()
        Dim employeesLink1 As System.Web.UI.HtmlControls.HtmlAnchor = DirectCast(employeesRepeater.Controls(FooterIndex).FindControl("employeesLink1"),System.Web.UI.HtmlControls.HtmlAnchor)

        item.Link1Href = "NavRecordGrid.aspx?"
        item.Link1HrefParameters.Add("emp_id",System.Web.HttpUtility.UrlEncode((-1).ToString()))

        employeesLink1.InnerText += item.Link1.GetFormattedValue().Replace(vbCrLf,"")
        employeesLink1.HRef += item.Link1Href & item.Link1HrefParameters.ToString("GET","", ViewState)
        If PagesCount = 0 Then
            employeesRepeater.Controls(FooterIndex).FindControl("NoRecords").Visible = True
        End If
        Dim NavigatorNavigator As Controls.Navigator = CType(employeesRepeater.Controls(FooterIndex).FindControl("NavigatorNavigator"),Controls.Navigator)
        NavigatorNavigator.MaxPage=PagesCount
        NavigatorNavigator.PageNumber=employeesData.PageNumber
        NavigatorNavigator.DataBind
        If employeesErrors.Count > 0 Then
            Dim ErrorLabel As System.Web.UI.WebControls.Label = DirectCast(employeesRepeater.Controls(0).FindControl("ErrorLabel"),System.Web.UI.WebControls.Label)
            Dim RowError As PlaceHolder = DirectCast(employeesRepeater.Controls(0).FindControl("employeesError"), System.Web.UI.WebControls.PlaceHolder)
            RowError.Visible = True
            Dim msg As String
            For Each msg In employeesErrors
                ErrorLabel.Text += employeesErrors(msg) + "<br/>"
            Next
        End If
'End Grid Form employees BeforeShow tail

'Control employees Event BeforeShow. Action Custom Code @88-73254650
 'If adding a new record
  If CInt(Request.QueryString("emp_id")) = -1 Then
	 'Hide the navigator
     NavigatorNavigator.Visible = False 
  End if 
'End Control employees Event BeforeShow. Action Custom Code

'EditableGrid employees Bind tail @67-B7E20C3C
        employeesShowErrors(New ArrayList(CType(employeesRepeater.DataSource, ICollection)), employeesRepeater.Items)
    End Sub
'End EditableGrid employees Bind tail

'EditableGrid employees Table Parameters @67-0DD1ECB5
    Protected Sub employeesParameters()
        Try
            employeesData.Urlemp_id= IntegerParameter.GetParam(Request.QueryString("emp_id"))
        Catch
            Dim ParentControls As ControlCollection = employeesRepeater.Parent.Controls
            Dim RepeaterIndex As Integer = ParentControls.IndexOf(employeesRepeater)
            ParentControls.RemoveAt(RepeaterIndex)
            Dim ErrorMessage As Literal = New Literal()
            ErrorMessage.Text = "Error in Grid employees: Invalid parameter"
            ParentControls.AddAt(RepeaterIndex,ErrorMessage)
        End Try
	End Sub
	
'End EditableGrid employees Table Parameters

'EditableGrid employees ItemDataBound event @67-DC17EE1F
    Protected Sub employeesItemDataBound(ByVal Sender As Object, ByVal e As RepeaterItemEventArgs)
        Dim DataItem As employeesItem = DirectCast(e.Item.DataItem, employeesItem)
        If e.Item.ItemType = ListItemType.Item Or e.Item.ItemType = ListItemType.AlternatingItem Then
            DataItem.RowId = e.Item.ItemIndex
            Dim formState As Hashtable = DirectCast(ViewState("employeesFormState"), Hashtable)
            formState.Add("emp_idField:" & e.Item.ItemIndex, DataItem.emp_idField.Value)
            Dim employeesgroup_id As System.Web.UI.HtmlControls.HtmlSelect = DirectCast(e.Item.FindControl("employeesgroup_id"),System.Web.UI.HtmlControls.HtmlSelect)
            DataItem.group_idItems.SetSelection(DataItem.group_id.Value)
            employeesgroup_id.SelectedIndex = -1
            DataItem.group_idItems.CopyTo(employeesgroup_id.Items)
            Dim employeesdepartment_id As System.Web.UI.HtmlControls.HtmlSelect = DirectCast(e.Item.FindControl("employeesdepartment_id"),System.Web.UI.HtmlControls.HtmlSelect)
            DataItem.department_idItems.SetSelection(DataItem.department_id.Value)
            employeesdepartment_id.SelectedIndex = -1
            DataItem.department_idItems.CopyTo(employeesdepartment_id.Items)
            Dim employeesDelete1 As System.Web.UI.WebControls.CheckBox = DirectCast(e.Item.FindControl("employeesDelete1"),System.Web.UI.WebControls.CheckBox)
            If DataItem.Delete1CheckedValue.Value.Equals(DataItem.Delete1.Value) Then
                employeesDelete1.Checked = True
            End If
        End If
'End EditableGrid employees ItemDataBound event

'EditableGrid employees ItemDataBound event tail @67-E31F8E2A
    End Sub
'End EditableGrid employees ItemDataBound event tail

'EditableGrid employees GetRedirectUrl method @67-09BE418E
    Protected Function GetemployeesRedirectUrl(ByVal redirectString As String, ByVal removeList As String) As String
        Dim Params As String = ""
        Dim List As String()

        If removeList = "" Then
            List = New String() {""}
        Else
            List = removeList.Split(New Char() {";"})
        End If

        If redirectString = "" Then redirectString = Request.Url.AbsolutePath
        Dim i As Integer
        For i = 0 To Request.QueryString.Count - 1
            If Array.IndexOf(List,Request.QueryString.AllKeys(i)) < 0 Then
                Params &= Request.QueryString.AllKeys(i) & "=" & Server.UrlEncode(Request.QueryString(i)) & "&"
            End If
        Next i
        Params = Params.TrimEnd(New Char(){"&"})
        Return redirectString & "?" & Params
    End Function
    Protected Function GetemployeesRedirectUrl(ByVal redirectString As String) As String
        Return GetemployeesRedirectUrl(redirectString ,"emp_id")
    End Function
'End EditableGrid employees GetRedirectUrl method

'EditableGrid employees ShowErrors method @67-C091E1FB
    Protected Function employeesShowErrors(ByVal items As ArrayList, ByVal col As RepeaterItemCollection) As Boolean
        Dim result As Boolean = True
        Dim i As Integer
        For i=0 To items.Count - 1
            If CType(items(i), employeesItem).IsUpdated Then col(CType(items(i), employeesItem).RowId).Visible = False
            If (CType(items(i), employeesItem).errors.Count > 0) Then
                result = False
                Dim DefaultMessage As String = ""
                Dim j As Integer
                For j = 0 To CType(items(i), employeesItem).errors.Count - 1
                Select CType(items(i), employeesItem).errors.AllKeys(j)
                    Case Else
                        DefaultMessage &= CType(items(i), employeesItem).errors(j) & "<br>"
                End Select
                Next j
                Dim Err As System.Web.UI.WebControls.Label = CType(col(CType(items(i), employeesItem).RowId).FindControl("ErrorLabel"), System.Web.UI.WebControls.Label)
                col(CType(items(i), employeesItem).RowId).FindControl("RowError").Visible = True
                Err.Text = DefaultMessage
            End If
        Next i
        Return result
    End Function
'End EditableGrid employees ShowErrors method

'EditableGrid employees ItemCommand event @67-5BC5779C
    Protected Sub employeesItemCommand(ByVal Sender As Object, ByVal e As RepeaterCommandEventArgs)
        Dim FooterIndex  As Integer = employeesRepeater.Controls.Count - 1
        Dim BindAllowed As Boolean = False
        If e.CommandName= "Sort" Then
            If(CType(e.CommandArgument, SorterState) = SorterState.None) Then
                If(CType(ViewState("employeesSortDir"), SortDirections) = SortDirections._Asc And ViewState("employeesSortField").ToString() = CType(e.CommandSource, Controls.Sorter).Field) Then
                    ViewState("employeesSortDir") = SortDirections._Desc
                Else
                    ViewState("employeesSortDir") = SortDirections._Asc
                End If
            Else
                ViewState("employeesSortDir") = CType((CType(e.CommandSource, Controls.Sorter).State), Integer)
            End If
            Dim sf As employeesDataProvider.SortFields = 0
            ViewState("employeesSortField") = [Enum].Parse(SF.GetType(),CType(e.CommandSource, Controls.Sorter).Field)
            ViewState("employeesPageNumber") = 1
            BindAllowed = True
        End If

        If e.CommandName = "Navigate" Then
            ViewState("employeesPageNumber") = Int32.Parse(e.CommandArgument.ToString())
            BindAllowed = True
        End If

        If (e.CommandName = "Submit") Then
            BindAllowed = True
            Dim col As RepeaterItemCollection = employeesRepeater.Items
            Dim items As ArrayList = New ArrayList()
            Dim RedirectUrl As String = GetemployeesRedirectUrl("")
            Dim formState As Hashtable = DirectCast(ViewState("employeesFormState"), Hashtable)
            Dim i As Integer
            For i = 0 To col.Count - 1
                If(col(i).ItemType = ListItemType.Item Or col(i).ItemType = ListItemType.AlternatingItem) Then
                    Dim employeesemp_name As System.Web.UI.WebControls.TextBox = DirectCast(col(i).FindControl("employeesemp_name"),System.Web.UI.WebControls.TextBox)
                    Dim employeesHidden1 As System.Web.UI.HtmlControls.HtmlInputHidden = DirectCast(col(i).FindControl("employeesHidden1"),System.Web.UI.HtmlControls.HtmlInputHidden)
                    Dim employeesemp_login As System.Web.UI.WebControls.TextBox = DirectCast(col(i).FindControl("employeesemp_login"),System.Web.UI.WebControls.TextBox)
                    Dim employeesemp_password As System.Web.UI.WebControls.TextBox = DirectCast(col(i).FindControl("employeesemp_password"),System.Web.UI.WebControls.TextBox)
                    Dim employeestitle As System.Web.UI.WebControls.TextBox = DirectCast(col(i).FindControl("employeestitle"),System.Web.UI.WebControls.TextBox)
                    Dim employeesgroup_id As System.Web.UI.HtmlControls.HtmlSelect = DirectCast(col(i).FindControl("employeesgroup_id"),System.Web.UI.HtmlControls.HtmlSelect)
                    Dim employeesdepartment_id As System.Web.UI.HtmlControls.HtmlSelect = DirectCast(col(i).FindControl("employeesdepartment_id"),System.Web.UI.HtmlControls.HtmlSelect)
                    Dim employeesphone_work As System.Web.UI.WebControls.TextBox = DirectCast(col(i).FindControl("employeesphone_work"),System.Web.UI.WebControls.TextBox)
                    Dim employeesDelete1 As System.Web.UI.WebControls.CheckBox = DirectCast(col(i).FindControl("employeesDelete1"),System.Web.UI.WebControls.CheckBox)
                    Dim employeesLink1 As System.Web.UI.HtmlControls.HtmlAnchor = DirectCast(employeesRepeater.Controls(FooterIndex).FindControl("employeesLink1"),System.Web.UI.HtmlControls.HtmlAnchor)
                    col(i).FindControl("RowError").Visible = False
                    Dim item As employeesItem = New employeesItem()
                    item.RowId = col(i).ItemIndex
                    item.IsUpdated = Not(col(i).Visible)
                    item.emp_idField.Value = formState("emp_idField:" & col(i).ItemIndex)
                    item.IsDeleted = (CType(col(i).FindControl("employeesDelete1"), System.Web.UI.WebControls.CheckBox)).Checked
                    item.emp_name.SetValue(employeesemp_name.Text)
                    item.Hidden1.SetValue(employeesHidden1.Value)
                    item.emp_login.SetValue(employeesemp_login.Text)
                    item.emp_password.SetValue(employeesemp_password.Text)
                    item.title.SetValue(employeestitle.Text)
                    Try
                    item.group_id.SetValue(employeesgroup_id.Value)
                    Catch ex As ArgumentException
                        item.errors.Add("group_id","The value in field Group is not valid.")
                    End Try
                    Try
                    item.department_id.SetValue(employeesdepartment_id.Value)
                    Catch ex As ArgumentException
                        item.errors.Add("department_id","The value in field Department is not valid.")
                    End Try
                    item.phone_work.SetValue(employeesphone_work.Text)
                    items.Add(item)

                    If Not item.IsEmptyItem And Not item.IsDeleted Then BindAllowed = item.Validate(employeesData) And BindAllowed
                End If
            Next i
'End EditableGrid employees ItemCommand event

'EditableGrid employees Update @67-025787BB
            If BindAllowed Then
                Try
                    employeesData.Update(items)
                    If employeesShowErrors(items, col) Then
                        Response.Redirect(RedirectUrl)
                    Else
                        BindAllowed = False
                    End If
                Catch ex As Exception
                    Dim Error_ As System.Web.UI.WebControls.Label = CType(col(0).FindControl("ErrorLabel"), System.Web.UI.WebControls.Label)
                    Dim RowError As PlaceHolder = Ctype(col(0).FindControl("employeesError"), System.Web.UI.WebControls.PlaceHolder)
                    RowError.Visible = True
                    Error_.Text = "DataProvider:" & ex.Message
                    BindAllowed = False
'End EditableGrid employees Update

'EditableGrid employees After Update @67-422F1E7B
                End Try
            Else
                employeesShowErrors(items, col)
            End If
            End If
            If BindAllowed Then
                employeesBind()
            End If
        End Sub
'End EditableGrid employees After Update

'OnInit Event @1-E46342EA
    #Region " Web Form Designer Generated Code "
    Protected Overrides Sub OnInit(ByVal e As EventArgs)
        '
        ' CODEGEN: This call is required by the ASP.NET Web Form Designer.
        '
        InitializeComponent()
        'Me.Load += new System.EventHandler(this.Page_Load);
        'Me.Unload += new System.EventHandler(this.Page_Unload);
        employeesData = New employeesDataProvider()
        MyBase.OnInit(e)
'End OnInit Event

'OnInit Event tail @1-E31F8E2A
    End Sub
'End OnInit Event tail

'InitializeComponent Event @1-EA5E2628
    ' <summary>
    ' Required method for Designer support - do not modify
    ' the contents of this method with the code editor.
    ' </summary>
    Private Sub InitializeComponent()
    End Sub
    #End Region
'End InitializeComponent Event

'Page class tail @1-DD082417
End Class
End Namespace
'End Page class tail

