//Using Statements @1-18EA64EA
using System;
using System.Collections;
using System.Collections.Specialized;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Text.RegularExpressions;
using System.Globalization;
using CCSExamplePack;
using CCSExamplePack.Data;
using CCSExamplePack.Configuration;
using CCSExamplePack.Controls;

namespace CCSExamplePack.OrderEntry.OrderEntry
{

//End Using Statements

//Forms Definition @1-8B3B8357
public class OrderEntryPage : System.Web.UI.Page
{
//End Forms Definition

//Forms Objects @1-533A7F6D
    protected System.Web.UI.WebControls.Repeater store_orders_gridRepeater;
    protected store_orders_gridDataProvider store_orders_gridData;
    protected store_orders_recordDataProvider store_orders_recordData;
    protected HtmlInputButton store_orders_recordButton_Insert;
    protected HtmlInputButton store_orders_recordButton_Update;
    protected HtmlInputButton store_orders_recordButton_Delete;
    protected System.Web.UI.WebControls.PlaceHolder store_orders_recordError;
    protected System.Web.UI.HtmlControls.HtmlTable store_orders_recordHolder;
    protected System.Web.UI.WebControls.Label store_orders_recordErrorLabel;
    protected bool store_orders_recordInsertAllowed=true;
    protected bool store_orders_recordUpdateAllowed=true;
    protected bool store_orders_recordDeleteAllowed=true;
    protected NameValueCollection store_orders_recordErrors=new NameValueCollection();
    protected System.Web.UI.HtmlControls.HtmlSelect store_orders_recorduser_id;
    protected System.Web.UI.WebControls.TextBox store_orders_recordorder_date;
    protected System.Web.UI.WebControls.PlaceHolder store_orders_recordDatePicker1;
    protected string store_orders_recordDatePicker1Name;
    protected string store_orders_recordDatePicker1DateControl;
    protected System.Web.UI.WebControls.Repeater store_orders_itemsRepeater;
    protected store_orders_itemsDataProvider store_orders_itemsData;
    protected NameValueCollection store_orders_itemsErrors=new NameValueCollection();
    protected System.Web.UI.HtmlControls.HtmlAnchor Link1;
//End Forms Objects
	private string OrdersEmtyRowId;

//Page_Load Event @1-55207E05
private void Page_Load(object sender, System.EventArgs e)
{
//End Page_Load Event

//Page_Load Event BeforeIsPostBack @1-284E040C
    if (!IsPostBack)
    {
            PageDataProvider PageData=new PageDataProvider();
            PageItem item=PageItem.CreateFromHttpRequest();
            item.Link1Href = "OrderEntry_desc.aspx";
            PageData.FillItem(item);
            Link1.InnerText += item.Link1.GetFormattedValue().Replace("\r","").Replace("\n","<br>");
            Link1.HRef += item.Link1Href+item.Link1HrefParameters.ToString("None","", ViewState);
            store_orders_gridBind();
            store_orders_recordShow();
            store_orders_itemsBind();
    }
//End Page_Load Event BeforeIsPostBack

//Page_Load Event tail @1-FCB6E20C
}
//End Page_Load Event tail

//Page_Unload Event @1-72102C7C
private void Page_Unload(object sender, System.EventArgs e)
{
//End Page_Unload Event

//Page_Unload Event tail @1-FCB6E20C
}
//End Page_Unload Event tail

//Grid store_orders_grid Bind @3-2C2C408F
    protected void store_orders_gridBind()
    {
        int PagesCount;
        int FooterIndex;
        if (!IsPostBack)
        {
            string Param;
            int PageSize;
            ViewState["store_orders_gridSortField"] = store_orders_gridDataProvider.SortFields.Default;
            PageSize = 10;
            ViewState["store_orders_gridPageNumber"] = 1;
            Param = Request.QueryString["store_orders_gridOrder"];
            if (Param != null && Param.Length > 0)
                try{
                    store_orders_gridDataProvider.SortFields SortField = 0;
                    ViewState["store_orders_gridSortField"] = Enum.Parse(SortField.GetType(), Param);
                }catch {}
            Param = Request.QueryString["store_orders_gridDir"];
            if (Param == null || Param.Length == 0 || Param.ToLower() == "desc")
                ViewState["store_orders_gridSortDir"] = SortDirections.Desc;
            else
                ViewState["store_orders_gridSortDir"] = SortDirections.Asc;
            Param = Request.QueryString["store_orders_gridPage"];
            int PageNumber;
            if (Param != null && Param.Length > 0)
                try
                {
                    PageNumber = Int32.Parse(Param);
                    if (PageNumber > 0) ViewState["store_orders_gridPageNumber"] = PageNumber;
                }
                catch {}
            Param = Request.QueryString["store_orders_gridPageSize"];
            if (Param != null && Param.Length > 0)
                try
                {
                    PageSize = Int32.Parse(Param);
                    if (PageSize <= 0) PageSize = 10;
                }
                catch {}
            if (PageSize > 100)
                PageSize = 100;
            ViewState["store_orders_gridPageSize"] = PageSize;
        }
//End Grid store_orders_grid Bind

//Grid Form store_orders_grid BeforeShow tail @3-E9CDC8A2
        store_orders_gridParameters();
        store_orders_gridData.SortField = (store_orders_gridDataProvider.SortFields)ViewState["store_orders_gridSortField"];
        store_orders_gridData.SortDir = (SortDirections)ViewState["store_orders_gridSortDir"];
        store_orders_gridData.PageNumber = (int)ViewState["store_orders_gridPageNumber"];
        store_orders_gridData.RecordsPerPage = (int)ViewState["store_orders_gridPageSize"];
        store_orders_gridRepeater.DataSource = store_orders_gridData.GetResultSet(out PagesCount);
        ViewState["store_orders_gridPagesCount"] = PagesCount;
        store_orders_gridRepeater.DataBind();
        FooterIndex = store_orders_gridRepeater.Controls.Count - 1;
        if (PagesCount == 0)
        {
            store_orders_gridRepeater.Controls[FooterIndex].FindControl("NoRecords").Visible = true;
        }
        store_orders_gridItem item=new store_orders_gridItem();
        System.Web.UI.HtmlControls.HtmlAnchor store_orders_gridLink1 = (System.Web.UI.HtmlControls.HtmlAnchor)store_orders_gridRepeater.Controls[FooterIndex].FindControl("store_orders_gridLink1");

        item.Link1Href = "OrderEntry.aspx?";

        store_orders_gridLink1.InnerText += item.Link1.GetFormattedValue().Replace("\r","").Replace("\n","<br>");
        store_orders_gridLink1.HRef += item.Link1Href+item.Link1HrefParameters.ToString("GET","order_id", ViewState);
        if(store_orders_gridData.SortField.ToString()=="Sorter_order_id") 
            ((CCSExamplePack.Controls.Sorter)store_orders_gridRepeater.Controls[0].FindControl("Sorter_order_idSorter")).State=store_orders_gridData.SortDir==SortDirections.Asc?SorterState.Ascending:SorterState.Descending;
        if(store_orders_gridData.SortField.ToString()=="Sorter_user_id") 
            ((CCSExamplePack.Controls.Sorter)store_orders_gridRepeater.Controls[0].FindControl("Sorter_user_idSorter")).State=store_orders_gridData.SortDir==SortDirections.Asc?SorterState.Ascending:SorterState.Descending;
        if(store_orders_gridData.SortField.ToString()=="Sorter_order_date") 
            ((CCSExamplePack.Controls.Sorter)store_orders_gridRepeater.Controls[0].FindControl("Sorter_order_dateSorter")).State=store_orders_gridData.SortDir==SortDirections.Asc?SorterState.Ascending:SorterState.Descending;
        CCSExamplePack.Controls.Navigator NavigatorNavigator = (CCSExamplePack.Controls.Navigator)store_orders_gridRepeater.Controls[FooterIndex].FindControl("NavigatorNavigator");
        NavigatorNavigator.MaxPage=PagesCount;
        NavigatorNavigator.PageNumber=store_orders_gridData.PageNumber;
        NavigatorNavigator.DataBind();
//End Grid Form store_orders_grid BeforeShow tail

//Grid store_orders_grid Bind tail @3-FCB6E20C
    }
//End Grid store_orders_grid Bind tail

//Grid store_orders_grid Table Parameters @3-51185510
    protected void store_orders_gridParameters()
    {
        try{
        }catch{
            ControlCollection ParentControls=store_orders_gridRepeater.Parent.Controls;
            int RepeaterIndex=ParentControls.IndexOf(store_orders_gridRepeater);
            ParentControls.RemoveAt(RepeaterIndex);
            Literal ErrorMessage=new Literal();
            ErrorMessage.Text="Error in Grid store_orders_grid: Invalid parameter";
            ParentControls.AddAt(RepeaterIndex,ErrorMessage);
        }
	}
	
//End Grid store_orders_grid Table Parameters

//Grid store_orders_grid ItemDataBound event @3-CB0DEF27
    protected void store_orders_gridItemDataBound(Object Sender, RepeaterItemEventArgs e)
    {
        store_orders_gridItem DataItem=(store_orders_gridItem)e.Item.DataItem;
        if (e.Item.ItemType == ListItemType.Item || e.Item.ItemType == ListItemType.AlternatingItem) {
            System.Web.UI.HtmlControls.HtmlAnchor store_orders_gridorder_id = (System.Web.UI.HtmlControls.HtmlAnchor)(e.Item.FindControl("store_orders_gridorder_id"));
            DataItem.order_idHref = "OrderEntry.aspx?";
            store_orders_gridorder_id.HRef += DataItem.order_idHref + DataItem.order_idHrefParameters.ToString("GET","", ViewState);
        }
//End Grid store_orders_grid ItemDataBound event

//Grid store_orders_grid ItemDataBound event tail @3-FCB6E20C
    }
//End Grid store_orders_grid ItemDataBound event tail

//Grid store_orders_grid ItemCommand event @3-12E6CA1F
    protected void store_orders_gridItemCommand(Object Sender, RepeaterCommandEventArgs e)
    {
        int FooterIndex = store_orders_gridRepeater.Controls.Count - 1;
        bool BindAllowed = false;
        if(e.CommandName=="Sort"){
            if(((SorterState)e.CommandArgument)==SorterState.None)
                if((SortDirections)ViewState["store_orders_gridSortDir"]==SortDirections.Asc&&ViewState["store_orders_gridSortField"].ToString()==((CCSExamplePack.Controls.Sorter)e.CommandSource).Field)
                    ViewState["store_orders_gridSortDir"]=SortDirections.Desc;
                else
                    ViewState["store_orders_gridSortDir"]=SortDirections.Asc;
            else
                ViewState["store_orders_gridSortDir"]=(int)(((CCSExamplePack.Controls.Sorter)e.CommandSource).State);
            ViewState["store_orders_gridSortField"]=Enum.Parse(typeof(store_orders_gridDataProvider.SortFields),((CCSExamplePack.Controls.Sorter)e.CommandSource).Field);
            ViewState["store_orders_gridPageNumber"] = 1;
            BindAllowed = true;
        }
        if(e.CommandName=="Navigate"){
            ViewState["store_orders_gridPageNumber"] = Int32.Parse(e.CommandArgument.ToString());
            BindAllowed = true;
        }
        if (BindAllowed)
            store_orders_gridBind();
    }
//End Grid store_orders_grid ItemCommand event

//Record Form store_orders_record Parameters @64-FE30CACB
    protected void store_orders_recordParameters()
    {
        try{
            store_orders_recordData.Urlorder_id= IntegerParameter.GetParam(Request.QueryString["order_id"], (object)(-1));
        }catch(Exception e){
            store_orders_recordErrors.Add("Parameters","Form parameters: " + e.Message);
        }
    }
//End Record Form store_orders_record Parameters

//Record Form store_orders_record Show method @64-60C9BAA0
    protected void store_orders_recordShow()
    {
        bool AllowRead = true,AllowInsert = true,AllowUpdate = true,AllowDelete = true;
        store_orders_recordItem item=store_orders_recordItem.CreateFromHttpRequest();
        bool IsInsertMode=!AllowRead;
        store_orders_recordErrors.Add(item.errors);
//End Record Form store_orders_record Show method

//Grid Form store_orders_record BeforeShow tail @64-3FDCA892
        store_orders_recordParameters();
        store_orders_recordData.FillItem(item,ref IsInsertMode);
        store_orders_recordButton_Insert.Visible=IsInsertMode&&AllowInsert;
        store_orders_recordButton_Update.Visible=!IsInsertMode&&AllowUpdate;
        store_orders_recordButton_Delete.Visible=!IsInsertMode&&AllowDelete;
        item.user_idItems.SetSelection(item.user_id.Value);
        store_orders_recorduser_id.SelectedIndex = -1;
        item.user_idItems.CopyTo(store_orders_recorduser_id.Items);
        store_orders_recordorder_date.Text=item.order_date.GetFormattedValue();
        store_orders_recordDatePicker1Name = "store_orders_record_DatePicker1";
        store_orders_recordDatePicker1DateControl = store_orders_recordorder_date.ClientID;
        store_orders_recordDatePicker1.DataBind();
//End Grid Form store_orders_record BeforeShow tail

//Record store_orders_record Event BeforeShow. Action Custom Code @74-2A29BDB7
	if(IsInsertMode) store_orders_itemsRepeater.Visible = false;
//End Record store_orders_record Event BeforeShow. Action Custom Code

//Record Form store_orders_record Show method tail @64-D38C1CAC
        if(store_orders_recordErrors.Count>0)
            store_orders_recordShowErrors();
    }
//End Record Form store_orders_record Show method tail

//Record Form store_orders_record LoadItemFromRequest method @64-0041C9B4
    protected void store_orders_recordLoadItemFromRequest(store_orders_recordItem item, bool EnableValidation)
    {
        try{
        item.user_id.SetValue(store_orders_recorduser_id.Value);
        }catch(ArgumentException){
            store_orders_recordErrors.Add("user_id","The value in field Customer is not valid.");}
        try{
        item.order_date.SetValue(store_orders_recordorder_date.Text);
        }catch(ArgumentException){
            string Format=@"mm/dd/yyyy";
            store_orders_recordErrors.Add("order_date","The value in field Order Date is not valid. Use the following format: "+Format+".");}
        if(EnableValidation)
            item.Validate(store_orders_recordData);
        store_orders_recordErrors.Add(item.errors);
    }
//End Record Form store_orders_record LoadItemFromRequest method

//Record Form store_orders_record GetRedirectUrl method @64-9B6527F1
    protected string Getstore_orders_recordRedirectUrl(string redirectString ,string removeList)
    {
        string Params="";
        string[] List=("order_id;" + removeList).ToLower().Split(new Char[] {';'});

        if(redirectString == "") redirectString = "OrderEntry.aspx";
        for(int i = 0; i < Request.QueryString.Count;i ++)
            if(Array.IndexOf(List,Request.QueryString.AllKeys[i].ToLower()) < 0)
                Params += Request.QueryString.AllKeys[i] + "=" + Server.UrlEncode(Request.QueryString[i]) + "&";
        Params = Params.TrimEnd(new Char[]{'&'});
        return redirectString + "?" + Params;
    }

//End Record Form store_orders_record GetRedirectUrl method

//Record Form store_orders_record ShowErrors method @64-592506F5
    protected void store_orders_recordShowErrors()
    {
        string DefaultMessage="";
        for(int i=0;i<store_orders_recordErrors.Count;i++)
        switch(store_orders_recordErrors.AllKeys[i])
        {
            default:
                DefaultMessage+=store_orders_recordErrors[i]+"<br>";
                break;
        }
        store_orders_recordError.Visible = true;
        store_orders_recordErrorLabel.Text = DefaultMessage;
    }
//End Record Form store_orders_record ShowErrors method

//Record Form store_orders_record Insert Operation @64-3C397C37
    protected void store_orders_record_Insert(object sender, System.EventArgs e)
    {
        bool ExecuteFlag = true;
        bool ErrorFlag = false;
        store_orders_recordItem item=new store_orders_recordItem();
        string RedirectUrl = Getstore_orders_recordRedirectUrl("", "");
//End Record Form store_orders_record Insert Operation

//Record Form store_orders_record BeforeInsert tail @64-7985CF00
    store_orders_recordParameters();
    store_orders_recordLoadItemFromRequest(item, true);
    if(store_orders_recordInsertAllowed){
    ErrorFlag=(store_orders_recordErrors.Count>0);
        if(ExecuteFlag&&!ErrorFlag)
            try
            {
                store_orders_recordData.InsertItem(item);
            }
            catch (Exception ex)
            {
                store_orders_recordErrors.Add("DataProvider",ex.Message);
                ErrorFlag=true;
            }
//End Record Form store_orders_record BeforeInsert tail

//Record store_orders_record Event AfterInsert. Action Custom Code @73-2A29BDB7

	DataAccessObject NewDao = Settings.IntranetDBDataAccessObject;
    RedirectUrl += "&order_id=" + NewDao.ExecuteScalar("SELECT max(order_id) FROM orders").ToString();

//End Record store_orders_record Event AfterInsert. Action Custom Code

//Record Form store_orders_record AfterInsert tail  @64-3C94940B
        }
        if(ErrorFlag)
            store_orders_recordShowErrors();
        else
            Response.Redirect(RedirectUrl);
    }
//End Record Form store_orders_record AfterInsert tail 

//Record Form store_orders_record Update Operation @64-74DA5946
    protected void store_orders_record_Update(object sender, System.EventArgs e)
    {
        store_orders_recordItem item=new store_orders_recordItem();
        item.IsNew = false;
        bool ExecuteFlag = true;
        bool ErrorFlag = false;
        string RedirectUrl = Getstore_orders_recordRedirectUrl("", "");
//End Record Form store_orders_record Update Operation

//Record Form store_orders_record Before Update tail @64-9AF96614
        store_orders_recordParameters();
        store_orders_recordLoadItemFromRequest(item, true);
        if(store_orders_recordUpdateAllowed){
        ErrorFlag=(store_orders_recordErrors.Count>0);
        if(ExecuteFlag&&!ErrorFlag)
            try
            {
                store_orders_recordData.UpdateItem(item);
            }
            catch (Exception ex)
            {
                store_orders_recordErrors.Add("DataProvider",ex.Message);
                ErrorFlag=true;
            }
//End Record Form store_orders_record Before Update tail

//Record Form store_orders_record Update Operation tail @64-3C94940B
        }
        if(ErrorFlag)
            store_orders_recordShowErrors();
        else
            Response.Redirect(RedirectUrl);
    }
//End Record Form store_orders_record Update Operation tail

//Record Form store_orders_record Delete Operation @64-B8DA2536
    protected void store_orders_record_Delete(object sender,System.EventArgs e)
    {
        bool ExecuteFlag = true;
        bool ErrorFlag = false;
        string RedirectUrl = Getstore_orders_recordRedirectUrl("", "");
        store_orders_recordItem item=new store_orders_recordItem();
        item.IsNew = false;
        item.IsDeleted = true;
//End Record Form store_orders_record Delete Operation

//Record store_orders_record Event BeforeDelete. Action Custom Code @75-2A29BDB7
  if(Request.QueryString["order_id"]!=null){
	  DataAccessObject NewDao = Settings.IntranetDBDataAccessObject;
	  NewDao.ExecuteNonQuery("DELETE FROM order_items WHERE order_id=" + NewDao.ToSql(Request.QueryString["order_id"],FieldType.Integer));
  }    
//End Record store_orders_record Event BeforeDelete. Action Custom Code

//Record Form BeforeDelete tail @64-66769EEB
        store_orders_recordParameters();
        store_orders_recordLoadItemFromRequest(item, false);
        if(store_orders_recordDeleteAllowed){
        ErrorFlag = (store_orders_recordErrors.Count > 0);
        if(ExecuteFlag && !ErrorFlag)
            try
            {
                store_orders_recordData.DeleteItem();
            }
            catch (Exception ex)
            {
                store_orders_recordErrors.Add("DataProvider", ex.Message);
                ErrorFlag = true;
            }
//End Record Form BeforeDelete tail

//Record Form AfterDelete tail @64-3C94940B
        }
        if(ErrorFlag)
            store_orders_recordShowErrors();
        else
            Response.Redirect(RedirectUrl);
    }
//End Record Form AfterDelete tail

//Record Form store_orders_record Cancel Operation @64-D6C899A6
    protected void store_orders_record_Cancel(object sender,System.EventArgs e)
    {
        store_orders_recordItem item=new store_orders_recordItem();
        string RedirectUrl = Getstore_orders_recordRedirectUrl("", "");
        store_orders_recordLoadItemFromRequest(item, true);
//End Record Form store_orders_record Cancel Operation

//Record Form store_orders_record Cancel Operation tail @64-AE897FBA
        Response.Redirect(RedirectUrl);
    }
//End Record Form store_orders_record Cancel Operation tail

//EditableGrid store_orders_items Bind @77-FAAED582
    protected void store_orders_itemsBind()
    {
        int PagesCount;
        int FooterIndex;
        if (!IsPostBack)
        {
            string Param;
            int PageSize;
            ViewState["store_orders_itemsSortField"] = store_orders_itemsDataProvider.SortFields.Default;
            PageSize = 0;
            ViewState["store_orders_itemsPageNumber"] = 1;
            Param = Request.QueryString["store_orders_itemsOrder"];
            if (Param != null && Param.Length > 0)
                try{
                    store_orders_itemsDataProvider.SortFields SortField = 0;
                    ViewState["store_orders_itemsSortField"] = Enum.Parse(SortField.GetType(), Param);
                }catch {}
            Param = Request.QueryString["store_orders_itemsDir"];
            if (Param == null || Param.Length == 0 || Param.ToLower() == "desc")
                ViewState["store_orders_itemsSortDir"] = SortDirections.Desc;
            else
                ViewState["store_orders_itemsSortDir"] = SortDirections.Asc;
            Param = Request.QueryString["store_orders_itemsPage"];
            int PageNumber;
            if (Param != null && Param.Length > 0)
                try
                {
                    PageNumber = Int32.Parse(Param);
                    if (PageNumber <= 0) ViewState["store_orders_itemsPageNumber"] = 1;
                }
                catch {}
            Param = Request.QueryString["store_orders_itemsPageSize"];
            if (Param != null && Param.Length > 0)
                try
                {
                    PageSize = Int32.Parse(Param);
                    if (PageSize <= 0) PageSize = 0;
                }
                catch {}
            if (PageSize > 100)
                PageSize = 100;
            ViewState["store_orders_itemsPageSize"] = PageSize;
        }
//End EditableGrid store_orders_items Bind

//Grid Form store_orders_items BeforeShow tail @77-F90703C5
        store_orders_itemsParameters();
        store_orders_itemsData.SortField = (store_orders_itemsDataProvider.SortFields)ViewState["store_orders_itemsSortField"];
        store_orders_itemsData.SortDir = (SortDirections)ViewState["store_orders_itemsSortDir"];
        store_orders_itemsData.PageNumber = (int)ViewState["store_orders_itemsPageNumber"];
        store_orders_itemsData.RecordsPerPage = (int)ViewState["store_orders_itemsPageSize"];
        object dataSource = store_orders_itemsData.GetResultSet(out PagesCount);
        store_orders_itemsRepeater.DataSource = store_orders_itemsData.GetResultSet(out PagesCount);
        ViewState["store_orders_itemsPagesCount"] = PagesCount;
        ViewState["store_orders_itemsFormState"] = new Hashtable();
        store_orders_itemsRepeater.DataBind();
        FooterIndex = store_orders_itemsRepeater.Controls.Count - 1;
        Literal Script = (Literal)store_orders_itemsRepeater.Controls[0].FindControl("FormScript");
        Literal Elements = (Literal)store_orders_itemsRepeater.Controls[0].FindControl("ElementsID");
        Elements.Text += "var store_orders_itemsStaticElementsID;\n";
        string StaticElementsID = "store_orders_itemsStaticElementsID = new Array (";
        Elements.Text += "var store_orders_itemsPriceArrayID=0;\n";
        StaticElementsID += "document.forms[\"_ctl0\"]." + store_orders_itemsRepeater.Controls[0].FindControl("store_orders_itemsPriceArray").ClientID + ",";
        Elements.Text += "var store_orders_itemsAddItemBtnID=1;\n";
        StaticElementsID += "document.forms[\"_ctl0\"]." + store_orders_itemsRepeater.Controls[FooterIndex].FindControl("store_orders_itemsAddItemBtn").ClientID + ",";
        Elements.Text += "var store_orders_itemsButton_SubmitID=2;\n";
        StaticElementsID += "document.forms[\"_ctl0\"]." + store_orders_itemsRepeater.Controls[FooterIndex].FindControl("store_orders_itemsButton_Submit").ClientID + "";
        Script.Text += StaticElementsID + ");\n";
        Elements.Text += "var store_orders_itemsEmptyRows = 30;\n";
        Script.Text += "store_orders_itemsElements = new Array (";
        Elements.Text += "var store_orders_itemsorder_idID=0;\n";
        Elements.Text += "var store_orders_itemsproduct_idID=1;\n";
        Elements.Text += "var store_orders_itemspriceID=2;\n";
        Elements.Text += "var store_orders_itemsquantityID=3;\n";
        Elements.Text += "var store_orders_itemsSumPriceID=4;\n";
        Elements.Text += "var store_orders_itemsDelete1ID=5;\n";
        Elements.Text += "var store_orders_itemsDeleteControl = 5;\n";
        foreach(Control col in store_orders_itemsRepeater.Controls){
            if(((RepeaterItem)col).ItemType == ListItemType.Item || ((RepeaterItem)col).ItemType == ListItemType.AlternatingItem){
                string arr = "";
                arr += "document.forms[\"_ctl0\"]." + col.FindControl("store_orders_itemsorder_id").ClientID + ",";
                arr += "document.forms[\"_ctl0\"]." + col.FindControl("store_orders_itemsproduct_id").ClientID + ",";
                arr += "document.forms[\"_ctl0\"]." + col.FindControl("store_orders_itemsprice").ClientID + ",";
                arr += "document.forms[\"_ctl0\"]." + col.FindControl("store_orders_itemsquantity").ClientID + ",";
                arr += "document.forms[\"_ctl0\"]." + col.FindControl("store_orders_itemsSumPrice").ClientID + ",";
                arr += "document.forms[\"_ctl0\"]." + col.FindControl("store_orders_itemsDelete1").ClientID + ",";
                Script.Text += ("\nnew Array(" + arr.TrimEnd(new char[] {','}) + "),");}
        }
        Script.Text = Script.Text.TrimEnd(new char[] {','}) + ");";
        store_orders_itemsItem item=new store_orders_itemsItem();
        System.Web.UI.WebControls.Literal store_orders_itemsPriceArray = (System.Web.UI.WebControls.Literal)store_orders_itemsRepeater.Controls[0].FindControl("store_orders_itemsPriceArray");


        store_orders_itemsPriceArray.Text=item.PriceArray.GetFormattedValue();
        if (PagesCount == 0)
        {
            store_orders_itemsRepeater.Controls[FooterIndex].FindControl("NoRecords").Visible = true;
        }
        if (store_orders_itemsErrors.Count > 0)
        {
            System.Web.UI.WebControls.Label Error = (System.Web.UI.WebControls.Label)(store_orders_itemsRepeater.Controls[0].FindControl("ErrorLabel"));
            PlaceHolder RowError = (System.Web.UI.WebControls.PlaceHolder)(store_orders_itemsRepeater.Controls[0].FindControl("store_orders_itemsError"));
            RowError.Visible = true;
            foreach(string msg in store_orders_itemsErrors)
                Error.Text += store_orders_itemsErrors[msg] + "<br/>";
        }
//End Grid Form store_orders_items BeforeShow tail

//store_orders_items controls Before Show @77-15D54739
        {
//End store_orders_items controls Before Show

//EditableGrid PriceArray Event BeforeShow. Action Custom Code @79-2A29BDB7
    	DataRowCollection dr = Settings.IntranetDBDataAccessObject.RunSql("SELECT product_id,price FROM products").Tables[0].Rows;
		string prices = "<script language=\"JavaScript\"> product_price = new Array ();";
		for(int i=0;i<dr.Count;i++)
			prices += "product_price[" + dr[i]["product_id"].ToString() + "]=\"" + dr[i]["price"].ToString() + "\"; ";
		store_orders_itemsPriceArray.Text = prices + " </script>";
//End EditableGrid PriceArray Event BeforeShow. Action Custom Code

//store_orders_items controls Before Show tail @77-FCB6E20C
        }
//End store_orders_items controls Before Show tail

//Control store_orders_items Event BeforeShow. Action Custom Code @117-2A29BDB7
	ViewState["OrdersRowIDs"] = OrdersEmtyRowId.TrimEnd(new Char[]{','});
	if (store_orders_itemsRepeater.Visible) {
      RegisterArrayDeclaration("OrdersRowIDs",OrdersEmtyRowId.TrimEnd(new Char[]{','}));
    }
//End Control store_orders_items Event BeforeShow. Action Custom Code

//EditableGrid store_orders_items Bind tail @77-C1D119CF
        store_orders_itemsShowErrors(new ArrayList((ICollection)store_orders_itemsRepeater.DataSource), store_orders_itemsRepeater.Items);
    }
//End EditableGrid store_orders_items Bind tail

//EditableGrid store_orders_items Table Parameters @77-37032AFD
    protected void store_orders_itemsParameters()
    {
        try{
            store_orders_itemsData.Urlorder_id= IntegerParameter.GetParam(Request.QueryString["order_id"], (object)(-1));
        }catch{
            ControlCollection ParentControls=store_orders_itemsRepeater.Parent.Controls;
            int RepeaterIndex=ParentControls.IndexOf(store_orders_itemsRepeater);
            ParentControls.RemoveAt(RepeaterIndex);
            Literal ErrorMessage=new Literal();
            ErrorMessage.Text="Error in Grid store_orders_items: Invalid parameter";
            ParentControls.AddAt(RepeaterIndex,ErrorMessage);
        }
	}
	
//End EditableGrid store_orders_items Table Parameters

//EditableGrid store_orders_items ItemDataBound event @77-A6F1B819
    protected void store_orders_itemsItemDataBound(Object Sender, RepeaterItemEventArgs e)
    {
        store_orders_itemsItem DataItem=(store_orders_itemsItem)e.Item.DataItem;
        if (e.Item.ItemType == ListItemType.Item || e.Item.ItemType == ListItemType.AlternatingItem) {
            DataItem.RowId = e.Item.ItemIndex;
            Hashtable formState = (Hashtable)ViewState["store_orders_itemsFormState"];
            formState.Add("order_item_idField:" + e.Item.ItemIndex.ToString(),DataItem.order_item_idField.Value);
            System.Web.UI.HtmlControls.HtmlSelect store_orders_itemsproduct_id = (System.Web.UI.HtmlControls.HtmlSelect)(e.Item.FindControl("store_orders_itemsproduct_id"));
            DataItem.product_idItems.SetSelection(DataItem.product_id.Value);
            store_orders_itemsproduct_id.SelectedIndex = -1;
            DataItem.product_idItems.CopyTo(store_orders_itemsproduct_id.Items);
            System.Web.UI.WebControls.CheckBox store_orders_itemsDelete1 = (System.Web.UI.WebControls.CheckBox)(e.Item.FindControl("store_orders_itemsDelete1"));
            if(DataItem.Delete1CheckedValue.Value.Equals(DataItem.Delete1.Value))
                store_orders_itemsDelete1.Checked = true;
        }
//End EditableGrid store_orders_items ItemDataBound event

//store_orders_items control Before Show @77-77E330BC
        if (e.Item.ItemType == ListItemType.Item || e.Item.ItemType == ListItemType.AlternatingItem) {
//End store_orders_items control Before Show

//Get PriceArray control @78-FB53BDBF
            System.Web.UI.WebControls.Literal store_orders_itemsPriceArray = (System.Web.UI.WebControls.Literal)store_orders_itemsRepeater.Controls[0].FindControl("store_orders_itemsPriceArray");
//End Get PriceArray control

//Control PriceArray Event BeforeShow. Action Custom Code @79-2A29BDB7
    // -------------------------
    // Write your own code here.
    // -------------------------
//End Control PriceArray Event BeforeShow. Action Custom Code

//store_orders_items control Before Show tail @77-FCB6E20C
        }
//End store_orders_items control Before Show tail

//EditableGrid store_orders_items Event BeforeShowRow. Action Custom Code @105-2A29BDB7
	if (e.Item.ItemType == ListItemType.Item || e.Item.ItemType == ListItemType.AlternatingItem){
		if(DataItem.IsEmptyItem){
			OrdersEmtyRowId += e.Item.FindControl("MyRow").ClientID + ",";
			((HtmlControl)e.Item.FindControl("MyRow")).Attributes.Add("style","display:none");
		}
	}
//End EditableGrid store_orders_items Event BeforeShowRow. Action Custom Code

//EditableGrid store_orders_items ItemDataBound event tail @77-FCB6E20C
    }
//End EditableGrid store_orders_items ItemDataBound event tail

//EditableGrid store_orders_items GetRedirectUrl method @77-265877E5
    protected string Getstore_orders_itemsRedirectUrl(string redirectString ,string removeList)
    {
        string Params="";
        string[] List;

        if(removeList=="")
            List=new string[1];
        else
            List=removeList.Split(new Char[] {';'});

        if(redirectString == "") redirectString = Request.Url.AbsolutePath;
        for(int i = 0; i < Request.QueryString.Count;i ++)
            if(Array.IndexOf(List,Request.QueryString.AllKeys[i]) < 0)
                Params += Request.QueryString.AllKeys[i] + "=" + Server.UrlEncode(Request.QueryString[i]) + "&";
        Params = Params.TrimEnd(new Char[]{'&'});
        return redirectString + "?" + Params;
    }
    protected string Getstore_orders_itemsRedirectUrl(string redirectString)
    {
        return Getstore_orders_itemsRedirectUrl(redirectString ,"");
    }
//End EditableGrid store_orders_items GetRedirectUrl method

//EditableGrid store_orders_items ShowErrors method @77-EA740A3C
    protected bool store_orders_itemsShowErrors(ArrayList items, RepeaterItemCollection col)
    {
        bool result = true;
        foreach(store_orders_itemsItem item in items)
        {
            if(item.IsUpdated) col[item.RowId].Visible = false;
            if(item.errors.Count > 0){
                result = false;
                string DefaultMessage="";
                for(int j = 0; j < item.errors.Count; j ++)
                switch (item.errors.AllKeys[j])
                {
                    default:
                        DefaultMessage += item.errors[j] + "<br>";
                        break;
                }
                System.Web.UI.WebControls.Label Error = (System.Web.UI.WebControls.Label)(col[item.RowId].FindControl("ErrorLabel"));
                col[item.RowId].FindControl("RowError").Visible = true;
                Error.Text = DefaultMessage;
            }
        }
        return result;
    }
//End EditableGrid store_orders_items ShowErrors method

//EditableGrid store_orders_items ItemCommand event @77-E9B4095F
    protected void store_orders_itemsItemCommand(Object Sender, RepeaterCommandEventArgs e)
    {
        int FooterIndex = store_orders_itemsRepeater.Controls.Count - 1;
        bool BindAllowed = false;
//End EditableGrid store_orders_items ItemCommand event

//EditableGrid Form store_orders_items ItemCommand event tail @77-F7B8A015
        if(e.CommandName=="Sort"){
            if(((SorterState)e.CommandArgument)==SorterState.None)
                if((SortDirections)ViewState["store_orders_itemsSortDir"]==SortDirections.Asc&&ViewState["store_orders_itemsSortField"].ToString()==((CCSExamplePack.Controls.Sorter)e.CommandSource).Field)
                    ViewState["store_orders_itemsSortDir"]=SortDirections.Desc;
                else
                    ViewState["store_orders_itemsSortDir"]=SortDirections.Asc;
            else
                ViewState["store_orders_itemsSortDir"]=(int)(((CCSExamplePack.Controls.Sorter)e.CommandSource).State);
            ViewState["store_orders_itemsSortField"]=Enum.Parse(typeof(store_orders_itemsDataProvider.SortFields),((CCSExamplePack.Controls.Sorter)e.CommandSource).Field);
            ViewState["store_orders_itemsPageNumber"] = 1;
            BindAllowed = true;
        }

        if(e.CommandName=="Navigate"){
            ViewState["store_orders_itemsPageNumber"] = Int32.Parse(e.CommandArgument.ToString());
            BindAllowed = true;
        }

        if(e.CommandName=="Submit"){
            BindAllowed = true;
            RepeaterItemCollection col=store_orders_itemsRepeater.Items;
            ArrayList items=new ArrayList();
            Hashtable formState = (Hashtable)ViewState["store_orders_itemsFormState"];
            string RedirectUrl = Getstore_orders_itemsRedirectUrl("");
            store_orders_itemsParameters();
            for(int i=0;i<col.Count;i++)
                if(col[i].ItemType == ListItemType.Item || col[i].ItemType == ListItemType.AlternatingItem){
                    System.Web.UI.WebControls.Literal store_orders_itemsPriceArray = (System.Web.UI.WebControls.Literal)store_orders_itemsRepeater.Controls[0].FindControl("store_orders_itemsPriceArray");
                    System.Web.UI.WebControls.Literal store_orders_itemsRowIDAttribute = (System.Web.UI.WebControls.Literal)(col[i].FindControl("store_orders_itemsRowIDAttribute"));
                    System.Web.UI.WebControls.Literal store_orders_itemsRowNameAttribute = (System.Web.UI.WebControls.Literal)(col[i].FindControl("store_orders_itemsRowNameAttribute"));
                    System.Web.UI.WebControls.Literal store_orders_itemsRowStyleAttribute = (System.Web.UI.WebControls.Literal)(col[i].FindControl("store_orders_itemsRowStyleAttribute"));
                    System.Web.UI.HtmlControls.HtmlInputHidden store_orders_itemsorder_id = (System.Web.UI.HtmlControls.HtmlInputHidden)(col[i].FindControl("store_orders_itemsorder_id"));
                    System.Web.UI.HtmlControls.HtmlSelect store_orders_itemsproduct_id = (System.Web.UI.HtmlControls.HtmlSelect)(col[i].FindControl("store_orders_itemsproduct_id"));
                    System.Web.UI.WebControls.TextBox store_orders_itemsprice = (System.Web.UI.WebControls.TextBox)(col[i].FindControl("store_orders_itemsprice"));
                    System.Web.UI.WebControls.TextBox store_orders_itemsquantity = (System.Web.UI.WebControls.TextBox)(col[i].FindControl("store_orders_itemsquantity"));
                    System.Web.UI.WebControls.TextBox store_orders_itemsSumPrice = (System.Web.UI.WebControls.TextBox)(col[i].FindControl("store_orders_itemsSumPrice"));
                    System.Web.UI.WebControls.CheckBox store_orders_itemsDelete1 = (System.Web.UI.WebControls.CheckBox)(col[i].FindControl("store_orders_itemsDelete1"));
                    col[i].FindControl("RowError").Visible = false;
                    store_orders_itemsItem item = new store_orders_itemsItem();
                    item.RowId = col[i].ItemIndex;
                    item.IsUpdated = !col[i].Visible;
                    item.order_item_idField.Value = formState["order_item_idField:" + col[i].ItemIndex.ToString()];
                    item.IsDeleted = store_orders_itemsDelete1.Checked;
                    item.PriceArray.SetValue(store_orders_itemsPriceArray.Text);
                    item.RowIDAttribute.SetValue(store_orders_itemsRowIDAttribute.Text);
                    item.RowNameAttribute.SetValue(store_orders_itemsRowNameAttribute.Text);
                    item.RowStyleAttribute.SetValue(store_orders_itemsRowStyleAttribute.Text);
                    try{
                    item.order_id.SetValue(store_orders_itemsorder_id.Value);
                    }catch(ArgumentException){
                        item.errors.Add("order_id","The value in field Order Id is not valid.");}
                    try{
                    item.product_id.SetValue(store_orders_itemsproduct_id.Value);
                    }catch(ArgumentException){
                        item.errors.Add("product_id","The value in field Product Id is not valid.");}
                    try{
                    item.price.SetValue(store_orders_itemsprice.Text);
                    }catch(ArgumentException){
                        string Format=@"0.00";
                        item.errors.Add("price","The value in field Price is not valid. Use the following format: "+Format+".");}
                    try{
                    item.quantity.SetValue(store_orders_itemsquantity.Text);
                    }catch(ArgumentException){
                        item.errors.Add("quantity","The value in field Quantity is not valid.");}
                    item.SumPrice.SetValue(store_orders_itemsSumPrice.Text);
                    items.Add(item);

                    if(!item.IsEmptyItem && !item.IsDeleted) BindAllowed = item.Validate(store_orders_itemsData) && BindAllowed;
            }

//End EditableGrid Form store_orders_items ItemCommand event tail

//EditableGrid store_orders_items Event BeforeSubmit. Action Custom Code @118-2A29BDB7
 		foreach(store_orders_itemsItem item in items)
        {
            if(!item.IsEmptyItem){
				((HtmlControl)(col[item.RowId].FindControl("MyRow"))).Attributes.Remove("style");
            }
			RegisterArrayDeclaration("OrdersRowIDs",ViewState["OrdersRowIDs"] as string);
        }
//End EditableGrid store_orders_items Event BeforeSubmit. Action Custom Code

//EditableGrid store_orders_items Update @77-85A25F9F
        if (BindAllowed)
            try
            {
                store_orders_itemsData.Update(items);
                if (store_orders_itemsShowErrors(items, col))
                    Response.Redirect(RedirectUrl);
                else
                    BindAllowed = false;
            }
            catch (Exception ex)
            {
                System.Web.UI.WebControls.Label Error = (System.Web.UI.WebControls.Label)(col[0].FindControl("ErrorLabel"));
                PlaceHolder RowError = (System.Web.UI.WebControls.PlaceHolder)(col[0].FindControl("store_orders_itemsError"));
                RowError.Visible = true;
                Error.Text = "DataProvider:" + ex.Message;
                BindAllowed=false;
            }
//End EditableGrid store_orders_items Update

//EditableGrid store_orders_items AfterSubmit @77-6B72767A
        else
            store_orders_itemsShowErrors(items, col);
        }
        if (BindAllowed)
            store_orders_itemsBind();
    }
//End EditableGrid store_orders_items AfterSubmit

//OnInit Event @1-17A39F1B
    #region Web Form Designer generated code
    override protected void OnInit(EventArgs e)
    {
        //
        //CODEGEN: This call is required by the ASP.NET Web Form Designer.
        //
        InitializeComponent();
        this.Load += new System.EventHandler(this.Page_Load);
        this.Unload += new System.EventHandler(this.Page_Unload);
        store_orders_gridData = new store_orders_gridDataProvider();
        store_orders_recordData = new store_orders_recordDataProvider();
        store_orders_itemsData = new store_orders_itemsDataProvider();
        base.OnInit(e);
//End OnInit Event

//OnInit Event tail @1-FCB6E20C
    }
//End OnInit Event tail

//InitializeComponent Event @1-722FC1EE
    /// <summary>
    /// Required method for Designer support - do not modify
    /// the contents of this method with the code editor.
    /// </summary>
    private void InitializeComponent()
    {
    }
    #endregion
//End InitializeComponent Event

//Page class tail @1-F5FC18C5
}
}
//End Page class tail

