#BindEvents Method @1-42DB874E
sub BindEvents {
    $store_orders_record->{CCSEvents}->{"AfterInsert"} = "store_orders_record_AfterInsert";
    $store_orders_record->{CCSEvents}->{"BeforeShow"} = "store_orders_record_BeforeShow";
    $store_orders_record->{CCSEvents}->{"BeforeDelete"} = "store_orders_record_BeforeDelete";
    $store_orders_items->{PriceArray}->{CCSEvents}->{"BeforeShow"} = "store_orders_items_PriceArray_BeforeShow";
    $store_orders_items->{ds}->{CCSEvents}->{"BeforeBuildInsert"} = "store_orders_items_ds_BeforeBuildInsert";
    $store_orders_items->{CCSEvents}->{"BeforeShowRow"} = "store_orders_items_BeforeShowRow";
}
#End BindEvents Method

$RowNumber = 0;

#store_orders_record_AfterInsert @64-C6AA5ED9
sub store_orders_record_AfterInsert()
{
    $store_orders_record_AfterInsert = 1;
#End store_orders_record_AfterInsert

#Custom Code @73-84ABEA10
  	
	$Redirect = $FileName."?order_id=".CCDlookUp("max(order_id)","orders","", $store_orders_record->{ds});
#End Custom Code

#Close store_orders_record_AfterInsert @64-B4898DC4
    return $store_orders_record_AfterInsert;
}
#End Close store_orders_record_AfterInsert

#store_orders_record_BeforeShow @64-4DFE159E
sub store_orders_record_BeforeShow()
{
    $store_orders_record_BeforeShow = 1;
#End store_orders_record_BeforeShow

#Custom Code @74-84ABEA10

  	if(!$store_orders_record->{EditMode}){ $store_orders_items->{Visible} = 0; }

#End Custom Code

#Close store_orders_record_BeforeShow @64-F3B198F5
    return $store_orders_record_BeforeShow;
}
#End Close store_orders_record_BeforeShow

#store_orders_record_BeforeDelete @64-04C02C7B
sub store_orders_record_BeforeDelete()
{
    $store_orders_record_BeforeDelete = 1;
#End store_orders_record_BeforeDelete

#Custom Code @75-84ABEA10
	
	my $order_id = CCGetFromGet("order_id",0);	
 
	if($order_id=~/^\d+$/){
    
		#Create a new database connection object
    	$NewConnection = clsDBIntranetDB->new();
		
    	$NewConnection->query("DELETE FROM order_items WHERE order_id=".$NewConnection->ToSQL($order_id,$ccsInteger));

    	#Close and destroy the database connection object 
    	$NewConnection->{sth} = undef;
	}    
#End Custom Code

#Close store_orders_record_BeforeDelete @64-9E9F5864
    return $store_orders_record_BeforeDelete;
}
#End Close store_orders_record_BeforeDelete

#store_orders_items_PriceArray_BeforeShow @78-5F154325
sub store_orders_items_PriceArray_BeforeShow()
{
    $store_orders_items_PriceArray_BeforeShow = 1;
#End store_orders_items_PriceArray_BeforeShow

#Custom Code @79-84ABEA10
	
	my $price_str = "";

    $NewConnection = clsDBIntranetDB->new();
	$price_str = "<script language='JavaScript'> product_price = new Array ();";
        
    $NewConnection->query("SELECT product_id,price FROM products");
    while($NewConnection->next_record()){

		$price_str.=" product_price[".$NewConnection->f("product_id")."]='".$NewConnection->f("price")."';";
    			
	}
	$price_str.=" </script>";
    $store_orders_items->{PriceArray}->SetValue($price_str);
    
	#Close and destroy the database connection object
    $NewConnection->{sth} = undef;
    
#End Custom Code

#Close store_orders_items_PriceArray_BeforeShow @78-5D77C37A
    return $store_orders_items_PriceArray_BeforeShow;
}
#End Close store_orders_items_PriceArray_BeforeShow

#store_orders_items_ds_BeforeBuildInsert @77-85F822C3
sub store_orders_items_ds_BeforeBuildInsert()
{
    $store_orders_items_ds_BeforeBuildInsert = 1;
#End store_orders_items_ds_BeforeBuildInsert

#Custom Code @90-84ABEA10

  	my $order_id = CCGetFromGet("order_id",0);
	if($order_id >0){
		$store_orders_items->{ds}->{order_id}->SetValue($order_id);
  	}

#End Custom Code

#Close store_orders_items_ds_BeforeBuildInsert @77-68EBA9A0
    return $store_orders_items_ds_BeforeBuildInsert;
}
#End Close store_orders_items_ds_BeforeBuildInsert

#store_orders_items_BeforeShowRow @77-1F3BDA73
sub store_orders_items_BeforeShowRow()
{
    $store_orders_items_BeforeShowRow = 1;
#End store_orders_items_BeforeShowRow

#Custom Code @105-84ABEA10

	$RowNumber = $RowNumber + 1;
	$store_orders_items->{RowIDAttribute}->SetValue($RowNumber);

	if( ($RowNumber <= $store_orders_items->{ds}->{RecordsCount}) && ($RowNumber <= $store_orders_items->{PageSize}) ){
     $store_orders_items->{RowNameAttribute}->SetValue("FillRow");
  
  	}else{ 
    
		$store_orders_items->{RowNameAttribute}->SetValue("EmptyRow");
     	$store_orders_items->{RowStyleAttribute}->SetValue("style='display:none;'");
     
	 	if($store_orders_items->{EditMode}){
	    
			if($store_orders_items->{RowsErrors}->[$RowNumber]){
				$store_orders_items->{RowStyleAttribute}->SetValue("");
        	} 
	 	}
	}   

#End Custom Code

#Close store_orders_items_BeforeShowRow @77-9FC54EEB
    return $store_orders_items_BeforeShowRow;
}
#End Close store_orders_items_BeforeShowRow


1;
