'Using Statements @1-D0A31CEE
Imports System
Imports System.Text
Imports System.Text.RegularExpressions
Imports System.Collections
Imports System.Collections.Specialized
Imports System.Data
Imports CCSExamplePack
Imports CCSExamplePack.Data
Imports CCSExamplePack.Controls
Imports CCSExamplePack.Configuration

Namespace OrderEntry.OrderEntry
'End Using Statements

'Page Data Class @1-0E92F43E
Public Class PageItem
    Public errors As NameValueCollection = New NameValueCollection()

    Public Sub New()
    End Sub
    Public Shared Function CreateFromHttpRequest() As PageItem
        Dim item As PageItem = New PageItem()
        item.Link1.SetValue(DBUtility.GetInitialValue("Link1"))
        Return item
    End Function

    Default Public Property Field(fieldName As String) As FieldBase
        Get
            Select fieldName
                Case "Link1"
                    Return Link1
                Case Else
                    Throw (New ArgumentOutOfRangeException())
            End Select
        End Get
        Set (ByVal Value As FieldBase)
            Select fieldName
                Case "Link1"
                    Link1 = CType(value, TextField)
                Case Else
                    Throw (New ArgumentOutOfRangeException())
            End Select
        End Set
    End Property

    Public Link1 As TextField = New TextField("",Nothing)
    Public Link1Href As Object
    Public Link1HrefParameters As LinkParameterCollection = New LinkParameterCollection()
End Class
'End Page Data Class

'Page Data Provider Class @1-E3544B64
Public Class PageDataProvider
Dim j As Integer
'End Page Data Provider Class

'Page Data Provider Class Constructor @1-12B526DF

    Public Sub New()
    End Sub
'End Page Data Provider Class Constructor

'Page Data Provider Class GetResultSet Method @1-F73C4626

    Public Sub FillItem(ByVal item As PageItem)
'End Page Data Provider Class GetResultSet Method

'Page Data Provider Class GetResultSet Method tail @1-E31F8E2A
    End Sub
'End Page Data Provider Class GetResultSet Method tail

'Page Data Provider Tail @1-A61BA892
End Class
'End Page Data Provider Tail

'Grid store_orders_grid Item Class @3-A7517922
Public Class store_orders_gridItem
    Public errors As NameValueCollection = New NameValueCollection()
    Public Sub New()
    End Sub

    Public Default Property Field(ByVal fieldName As String) as FieldBase
        Get
            Select fieldName
                Case "order_id"
                    Return Me.order_id
                Case "customer_name"
                    Return Me.customer_name
                Case "order_date"
                    Return Me.order_date
                Case "Link1"
                    Return Me.Link1
                Case Else
                    Throw New ArgumentOutOfRangeException()
            End Select
        End Get
        Set (ByVal Value As FieldBase)
            Select fieldName
                Case "order_id"
                    Me.order_id = CType(Value,IntegerField)
                Case "customer_name"
                    Me.customer_name = CType(Value,TextField)
                Case "order_date"
                    Me.order_date = CType(Value,DateField)
                Case "Link1"
                    Me.Link1 = CType(Value,TextField)
                Case Else
                    Throw New ArgumentOutOfRangeException()
            End Select
        End Set
    End Property

    Public order_id As IntegerField = New IntegerField("",Nothing)
    Public order_idHref As Object
    Public order_idHrefParameters As LinkParameterCollection = New LinkParameterCollection()
    Public customer_name As TextField = New TextField("", Nothing)
    Public order_date As DateField = New DateField(Settings.DateFormat, Nothing)
    Public Link1 As TextField = New TextField("",Nothing)
    Public Link1Href As Object
    Public Link1HrefParameters As LinkParameterCollection = New LinkParameterCollection()
End Class
'End Grid store_orders_grid Item Class

'Grid store_orders_grid Data Provider Class Header @3-7535546A
Public Class store_orders_gridDataProvider
Inherits GridDataProviderBase
'End Grid store_orders_grid Data Provider Class Header

'Grid store_orders_grid Data Provider Class Variables @3-A72F0E76

    Public Enum SortFields
        _Default
        Sorter_order_id
        Sorter_user_id
        Sorter_order_date
    End Enum

    Private SortFieldsNames As String() = New String() {"","order_id","customer_id","order_date"}
    Private SortFieldsNamesDesc As String() = New string() {"","order_id DESC","customer_id DESC","order_date DESC"}
    Public SortField As SortFields = SortFields._Default
    Public SortDir As SortDirections = SortDirections._Asc
    Public RecordsPerPage As Integer = 10
    Public PageNumber As Integer = 1
'End Grid store_orders_grid Data Provider Class Variables

'Grid store_orders_grid Data Provider Class Constructor @3-D420B6AF

    Public Sub New()
        Select_ = New TableCommand("SELECT orders.*, customer_name  " & _
          "FROM customers INNER JOIN orders ON customers.customer_id = orders.order_customer_id",New String(){},Settings.IntranetDBDataAccessObject)
        Count = New TableCommand("SELECT COUNT(*)  " & _
          "FROM customers INNER JOIN orders ON customers.customer_id = orders.order_customer_id",New String(){},Settings.IntranetDBDataAccessObject)
    End Sub
'End Grid store_orders_grid Data Provider Class Constructor

'Grid store_orders_grid Data Provider Class GetResultSet Method @3-336B9160

    Public Function GetResultSet(ByRef PagesCount As Integer) As store_orders_gridItem()
'End Grid store_orders_grid Data Provider Class GetResultSet Method

'Before build Select @3-EB06405A
        Parameters.Clear
        If SortDir = SortDirections._Asc Then
            Select_.OrderBy=SortFieldsNames(CInt(SortField)).Trim()
        Else
            Select_.OrderBy=SortFieldsNamesDesc(CInt(SortField)).Trim()
        End If
'End Before build Select

'Execute Select @3-467AC0A8
        Dim ds As DataSet = Nothing, E as Exception = Nothing
        PagesCount=0
        Try
            If RecordsPerPage>0
                ds=ExecuteSelect((PageNumber-1)*RecordsPerPage,RecordsPerPage)
                PagesCount = ExecuteCount()
                m_recordCount = PagesCount
                If PagesCount Mod RecordsPerPage>0 Then
                    PagesCount = (PagesCount\RecordsPerPage)+1
                Else
                    PagesCount = PagesCount\RecordsPerPage
                End If
            Else
            ds=ExecuteSelect()
            If ds.Tables(0).Rows.Count<>0 Then 
                PagesCount=1
            End If
            End If
        Catch ee as Exception
            E=ee
        Finally
'End Execute Select

'After execute Select @3-E4988485
        If Not IsNothing(E) Then Throw E
        End Try
        Dim dr as DataRowCollection = ds.Tables(0).Rows
        Dim result(dr.Count - 1) as store_orders_gridItem
        Dim j As Integer
'End After execute Select

'After execute Select tail @3-4D93CCD8
        Dim i as Integer
        For i = 0 To dr.Count - 1
            Dim item as store_orders_gridItem = New store_orders_gridItem()
            item.order_id.SetValue(dr(i)("order_id"),"")
            item.order_idHrefParameters.Add("order_id",System.Web.HttpUtility.UrlEncode(dr(i)("order_id").ToString()))
            item.customer_name.SetValue(dr(i)("customer_name"),"")
            item.order_date.SetValue(dr(i)("order_date"),Select_.DateFormat)
            result(i)=item
        Next
        Return result 
    End Function
'End After execute Select tail

'Grid Data Provider tail @3-A61BA892
End Class
'End Grid Data Provider tail

'Record store_orders_record Item Class @64-CF07F61C
Public Class store_orders_recordItem
    Private _isNew As Boolean = True
    Private _isDeleted As Boolean = False
    Public errors As NameValueCollection = New NameValueCollection()

    public Sub New()
    End Sub
    Public user_id As IntegerField = New IntegerField("", Nothing)
    Public user_idItems As ItemCollection = New ItemCollection()
    Public order_date As DateField = New DateField(Settings.DateFormat, Nothing)

    Public Shared Function CreateFromHttpRequest() As store_orders_recordItem
        Dim item As store_orders_recordItem = New store_orders_recordItem()
        If Not IsNothing(DBUtility.GetInitialValue("user_id")) Then
        item.user_id.SetValue(DBUtility.GetInitialValue("user_id"))
        End If 
        If Not IsNothing(DBUtility.GetInitialValue("order_date")) Then
        item.order_date.SetValue(DBUtility.GetInitialValue("order_date"))
        End If 
        If Not IsNothing(DBUtility.GetInitialValue("DatePicker1")) Then
        End If 
        If Not IsNothing(DBUtility.GetInitialValue("Button_Insert")) Then
        End If 
        If Not IsNothing(DBUtility.GetInitialValue("Button_Update")) Then
        End If 
        If Not IsNothing(DBUtility.GetInitialValue("Button_Delete")) Then
        End If 
        Return item
    End Function

    Default Public Property Field(fieldName As String) As FieldBase
        Get
            Select fieldName
                Case "user_id"
                    Return user_id
                Case "order_date"
                    Return order_date
                Case Else
                    Throw (New ArgumentOutOfRangeException())
            End Select
        End Get
        Set (ByVal Value As FieldBase)
            Select fieldName
                Case "user_id"
                    user_id = CType(value, IntegerField)
                Case "order_date"
                    order_date = CType(value, DateField)
                Case Else
                    Throw (New ArgumentOutOfRangeException())
            End Select
        End Set
    End Property

    Public Property IsNew() As Boolean
        Get
            Return _isNew
        End Get
        Set
            _isNew = Value
        End Set
    End Property

    Public Property IsDeleted() As Boolean
        Get
            Return _isDeleted
        End Get
        Set
            _isDeleted = Value
        End Set
    End Property

    Public Sub Validate(ByVal provider As store_orders_recordDataProvider)
'End Record store_orders_record Item Class

'user_id validate @65-298A8584
        If IsNothing(user_id.Value) Then
            errors.Add("user_id","The value in field Customer is required.")
        ElseIf user_id.Value.ToString() ="" Then
            errors.Add("user_id","The value in field Customer is required.")
        End If
'End user_id validate

'Record store_orders_record Item Class tail @64-8B704AE2
    End Sub
End Class
'End Record store_orders_record Item Class tail

'Record store_orders_record Data Provider Class @64-6B0B7A54
Public Class store_orders_recordDataProvider
Inherits RecordDataProviderBase
'End Record store_orders_record Data Provider Class

'Record store_orders_record Data Provider Class Variables @64-05575970
    Protected user_idDataCommand As DataCommand = New TableCommand("SELECT *  " & _
          "FROM customers",New String(){},Settings.IntranetDBDataAccessObject)
    Public Urlorder_id As IntegerParameter
'End Record store_orders_record Data Provider Class Variables

'Record store_orders_record Data Provider Class Constructor @64-C437659F

    Public Sub New()
        Select_ = New TableCommand("SELECT *  " & _
          "FROM orders",New String(){"order_id76"},Settings.IntranetDBDataAccessObject)
        Insert = New TableCommand("INSERT INTO orders(order_customer_id, order_date ) VALUES ( {user_id}, {order_date})" _
          ,New String(){},Settings.IntranetDBDataAccessObject)
        Update = New TableCommand("UPDATE orders SET order_customer_id={user_id}, order_date={order_date}" _
          ,New String(){"order_id76"},Settings.IntranetDBDataAccessObject)
        Delete = New TableCommand("DELETE FROM orders",New String(){"order_id76"},Settings.IntranetDBDataAccessObject)
    End Sub
'End Record store_orders_record Data Provider Class Constructor

'Record store_orders_record Data Provider Class LoadParams Method @64-E773D7A7

    Protected Function LoadParams() As Boolean
        CommonParameters.Clear()
    If IsNothing(Urlorder_id) Then
        CommonParameters.Add("order_id76","")
    Else
        CommonParameters.Add("order_id76","order_id = " & Select_.Dao.ToSql(Urlorder_id.GetFormattedValue(""),FieldType._Integer))
    End If
        Return (IsNothing(Urlorder_id))
    End Function
'End Record store_orders_record Data Provider Class LoadParams Method

'Record store_orders_record Data Provider Class CheckUnique Method @64-5DD255E2

    Public Function CheckUnique(ByVal ControlName As String, ByVal item As store_orders_recordItem) As Boolean
        Return True
    End Function
'End Record store_orders_record Data Provider Class CheckUnique Method

'Record store_orders_record Data Provider Class PrepareInsert Method @64-0E277F0A

    Protected Overrides Sub PrepareInsert()
'End Record store_orders_record Data Provider Class PrepareInsert Method

'Record store_orders_record Data Provider Class PrepareInsert Method tail @64-E31F8E2A
    End Sub
'End Record store_orders_record Data Provider Class PrepareInsert Method tail

'Record store_orders_record Data Provider Class Insert Method @64-74502859

    Public Function InsertItem(ByVal item As store_orders_recordItem) As Integer
'End Record store_orders_record Data Provider Class Insert Method

'Record store_orders_record Build insert @64-907C1D4E
        Insert.SqlQuery.Replace("{user_id}",Insert.Dao.ToSql(item.user_id.GetFormattedValue(""),FieldType._Integer))
        Insert.SqlQuery.Replace("{order_date}",Insert.Dao.ToSql(item.order_date.GetFormattedValue(Insert.DateFormat),FieldType._Date))
        Dim result As Object = Nothing
        Dim E As Exception = Nothing
        Try
            result = ExecuteInsert()
        Catch ee As Exception
            E = ee
        Finally
'End Record store_orders_record Build insert

'Record store_orders_record AfterExecuteInsert @64-2FB4FB62
            If Not IsNothing(E) Then Throw E
        End Try
        Return CType(result, Integer)
    End Function
'End Record store_orders_record AfterExecuteInsert

'Record store_orders_record Data Provider Class PrepareUpdate Method @64-D72B5D1D

    Protected Overrides Sub PrepareUpdate()
        LoadParams()
        Update.Parameters = CommonParameters
'End Record store_orders_record Data Provider Class PrepareUpdate Method

'Record store_orders_record Data Provider Class PrepareUpdate Method tail @64-E31F8E2A
    End Sub
'End Record store_orders_record Data Provider Class PrepareUpdate Method tail

'Record store_orders_record Data Provider Class Update Method @64-4C4F169D

    Public Function UpdateItem(ByVal item As store_orders_recordItem) As Integer
'End Record store_orders_record Data Provider Class Update Method

'Record store_orders_record BeforeBuildUpdate @64-15026C36
        Update.SqlQuery.Replace("{user_id}",Update.Dao.ToSql(item.user_id.GetFormattedValue(""),FieldType._Integer))
        Update.SqlQuery.Replace("{order_date}",Update.Dao.ToSql(item.order_date.GetFormattedValue(Update.DateFormat),FieldType._Date))
        Dim result As Object = Nothing
        Dim E As Exception = Nothing
        Try
            result = ExecuteUpdate()
        Catch ee As Exception
            E = ee
        Finally
'End Record store_orders_record BeforeBuildUpdate

'Record store_orders_record AfterExecuteUpdate @64-2FB4FB62
            If Not IsNothing(E) Then Throw E
        End Try
        Return CType(result, Integer)
    End Function
'End Record store_orders_record AfterExecuteUpdate

'Record store_orders_record Data Provider Class PrepareDelete Method @64-998024F7

    Protected Overrides Sub PrepareDelete()
        LoadParams()
        Delete.Parameters = CommonParameters
'End Record store_orders_record Data Provider Class PrepareDelete Method

'Record store_orders_record Data Provider Class PrepareDelete Method tail @64-E31F8E2A
    End Sub
'End Record store_orders_record Data Provider Class PrepareDelete Method tail

'Record store_orders_record Data Provider Class Delete Method @64-3393434D

    Public Function DeleteItem() As Integer
'End Record store_orders_record Data Provider Class Delete Method

'Record store_orders_record BeforeBuildDelete @64-19F34D29
        Dim result As Object = Nothing
        Dim E As Exception = Nothing
        Try
            result = ExecuteDelete()
        Catch ee As Exception
            E = ee
        Finally
'End Record store_orders_record BeforeBuildDelete

'Record store_orders_record BeforeBuildDelete @64-2FB4FB62
            If Not IsNothing(E) Then Throw E
        End Try
        Return CType(result, Integer)
    End Function
'End Record store_orders_record BeforeBuildDelete

'PrepareSelect Method @64-34AB3510

    Protected Overrides Sub PrepareSelect()
        LoadParams()
        Select_.Parameters = CommonParameters
    End Sub
'End PrepareSelect Method

'Record store_orders_record Data Provider Class GetResultSet Method @64-2001243F

    Public Sub FillItem(ByVal item As store_orders_recordItem, ByRef IsInsertMode As Boolean)
        Dim ReadNotAllowed As Boolean = IsInsertMode
        Dim E As Exception = Nothing
'End Record store_orders_record Data Provider Class GetResultSet Method

'Record store_orders_record BeforeBuildSelect @64-0FCCC126
        IsInsertMode = LoadParams()
        Dim dr As DataRowCollection = Nothing
        If Not IsInsertMode Then
'End Record store_orders_record BeforeBuildSelect

'Record store_orders_record BeforeExecuteSelect @64-EBD3678C
            Try
                dr = ExecuteSelect().Tables(0).Rows
            Catch ee As Exception
                E = ee
            Finally
'End Record store_orders_record BeforeExecuteSelect

'Record store_orders_record AfterExecuteSelect @64-A19FBD30
                If Not IsNothing(E) Then Throw E
        End Try
        End If
        If (Not IsInsertMode) And (Not ReadNotAllowed) Then
            If dr.Count <> 0 Then
                Dim i As Integer = 0
                item.user_id.SetValue(dr(i)("order_customer_id"),"")
                item.order_date.SetValue(dr(i)("order_date"),Select_.DateFormat)
        Else
            IsInsertMode = True
            End If
        End If
        Dim ListBoxSource As DataRowCollection = Nothing
        Dim j As Integer
'End Record store_orders_record AfterExecuteSelect

'ListBox user_id BeforeExecuteSelect @65-0FB3AFB3
        Try
            ListBoxSource=user_idDataCommand.Execute().Tables(0).Rows
        Catch ee as Exception 
            E=ee
        Finally
'End ListBox user_id BeforeExecuteSelect

'ListBox user_id AfterExecuteSelect @65-BE99E394
            If Not IsNothing(E) Then Throw E
        End Try
        For j=0 To ListBoxSource.Count-1 
            Dim Key As String = (New IntegerField("", ListBoxSource(j)("customer_id"))).GetFormattedValue("")
            Dim Val As Object = ListBoxSource(j)("customer_name")
            item.user_idItems.Add(Key, Val)
        Next
'End ListBox user_id AfterExecuteSelect

'Record store_orders_record AfterExecuteSelect tail @64-E31F8E2A
    End Sub
'End Record store_orders_record AfterExecuteSelect tail

'Record store_orders_record Data Provider Class @64-A61BA892
End Class

'End Record store_orders_record Data Provider Class

'EditableGrid store_orders_items Item Class @77-45C6C2B6
Public Class store_orders_itemsItem
    Public errors As NameValueCollection = New NameValueCollection()
    Public RowId As Integer
    Public Sub New()
    End Sub

    Public Default Property Field(ByVal fieldName As String) as FieldBase
        Get
            Select fieldName
                Case "order_item_idField"
                    Return Me.order_item_idField
                Case "PriceArray"
                    Return Me.PriceArray
                Case "RowIDAttribute"
                    Return Me.RowIDAttribute
                Case "RowNameAttribute"
                    Return Me.RowNameAttribute
                Case "RowStyleAttribute"
                    Return Me.RowStyleAttribute
                Case "order_id"
                    Return Me.order_id
                Case "product_id"
                    Return Me.product_id
                Case "price"
                    Return Me.price
                Case "quantity"
                    Return Me.quantity
                Case "SumPrice"
                    Return Me.SumPrice
                Case "Delete1"
                    Return Me.Delete1
                Case Else
                    Throw New ArgumentOutOfRangeException()
            End Select
        End Get
        Set (ByVal Value As FieldBase)
            Select fieldName
                Case "order_item_idField"
                    Me.order_item_idField = CType(Value,IntegerField)
                Case "PriceArray"
                    Me.PriceArray = CType(Value,TextField)
                Case "RowIDAttribute"
                    Me.RowIDAttribute = CType(Value,TextField)
                Case "RowNameAttribute"
                    Me.RowNameAttribute = CType(Value,TextField)
                Case "RowStyleAttribute"
                    Me.RowStyleAttribute = CType(Value,TextField)
                Case "order_id"
                    Me.order_id = CType(Value,IntegerField)
                Case "product_id"
                    Me.product_id = CType(Value,IntegerField)
                Case "price"
                    Me.price = CType(Value,FloatField)
                Case "quantity"
                    Me.quantity = CType(Value,IntegerField)
                Case "SumPrice"
                    Me.SumPrice = CType(Value,TextField)
                Case "Delete1"
                    Me.Delete1 = CType(Value,BooleanField)
                Case Else
                    Throw New ArgumentOutOfRangeException()
            End Select
        End Set
    End Property

    Public ReadOnly Property IsNew As Boolean
        Get
            Dim result As Boolean = True
            Dim result1 As Boolean = True
            result = IsNothing(order_item_idField.Value) And result
            result1 = IsNothing(order_id.Value) And result1
            result1 = IsNothing(product_id.Value) And result1
            result1 = IsNothing(price.Value) And result1
            result1 = IsNothing(quantity.Value) And result1
            result1 = IsNothing(SumPrice.Value) And result1
            result1 = IsNothing(Delete1.Value) And result1
            Return result And (Not result1)
        End Get
    End Property

    Public ReadOnly Property IsEmptyItem As Boolean
        Get
            Dim result As Boolean = True
            result = IsNothing(order_id.Value) And result
            result = IsNothing(product_id.Value) And result
            result = IsNothing(price.Value) And result
            result = IsNothing(quantity.Value) And result
            result = IsNothing(SumPrice.Value) And result
            result = IsNothing(Delete1.Value) And result
            result = IsNothing(order_item_idField.Value) And result
            Return result
        End Get
    End Property

    Public IsDeleted As Boolean = False
    Public IsUpdated As Boolean = False
    Public PriceArray As TextField = New TextField("", Nothing)
    Public RowIDAttribute As TextField = New TextField("", Nothing)
    Public RowNameAttribute As TextField = New TextField("", Nothing)
    Public RowStyleAttribute As TextField = New TextField("", Nothing)
    Public order_id As IntegerField = New IntegerField("", Nothing)
    Public product_id As IntegerField = New IntegerField("", Nothing)
    Public product_idItems As ItemCollection = New ItemCollection()
    Public price As FloatField = New FloatField("0.00", Nothing)
    Public quantity As IntegerField = New IntegerField("", Nothing)
    Public SumPrice As TextField = New TextField("", Nothing)
    Public Delete1 As BooleanField = New BooleanField(Settings.BoolFormat, Nothing)
    Public Delete1CheckedValue As BooleanField = New BooleanField(Settings.BoolFormat, true)
    Public Delete1UncheckedValue As BooleanField = New BooleanField(Settings.BoolFormat, false)

    Public order_item_idField As IntegerField = New IntegerField()
    Public Function Validate(ByVal provider As store_orders_itemsDataProvider) As Boolean
'End EditableGrid store_orders_items Item Class

'product_id validate @81-B0A1FFD5
        If IsNothing(product_id.Value) Then
            errors.Add("product_id","The value in field Product Id is required.")
        ElseIf product_id.Value.ToString() ="" Then
            errors.Add("product_id","The value in field Product Id is required.")
        End If
'End product_id validate

'quantity validate @84-9C48B5B6
        If IsNothing(quantity.Value) Then
            errors.Add("quantity","The value in field Quantity is required.")
        ElseIf quantity.Value.ToString() ="" Then
            errors.Add("quantity","The value in field Quantity is required.")
        End If
'End quantity validate

'EditableGrid store_orders_items Item Class tail @77-9124938E
        Return errors.Count = 0
    End Function
End Class
'End EditableGrid store_orders_items Item Class tail

'EditableGrid store_orders_items Data Provider Class Header @77-5799F515
Public Class store_orders_itemsDataProvider
Inherits EditableGridDataProviderBase
'End EditableGrid store_orders_items Data Provider Class Header

'Grid store_orders_items Data Provider Class Variables @77-1BC09031

    Public Enum SortFields
        _Default
    End Enum

    Private SortFieldsNames As String() = New String() {""}
    Private SortFieldsNamesDesc As String() = New string() {""}
    Public SortField As SortFields = SortFields._Default
    Public SortDir As SortDirections = SortDirections._Asc
    Public RecordsPerPage As Integer = 0
    Public PageNumber As Integer = 1
    Public EmptyRows As Integer = 30
    Public Urlorder_id As IntegerParameter
    Protected product_idDataCommand As DataCommand = New TableCommand("SELECT *  " & _
          "FROM products",New String(){},Settings.IntranetDBDataAccessObject)
'End Grid store_orders_items Data Provider Class Variables

'EditableGrid store_orders_items Data Provider Class Constructor @77-3F2A7362

    Public Sub New()
        Select_ = New TableCommand("SELECT *  " & _
          "FROM order_items",New String(){"order_id92"},Settings.IntranetDBDataAccessObject)
        Count = New TableCommand("SELECT COUNT(*)  " & _
          "FROM order_items",New String(){"order_id92"},Settings.IntranetDBDataAccessObject)
    End Sub
'End EditableGrid store_orders_items Data Provider Class Constructor

'Record store_orders_items Data Provider Class CheckUnique Method @77-BFF5A7BB

    Public Function CheckUnique(ByVal ControlName As String, ByVal item As store_orders_itemsItem) As Boolean
        Return True
    End Function
'End Record store_orders_items Data Provider Class CheckUnique Method

'Grid store_orders_items Data Provider Class Insert Method @77-710EB1A1
    Protected Function InsertItem(ByVal item As store_orders_itemsItem) As Integer
        Dim Insert As DataCommand = New TableCommand("INSERT INTO order_items(order_id, product_id, price, quantity ) VALUES ( {order_id}, {product_id}, {price}, {quantity})" _
          ,New String(){},Settings.IntranetDBDataAccessObject)
'End Grid store_orders_items Data Provider Class Insert Method

'EditableGrid store_orders_items Event BeforeBuildInsert. Action Custom Code @90-73254650
    If Not (System.Web.HttpContext.Current.Request.QueryString("order_id") Is Nothing) Then
   		item.order_id.SetValue(System.Web.HttpContext.Current.Request.QueryString("order_id"))
	End If
'End EditableGrid store_orders_items Event BeforeBuildInsert. Action Custom Code

'EditableGrid store_orders_items Build insert @77-CA65082D
        Insert.SqlQuery.Replace("{order_id}",Insert.Dao.ToSql(item.order_id.GetFormattedValue(""),FieldType._Integer))
        Insert.SqlQuery.Replace("{product_id}",Insert.Dao.ToSql(item.product_id.GetFormattedValue(""),FieldType._Integer))
        Insert.SqlQuery.Replace("{price}",Insert.Dao.ToSql(item.price.GetFormattedValue(""),FieldType._Float))
        Insert.SqlQuery.Replace("{quantity}",Insert.Dao.ToSql(item.quantity.GetFormattedValue(""),FieldType._Integer))
        Insert.SqlQuery.Replace("{SumPrice}",Insert.Dao.ToSql(item.SumPrice.GetFormattedValue(""),FieldType._Text))
'End EditableGrid store_orders_items Build insert

'EditableGrid store_orders_items Data Provider Class ExecuteInsert @77-9E5B2417
        Dim result As Object = Nothing
        Dim E As Exception = Nothing
        Try
            result = Insert.ExecuteNonQuery()
        Catch e_ As Exception
            item.errors.Add("DataProvider",e_.Source + ":" + e_.Message)
            result = 0
        Finally
'End EditableGrid store_orders_items Data Provider Class ExecuteInsert

'EditableGrid store_orders_items AfterExecuteInsert @77-5C54EEF8
        End Try
        Return CType(result, Integer)
    End Function
'End EditableGrid store_orders_items AfterExecuteInsert

'EditableGrid store_orders_items Data Provider Class Update Method @77-37439BB3
    Protected Function UpdateItem(ByVal item As store_orders_itemsItem) As Integer
        Dim Update As DataCommand = New TableCommand("UPDATE order_items SET order_id={order_id}, product_id={product_id}, price={price}, quantity={quantity}" _
          ,New String(){"order_item_id95"},Settings.IntranetDBDataAccessObject)
'End EditableGrid store_orders_items Data Provider Class Update Method

'EditableGrid store_orders_items BeforeBuildUpdate @77-2AFF09B7
        Update.SqlQuery.Replace("{order_id}",Update.Dao.ToSql(item.order_id.GetFormattedValue(""),FieldType._Integer))
        Update.SqlQuery.Replace("{product_id}",Update.Dao.ToSql(item.product_id.GetFormattedValue(""),FieldType._Integer))
        Update.SqlQuery.Replace("{price}",Update.Dao.ToSql(item.price.GetFormattedValue(""),FieldType._Float))
        Update.SqlQuery.Replace("{quantity}",Update.Dao.ToSql(item.quantity.GetFormattedValue(""),FieldType._Integer))
        Update.SqlQuery.Replace("{SumPrice}",Update.Dao.ToSql(item.SumPrice.GetFormattedValue(""),FieldType._Text))
        Update.Parameters.Add("order_item_id95","order_item_id = " & Update.Dao.ToSql(item.order_item_idField.GetFormattedValue(""),FieldType._Integer))
'End EditableGrid store_orders_items BeforeBuildUpdate

'EditableGrid store_orders_items Execute Update  @77-A372D3E2
        Dim result As Object = Nothing
        Dim E As Exception = Nothing
        Try
            result = Update.ExecuteNonQuery()
        Catch e_ As Exception
            item.errors.Add("DataProvider",e_.Source + ":" + e_.Message)
            result = 0
        Finally
'End EditableGrid store_orders_items Execute Update 

'EditableGrid store_orders_items AfterExecuteUpdate @77-5C54EEF8
        End Try
        Return CType(result, Integer)
    End Function
'End EditableGrid store_orders_items AfterExecuteUpdate

'Record store_orders_items Data Provider Class Delete Method @77-D5A9C3D4
    Public Function DeleteItem(ByVal item As store_orders_itemsItem) As Integer
        Dim Delete As DataCommand = New TableCommand("DELETE FROM order_items",New String(){"order_item_id95"},Settings.IntranetDBDataAccessObject)
'End Record store_orders_items Data Provider Class Delete Method

'Record store_orders_items BeforeBuildDelete @77-7FBF5DB1
        Delete.Parameters.Add("order_item_id95","order_item_id = " & Delete.Dao.ToSql(item.order_item_idField.GetFormattedValue(""),FieldType._Integer))
'End Record store_orders_items BeforeBuildDelete

'EditableGrid store_orders_items Data Provider Class Execute Delete @77-2A5D935C
        Dim result As Object = Nothing
        Dim E As Exception = Nothing
        Try
            result = Delete.ExecuteNonQuery()
        Catch e_ As Exception
            item.errors.Add("DataProvider",e_.Source + ":" + e_.Message)
            result = 0
        Finally
'End EditableGrid store_orders_items Data Provider Class Execute Delete

'EditableGrid store_orders_items AfterExecuteDelete @77-5C54EEF8
        End Try
        Return CType(result, Integer)
    End Function
'End EditableGrid store_orders_items AfterExecuteDelete

'Grid store_orders_items Data Provider Class GetResultSet Method @77-50930A75
    Public Sub Update(ByVal Items As ArrayList)
        Update(Items, 0)
    End Sub

    Public Sub Update(ByVal Items As ArrayList, ByVal userGroup As Integer)
        Dim AllowInsert As Boolean = True
        Dim AllowUpdate As Boolean = True
        Dim AllowDelete As Boolean = True
        Dim i As Integer
        For i = 0 To Items.Count - 1
            Dim op As EditableGridOperation = EditableGridOperation.Insert
            Dim isProcessed As Boolean = False
            Dim item As store_orders_itemsItem = CType(Items(i), store_orders_itemsItem)
'End Grid store_orders_items Data Provider Class GetResultSet Method

'EditableGrid store_orders_items Data Provider Class Update @77-222725D8
            If Not item.IsUpdated Then
                If item.IsDeleted And AllowDelete Then
                    DeleteItem(item)
                    op = EditableGridOperation.Delete
                    isProcessed = True
                End If
                If item.IsNew And AllowInsert And Not(isProcessed) Then
                    InsertItem(item)
                    op = EditableGridOperation.Insert
                    isProcessed = True
                End If
                If Not(item.IsEmptyItem) And AllowUpdate And Not(isProcessed) Then
                    UpdateItem(item)
                    op = EditableGridOperation.Update
                End If
'End EditableGrid store_orders_items Data Provider Class Update

'EditableGrid store_orders_items Data Provider Class AfterUpdate @77-6CCB76B9
                If item.errors.Count = 0 Then item.IsUpdated = True
                OnItemUpdated(New ItemUpdatedEventArgs(op, item))
            End If
        Next i
    End Sub
'End EditableGrid store_orders_items Data Provider Class AfterUpdate

'EditableGrid store_orders_items Data Provider Class GetResultSet Method @77-38ABC88E

    Public Function GetResultSet(ByRef PagesCount As Integer) As store_orders_itemsItem()
'End EditableGrid store_orders_items Data Provider Class GetResultSet Method

'Before build Select @77-BFFD54BB
        Dim E as Exception = Nothing
        Parameters.Clear
        If IsNothing(Urlorder_id) Then
            Parameters.Add("order_id92","")
        Else
            Parameters.Add("order_id92","order_id = " & Select_.Dao.ToSql(Urlorder_id.GetFormattedValue(""),FieldType._Integer))
        End If
        If SortDir = SortDirections._Asc Then
            Select_.OrderBy = SortFieldsNames(CInt(SortField)).Trim
        Else
            Select_.OrderBy = SortFieldsNamesDesc(CInt(SortField)).Trim
        End If
'End Before build Select

'Execute Select @77-A2C8CA79
        Dim ds As DataSet = Nothing
        PagesCount=0
        Try
            If RecordsPerPage>0
                ds=ExecuteSelect((PageNumber-1)*RecordsPerPage,RecordsPerPage)
                PagesCount = ExecuteCount()
                m_recordCount = PagesCount
                If PagesCount Mod RecordsPerPage>0 Then
                    PagesCount = (PagesCount\RecordsPerPage)+1
                Else
                    PagesCount = PagesCount\RecordsPerPage
                End If
            Else
            ds=ExecuteSelect()
            If ds.Tables(0).Rows.Count<>0 Then 
                PagesCount=1
            End If
            End If
        Catch ee as Exception
            E=ee
        Finally
'End Execute Select

'After execute Select @77-4F9FC7E9
        If Not IsNothing(E) Then Throw E
        End Try
        Dim dr as DataRowCollection = ds.Tables(0).Rows
        Dim result(dr.Count + EmptyRows - 1) as store_orders_itemsItem
        Dim ListBoxSource As DataRowCollection = Nothing
        Dim j As Integer
'End After execute Select

'ListBox product_id BeforeExecuteSelect @81-4F65AA91
    Try
        ListBoxSource=product_idDataCommand.Execute().Tables(0).Rows
    Catch ee as Exception 
        E=ee
    Finally
'End ListBox product_id BeforeExecuteSelect

'ListBox product_id AfterExecuteSelect @81-448FCC7D
        If Not IsNothing(E) Then Throw E
    End Try
    Dim product_idItems As ItemCollection = New ItemCollection()
    For j=0 To ListBoxSource.Count-1 
        Dim Key As String = (New IntegerField("", ListBoxSource(j)("product_id"))).GetFormattedValue("")
        Dim Val As Object = ListBoxSource(j)("product_name")
        product_idItems.Add(Key, Val)
    Next
'End ListBox product_id AfterExecuteSelect

'After execute Select tail @77-6F5B653C
        Dim i as Integer
        For i = 0 To dr.Count - 1
            Dim item as store_orders_itemsItem = New store_orders_itemsItem()
            item.order_id.SetValue(dr(i)("order_id"),"")
            item.product_id.SetValue(dr(i)("product_id"),"")
            item.product_idItems = CType(product_idItems.Clone(), ItemCollection)
            item.price.SetValue(dr(i)("price"),"")
            item.quantity.SetValue(dr(i)("quantity"),"")
            item.order_item_idField.SetValue(dr(i)("order_item_id"),"")
            result(i)=item
        Next i
        For i = dr.Count To dr.Count + EmptyRows - 1
            Dim item as store_orders_itemsItem = New store_orders_itemsItem()
            item.product_idItems = CType(product_idItems.Clone(), ItemCollection)
            result(i) = item
        Next i
        Return result 
    End Function
'End After execute Select tail

'Grid Data Provider tail @77-A61BA892
End Class
'End Grid Data Provider tail

'Page Data Provider Tail @1-5EA2E2E0
End Namespace
'End Page Data Provider Tail

