//Using Statements @1-EEDAE1A9
using System;
using System.Collections;
using System.Collections.Specialized;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Text.RegularExpressions;
using System.Globalization;
using CCSExample_CSharp;
using CCSExample_CSharp.Data;
using CCSExample_CSharp.Configuration;
using CCSExample_CSharp.Controls;

namespace CCSExample_CSharp.PopUpList.PopUpList
{

//End Using Statements

//Forms Definition @1-4A897D9E
public class PopUpListPage : System.Web.UI.Page
{
//End Forms Definition

//Forms Objects @1-349A91F5
    protected System.Web.UI.WebControls.Repeater departments_empRepeater;
    protected departments_empDataProvider departments_empData;
    protected departmentsDataProvider departmentsData;
    protected HtmlInputButton departmentsInsert_Button;
    protected HtmlInputButton departmentsUpdate_Button;
    protected HtmlInputButton departmentsDelete_Button;
    protected System.Web.UI.WebControls.PlaceHolder departmentsError;
    protected System.Web.UI.HtmlControls.HtmlTable departmentsHolder;
    protected System.Web.UI.WebControls.Label departmentsErrorLabel;
    protected bool departmentsInsertAllowed=true;
    protected bool departmentsUpdateAllowed=true;
    protected bool departmentsDeleteAllowed=true;
    protected NameValueCollection departmentsErrors=new NameValueCollection();
    protected System.Web.UI.WebControls.TextBox departmentsdepartment_name;
    protected System.Web.UI.WebControls.TextBox departmentsdepartment_manager_id;
    protected System.Web.UI.HtmlControls.HtmlAnchor departmentsLink1;
    protected System.Web.UI.HtmlControls.HtmlInputHidden departmentsis_change;
    protected System.Web.UI.HtmlControls.HtmlAnchor Link2;
//End Forms Objects

//Page_Load Event @1-55207E05
private void Page_Load(object sender, System.EventArgs e)
{
//End Page_Load Event

//Page_Load Event BeforeIsPostBack @1-5E7DD600
    if (!IsPostBack)
    {
            PageDataProvider PageData=new PageDataProvider();
            PageItem item=PageItem.CreateFromHttpRequest();
            item.Link2Href = "PopUpList_desc.aspx?";
            PageData.FillItem(item);
            Link2.InnerText += item.Link2.GetFormattedValue().Replace("\r","").Replace("\n","<br>");
            Link2.HRef += item.Link2Href+item.Link2HrefParameters.ToString("GET","", ViewState);
            departments_empBind();
            departmentsShow();
    }
//End Page_Load Event BeforeIsPostBack

//Page_Load Event tail @1-FCB6E20C
}
//End Page_Load Event tail

//Page_Unload Event @1-72102C7C
private void Page_Unload(object sender, System.EventArgs e)
{
//End Page_Unload Event

//Page_Unload Event tail @1-FCB6E20C
}
//End Page_Unload Event tail

//Grid departments_emp Bind @3-C50DC2BC
    protected void departments_empBind()
    {
        int PagesCount;
        int FooterIndex;
        if (!IsPostBack)
        {
            string Param;
            int PageSize;
            ViewState["departments_empSortField"] = departments_empDataProvider.SortFields.Default;
            PageSize = 10;
            ViewState["departments_empPageNumber"] = 1;
            Param = Request.QueryString["departments_empOrder"];
            if (Param != null && Param.Length > 0)
                try{
                    departments_empDataProvider.SortFields SortField = 0;
                    ViewState["departments_empSortField"] = Enum.Parse(SortField.GetType(), Param);
                }catch {}
            Param = Request.QueryString["departments_empDir"];
            if (Param == null || Param.Length == 0 || Param.ToLower() == "desc")
                ViewState["departments_empSortDir"] = SortDirections.Desc;
            else
                ViewState["departments_empSortDir"] = SortDirections.Asc;
            Param = Request.QueryString["departments_empPage"];
            int PageNumber;
            if (Param != null && Param.Length > 0)
                try
                {
                    PageNumber = Int32.Parse(Param);
                    if (PageNumber > 0) ViewState["departments_empPageNumber"] = PageNumber;
                }
                catch {}
            Param = Request.QueryString["departments_empPageSize"];
            if (Param != null && Param.Length > 0)
                try
                {
                    PageSize = Int32.Parse(Param);
                    if (PageSize <= 0) PageSize = 10;
                }
                catch {}
            if (PageSize > 100)
                PageSize = 100;
            ViewState["departments_empPageSize"] = PageSize;
        }
//End Grid departments_emp Bind

//Grid Form departments_emp BeforeShow tail @3-87912FE1
        departments_empParameters();
        departments_empData.SortField = (departments_empDataProvider.SortFields)ViewState["departments_empSortField"];
        departments_empData.SortDir = (SortDirections)ViewState["departments_empSortDir"];
        departments_empData.PageNumber = (int)ViewState["departments_empPageNumber"];
        departments_empData.RecordsPerPage = (int)ViewState["departments_empPageSize"];
        departments_empRepeater.DataSource = departments_empData.GetResultSet(out PagesCount);
        ViewState["departments_empPagesCount"] = PagesCount;
        departments_empRepeater.DataBind();
        FooterIndex = departments_empRepeater.Controls.Count - 1;
        departments_empItem item=new departments_empItem();
        System.Web.UI.HtmlControls.HtmlAnchor departments_empAdd = (System.Web.UI.HtmlControls.HtmlAnchor)departments_empRepeater.Controls[FooterIndex].FindControl("departments_empAdd");

        item.AddHref = "PopUpList.aspx?";

        departments_empAdd.InnerText += item.Add.GetFormattedValue().Replace("\r","").Replace("\n","<br>");
        departments_empAdd.HRef += item.AddHref+item.AddHrefParameters.ToString("GET","department_id", ViewState);
        CCSExample_CSharp.Controls.Navigator Navigator1Navigator = (CCSExample_CSharp.Controls.Navigator)departments_empRepeater.Controls[FooterIndex].FindControl("Navigator1Navigator");
        Navigator1Navigator.MaxPage=PagesCount;
        Navigator1Navigator.PageNumber=departments_empData.PageNumber;
        Navigator1Navigator.DataBind();
//End Grid Form departments_emp BeforeShow tail

//Grid departments_emp Bind tail @3-FCB6E20C
    }
//End Grid departments_emp Bind tail

//Grid departments_emp Table Parameters @3-59C104C5
    protected void departments_empParameters()
    {
        try{
        }catch{
            ControlCollection ParentControls=departments_empRepeater.Parent.Controls;
            int RepeaterIndex=ParentControls.IndexOf(departments_empRepeater);
            ParentControls.RemoveAt(RepeaterIndex);
            Literal ErrorMessage=new Literal();
            ErrorMessage.Text="Error in Grid departments_emp: Invalid parameter";
            ParentControls.AddAt(RepeaterIndex,ErrorMessage);
        }
	}
	
//End Grid departments_emp Table Parameters

//Grid departments_emp ItemDataBound event @3-FB1BF8BA
    protected void departments_empItemDataBound(Object Sender, RepeaterItemEventArgs e)
    {
        departments_empItem DataItem=(departments_empItem)e.Item.DataItem;
        if (e.Item.ItemType == ListItemType.Item || e.Item.ItemType == ListItemType.AlternatingItem) {
            System.Web.UI.HtmlControls.HtmlAnchor departments_empdepartment_name = (System.Web.UI.HtmlControls.HtmlAnchor)(e.Item.FindControl("departments_empdepartment_name"));
            DataItem.department_nameHref = "PopUpList.aspx?";
            departments_empdepartment_name.HRef += DataItem.department_nameHref + DataItem.department_nameHrefParameters.ToString("GET","", ViewState);
        }
//End Grid departments_emp ItemDataBound event

//Grid departments_emp ItemDataBound event tail @3-FCB6E20C
    }
//End Grid departments_emp ItemDataBound event tail

//Grid departments_emp ItemCommand event @3-8047ADCF
    protected void departments_empItemCommand(Object Sender, RepeaterCommandEventArgs e)
    {
        int FooterIndex = departments_empRepeater.Controls.Count - 1;
        bool BindAllowed = false;
        if(e.CommandName=="Sort"){
            if(((SorterState)e.CommandArgument)==SorterState.None)
                if((SortDirections)ViewState["departments_empSortDir"]==SortDirections.Asc&&ViewState["departments_empSortField"].ToString()==((CCSExample_CSharp.Controls.Sorter)e.CommandSource).Field)
                    ViewState["departments_empSortDir"]=SortDirections.Desc;
                else
                    ViewState["departments_empSortDir"]=SortDirections.Asc;
            else
                ViewState["departments_empSortDir"]=(int)(((CCSExample_CSharp.Controls.Sorter)e.CommandSource).State);
            ViewState["departments_empSortField"]=Enum.Parse(typeof(departments_empDataProvider.SortFields),((CCSExample_CSharp.Controls.Sorter)e.CommandSource).Field);
            ViewState["departments_empPageNumber"] = 1;
            BindAllowed = true;
        }
        if(e.CommandName=="Navigate"){
            ViewState["departments_empPageNumber"] = Int32.Parse(e.CommandArgument.ToString());
            BindAllowed = true;
        }
        if (BindAllowed)
            departments_empBind();
    }
//End Grid departments_emp ItemCommand event

//Record Form departments Parameters @11-76E6748E
    protected void departmentsParameters()
    {
        try{
            departmentsData.Urldepartment_id= IntegerParameter.GetParam(Request.QueryString["department_id"]);
        }catch(Exception e){
            departmentsErrors.Add("Parameters","Form parameters: " + e.Message);
        }
    }
//End Record Form departments Parameters

//Record Form departments Show method @11-6CE16415
    protected void departmentsShow()
    {
        bool AllowRead = true,AllowInsert = true,AllowUpdate = true,AllowDelete = true;
        departmentsItem item=departmentsItem.CreateFromHttpRequest();
        bool IsInsertMode=!AllowRead;
        item.Link1Href = "PopUpList_Window.aspx";
        departmentsErrors.Add(item.errors);
//End Record Form departments Show method

//Grid Form departments BeforeShow tail @11-915F645E
        departmentsParameters();
        departmentsData.FillItem(item,ref IsInsertMode);
        departmentsInsert_Button.Visible=IsInsertMode&&AllowInsert;
        departmentsUpdate_Button.Visible=!IsInsertMode&&AllowUpdate;
        departmentsDelete_Button.Visible=!IsInsertMode&&AllowDelete;
        departmentsdepartment_name.Text=item.department_name.GetFormattedValue();
        departmentsdepartment_manager_id.Text=item.department_manager_id.GetFormattedValue();
        departmentsLink1.InnerText += item.Link1.GetFormattedValue().Replace("\r","").Replace("\n","<br>");
        departmentsLink1.HRef += item.Link1Href+item.Link1HrefParameters.ToString("None","", ViewState);
        departmentsis_change.Value=item.is_change.GetFormattedValue();
//End Grid Form departments BeforeShow tail

//Record departments Event BeforeShow. Action Custom Code @17-2A29BDB7

  if(departmentsdepartment_manager_id.Text != ""){
  	departmentsdepartment_manager_id.Text = 
         new TextField("",Settings.IntranetDBDataAccessObject.ExecuteScalar("SELECT emp_name FROM employees WHERE emp_id=" + departmentsdepartment_manager_id.Text)).GetFormattedValue("");
  }
    
//End Record departments Event BeforeShow. Action Custom Code

//Record Form departments Show method tail @11-DC0BB6F3
        if(departmentsErrors.Count>0)
            departmentsShowErrors();
    }
//End Record Form departments Show method tail

//Record Form departments LoadItemFromRequest method @11-DE37CB2D
    protected void departmentsLoadItemFromRequest(departmentsItem item, bool EnableValidation)
    {
        item.department_name.SetValue(departmentsdepartment_name.Text);
        item.department_manager_id.SetValue(departmentsdepartment_manager_id.Text);
        item.is_change.SetValue(departmentsis_change.Value);
        if(EnableValidation)
            item.Validate(departmentsData);
        departmentsErrors.Add(item.errors);
    }
//End Record Form departments LoadItemFromRequest method

//Record Form departments GetRedirectUrl method @11-27851F3F
    protected string GetdepartmentsRedirectUrl(string redirectString ,string removeList)
    {
        string Params="";
        string[] List=("department_id;" + removeList).ToLower().Split(new Char[] {';'});

        if(redirectString == "") redirectString = "PopUpList.aspx";
        for(int i = 0; i < Request.QueryString.Count;i ++)
            if(Array.IndexOf(List,Request.QueryString.AllKeys[i].ToLower()) < 0)
                Params += Request.QueryString.AllKeys[i] + "=" + Server.UrlEncode(Request.QueryString[i]) + "&";
        Params = Params.TrimEnd(new Char[]{'&'});
        return redirectString + "?" + Params;
    }

//End Record Form departments GetRedirectUrl method

//Record Form departments ShowErrors method @11-8DF44C5B
    protected void departmentsShowErrors()
    {
        string DefaultMessage="";
        for(int i=0;i<departmentsErrors.Count;i++)
        switch(departmentsErrors.AllKeys[i])
        {
            default:
                DefaultMessage+=departmentsErrors[i]+"<br>";
                break;
        }
        departmentsError.Visible = true;
        departmentsErrorLabel.Text = DefaultMessage;
    }
//End Record Form departments ShowErrors method

//Record Form departments Insert Operation @11-63592B13
    protected void departments_Insert(object sender, System.EventArgs e)
    {
        bool ExecuteFlag = true;
        bool ErrorFlag = false;
        departmentsItem item=new departmentsItem();
        string RedirectUrl = GetdepartmentsRedirectUrl("", "");
//End Record Form departments Insert Operation

//Record Form departments BeforeInsert tail @11-45B9E731
    departmentsParameters();
    departmentsLoadItemFromRequest(item, true);
    if(departmentsInsertAllowed){
    ErrorFlag=(departmentsErrors.Count>0);
        if(ExecuteFlag&&!ErrorFlag)
            try
            {
                departmentsData.InsertItem(item);
            }
            catch (Exception ex)
            {
                departmentsErrors.Add("DataProvider",ex.Message);
                ErrorFlag=true;
            }
//End Record Form departments BeforeInsert tail

//Record Form departments AfterInsert tail  @11-39650612
        }
        if(ErrorFlag)
            departmentsShowErrors();
        else
            Response.Redirect(RedirectUrl);
    }
//End Record Form departments AfterInsert tail 

//Record Form departments Update Operation @11-6F713F3F
    protected void departments_Update(object sender, System.EventArgs e)
    {
        departmentsItem item=new departmentsItem();
        item.IsNew = false;
        bool ExecuteFlag = true;
        bool ErrorFlag = false;
        string RedirectUrl = GetdepartmentsRedirectUrl("", "");
//End Record Form departments Update Operation

//Record Form departments Before Update tail @11-B7696AAF
        departmentsParameters();
        departmentsLoadItemFromRequest(item, true);
        if(departmentsUpdateAllowed){
        ErrorFlag=(departmentsErrors.Count>0);
        if(ExecuteFlag&&!ErrorFlag)
            try
            {
                departmentsData.UpdateItem(item);
            }
            catch (Exception ex)
            {
                departmentsErrors.Add("DataProvider",ex.Message);
                ErrorFlag=true;
            }
//End Record Form departments Before Update tail

//Record Form departments Update Operation tail @11-39650612
        }
        if(ErrorFlag)
            departmentsShowErrors();
        else
            Response.Redirect(RedirectUrl);
    }
//End Record Form departments Update Operation tail

//Record Form departments Delete Operation @11-A3521E74
    protected void departments_Delete(object sender,System.EventArgs e)
    {
        bool ExecuteFlag = true;
        bool ErrorFlag = false;
        string RedirectUrl = GetdepartmentsRedirectUrl("", "");
        departmentsItem item=new departmentsItem();
        item.IsNew = false;
        item.IsDeleted = true;
//End Record Form departments Delete Operation

//Record Form BeforeDelete tail @11-9F25F0EF
        departmentsParameters();
        departmentsLoadItemFromRequest(item, true);
        if(departmentsDeleteAllowed){
        ErrorFlag = (departmentsErrors.Count > 0);
        if(ExecuteFlag && !ErrorFlag)
            try
            {
                departmentsData.DeleteItem();
            }
            catch (Exception ex)
            {
                departmentsErrors.Add("DataProvider", ex.Message);
                ErrorFlag = true;
            }
//End Record Form BeforeDelete tail

//Record Form AfterDelete tail @11-39650612
        }
        if(ErrorFlag)
            departmentsShowErrors();
        else
            Response.Redirect(RedirectUrl);
    }
//End Record Form AfterDelete tail

//Record Form departments Cancel Operation @11-74EAC609
    protected void departments_Cancel(object sender,System.EventArgs e)
    {
        departmentsItem item=new departmentsItem();
        string RedirectUrl = GetdepartmentsRedirectUrl("", "");
        departmentsLoadItemFromRequest(item, true);
//End Record Form departments Cancel Operation

//Record Form departments Cancel Operation tail @11-AE897FBA
        Response.Redirect(RedirectUrl);
    }
//End Record Form departments Cancel Operation tail

//OnInit Event @1-81B86E28
    #region Web Form Designer generated code
    override protected void OnInit(EventArgs e)
    {
        //
        //CODEGEN: This call is required by the ASP.NET Web Form Designer.
        //
        InitializeComponent();
        this.Load += new System.EventHandler(this.Page_Load);
        this.Unload += new System.EventHandler(this.Page_Unload);
        departments_empData = new departments_empDataProvider();
        departmentsData = new departmentsDataProvider();
        base.OnInit(e);
//End OnInit Event

//OnInit Event tail @1-FCB6E20C
    }
//End OnInit Event tail

//InitializeComponent Event @1-722FC1EE
    /// <summary>
    /// Required method for Designer support - do not modify
    /// the contents of this method with the code editor.
    /// </summary>
    private void InitializeComponent()
    {
    }
    #endregion
//End InitializeComponent Event

//Page class tail @1-F5FC18C5
}
}
//End Page class tail

