'Using Statements @1-C54E9A1A
Imports System
Imports System.Collections
Imports System.Collections.Specialized
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Web
Imports System.Web.SessionState
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports System.Web.UI.HtmlControls
Imports System.Text.RegularExpressions
Imports System.Globalization
Imports CCSExamplePack
Imports CCSExamplePack.Data
Imports CCSExamplePack.Configuration
Imports CCSExamplePack.Controls
Namespace PopUpList.PopUpList
'End Using Statements

'Forms Definition @1-F11D2B9E
Public Class [PopUpListPage]
Inherits System.Web.UI.Page
'End Forms Definition

'Forms Objects @1-C6CEA139
    Protected departments_empRepeater As  System.Web.UI.WebControls.Repeater
    Protected departments_empData As departments_empDataProvider
    Protected departmentsData As departmentsDataProvider
    Protected departmentsInsert_Button As HtmlInputButton 
    Protected departmentsUpdate_Button As HtmlInputButton 
    Protected departmentsDelete_Button As HtmlInputButton 
    Protected departmentsError As System.Web.UI.WebControls.PlaceHolder
    Protected departmentsHolder As System.Web.UI.HtmlControls.HtmlTable
    Protected departmentsErrorLabel As System.Web.UI.WebControls.Label
    Protected departmentsInsertAllowed As Boolean = True
    Protected departmentsUpdateAllowed As Boolean = True
    Protected departmentsDeleteAllowed As Boolean = True
    Protected departmentsErrors As NameValueCollection = New NameValueCollection()
    Protected departmentsdepartment_name As System.Web.UI.WebControls.TextBox
    Protected departmentsdepartment_manager_id As System.Web.UI.WebControls.TextBox
    Protected departmentsLink1 As System.Web.UI.HtmlControls.HtmlAnchor
    Protected departmentsis_change As System.Web.UI.HtmlControls.HtmlInputHidden
    Protected Link2 As System.Web.UI.HtmlControls.HtmlAnchor
'End Forms Objects

'Page_Load Event @1-A2D2CF1E

Protected Overrides Sub OnLoad(ByVal e As System.EventArgs)
'End Page_Load Event

'Page_Load Event BeforeIsPostBack @1-6619C57F
    If Not IsPostBack Then
            Dim PageData As PageDataProvider = New PageDataProvider()
            Dim item As PageItem = PageItem.CreateFromHttpRequest()
            item.Link2Href = "PopUpList_desc.aspx?"
            PageData.FillItem(item)
            Link2.InnerText += item.Link2.GetFormattedValue().Replace(vbCrLf,"")
            Link2.HRef += item.Link2Href & item.Link2HrefParameters.ToString("GET","", ViewState)
            departments_empBind
            departmentsShow()
    End If
'End Page_Load Event BeforeIsPostBack

'Page_Load Event tail @1-E31F8E2A
End Sub
'End Page_Load Event tail

'Page_Unload Event @1-D998A98F

Protected Overrides Sub OnUnload(ByVal e As System.EventArgs)
'End Page_Unload Event

'Page_Unload Event tail @1-E31F8E2A
End Sub
'End Page_Unload Event tail

'Grid departments_emp Bind @3-C6EB787D

    Protected Sub departments_empBind()
        Dim PagesCount As Integer
        Dim FooterIndex As Integer
        If Not(IsPostBack) Then
            Dim Param As String
            Param = Request.QueryString("departments_empOrder")
            Try
                Dim sf As departments_empDataProvider.SortFields = 0
                ViewState("departments_empSortField") = [Enum].Parse(sf.GetType(), Param)
            Catch
                ViewState("departments_empSortField") = departments_empDataProvider.SortFields._Default
            End Try

            Param = Request.QueryString("departments_empDir")
            If IsNothing(Param) Then
                ViewState("departments_empSortDir") = SortDirections._Desc
            Else
                If Param.Length = 0 Or Param.ToLower() = "desc" Then
                    ViewState("departments_empSortDir") = SortDirections._Desc
                Else
                    ViewState("departments_empSortDir") = SortDirections._Asc
                End If
            End If
            Param = Request.QueryString("departments_empPage")
            Dim PageNumber as Integer
            Try
                PageNumber = Int32.Parse(Param)
                If PageNumber <= 0 Then PageNumber = 1
            Catch
                PageNumber = 1
            End Try
            ViewState("departments_empPageNumber") = PageNumber
            Param = Request.QueryString("departments_empPageSize")
            Try
                PageNumber = Int32.Parse(Param)
                If PageNumber <= 0 Then PageNumber = 10
            Catch
                PageNumber = 10
            End Try
            If PageNumber > 100 Then
                PageNumber = 100
            End If
            ViewState("departments_empPageSize") = PageNumber
        End If
'End Grid departments_emp Bind

'Grid Form departments_emp BeforeShow tail @3-3836CBC5
        departments_empParameters
        departments_empData.SortField = CType(ViewState("departments_empSortField"),departments_empDataProvider.SortFields)
        departments_empData.SortDir = CType(ViewState("departments_empSortDir"),SortDirections)
        departments_empData.PageNumber = CInt(ViewState("departments_empPageNumber"))
        departments_empData.RecordsPerPage = CInt(ViewState("departments_empPageSize"))
        departments_empRepeater.DataSource = departments_empData.GetResultSet(PagesCount)
        ViewState("departments_empPagesCount") = PagesCount
        departments_empRepeater.DataBind
        FooterIndex = departments_empRepeater.Controls.Count - 1
        Dim item As departments_empItem = New departments_empItem()
        Dim departments_empAdd As System.Web.UI.HtmlControls.HtmlAnchor = DirectCast(departments_empRepeater.Controls(FooterIndex).FindControl("departments_empAdd"),System.Web.UI.HtmlControls.HtmlAnchor)

        item.AddHref = "PopUpList.aspx?"

        departments_empAdd.InnerText += item.Add.GetFormattedValue().Replace(vbCrLf,"")
        departments_empAdd.HRef += item.AddHref & item.AddHrefParameters.ToString("GET","department_id", ViewState)
        Dim Navigator1Navigator As Controls.Navigator = CType(departments_empRepeater.Controls(FooterIndex).FindControl("Navigator1Navigator"),Controls.Navigator)
        Navigator1Navigator.MaxPage=PagesCount
        Navigator1Navigator.PageNumber=departments_empData.PageNumber
        Navigator1Navigator.DataBind
'End Grid Form departments_emp BeforeShow tail

'Grid departments_emp Bind tail @3-E31F8E2A
    End Sub
'End Grid departments_emp Bind tail

'Grid departments_emp Table Parameters @3-22E90850

    Protected Sub departments_empParameters()
        Try

        Catch
            Dim ParentControls As ControlCollection=departments_empRepeater.Parent.Controls
            Dim RepeaterIndex As Integer=ParentControls.IndexOf(departments_empRepeater)
            ParentControls.RemoveAt(RepeaterIndex)
            Dim ErrorMessage as Literal=New Literal()
            ErrorMessage.Text="Error in Grid departments_emp: Invalid parameter"
            ParentControls.AddAt(RepeaterIndex,ErrorMessage)
        End Try
    End Sub
'End Grid departments_emp Table Parameters

'Grid departments_emp ItemDataBound event @3-B9BEF845

    Protected Sub departments_empItemDataBound(Sender as Object, e as RepeaterItemEventArgs)
        Dim DataItem as departments_empItem=CType(e.Item.DataItem,departments_empItem)
        If e.Item.ItemType = ListItemType.Item Or e.Item.ItemType = ListItemType.AlternatingItem Then
            Dim departments_empdepartment_name As System.Web.UI.HtmlControls.HtmlAnchor = DirectCast(e.Item.FindControl("departments_empdepartment_name"),System.Web.UI.HtmlControls.HtmlAnchor)
            DataItem.department_nameHref = "PopUpList.aspx?"
            departments_empdepartment_name.HRef += DataItem.department_nameHref & DataItem.department_nameHrefParameters.ToString("GET","", ViewState)
        End If
'End Grid departments_emp ItemDataBound event

'Grid departments_emp ItemDataBound event tail @3-E31F8E2A
    End Sub
'End Grid departments_emp ItemDataBound event tail

'Grid departments_emp ItemCommand event @3-2532E926

    Protected Sub departments_empItemCommand(Sender as Object, e as RepeaterCommandEventArgs)
        Dim FooterIndex as Integer= departments_empRepeater.Controls.Count - 1
        Dim BindAllowed as Boolean= False
        If e.CommandName = "Sort" Then
            If CType(e.CommandArgument,SorterState)=SorterState.None
                If CType(ViewState("departments_empSortDir"),SortDirections) = SortDirections._Asc And ViewState("departments_empSortField").ToString()=CType(e.CommandSource,Controls.Sorter).Field
                    ViewState("departments_empSortDir")=SortDirections._Desc
                Else
                    ViewState("departments_empSortDir")=SortDirections._Asc
                End If
            Else
                ViewState("departments_empSortDir")=CInt(CType(e.CommandSource,Controls.Sorter).State)
            End If
            Dim sf As departments_empDataProvider.SortFields = 0
            ViewState("departments_empSortField")=[Enum].Parse(sf.GetType(),CType(e.CommandSource,Controls.Sorter).Field)
            ViewState("departments_empPageNumber") = 1
            BindAllowed = True
        End If

        If e.CommandName="Navigate" Then
            ViewState("departments_empPageNumber") = Int32.Parse(e.CommandArgument.ToString())
            BindAllowed = True
        End If
        If BindAllowed Then
            departments_empBind
        End If
    End Sub
'End Grid departments_emp ItemCommand event

'Record Form departments Parameters @11-71461138

    Protected Sub departmentsParameters()
        Try
            departmentsData.Urldepartment_id = IntegerParameter.GetParam(Request.QueryString("department_id"))
        Catch e As Exception
            departmentsErrors.Add("Parameters","Form Parameters: " + e.Message)
        End Try
    End Sub
'End Record Form departments Parameters

'Record Form departments Show method @11-69790C14
    Protected Sub departmentsShow()
        Dim AllowRead As Boolean = True
        Dim AllowInsert As Boolean = True
        Dim AllowUpdate As Boolean = True
        Dim AllowDelete As Boolean = True
        Dim item As departmentsItem = departmentsItem.CreateFromHttpRequest()
        Dim IsInsertMode As Boolean = Not AllowRead
        item.Link1Href = "PopUpList_Window.aspx"
        departmentsErrors.Add(item.errors)
        If departmentsErrors.Count > 0 Then
            departmentsShowErrors()
            Return
        End If
'End Record Form departments Show method

'Record Form departments BeforeShow tail @11-F00F7154
        departmentsParameters()
        departmentsData.FillItem(item, IsInsertMode)
        departmentsInsert_Button.Visible = IsInsertMode And AllowInsert
        departmentsUpdate_Button.Visible = (Not IsInsertMode) And AllowUpdate
        departmentsDelete_Button.Visible = (Not IsInsertMode) And AllowDelete
        departmentsdepartment_name.Text=item.department_name.GetFormattedValue()
        departmentsdepartment_manager_id.Text=item.department_manager_id.GetFormattedValue()
        departmentsLink1.InnerText += item.Link1.GetFormattedValue().Replace(vbCrLf,"")
        departmentsLink1.HRef += item.Link1Href & item.Link1HrefParameters.ToString("None","", ViewState)
        departmentsis_change.Value = item.is_change.GetFormattedValue()
'End Record Form departments BeforeShow tail

'Record departments Event BeforeShow. Action Custom Code @17-73254650
    
	If departmentsdepartment_manager_id.Text <> "" Then
  		departmentsdepartment_manager_id.Text = _
         new TextField("",Settings.IntranetDBDataAccessObject.ExecuteScalar("SELECT emp_name FROM employees WHERE emp_id=" & departmentsdepartment_manager_id.Text)).GetFormattedValue("")
	End If

'End Record departments Event BeforeShow. Action Custom Code

'Record Form departments Show method tail @11-E3C8D338
        If departmentsErrors.Count > 0 Then
            departmentsShowErrors()
        End If
    End Sub
'End Record Form departments Show method tail

'Record Form departments LoadItemFromRequest method @11-5FF6C2EC

    Protected Sub departmentsLoadItemFromRequest(item As departmentsItem, ByVal EnableValidation As Boolean)
        item.department_name.SetValue(departmentsdepartment_name.Text)
        item.department_manager_id.SetValue(departmentsdepartment_manager_id.Text)
        item.is_change.SetValue(departmentsis_change.Value)
        If EnableValidation Then
            item.Validate(departmentsData)
        End If
        departmentsErrors.Add(item.errors)
    End Sub
'End Record Form departments LoadItemFromRequest method

'Record Form departments GetRedirectUrl method @11-48505FF5

    Protected Function GetdepartmentsRedirectUrl(ByVal redirect As String, ByVal removeList As String) As String
        Dim Params As String = ""
        Dim List() As String = {""}

        List = ("department_id;" + RemoveList).ToLower().Split(New Char() {";"})
        If Redirect= "" Then
            Redirect = "PopUpList.aspx"
        End If
        Dim j As Integer
        For j=0 To Request.QueryString.Count - 1
            If Array.IndexOf(List,Request.QueryString.AllKeys(j).ToLower()) < 0 Then
                Params = Params & Request.QueryString.AllKeys(j) & "=" & Server.UrlEncode(Request.QueryString(j)) & "&"
            End If
        Next j
        Params = Params.TrimEnd(New Char(){"&"})
        Return Redirect & "?" & Params
    End Function
'End Record Form departments GetRedirectUrl method

'Record Form departments ShowErrors method @11-2A154C9E

    Protected Sub departmentsShowErrors()
        Dim DefaultMessage As String = ""
        Dim i As Integer
        For i = 0 To departmentsErrors.Count - 1
        Select Case departmentsErrors.AllKeys(i)
            Case Else
                DefaultMessage = DefaultMessage & departmentsErrors(i) & "<br>"
        End Select
        Next i
        departmentsError.Visible = True
        departmentsErrorLabel.Text = DefaultMessage
    End Sub
'End Record Form departments ShowErrors method

'Record Form departments Insert Operation @11-616F0DF4

    Protected Sub departments_Insert(ByVal sender As Object, ByVal e As System.EventArgs)
        Dim item As departmentsItem = New departmentsItem()
        Dim ExecuteFlag As Boolean = True
        Dim ErrorFlag As Boolean = False
        Dim RedirectUrl As String = GetdepartmentsRedirectUrl("", "")
'End Record Form departments Insert Operation

'Record Form departments BeforeInsert tail @11-B4008E7E
    departmentsParameters()
    departmentsLoadItemFromRequest(item, True)
    If departmentsInsertAllowed Then
        ErrorFlag=(departmentsErrors.Count > 0)
        If ExecuteFlag And (Not ErrorFlag) Then
            Try
                departmentsData.InsertItem(item)
            Catch ex As Exception
                departmentsErrors.Add("DataProvider",ex.Message)
                ErrorFlag = True
            End Try
        End If
'End Record Form departments BeforeInsert tail

'Record Form departments AfterInsert tail  @11-F39BECEE
        End If
        If ErrorFlag Then
            departmentsShowErrors()
        Else
            Response.Redirect(RedirectUrl)
        End If
    End Sub
'End Record Form departments AfterInsert tail 

'Record Form departments Update Operation @11-F7521987

    Protected Sub departments_Update(ByVal sender As Object, ByVal e As System.EventArgs)
        Dim item As departmentsItem = New departmentsItem()
        item.IsNew = False
        Dim ExecuteFlag As Boolean = True
        Dim ErrorFlag As Boolean = False
        Dim RedirectUrl As String = GetdepartmentsRedirectUrl("", "")
'End Record Form departments Update Operation

'Record Form departments Before Update tail @11-DF841ABA
        departmentsParameters()
        departmentsLoadItemFromRequest(item, True)
        If departmentsUpdateAllowed Then
        ErrorFlag = (departmentsErrors.Count > 0)
        If ExecuteFlag And (Not ErrorFlag) Then
            Try
                departmentsData.UpdateItem(item)
            Catch ex As Exception
                departmentsErrors.Add("DataProvider",ex.Message)
                ErrorFlag = True
            End Try
        End If
'End Record Form departments Before Update tail

'Record Form departments Update Operation tail @11-F39BECEE
        End If
        If ErrorFlag Then
            departmentsShowErrors()
        Else
            Response.Redirect(RedirectUrl)
        End If
    End Sub
'End Record Form departments Update Operation tail

'Record Form departments Delete Operation @11-2A2A674A

    Protected Sub departments_Delete(ByVal sender As Object, ByVal e As System.EventArgs)
        Dim ExecuteFlag As Boolean = True
        Dim ErrorFlag As Boolean = False
        Dim RedirectUrl As String = GetdepartmentsRedirectUrl("", "")
        Dim item As departmentsItem = New departmentsItem()
        item.IsNew  = False
        item.IsDeleted  = True
'End Record Form departments Delete Operation

'Record Form BeforeDelete tail @11-783954EA
        departmentsParameters()
        departmentsLoadItemFromRequest(item, True)
        If departmentsDeleteAllowed Then
        ErrorFlag = (departmentsErrors.Count > 0)
        If ExecuteFlag And (Not ErrorFlag) Then
            Try
                departmentsData.DeleteItem()
            Catch ex As Exception
                departmentsErrors.Add("DataProvider",ex.Message)
                ErrorFlag = True
            End Try
        End If
'End Record Form BeforeDelete tail

'Record Form AfterDelete tail @11-F39BECEE
        End If
        If ErrorFlag Then
            departmentsShowErrors()
        Else
            Response.Redirect(RedirectUrl)
        End If
    End Sub
'End Record Form AfterDelete tail

'Record Form departments Cancel Operation @11-24AB22AD

    Protected Sub departments_Cancel(ByVal sender As Object, ByVal e As System.EventArgs)
        Dim item As departmentsItem = New departmentsItem()
        Dim RedirectUrl As String = GetdepartmentsRedirectUrl("", "")
        departmentsLoadItemFromRequest(item, True)
'End Record Form departments Cancel Operation

'Record Form departments Cancel Operation tail @11-EA2B0FFB
        Response.Redirect(RedirectUrl)
    End Sub
'End Record Form departments Cancel Operation tail

'OnInit Event @1-3D4637B0
    #Region " Web Form Designer Generated Code "
    Protected Overrides Sub OnInit(ByVal e As EventArgs)
        '
        ' CODEGEN: This call is required by the ASP.NET Web Form Designer.
        '
        InitializeComponent()
        'Me.Load += new System.EventHandler(this.Page_Load);
        'Me.Unload += new System.EventHandler(this.Page_Unload);
        departments_empData = New departments_empDataProvider()
        departmentsData = New departmentsDataProvider()
        MyBase.OnInit(e)
'End OnInit Event

'OnInit Event tail @1-E31F8E2A
    End Sub
'End OnInit Event tail

'InitializeComponent Event @1-EA5E2628
    ' <summary>
    ' Required method for Designer support - do not modify
    ' the contents of this method with the code editor.
    ' </summary>
    Private Sub InitializeComponent()
    End Sub
    #End Region
'End InitializeComponent Event

'Page class tail @1-DD082417
End Class
End Namespace
'End Page class tail

