//Using Statements @1-A57357F0
using System;
using System.Collections;
using System.Collections.Specialized;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Text.RegularExpressions;
using System.Globalization;
using CCSExample_CSharp;
using CCSExample_CSharp.Data;
using CCSExample_CSharp.Configuration;
using CCSExample_CSharp.Controls;

namespace CCSExample_CSharp.PopUpList.PopUpList_Window
{

//End Using Statements

//Forms Definition @1-94DAB372
public class PopUpList_WindowPage : System.Web.UI.Page
{
//End Forms Definition

//Forms Objects @1-CAB7E4B6
    protected employees_deparSearchDataProvider employees_deparSearchData;
    protected HtmlInputButton employees_deparSearchDoSearch;
    protected System.Web.UI.WebControls.PlaceHolder employees_deparSearchError;
    protected System.Web.UI.HtmlControls.HtmlTable employees_deparSearchHolder;
    protected System.Web.UI.WebControls.Label employees_deparSearchErrorLabel;
    protected NameValueCollection employees_deparSearchErrors=new NameValueCollection();
    protected System.Web.UI.WebControls.TextBox employees_deparSearchs_emp_name;
    protected System.Web.UI.HtmlControls.HtmlSelect employees_deparSearchs_department_name;
    protected System.Web.UI.WebControls.Repeater employeesRepeater;
    protected employeesDataProvider employeesData;
    protected System.Web.UI.HtmlControls.HtmlAnchor Link1;
//End Forms Objects

//Page_Load Event @1-55207E05
private void Page_Load(object sender, System.EventArgs e)
{
//End Page_Load Event

//Page_Load Event BeforeIsPostBack @1-7C6A532B
    if (!IsPostBack)
    {
            PageDataProvider PageData=new PageDataProvider();
            PageItem item=PageItem.CreateFromHttpRequest();
            PageData.FillItem(item);
            Link1.InnerText += item.Link1.GetFormattedValue().Replace("\r","").Replace("\n","<br>");
            employees_deparSearchShow();
            employeesBind();
    }
//End Page_Load Event BeforeIsPostBack

//Page_Load Event tail @1-FCB6E20C
}
//End Page_Load Event tail

//Page_Unload Event @1-72102C7C
private void Page_Unload(object sender, System.EventArgs e)
{
//End Page_Unload Event

//Page_Unload Event tail @1-FCB6E20C
}
//End Page_Unload Event tail

//Record Form employees_deparSearch Parameters @8-2C3C04DB
    protected void employees_deparSearchParameters()
    {
        try{
        }catch(Exception e){
            employees_deparSearchErrors.Add("Parameters","Form parameters: " + e.Message);
        }
    }
//End Record Form employees_deparSearch Parameters

//Record Form employees_deparSearch Show method @8-F79C6978
    protected void employees_deparSearchShow()
    {
        bool AllowRead = true;
        employees_deparSearchItem item=employees_deparSearchItem.CreateFromHttpRequest();
        bool IsInsertMode=!AllowRead;
        employees_deparSearchErrors.Add(item.errors);
//End Record Form employees_deparSearch Show method

//Grid Form employees_deparSearch BeforeShow tail @8-5A954AD0
        employees_deparSearchParameters();
        employees_deparSearchData.FillItem(item,ref IsInsertMode);
        employees_deparSearchs_emp_name.Text=item.s_emp_name.GetFormattedValue();
        item.s_department_nameItems.SetSelection(item.s_department_name.Value);
        employees_deparSearchs_department_name.SelectedIndex = -1;
        item.s_department_nameItems.CopyTo(employees_deparSearchs_department_name.Items);
//End Grid Form employees_deparSearch BeforeShow tail

//Record Form employees_deparSearch Show method tail @8-CCD085BD
        if(employees_deparSearchErrors.Count>0)
            employees_deparSearchShowErrors();
    }
//End Record Form employees_deparSearch Show method tail

//Record Form employees_deparSearch LoadItemFromRequest method @8-35A24AF3
    protected void employees_deparSearchLoadItemFromRequest(employees_deparSearchItem item, bool EnableValidation)
    {
        item.s_emp_name.SetValue(employees_deparSearchs_emp_name.Text);
        try{
        item.s_department_name.SetValue(employees_deparSearchs_department_name.Value);
        }catch(ArgumentException){
            employees_deparSearchErrors.Add("s_department_name","The value in field s_department_name is not valid.");}
        if(EnableValidation)
            item.Validate(employees_deparSearchData);
        employees_deparSearchErrors.Add(item.errors);
    }
//End Record Form employees_deparSearch LoadItemFromRequest method

//Record Form employees_deparSearch GetRedirectUrl method @8-F49B211D
    protected string Getemployees_deparSearchRedirectUrl(string redirectString ,string removeList)
    {
        string Params="";
        string[] List=(removeList).ToLower().Split(new Char[] {';'});

        if(redirectString == "") redirectString = "PopUpList_Window.aspx";
        for(int i=0;i<Request.Form.Count;i++)
        {
            if(Array.IndexOf(List,Request.Form.AllKeys[i].ToLower()) < 0 && Request.Form.AllKeys[i] != "__EVENTTARGET" && Request.Form.AllKeys[i] != "__EVENTARGUMENT" && Request.Form.AllKeys[i] != "__VIEWSTATE")
                Params += Request.Form.AllKeys[i] + "=" + Server.UrlEncode(Request.Form[i]) + "&";
        }
        Params = Params.TrimEnd(new Char[]{'&'});
        return redirectString + "?" + Params;
    }

//End Record Form employees_deparSearch GetRedirectUrl method

//Record Form employees_deparSearch ShowErrors method @8-21927513
    protected void employees_deparSearchShowErrors()
    {
        string DefaultMessage="";
        for(int i=0;i<employees_deparSearchErrors.Count;i++)
        switch(employees_deparSearchErrors.AllKeys[i])
        {
            default:
                DefaultMessage+=employees_deparSearchErrors[i]+"<br>";
                break;
        }
    }
//End Record Form employees_deparSearch ShowErrors method

//Record Form employees_deparSearch Search Operation @8-0C94362A
    protected void employees_deparSearch_Search(object sender, System.EventArgs e)
    {
        bool ErrorFlag=false;
        employees_deparSearchItem item=new employees_deparSearchItem();
        employees_deparSearchLoadItemFromRequest(item, true);
        ErrorFlag=(employees_deparSearchErrors.Count>0);
//End Record Form employees_deparSearch Search Operation

//Record Form employees_deparSearch Search Operation tail @8-6B706157
        if(ErrorFlag)
            employees_deparSearchShowErrors();
        else{
            string Params="";
            Params+=employees_deparSearchs_emp_name.Text!=""?("s_emp_name="+Server.UrlEncode(employees_deparSearchs_emp_name.Text)+"&"):"";
            foreach(ListItem li in employees_deparSearchs_department_name.Items)
                if(li.Selected && !"".Equals(li.Value))
                    Params += "s_department_name="+Server.UrlEncode(li.Value)+"&";
            string RedirectUrl = Getemployees_deparSearchRedirectUrl("", "s_emp_name;s_department_name");
            if( RedirectUrl.EndsWith("?"))
                RedirectUrl += Params;
            else
                RedirectUrl += "&" + Params;
            RedirectUrl = RedirectUrl.TrimEnd(new Char[]{'&'});
            Response.Redirect(RedirectUrl);
        }
    }
//End Record Form employees_deparSearch Search Operation tail

//Grid employees Bind @2-BCECE3D0
    protected void employeesBind()
    {
        int PagesCount;
        int FooterIndex;
        if (!IsPostBack)
        {
            string Param;
            int PageSize;
            ViewState["employeesSortField"] = employeesDataProvider.SortFields.Default;
            PageSize = 10;
            ViewState["employeesPageNumber"] = 1;
            Param = Request.QueryString["employeesOrder"];
            if (Param != null && Param.Length > 0)
                try{
                    employeesDataProvider.SortFields SortField = 0;
                    ViewState["employeesSortField"] = Enum.Parse(SortField.GetType(), Param);
                }catch {}
            Param = Request.QueryString["employeesDir"];
            if (Param == null || Param.Length == 0 || Param.ToLower() == "desc")
                ViewState["employeesSortDir"] = SortDirections.Desc;
            else
                ViewState["employeesSortDir"] = SortDirections.Asc;
            Param = Request.QueryString["employeesPage"];
            int PageNumber;
            if (Param != null && Param.Length > 0)
                try
                {
                    PageNumber = Int32.Parse(Param);
                    if (PageNumber > 0) ViewState["employeesPageNumber"] = PageNumber;
                }
                catch {}
            Param = Request.QueryString["employeesPageSize"];
            if (Param != null && Param.Length > 0)
                try
                {
                    PageSize = Int32.Parse(Param);
                    if (PageSize <= 0) PageSize = 10;
                }
                catch {}
            if (PageSize > 100)
                PageSize = 100;
            ViewState["employeesPageSize"] = PageSize;
        }
//End Grid employees Bind

//Grid Form employees BeforeShow tail @2-20071551
        employeesParameters();
        employeesData.SortField = (employeesDataProvider.SortFields)ViewState["employeesSortField"];
        employeesData.SortDir = (SortDirections)ViewState["employeesSortDir"];
        employeesData.PageNumber = (int)ViewState["employeesPageNumber"];
        employeesData.RecordsPerPage = (int)ViewState["employeesPageSize"];
        employeesRepeater.DataSource = employeesData.GetResultSet(out PagesCount);
        ViewState["employeesPagesCount"] = PagesCount;
        employeesRepeater.DataBind();
        FooterIndex = employeesRepeater.Controls.Count - 1;
        if (PagesCount == 0)
        {
            employeesRepeater.Controls[FooterIndex].FindControl("NoRecords").Visible = true;
        }


        CCSExample_CSharp.Controls.Navigator Navigator1Navigator = (CCSExample_CSharp.Controls.Navigator)employeesRepeater.Controls[FooterIndex].FindControl("Navigator1Navigator");
        Navigator1Navigator.MaxPage=PagesCount;
        Navigator1Navigator.PageNumber=employeesData.PageNumber;
        Navigator1Navigator.DataBind();
//End Grid Form employees BeforeShow tail

//Control employees Event BeforeShow. Action Custom Code @23-2A29BDB7

 if(PagesCount < 2){ 
    Navigator1Navigator.Visible = false;
 }
    
//End Control employees Event BeforeShow. Action Custom Code

//Grid employees Bind tail @2-FCB6E20C
    }
//End Grid employees Bind tail

//Grid employees Table Parameters @2-29B33F5A
    protected void employeesParameters()
    {
        try{
            employeesData.Urls_department_name= IntegerParameter.GetParam(Request.QueryString["s_department_name"]);
        }catch{
            ControlCollection ParentControls=employeesRepeater.Parent.Controls;
            int RepeaterIndex=ParentControls.IndexOf(employeesRepeater);
            ParentControls.RemoveAt(RepeaterIndex);
            Literal ErrorMessage=new Literal();
            ErrorMessage.Text="Error in Grid employees: Invalid parameter";
            ParentControls.AddAt(RepeaterIndex,ErrorMessage);
        }
	}
	
//End Grid employees Table Parameters

//Grid employees ItemDataBound event @2-C81C10FE
    protected void employeesItemDataBound(Object Sender, RepeaterItemEventArgs e)
    {
        employeesItem DataItem=(employeesItem)e.Item.DataItem;
        if (e.Item.ItemType == ListItemType.Item || e.Item.ItemType == ListItemType.AlternatingItem) {
            System.Web.UI.HtmlControls.HtmlAnchor employeesemp_name = (System.Web.UI.HtmlControls.HtmlAnchor)(e.Item.FindControl("employeesemp_name"));
            DataItem.emp_nameHref = "PopUpList_Window.aspx?";
            employeesemp_name.HRef += DataItem.emp_nameHref + DataItem.emp_nameHrefParameters.ToString("GET","", ViewState);
        }
//End Grid employees ItemDataBound event

//Grid employees ItemDataBound event tail @2-FCB6E20C
    }
//End Grid employees ItemDataBound event tail

//Grid employees ItemCommand event @2-593EB4BC
    protected void employeesItemCommand(Object Sender, RepeaterCommandEventArgs e)
    {
        int FooterIndex = employeesRepeater.Controls.Count - 1;
        bool BindAllowed = false;
        if(e.CommandName=="Sort"){
            if(((SorterState)e.CommandArgument)==SorterState.None)
                if((SortDirections)ViewState["employeesSortDir"]==SortDirections.Asc&&ViewState["employeesSortField"].ToString()==((CCSExample_CSharp.Controls.Sorter)e.CommandSource).Field)
                    ViewState["employeesSortDir"]=SortDirections.Desc;
                else
                    ViewState["employeesSortDir"]=SortDirections.Asc;
            else
                ViewState["employeesSortDir"]=(int)(((CCSExample_CSharp.Controls.Sorter)e.CommandSource).State);
            ViewState["employeesSortField"]=Enum.Parse(typeof(employeesDataProvider.SortFields),((CCSExample_CSharp.Controls.Sorter)e.CommandSource).Field);
            ViewState["employeesPageNumber"] = 1;
            BindAllowed = true;
        }
        if(e.CommandName=="Navigate"){
            ViewState["employeesPageNumber"] = Int32.Parse(e.CommandArgument.ToString());
            BindAllowed = true;
        }
        if (BindAllowed)
            employeesBind();
    }
//End Grid employees ItemCommand event

//OnInit Event @1-5A908AB3
    #region Web Form Designer generated code
    override protected void OnInit(EventArgs e)
    {
        //
        //CODEGEN: This call is required by the ASP.NET Web Form Designer.
        //
        InitializeComponent();
        this.Load += new System.EventHandler(this.Page_Load);
        this.Unload += new System.EventHandler(this.Page_Unload);
        employees_deparSearchData = new employees_deparSearchDataProvider();
        employeesData = new employeesDataProvider();
        base.OnInit(e);
//End OnInit Event

//OnInit Event tail @1-FCB6E20C
    }
//End OnInit Event tail

//InitializeComponent Event @1-722FC1EE
    /// <summary>
    /// Required method for Designer support - do not modify
    /// the contents of this method with the code editor.
    /// </summary>
    private void InitializeComponent()
    {
    }
    #endregion
//End InitializeComponent Event

//Page class tail @1-F5FC18C5
}
}
//End Page class tail

