#BindEvents Method @1-5935E778
sub BindEvents {
    $departments->{CCSEvents}->{"BeforeShow"} = "departments_BeforeShow";
    $departments->{CCSEvents}->{"OnValidate"} = "departments_OnValidate";
}
#End BindEvents Method

#departments_BeforeShow @11-5F38FA7A
sub departments_BeforeShow()
{
    $departments_BeforeShow = 1;
#End departments_BeforeShow

#Custom Code @17-84ABEA10

  $DBIntranetDB = clsDBIntranetDB->new();
  if($departments->{department_manager_id}->{Value} >0) {
   	$departments->{department_manager_id}->SetValue(CCDlookUp("emp_name", "employees", "emp_id=".$DBIntranetDB->ToSQL($departments->{department_manager_id}->{Value},$ccsInteger), $DBIntranetDB));
  }  

#End Custom Code

#Close departments_BeforeShow @11-E1783FFC
    return $departments_BeforeShow;
}
#End Close departments_BeforeShow

#departments_OnValidate @11-1DB08AE4
sub departments_OnValidate()
{
    $departments_OnValidate = 1;
#End departments_OnValidate

#Custom Code @19-84ABEA10
  
	my $EmpCount = 0;
	my $search_name = "";

	#search for an employee by initials
	$search_name = $departments->{department_manager_id}->{Value};
	$search_name =~s/^\s+|\s+$//g;

	$DBIntranetDB = clsDBIntranetDB->new();
  
	if($search_name){
    
		$search_name =~s/\s+/%/g;
			
    	if(index($search_name,"%") == -1){ 
       		$search_name = "%".$search_name."%";
    	}else{ 
       		$search_name = $search_name."%";
		}

	#$search_name = ~s/'/''/g;

     	$EmpCount = CCDlookUp("COUNT(*)", "employees", "emp_name LIKE ".$DBIntranetDB->ToSQL($search_name,$ccsText), $DBIntranetDB);
     	if($EmpCount > 1){ 
        	$departments->{Errors}->addError("Too many matching employees were found.");
		}
     	if($EmpCount == 0){ 
        	$departments->{Errors}->addError("No matching employees were found.");
		}
     	if($EmpCount == 1){
        	$departments->{department_manager_id}->SetValue(CCDlookUp("emp_id", "employees", "emp_name LIKE ".$DBIntranetDB->ToSQL($search_name,$ccsText), $DBIntranetDB));
		}
  }  

#End Custom Code

#Close departments_OnValidate @11-DE835B75
    return $departments_OnValidate;
}
#End Close departments_OnValidate


1;
