//Using Statements @1-B658B243
using System;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Specialized;
using System.Data;
using CCSExample_CSharp;
using CCSExample_CSharp.Data;
using CCSExample_CSharp.Controls;
using CCSExample_CSharp.Configuration;

namespace CCSExample_CSharp.PopUpList.PopUpList
{
//End Using Statements

//Page Data Class @1-629972A2
public class PageItem
{
    public NameValueCollection errors=new NameValueCollection();
    public PageItem()
    {
    }
    public static PageItem CreateFromHttpRequest()
    {
        PageItem item = new PageItem();
        item.Link2.SetValue(DBUtility.GetInitialValue("Link2"));
        return item;
    }

    public FieldBase this[string fieldName]{
        get{
            switch(fieldName){
                case "Link2":
                    return this.Link2;
                default:
                    throw (new ArgumentOutOfRangeException());
            }
        }
        set{
            switch(fieldName){
                case "Link2":
                    this.Link2 = (TextField)value;
                    break;
                default:
                    throw (new ArgumentOutOfRangeException());
            }
        }
    }

    public TextField Link2 = new TextField("",null);
    public object Link2Href;
    public LinkParameterCollection Link2HrefParameters = new LinkParameterCollection();
}
//End Page Data Class

//Page Data Provider Class @1-50FE4D41
public class PageDataProvider
{
//End Page Data Provider Class

//Page Data Provider Class Constructor @1-9A44B219
    public PageDataProvider()
    {
    }
//End Page Data Provider Class Constructor

//Page Data Provider Class GetResultSet Method @1-052161C6
    public void FillItem(PageItem item)
    {
//End Page Data Provider Class GetResultSet Method

//Page Data Provider Class GetResultSet Method tail @1-FCB6E20C
    }
//End Page Data Provider Class GetResultSet Method tail

//Page Data Provider Tail @1-FCB6E20C
}
//End Page Data Provider Tail

//Grid departments_emp Item Class @3-73A1D166
public class departments_empItem
{
    public NameValueCollection errors=new NameValueCollection();
    public departments_empItem()
    {
    }

    public FieldBase this[string fieldName]{
        get{
            switch(fieldName){
                case "department_name":
                    return this.department_name;
                case "emp_name":
                    return this.emp_name;
                case "Add":
                    return this.Add;
                default:
                    throw (new ArgumentOutOfRangeException());
            }
        }
        set{
            switch(fieldName){
                case "department_name":
                    this.department_name = (TextField)value;
                    break;
                case "emp_name":
                    this.emp_name = (TextField)value;
                    break;
                case "Add":
                    this.Add = (TextField)value;
                    break;
                default:
                    throw (new ArgumentOutOfRangeException());
            }
        }
    }

    public TextField department_name = new TextField("",null);
    public object department_nameHref;
    public LinkParameterCollection department_nameHrefParameters = new LinkParameterCollection();
    public TextField emp_name=new TextField("", null);
    public TextField Add = new TextField("",null);
    public object AddHref;
    public LinkParameterCollection AddHrefParameters = new LinkParameterCollection();
}
//End Grid departments_emp Item Class

//Grid departments_emp Data Provider Class Header @3-85C6DC9A
public class departments_empDataProvider:GridDataProviderBase
{
//End Grid departments_emp Data Provider Class Header

//Grid departments_emp Data Provider Class Variables @3-3E5247F7
    public enum SortFields {Default}
    private string[] SortFieldsNames=new string[]{"departments.department_id"};
    private string[] SortFieldsNamesDesc=new string[]{"departments.department_id"};
    public SortFields SortField=SortFields.Default;
    public SortDirections SortDir=SortDirections.Asc;
    public int RecordsPerPage=10;
    public int PageNumber=1;
//End Grid departments_emp Data Provider Class Variables

//Grid departments_emp Data Provider Class Constructor @3-2EA15A6A
    public departments_empDataProvider()
    {
        Select=new TableCommand("SELECT departments.department_id AS departments_department_id, department_name, emp_name  " + 
          "FROM departments LEFT JOIN employees ON departments.department_manager_id = employees.emp_id",new string[]{},Settings.IntranetDBDataAccessObject);
        Count=new TableCommand("SELECT COUNT(*)  " + 
          "FROM departments LEFT JOIN employees ON departments.department_manager_id = employees.emp_id",new string[]{},Settings.IntranetDBDataAccessObject);
    }
//End Grid departments_emp Data Provider Class Constructor

//Grid departments_emp Data Provider Class GetResultSet Method @3-F1D892C7
    public departments_empItem[] GetResultSet(out int PagesCount)
    {
//End Grid departments_emp Data Provider Class GetResultSet Method

//Before build Select @3-EB281404
        Parameters.Clear();
        Select.OrderBy=(SortDir==SortDirections.Asc?SortFieldsNames[(int)SortField]:SortFieldsNamesDesc[(int)SortField]).Trim();
//End Before build Select

//Execute Select @3-E684A2A4
        DataSet ds=null;Exception E=null;
        PagesCount=0;
        try{
            if(RecordsPerPage>0)
            {
                ds=ExecuteSelect((PageNumber-1)*RecordsPerPage,RecordsPerPage);
                PagesCount = ExecuteCount();
                mRecordCount = PagesCount;
                PagesCount = PagesCount%RecordsPerPage>0?(int)(PagesCount/RecordsPerPage)+1:(int)(PagesCount/RecordsPerPage);
            }
            else
            {
            ds=ExecuteSelect();
            if(ds.Tables[0].Rows.Count!=0)PagesCount=1;
            }
        }catch(Exception e){
            E=e;}
        finally{
//End Execute Select

//After execute Select @3-28AA95FE
        if(E!=null) throw(E);
        }
        DataRowCollection dr=ds.Tables[0].Rows;
        departments_empItem[] result=new departments_empItem[dr.Count];
//End After execute Select

//After execute Select tail @3-B4A81709
        for(int i=0;i<dr.Count;i++)
        {
            departments_empItem item=new departments_empItem();
            item.department_name.SetValue(dr[i]["department_name"],"");
            item.department_nameHrefParameters.Add("department_id",System.Web.HttpUtility.UrlEncode(dr[i]["departments_department_id"].ToString()));
            item.emp_name.SetValue(dr[i]["emp_name"],"");
            result[i]=item;
        }
        return result; 
    }
//End After execute Select tail

//Grid Data Provider tail @3-FCB6E20C
}
//End Grid Data Provider tail

//Record departments Item Class @11-00179195
public class departmentsItem
{
    private bool _isNew = true;
    private bool _isDeleted = false;
    public NameValueCollection errors=new NameValueCollection();
    public departmentsItem()
    {
    }
    public TextField department_name=new TextField("", null);
    public TextField department_manager_id=new TextField("", null);
    public TextField Link1 = new TextField("",null);
    public object Link1Href;
    public LinkParameterCollection Link1HrefParameters = new LinkParameterCollection();
    public TextField is_change=new TextField("", null);

    public static departmentsItem CreateFromHttpRequest()
    {
        departmentsItem item = new departmentsItem();
        if(DBUtility.GetInitialValue("department_name") != null){
        item.department_name.SetValue(DBUtility.GetInitialValue("department_name"));
        }
        if(DBUtility.GetInitialValue("department_manager_id") != null){
        item.department_manager_id.SetValue(DBUtility.GetInitialValue("department_manager_id"));
        }
        if(DBUtility.GetInitialValue("Link1") != null){
        item.Link1.SetValue(DBUtility.GetInitialValue("Link1"));
        }
        if(DBUtility.GetInitialValue("is_change") != null){
        item.is_change.SetValue(DBUtility.GetInitialValue("is_change"));
        }
        if(DBUtility.GetInitialValue("Insert_Button") != null){
        }
        if(DBUtility.GetInitialValue("Update_Button") != null){
        }
        if(DBUtility.GetInitialValue("Delete_Button") != null){
        }
        return item;
    }

    public FieldBase this[string fieldName]{
        get{
            switch(fieldName){
                case "department_name":
                    return this.department_name;
                case "department_manager_id":
                    return this.department_manager_id;
                case "Link1":
                    return this.Link1;
                case "is_change":
                    return this.is_change;
                default:
                    throw (new ArgumentOutOfRangeException());
            }
        }
        set{
            switch(fieldName){
                case "department_name":
                    this.department_name = (TextField)value;
                    break;
                case "department_manager_id":
                    this.department_manager_id = (TextField)value;
                    break;
                case "Link1":
                    this.Link1 = (TextField)value;
                    break;
                case "is_change":
                    this.is_change = (TextField)value;
                    break;
                default:
                    throw (new ArgumentOutOfRangeException());
            }
        }
    }

    public bool IsNew{
        get{
            return _isNew;
        }
        set{
            _isNew = value;
        }
    }

    public bool IsDeleted{
        get{
            return _isDeleted;
        }
        set{
            _isDeleted = value;
        }
    }

    public void Validate(departmentsDataProvider provider)
    {
//End Record departments Item Class

//department_name validate @14-1D2ADE85
        if(department_name.Value==null||department_name.Value.ToString()=="")
            errors.Add("department_name","The value in field Department is required.");
//End department_name validate

//Record departments Event OnValidate. Action Custom Code @19-2A29BDB7
  
  int EmpCount = 0;	
  string search_name;
  
  if(department_manager_id.Value==null)	search_name = "";
  else search_name = (department_manager_id.Value.ToString()).Trim();

  if(search_name !=""){
    
	search_name = search_name.Replace(" ","%");
    if(search_name.IndexOf("%")==-1){
       search_name = "%" + search_name + "%";
    }else{
       search_name = search_name + "%";
    } 
    search_name = search_name.Replace("'","''");

    EmpCount = Int32.Parse(new IntegerField("",Settings.IntranetDBDataAccessObject.ExecuteScalar("SELECT COUNT(*) FROM employees WHERE emp_name LIKE " + "'" + search_name + "'" )).GetFormattedValue(""));
    if(EmpCount > 1){
       errors.Add("department_manager_id","Too many matching employees were found.");
    } 
    else if(EmpCount == 0){
       errors.Add("department_manager_id","No matching employees were found.");
    }
    else if(EmpCount == 1){ 
       department_manager_id.Value = Int32.Parse(new IntegerField("",Settings.IntranetDBDataAccessObject.ExecuteScalar("SELECT emp_id FROM employees WHERE emp_name LIKE " + "'" + search_name + "'" )).GetFormattedValue(""));
    }
  
  }
	
//End Record departments Event OnValidate. Action Custom Code

//Record departments Item Class tail @11-F5FC18C5
    }
}
//End Record departments Item Class tail

//Record departments Data Provider Class @11-3783310C
public class departmentsDataProvider:RecordDataProviderBase
{
//End Record departments Data Provider Class

//Record departments Data Provider Class Variables @11-A6120E52
    public IntegerParameter Urldepartment_id;
//End Record departments Data Provider Class Variables

//Record departments Data Provider Class Constructor @11-428394D3
    public departmentsDataProvider()
    {
        Select=new TableCommand("SELECT *  " + 
          "FROM departments",new string[]{"department_id13"},Settings.IntranetDBDataAccessObject);
        Insert=new TableCommand("INSERT INTO departments(department_name, department_manager_id ) VALUES ( {department_name}, {department_manager_id})"
        ,new string[0],Settings.IntranetDBDataAccessObject);
        Update=new TableCommand("UPDATE departments SET department_name={department_name}, department_manager_id={department_manager_id}"
        ,new string[]{"department_id13"},Settings.IntranetDBDataAccessObject);
        Delete=new TableCommand("DELETE FROM departments",new string[]{"department_id13"},Settings.IntranetDBDataAccessObject);
    }
//End Record departments Data Provider Class Constructor

//Record departments Data Provider Class LoadParams Method @11-FC3506F1
    protected bool LoadParams()
    {
        CommonParameters.Clear();
        CommonParameters.Add("department_id13",Urldepartment_id==null?"":("department_id = " + Select.Dao.ToSql(Urldepartment_id.GetFormattedValue(""),FieldType.Integer)));
        return !(Urldepartment_id!=null);
    }
//End Record departments Data Provider Class LoadParams Method

//Record departments Data Provider Class CheckUnique Method @11-A73D3349
    public bool CheckUnique(string ControlName,departmentsItem item)
    {
        return true;
    }
//End Record departments Data Provider Class CheckUnique Method

//Record departments Data Provider Class PrepareInsert Method @11-E2788B74
    override protected void PrepareInsert()
    {
//End Record departments Data Provider Class PrepareInsert Method

//Record departments Data Provider Class PrepareInsert Method tail @11-FCB6E20C
    }
//End Record departments Data Provider Class PrepareInsert Method tail

//Record departments Data Provider Class Insert Method @11-2C17A327
    public int InsertItem(departmentsItem item)
    {
//End Record departments Data Provider Class Insert Method

//Record departments Build insert @11-0136589A
        Insert.SqlQuery.Replace("{department_name}",Insert.Dao.ToSql(item.department_name.GetFormattedValue(""),FieldType.Text));
        Insert.SqlQuery.Replace("{department_manager_id}",Insert.Dao.ToSql(item.department_manager_id.GetFormattedValue(""),FieldType.Text));
        object result=null;Exception E=null;
        try{
            result=ExecuteInsert();
        }catch(Exception e){
            E=e;}
        finally{
//End Record departments Build insert

//Record departments AfterExecuteInsert @11-33B45808
            if(E!=null) throw(E);
        }
        return (int)result;
    }
//End Record departments AfterExecuteInsert

//Record departments Data Provider Class PrepareUpdate Method @11-7A788766
    override protected void PrepareUpdate()
    {
        LoadParams();
        Update.Parameters=CommonParameters;
//End Record departments Data Provider Class PrepareUpdate Method

//Record departments Data Provider Class PrepareUpdate Method tail @11-FCB6E20C
    }
//End Record departments Data Provider Class PrepareUpdate Method tail

//Record departments Data Provider Class Update Method @11-BB25137F
    public int UpdateItem(departmentsItem item)
    {
//End Record departments Data Provider Class Update Method

//Record departments BeforeBuildUpdate @11-EE8FE4A7
        Update.SqlQuery.Replace("{department_name}",Update.Dao.ToSql(item.department_name.GetFormattedValue(""),FieldType.Text));
        Update.SqlQuery.Replace("{department_manager_id}",Update.Dao.ToSql(item.department_manager_id.GetFormattedValue(""),FieldType.Text));
        object result=null;Exception E=null;
        try{
            result=ExecuteUpdate();
        }catch(Exception e){
            E=e;}
        finally{
//End Record departments BeforeBuildUpdate

//Record departments AfterExecuteUpdate @11-33B45808
            if(E!=null) throw(E);
        }
        return (int)result;
    }
//End Record departments AfterExecuteUpdate

//Record departments Data Provider Class PrepareDelete Method @11-9923EE9D
    override protected void PrepareDelete()
    {
        LoadParams();
        Delete.Parameters=CommonParameters;
//End Record departments Data Provider Class PrepareDelete Method

//Record departments Data Provider Class PrepareDelete Method tail @11-FCB6E20C
    }
//End Record departments Data Provider Class PrepareDelete Method tail

//Record departments Data Provider Class Delete Method @11-F69D1A58
    public int DeleteItem()
    {
//End Record departments Data Provider Class Delete Method

//Record departments BeforeBuildDelete @11-C970B5CF
        object result=null;Exception E=null;
        try{
            result=ExecuteDelete();
        }catch(Exception e){
            E=e;}
        finally{
//End Record departments BeforeBuildDelete

//Record departments BeforeBuildDelete @11-33B45808
            if(E!=null) throw(E);
        }
        return (int)result;
    }
//End Record departments BeforeBuildDelete

//PrepareSelect Method @11-32F2D8AA
    override protected void PrepareSelect()
    {
        LoadParams();
        Select.Parameters=CommonParameters;
    }
//End PrepareSelect Method

//Record departments Data Provider Class GetResultSet Method @11-EF21AAA5
    public void FillItem(departmentsItem item, ref bool IsInsertMode)
    {
        bool ReadNotAllowed=IsInsertMode;
        Exception E=null;
//End Record departments Data Provider Class GetResultSet Method

//Record departments BeforeBuildSelect @11-0CD0BD3D
        IsInsertMode=LoadParams();
        DataRowCollection dr=null;
        if(!IsInsertMode){
//End Record departments BeforeBuildSelect

//Record departments BeforeExecuteSelect @11-94ACF54A
            try{
                dr=ExecuteSelect().Tables[0].Rows;
            }catch(Exception e){
                E=e;}
            finally{
//End Record departments BeforeExecuteSelect

//Record departments AfterExecuteSelect @11-A7F7ADFE
                if(E!=null) throw(E);
            }
        }
        if(!IsInsertMode && !ReadNotAllowed && dr.Count!=0)
        {
            int i=0;
            item.department_name.SetValue(dr[i]["department_name"],"");
            item.department_manager_id.SetValue(dr[i]["department_manager_id"],"");
        }
        else
            IsInsertMode=true;
//End Record departments AfterExecuteSelect

//Record departments AfterExecuteSelect tail @11-FCB6E20C
    }
//End Record departments AfterExecuteSelect tail

//Record departments Data Provider Class @11-FCB6E20C
}

//End Record departments Data Provider Class

//Page Data Provider Tail @1-FCB6E20C
}
//End Page Data Provider Tail

